// THIS FILE IS GENERATED AUTOMATICALLY AND SHOULD NOT BE EDITED DIRECTLY.
import 'dart:ffi';
import 'dart:io';
import 'package:ffi/ffi.dart';
import 'struct_sdl2.dart';

final _SDL2 = DynamicLibrary.open(Platform.isWindows ? 'SDL2.dll' : 'libSDL2.so');

/// 
/// This function initializes  the subsystems specified by \c flags
/// Unless the ::SDL_INIT_NOPARACHUTE flag is set, it will install cleanup
/// signal handlers for some commonly ignored fatal signals (like SIGSEGV).
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_Init(Uint32 flags)
/// ```
int SDL_Init(int flags) {
  final _SDL_Init = _SDL2.lookupFunction<
      Int32 Function(Uint32 flags),
      int Function(int flags)>('SDL_Init');
  return _SDL_Init(flags);
}

/// 
/// This function initializes specific SDL subsystems
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_InitSubSystem(Uint32 flags)
/// ```
int SDL_InitSubSystem(int flags) {
  final _SDL_InitSubSystem = _SDL2.lookupFunction<
      Int32 Function(Uint32 flags),
      int Function(int flags)>('SDL_InitSubSystem');
  return _SDL_InitSubSystem(flags);
}

/// 
/// This function cleans up specific SDL subsystems
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_QuitSubSystem(Uint32 flags)
/// ```
void SDL_QuitSubSystem(int flags) {
  final _SDL_QuitSubSystem = _SDL2.lookupFunction<
      Void Function(Uint32 flags),
      void Function(int flags)>('SDL_QuitSubSystem');
  return _SDL_QuitSubSystem(flags);
}

/// 
/// This function returns a mask of the specified subsystems which have
/// previously been initialized.
/// 
/// If \c flags is 0, it returns a mask of all initialized subsystems.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_WasInit(Uint32 flags)
/// ```
int SDL_WasInit(int flags) {
  final _SDL_WasInit = _SDL2.lookupFunction<
      Uint32 Function(Uint32 flags),
      int Function(int flags)>('SDL_WasInit');
  return _SDL_WasInit(flags);
}

/// 
/// This function cleans up all initialized subsystems. You should
/// call it upon all exit conditions.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_Quit(void)
/// ```
void SDL_Quit() {
  final _SDL_Quit = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_Quit');
  return _SDL_Quit();
}

/// Never call this directly. Use the SDL_assert* macros.
/// ```c
/// extern DECLSPEC SDL_assert_state SDLCALL SDL_ReportAssertion(SDL_assert_data *, const char *, const char *, int)
/// ```
int SDL_ReportAssertion(Pointer<SDL_assert_data>? arg0, String arg1, String arg2, int arg3) {
  final _SDL_ReportAssertion = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_assert_data>? arg0, Pointer<Utf8>? arg1, Pointer<Utf8>? arg2, Int32 arg3),
      int Function(Pointer<SDL_assert_data>? arg0, Pointer<Utf8>? arg1, Pointer<Utf8>? arg2, int arg3)>('SDL_ReportAssertion');
  final _arg1Pointer = arg1.toNativeUtf8();
  final _arg2Pointer = arg2.toNativeUtf8();
  final _result = _SDL_ReportAssertion(arg0, _arg1Pointer, _arg2Pointer, arg3);
  calloc.free(_arg1Pointer);
  calloc.free(_arg2Pointer);
  return _result;
}

/// 
/// \brief Set an application-defined assertion handler.
/// 
/// This allows an app to show its own assertion UI and/or force the
/// response to an assertion failure. If the app doesn't provide this, SDL
/// will try to do the right thing, popping up a system-specific GUI dialog,
/// and probably minimizing any fullscreen windows.
/// 
/// This callback may fire from any thread, but it runs wrapped in a mutex, so
/// it will only fire from one thread at a time.
/// 
/// Setting the callback to NULL restores SDL's original internal handler.
/// 
/// This callback is NOT reset to SDL's internal handler upon SDL_Quit()!
/// 
/// \return SDL_assert_state value of how to handle the assertion failure.
/// 
/// \param handler Callback function, called when an assertion fails.
/// \param userdata A pointer passed to the callback as-is.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetAssertionHandler( SDL_AssertionHandler handler, void *userdata)
/// ```
void SDL_SetAssertionHandler(Pointer<Void>? handler, Pointer<Void>? userdata) {
  final _SDL_SetAssertionHandler = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? handler, Pointer<Void>? userdata),
      void Function(Pointer<Void>? handler, Pointer<Void>? userdata)>('SDL_SetAssertionHandler');
  return _SDL_SetAssertionHandler(handler, userdata);
}

/// 
/// \brief Get a list of all assertion failures.
/// 
/// Get all assertions triggered since last call to SDL_ResetAssertionReport(),
/// or the start of the program.
/// 
/// The proper way to examine this data looks something like this:
/// 
/// <code>
/// const SDL_assert_data *item = SDL_GetAssertionReport();
/// while (item) {
/// printf("'%s', %s (%s:%d), triggered %u times, always ignore: %s.\n",
/// item->condition, item->function, item->filename,
/// item->linenum, item->trigger_count,
/// item->always_ignore ? "yes" : "no");
/// item = item->next;
/// }
/// </code>
/// 
/// \return List of all assertions.
/// \sa SDL_ResetAssertionReport
/// 
/// ```c
/// extern DECLSPEC const SDL_assert_data * SDLCALL SDL_GetAssertionReport(void)
/// ```
Pointer<SDL_assert_data>? SDL_GetAssertionReport() {
  final _SDL_GetAssertionReport = _SDL2.lookupFunction<
      Pointer<SDL_assert_data>? Function(),
      Pointer<SDL_assert_data>? Function()>('SDL_GetAssertionReport');
  return _SDL_GetAssertionReport();
}

/// 
/// \brief Reset the list of all assertion failures.
/// 
/// Reset list of all assertions triggered.
/// 
/// \sa SDL_GetAssertionReport
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_ResetAssertionReport(void)
/// ```
void SDL_ResetAssertionReport() {
  final _SDL_ResetAssertionReport = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_ResetAssertionReport');
  return _SDL_ResetAssertionReport();
}

/// 
/// \brief Try to lock a spin lock by setting it to a non-zero value.
/// 
/// \param lock Points to the lock.
/// 
/// \return SDL_TRUE if the lock succeeded, SDL_FALSE if the lock is already held.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_AtomicTryLock(SDL_SpinLock *lock)
/// ```
int SDL_AtomicTryLock(Pointer<Int32>? lock) {
  final _SDL_AtomicTryLock = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int32>? lock),
      int Function(Pointer<Int32>? lock)>('SDL_AtomicTryLock');
  return _SDL_AtomicTryLock(lock);
}

/// 
/// \brief Lock a spin lock by setting it to a non-zero value.
/// 
/// \param lock Points to the lock.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_AtomicLock(SDL_SpinLock *lock)
/// ```
void SDL_AtomicLock(Pointer<Int32>? lock) {
  final _SDL_AtomicLock = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? lock),
      void Function(Pointer<Int32>? lock)>('SDL_AtomicLock');
  return _SDL_AtomicLock(lock);
}

/// 
/// \brief Unlock a spin lock by setting it to 0. Always returns immediately
/// 
/// \param lock Points to the lock.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_AtomicUnlock(SDL_SpinLock *lock)
/// ```
void SDL_AtomicUnlock(Pointer<Int32>? lock) {
  final _SDL_AtomicUnlock = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? lock),
      void Function(Pointer<Int32>? lock)>('SDL_AtomicUnlock');
  return _SDL_AtomicUnlock(lock);
}

/// The mcr instruction isn't available in thumb mode, use real functions
/// ```c
/// extern DECLSPEC void SDLCALL SDL_MemoryBarrierRelease()
/// ```
void SDL_MemoryBarrierRelease() {
  final _SDL_MemoryBarrierRelease = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_MemoryBarrierRelease');
  return _SDL_MemoryBarrierRelease();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_MemoryBarrierAcquire()
/// ```
void SDL_MemoryBarrierAcquire() {
  final _SDL_MemoryBarrierAcquire = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_MemoryBarrierAcquire');
  return _SDL_MemoryBarrierAcquire();
}

/// 
/// \brief Set an atomic variable to a new value if it is currently an old value.
/// 
/// \return SDL_TRUE if the atomic variable was set, SDL_FALSE otherwise.
/// 
/// \note If you don't know what this function is for, you shouldn't use it!
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_AtomicCAS(SDL_atomic_t *a, int oldval, int newval)
/// ```
int SDL_AtomicCAS(Pointer<SDL_atomic_t>? a, int oldval, int newval) {
  final _SDL_AtomicCAS = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_atomic_t>? a, Int32 oldval, Int32 newval),
      int Function(Pointer<SDL_atomic_t>? a, int oldval, int newval)>('SDL_AtomicCAS');
  return _SDL_AtomicCAS(a, oldval, newval);
}

/// 
/// \brief Set a pointer to a new value if it is currently an old value.
/// 
/// \return SDL_TRUE if the pointer was set, SDL_FALSE otherwise.
/// 
/// \note If you don't know what this function is for, you shouldn't use it!
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_AtomicCASPtr(void* *a, void *oldval, void *newval)
/// ```
int SDL_AtomicCASPtr(Pointer<Pointer<Void>>? a, Pointer<Void>? oldval, Pointer<Void>? newval) {
  final _SDL_AtomicCASPtr = _SDL2.lookupFunction<
      Int32 Function(Pointer<Pointer<Void>>? a, Pointer<Void>? oldval, Pointer<Void>? newval),
      int Function(Pointer<Pointer<Void>>? a, Pointer<Void>? oldval, Pointer<Void>? newval)>('SDL_AtomicCASPtr');
  return _SDL_AtomicCASPtr(a, oldval, newval);
}

/// @{
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumAudioDrivers(void)
/// ```
int SDL_GetNumAudioDrivers() {
  final _SDL_GetNumAudioDrivers = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetNumAudioDrivers');
  return _SDL_GetNumAudioDrivers();
}

/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetAudioDriver(int index)
/// ```
String SDL_GetAudioDriver(int index) {
  final _SDL_GetAudioDriver = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 index),
      Pointer<Utf8>? Function(int index)>('SDL_GetAudioDriver');
  return _SDL_GetAudioDriver(index)!.toDartString();
}

/// @{
/// ```c
/// extern DECLSPEC int SDLCALL SDL_AudioInit(const char *driver_name)
/// ```
int SDL_AudioInit(String driver_name) {
  final _SDL_AudioInit = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? driver_name),
      int Function(Pointer<Utf8>? driver_name)>('SDL_AudioInit');
  final _driver_namePointer = driver_name.toNativeUtf8();
  final _result = _SDL_AudioInit(_driver_namePointer);
  calloc.free(_driver_namePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_AudioQuit(void)
/// ```
void SDL_AudioQuit() {
  final _SDL_AudioQuit = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_AudioQuit');
  return _SDL_AudioQuit();
}

/// 
/// This function returns the name of the current audio driver, or NULL
/// if no driver has been initialized.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetCurrentAudioDriver(void)
/// ```
String SDL_GetCurrentAudioDriver() {
  final _SDL_GetCurrentAudioDriver = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_GetCurrentAudioDriver');
  return _SDL_GetCurrentAudioDriver()!.toDartString();
}

/// 
/// This function opens the audio device with the desired parameters, and
/// returns 0 if successful, placing the actual hardware parameters in the
/// structure pointed to by \c obtained.  If \c obtained is NULL, the audio
/// data passed to the callback function will be guaranteed to be in the
/// requested format, and will be automatically converted to the hardware
/// audio format if necessary.  This function returns -1 if it failed
/// to open the audio device, or couldn't set up the audio thread.
/// 
/// When filling in the desired audio spec structure,
/// - \c desired->freq should be the desired audio frequency in samples-per-
/// second.
/// - \c desired->format should be the desired audio format.
/// - \c desired->samples is the desired size of the audio buffer, in
/// samples.  This number should be a power of two, and may be adjusted by
/// the audio driver to a value more suitable for the hardware.  Good values
/// seem to range between 512 and 8096 inclusive, depending on the
/// application and CPU speed.  Smaller values yield faster response time,
/// but can lead to underflow if the application is doing heavy processing
/// and cannot fill the audio buffer in time.  A stereo sample consists of
/// both right and left channels in LR ordering.
/// Note that the number of samples is directly related to time by the
/// following formula:  \code ms = (samples*1000)/freq \endcode
/// - \c desired->size is the size in bytes of the audio buffer, and is
/// calculated by SDL_OpenAudio().
/// - \c desired->silence is the value used to set the buffer to silence,
/// and is calculated by SDL_OpenAudio().
/// - \c desired->callback should be set to a function that will be called
/// when the audio device is ready for more data.  It is passed a pointer
/// to the audio buffer, and the length in bytes of the audio buffer.
/// This function usually runs in a separate thread, and so you should
/// protect data structures that it accesses by calling SDL_LockAudio()
/// and SDL_UnlockAudio() in your code.
/// - \c desired->userdata is passed as the first parameter to your callback
/// function.
/// 
/// The audio device starts out playing silence when it's opened, and should
/// be enabled for playing by calling \c SDL_PauseAudio(0) when you are ready
/// for your audio callback function to be called.  Since the audio driver
/// may modify the requested size of the audio buffer, you should allocate
/// any local mixing buffers after you open the audio device.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_OpenAudio(SDL_AudioSpec * desired, SDL_AudioSpec * obtained)
/// ```
int SDL_OpenAudio(Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained) {
  final _SDL_OpenAudio = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained),
      int Function(Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained)>('SDL_OpenAudio');
  return _SDL_OpenAudio(desired, obtained);
}

/// 
/// Get the number of available devices exposed by the current driver.
/// Only valid after a successfully initializing the audio subsystem.
/// Returns -1 if an explicit list of devices can't be determined; this is
/// not an error. For example, if SDL is set up to talk to a remote audio
/// server, it can't list every one available on the Internet, but it will
/// still allow a specific host to be specified to SDL_OpenAudioDevice().
/// 
/// In many common cases, when this function returns a value <= 0, it can still
/// successfully open the default device (NULL for first argument of
/// SDL_OpenAudioDevice()).
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumAudioDevices(int iscapture)
/// ```
int SDL_GetNumAudioDevices(int iscapture) {
  final _SDL_GetNumAudioDevices = _SDL2.lookupFunction<
      Int32 Function(Int32 iscapture),
      int Function(int iscapture)>('SDL_GetNumAudioDevices');
  return _SDL_GetNumAudioDevices(iscapture);
}

/// 
/// Get the human-readable name of a specific audio device.
/// Must be a value between 0 and (number of audio devices-1).
/// Only valid after a successfully initializing the audio subsystem.
/// The values returned by this function reflect the latest call to
/// SDL_GetNumAudioDevices(); recall that function to redetect available
/// hardware.
/// 
/// The string returned by this function is UTF-8 encoded, read-only, and
/// managed internally. You are not to free it. If you need to keep the
/// string for any length of time, you should make your own copy of it, as it
/// will be invalid next time any of several other SDL functions is called.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetAudioDeviceName(int index, int iscapture)
/// ```
String SDL_GetAudioDeviceName(int index, int iscapture) {
  final _SDL_GetAudioDeviceName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 index, Int32 iscapture),
      Pointer<Utf8>? Function(int index, int iscapture)>('SDL_GetAudioDeviceName');
  return _SDL_GetAudioDeviceName(index, iscapture)!.toDartString();
}

/// 
/// Open a specific audio device. Passing in a device name of NULL requests
/// the most reasonable default (and is equivalent to calling SDL_OpenAudio()).
/// 
/// The device name is a UTF-8 string reported by SDL_GetAudioDeviceName(), but
/// some drivers allow arbitrary and driver-specific strings, such as a
/// hostname/IP address for a remote audio server, or a filename in the
/// diskaudio driver.
/// 
/// \return 0 on error, a valid device ID that is >= 2 on success.
/// 
/// SDL_OpenAudio(), unlike this function, always acts on device ID 1.
/// 
/// ```c
/// extern DECLSPEC SDL_AudioDeviceID SDLCALL SDL_OpenAudioDevice(const char *device, int iscapture, const SDL_AudioSpec * desired, SDL_AudioSpec * obtained, int allowed_changes)
/// ```
int SDL_OpenAudioDevice(String device, int iscapture, Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained, int allowed_changes) {
  final _SDL_OpenAudioDevice = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Utf8>? device, Int32 iscapture, Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained, Int32 allowed_changes),
      int Function(Pointer<Utf8>? device, int iscapture, Pointer<SDL_AudioSpec>? desired, Pointer<SDL_AudioSpec>? obtained, int allowed_changes)>('SDL_OpenAudioDevice');
  final _devicePointer = device.toNativeUtf8();
  final _result = _SDL_OpenAudioDevice(_devicePointer, iscapture, desired, obtained, allowed_changes);
  calloc.free(_devicePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC SDL_AudioStatus SDLCALL SDL_GetAudioStatus(void)
/// ```
int SDL_GetAudioStatus() {
  final _SDL_GetAudioStatus = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetAudioStatus');
  return _SDL_GetAudioStatus();
}

/// ```c
/// extern DECLSPEC SDL_AudioStatus SDLCALL SDL_GetAudioDeviceStatus(SDL_AudioDeviceID dev)
/// ```
int SDL_GetAudioDeviceStatus(int dev) {
  final _SDL_GetAudioDeviceStatus = _SDL2.lookupFunction<
      Int32 Function(Uint32 dev),
      int Function(int dev)>('SDL_GetAudioDeviceStatus');
  return _SDL_GetAudioDeviceStatus(dev);
}

/// @{
/// ```c
/// extern DECLSPEC void SDLCALL SDL_PauseAudio(int pause_on)
/// ```
void SDL_PauseAudio(int pause_on) {
  final _SDL_PauseAudio = _SDL2.lookupFunction<
      Void Function(Int32 pause_on),
      void Function(int pause_on)>('SDL_PauseAudio');
  return _SDL_PauseAudio(pause_on);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_PauseAudioDevice(SDL_AudioDeviceID dev, int pause_on)
/// ```
void SDL_PauseAudioDevice(int dev, int pause_on) {
  final _SDL_PauseAudioDevice = _SDL2.lookupFunction<
      Void Function(Uint32 dev, Int32 pause_on),
      void Function(int dev, int pause_on)>('SDL_PauseAudioDevice');
  return _SDL_PauseAudioDevice(dev, pause_on);
}

/// 
/// This function loads a WAVE from the data source, automatically freeing
/// that source if \c freesrc is non-zero.  For example, to load a WAVE file,
/// you could do:
/// \code
/// SDL_LoadWAV_RW(SDL_RWFromFile("sample.wav", "rb"), 1, ...);
/// \endcode
/// 
/// If this function succeeds, it returns the given SDL_AudioSpec,
/// filled with the audio data format of the wave data, and sets
/// \c *audio_buf to a malloc()'d buffer containing the audio data,
/// and sets \c *audio_len to the length of that audio buffer, in bytes.
/// You need to free the audio buffer with SDL_FreeWAV() when you are
/// done with it.
/// 
/// This function returns NULL and sets the SDL error message if the
/// wave file cannot be opened, uses an unknown data format, or is
/// corrupt.  Currently raw and MS-ADPCM WAVE files are supported.
/// 
/// ```c
/// extern DECLSPEC SDL_AudioSpec *SDLCALL SDL_LoadWAV_RW(SDL_RWops * src, int freesrc, SDL_AudioSpec * spec, Uint8 ** audio_buf, Uint32 * audio_len)
/// ```
Pointer<SDL_AudioSpec>? SDL_LoadWAV_RW(Pointer<SDL_RWops>? src, int freesrc, Pointer<SDL_AudioSpec>? spec, Pointer<Pointer<Uint8>>? audio_buf, Pointer<Uint32>? audio_len) {
  final _SDL_LoadWAV_RW = _SDL2.lookupFunction<
      Pointer<SDL_AudioSpec>? Function(Pointer<SDL_RWops>? src, Int32 freesrc, Pointer<SDL_AudioSpec>? spec, Pointer<Pointer<Uint8>>? audio_buf, Pointer<Uint32>? audio_len),
      Pointer<SDL_AudioSpec>? Function(Pointer<SDL_RWops>? src, int freesrc, Pointer<SDL_AudioSpec>? spec, Pointer<Pointer<Uint8>>? audio_buf, Pointer<Uint32>? audio_len)>('SDL_LoadWAV_RW');
  return _SDL_LoadWAV_RW(src, freesrc, spec, audio_buf, audio_len);
}

/// 
/// This function frees data previously allocated with SDL_LoadWAV_RW()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreeWAV(Uint8 * audio_buf)
/// ```
void SDL_FreeWAV(Pointer<Uint8>? audio_buf) {
  final _SDL_FreeWAV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? audio_buf),
      void Function(Pointer<Uint8>? audio_buf)>('SDL_FreeWAV');
  return _SDL_FreeWAV(audio_buf);
}

/// 
/// This function takes a source format and rate and a destination format
/// and rate, and initializes the \c cvt structure with information needed
/// by SDL_ConvertAudio() to convert a buffer of audio data from one format
/// to the other.
/// 
/// \return -1 if the format conversion is not supported, 0 if there's
/// no conversion needed, or 1 if the audio filter is set up.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_BuildAudioCVT(SDL_AudioCVT * cvt, SDL_AudioFormat src_format, Uint8 src_channels, int src_rate, SDL_AudioFormat dst_format, Uint8 dst_channels, int dst_rate)
/// ```
int SDL_BuildAudioCVT(Pointer<SDL_AudioCVT>? cvt, int src_format, int src_channels, int src_rate, int dst_format, int dst_channels, int dst_rate) {
  final _SDL_BuildAudioCVT = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_AudioCVT>? cvt, Uint16 src_format, Uint8 src_channels, Int32 src_rate, Uint16 dst_format, Uint8 dst_channels, Int32 dst_rate),
      int Function(Pointer<SDL_AudioCVT>? cvt, int src_format, int src_channels, int src_rate, int dst_format, int dst_channels, int dst_rate)>('SDL_BuildAudioCVT');
  return _SDL_BuildAudioCVT(cvt, src_format, src_channels, src_rate, dst_format, dst_channels, dst_rate);
}

/// 
/// Once you have initialized the \c cvt structure using SDL_BuildAudioCVT(),
/// created an audio buffer \c cvt->buf, and filled it with \c cvt->len bytes of
/// audio data in the source format, this function will convert it in-place
/// to the desired format.
/// 
/// The data conversion may expand the size of the audio data, so the buffer
/// \c cvt->buf should be allocated after the \c cvt structure is initialized by
/// SDL_BuildAudioCVT(), and should be \c cvt->len*cvt->len_mult bytes long.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_ConvertAudio(SDL_AudioCVT * cvt)
/// ```
int SDL_ConvertAudio(Pointer<SDL_AudioCVT>? cvt) {
  final _SDL_ConvertAudio = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_AudioCVT>? cvt),
      int Function(Pointer<SDL_AudioCVT>? cvt)>('SDL_ConvertAudio');
  return _SDL_ConvertAudio(cvt);
}

/// 
/// This takes two audio buffers of the playing audio format and mixes
/// them, performing addition, volume adjustment, and overflow clipping.
/// The volume ranges from 0 - 128, and should be set to ::SDL_MIX_MAXVOLUME
/// for full audio volume.  Note this does not change hardware volume.
/// This is provided for convenience -- you can mix your own audio data.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_MixAudio(Uint8 * dst, const Uint8 * src, Uint32 len, int volume)
/// ```
void SDL_MixAudio(Pointer<Uint8>? dst, Pointer<Uint8>? src, int len, int volume) {
  final _SDL_MixAudio = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? dst, Pointer<Uint8>? src, Uint32 len, Int32 volume),
      void Function(Pointer<Uint8>? dst, Pointer<Uint8>? src, int len, int volume)>('SDL_MixAudio');
  return _SDL_MixAudio(dst, src, len, volume);
}

/// 
/// This works like SDL_MixAudio(), but you specify the audio format instead of
/// using the format of audio device 1. Thus it can be used when no audio
/// device is open at all.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_MixAudioFormat(Uint8 * dst, const Uint8 * src, SDL_AudioFormat format, Uint32 len, int volume)
/// ```
void SDL_MixAudioFormat(Pointer<Uint8>? dst, Pointer<Uint8>? src, int format, int len, int volume) {
  final _SDL_MixAudioFormat = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? dst, Pointer<Uint8>? src, Uint16 format, Uint32 len, Int32 volume),
      void Function(Pointer<Uint8>? dst, Pointer<Uint8>? src, int format, int len, int volume)>('SDL_MixAudioFormat');
  return _SDL_MixAudioFormat(dst, src, format, len, volume);
}

/// @{
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LockAudio(void)
/// ```
void SDL_LockAudio() {
  final _SDL_LockAudio = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_LockAudio');
  return _SDL_LockAudio();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_LockAudioDevice(SDL_AudioDeviceID dev)
/// ```
void SDL_LockAudioDevice(int dev) {
  final _SDL_LockAudioDevice = _SDL2.lookupFunction<
      Void Function(Uint32 dev),
      void Function(int dev)>('SDL_LockAudioDevice');
  return _SDL_LockAudioDevice(dev);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnlockAudio(void)
/// ```
void SDL_UnlockAudio() {
  final _SDL_UnlockAudio = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_UnlockAudio');
  return _SDL_UnlockAudio();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnlockAudioDevice(SDL_AudioDeviceID dev)
/// ```
void SDL_UnlockAudioDevice(int dev) {
  final _SDL_UnlockAudioDevice = _SDL2.lookupFunction<
      Void Function(Uint32 dev),
      void Function(int dev)>('SDL_UnlockAudioDevice');
  return _SDL_UnlockAudioDevice(dev);
}

/// 
/// This function shuts down audio processing and closes the audio device.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_CloseAudio(void)
/// ```
void SDL_CloseAudio() {
  final _SDL_CloseAudio = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_CloseAudio');
  return _SDL_CloseAudio();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_CloseAudioDevice(SDL_AudioDeviceID dev)
/// ```
void SDL_CloseAudioDevice(int dev) {
  final _SDL_CloseAudioDevice = _SDL2.lookupFunction<
      Void Function(Uint32 dev),
      void Function(int dev)>('SDL_CloseAudioDevice');
  return _SDL_CloseAudioDevice(dev);
}

/// 
/// \brief Put UTF-8 text into the clipboard
/// 
/// \sa SDL_GetClipboardText()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetClipboardText(const char *text)
/// ```
int SDL_SetClipboardText(String text) {
  final _SDL_SetClipboardText = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? text),
      int Function(Pointer<Utf8>? text)>('SDL_SetClipboardText');
  final _textPointer = text.toNativeUtf8();
  final _result = _SDL_SetClipboardText(_textPointer);
  calloc.free(_textPointer);
  return _result;
}

/// 
/// \brief Get UTF-8 text from the clipboard, which must be freed with SDL_free()
/// 
/// \sa SDL_SetClipboardText()
/// 
/// ```c
/// extern DECLSPEC char * SDLCALL SDL_GetClipboardText(void)
/// ```
Pointer<Int8>? SDL_GetClipboardText() {
  final _SDL_GetClipboardText = _SDL2.lookupFunction<
      Pointer<Int8>? Function(),
      Pointer<Int8>? Function()>('SDL_GetClipboardText');
  return _SDL_GetClipboardText();
}

/// 
/// \brief Returns a flag indicating whether the clipboard exists and contains a text string that is non-empty
/// 
/// \sa SDL_GetClipboardText()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasClipboardText(void)
/// ```
int SDL_HasClipboardText() {
  final _SDL_HasClipboardText = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasClipboardText');
  return _SDL_HasClipboardText();
}

/// 
/// This function returns the number of CPU cores available.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetCPUCount(void)
/// ```
int SDL_GetCPUCount() {
  final _SDL_GetCPUCount = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetCPUCount');
  return _SDL_GetCPUCount();
}

/// 
/// This function returns the L1 cache line size of the CPU
/// 
/// This is useful for determining multi-threaded structure padding
/// or SIMD prefetch sizes.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetCPUCacheLineSize(void)
/// ```
int SDL_GetCPUCacheLineSize() {
  final _SDL_GetCPUCacheLineSize = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetCPUCacheLineSize');
  return _SDL_GetCPUCacheLineSize();
}

/// 
/// This function returns true if the CPU has the RDTSC instruction.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasRDTSC(void)
/// ```
int SDL_HasRDTSC() {
  final _SDL_HasRDTSC = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasRDTSC');
  return _SDL_HasRDTSC();
}

/// 
/// This function returns true if the CPU has AltiVec features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasAltiVec(void)
/// ```
int SDL_HasAltiVec() {
  final _SDL_HasAltiVec = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasAltiVec');
  return _SDL_HasAltiVec();
}

/// 
/// This function returns true if the CPU has MMX features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasMMX(void)
/// ```
int SDL_HasMMX() {
  final _SDL_HasMMX = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasMMX');
  return _SDL_HasMMX();
}

/// 
/// This function returns true if the CPU has 3DNow! features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_Has3DNow(void)
/// ```
int SDL_Has3DNow() {
  final _SDL_Has3DNow = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_Has3DNow');
  return _SDL_Has3DNow();
}

/// 
/// This function returns true if the CPU has SSE features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasSSE(void)
/// ```
int SDL_HasSSE() {
  final _SDL_HasSSE = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasSSE');
  return _SDL_HasSSE();
}

/// 
/// This function returns true if the CPU has SSE2 features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasSSE2(void)
/// ```
int SDL_HasSSE2() {
  final _SDL_HasSSE2 = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasSSE2');
  return _SDL_HasSSE2();
}

/// 
/// This function returns true if the CPU has SSE3 features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasSSE3(void)
/// ```
int SDL_HasSSE3() {
  final _SDL_HasSSE3 = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasSSE3');
  return _SDL_HasSSE3();
}

/// 
/// This function returns true if the CPU has SSE4.1 features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasSSE41(void)
/// ```
int SDL_HasSSE41() {
  final _SDL_HasSSE41 = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasSSE41');
  return _SDL_HasSSE41();
}

/// 
/// This function returns true if the CPU has SSE4.2 features.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasSSE42(void)
/// ```
int SDL_HasSSE42() {
  final _SDL_HasSSE42 = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasSSE42');
  return _SDL_HasSSE42();
}

/// SDL_SetError() unconditionally returns -1.
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetError(const char *fmt, ...)
/// ```
int SDL_SetError(String fmt, Pointer<Void>? arg1) {
  final _SDL_SetError = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? fmt, Pointer<Void>? arg1),
      int Function(Pointer<Utf8>? fmt, Pointer<Void>? arg1)>('SDL_SetError');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_SetError(_fmtPointer, arg1);
  calloc.free(_fmtPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetError(void)
/// ```
String SDL_GetError() {
  final _SDL_GetError = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_GetError');
  return _SDL_GetError()!.toDartString();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_ClearError(void)
/// ```
void SDL_ClearError() {
  final _SDL_ClearError = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_ClearError');
  return _SDL_ClearError();
}

/// SDL_Error() unconditionally returns -1.
/// ```c
/// extern DECLSPEC int SDLCALL SDL_Error(SDL_errorcode code)
/// ```
int SDL_Error(int code) {
  final _SDL_Error = _SDL2.lookupFunction<
      Int32 Function(Int32 code),
      int Function(int code)>('SDL_Error');
  return _SDL_Error(code);
}

/// 
/// Pumps the event loop, gathering events from the input devices.
/// 
/// This function updates the event queue and internal input device state.
/// 
/// This should only be run in the thread that sets the video mode.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_PumpEvents(void)
/// ```
void SDL_PumpEvents() {
  final _SDL_PumpEvents = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_PumpEvents');
  return _SDL_PumpEvents();
}

/// 
/// Checks the event queue for messages and optionally returns them.
/// 
/// If \c action is ::SDL_ADDEVENT, up to \c numevents events will be added to
/// the back of the event queue.
/// 
/// If \c action is ::SDL_PEEKEVENT, up to \c numevents events at the front
/// of the event queue, within the specified minimum and maximum type,
/// will be returned and will not be removed from the queue.
/// 
/// If \c action is ::SDL_GETEVENT, up to \c numevents events at the front
/// of the event queue, within the specified minimum and maximum type,
/// will be returned and will be removed from the queue.
/// 
/// \return The number of events actually stored, or -1 if there was an error.
/// 
/// This function is thread-safe.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_PeepEvents(SDL_Event * events, int numevents, SDL_eventaction action, Uint32 minType, Uint32 maxType)
/// ```
int SDL_PeepEvents(Pointer<SDL_Event>? events, int numevents, int action, int minType, int maxType) {
  final _SDL_PeepEvents = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Event>? events, Int32 numevents, Int32 action, Uint32 minType, Uint32 maxType),
      int Function(Pointer<SDL_Event>? events, int numevents, int action, int minType, int maxType)>('SDL_PeepEvents');
  return _SDL_PeepEvents(events, numevents, action, minType, maxType);
}

/// 
/// Checks to see if certain event types are in the event queue.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasEvent(Uint32 type)
/// ```
int SDL_HasEvent(int type) {
  final _SDL_HasEvent = _SDL2.lookupFunction<
      Int32 Function(Uint32 type),
      int Function(int type)>('SDL_HasEvent');
  return _SDL_HasEvent(type);
}

/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasEvents(Uint32 minType, Uint32 maxType)
/// ```
int SDL_HasEvents(int minType, int maxType) {
  final _SDL_HasEvents = _SDL2.lookupFunction<
      Int32 Function(Uint32 minType, Uint32 maxType),
      int Function(int minType, int maxType)>('SDL_HasEvents');
  return _SDL_HasEvents(minType, maxType);
}

/// 
/// This function clears events from the event queue
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FlushEvent(Uint32 type)
/// ```
void SDL_FlushEvent(int type) {
  final _SDL_FlushEvent = _SDL2.lookupFunction<
      Void Function(Uint32 type),
      void Function(int type)>('SDL_FlushEvent');
  return _SDL_FlushEvent(type);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_FlushEvents(Uint32 minType, Uint32 maxType)
/// ```
void SDL_FlushEvents(int minType, int maxType) {
  final _SDL_FlushEvents = _SDL2.lookupFunction<
      Void Function(Uint32 minType, Uint32 maxType),
      void Function(int minType, int maxType)>('SDL_FlushEvents');
  return _SDL_FlushEvents(minType, maxType);
}

/// 
/// \brief Polls for currently pending events.
/// 
/// \return 1 if there are any pending events, or 0 if there are none available.
/// 
/// \param event If not NULL, the next event is removed from the queue and
/// stored in that area.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_PollEvent(SDL_Event * event)
/// ```
int SDL_PollEvent(Pointer<SDL_Event>? event) {
  final _SDL_PollEvent = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Event>? event),
      int Function(Pointer<SDL_Event>? event)>('SDL_PollEvent');
  return _SDL_PollEvent(event);
}

/// 
/// \brief Waits indefinitely for the next available event.
/// 
/// \return 1, or 0 if there was an error while waiting for events.
/// 
/// \param event If not NULL, the next event is removed from the queue and
/// stored in that area.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_WaitEvent(SDL_Event * event)
/// ```
int SDL_WaitEvent(Pointer<SDL_Event>? event) {
  final _SDL_WaitEvent = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Event>? event),
      int Function(Pointer<SDL_Event>? event)>('SDL_WaitEvent');
  return _SDL_WaitEvent(event);
}

/// 
/// \brief Waits until the specified timeout (in milliseconds) for the next
/// available event.
/// 
/// \return 1, or 0 if there was an error while waiting for events.
/// 
/// \param event If not NULL, the next event is removed from the queue and
/// stored in that area.
/// \param timeout The timeout (in milliseconds) to wait for next event.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_WaitEventTimeout(SDL_Event * event, int timeout)
/// ```
int SDL_WaitEventTimeout(Pointer<SDL_Event>? event, int timeout) {
  final _SDL_WaitEventTimeout = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Event>? event, Int32 timeout),
      int Function(Pointer<SDL_Event>? event, int timeout)>('SDL_WaitEventTimeout');
  return _SDL_WaitEventTimeout(event, timeout);
}

/// 
/// \brief Add an event to the event queue.
/// 
/// \return 1 on success, 0 if the event was filtered, or -1 if the event queue
/// was full or there was some other error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_PushEvent(SDL_Event * event)
/// ```
int SDL_PushEvent(Pointer<SDL_Event>? event) {
  final _SDL_PushEvent = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Event>? event),
      int Function(Pointer<SDL_Event>? event)>('SDL_PushEvent');
  return _SDL_PushEvent(event);
}

/// 
/// Sets up a filter to process all events before they change internal state and
/// are posted to the internal event queue.
/// 
/// The filter is prototyped as:
/// \code
/// int SDL_EventFilter(void *userdata, SDL_Event * event);
/// \endcode
/// 
/// If the filter returns 1, then the event will be added to the internal queue.
/// If it returns 0, then the event will be dropped from the queue, but the
/// internal state will still be updated.  This allows selective filtering of
/// dynamically arriving events.
/// 
/// \warning  Be very careful of what you do in the event filter function, as
/// it may run in a different thread!
/// 
/// There is one caveat when dealing with the ::SDL_QuitEvent event type.  The
/// event filter is only called when the window manager desires to close the
/// application window.  If the event filter returns 1, then the window will
/// be closed, otherwise the window will remain open if possible.
/// 
/// If the quit event is generated by an interrupt signal, it will bypass the
/// internal queue and be delivered to the application at the next event poll.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetEventFilter(SDL_EventFilter filter, void *userdata)
/// ```
void SDL_SetEventFilter(Pointer<Void>? filter, Pointer<Void>? userdata) {
  final _SDL_SetEventFilter = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? filter, Pointer<Void>? userdata),
      void Function(Pointer<Void>? filter, Pointer<Void>? userdata)>('SDL_SetEventFilter');
  return _SDL_SetEventFilter(filter, userdata);
}

/// 
/// Return the current event filter - can be used to "chain" filters.
/// If there is no event filter set, this function returns SDL_FALSE.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GetEventFilter(SDL_EventFilter * filter, void **userdata)
/// ```
int SDL_GetEventFilter(Pointer<Pointer<Void>>? filter, Pointer<Pointer<Void>>? userdata) {
  final _SDL_GetEventFilter = _SDL2.lookupFunction<
      Int32 Function(Pointer<Pointer<Void>>? filter, Pointer<Pointer<Void>>? userdata),
      int Function(Pointer<Pointer<Void>>? filter, Pointer<Pointer<Void>>? userdata)>('SDL_GetEventFilter');
  return _SDL_GetEventFilter(filter, userdata);
}

/// 
/// Add a function which is called when an event is added to the queue.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_AddEventWatch(SDL_EventFilter filter, void *userdata)
/// ```
void SDL_AddEventWatch(Pointer<Void>? filter, Pointer<Void>? userdata) {
  final _SDL_AddEventWatch = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? filter, Pointer<Void>? userdata),
      void Function(Pointer<Void>? filter, Pointer<Void>? userdata)>('SDL_AddEventWatch');
  return _SDL_AddEventWatch(filter, userdata);
}

/// 
/// Remove an event watch function added with SDL_AddEventWatch()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DelEventWatch(SDL_EventFilter filter, void *userdata)
/// ```
void SDL_DelEventWatch(Pointer<Void>? filter, Pointer<Void>? userdata) {
  final _SDL_DelEventWatch = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? filter, Pointer<Void>? userdata),
      void Function(Pointer<Void>? filter, Pointer<Void>? userdata)>('SDL_DelEventWatch');
  return _SDL_DelEventWatch(filter, userdata);
}

/// 
/// Run the filter function on the current event queue, removing any
/// events for which the filter returns 0.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FilterEvents(SDL_EventFilter filter, void *userdata)
/// ```
void SDL_FilterEvents(Pointer<Void>? filter, Pointer<Void>? userdata) {
  final _SDL_FilterEvents = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? filter, Pointer<Void>? userdata),
      void Function(Pointer<Void>? filter, Pointer<Void>? userdata)>('SDL_FilterEvents');
  return _SDL_FilterEvents(filter, userdata);
}

/// 
/// This function allows you to set the state of processing certain events.
/// - If \c state is set to ::SDL_IGNORE, that event will be automatically
/// dropped from the event queue and will not event be filtered.
/// - If \c state is set to ::SDL_ENABLE, that event will be processed
/// normally.
/// - If \c state is set to ::SDL_QUERY, SDL_EventState() will return the
/// current processing state of the specified event.
/// 
/// ```c
/// extern DECLSPEC Uint8 SDLCALL SDL_EventState(Uint32 type, int state)
/// ```
int SDL_EventState(int type, int state) {
  final _SDL_EventState = _SDL2.lookupFunction<
      Uint8 Function(Uint32 type, Int32 state),
      int Function(int type, int state)>('SDL_EventState');
  return _SDL_EventState(type, state);
}

/// 
/// This function allocates a set of user-defined events, and returns
/// the beginning event number for that set of events.
/// 
/// If there aren't enough user-defined events left, this function
/// returns (Uint32)-1
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_RegisterEvents(int numevents)
/// ```
int SDL_RegisterEvents(int numevents) {
  final _SDL_RegisterEvents = _SDL2.lookupFunction<
      Uint32 Function(Int32 numevents),
      int Function(int numevents)>('SDL_RegisterEvents');
  return _SDL_RegisterEvents(numevents);
}

/// 
/// Add or update an existing mapping configuration
/// 
/// \return 1 if mapping is added, 0 if updated, -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GameControllerAddMapping( const char* mappingString )
/// ```
int SDL_GameControllerAddMapping(String mappingString) {
  final _SDL_GameControllerAddMapping = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? mappingString),
      int Function(Pointer<Utf8>? mappingString)>('SDL_GameControllerAddMapping');
  final _mappingStringPointer = mappingString.toNativeUtf8();
  final _result = _SDL_GameControllerAddMapping(_mappingStringPointer);
  calloc.free(_mappingStringPointer);
  return _result;
}

/// 
/// Get a mapping string for a GUID
/// 
/// \return the mapping string.  Must be freed with SDL_free.  Returns NULL if no mapping is available
/// 
/// ```c
/// extern DECLSPEC char * SDLCALL SDL_GameControllerMappingForGUID( SDL_JoystickGUID guid )
/// ```
Pointer<Int8>? SDL_GameControllerMappingForGUID(Pointer<Void>? guid) {
  final _SDL_GameControllerMappingForGUID = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Void>? guid),
      Pointer<Int8>? Function(Pointer<Void>? guid)>('SDL_GameControllerMappingForGUID');
  return _SDL_GameControllerMappingForGUID(guid);
}

/// 
/// Get a mapping string for an open GameController
/// 
/// \return the mapping string.  Must be freed with SDL_free.  Returns NULL if no mapping is available
/// 
/// ```c
/// extern DECLSPEC char * SDLCALL SDL_GameControllerMapping( SDL_GameController * gamecontroller )
/// ```
Pointer<Int8>? SDL_GameControllerMapping(Pointer<SDL_GameController>? gamecontroller) {
  final _SDL_GameControllerMapping = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<SDL_GameController>? gamecontroller),
      Pointer<Int8>? Function(Pointer<SDL_GameController>? gamecontroller)>('SDL_GameControllerMapping');
  return _SDL_GameControllerMapping(gamecontroller);
}

/// 
/// Is the joystick on this index supported by the game controller interface?
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IsGameController(int joystick_index)
/// ```
int SDL_IsGameController(int joystick_index) {
  final _SDL_IsGameController = _SDL2.lookupFunction<
      Int32 Function(Int32 joystick_index),
      int Function(int joystick_index)>('SDL_IsGameController');
  return _SDL_IsGameController(joystick_index);
}

/// 
/// Get the implementation dependent name of a game controller.
/// This can be called before any controllers are opened.
/// If no name can be found, this function returns NULL.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GameControllerNameForIndex(int joystick_index)
/// ```
String SDL_GameControllerNameForIndex(int joystick_index) {
  final _SDL_GameControllerNameForIndex = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 joystick_index),
      Pointer<Utf8>? Function(int joystick_index)>('SDL_GameControllerNameForIndex');
  return _SDL_GameControllerNameForIndex(joystick_index)!.toDartString();
}

/// 
/// Open a game controller for use.
/// The index passed as an argument refers to the N'th game controller on the system.
/// This index is the value which will identify this controller in future controller
/// events.
/// 
/// \return A controller identifier, or NULL if an error occurred.
/// 
/// ```c
/// extern DECLSPEC SDL_GameController *SDLCALL SDL_GameControllerOpen(int joystick_index)
/// ```
Pointer<SDL_GameController>? SDL_GameControllerOpen(int joystick_index) {
  final _SDL_GameControllerOpen = _SDL2.lookupFunction<
      Pointer<SDL_GameController>? Function(Int32 joystick_index),
      Pointer<SDL_GameController>? Function(int joystick_index)>('SDL_GameControllerOpen');
  return _SDL_GameControllerOpen(joystick_index);
}

/// 
/// Return the name for this currently opened controller
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GameControllerName(SDL_GameController *gamecontroller)
/// ```
String SDL_GameControllerName(Pointer<SDL_GameController>? gamecontroller) {
  final _SDL_GameControllerName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Pointer<SDL_GameController>? gamecontroller),
      Pointer<Utf8>? Function(Pointer<SDL_GameController>? gamecontroller)>('SDL_GameControllerName');
  return _SDL_GameControllerName(gamecontroller)!.toDartString();
}

/// 
/// Returns SDL_TRUE if the controller has been opened and currently connected,
/// or SDL_FALSE if it has not.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GameControllerGetAttached(SDL_GameController *gamecontroller)
/// ```
int SDL_GameControllerGetAttached(Pointer<SDL_GameController>? gamecontroller) {
  final _SDL_GameControllerGetAttached = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_GameController>? gamecontroller),
      int Function(Pointer<SDL_GameController>? gamecontroller)>('SDL_GameControllerGetAttached');
  return _SDL_GameControllerGetAttached(gamecontroller);
}

/// 
/// Get the underlying joystick object used by a controller
/// 
/// ```c
/// extern DECLSPEC SDL_Joystick *SDLCALL SDL_GameControllerGetJoystick(SDL_GameController *gamecontroller)
/// ```
Pointer<SDL_Joystick>? SDL_GameControllerGetJoystick(Pointer<SDL_GameController>? gamecontroller) {
  final _SDL_GameControllerGetJoystick = _SDL2.lookupFunction<
      Pointer<SDL_Joystick>? Function(Pointer<SDL_GameController>? gamecontroller),
      Pointer<SDL_Joystick>? Function(Pointer<SDL_GameController>? gamecontroller)>('SDL_GameControllerGetJoystick');
  return _SDL_GameControllerGetJoystick(gamecontroller);
}

/// 
/// Enable/disable controller event polling.
/// 
/// If controller events are disabled, you must call SDL_GameControllerUpdate()
/// yourself and check the state of the controller when you want controller
/// information.
/// 
/// The state can be one of ::SDL_QUERY, ::SDL_ENABLE or ::SDL_IGNORE.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GameControllerEventState(int state)
/// ```
int SDL_GameControllerEventState(int state) {
  final _SDL_GameControllerEventState = _SDL2.lookupFunction<
      Int32 Function(Int32 state),
      int Function(int state)>('SDL_GameControllerEventState');
  return _SDL_GameControllerEventState(state);
}

/// 
/// Update the current state of the open game controllers.
/// 
/// This is called automatically by the event loop if any game controller
/// events are enabled.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GameControllerUpdate(void)
/// ```
void SDL_GameControllerUpdate() {
  final _SDL_GameControllerUpdate = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_GameControllerUpdate');
  return _SDL_GameControllerUpdate();
}

/// 
/// turn this string into a axis mapping
/// 
/// ```c
/// extern DECLSPEC SDL_GameControllerAxis SDLCALL SDL_GameControllerGetAxisFromString(const char *pchString)
/// ```
int SDL_GameControllerGetAxisFromString(String pchString) {
  final _SDL_GameControllerGetAxisFromString = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? pchString),
      int Function(Pointer<Utf8>? pchString)>('SDL_GameControllerGetAxisFromString');
  final _pchStringPointer = pchString.toNativeUtf8();
  final _result = _SDL_GameControllerGetAxisFromString(_pchStringPointer);
  calloc.free(_pchStringPointer);
  return _result;
}

/// 
/// turn this axis enum into a string mapping
/// 
/// ```c
/// extern DECLSPEC const char* SDLCALL SDL_GameControllerGetStringForAxis(SDL_GameControllerAxis axis)
/// ```
String SDL_GameControllerGetStringForAxis(int axis) {
  final _SDL_GameControllerGetStringForAxis = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 axis),
      Pointer<Utf8>? Function(int axis)>('SDL_GameControllerGetStringForAxis');
  return _SDL_GameControllerGetStringForAxis(axis)!.toDartString();
}

/// 
/// Get the SDL joystick layer binding for this controller button mapping
/// 
/// ```c
/// extern DECLSPEC SDL_GameControllerButtonBind SDLCALL SDL_GameControllerGetBindForAxis(SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
/// ```
Pointer<Void>? SDL_GameControllerGetBindForAxis(Pointer<SDL_GameController>? gamecontroller, int axis) {
  final _SDL_GameControllerGetBindForAxis = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_GameController>? gamecontroller, Int32 axis),
      Pointer<Void>? Function(Pointer<SDL_GameController>? gamecontroller, int axis)>('SDL_GameControllerGetBindForAxis');
  return _SDL_GameControllerGetBindForAxis(gamecontroller, axis);
}

/// 
/// Get the current state of an axis control on a game controller.
/// 
/// The state is a value ranging from -32768 to 32767.
/// 
/// The axis indices start at index 0.
/// 
/// ```c
/// extern DECLSPEC Sint16 SDLCALL SDL_GameControllerGetAxis(SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
/// ```
int SDL_GameControllerGetAxis(Pointer<SDL_GameController>? gamecontroller, int axis) {
  final _SDL_GameControllerGetAxis = _SDL2.lookupFunction<
      Int16 Function(Pointer<SDL_GameController>? gamecontroller, Int32 axis),
      int Function(Pointer<SDL_GameController>? gamecontroller, int axis)>('SDL_GameControllerGetAxis');
  return _SDL_GameControllerGetAxis(gamecontroller, axis);
}

/// 
/// turn this string into a button mapping
/// 
/// ```c
/// extern DECLSPEC SDL_GameControllerButton SDLCALL SDL_GameControllerGetButtonFromString(const char *pchString)
/// ```
int SDL_GameControllerGetButtonFromString(String pchString) {
  final _SDL_GameControllerGetButtonFromString = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? pchString),
      int Function(Pointer<Utf8>? pchString)>('SDL_GameControllerGetButtonFromString');
  final _pchStringPointer = pchString.toNativeUtf8();
  final _result = _SDL_GameControllerGetButtonFromString(_pchStringPointer);
  calloc.free(_pchStringPointer);
  return _result;
}

/// 
/// turn this button enum into a string mapping
/// 
/// ```c
/// extern DECLSPEC const char* SDLCALL SDL_GameControllerGetStringForButton(SDL_GameControllerButton button)
/// ```
String SDL_GameControllerGetStringForButton(int button) {
  final _SDL_GameControllerGetStringForButton = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 button),
      Pointer<Utf8>? Function(int button)>('SDL_GameControllerGetStringForButton');
  return _SDL_GameControllerGetStringForButton(button)!.toDartString();
}

/// 
/// Get the SDL joystick layer binding for this controller button mapping
/// 
/// ```c
/// extern DECLSPEC SDL_GameControllerButtonBind SDLCALL SDL_GameControllerGetBindForButton(SDL_GameController *gamecontroller, SDL_GameControllerButton button)
/// ```
Pointer<Void>? SDL_GameControllerGetBindForButton(Pointer<SDL_GameController>? gamecontroller, int button) {
  final _SDL_GameControllerGetBindForButton = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_GameController>? gamecontroller, Int32 button),
      Pointer<Void>? Function(Pointer<SDL_GameController>? gamecontroller, int button)>('SDL_GameControllerGetBindForButton');
  return _SDL_GameControllerGetBindForButton(gamecontroller, button);
}

/// 
/// Get the current state of a button on a game controller.
/// 
/// The button indices start at index 0.
/// 
/// ```c
/// extern DECLSPEC Uint8 SDLCALL SDL_GameControllerGetButton(SDL_GameController *gamecontroller, SDL_GameControllerButton button)
/// ```
int SDL_GameControllerGetButton(Pointer<SDL_GameController>? gamecontroller, int button) {
  final _SDL_GameControllerGetButton = _SDL2.lookupFunction<
      Uint8 Function(Pointer<SDL_GameController>? gamecontroller, Int32 button),
      int Function(Pointer<SDL_GameController>? gamecontroller, int button)>('SDL_GameControllerGetButton');
  return _SDL_GameControllerGetButton(gamecontroller, button);
}

/// 
/// Close a controller previously opened with SDL_GameControllerOpen().
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GameControllerClose(SDL_GameController *gamecontroller)
/// ```
void SDL_GameControllerClose(Pointer<SDL_GameController>? gamecontroller) {
  final _SDL_GameControllerClose = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_GameController>? gamecontroller),
      void Function(Pointer<SDL_GameController>? gamecontroller)>('SDL_GameControllerClose');
  return _SDL_GameControllerClose(gamecontroller);
}

/// 
/// \brief Begin Recording a gesture on the specified touch, or all touches (-1)
/// 
/// 
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RecordGesture(SDL_TouchID touchId)
/// ```
int SDL_RecordGesture(int touchId) {
  final _SDL_RecordGesture = _SDL2.lookupFunction<
      Int32 Function(Int64 touchId),
      int Function(int touchId)>('SDL_RecordGesture');
  return _SDL_RecordGesture(touchId);
}

/// 
/// \brief Save all currently loaded Dollar Gesture templates
/// 
/// 
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SaveAllDollarTemplates(SDL_RWops *src)
/// ```
int SDL_SaveAllDollarTemplates(Pointer<SDL_RWops>? src) {
  final _SDL_SaveAllDollarTemplates = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_SaveAllDollarTemplates');
  return _SDL_SaveAllDollarTemplates(src);
}

/// 
/// \brief Save a currently loaded Dollar Gesture template
/// 
/// 
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SaveDollarTemplate(SDL_GestureID gestureId,SDL_RWops *src)
/// ```
int SDL_SaveDollarTemplate(int gestureId, Pointer<SDL_RWops>? src) {
  final _SDL_SaveDollarTemplate = _SDL2.lookupFunction<
      Int32 Function(Int64 gestureId, Pointer<SDL_RWops>? src),
      int Function(int gestureId, Pointer<SDL_RWops>? src)>('SDL_SaveDollarTemplate');
  return _SDL_SaveDollarTemplate(gestureId, src);
}

/// 
/// \brief Load Dollar Gesture templates from a file
/// 
/// 
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LoadDollarTemplates(SDL_TouchID touchId, SDL_RWops *src)
/// ```
int SDL_LoadDollarTemplates(int touchId, Pointer<SDL_RWops>? src) {
  final _SDL_LoadDollarTemplates = _SDL2.lookupFunction<
      Int32 Function(Int64 touchId, Pointer<SDL_RWops>? src),
      int Function(int touchId, Pointer<SDL_RWops>? src)>('SDL_LoadDollarTemplates');
  return _SDL_LoadDollarTemplates(touchId, src);
}

/// 
/// \brief Count the number of haptic devices attached to the system.
/// 
/// \return Number of haptic devices detected on the system.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_NumHaptics(void)
/// ```
int SDL_NumHaptics() {
  final _SDL_NumHaptics = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_NumHaptics');
  return _SDL_NumHaptics();
}

/// 
/// \brief Get the implementation dependent name of a Haptic device.
/// 
/// This can be called before any joysticks are opened.
/// If no name can be found, this function returns NULL.
/// 
/// \param device_index Index of the device to get its name.
/// \return Name of the device or NULL on error.
/// 
/// \sa SDL_NumHaptics
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_HapticName(int device_index)
/// ```
String SDL_HapticName(int device_index) {
  final _SDL_HapticName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 device_index),
      Pointer<Utf8>? Function(int device_index)>('SDL_HapticName');
  return _SDL_HapticName(device_index)!.toDartString();
}

/// 
/// \brief Opens a Haptic device for usage.
/// 
/// The index passed as an argument refers to the N'th Haptic device on this
/// system.
/// 
/// When opening a haptic device, its gain will be set to maximum and
/// autocenter will be disabled.  To modify these values use
/// SDL_HapticSetGain() and SDL_HapticSetAutocenter().
/// 
/// \param device_index Index of the device to open.
/// \return Device identifier or NULL on error.
/// 
/// \sa SDL_HapticIndex
/// \sa SDL_HapticOpenFromMouse
/// \sa SDL_HapticOpenFromJoystick
/// \sa SDL_HapticClose
/// \sa SDL_HapticSetGain
/// \sa SDL_HapticSetAutocenter
/// \sa SDL_HapticPause
/// \sa SDL_HapticStopAll
/// 
/// ```c
/// extern DECLSPEC SDL_Haptic *SDLCALL SDL_HapticOpen(int device_index)
/// ```
Pointer<SDL_Haptic>? SDL_HapticOpen(int device_index) {
  final _SDL_HapticOpen = _SDL2.lookupFunction<
      Pointer<SDL_Haptic>? Function(Int32 device_index),
      Pointer<SDL_Haptic>? Function(int device_index)>('SDL_HapticOpen');
  return _SDL_HapticOpen(device_index);
}

/// 
/// \brief Checks if the haptic device at index has been opened.
/// 
/// \param device_index Index to check to see if it has been opened.
/// \return 1 if it has been opened or 0 if it hasn't.
/// 
/// \sa SDL_HapticOpen
/// \sa SDL_HapticIndex
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticOpened(int device_index)
/// ```
int SDL_HapticOpened(int device_index) {
  final _SDL_HapticOpened = _SDL2.lookupFunction<
      Int32 Function(Int32 device_index),
      int Function(int device_index)>('SDL_HapticOpened');
  return _SDL_HapticOpened(device_index);
}

/// 
/// \brief Gets the index of a haptic device.
/// 
/// \param haptic Haptic device to get the index of.
/// \return The index of the haptic device or -1 on error.
/// 
/// \sa SDL_HapticOpen
/// \sa SDL_HapticOpened
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticIndex(SDL_Haptic * haptic)
/// ```
int SDL_HapticIndex(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticIndex = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticIndex');
  return _SDL_HapticIndex(haptic);
}

/// 
/// \brief Gets whether or not the current mouse has haptic capabilities.
/// 
/// \return SDL_TRUE if the mouse is haptic, SDL_FALSE if it isn't.
/// 
/// \sa SDL_HapticOpenFromMouse
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_MouseIsHaptic(void)
/// ```
int SDL_MouseIsHaptic() {
  final _SDL_MouseIsHaptic = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_MouseIsHaptic');
  return _SDL_MouseIsHaptic();
}

/// 
/// \brief Tries to open a haptic device from the current mouse.
/// 
/// \return The haptic device identifier or NULL on error.
/// 
/// \sa SDL_MouseIsHaptic
/// \sa SDL_HapticOpen
/// 
/// ```c
/// extern DECLSPEC SDL_Haptic *SDLCALL SDL_HapticOpenFromMouse(void)
/// ```
Pointer<SDL_Haptic>? SDL_HapticOpenFromMouse() {
  final _SDL_HapticOpenFromMouse = _SDL2.lookupFunction<
      Pointer<SDL_Haptic>? Function(),
      Pointer<SDL_Haptic>? Function()>('SDL_HapticOpenFromMouse');
  return _SDL_HapticOpenFromMouse();
}

/// 
/// \brief Checks to see if a joystick has haptic features.
/// 
/// \param joystick Joystick to test for haptic capabilities.
/// \return 1 if the joystick is haptic, 0 if it isn't
/// or -1 if an error ocurred.
/// 
/// \sa SDL_HapticOpenFromJoystick
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickIsHaptic(SDL_Joystick * joystick)
/// ```
int SDL_JoystickIsHaptic(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickIsHaptic = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickIsHaptic');
  return _SDL_JoystickIsHaptic(joystick);
}

/// 
/// \brief Opens a Haptic device for usage from a Joystick device.
/// 
/// You must still close the haptic device seperately.  It will not be closed
/// with the joystick.
/// 
/// When opening from a joystick you should first close the haptic device before
/// closing the joystick device.  If not, on some implementations the haptic
/// device will also get unallocated and you'll be unable to use force feedback
/// on that device.
/// 
/// \param joystick Joystick to create a haptic device from.
/// \return A valid haptic device identifier on success or NULL on error.
/// 
/// \sa SDL_HapticOpen
/// \sa SDL_HapticClose
/// 
/// ```c
/// extern DECLSPEC SDL_Haptic *SDLCALL SDL_HapticOpenFromJoystick(SDL_Joystick * joystick)
/// ```
Pointer<SDL_Haptic>? SDL_HapticOpenFromJoystick(Pointer<SDL_Joystick>? joystick) {
  final _SDL_HapticOpenFromJoystick = _SDL2.lookupFunction<
      Pointer<SDL_Haptic>? Function(Pointer<SDL_Joystick>? joystick),
      Pointer<SDL_Haptic>? Function(Pointer<SDL_Joystick>? joystick)>('SDL_HapticOpenFromJoystick');
  return _SDL_HapticOpenFromJoystick(joystick);
}

/// 
/// \brief Closes a Haptic device previously opened with SDL_HapticOpen().
/// 
/// \param haptic Haptic device to close.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_HapticClose(SDL_Haptic * haptic)
/// ```
void SDL_HapticClose(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticClose = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Haptic>? haptic),
      void Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticClose');
  return _SDL_HapticClose(haptic);
}

/// 
/// \brief Returns the number of effects a haptic device can store.
/// 
/// On some platforms this isn't fully supported, and therefore is an
/// approximation.  Always check to see if your created effect was actually
/// created and do not rely solely on SDL_HapticNumEffects().
/// 
/// \param haptic The haptic device to query effect max.
/// \return The number of effects the haptic device can store or
/// -1 on error.
/// 
/// \sa SDL_HapticNumEffectsPlaying
/// \sa SDL_HapticQuery
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticNumEffects(SDL_Haptic * haptic)
/// ```
int SDL_HapticNumEffects(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticNumEffects = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticNumEffects');
  return _SDL_HapticNumEffects(haptic);
}

/// 
/// \brief Returns the number of effects a haptic device can play at the same
/// time.
/// 
/// This is not supported on all platforms, but will always return a value.
/// Added here for the sake of completeness.
/// 
/// \param haptic The haptic device to query maximum playing effects.
/// \return The number of effects the haptic device can play at the same time
/// or -1 on error.
/// 
/// \sa SDL_HapticNumEffects
/// \sa SDL_HapticQuery
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticNumEffectsPlaying(SDL_Haptic * haptic)
/// ```
int SDL_HapticNumEffectsPlaying(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticNumEffectsPlaying = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticNumEffectsPlaying');
  return _SDL_HapticNumEffectsPlaying(haptic);
}

/// 
/// \brief Gets the haptic devices supported features in bitwise matter.
/// 
/// Example:
/// \code
/// if (SDL_HapticQuery(haptic) & SDL_HAPTIC_CONSTANT) {
/// printf("We have constant haptic effect!");
/// }
/// \endcode
/// 
/// \param haptic The haptic device to query.
/// \return Haptic features in bitwise manner (OR'd).
/// 
/// \sa SDL_HapticNumEffects
/// \sa SDL_HapticEffectSupported
/// 
/// ```c
/// extern DECLSPEC unsigned int SDLCALL SDL_HapticQuery(SDL_Haptic * haptic)
/// ```
int SDL_HapticQuery(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticQuery = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticQuery');
  return _SDL_HapticQuery(haptic);
}

/// 
/// \brief Gets the number of haptic axes the device has.
/// 
/// \sa SDL_HapticDirection
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticNumAxes(SDL_Haptic * haptic)
/// ```
int SDL_HapticNumAxes(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticNumAxes = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticNumAxes');
  return _SDL_HapticNumAxes(haptic);
}

/// 
/// \brief Checks to see if effect is supported by haptic.
/// 
/// \param haptic Haptic device to check on.
/// \param effect Effect to check to see if it is supported.
/// \return SDL_TRUE if effect is supported, SDL_FALSE if it isn't or -1 on error.
/// 
/// \sa SDL_HapticQuery
/// \sa SDL_HapticNewEffect
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticEffectSupported(SDL_Haptic * haptic, SDL_HapticEffect * effect)
/// ```
int SDL_HapticEffectSupported(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect) {
  final _SDL_HapticEffectSupported = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect),
      int Function(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect)>('SDL_HapticEffectSupported');
  return _SDL_HapticEffectSupported(haptic, effect);
}

/// 
/// \brief Creates a new haptic effect on the device.
/// 
/// \param haptic Haptic device to create the effect on.
/// \param effect Properties of the effect to create.
/// \return The id of the effect on success or -1 on error.
/// 
/// \sa SDL_HapticUpdateEffect
/// \sa SDL_HapticRunEffect
/// \sa SDL_HapticDestroyEffect
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticNewEffect(SDL_Haptic * haptic, SDL_HapticEffect * effect)
/// ```
int SDL_HapticNewEffect(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect) {
  final _SDL_HapticNewEffect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect),
      int Function(Pointer<SDL_Haptic>? haptic, Pointer<SDL_HapticEffect>? effect)>('SDL_HapticNewEffect');
  return _SDL_HapticNewEffect(haptic, effect);
}

/// 
/// \brief Updates the properties of an effect.
/// 
/// Can be used dynamically, although behaviour when dynamically changing
/// direction may be strange.  Specifically the effect may reupload itself
/// and start playing from the start.  You cannot change the type either when
/// running SDL_HapticUpdateEffect().
/// 
/// \param haptic Haptic device that has the effect.
/// \param effect Effect to update.
/// \param data New effect properties to use.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticNewEffect
/// \sa SDL_HapticRunEffect
/// \sa SDL_HapticDestroyEffect
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticUpdateEffect(SDL_Haptic * haptic, int effect, SDL_HapticEffect * data)
/// ```
int SDL_HapticUpdateEffect(Pointer<SDL_Haptic>? haptic, int effect, Pointer<SDL_HapticEffect>? data) {
  final _SDL_HapticUpdateEffect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 effect, Pointer<SDL_HapticEffect>? data),
      int Function(Pointer<SDL_Haptic>? haptic, int effect, Pointer<SDL_HapticEffect>? data)>('SDL_HapticUpdateEffect');
  return _SDL_HapticUpdateEffect(haptic, effect, data);
}

/// 
/// \brief Runs the haptic effect on its associated haptic device.
/// 
/// If iterations are ::SDL_HAPTIC_INFINITY, it'll run the effect over and over
/// repeating the envelope (attack and fade) every time.  If you only want the
/// effect to last forever, set ::SDL_HAPTIC_INFINITY in the effect's length
/// parameter.
/// 
/// \param haptic Haptic device to run the effect on.
/// \param effect Identifier of the haptic effect to run.
/// \param iterations Number of iterations to run the effect. Use
/// ::SDL_HAPTIC_INFINITY for infinity.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticStopEffect
/// \sa SDL_HapticDestroyEffect
/// \sa SDL_HapticGetEffectStatus
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticRunEffect(SDL_Haptic * haptic, int effect, Uint32 iterations)
/// ```
int SDL_HapticRunEffect(Pointer<SDL_Haptic>? haptic, int effect, int iterations) {
  final _SDL_HapticRunEffect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 effect, Uint32 iterations),
      int Function(Pointer<SDL_Haptic>? haptic, int effect, int iterations)>('SDL_HapticRunEffect');
  return _SDL_HapticRunEffect(haptic, effect, iterations);
}

/// 
/// \brief Stops the haptic effect on its associated haptic device.
/// 
/// \param haptic Haptic device to stop the effect on.
/// \param effect Identifier of the effect to stop.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticRunEffect
/// \sa SDL_HapticDestroyEffect
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticStopEffect(SDL_Haptic * haptic, int effect)
/// ```
int SDL_HapticStopEffect(Pointer<SDL_Haptic>? haptic, int effect) {
  final _SDL_HapticStopEffect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 effect),
      int Function(Pointer<SDL_Haptic>? haptic, int effect)>('SDL_HapticStopEffect');
  return _SDL_HapticStopEffect(haptic, effect);
}

/// 
/// \brief Destroys a haptic effect on the device.
/// 
/// This will stop the effect if it's running.  Effects are automatically
/// destroyed when the device is closed.
/// 
/// \param haptic Device to destroy the effect on.
/// \param effect Identifier of the effect to destroy.
/// 
/// \sa SDL_HapticNewEffect
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_HapticDestroyEffect(SDL_Haptic * haptic, int effect)
/// ```
void SDL_HapticDestroyEffect(Pointer<SDL_Haptic>? haptic, int effect) {
  final _SDL_HapticDestroyEffect = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Haptic>? haptic, Int32 effect),
      void Function(Pointer<SDL_Haptic>? haptic, int effect)>('SDL_HapticDestroyEffect');
  return _SDL_HapticDestroyEffect(haptic, effect);
}

/// 
/// \brief Gets the status of the current effect on the haptic device.
/// 
/// Device must support the ::SDL_HAPTIC_STATUS feature.
/// 
/// \param haptic Haptic device to query the effect status on.
/// \param effect Identifier of the effect to query its status.
/// \return 0 if it isn't playing, 1 if it is playing or -1 on error.
/// 
/// \sa SDL_HapticRunEffect
/// \sa SDL_HapticStopEffect
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticGetEffectStatus(SDL_Haptic * haptic, int effect)
/// ```
int SDL_HapticGetEffectStatus(Pointer<SDL_Haptic>? haptic, int effect) {
  final _SDL_HapticGetEffectStatus = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 effect),
      int Function(Pointer<SDL_Haptic>? haptic, int effect)>('SDL_HapticGetEffectStatus');
  return _SDL_HapticGetEffectStatus(haptic, effect);
}

/// 
/// \brief Sets the global gain of the device.
/// 
/// Device must support the ::SDL_HAPTIC_GAIN feature.
/// 
/// The user may specify the maximum gain by setting the environment variable
/// SDL_HAPTIC_GAIN_MAX which should be between 0 and 100.  All calls to
/// SDL_HapticSetGain() will scale linearly using SDL_HAPTIC_GAIN_MAX as the
/// maximum.
/// 
/// \param haptic Haptic device to set the gain on.
/// \param gain Value to set the gain to, should be between 0 and 100.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticQuery
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticSetGain(SDL_Haptic * haptic, int gain)
/// ```
int SDL_HapticSetGain(Pointer<SDL_Haptic>? haptic, int gain) {
  final _SDL_HapticSetGain = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 gain),
      int Function(Pointer<SDL_Haptic>? haptic, int gain)>('SDL_HapticSetGain');
  return _SDL_HapticSetGain(haptic, gain);
}

/// 
/// \brief Sets the global autocenter of the device.
/// 
/// Autocenter should be between 0 and 100.  Setting it to 0 will disable
/// autocentering.
/// 
/// Device must support the ::SDL_HAPTIC_AUTOCENTER feature.
/// 
/// \param haptic Haptic device to set autocentering on.
/// \param autocenter Value to set autocenter to, 0 disables autocentering.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticQuery
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticSetAutocenter(SDL_Haptic * haptic, int autocenter)
/// ```
int SDL_HapticSetAutocenter(Pointer<SDL_Haptic>? haptic, int autocenter) {
  final _SDL_HapticSetAutocenter = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Int32 autocenter),
      int Function(Pointer<SDL_Haptic>? haptic, int autocenter)>('SDL_HapticSetAutocenter');
  return _SDL_HapticSetAutocenter(haptic, autocenter);
}

/// 
/// \brief Pauses a haptic device.
/// 
/// Device must support the ::SDL_HAPTIC_PAUSE feature.  Call
/// SDL_HapticUnpause() to resume playback.
/// 
/// Do not modify the effects nor add new ones while the device is paused.
/// That can cause all sorts of weird errors.
/// 
/// \param haptic Haptic device to pause.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticUnpause
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticPause(SDL_Haptic * haptic)
/// ```
int SDL_HapticPause(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticPause = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticPause');
  return _SDL_HapticPause(haptic);
}

/// 
/// \brief Unpauses a haptic device.
/// 
/// Call to unpause after SDL_HapticPause().
/// 
/// \param haptic Haptic device to pause.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticPause
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticUnpause(SDL_Haptic * haptic)
/// ```
int SDL_HapticUnpause(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticUnpause = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticUnpause');
  return _SDL_HapticUnpause(haptic);
}

/// 
/// \brief Stops all the currently playing effects on a haptic device.
/// 
/// \param haptic Haptic device to stop.
/// \return 0 on success or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticStopAll(SDL_Haptic * haptic)
/// ```
int SDL_HapticStopAll(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticStopAll = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticStopAll');
  return _SDL_HapticStopAll(haptic);
}

/// 
/// \brief Checks to see if rumble is supported on a haptic device.
/// 
/// \param haptic Haptic device to check to see if it supports rumble.
/// \return SDL_TRUE if effect is supported, SDL_FALSE if it isn't or -1 on error.
/// 
/// \sa SDL_HapticRumbleInit
/// \sa SDL_HapticRumblePlay
/// \sa SDL_HapticRumbleStop
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticRumbleSupported(SDL_Haptic * haptic)
/// ```
int SDL_HapticRumbleSupported(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticRumbleSupported = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticRumbleSupported');
  return _SDL_HapticRumbleSupported(haptic);
}

/// 
/// \brief Initializes the haptic device for simple rumble playback.
/// 
/// \param haptic Haptic device to initialize for simple rumble playback.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticOpen
/// \sa SDL_HapticRumbleSupported
/// \sa SDL_HapticRumblePlay
/// \sa SDL_HapticRumbleStop
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticRumbleInit(SDL_Haptic * haptic)
/// ```
int SDL_HapticRumbleInit(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticRumbleInit = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticRumbleInit');
  return _SDL_HapticRumbleInit(haptic);
}

/// 
/// \brief Runs simple rumble on a haptic device
/// 
/// \param haptic Haptic device to play rumble effect on.
/// \param strength Strength of the rumble to play as a 0-1 float value.
/// \param length Length of the rumble to play in milliseconds.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticRumbleSupported
/// \sa SDL_HapticRumbleInit
/// \sa SDL_HapticRumbleStop
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticRumblePlay(SDL_Haptic * haptic, float strength, Uint32 length )
/// ```
int SDL_HapticRumblePlay(Pointer<SDL_Haptic>? haptic, double strength, int length) {
  final _SDL_HapticRumblePlay = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic, Float strength, Uint32 length),
      int Function(Pointer<SDL_Haptic>? haptic, double strength, int length)>('SDL_HapticRumblePlay');
  return _SDL_HapticRumblePlay(haptic, strength, length);
}

/// 
/// \brief Stops the simple rumble on a haptic device.
/// 
/// \param haptic Haptic to stop the rumble on.
/// \return 0 on success or -1 on error.
/// 
/// \sa SDL_HapticRumbleSupported
/// \sa SDL_HapticRumbleInit
/// \sa SDL_HapticRumblePlay
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_HapticRumbleStop(SDL_Haptic * haptic)
/// ```
int SDL_HapticRumbleStop(Pointer<SDL_Haptic>? haptic) {
  final _SDL_HapticRumbleStop = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Haptic>? haptic),
      int Function(Pointer<SDL_Haptic>? haptic)>('SDL_HapticRumbleStop');
  return _SDL_HapticRumbleStop(haptic);
}

/// 
/// \brief Set a hint with a specific priority
/// 
/// The priority controls the behavior when setting a hint that already
/// has a value.  Hints will replace existing hints of their priority and
/// lower.  Environment variables are considered to have override priority.
/// 
/// \return SDL_TRUE if the hint was set, SDL_FALSE otherwise
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_SetHintWithPriority(const char *name, const char *value, SDL_HintPriority priority)
/// ```
int SDL_SetHintWithPriority(String name, String value, int priority) {
  final _SDL_SetHintWithPriority = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? name, Pointer<Utf8>? value, Int32 priority),
      int Function(Pointer<Utf8>? name, Pointer<Utf8>? value, int priority)>('SDL_SetHintWithPriority');
  final _namePointer = name.toNativeUtf8();
  final _valuePointer = value.toNativeUtf8();
  final _result = _SDL_SetHintWithPriority(_namePointer, _valuePointer, priority);
  calloc.free(_namePointer);
  calloc.free(_valuePointer);
  return _result;
}

/// 
/// \brief Set a hint with normal priority
/// 
/// \return SDL_TRUE if the hint was set, SDL_FALSE otherwise
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_SetHint(const char *name, const char *value)
/// ```
int SDL_SetHint(String name, String value) {
  final _SDL_SetHint = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? name, Pointer<Utf8>? value),
      int Function(Pointer<Utf8>? name, Pointer<Utf8>? value)>('SDL_SetHint');
  final _namePointer = name.toNativeUtf8();
  final _valuePointer = value.toNativeUtf8();
  final _result = _SDL_SetHint(_namePointer, _valuePointer);
  calloc.free(_namePointer);
  calloc.free(_valuePointer);
  return _result;
}

/// 
/// \brief Get a hint
/// 
/// \return The string value of a hint variable.
/// 
/// ```c
/// extern DECLSPEC const char * SDLCALL SDL_GetHint(const char *name)
/// ```
String SDL_GetHint(String name) {
  final _SDL_GetHint = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Pointer<Utf8>? name),
      Pointer<Utf8>? Function(Pointer<Utf8>? name)>('SDL_GetHint');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_GetHint(_namePointer)!.toDartString();
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_AddHintCallback(const char *name, SDL_HintCallback callback, void *userdata)
/// ```
void SDL_AddHintCallback(String name, Pointer<Void>? callback, Pointer<Void>? userdata) {
  final _SDL_AddHintCallback = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? name, Pointer<Void>? callback, Pointer<Void>? userdata),
      void Function(Pointer<Utf8>? name, Pointer<Void>? callback, Pointer<Void>? userdata)>('SDL_AddHintCallback');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_AddHintCallback(_namePointer, callback, userdata);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief Remove a function watching a particular hint
/// 
/// \param name The hint being watched
/// \param callback The function being called when the hint value changes
/// \param userdata A pointer being passed to the callback function
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DelHintCallback(const char *name, SDL_HintCallback callback, void *userdata)
/// ```
void SDL_DelHintCallback(String name, Pointer<Void>? callback, Pointer<Void>? userdata) {
  final _SDL_DelHintCallback = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? name, Pointer<Void>? callback, Pointer<Void>? userdata),
      void Function(Pointer<Utf8>? name, Pointer<Void>? callback, Pointer<Void>? userdata)>('SDL_DelHintCallback');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_DelHintCallback(_namePointer, callback, userdata);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief  Clear all hints
/// 
/// This function is called during SDL_Quit() to free stored hints.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_ClearHints(void)
/// ```
void SDL_ClearHints() {
  final _SDL_ClearHints = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_ClearHints');
  return _SDL_ClearHints();
}

/// 
/// Count the number of joysticks attached to the system right now
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_NumJoysticks(void)
/// ```
int SDL_NumJoysticks() {
  final _SDL_NumJoysticks = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_NumJoysticks');
  return _SDL_NumJoysticks();
}

/// 
/// Get the implementation dependent name of a joystick.
/// This can be called before any joysticks are opened.
/// If no name can be found, this function returns NULL.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_JoystickNameForIndex(int device_index)
/// ```
String SDL_JoystickNameForIndex(int device_index) {
  final _SDL_JoystickNameForIndex = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 device_index),
      Pointer<Utf8>? Function(int device_index)>('SDL_JoystickNameForIndex');
  return _SDL_JoystickNameForIndex(device_index)!.toDartString();
}

/// 
/// Open a joystick for use.
/// The index passed as an argument refers tothe N'th joystick on the system.
/// This index is the value which will identify this joystick in future joystick
/// events.
/// 
/// \return A joystick identifier, or NULL if an error occurred.
/// 
/// ```c
/// extern DECLSPEC SDL_Joystick *SDLCALL SDL_JoystickOpen(int device_index)
/// ```
Pointer<SDL_Joystick>? SDL_JoystickOpen(int device_index) {
  final _SDL_JoystickOpen = _SDL2.lookupFunction<
      Pointer<SDL_Joystick>? Function(Int32 device_index),
      Pointer<SDL_Joystick>? Function(int device_index)>('SDL_JoystickOpen');
  return _SDL_JoystickOpen(device_index);
}

/// 
/// Return the name for this currently opened joystick.
/// If no name can be found, this function returns NULL.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_JoystickName(SDL_Joystick * joystick)
/// ```
String SDL_JoystickName(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Pointer<SDL_Joystick>? joystick),
      Pointer<Utf8>? Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickName');
  return _SDL_JoystickName(joystick)!.toDartString();
}

/// 
/// Return the GUID for the joystick at this index
/// 
/// ```c
/// extern DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetDeviceGUID(int device_index)
/// ```
Pointer<Void>? SDL_JoystickGetDeviceGUID(int device_index) {
  final _SDL_JoystickGetDeviceGUID = _SDL2.lookupFunction<
      Pointer<Void>? Function(Int32 device_index),
      Pointer<Void>? Function(int device_index)>('SDL_JoystickGetDeviceGUID');
  return _SDL_JoystickGetDeviceGUID(device_index);
}

/// 
/// Return the GUID for this opened joystick
/// 
/// ```c
/// extern DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetGUID(SDL_Joystick * joystick)
/// ```
Pointer<Void>? SDL_JoystickGetGUID(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickGetGUID = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_Joystick>? joystick),
      Pointer<Void>? Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickGetGUID');
  return _SDL_JoystickGetGUID(joystick);
}

/// 
/// Return a string representation for this guid. pszGUID must point to at least 33 bytes
/// (32 for the string plus a NULL terminator).
/// 
/// ```c
/// extern DECLSPEC void SDL_JoystickGetGUIDString(SDL_JoystickGUID guid, char *pszGUID, int cbGUID)
/// ```
void SDL_JoystickGetGUIDString(Pointer<Void>? guid, Pointer<Int8>? pszGUID, int cbGUID) {
  final _SDL_JoystickGetGUIDString = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? guid, Pointer<Int8>? pszGUID, Int32 cbGUID),
      void Function(Pointer<Void>? guid, Pointer<Int8>? pszGUID, int cbGUID)>('SDL_JoystickGetGUIDString');
  return _SDL_JoystickGetGUIDString(guid, pszGUID, cbGUID);
}

/// 
/// convert a string into a joystick formatted guid
/// 
/// ```c
/// extern DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetGUIDFromString(const char *pchGUID)
/// ```
Pointer<Void>? SDL_JoystickGetGUIDFromString(String pchGUID) {
  final _SDL_JoystickGetGUIDFromString = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Utf8>? pchGUID),
      Pointer<Void>? Function(Pointer<Utf8>? pchGUID)>('SDL_JoystickGetGUIDFromString');
  final _pchGUIDPointer = pchGUID.toNativeUtf8();
  final _result = _SDL_JoystickGetGUIDFromString(_pchGUIDPointer);
  calloc.free(_pchGUIDPointer);
  return _result;
}

/// 
/// Returns SDL_TRUE if the joystick has been opened and currently connected, or SDL_FALSE if it has not.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_JoystickGetAttached(SDL_Joystick * joystick)
/// ```
int SDL_JoystickGetAttached(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickGetAttached = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickGetAttached');
  return _SDL_JoystickGetAttached(joystick);
}

/// 
/// Get the instance ID of an opened joystick or -1 if the joystick is invalid.
/// 
/// ```c
/// extern DECLSPEC SDL_JoystickID SDLCALL SDL_JoystickInstanceID(SDL_Joystick * joystick)
/// ```
int SDL_JoystickInstanceID(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickInstanceID = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickInstanceID');
  return _SDL_JoystickInstanceID(joystick);
}

/// 
/// Get the number of general axis controls on a joystick.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickNumAxes(SDL_Joystick * joystick)
/// ```
int SDL_JoystickNumAxes(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickNumAxes = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickNumAxes');
  return _SDL_JoystickNumAxes(joystick);
}

/// 
/// Get the number of trackballs on a joystick.
/// 
/// Joystick trackballs have only relative motion events associated
/// with them and their state cannot be polled.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickNumBalls(SDL_Joystick * joystick)
/// ```
int SDL_JoystickNumBalls(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickNumBalls = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickNumBalls');
  return _SDL_JoystickNumBalls(joystick);
}

/// 
/// Get the number of POV hats on a joystick.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickNumHats(SDL_Joystick * joystick)
/// ```
int SDL_JoystickNumHats(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickNumHats = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickNumHats');
  return _SDL_JoystickNumHats(joystick);
}

/// 
/// Get the number of buttons on a joystick.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickNumButtons(SDL_Joystick * joystick)
/// ```
int SDL_JoystickNumButtons(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickNumButtons = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick),
      int Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickNumButtons');
  return _SDL_JoystickNumButtons(joystick);
}

/// 
/// Update the current state of the open joysticks.
/// 
/// This is called automatically by the event loop if any joystick
/// events are enabled.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_JoystickUpdate(void)
/// ```
void SDL_JoystickUpdate() {
  final _SDL_JoystickUpdate = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_JoystickUpdate');
  return _SDL_JoystickUpdate();
}

/// 
/// Enable/disable joystick event polling.
/// 
/// If joystick events are disabled, you must call SDL_JoystickUpdate()
/// yourself and check the state of the joystick when you want joystick
/// information.
/// 
/// The state can be one of ::SDL_QUERY, ::SDL_ENABLE or ::SDL_IGNORE.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickEventState(int state)
/// ```
int SDL_JoystickEventState(int state) {
  final _SDL_JoystickEventState = _SDL2.lookupFunction<
      Int32 Function(Int32 state),
      int Function(int state)>('SDL_JoystickEventState');
  return _SDL_JoystickEventState(state);
}

/// 
/// Get the current state of an axis control on a joystick.
/// 
/// The state is a value ranging from -32768 to 32767.
/// 
/// The axis indices start at index 0.
/// 
/// ```c
/// extern DECLSPEC Sint16 SDLCALL SDL_JoystickGetAxis(SDL_Joystick * joystick, int axis)
/// ```
int SDL_JoystickGetAxis(Pointer<SDL_Joystick>? joystick, int axis) {
  final _SDL_JoystickGetAxis = _SDL2.lookupFunction<
      Int16 Function(Pointer<SDL_Joystick>? joystick, Int32 axis),
      int Function(Pointer<SDL_Joystick>? joystick, int axis)>('SDL_JoystickGetAxis');
  return _SDL_JoystickGetAxis(joystick, axis);
}

/// 
/// Get the current state of a POV hat on a joystick.
/// 
/// The hat indices start at index 0.
/// 
/// \return The return value is one of the following positions:
/// - ::SDL_HAT_CENTERED
/// - ::SDL_HAT_UP
/// - ::SDL_HAT_RIGHT
/// - ::SDL_HAT_DOWN
/// - ::SDL_HAT_LEFT
/// - ::SDL_HAT_RIGHTUP
/// - ::SDL_HAT_RIGHTDOWN
/// - ::SDL_HAT_LEFTUP
/// - ::SDL_HAT_LEFTDOWN
/// 
/// ```c
/// extern DECLSPEC Uint8 SDLCALL SDL_JoystickGetHat(SDL_Joystick * joystick, int hat)
/// ```
int SDL_JoystickGetHat(Pointer<SDL_Joystick>? joystick, int hat) {
  final _SDL_JoystickGetHat = _SDL2.lookupFunction<
      Uint8 Function(Pointer<SDL_Joystick>? joystick, Int32 hat),
      int Function(Pointer<SDL_Joystick>? joystick, int hat)>('SDL_JoystickGetHat');
  return _SDL_JoystickGetHat(joystick, hat);
}

/// 
/// Get the ball axis change since the last poll.
/// 
/// \return 0, or -1 if you passed it invalid parameters.
/// 
/// The ball indices start at index 0.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_JoystickGetBall(SDL_Joystick * joystick, int ball, int *dx, int *dy)
/// ```
int SDL_JoystickGetBall(Pointer<SDL_Joystick>? joystick, int ball, Pointer<Int32>? dx, Pointer<Int32>? dy) {
  final _SDL_JoystickGetBall = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Joystick>? joystick, Int32 ball, Pointer<Int32>? dx, Pointer<Int32>? dy),
      int Function(Pointer<SDL_Joystick>? joystick, int ball, Pointer<Int32>? dx, Pointer<Int32>? dy)>('SDL_JoystickGetBall');
  return _SDL_JoystickGetBall(joystick, ball, dx, dy);
}

/// 
/// Get the current state of a button on a joystick.
/// 
/// The button indices start at index 0.
/// 
/// ```c
/// extern DECLSPEC Uint8 SDLCALL SDL_JoystickGetButton(SDL_Joystick * joystick, int button)
/// ```
int SDL_JoystickGetButton(Pointer<SDL_Joystick>? joystick, int button) {
  final _SDL_JoystickGetButton = _SDL2.lookupFunction<
      Uint8 Function(Pointer<SDL_Joystick>? joystick, Int32 button),
      int Function(Pointer<SDL_Joystick>? joystick, int button)>('SDL_JoystickGetButton');
  return _SDL_JoystickGetButton(joystick, button);
}

/// 
/// Close a joystick previously opened with SDL_JoystickOpen().
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_JoystickClose(SDL_Joystick * joystick)
/// ```
void SDL_JoystickClose(Pointer<SDL_Joystick>? joystick) {
  final _SDL_JoystickClose = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Joystick>? joystick),
      void Function(Pointer<SDL_Joystick>? joystick)>('SDL_JoystickClose');
  return _SDL_JoystickClose(joystick);
}

/// 
/// \brief Get the window which currently has keyboard focus.
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_GetKeyboardFocus(void)
/// ```
Pointer<SDL_Window>? SDL_GetKeyboardFocus() {
  final _SDL_GetKeyboardFocus = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(),
      Pointer<SDL_Window>? Function()>('SDL_GetKeyboardFocus');
  return _SDL_GetKeyboardFocus();
}

/// 
/// \brief Get a snapshot of the current state of the keyboard.
/// 
/// \param numkeys if non-NULL, receives the length of the returned array.
/// 
/// \return An array of key states. Indexes into this array are obtained by using ::SDL_Scancode values.
/// 
/// \b Example:
/// \code
/// const Uint8 *state = SDL_GetKeyboardState(NULL);
/// if ( state[SDL_SCANCODE_RETURN] )   {
/// printf("<RETURN> is pressed.\n");
/// }
/// \endcode
/// 
/// ```c
/// extern DECLSPEC const Uint8 *SDLCALL SDL_GetKeyboardState(int *numkeys)
/// ```
Pointer<Uint8>? SDL_GetKeyboardState(Pointer<Int32>? numkeys) {
  final _SDL_GetKeyboardState = _SDL2.lookupFunction<
      Pointer<Uint8>? Function(Pointer<Int32>? numkeys),
      Pointer<Uint8>? Function(Pointer<Int32>? numkeys)>('SDL_GetKeyboardState');
  return _SDL_GetKeyboardState(numkeys);
}

/// 
/// \brief Get the current key modifier state for the keyboard.
/// 
/// ```c
/// extern DECLSPEC SDL_Keymod SDLCALL SDL_GetModState(void)
/// ```
int SDL_GetModState() {
  final _SDL_GetModState = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetModState');
  return _SDL_GetModState();
}

/// 
/// \brief Set the current key modifier state for the keyboard.
/// 
/// \note This does not change the keyboard state, only the key modifier flags.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetModState(SDL_Keymod modstate)
/// ```
void SDL_SetModState(int modstate) {
  final _SDL_SetModState = _SDL2.lookupFunction<
      Void Function(Int32 modstate),
      void Function(int modstate)>('SDL_SetModState');
  return _SDL_SetModState(modstate);
}

/// 
/// \brief Get the key code corresponding to the given scancode according
/// to the current keyboard layout.
/// 
/// See ::SDL_Keycode for details.
/// 
/// \sa SDL_GetKeyName()
/// 
/// ```c
/// extern DECLSPEC SDL_Keycode SDLCALL SDL_GetKeyFromScancode(SDL_Scancode scancode)
/// ```
int SDL_GetKeyFromScancode(int scancode) {
  final _SDL_GetKeyFromScancode = _SDL2.lookupFunction<
      Int32 Function(Int32 scancode),
      int Function(int scancode)>('SDL_GetKeyFromScancode');
  return _SDL_GetKeyFromScancode(scancode);
}

/// 
/// \brief Get the scancode corresponding to the given key code according to the
/// current keyboard layout.
/// 
/// See ::SDL_Scancode for details.
/// 
/// \sa SDL_GetScancodeName()
/// 
/// ```c
/// extern DECLSPEC SDL_Scancode SDLCALL SDL_GetScancodeFromKey(SDL_Keycode key)
/// ```
int SDL_GetScancodeFromKey(int key) {
  final _SDL_GetScancodeFromKey = _SDL2.lookupFunction<
      Int32 Function(Int32 key),
      int Function(int key)>('SDL_GetScancodeFromKey');
  return _SDL_GetScancodeFromKey(key);
}

/// 
/// \brief Get a human-readable name for a scancode.
/// 
/// \return A pointer to the name for the scancode.
/// If the scancode doesn't have a name, this function returns
/// an empty string ("").
/// 
/// \sa SDL_Scancode
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetScancodeName(SDL_Scancode scancode)
/// ```
String SDL_GetScancodeName(int scancode) {
  final _SDL_GetScancodeName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 scancode),
      Pointer<Utf8>? Function(int scancode)>('SDL_GetScancodeName');
  return _SDL_GetScancodeName(scancode)!.toDartString();
}

/// 
/// \brief Get a scancode from a human-readable name
/// 
/// \return scancode, or SDL_SCANCODE_UNKNOWN if the name wasn't recognized
/// 
/// \sa SDL_Scancode
/// 
/// ```c
/// extern DECLSPEC SDL_Scancode SDLCALL SDL_GetScancodeFromName(const char *name)
/// ```
int SDL_GetScancodeFromName(String name) {
  final _SDL_GetScancodeFromName = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? name),
      int Function(Pointer<Utf8>? name)>('SDL_GetScancodeFromName');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_GetScancodeFromName(_namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief Get a human-readable name for a key.
/// 
/// \return A pointer to a UTF-8 string that stays valid at least until the next
/// call to this function. If you need it around any longer, you must
/// copy it.  If the key doesn't have a name, this function returns an
/// empty string ("").
/// 
/// \sa SDL_Key
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetKeyName(SDL_Keycode key)
/// ```
String SDL_GetKeyName(int key) {
  final _SDL_GetKeyName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 key),
      Pointer<Utf8>? Function(int key)>('SDL_GetKeyName');
  return _SDL_GetKeyName(key)!.toDartString();
}

/// 
/// \brief Get a key code from a human-readable name
/// 
/// \return key code, or SDLK_UNKNOWN if the name wasn't recognized
/// 
/// \sa SDL_Keycode
/// 
/// ```c
/// extern DECLSPEC SDL_Keycode SDLCALL SDL_GetKeyFromName(const char *name)
/// ```
int SDL_GetKeyFromName(String name) {
  final _SDL_GetKeyFromName = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? name),
      int Function(Pointer<Utf8>? name)>('SDL_GetKeyFromName');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_GetKeyFromName(_namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief Start accepting Unicode text input events.
/// This function will show the on-screen keyboard if supported.
/// 
/// \sa SDL_StopTextInput()
/// \sa SDL_SetTextInputRect()
/// \sa SDL_HasScreenKeyboardSupport()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_StartTextInput(void)
/// ```
void SDL_StartTextInput() {
  final _SDL_StartTextInput = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_StartTextInput');
  return _SDL_StartTextInput();
}

/// 
/// \brief Return whether or not Unicode text input events are enabled.
/// 
/// \sa SDL_StartTextInput()
/// \sa SDL_StopTextInput()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IsTextInputActive(void)
/// ```
int SDL_IsTextInputActive() {
  final _SDL_IsTextInputActive = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_IsTextInputActive');
  return _SDL_IsTextInputActive();
}

/// 
/// \brief Stop receiving any text input events.
/// This function will hide the on-screen keyboard if supported.
/// 
/// \sa SDL_StartTextInput()
/// \sa SDL_HasScreenKeyboardSupport()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_StopTextInput(void)
/// ```
void SDL_StopTextInput() {
  final _SDL_StopTextInput = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_StopTextInput');
  return _SDL_StopTextInput();
}

/// 
/// \brief Set the rectangle used to type Unicode text inputs.
/// This is used as a hint for IME and on-screen keyboard placement.
/// 
/// \sa SDL_StartTextInput()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetTextInputRect(SDL_Rect *rect)
/// ```
void SDL_SetTextInputRect(Pointer<SDL_Rect>? rect) {
  final _SDL_SetTextInputRect = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Rect>? rect),
      void Function(Pointer<SDL_Rect>? rect)>('SDL_SetTextInputRect');
  return _SDL_SetTextInputRect(rect);
}

/// 
/// \brief Returns whether the platform has some screen keyboard support.
/// 
/// \return SDL_TRUE if some keyboard support is available else SDL_FALSE.
/// 
/// \note Not all screen keyboard functions are supported on all platforms.
/// 
/// \sa SDL_IsScreenKeyboardShown()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasScreenKeyboardSupport(void)
/// ```
int SDL_HasScreenKeyboardSupport() {
  final _SDL_HasScreenKeyboardSupport = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_HasScreenKeyboardSupport');
  return _SDL_HasScreenKeyboardSupport();
}

/// 
/// \brief Returns whether the screen keyboard is shown for given window.
/// 
/// \param window The window for which screen keyboard should be queried.
/// 
/// \return SDL_TRUE if screen keyboard is shown else SDL_FALSE.
/// 
/// \sa SDL_HasScreenKeyboardSupport()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IsScreenKeyboardShown(SDL_Window *window)
/// ```
int SDL_IsScreenKeyboardShown(Pointer<SDL_Window>? window) {
  final _SDL_IsScreenKeyboardShown = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_IsScreenKeyboardShown');
  return _SDL_IsScreenKeyboardShown(window);
}

/// 
/// This function dynamically loads a shared object and returns a pointer
/// to the object handle (or NULL if there was an error).
/// The 'sofile' parameter is a system dependent name of the object file.
/// 
/// ```c
/// extern DECLSPEC void *SDLCALL SDL_LoadObject(const char *sofile)
/// ```
Pointer<Void>? SDL_LoadObject(String sofile) {
  final _SDL_LoadObject = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Utf8>? sofile),
      Pointer<Void>? Function(Pointer<Utf8>? sofile)>('SDL_LoadObject');
  final _sofilePointer = sofile.toNativeUtf8();
  final _result = _SDL_LoadObject(_sofilePointer);
  calloc.free(_sofilePointer);
  return _result;
}

/// 
/// Given an object handle, this function looks up the address of the
/// named function in the shared object and returns it.  This address
/// is no longer valid after calling SDL_UnloadObject().
/// 
/// ```c
/// extern DECLSPEC void *SDLCALL SDL_LoadFunction(void *handle, const char *name)
/// ```
Pointer<Void>? SDL_LoadFunction(Pointer<Void>? handle, String name) {
  final _SDL_LoadFunction = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? handle, Pointer<Utf8>? name),
      Pointer<Void>? Function(Pointer<Void>? handle, Pointer<Utf8>? name)>('SDL_LoadFunction');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_LoadFunction(handle, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// Unload a shared object from memory.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnloadObject(void *handle)
/// ```
void SDL_UnloadObject(Pointer<Void>? handle) {
  final _SDL_UnloadObject = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? handle),
      void Function(Pointer<Void>? handle)>('SDL_UnloadObject');
  return _SDL_UnloadObject(handle);
}

/// 
/// \brief Set the priority of all log categories
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogSetAllPriority(SDL_LogPriority priority)
/// ```
void SDL_LogSetAllPriority(int priority) {
  final _SDL_LogSetAllPriority = _SDL2.lookupFunction<
      Void Function(Int32 priority),
      void Function(int priority)>('SDL_LogSetAllPriority');
  return _SDL_LogSetAllPriority(priority);
}

/// 
/// \brief Set the priority of a particular log category
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogSetPriority(int category, SDL_LogPriority priority)
/// ```
void SDL_LogSetPriority(int category, int priority) {
  final _SDL_LogSetPriority = _SDL2.lookupFunction<
      Void Function(Int32 category, Int32 priority),
      void Function(int category, int priority)>('SDL_LogSetPriority');
  return _SDL_LogSetPriority(category, priority);
}

/// 
/// \brief Get the priority of a particular log category
/// 
/// ```c
/// extern DECLSPEC SDL_LogPriority SDLCALL SDL_LogGetPriority(int category)
/// ```
int SDL_LogGetPriority(int category) {
  final _SDL_LogGetPriority = _SDL2.lookupFunction<
      Int32 Function(Int32 category),
      int Function(int category)>('SDL_LogGetPriority');
  return _SDL_LogGetPriority(category);
}

/// 
/// \brief Reset all priorities to default.
/// 
/// \note This is called in SDL_Quit().
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogResetPriorities(void)
/// ```
void SDL_LogResetPriorities() {
  final _SDL_LogResetPriorities = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_LogResetPriorities');
  return _SDL_LogResetPriorities();
}

/// 
/// \brief Log a message with SDL_LOG_CATEGORY_APPLICATION and SDL_LOG_PRIORITY_INFO
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_Log(const char *fmt, ...)
/// ```
void SDL_Log(String fmt, Pointer<Void>? arg1) {
  final _SDL_Log = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? fmt, Pointer<Void>? arg1),
      void Function(Pointer<Utf8>? fmt, Pointer<Void>? arg1)>('SDL_Log');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_Log(_fmtPointer, arg1);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_VERBOSE
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogVerbose(int category, const char *fmt, ...)
/// ```
void SDL_LogVerbose(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogVerbose = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogVerbose');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogVerbose(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_DEBUG
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogDebug(int category, const char *fmt, ...)
/// ```
void SDL_LogDebug(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogDebug = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogDebug');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogDebug(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_INFO
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogInfo(int category, const char *fmt, ...)
/// ```
void SDL_LogInfo(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogInfo = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogInfo');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogInfo(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_WARN
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogWarn(int category, const char *fmt, ...)
/// ```
void SDL_LogWarn(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogWarn = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogWarn');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogWarn(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_ERROR
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogError(int category, const char *fmt, ...)
/// ```
void SDL_LogError(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogError = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogError');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogError(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with SDL_LOG_PRIORITY_CRITICAL
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogCritical(int category, const char *fmt, ...)
/// ```
void SDL_LogCritical(int category, String fmt, Pointer<Void>? arg2) {
  final _SDL_LogCritical = _SDL2.lookupFunction<
      Void Function(Int32 category, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      void Function(int category, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_LogCritical');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogCritical(category, _fmtPointer, arg2);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with the specified category and priority.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogMessage(int category, SDL_LogPriority priority, const char *fmt, ...)
/// ```
void SDL_LogMessage(int category, int priority, String fmt, Pointer<Void>? arg3) {
  final _SDL_LogMessage = _SDL2.lookupFunction<
      Void Function(Int32 category, Int32 priority, Pointer<Utf8>? fmt, Pointer<Void>? arg3),
      void Function(int category, int priority, Pointer<Utf8>? fmt, Pointer<Void>? arg3)>('SDL_LogMessage');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogMessage(category, priority, _fmtPointer, arg3);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Log a message with the specified category and priority.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogMessageV(int category, SDL_LogPriority priority, const char *fmt, va_list ap)
/// ```
void SDL_LogMessageV(int category, int priority, String fmt, Pointer<Void>? ap) {
  final _SDL_LogMessageV = _SDL2.lookupFunction<
      Void Function(Int32 category, Int32 priority, Pointer<Utf8>? fmt, Pointer<Void>? ap),
      void Function(int category, int priority, Pointer<Utf8>? fmt, Pointer<Void>? ap)>('SDL_LogMessageV');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_LogMessageV(category, priority, _fmtPointer, ap);
  calloc.free(_fmtPointer);
  return _result;
}

/// 
/// \brief Get the current log output function.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogGetOutputFunction(SDL_LogOutputFunction *callback, void **userdata)
/// ```
void SDL_LogGetOutputFunction(Pointer<Pointer<Void>>? callback, Pointer<Pointer<Void>>? userdata) {
  final _SDL_LogGetOutputFunction = _SDL2.lookupFunction<
      Void Function(Pointer<Pointer<Void>>? callback, Pointer<Pointer<Void>>? userdata),
      void Function(Pointer<Pointer<Void>>? callback, Pointer<Pointer<Void>>? userdata)>('SDL_LogGetOutputFunction');
  return _SDL_LogGetOutputFunction(callback, userdata);
}

/// 
/// \brief This function allows you to replace the default log output
/// function with one of your own.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_LogSetOutputFunction(SDL_LogOutputFunction callback, void *userdata)
/// ```
void SDL_LogSetOutputFunction(Pointer<Void>? callback, Pointer<Void>? userdata) {
  final _SDL_LogSetOutputFunction = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? callback, Pointer<Void>? userdata),
      void Function(Pointer<Void>? callback, Pointer<Void>? userdata)>('SDL_LogSetOutputFunction');
  return _SDL_LogSetOutputFunction(callback, userdata);
}

/// 
/// This is called by the real SDL main function to let the rest of the
/// library know that initialization was done properly.
/// 
/// Calling this yourself without knowing what you're doing can cause
/// crashes and hard to diagnose problems with your application.
/// /
/// ```c
/// extern DECLSPEC void SDL_SetMainReady(void)
/// ```
void SDL_SetMainReady() {
  final _SDL_SetMainReady = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_SetMainReady');
  return _SDL_SetMainReady();
}

/// 
/// This can be called to set the application class at startup
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RegisterApp(char *name, Uint32 style, void *hInst)
/// ```
int SDL_RegisterApp(Pointer<Int8>? name, int style, Pointer<Void>? hInst) {
  final _SDL_RegisterApp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int8>? name, Uint32 style, Pointer<Void>? hInst),
      int Function(Pointer<Int8>? name, int style, Pointer<Void>? hInst)>('SDL_RegisterApp');
  return _SDL_RegisterApp(name, style, hInst);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnregisterApp(void)
/// ```
void SDL_UnregisterApp() {
  final _SDL_UnregisterApp = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_UnregisterApp');
  return _SDL_UnregisterApp();
}

/// 
/// \brief Create a modal message box.
/// 
/// \param messageboxdata The SDL_MessageBoxData structure with title, text, etc.
/// \param buttonid The pointer to which user id of hit button should be copied.
/// 
/// \return -1 on error, otherwise 0 and buttonid contains user id of button
/// hit or -1 if dialog was closed.
/// 
/// \note This function should be called on the thread that created the parent
/// window, or on the main thread if the messagebox has no parent.  It will
/// block execution of that thread until the user clicks a button or
/// closes the messagebox.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_ShowMessageBox(const SDL_MessageBoxData *messageboxdata, int *buttonid)
/// ```
int SDL_ShowMessageBox(Pointer<SDL_MessageBoxData>? messageboxdata, Pointer<Int32>? buttonid) {
  final _SDL_ShowMessageBox = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_MessageBoxData>? messageboxdata, Pointer<Int32>? buttonid),
      int Function(Pointer<SDL_MessageBoxData>? messageboxdata, Pointer<Int32>? buttonid)>('SDL_ShowMessageBox');
  return _SDL_ShowMessageBox(messageboxdata, buttonid);
}

/// 
/// \brief Create a simple modal message box
/// 
/// \param flags    ::SDL_MessageBoxFlags
/// \param title    UTF-8 title text
/// \param message  UTF-8 message text
/// \param window   The parent window, or NULL for no parent
/// 
/// \return 0 on success, -1 on error
/// 
/// \sa SDL_ShowMessageBox
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_ShowSimpleMessageBox(Uint32 flags, const char *title, const char *message, SDL_Window *window)
/// ```
int SDL_ShowSimpleMessageBox(int flags, String title, String message, Pointer<SDL_Window>? window) {
  final _SDL_ShowSimpleMessageBox = _SDL2.lookupFunction<
      Int32 Function(Uint32 flags, Pointer<Utf8>? title, Pointer<Utf8>? message, Pointer<SDL_Window>? window),
      int Function(int flags, Pointer<Utf8>? title, Pointer<Utf8>? message, Pointer<SDL_Window>? window)>('SDL_ShowSimpleMessageBox');
  final _titlePointer = title.toNativeUtf8();
  final _messagePointer = message.toNativeUtf8();
  final _result = _SDL_ShowSimpleMessageBox(flags, _titlePointer, _messagePointer, window);
  calloc.free(_titlePointer);
  calloc.free(_messagePointer);
  return _result;
}

/// 
/// \brief Get the window which currently has mouse focus.
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_GetMouseFocus(void)
/// ```
Pointer<SDL_Window>? SDL_GetMouseFocus() {
  final _SDL_GetMouseFocus = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(),
      Pointer<SDL_Window>? Function()>('SDL_GetMouseFocus');
  return _SDL_GetMouseFocus();
}

/// 
/// \brief Retrieve the current state of the mouse.
/// 
/// The current button state is returned as a button bitmask, which can
/// be tested using the SDL_BUTTON(X) macros, and x and y are set to the
/// mouse cursor position relative to the focus window for the currently
/// selected mouse.  You can pass NULL for either x or y.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetMouseState(int *x, int *y)
/// ```
int SDL_GetMouseState(Pointer<Int32>? x, Pointer<Int32>? y) {
  final _SDL_GetMouseState = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int32>? x, Pointer<Int32>? y),
      int Function(Pointer<Int32>? x, Pointer<Int32>? y)>('SDL_GetMouseState');
  return _SDL_GetMouseState(x, y);
}

/// 
/// \brief Retrieve the relative state of the mouse.
/// 
/// The current button state is returned as a button bitmask, which can
/// be tested using the SDL_BUTTON(X) macros, and x and y are set to the
/// mouse deltas since the last call to SDL_GetRelativeMouseState().
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetRelativeMouseState(int *x, int *y)
/// ```
int SDL_GetRelativeMouseState(Pointer<Int32>? x, Pointer<Int32>? y) {
  final _SDL_GetRelativeMouseState = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int32>? x, Pointer<Int32>? y),
      int Function(Pointer<Int32>? x, Pointer<Int32>? y)>('SDL_GetRelativeMouseState');
  return _SDL_GetRelativeMouseState(x, y);
}

/// 
/// \brief Moves the mouse to the given position within the window.
/// 
/// \param window The window to move the mouse into, or NULL for the current mouse focus
/// \param x The x coordinate within the window
/// \param y The y coordinate within the window
/// 
/// \note This function generates a mouse motion event
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_WarpMouseInWindow(SDL_Window * window, int x, int y)
/// ```
void SDL_WarpMouseInWindow(Pointer<SDL_Window>? window, int x, int y) {
  final _SDL_WarpMouseInWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 x, Int32 y),
      void Function(Pointer<SDL_Window>? window, int x, int y)>('SDL_WarpMouseInWindow');
  return _SDL_WarpMouseInWindow(window, x, y);
}

/// 
/// \brief Set relative mouse mode.
/// 
/// \param enabled Whether or not to enable relative mode
/// 
/// \return 0 on success, or -1 if relative mode is not supported.
/// 
/// While the mouse is in relative mode, the cursor is hidden, and the
/// driver will try to report continuous motion in the current window.
/// Only relative motion events will be delivered, the mouse position
/// will not change.
/// 
/// \note This function will flush any pending mouse motion.
/// 
/// \sa SDL_GetRelativeMouseMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetRelativeMouseMode(SDL_bool enabled)
/// ```
int SDL_SetRelativeMouseMode(int enabled) {
  final _SDL_SetRelativeMouseMode = _SDL2.lookupFunction<
      Int32 Function(Int32 enabled),
      int Function(int enabled)>('SDL_SetRelativeMouseMode');
  return _SDL_SetRelativeMouseMode(enabled);
}

/// 
/// \brief Query whether relative mouse mode is enabled.
/// 
/// \sa SDL_SetRelativeMouseMode()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GetRelativeMouseMode(void)
/// ```
int SDL_GetRelativeMouseMode() {
  final _SDL_GetRelativeMouseMode = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetRelativeMouseMode');
  return _SDL_GetRelativeMouseMode();
}

/// 
/// \brief Create a cursor, using the specified bitmap data and
/// mask (in MSB format).
/// 
/// The cursor width must be a multiple of 8 bits.
/// 
/// The cursor is created in black and white according to the following:
/// <table>
/// <tr><td> data </td><td> mask </td><td> resulting pixel on screen </td></tr>
/// <tr><td>  0   </td><td>  1   </td><td> White </td></tr>
/// <tr><td>  1   </td><td>  1   </td><td> Black </td></tr>
/// <tr><td>  0   </td><td>  0   </td><td> Transparent </td></tr>
/// <tr><td>  1   </td><td>  0   </td><td> Inverted color if possible, black
/// if not. </td></tr>
/// </table>
/// 
/// \sa SDL_FreeCursor()
/// 
/// ```c
/// extern DECLSPEC SDL_Cursor *SDLCALL SDL_CreateCursor(const Uint8 * data, const Uint8 * mask, int w, int h, int hot_x, int hot_y)
/// ```
Pointer<SDL_Cursor>? SDL_CreateCursor(Pointer<Uint8>? data, Pointer<Uint8>? mask, int w, int h, int hot_x, int hot_y) {
  final _SDL_CreateCursor = _SDL2.lookupFunction<
      Pointer<SDL_Cursor>? Function(Pointer<Uint8>? data, Pointer<Uint8>? mask, Int32 w, Int32 h, Int32 hot_x, Int32 hot_y),
      Pointer<SDL_Cursor>? Function(Pointer<Uint8>? data, Pointer<Uint8>? mask, int w, int h, int hot_x, int hot_y)>('SDL_CreateCursor');
  return _SDL_CreateCursor(data, mask, w, h, hot_x, hot_y);
}

/// 
/// \brief Create a color cursor.
/// 
/// \sa SDL_FreeCursor()
/// 
/// ```c
/// extern DECLSPEC SDL_Cursor *SDLCALL SDL_CreateColorCursor(SDL_Surface *surface, int hot_x, int hot_y)
/// ```
Pointer<SDL_Cursor>? SDL_CreateColorCursor(Pointer<SDL_Surface>? surface, int hot_x, int hot_y) {
  final _SDL_CreateColorCursor = _SDL2.lookupFunction<
      Pointer<SDL_Cursor>? Function(Pointer<SDL_Surface>? surface, Int32 hot_x, Int32 hot_y),
      Pointer<SDL_Cursor>? Function(Pointer<SDL_Surface>? surface, int hot_x, int hot_y)>('SDL_CreateColorCursor');
  return _SDL_CreateColorCursor(surface, hot_x, hot_y);
}

/// 
/// \brief Create a system cursor.
/// 
/// \sa SDL_FreeCursor()
/// 
/// ```c
/// extern DECLSPEC SDL_Cursor *SDLCALL SDL_CreateSystemCursor(SDL_SystemCursor id)
/// ```
Pointer<SDL_Cursor>? SDL_CreateSystemCursor(int id) {
  final _SDL_CreateSystemCursor = _SDL2.lookupFunction<
      Pointer<SDL_Cursor>? Function(Int32 id),
      Pointer<SDL_Cursor>? Function(int id)>('SDL_CreateSystemCursor');
  return _SDL_CreateSystemCursor(id);
}

/// 
/// \brief Set the active cursor.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetCursor(SDL_Cursor * cursor)
/// ```
void SDL_SetCursor(Pointer<SDL_Cursor>? cursor) {
  final _SDL_SetCursor = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Cursor>? cursor),
      void Function(Pointer<SDL_Cursor>? cursor)>('SDL_SetCursor');
  return _SDL_SetCursor(cursor);
}

/// 
/// \brief Return the active cursor.
/// 
/// ```c
/// extern DECLSPEC SDL_Cursor *SDLCALL SDL_GetCursor(void)
/// ```
Pointer<SDL_Cursor>? SDL_GetCursor() {
  final _SDL_GetCursor = _SDL2.lookupFunction<
      Pointer<SDL_Cursor>? Function(),
      Pointer<SDL_Cursor>? Function()>('SDL_GetCursor');
  return _SDL_GetCursor();
}

/// 
/// \brief Return the default cursor.
/// 
/// ```c
/// extern DECLSPEC SDL_Cursor *SDLCALL SDL_GetDefaultCursor(void)
/// ```
Pointer<SDL_Cursor>? SDL_GetDefaultCursor() {
  final _SDL_GetDefaultCursor = _SDL2.lookupFunction<
      Pointer<SDL_Cursor>? Function(),
      Pointer<SDL_Cursor>? Function()>('SDL_GetDefaultCursor');
  return _SDL_GetDefaultCursor();
}

/// 
/// \brief Frees a cursor created with SDL_CreateCursor().
/// 
/// \sa SDL_CreateCursor()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreeCursor(SDL_Cursor * cursor)
/// ```
void SDL_FreeCursor(Pointer<SDL_Cursor>? cursor) {
  final _SDL_FreeCursor = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Cursor>? cursor),
      void Function(Pointer<SDL_Cursor>? cursor)>('SDL_FreeCursor');
  return _SDL_FreeCursor(cursor);
}

/// 
/// \brief Toggle whether or not the cursor is shown.
/// 
/// \param toggle 1 to show the cursor, 0 to hide it, -1 to query the current
/// state.
/// 
/// \return 1 if the cursor is shown, or 0 if the cursor is hidden.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_ShowCursor(int toggle)
/// ```
int SDL_ShowCursor(int toggle) {
  final _SDL_ShowCursor = _SDL2.lookupFunction<
      Int32 Function(Int32 toggle),
      int Function(int toggle)>('SDL_ShowCursor');
  return _SDL_ShowCursor(toggle);
}

/// 
/// Create a mutex, initialized unlocked.
/// 
/// ```c
/// extern DECLSPEC SDL_mutex *SDLCALL SDL_CreateMutex(void)
/// ```
Pointer<SDL_mutex>? SDL_CreateMutex() {
  final _SDL_CreateMutex = _SDL2.lookupFunction<
      Pointer<SDL_mutex>? Function(),
      Pointer<SDL_mutex>? Function()>('SDL_CreateMutex');
  return _SDL_CreateMutex();
}

/// 
/// Lock the mutex.
/// 
/// \return 0, or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LockMutex(SDL_mutex * mutex)
/// ```
int SDL_LockMutex(Pointer<SDL_mutex>? mutex) {
  final _SDL_LockMutex = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_mutex>? mutex),
      int Function(Pointer<SDL_mutex>? mutex)>('SDL_LockMutex');
  return _SDL_LockMutex(mutex);
}

/// 
/// Try to lock the mutex
/// 
/// \return 0, SDL_MUTEX_TIMEDOUT, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_TryLockMutex(SDL_mutex * mutex)
/// ```
int SDL_TryLockMutex(Pointer<SDL_mutex>? mutex) {
  final _SDL_TryLockMutex = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_mutex>? mutex),
      int Function(Pointer<SDL_mutex>? mutex)>('SDL_TryLockMutex');
  return _SDL_TryLockMutex(mutex);
}

/// 
/// Unlock the mutex.
/// 
/// \return 0, or -1 on error.
/// 
/// \warning It is an error to unlock a mutex that has not been locked by
/// the current thread, and doing so results in undefined behavior.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UnlockMutex(SDL_mutex * mutex)
/// ```
int SDL_UnlockMutex(Pointer<SDL_mutex>? mutex) {
  final _SDL_UnlockMutex = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_mutex>? mutex),
      int Function(Pointer<SDL_mutex>? mutex)>('SDL_UnlockMutex');
  return _SDL_UnlockMutex(mutex);
}

/// 
/// Destroy a mutex.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroyMutex(SDL_mutex * mutex)
/// ```
void SDL_DestroyMutex(Pointer<SDL_mutex>? mutex) {
  final _SDL_DestroyMutex = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_mutex>? mutex),
      void Function(Pointer<SDL_mutex>? mutex)>('SDL_DestroyMutex');
  return _SDL_DestroyMutex(mutex);
}

/// 
/// Create a semaphore, initialized with value, returns NULL on failure.
/// 
/// ```c
/// extern DECLSPEC SDL_sem *SDLCALL SDL_CreateSemaphore(Uint32 initial_value)
/// ```
Pointer<SDL_sem>? SDL_CreateSemaphore(int initial_value) {
  final _SDL_CreateSemaphore = _SDL2.lookupFunction<
      Pointer<SDL_sem>? Function(Uint32 initial_value),
      Pointer<SDL_sem>? Function(int initial_value)>('SDL_CreateSemaphore');
  return _SDL_CreateSemaphore(initial_value);
}

/// 
/// Destroy a semaphore.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroySemaphore(SDL_sem * sem)
/// ```
void SDL_DestroySemaphore(Pointer<SDL_sem>? sem) {
  final _SDL_DestroySemaphore = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_sem>? sem),
      void Function(Pointer<SDL_sem>? sem)>('SDL_DestroySemaphore');
  return _SDL_DestroySemaphore(sem);
}

/// 
/// This function suspends the calling thread until the semaphore pointed
/// to by \c sem has a positive count. It then atomically decreases the
/// semaphore count.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SemWait(SDL_sem * sem)
/// ```
int SDL_SemWait(Pointer<SDL_sem>? sem) {
  final _SDL_SemWait = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_sem>? sem),
      int Function(Pointer<SDL_sem>? sem)>('SDL_SemWait');
  return _SDL_SemWait(sem);
}

/// 
/// Non-blocking variant of SDL_SemWait().
/// 
/// \return 0 if the wait succeeds, ::SDL_MUTEX_TIMEDOUT if the wait would
/// block, and -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SemTryWait(SDL_sem * sem)
/// ```
int SDL_SemTryWait(Pointer<SDL_sem>? sem) {
  final _SDL_SemTryWait = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_sem>? sem),
      int Function(Pointer<SDL_sem>? sem)>('SDL_SemTryWait');
  return _SDL_SemTryWait(sem);
}

/// 
/// Variant of SDL_SemWait() with a timeout in milliseconds.
/// 
/// \return 0 if the wait succeeds, ::SDL_MUTEX_TIMEDOUT if the wait does not
/// succeed in the allotted time, and -1 on error.
/// 
/// \warning On some platforms this function is implemented by looping with a
/// delay of 1 ms, and so should be avoided if possible.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SemWaitTimeout(SDL_sem * sem, Uint32 ms)
/// ```
int SDL_SemWaitTimeout(Pointer<SDL_sem>? sem, int ms) {
  final _SDL_SemWaitTimeout = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_sem>? sem, Uint32 ms),
      int Function(Pointer<SDL_sem>? sem, int ms)>('SDL_SemWaitTimeout');
  return _SDL_SemWaitTimeout(sem, ms);
}

/// 
/// Atomically increases the semaphore's count (not blocking).
/// 
/// \return 0, or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SemPost(SDL_sem * sem)
/// ```
int SDL_SemPost(Pointer<SDL_sem>? sem) {
  final _SDL_SemPost = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_sem>? sem),
      int Function(Pointer<SDL_sem>? sem)>('SDL_SemPost');
  return _SDL_SemPost(sem);
}

/// 
/// Returns the current count of the semaphore.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_SemValue(SDL_sem * sem)
/// ```
int SDL_SemValue(Pointer<SDL_sem>? sem) {
  final _SDL_SemValue = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_sem>? sem),
      int Function(Pointer<SDL_sem>? sem)>('SDL_SemValue');
  return _SDL_SemValue(sem);
}

/// 
/// Create a condition variable.
/// 
/// Typical use of condition variables:
/// 
/// Thread A:
/// SDL_LockMutex(lock);
/// while ( ! condition ) {
/// SDL_CondWait(cond, lock);
/// }
/// SDL_UnlockMutex(lock);
/// 
/// Thread B:
/// SDL_LockMutex(lock);
/// ...
/// condition = true;
/// ...
/// SDL_CondSignal(cond);
/// SDL_UnlockMutex(lock);
/// 
/// There is some discussion whether to signal the condition variable
/// with the mutex locked or not.  There is some potential performance
/// benefit to unlocking first on some platforms, but there are some
/// potential race conditions depending on how your code is structured.
/// 
/// In general it's safer to signal the condition variable while the
/// mutex is locked.
/// 
/// ```c
/// extern DECLSPEC SDL_cond *SDLCALL SDL_CreateCond(void)
/// ```
Pointer<SDL_cond>? SDL_CreateCond() {
  final _SDL_CreateCond = _SDL2.lookupFunction<
      Pointer<SDL_cond>? Function(),
      Pointer<SDL_cond>? Function()>('SDL_CreateCond');
  return _SDL_CreateCond();
}

/// 
/// Destroy a condition variable.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroyCond(SDL_cond * cond)
/// ```
void SDL_DestroyCond(Pointer<SDL_cond>? cond) {
  final _SDL_DestroyCond = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_cond>? cond),
      void Function(Pointer<SDL_cond>? cond)>('SDL_DestroyCond');
  return _SDL_DestroyCond(cond);
}

/// 
/// Restart one of the threads that are waiting on the condition variable.
/// 
/// \return 0 or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_CondSignal(SDL_cond * cond)
/// ```
int SDL_CondSignal(Pointer<SDL_cond>? cond) {
  final _SDL_CondSignal = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_cond>? cond),
      int Function(Pointer<SDL_cond>? cond)>('SDL_CondSignal');
  return _SDL_CondSignal(cond);
}

/// 
/// Restart all threads that are waiting on the condition variable.
/// 
/// \return 0 or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_CondBroadcast(SDL_cond * cond)
/// ```
int SDL_CondBroadcast(Pointer<SDL_cond>? cond) {
  final _SDL_CondBroadcast = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_cond>? cond),
      int Function(Pointer<SDL_cond>? cond)>('SDL_CondBroadcast');
  return _SDL_CondBroadcast(cond);
}

/// 
/// Wait on the condition variable, unlocking the provided mutex.
/// 
/// \warning The mutex must be locked before entering this function!
/// 
/// The mutex is re-locked once the condition variable is signaled.
/// 
/// \return 0 when it is signaled, or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_CondWait(SDL_cond * cond, SDL_mutex * mutex)
/// ```
int SDL_CondWait(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex) {
  final _SDL_CondWait = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex),
      int Function(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex)>('SDL_CondWait');
  return _SDL_CondWait(cond, mutex);
}

/// 
/// Waits for at most \c ms milliseconds, and returns 0 if the condition
/// variable is signaled, ::SDL_MUTEX_TIMEDOUT if the condition is not
/// signaled in the allotted time, and -1 on error.
/// 
/// \warning On some platforms this function is implemented by looping with a
/// delay of 1 ms, and so should be avoided if possible.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_CondWaitTimeout(SDL_cond * cond, SDL_mutex * mutex, Uint32 ms)
/// ```
int SDL_CondWaitTimeout(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex, int ms) {
  final _SDL_CondWaitTimeout = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex, Uint32 ms),
      int Function(Pointer<SDL_cond>? cond, Pointer<SDL_mutex>? mutex, int ms)>('SDL_CondWaitTimeout');
  return _SDL_CondWaitTimeout(cond, mutex, ms);
}

/// ```c
/// GLAPI void APIENTRY glBlendColor (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
/// ```
void glBlendColor(double red, double green, double blue, double alpha) {
  final _glBlendColor = _SDL2.lookupFunction<
      Void Function(Float red, Float green, Float blue, Float alpha),
      void Function(double red, double green, double blue, double alpha)>('glBlendColor');
  return _glBlendColor(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquation (GLenum mode)
/// ```
void glBlendEquation(int mode) {
  final _glBlendEquation = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glBlendEquation');
  return _glBlendEquation(mode);
}

/// ```c
/// GLAPI void APIENTRY glDrawRangeElements (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices)
/// ```
void glDrawRangeElements(int mode, int start, int end, int count, int type, Pointer<Void>? indices) {
  final _glDrawRangeElements = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Uint32 count, Uint32 type, Pointer<Void>? indices),
      void Function(int mode, int start, int end, int count, int type, Pointer<Void>? indices)>('glDrawRangeElements');
  return _glDrawRangeElements(mode, start, end, count, type, indices);
}

/// ```c
/// GLAPI void APIENTRY glTexImage3D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexImage3D(int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTexImage3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels)>('glTexImage3D');
  return _glTexImage3D(target, level, internalformat, width, height, depth, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTexSubImage3D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexSubImage3D(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels) {
  final _glTexSubImage3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels)>('glTexSubImage3D');
  return _glTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexSubImage3D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyTexSubImage3D(int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height) {
  final _glCopyTexSubImage3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height)>('glCopyTexSubImage3D');
  return _glCopyTexSubImage3D(target, level, xoffset, yoffset, zoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glColorTable (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
/// ```
void glColorTable(int target, int internalformat, int width, int format, int type, Pointer<Void>? table) {
  final _glColorTable = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? table),
      void Function(int target, int internalformat, int width, int format, int type, Pointer<Void>? table)>('glColorTable');
  return _glColorTable(target, internalformat, width, format, type, table);
}

/// ```c
/// GLAPI void APIENTRY glColorTableParameterfv (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glColorTableParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glColorTableParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glColorTableParameterfv');
  return _glColorTableParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glColorTableParameteriv (GLenum target, GLenum pname, const GLint *params)
/// ```
void glColorTableParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glColorTableParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glColorTableParameteriv');
  return _glColorTableParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCopyColorTable (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
/// ```
void glCopyColorTable(int target, int internalformat, int x, int y, int width) {
  final _glCopyColorTable = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int internalformat, int x, int y, int width)>('glCopyColorTable');
  return _glCopyColorTable(target, internalformat, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTable (GLenum target, GLenum format, GLenum type, GLvoid *table)
/// ```
void glGetColorTable(int target, int format, int type, Pointer<Void>? table) {
  final _glGetColorTable = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? table),
      void Function(int target, int format, int type, Pointer<Void>? table)>('glGetColorTable');
  return _glGetColorTable(target, format, type, table);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameterfv (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetColorTableParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glGetColorTableParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetColorTableParameterfv');
  return _glGetColorTableParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetColorTableParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetColorTableParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetColorTableParameteriv');
  return _glGetColorTableParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glColorSubTable (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data)
/// ```
void glColorSubTable(int target, int start, int count, int format, int type, Pointer<Void>? data) {
  final _glColorSubTable = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 start, Uint32 count, Uint32 format, Uint32 type, Pointer<Void>? data),
      void Function(int target, int start, int count, int format, int type, Pointer<Void>? data)>('glColorSubTable');
  return _glColorSubTable(target, start, count, format, type, data);
}

/// ```c
/// GLAPI void APIENTRY glCopyColorSubTable (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width)
/// ```
void glCopyColorSubTable(int target, int start, int x, int y, int width) {
  final _glCopyColorSubTable = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 start, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int start, int x, int y, int width)>('glCopyColorSubTable');
  return _glCopyColorSubTable(target, start, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionFilter1D (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image)
/// ```
void glConvolutionFilter1D(int target, int internalformat, int width, int format, int type, Pointer<Void>? image) {
  final _glConvolutionFilter1D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int internalformat, int width, int format, int type, Pointer<Void>? image)>('glConvolutionFilter1D');
  return _glConvolutionFilter1D(target, internalformat, width, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionFilter2D (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image)
/// ```
void glConvolutionFilter2D(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? image) {
  final _glConvolutionFilter2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? image)>('glConvolutionFilter2D');
  return _glConvolutionFilter2D(target, internalformat, width, height, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameterf (GLenum target, GLenum pname, GLfloat params)
/// ```
void glConvolutionParameterf(int target, int pname, double params) {
  final _glConvolutionParameterf = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Float params),
      void Function(int target, int pname, double params)>('glConvolutionParameterf');
  return _glConvolutionParameterf(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameterfv (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glConvolutionParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glConvolutionParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glConvolutionParameterfv');
  return _glConvolutionParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameteri (GLenum target, GLenum pname, GLint params)
/// ```
void glConvolutionParameteri(int target, int pname, int params) {
  final _glConvolutionParameteri = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Int32 params),
      void Function(int target, int pname, int params)>('glConvolutionParameteri');
  return _glConvolutionParameteri(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameteriv (GLenum target, GLenum pname, const GLint *params)
/// ```
void glConvolutionParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glConvolutionParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glConvolutionParameteriv');
  return _glConvolutionParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCopyConvolutionFilter1D (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
/// ```
void glCopyConvolutionFilter1D(int target, int internalformat, int x, int y, int width) {
  final _glCopyConvolutionFilter1D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int internalformat, int x, int y, int width)>('glCopyConvolutionFilter1D');
  return _glCopyConvolutionFilter1D(target, internalformat, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glCopyConvolutionFilter2D (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyConvolutionFilter2D(int target, int internalformat, int x, int y, int width, int height) {
  final _glCopyConvolutionFilter2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int target, int internalformat, int x, int y, int width, int height)>('glCopyConvolutionFilter2D');
  return _glCopyConvolutionFilter2D(target, internalformat, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionFilter (GLenum target, GLenum format, GLenum type, GLvoid *image)
/// ```
void glGetConvolutionFilter(int target, int format, int type, Pointer<Void>? image) {
  final _glGetConvolutionFilter = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int format, int type, Pointer<Void>? image)>('glGetConvolutionFilter');
  return _glGetConvolutionFilter(target, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionParameterfv (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetConvolutionParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glGetConvolutionParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetConvolutionParameterfv');
  return _glGetConvolutionParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetConvolutionParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetConvolutionParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetConvolutionParameteriv');
  return _glGetConvolutionParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSeparableFilter (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span)
/// ```
void glGetSeparableFilter(int target, int format, int type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span) {
  final _glGetSeparableFilter = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span),
      void Function(int target, int format, int type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span)>('glGetSeparableFilter');
  return _glGetSeparableFilter(target, format, type, row, column, span);
}

/// ```c
/// GLAPI void APIENTRY glSeparableFilter2D (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column)
/// ```
void glSeparableFilter2D(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? row, Pointer<Void>? column) {
  final _glSeparableFilter2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? row, Pointer<Void>? column),
      void Function(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? row, Pointer<Void>? column)>('glSeparableFilter2D');
  return _glSeparableFilter2D(target, internalformat, width, height, format, type, row, column);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogram (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
/// ```
void glGetHistogram(int target, int reset, int format, int type, Pointer<Void>? values) {
  final _glGetHistogram = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, Pointer<Void>? values)>('glGetHistogram');
  return _glGetHistogram(target, reset, format, type, values);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogramParameterfv (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetHistogramParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glGetHistogramParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetHistogramParameterfv');
  return _glGetHistogramParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogramParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetHistogramParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetHistogramParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetHistogramParameteriv');
  return _glGetHistogramParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmax (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
/// ```
void glGetMinmax(int target, int reset, int format, int type, Pointer<Void>? values) {
  final _glGetMinmax = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, Pointer<Void>? values)>('glGetMinmax');
  return _glGetMinmax(target, reset, format, type, values);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmaxParameterfv (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetMinmaxParameterfv(int target, int pname, Pointer<Float>? params) {
  final _glGetMinmaxParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetMinmaxParameterfv');
  return _glGetMinmaxParameterfv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmaxParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMinmaxParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetMinmaxParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetMinmaxParameteriv');
  return _glGetMinmaxParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glHistogram (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink)
/// ```
void glHistogram(int target, int width, int internalformat, int sink) {
  final _glHistogram = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 width, Uint32 internalformat, Int32 sink),
      void Function(int target, int width, int internalformat, int sink)>('glHistogram');
  return _glHistogram(target, width, internalformat, sink);
}

/// ```c
/// GLAPI void APIENTRY glMinmax (GLenum target, GLenum internalformat, GLboolean sink)
/// ```
void glMinmax(int target, int internalformat, int sink) {
  final _glMinmax = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 sink),
      void Function(int target, int internalformat, int sink)>('glMinmax');
  return _glMinmax(target, internalformat, sink);
}

/// ```c
/// GLAPI void APIENTRY glResetHistogram (GLenum target)
/// ```
void glResetHistogram(int target) {
  final _glResetHistogram = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glResetHistogram');
  return _glResetHistogram(target);
}

/// ```c
/// GLAPI void APIENTRY glResetMinmax (GLenum target)
/// ```
void glResetMinmax(int target) {
  final _glResetMinmax = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glResetMinmax');
  return _glResetMinmax(target);
}

/// ```c
/// GLAPI void APIENTRY glActiveTexture (GLenum texture)
/// ```
void glActiveTexture(int texture) {
  final _glActiveTexture = _SDL2.lookupFunction<
      Void Function(Uint32 texture),
      void Function(int texture)>('glActiveTexture');
  return _glActiveTexture(texture);
}

/// ```c
/// GLAPI void APIENTRY glSampleCoverage (GLclampf value, GLboolean invert)
/// ```
void glSampleCoverage(double value, int invert) {
  final _glSampleCoverage = _SDL2.lookupFunction<
      Void Function(Float value, Int32 invert),
      void Function(double value, int invert)>('glSampleCoverage');
  return _glSampleCoverage(value, invert);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage3D (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage3D(int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage3D');
  return _glCompressedTexImage3D(target, level, internalformat, width, height, depth, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage2D (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage2D(int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage2D');
  return _glCompressedTexImage2D(target, level, internalformat, width, height, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage1D (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage1D(int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage1D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage1D');
  return _glCompressedTexImage1D(target, level, internalformat, width, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage3D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage3D(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage3D');
  return _glCompressedTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage2D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage2D(int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage2D');
  return _glCompressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage1D (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage1D(int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage1D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage1D');
  return _glCompressedTexSubImage1D(target, level, xoffset, width, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glGetCompressedTexImage (GLenum target, GLint level, GLvoid *img)
/// ```
void glGetCompressedTexImage(int target, int level, Pointer<Void>? img) {
  final _glGetCompressedTexImage = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Pointer<Void>? img),
      void Function(int target, int level, Pointer<Void>? img)>('glGetCompressedTexImage');
  return _glGetCompressedTexImage(target, level, img);
}

/// ```c
/// GLAPI void APIENTRY glClientActiveTexture (GLenum texture)
/// ```
void glClientActiveTexture(int texture) {
  final _glClientActiveTexture = _SDL2.lookupFunction<
      Void Function(Uint32 texture),
      void Function(int texture)>('glClientActiveTexture');
  return _glClientActiveTexture(texture);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1d (GLenum target, GLdouble s)
/// ```
void glMultiTexCoord1d(int target, double s) {
  final _glMultiTexCoord1d = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s),
      void Function(int target, double s)>('glMultiTexCoord1d');
  return _glMultiTexCoord1d(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1dv (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord1dv(int target, Pointer<Double>? v) {
  final _glMultiTexCoord1dv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord1dv');
  return _glMultiTexCoord1dv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1f (GLenum target, GLfloat s)
/// ```
void glMultiTexCoord1f(int target, double s) {
  final _glMultiTexCoord1f = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s),
      void Function(int target, double s)>('glMultiTexCoord1f');
  return _glMultiTexCoord1f(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1fv (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord1fv(int target, Pointer<Float>? v) {
  final _glMultiTexCoord1fv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord1fv');
  return _glMultiTexCoord1fv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1i (GLenum target, GLint s)
/// ```
void glMultiTexCoord1i(int target, int s) {
  final _glMultiTexCoord1i = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s),
      void Function(int target, int s)>('glMultiTexCoord1i');
  return _glMultiTexCoord1i(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1iv (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord1iv(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord1iv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord1iv');
  return _glMultiTexCoord1iv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1s (GLenum target, GLshort s)
/// ```
void glMultiTexCoord1s(int target, int s) {
  final _glMultiTexCoord1s = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s),
      void Function(int target, int s)>('glMultiTexCoord1s');
  return _glMultiTexCoord1s(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1sv (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord1sv(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord1sv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord1sv');
  return _glMultiTexCoord1sv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2d (GLenum target, GLdouble s, GLdouble t)
/// ```
void glMultiTexCoord2d(int target, double s, double t) {
  final _glMultiTexCoord2d = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t),
      void Function(int target, double s, double t)>('glMultiTexCoord2d');
  return _glMultiTexCoord2d(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2dv (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord2dv(int target, Pointer<Double>? v) {
  final _glMultiTexCoord2dv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord2dv');
  return _glMultiTexCoord2dv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2f (GLenum target, GLfloat s, GLfloat t)
/// ```
void glMultiTexCoord2f(int target, double s, double t) {
  final _glMultiTexCoord2f = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t),
      void Function(int target, double s, double t)>('glMultiTexCoord2f');
  return _glMultiTexCoord2f(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2fv (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord2fv(int target, Pointer<Float>? v) {
  final _glMultiTexCoord2fv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord2fv');
  return _glMultiTexCoord2fv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2i (GLenum target, GLint s, GLint t)
/// ```
void glMultiTexCoord2i(int target, int s, int t) {
  final _glMultiTexCoord2i = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t),
      void Function(int target, int s, int t)>('glMultiTexCoord2i');
  return _glMultiTexCoord2i(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2iv (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord2iv(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord2iv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord2iv');
  return _glMultiTexCoord2iv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2s (GLenum target, GLshort s, GLshort t)
/// ```
void glMultiTexCoord2s(int target, int s, int t) {
  final _glMultiTexCoord2s = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t),
      void Function(int target, int s, int t)>('glMultiTexCoord2s');
  return _glMultiTexCoord2s(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2sv (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord2sv(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord2sv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord2sv');
  return _glMultiTexCoord2sv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3d (GLenum target, GLdouble s, GLdouble t, GLdouble r)
/// ```
void glMultiTexCoord3d(int target, double s, double t, double r) {
  final _glMultiTexCoord3d = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t, Double r),
      void Function(int target, double s, double t, double r)>('glMultiTexCoord3d');
  return _glMultiTexCoord3d(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3dv (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord3dv(int target, Pointer<Double>? v) {
  final _glMultiTexCoord3dv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord3dv');
  return _glMultiTexCoord3dv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3f (GLenum target, GLfloat s, GLfloat t, GLfloat r)
/// ```
void glMultiTexCoord3f(int target, double s, double t, double r) {
  final _glMultiTexCoord3f = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t, Float r),
      void Function(int target, double s, double t, double r)>('glMultiTexCoord3f');
  return _glMultiTexCoord3f(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3fv (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord3fv(int target, Pointer<Float>? v) {
  final _glMultiTexCoord3fv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord3fv');
  return _glMultiTexCoord3fv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3i (GLenum target, GLint s, GLint t, GLint r)
/// ```
void glMultiTexCoord3i(int target, int s, int t, int r) {
  final _glMultiTexCoord3i = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t, Int32 r),
      void Function(int target, int s, int t, int r)>('glMultiTexCoord3i');
  return _glMultiTexCoord3i(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3iv (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord3iv(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord3iv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord3iv');
  return _glMultiTexCoord3iv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3s (GLenum target, GLshort s, GLshort t, GLshort r)
/// ```
void glMultiTexCoord3s(int target, int s, int t, int r) {
  final _glMultiTexCoord3s = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t, Int16 r),
      void Function(int target, int s, int t, int r)>('glMultiTexCoord3s');
  return _glMultiTexCoord3s(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3sv (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord3sv(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord3sv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord3sv');
  return _glMultiTexCoord3sv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4d (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
/// ```
void glMultiTexCoord4d(int target, double s, double t, double r, double q) {
  final _glMultiTexCoord4d = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t, Double r, Double q),
      void Function(int target, double s, double t, double r, double q)>('glMultiTexCoord4d');
  return _glMultiTexCoord4d(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4dv (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord4dv(int target, Pointer<Double>? v) {
  final _glMultiTexCoord4dv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord4dv');
  return _glMultiTexCoord4dv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4f (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
/// ```
void glMultiTexCoord4f(int target, double s, double t, double r, double q) {
  final _glMultiTexCoord4f = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t, Float r, Float q),
      void Function(int target, double s, double t, double r, double q)>('glMultiTexCoord4f');
  return _glMultiTexCoord4f(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4fv (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord4fv(int target, Pointer<Float>? v) {
  final _glMultiTexCoord4fv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord4fv');
  return _glMultiTexCoord4fv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4i (GLenum target, GLint s, GLint t, GLint r, GLint q)
/// ```
void glMultiTexCoord4i(int target, int s, int t, int r, int q) {
  final _glMultiTexCoord4i = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t, Int32 r, Int32 q),
      void Function(int target, int s, int t, int r, int q)>('glMultiTexCoord4i');
  return _glMultiTexCoord4i(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4iv (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord4iv(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord4iv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord4iv');
  return _glMultiTexCoord4iv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4s (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q)
/// ```
void glMultiTexCoord4s(int target, int s, int t, int r, int q) {
  final _glMultiTexCoord4s = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t, Int16 r, Int16 q),
      void Function(int target, int s, int t, int r, int q)>('glMultiTexCoord4s');
  return _glMultiTexCoord4s(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4sv (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord4sv(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord4sv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord4sv');
  return _glMultiTexCoord4sv(target, v);
}

/// ```c
/// GLAPI void APIENTRY glLoadTransposeMatrixf (const GLfloat *m)
/// ```
void glLoadTransposeMatrixf(Pointer<Float>? m) {
  final _glLoadTransposeMatrixf = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? m),
      void Function(Pointer<Float>? m)>('glLoadTransposeMatrixf');
  return _glLoadTransposeMatrixf(m);
}

/// ```c
/// GLAPI void APIENTRY glLoadTransposeMatrixd (const GLdouble *m)
/// ```
void glLoadTransposeMatrixd(Pointer<Double>? m) {
  final _glLoadTransposeMatrixd = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? m),
      void Function(Pointer<Double>? m)>('glLoadTransposeMatrixd');
  return _glLoadTransposeMatrixd(m);
}

/// ```c
/// GLAPI void APIENTRY glMultTransposeMatrixf (const GLfloat *m)
/// ```
void glMultTransposeMatrixf(Pointer<Float>? m) {
  final _glMultTransposeMatrixf = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? m),
      void Function(Pointer<Float>? m)>('glMultTransposeMatrixf');
  return _glMultTransposeMatrixf(m);
}

/// ```c
/// GLAPI void APIENTRY glMultTransposeMatrixd (const GLdouble *m)
/// ```
void glMultTransposeMatrixd(Pointer<Double>? m) {
  final _glMultTransposeMatrixd = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? m),
      void Function(Pointer<Double>? m)>('glMultTransposeMatrixd');
  return _glMultTransposeMatrixd(m);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparate (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
/// ```
void glBlendFuncSeparate(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha) {
  final _glBlendFuncSeparate = _SDL2.lookupFunction<
      Void Function(Uint32 sfactorRGB, Uint32 dfactorRGB, Uint32 sfactorAlpha, Uint32 dfactorAlpha),
      void Function(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha)>('glBlendFuncSeparate');
  return _glBlendFuncSeparate(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawArrays (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
/// ```
void glMultiDrawArrays(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount) {
  final _glMultiDrawArrays = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Int32>? first, Pointer<Uint32>? count, Uint32 primcount),
      void Function(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount)>('glMultiDrawArrays');
  return _glMultiDrawArrays(mode, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawElements (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount)
/// ```
void glMultiDrawElements(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount) {
  final _glMultiDrawElements = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Uint32>? count, Uint32 type, Pointer<Pointer<Void>>? indices, Uint32 primcount),
      void Function(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount)>('glMultiDrawElements');
  return _glMultiDrawElements(mode, count, type, indices, primcount);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterf (GLenum pname, GLfloat param)
/// ```
void glPointParameterf(int pname, double param) {
  final _glPointParameterf = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPointParameterf');
  return _glPointParameterf(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfv (GLenum pname, const GLfloat *params)
/// ```
void glPointParameterfv(int pname, Pointer<Float>? params) {
  final _glPointParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glPointParameterfv');
  return _glPointParameterfv(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPointParameteri (GLenum pname, GLint param)
/// ```
void glPointParameteri(int pname, int param) {
  final _glPointParameteri = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glPointParameteri');
  return _glPointParameteri(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameteriv (GLenum pname, const GLint *params)
/// ```
void glPointParameteriv(int pname, Pointer<Int32>? params) {
  final _glPointParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glPointParameteriv');
  return _glPointParameteriv(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordf (GLfloat coord)
/// ```
void glFogCoordf(double coord) {
  final _glFogCoordf = _SDL2.lookupFunction<
      Void Function(Float coord),
      void Function(double coord)>('glFogCoordf');
  return _glFogCoordf(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordfv (const GLfloat *coord)
/// ```
void glFogCoordfv(Pointer<Float>? coord) {
  final _glFogCoordfv = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? coord),
      void Function(Pointer<Float>? coord)>('glFogCoordfv');
  return _glFogCoordfv(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordd (GLdouble coord)
/// ```
void glFogCoordd(double coord) {
  final _glFogCoordd = _SDL2.lookupFunction<
      Void Function(Double coord),
      void Function(double coord)>('glFogCoordd');
  return _glFogCoordd(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoorddv (const GLdouble *coord)
/// ```
void glFogCoorddv(Pointer<Double>? coord) {
  final _glFogCoorddv = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? coord),
      void Function(Pointer<Double>? coord)>('glFogCoorddv');
  return _glFogCoorddv(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordPointer (GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glFogCoordPointer(int type, int stride, Pointer<Void>? pointer) {
  final _glFogCoordPointer = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int type, int stride, Pointer<Void>? pointer)>('glFogCoordPointer');
  return _glFogCoordPointer(type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3b (GLbyte red, GLbyte green, GLbyte blue)
/// ```
void glSecondaryColor3b(int red, int green, int blue) {
  final _glSecondaryColor3b = _SDL2.lookupFunction<
      Void Function(Int8 red, Int8 green, Int8 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3b');
  return _glSecondaryColor3b(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3bv (const GLbyte *v)
/// ```
void glSecondaryColor3bv(String v) {
  final _glSecondaryColor3bv = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? v),
      void Function(Pointer<Utf8>? v)>('glSecondaryColor3bv');
  final _vPointer = v.toNativeUtf8();
  final _result = _glSecondaryColor3bv(_vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3d (GLdouble red, GLdouble green, GLdouble blue)
/// ```
void glSecondaryColor3d(double red, double green, double blue) {
  final _glSecondaryColor3d = _SDL2.lookupFunction<
      Void Function(Double red, Double green, Double blue),
      void Function(double red, double green, double blue)>('glSecondaryColor3d');
  return _glSecondaryColor3d(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3dv (const GLdouble *v)
/// ```
void glSecondaryColor3dv(Pointer<Double>? v) {
  final _glSecondaryColor3dv = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glSecondaryColor3dv');
  return _glSecondaryColor3dv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3f (GLfloat red, GLfloat green, GLfloat blue)
/// ```
void glSecondaryColor3f(double red, double green, double blue) {
  final _glSecondaryColor3f = _SDL2.lookupFunction<
      Void Function(Float red, Float green, Float blue),
      void Function(double red, double green, double blue)>('glSecondaryColor3f');
  return _glSecondaryColor3f(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3fv (const GLfloat *v)
/// ```
void glSecondaryColor3fv(Pointer<Float>? v) {
  final _glSecondaryColor3fv = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glSecondaryColor3fv');
  return _glSecondaryColor3fv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3i (GLint red, GLint green, GLint blue)
/// ```
void glSecondaryColor3i(int red, int green, int blue) {
  final _glSecondaryColor3i = _SDL2.lookupFunction<
      Void Function(Int32 red, Int32 green, Int32 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3i');
  return _glSecondaryColor3i(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3iv (const GLint *v)
/// ```
void glSecondaryColor3iv(Pointer<Int32>? v) {
  final _glSecondaryColor3iv = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glSecondaryColor3iv');
  return _glSecondaryColor3iv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3s (GLshort red, GLshort green, GLshort blue)
/// ```
void glSecondaryColor3s(int red, int green, int blue) {
  final _glSecondaryColor3s = _SDL2.lookupFunction<
      Void Function(Int16 red, Int16 green, Int16 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3s');
  return _glSecondaryColor3s(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3sv (const GLshort *v)
/// ```
void glSecondaryColor3sv(Pointer<Int16>? v) {
  final _glSecondaryColor3sv = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glSecondaryColor3sv');
  return _glSecondaryColor3sv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ub (GLubyte red, GLubyte green, GLubyte blue)
/// ```
void glSecondaryColor3ub(int red, int green, int blue) {
  final _glSecondaryColor3ub = _SDL2.lookupFunction<
      Void Function(Uint8 red, Uint8 green, Uint8 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3ub');
  return _glSecondaryColor3ub(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ubv (const GLubyte *v)
/// ```
void glSecondaryColor3ubv(Pointer<Uint8>? v) {
  final _glSecondaryColor3ubv = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? v),
      void Function(Pointer<Uint8>? v)>('glSecondaryColor3ubv');
  return _glSecondaryColor3ubv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ui (GLuint red, GLuint green, GLuint blue)
/// ```
void glSecondaryColor3ui(int red, int green, int blue) {
  final _glSecondaryColor3ui = _SDL2.lookupFunction<
      Void Function(Uint32 red, Uint32 green, Uint32 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3ui');
  return _glSecondaryColor3ui(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3uiv (const GLuint *v)
/// ```
void glSecondaryColor3uiv(Pointer<Uint32>? v) {
  final _glSecondaryColor3uiv = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? v),
      void Function(Pointer<Uint32>? v)>('glSecondaryColor3uiv');
  return _glSecondaryColor3uiv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3us (GLushort red, GLushort green, GLushort blue)
/// ```
void glSecondaryColor3us(int red, int green, int blue) {
  final _glSecondaryColor3us = _SDL2.lookupFunction<
      Void Function(Uint16 red, Uint16 green, Uint16 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3us');
  return _glSecondaryColor3us(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3usv (const GLushort *v)
/// ```
void glSecondaryColor3usv(Pointer<Uint16>? v) {
  final _glSecondaryColor3usv = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glSecondaryColor3usv');
  return _glSecondaryColor3usv(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glSecondaryColorPointer(int size, int type, int stride, Pointer<Void>? pointer) {
  final _glSecondaryColorPointer = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, Pointer<Void>? pointer)>('glSecondaryColorPointer');
  return _glSecondaryColorPointer(size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2d (GLdouble x, GLdouble y)
/// ```
void glWindowPos2d(double x, double y) {
  final _glWindowPos2d = _SDL2.lookupFunction<
      Void Function(Double x, Double y),
      void Function(double x, double y)>('glWindowPos2d');
  return _glWindowPos2d(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2dv (const GLdouble *v)
/// ```
void glWindowPos2dv(Pointer<Double>? v) {
  final _glWindowPos2dv = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos2dv');
  return _glWindowPos2dv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2f (GLfloat x, GLfloat y)
/// ```
void glWindowPos2f(double x, double y) {
  final _glWindowPos2f = _SDL2.lookupFunction<
      Void Function(Float x, Float y),
      void Function(double x, double y)>('glWindowPos2f');
  return _glWindowPos2f(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2fv (const GLfloat *v)
/// ```
void glWindowPos2fv(Pointer<Float>? v) {
  final _glWindowPos2fv = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos2fv');
  return _glWindowPos2fv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2i (GLint x, GLint y)
/// ```
void glWindowPos2i(int x, int y) {
  final _glWindowPos2i = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y),
      void Function(int x, int y)>('glWindowPos2i');
  return _glWindowPos2i(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2iv (const GLint *v)
/// ```
void glWindowPos2iv(Pointer<Int32>? v) {
  final _glWindowPos2iv = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos2iv');
  return _glWindowPos2iv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2s (GLshort x, GLshort y)
/// ```
void glWindowPos2s(int x, int y) {
  final _glWindowPos2s = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y),
      void Function(int x, int y)>('glWindowPos2s');
  return _glWindowPos2s(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2sv (const GLshort *v)
/// ```
void glWindowPos2sv(Pointer<Int16>? v) {
  final _glWindowPos2sv = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos2sv');
  return _glWindowPos2sv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3d (GLdouble x, GLdouble y, GLdouble z)
/// ```
void glWindowPos3d(double x, double y, double z) {
  final _glWindowPos3d = _SDL2.lookupFunction<
      Void Function(Double x, Double y, Double z),
      void Function(double x, double y, double z)>('glWindowPos3d');
  return _glWindowPos3d(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3dv (const GLdouble *v)
/// ```
void glWindowPos3dv(Pointer<Double>? v) {
  final _glWindowPos3dv = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos3dv');
  return _glWindowPos3dv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3f (GLfloat x, GLfloat y, GLfloat z)
/// ```
void glWindowPos3f(double x, double y, double z) {
  final _glWindowPos3f = _SDL2.lookupFunction<
      Void Function(Float x, Float y, Float z),
      void Function(double x, double y, double z)>('glWindowPos3f');
  return _glWindowPos3f(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3fv (const GLfloat *v)
/// ```
void glWindowPos3fv(Pointer<Float>? v) {
  final _glWindowPos3fv = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos3fv');
  return _glWindowPos3fv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3i (GLint x, GLint y, GLint z)
/// ```
void glWindowPos3i(int x, int y, int z) {
  final _glWindowPos3i = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y, Int32 z),
      void Function(int x, int y, int z)>('glWindowPos3i');
  return _glWindowPos3i(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3iv (const GLint *v)
/// ```
void glWindowPos3iv(Pointer<Int32>? v) {
  final _glWindowPos3iv = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos3iv');
  return _glWindowPos3iv(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3s (GLshort x, GLshort y, GLshort z)
/// ```
void glWindowPos3s(int x, int y, int z) {
  final _glWindowPos3s = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y, Int16 z),
      void Function(int x, int y, int z)>('glWindowPos3s');
  return _glWindowPos3s(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3sv (const GLshort *v)
/// ```
void glWindowPos3sv(Pointer<Int16>? v) {
  final _glWindowPos3sv = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos3sv');
  return _glWindowPos3sv(v);
}

/// ```c
/// GLAPI void APIENTRY glGenQueries (GLsizei n, GLuint *ids)
/// ```
void glGenQueries(int n, Pointer<Uint32>? ids) {
  final _glGenQueries = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glGenQueries');
  return _glGenQueries(n, ids);
}

/// ```c
/// GLAPI void APIENTRY glDeleteQueries (GLsizei n, const GLuint *ids)
/// ```
void glDeleteQueries(int n, Pointer<Uint32>? ids) {
  final _glDeleteQueries = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glDeleteQueries');
  return _glDeleteQueries(n, ids);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsQuery (GLuint id)
/// ```
int glIsQuery(int id) {
  final _glIsQuery = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsQuery');
  return _glIsQuery(id);
}

/// ```c
/// GLAPI void APIENTRY glBeginQuery (GLenum target, GLuint id)
/// ```
void glBeginQuery(int target, int id) {
  final _glBeginQuery = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id),
      void Function(int target, int id)>('glBeginQuery');
  return _glBeginQuery(target, id);
}

/// ```c
/// GLAPI void APIENTRY glEndQuery (GLenum target)
/// ```
void glEndQuery(int target) {
  final _glEndQuery = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glEndQuery');
  return _glEndQuery(target);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryiv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetQueryiv(int target, int pname, Pointer<Int32>? params) {
  final _glGetQueryiv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetQueryiv');
  return _glGetQueryiv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectiv (GLuint id, GLenum pname, GLint *params)
/// ```
void glGetQueryObjectiv(int id, int pname, Pointer<Int32>? params) {
  final _glGetQueryObjectiv = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int32>? params),
      void Function(int id, int pname, Pointer<Int32>? params)>('glGetQueryObjectiv');
  return _glGetQueryObjectiv(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectuiv (GLuint id, GLenum pname, GLuint *params)
/// ```
void glGetQueryObjectuiv(int id, int pname, Pointer<Uint32>? params) {
  final _glGetQueryObjectuiv = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint32>? params),
      void Function(int id, int pname, Pointer<Uint32>? params)>('glGetQueryObjectuiv');
  return _glGetQueryObjectuiv(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glBindBuffer (GLenum target, GLuint buffer)
/// ```
void glBindBuffer(int target, int buffer) {
  final _glBindBuffer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 buffer),
      void Function(int target, int buffer)>('glBindBuffer');
  return _glBindBuffer(target, buffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteBuffers (GLsizei n, const GLuint *buffers)
/// ```
void glDeleteBuffers(int n, Pointer<Uint32>? buffers) {
  final _glDeleteBuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? buffers),
      void Function(int n, Pointer<Uint32>? buffers)>('glDeleteBuffers');
  return _glDeleteBuffers(n, buffers);
}

/// ```c
/// GLAPI void APIENTRY glGenBuffers (GLsizei n, GLuint *buffers)
/// ```
void glGenBuffers(int n, Pointer<Uint32>? buffers) {
  final _glGenBuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? buffers),
      void Function(int n, Pointer<Uint32>? buffers)>('glGenBuffers');
  return _glGenBuffers(n, buffers);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsBuffer (GLuint buffer)
/// ```
int glIsBuffer(int buffer) {
  final _glIsBuffer = _SDL2.lookupFunction<
      Int32 Function(Uint32 buffer),
      int Function(int buffer)>('glIsBuffer');
  return _glIsBuffer(buffer);
}

/// ```c
/// GLAPI void APIENTRY glBufferData (GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage)
/// ```
void glBufferData(int target, Pointer<Void>? size, Pointer<Void>? data, int usage) {
  final _glBufferData = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Void>? size, Pointer<Void>? data, Uint32 usage),
      void Function(int target, Pointer<Void>? size, Pointer<Void>? data, int usage)>('glBufferData');
  return _glBufferData(target, size, data, usage);
}

/// ```c
/// GLAPI void APIENTRY glBufferSubData (GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data)
/// ```
void glBufferSubData(int target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data) {
  final _glBufferSubData = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data),
      void Function(int target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data)>('glBufferSubData');
  return _glBufferSubData(target, offset, size, data);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferSubData (GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data)
/// ```
void glGetBufferSubData(int target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data) {
  final _glGetBufferSubData = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data),
      void Function(int target, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data)>('glGetBufferSubData');
  return _glGetBufferSubData(target, offset, size, data);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapBuffer (GLenum target, GLenum access)
/// ```
Pointer<Void>? glMapBuffer(int target, int access) {
  final _glMapBuffer = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 target, Uint32 access),
      Pointer<Void>? Function(int target, int access)>('glMapBuffer');
  return _glMapBuffer(target, access);
}

/// ```c
/// GLAPI GLboolean APIENTRY glUnmapBuffer (GLenum target)
/// ```
int glUnmapBuffer(int target) {
  final _glUnmapBuffer = _SDL2.lookupFunction<
      Int32 Function(Uint32 target),
      int Function(int target)>('glUnmapBuffer');
  return _glUnmapBuffer(target);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetBufferParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetBufferParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetBufferParameteriv');
  return _glGetBufferParameteriv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferPointerv (GLenum target, GLenum pname, GLvoid* *params)
/// ```
void glGetBufferPointerv(int target, int pname, Pointer<Pointer<Void>>? params) {
  final _glGetBufferPointerv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Pointer<Void>>? params),
      void Function(int target, int pname, Pointer<Pointer<Void>>? params)>('glGetBufferPointerv');
  return _glGetBufferPointerv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationSeparate (GLenum modeRGB, GLenum modeAlpha)
/// ```
void glBlendEquationSeparate(int modeRGB, int modeAlpha) {
  final _glBlendEquationSeparate = _SDL2.lookupFunction<
      Void Function(Uint32 modeRGB, Uint32 modeAlpha),
      void Function(int modeRGB, int modeAlpha)>('glBlendEquationSeparate');
  return _glBlendEquationSeparate(modeRGB, modeAlpha);
}

/// ```c
/// GLAPI void APIENTRY glDrawBuffers (GLsizei n, const GLenum *bufs)
/// ```
void glDrawBuffers(int n, Pointer<Uint32>? bufs) {
  final _glDrawBuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? bufs),
      void Function(int n, Pointer<Uint32>? bufs)>('glDrawBuffers');
  return _glDrawBuffers(n, bufs);
}

/// ```c
/// GLAPI void APIENTRY glStencilOpSeparate (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass)
/// ```
void glStencilOpSeparate(int face, int sfail, int dpfail, int dppass) {
  final _glStencilOpSeparate = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 sfail, Uint32 dpfail, Uint32 dppass),
      void Function(int face, int sfail, int dpfail, int dppass)>('glStencilOpSeparate');
  return _glStencilOpSeparate(face, sfail, dpfail, dppass);
}

/// ```c
/// GLAPI void APIENTRY glStencilFuncSeparate (GLenum face, GLenum func, GLint ref, GLuint mask)
/// ```
void glStencilFuncSeparate(int face, int func, int ref, int mask) {
  final _glStencilFuncSeparate = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 func, Int32 ref, Uint32 mask),
      void Function(int face, int func, int ref, int mask)>('glStencilFuncSeparate');
  return _glStencilFuncSeparate(face, func, ref, mask);
}

/// ```c
/// GLAPI void APIENTRY glStencilMaskSeparate (GLenum face, GLuint mask)
/// ```
void glStencilMaskSeparate(int face, int mask) {
  final _glStencilMaskSeparate = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 mask),
      void Function(int face, int mask)>('glStencilMaskSeparate');
  return _glStencilMaskSeparate(face, mask);
}

/// ```c
/// GLAPI void APIENTRY glAttachShader (GLuint program, GLuint shader)
/// ```
void glAttachShader(int program, int shader) {
  final _glAttachShader = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shader),
      void Function(int program, int shader)>('glAttachShader');
  return _glAttachShader(program, shader);
}

/// ```c
/// GLAPI void APIENTRY glBindAttribLocation (GLuint program, GLuint index, const GLchar *name)
/// ```
void glBindAttribLocation(int program, int index, String name) {
  final _glBindAttribLocation = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Pointer<Utf8>? name),
      void Function(int program, int index, Pointer<Utf8>? name)>('glBindAttribLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glBindAttribLocation(program, index, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glCompileShader (GLuint shader)
/// ```
void glCompileShader(int shader) {
  final _glCompileShader = _SDL2.lookupFunction<
      Void Function(Uint32 shader),
      void Function(int shader)>('glCompileShader');
  return _glCompileShader(shader);
}

/// ```c
/// GLAPI GLuint APIENTRY glCreateProgram (void)
/// ```
int glCreateProgram() {
  final _glCreateProgram = _SDL2.lookupFunction<
      Uint32 Function(),
      int Function()>('glCreateProgram');
  return _glCreateProgram();
}

/// ```c
/// GLAPI GLuint APIENTRY glCreateShader (GLenum type)
/// ```
int glCreateShader(int type) {
  final _glCreateShader = _SDL2.lookupFunction<
      Uint32 Function(Uint32 type),
      int Function(int type)>('glCreateShader');
  return _glCreateShader(type);
}

/// ```c
/// GLAPI void APIENTRY glDeleteProgram (GLuint program)
/// ```
void glDeleteProgram(int program) {
  final _glDeleteProgram = _SDL2.lookupFunction<
      Void Function(Uint32 program),
      void Function(int program)>('glDeleteProgram');
  return _glDeleteProgram(program);
}

/// ```c
/// GLAPI void APIENTRY glDeleteShader (GLuint shader)
/// ```
void glDeleteShader(int shader) {
  final _glDeleteShader = _SDL2.lookupFunction<
      Void Function(Uint32 shader),
      void Function(int shader)>('glDeleteShader');
  return _glDeleteShader(shader);
}

/// ```c
/// GLAPI void APIENTRY glDetachShader (GLuint program, GLuint shader)
/// ```
void glDetachShader(int program, int shader) {
  final _glDetachShader = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shader),
      void Function(int program, int shader)>('glDetachShader');
  return _glDetachShader(program, shader);
}

/// ```c
/// GLAPI void APIENTRY glDisableVertexAttribArray (GLuint index)
/// ```
void glDisableVertexAttribArray(int index) {
  final _glDisableVertexAttribArray = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glDisableVertexAttribArray');
  return _glDisableVertexAttribArray(index);
}

/// ```c
/// GLAPI void APIENTRY glEnableVertexAttribArray (GLuint index)
/// ```
void glEnableVertexAttribArray(int index) {
  final _glEnableVertexAttribArray = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glEnableVertexAttribArray');
  return _glEnableVertexAttribArray(index);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveAttrib (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
/// ```
void glGetActiveAttrib(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetActiveAttrib = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetActiveAttrib');
  return _glGetActiveAttrib(program, index, bufSize, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniform (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
/// ```
void glGetActiveUniform(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetActiveUniform = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetActiveUniform');
  return _glGetActiveUniform(program, index, bufSize, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glGetAttachedShaders (GLuint program, GLsizei maxCount, GLsizei *count, GLuint *obj)
/// ```
void glGetAttachedShaders(int program, int maxCount, Pointer<Uint32>? count, Pointer<Uint32>? obj) {
  final _glGetAttachedShaders = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 maxCount, Pointer<Uint32>? count, Pointer<Uint32>? obj),
      void Function(int program, int maxCount, Pointer<Uint32>? count, Pointer<Uint32>? obj)>('glGetAttachedShaders');
  return _glGetAttachedShaders(program, maxCount, count, obj);
}

/// ```c
/// GLAPI GLint APIENTRY glGetAttribLocation (GLuint program, const GLchar *name)
/// ```
int glGetAttribLocation(int program, String name) {
  final _glGetAttribLocation = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetAttribLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetAttribLocation(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetProgramiv (GLuint program, GLenum pname, GLint *params)
/// ```
void glGetProgramiv(int program, int pname, Pointer<Int32>? params) {
  final _glGetProgramiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 pname, Pointer<Int32>? params),
      void Function(int program, int pname, Pointer<Int32>? params)>('glGetProgramiv');
  return _glGetProgramiv(program, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramInfoLog (GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
/// ```
void glGetProgramInfoLog(int program, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog) {
  final _glGetProgramInfoLog = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog),
      void Function(int program, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog)>('glGetProgramInfoLog');
  return _glGetProgramInfoLog(program, bufSize, length, infoLog);
}

/// ```c
/// GLAPI void APIENTRY glGetShaderiv (GLuint shader, GLenum pname, GLint *params)
/// ```
void glGetShaderiv(int shader, int pname, Pointer<Int32>? params) {
  final _glGetShaderiv = _SDL2.lookupFunction<
      Void Function(Uint32 shader, Uint32 pname, Pointer<Int32>? params),
      void Function(int shader, int pname, Pointer<Int32>? params)>('glGetShaderiv');
  return _glGetShaderiv(shader, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetShaderInfoLog (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
/// ```
void glGetShaderInfoLog(int shader, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog) {
  final _glGetShaderInfoLog = _SDL2.lookupFunction<
      Void Function(Uint32 shader, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog),
      void Function(int shader, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog)>('glGetShaderInfoLog');
  return _glGetShaderInfoLog(shader, bufSize, length, infoLog);
}

/// ```c
/// GLAPI void APIENTRY glGetShaderSource (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source)
/// ```
void glGetShaderSource(int shader, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? source) {
  final _glGetShaderSource = _SDL2.lookupFunction<
      Void Function(Uint32 shader, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? source),
      void Function(int shader, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? source)>('glGetShaderSource');
  return _glGetShaderSource(shader, bufSize, length, source);
}

/// ```c
/// GLAPI GLint APIENTRY glGetUniformLocation (GLuint program, const GLchar *name)
/// ```
int glGetUniformLocation(int program, String name) {
  final _glGetUniformLocation = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetUniformLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetUniformLocation(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetUniformfv (GLuint program, GLint location, GLfloat *params)
/// ```
void glGetUniformfv(int program, int location, Pointer<Float>? params) {
  final _glGetUniformfv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Float>? params),
      void Function(int program, int location, Pointer<Float>? params)>('glGetUniformfv');
  return _glGetUniformfv(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformiv (GLuint program, GLint location, GLint *params)
/// ```
void glGetUniformiv(int program, int location, Pointer<Int32>? params) {
  final _glGetUniformiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Int32>? params),
      void Function(int program, int location, Pointer<Int32>? params)>('glGetUniformiv');
  return _glGetUniformiv(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribdv (GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetVertexAttribdv(int index, int pname, Pointer<Double>? params) {
  final _glGetVertexAttribdv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int index, int pname, Pointer<Double>? params)>('glGetVertexAttribdv');
  return _glGetVertexAttribdv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribfv (GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetVertexAttribfv(int index, int pname, Pointer<Float>? params) {
  final _glGetVertexAttribfv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int index, int pname, Pointer<Float>? params)>('glGetVertexAttribfv');
  return _glGetVertexAttribfv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribiv (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribiv(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribiv');
  return _glGetVertexAttribiv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribPointerv (GLuint index, GLenum pname, GLvoid* *pointer)
/// ```
void glGetVertexAttribPointerv(int index, int pname, Pointer<Pointer<Void>>? pointer) {
  final _glGetVertexAttribPointerv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Pointer<Void>>? pointer),
      void Function(int index, int pname, Pointer<Pointer<Void>>? pointer)>('glGetVertexAttribPointerv');
  return _glGetVertexAttribPointerv(index, pname, pointer);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsProgram (GLuint program)
/// ```
int glIsProgram(int program) {
  final _glIsProgram = _SDL2.lookupFunction<
      Int32 Function(Uint32 program),
      int Function(int program)>('glIsProgram');
  return _glIsProgram(program);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsShader (GLuint shader)
/// ```
int glIsShader(int shader) {
  final _glIsShader = _SDL2.lookupFunction<
      Int32 Function(Uint32 shader),
      int Function(int shader)>('glIsShader');
  return _glIsShader(shader);
}

/// ```c
/// GLAPI void APIENTRY glLinkProgram (GLuint program)
/// ```
void glLinkProgram(int program) {
  final _glLinkProgram = _SDL2.lookupFunction<
      Void Function(Uint32 program),
      void Function(int program)>('glLinkProgram');
  return _glLinkProgram(program);
}

/// ```c
/// GLAPI void APIENTRY glShaderSource (GLuint shader, GLsizei count, const GLchar* *string, const GLint *length)
/// ```
void glShaderSource(int shader, int count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length) {
  final _glShaderSource = _SDL2.lookupFunction<
      Void Function(Uint32 shader, Uint32 count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length),
      void Function(int shader, int count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length)>('glShaderSource');
  return _glShaderSource(shader, count, string, length);
}

/// ```c
/// GLAPI void APIENTRY glUseProgram (GLuint program)
/// ```
void glUseProgram(int program) {
  final _glUseProgram = _SDL2.lookupFunction<
      Void Function(Uint32 program),
      void Function(int program)>('glUseProgram');
  return _glUseProgram(program);
}

/// ```c
/// GLAPI void APIENTRY glUniform1f (GLint location, GLfloat v0)
/// ```
void glUniform1f(int location, double v0) {
  final _glUniform1f = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0),
      void Function(int location, double v0)>('glUniform1f');
  return _glUniform1f(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2f (GLint location, GLfloat v0, GLfloat v1)
/// ```
void glUniform2f(int location, double v0, double v1) {
  final _glUniform2f = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1),
      void Function(int location, double v0, double v1)>('glUniform2f');
  return _glUniform2f(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3f (GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
/// ```
void glUniform3f(int location, double v0, double v1, double v2) {
  final _glUniform3f = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1, Float v2),
      void Function(int location, double v0, double v1, double v2)>('glUniform3f');
  return _glUniform3f(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4f (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
/// ```
void glUniform4f(int location, double v0, double v1, double v2, double v3) {
  final _glUniform4f = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1, Float v2, Float v3),
      void Function(int location, double v0, double v1, double v2, double v3)>('glUniform4f');
  return _glUniform4f(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1i (GLint location, GLint v0)
/// ```
void glUniform1i(int location, int v0) {
  final _glUniform1i = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0),
      void Function(int location, int v0)>('glUniform1i');
  return _glUniform1i(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2i (GLint location, GLint v0, GLint v1)
/// ```
void glUniform2i(int location, int v0, int v1) {
  final _glUniform2i = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1),
      void Function(int location, int v0, int v1)>('glUniform2i');
  return _glUniform2i(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3i (GLint location, GLint v0, GLint v1, GLint v2)
/// ```
void glUniform3i(int location, int v0, int v1, int v2) {
  final _glUniform3i = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1, Int32 v2),
      void Function(int location, int v0, int v1, int v2)>('glUniform3i');
  return _glUniform3i(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4i (GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
/// ```
void glUniform4i(int location, int v0, int v1, int v2, int v3) {
  final _glUniform4i = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3),
      void Function(int location, int v0, int v1, int v2, int v3)>('glUniform4i');
  return _glUniform4i(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1fv (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform1fv(int location, int count, Pointer<Float>? value) {
  final _glUniform1fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform1fv');
  return _glUniform1fv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2fv (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform2fv(int location, int count, Pointer<Float>? value) {
  final _glUniform2fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform2fv');
  return _glUniform2fv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3fv (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform3fv(int location, int count, Pointer<Float>? value) {
  final _glUniform3fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform3fv');
  return _glUniform3fv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4fv (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform4fv(int location, int count, Pointer<Float>? value) {
  final _glUniform4fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform4fv');
  return _glUniform4fv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform1iv (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform1iv(int location, int count, Pointer<Int32>? value) {
  final _glUniform1iv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform1iv');
  return _glUniform1iv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2iv (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform2iv(int location, int count, Pointer<Int32>? value) {
  final _glUniform2iv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform2iv');
  return _glUniform2iv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3iv (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform3iv(int location, int count, Pointer<Int32>? value) {
  final _glUniform3iv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform3iv');
  return _glUniform3iv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4iv (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform4iv(int location, int count, Pointer<Int32>? value) {
  final _glUniform4iv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform4iv');
  return _glUniform4iv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix2fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix2fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix2fv');
  return _glUniformMatrix2fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix3fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix3fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix3fv');
  return _glUniformMatrix3fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix4fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix4fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix4fv');
  return _glUniformMatrix4fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glValidateProgram (GLuint program)
/// ```
void glValidateProgram(int program) {
  final _glValidateProgram = _SDL2.lookupFunction<
      Void Function(Uint32 program),
      void Function(int program)>('glValidateProgram');
  return _glValidateProgram(program);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1d (GLuint index, GLdouble x)
/// ```
void glVertexAttrib1d(int index, double x) {
  final _glVertexAttrib1d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x),
      void Function(int index, double x)>('glVertexAttrib1d');
  return _glVertexAttrib1d(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib1dv(int index, Pointer<Double>? v) {
  final _glVertexAttrib1dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib1dv');
  return _glVertexAttrib1dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1f (GLuint index, GLfloat x)
/// ```
void glVertexAttrib1f(int index, double x) {
  final _glVertexAttrib1f = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x),
      void Function(int index, double x)>('glVertexAttrib1f');
  return _glVertexAttrib1f(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1fv (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib1fv(int index, Pointer<Float>? v) {
  final _glVertexAttrib1fv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib1fv');
  return _glVertexAttrib1fv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1s (GLuint index, GLshort x)
/// ```
void glVertexAttrib1s(int index, int x) {
  final _glVertexAttrib1s = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x),
      void Function(int index, int x)>('glVertexAttrib1s');
  return _glVertexAttrib1s(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1sv (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib1sv(int index, Pointer<Int16>? v) {
  final _glVertexAttrib1sv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib1sv');
  return _glVertexAttrib1sv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2d (GLuint index, GLdouble x, GLdouble y)
/// ```
void glVertexAttrib2d(int index, double x, double y) {
  final _glVertexAttrib2d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y),
      void Function(int index, double x, double y)>('glVertexAttrib2d');
  return _glVertexAttrib2d(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib2dv(int index, Pointer<Double>? v) {
  final _glVertexAttrib2dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib2dv');
  return _glVertexAttrib2dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2f (GLuint index, GLfloat x, GLfloat y)
/// ```
void glVertexAttrib2f(int index, double x, double y) {
  final _glVertexAttrib2f = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y),
      void Function(int index, double x, double y)>('glVertexAttrib2f');
  return _glVertexAttrib2f(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2fv (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib2fv(int index, Pointer<Float>? v) {
  final _glVertexAttrib2fv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib2fv');
  return _glVertexAttrib2fv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2s (GLuint index, GLshort x, GLshort y)
/// ```
void glVertexAttrib2s(int index, int x, int y) {
  final _glVertexAttrib2s = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y),
      void Function(int index, int x, int y)>('glVertexAttrib2s');
  return _glVertexAttrib2s(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2sv (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib2sv(int index, Pointer<Int16>? v) {
  final _glVertexAttrib2sv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib2sv');
  return _glVertexAttrib2sv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3d (GLuint index, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexAttrib3d(int index, double x, double y, double z) {
  final _glVertexAttrib3d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3d');
  return _glVertexAttrib3d(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib3dv(int index, Pointer<Double>? v) {
  final _glVertexAttrib3dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib3dv');
  return _glVertexAttrib3dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3f (GLuint index, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glVertexAttrib3f(int index, double x, double y, double z) {
  final _glVertexAttrib3f = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3f');
  return _glVertexAttrib3f(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3fv (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib3fv(int index, Pointer<Float>? v) {
  final _glVertexAttrib3fv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib3fv');
  return _glVertexAttrib3fv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3s (GLuint index, GLshort x, GLshort y, GLshort z)
/// ```
void glVertexAttrib3s(int index, int x, int y, int z) {
  final _glVertexAttrib3s = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z),
      void Function(int index, int x, int y, int z)>('glVertexAttrib3s');
  return _glVertexAttrib3s(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3sv (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib3sv(int index, Pointer<Int16>? v) {
  final _glVertexAttrib3sv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib3sv');
  return _glVertexAttrib3sv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nbv (GLuint index, const GLbyte *v)
/// ```
void glVertexAttrib4Nbv(int index, String v) {
  final _glVertexAttrib4Nbv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttrib4Nbv');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttrib4Nbv(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Niv (GLuint index, const GLint *v)
/// ```
void glVertexAttrib4Niv(int index, Pointer<Int32>? v) {
  final _glVertexAttrib4Niv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttrib4Niv');
  return _glVertexAttrib4Niv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nsv (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib4Nsv(int index, Pointer<Int16>? v) {
  final _glVertexAttrib4Nsv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib4Nsv');
  return _glVertexAttrib4Nsv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nub (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
/// ```
void glVertexAttrib4Nub(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4Nub = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint8 x, Uint8 y, Uint8 z, Uint8 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4Nub');
  return _glVertexAttrib4Nub(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nubv (GLuint index, const GLubyte *v)
/// ```
void glVertexAttrib4Nubv(int index, Pointer<Uint8>? v) {
  final _glVertexAttrib4Nubv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttrib4Nubv');
  return _glVertexAttrib4Nubv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nuiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttrib4Nuiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttrib4Nuiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttrib4Nuiv');
  return _glVertexAttrib4Nuiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4Nusv (GLuint index, const GLushort *v)
/// ```
void glVertexAttrib4Nusv(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib4Nusv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib4Nusv');
  return _glVertexAttrib4Nusv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4bv (GLuint index, const GLbyte *v)
/// ```
void glVertexAttrib4bv(int index, String v) {
  final _glVertexAttrib4bv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttrib4bv');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttrib4bv(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4d (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexAttrib4d(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4d');
  return _glVertexAttrib4d(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib4dv(int index, Pointer<Double>? v) {
  final _glVertexAttrib4dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib4dv');
  return _glVertexAttrib4dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4f (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glVertexAttrib4f(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4f = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4f');
  return _glVertexAttrib4f(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4fv (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib4fv(int index, Pointer<Float>? v) {
  final _glVertexAttrib4fv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib4fv');
  return _glVertexAttrib4fv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4iv (GLuint index, const GLint *v)
/// ```
void glVertexAttrib4iv(int index, Pointer<Int32>? v) {
  final _glVertexAttrib4iv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttrib4iv');
  return _glVertexAttrib4iv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4s (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
/// ```
void glVertexAttrib4s(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4s = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z, Int16 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4s');
  return _glVertexAttrib4s(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4sv (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib4sv(int index, Pointer<Int16>? v) {
  final _glVertexAttrib4sv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib4sv');
  return _glVertexAttrib4sv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4ubv (GLuint index, const GLubyte *v)
/// ```
void glVertexAttrib4ubv(int index, Pointer<Uint8>? v) {
  final _glVertexAttrib4ubv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttrib4ubv');
  return _glVertexAttrib4ubv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4uiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttrib4uiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttrib4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttrib4uiv');
  return _glVertexAttrib4uiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4usv (GLuint index, const GLushort *v)
/// ```
void glVertexAttrib4usv(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib4usv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib4usv');
  return _glVertexAttrib4usv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribPointer (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribPointer(int index, int size, int type, int normalized, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribPointer = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Int32 normalized, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int normalized, int stride, Pointer<Void>? pointer)>('glVertexAttribPointer');
  return _glVertexAttribPointer(index, size, type, normalized, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2x3fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix2x3fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix2x3fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix2x3fv');
  return _glUniformMatrix2x3fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3x2fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix3x2fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix3x2fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix3x2fv');
  return _glUniformMatrix3x2fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2x4fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix2x4fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix2x4fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix2x4fv');
  return _glUniformMatrix2x4fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4x2fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix4x2fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix4x2fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix4x2fv');
  return _glUniformMatrix4x2fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3x4fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix3x4fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix3x4fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix3x4fv');
  return _glUniformMatrix3x4fv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4x3fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix4x3fv(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix4x3fv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix4x3fv');
  return _glUniformMatrix4x3fv(location, count, transpose, value);
}

/// ARB_vertex_array_object
/// ```c
/// GLAPI void APIENTRY glColorMaski (GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
/// ```
void glColorMaski(int index, int r, int g, int b, int a) {
  final _glColorMaski = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 r, Int32 g, Int32 b, Int32 a),
      void Function(int index, int r, int g, int b, int a)>('glColorMaski');
  return _glColorMaski(index, r, g, b, a);
}

/// ```c
/// GLAPI void APIENTRY glGetBooleani_v (GLenum target, GLuint index, GLboolean *data)
/// ```
void glGetBooleani_v(int target, int index, Pointer<Int32>? data) {
  final _glGetBooleani_v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? data),
      void Function(int target, int index, Pointer<Int32>? data)>('glGetBooleani_v');
  return _glGetBooleani_v(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetIntegeri_v (GLenum target, GLuint index, GLint *data)
/// ```
void glGetIntegeri_v(int target, int index, Pointer<Int32>? data) {
  final _glGetIntegeri_v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? data),
      void Function(int target, int index, Pointer<Int32>? data)>('glGetIntegeri_v');
  return _glGetIntegeri_v(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glEnablei (GLenum target, GLuint index)
/// ```
void glEnablei(int target, int index) {
  final _glEnablei = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index),
      void Function(int target, int index)>('glEnablei');
  return _glEnablei(target, index);
}

/// ```c
/// GLAPI void APIENTRY glDisablei (GLenum target, GLuint index)
/// ```
void glDisablei(int target, int index) {
  final _glDisablei = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index),
      void Function(int target, int index)>('glDisablei');
  return _glDisablei(target, index);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsEnabledi (GLenum target, GLuint index)
/// ```
int glIsEnabledi(int target, int index) {
  final _glIsEnabledi = _SDL2.lookupFunction<
      Int32 Function(Uint32 target, Uint32 index),
      int Function(int target, int index)>('glIsEnabledi');
  return _glIsEnabledi(target, index);
}

/// ```c
/// GLAPI void APIENTRY glBeginTransformFeedback (GLenum primitiveMode)
/// ```
void glBeginTransformFeedback(int primitiveMode) {
  final _glBeginTransformFeedback = _SDL2.lookupFunction<
      Void Function(Uint32 primitiveMode),
      void Function(int primitiveMode)>('glBeginTransformFeedback');
  return _glBeginTransformFeedback(primitiveMode);
}

/// ```c
/// GLAPI void APIENTRY glEndTransformFeedback (void)
/// ```
void glEndTransformFeedback() {
  final _glEndTransformFeedback = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndTransformFeedback');
  return _glEndTransformFeedback();
}

/// ```c
/// GLAPI void APIENTRY glBindBufferRange (GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
/// ```
void glBindBufferRange(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size) {
  final _glBindBufferRange = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? size),
      void Function(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size)>('glBindBufferRange');
  return _glBindBufferRange(target, index, buffer, offset, size);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferBase (GLenum target, GLuint index, GLuint buffer)
/// ```
void glBindBufferBase(int target, int index, int buffer) {
  final _glBindBufferBase = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer),
      void Function(int target, int index, int buffer)>('glBindBufferBase');
  return _glBindBufferBase(target, index, buffer);
}

/// ```c
/// GLAPI void APIENTRY glTransformFeedbackVaryings (GLuint program, GLsizei count, const GLchar* *varyings, GLenum bufferMode)
/// ```
void glTransformFeedbackVaryings(int program, int count, Pointer<Pointer<Int8>>? varyings, int bufferMode) {
  final _glTransformFeedbackVaryings = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 count, Pointer<Pointer<Int8>>? varyings, Uint32 bufferMode),
      void Function(int program, int count, Pointer<Pointer<Int8>>? varyings, int bufferMode)>('glTransformFeedbackVaryings');
  return _glTransformFeedbackVaryings(program, count, varyings, bufferMode);
}

/// ```c
/// GLAPI void APIENTRY glGetTransformFeedbackVarying (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
/// ```
void glGetTransformFeedbackVarying(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetTransformFeedbackVarying = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetTransformFeedbackVarying');
  return _glGetTransformFeedbackVarying(program, index, bufSize, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glClampColor (GLenum target, GLenum clamp)
/// ```
void glClampColor(int target, int clamp) {
  final _glClampColor = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 clamp),
      void Function(int target, int clamp)>('glClampColor');
  return _glClampColor(target, clamp);
}

/// ```c
/// GLAPI void APIENTRY glBeginConditionalRender (GLuint id, GLenum mode)
/// ```
void glBeginConditionalRender(int id, int mode) {
  final _glBeginConditionalRender = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 mode),
      void Function(int id, int mode)>('glBeginConditionalRender');
  return _glBeginConditionalRender(id, mode);
}

/// ```c
/// GLAPI void APIENTRY glEndConditionalRender (void)
/// ```
void glEndConditionalRender() {
  final _glEndConditionalRender = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndConditionalRender');
  return _glEndConditionalRender();
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribIPointer (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribIPointer(int index, int size, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribIPointer = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int stride, Pointer<Void>? pointer)>('glVertexAttribIPointer');
  return _glVertexAttribIPointer(index, size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribIiv (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribIiv(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribIiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribIiv');
  return _glGetVertexAttribIiv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribIuiv (GLuint index, GLenum pname, GLuint *params)
/// ```
void glGetVertexAttribIuiv(int index, int pname, Pointer<Uint32>? params) {
  final _glGetVertexAttribIuiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Uint32>? params),
      void Function(int index, int pname, Pointer<Uint32>? params)>('glGetVertexAttribIuiv');
  return _glGetVertexAttribIuiv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1i (GLuint index, GLint x)
/// ```
void glVertexAttribI1i(int index, int x) {
  final _glVertexAttribI1i = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x),
      void Function(int index, int x)>('glVertexAttribI1i');
  return _glVertexAttribI1i(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2i (GLuint index, GLint x, GLint y)
/// ```
void glVertexAttribI2i(int index, int x, int y) {
  final _glVertexAttribI2i = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y),
      void Function(int index, int x, int y)>('glVertexAttribI2i');
  return _glVertexAttribI2i(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3i (GLuint index, GLint x, GLint y, GLint z)
/// ```
void glVertexAttribI3i(int index, int x, int y, int z) {
  final _glVertexAttribI3i = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y, Int32 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribI3i');
  return _glVertexAttribI3i(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4i (GLuint index, GLint x, GLint y, GLint z, GLint w)
/// ```
void glVertexAttribI4i(int index, int x, int y, int z, int w) {
  final _glVertexAttribI4i = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribI4i');
  return _glVertexAttribI4i(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1ui (GLuint index, GLuint x)
/// ```
void glVertexAttribI1ui(int index, int x) {
  final _glVertexAttribI1ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x),
      void Function(int index, int x)>('glVertexAttribI1ui');
  return _glVertexAttribI1ui(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2ui (GLuint index, GLuint x, GLuint y)
/// ```
void glVertexAttribI2ui(int index, int x, int y) {
  final _glVertexAttribI2ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y),
      void Function(int index, int x, int y)>('glVertexAttribI2ui');
  return _glVertexAttribI2ui(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3ui (GLuint index, GLuint x, GLuint y, GLuint z)
/// ```
void glVertexAttribI3ui(int index, int x, int y, int z) {
  final _glVertexAttribI3ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y, Uint32 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribI3ui');
  return _glVertexAttribI3ui(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4ui (GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
/// ```
void glVertexAttribI4ui(int index, int x, int y, int z, int w) {
  final _glVertexAttribI4ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y, Uint32 z, Uint32 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribI4ui');
  return _glVertexAttribI4ui(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1iv (GLuint index, const GLint *v)
/// ```
void glVertexAttribI1iv(int index, Pointer<Int32>? v) {
  final _glVertexAttribI1iv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI1iv');
  return _glVertexAttribI1iv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2iv (GLuint index, const GLint *v)
/// ```
void glVertexAttribI2iv(int index, Pointer<Int32>? v) {
  final _glVertexAttribI2iv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI2iv');
  return _glVertexAttribI2iv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3iv (GLuint index, const GLint *v)
/// ```
void glVertexAttribI3iv(int index, Pointer<Int32>? v) {
  final _glVertexAttribI3iv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI3iv');
  return _glVertexAttribI3iv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4iv (GLuint index, const GLint *v)
/// ```
void glVertexAttribI4iv(int index, Pointer<Int32>? v) {
  final _glVertexAttribI4iv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI4iv');
  return _glVertexAttribI4iv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1uiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI1uiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI1uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI1uiv');
  return _glVertexAttribI1uiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2uiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI2uiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI2uiv');
  return _glVertexAttribI2uiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3uiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI3uiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI3uiv');
  return _glVertexAttribI3uiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4uiv (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI4uiv(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI4uiv');
  return _glVertexAttribI4uiv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4bv (GLuint index, const GLbyte *v)
/// ```
void glVertexAttribI4bv(int index, String v) {
  final _glVertexAttribI4bv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttribI4bv');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttribI4bv(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4sv (GLuint index, const GLshort *v)
/// ```
void glVertexAttribI4sv(int index, Pointer<Int16>? v) {
  final _glVertexAttribI4sv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttribI4sv');
  return _glVertexAttribI4sv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4ubv (GLuint index, const GLubyte *v)
/// ```
void glVertexAttribI4ubv(int index, Pointer<Uint8>? v) {
  final _glVertexAttribI4ubv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttribI4ubv');
  return _glVertexAttribI4ubv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4usv (GLuint index, const GLushort *v)
/// ```
void glVertexAttribI4usv(int index, Pointer<Uint16>? v) {
  final _glVertexAttribI4usv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttribI4usv');
  return _glVertexAttribI4usv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformuiv (GLuint program, GLint location, GLuint *params)
/// ```
void glGetUniformuiv(int program, int location, Pointer<Uint32>? params) {
  final _glGetUniformuiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Uint32>? params),
      void Function(int program, int location, Pointer<Uint32>? params)>('glGetUniformuiv');
  return _glGetUniformuiv(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glBindFragDataLocation (GLuint program, GLuint color, const GLchar *name)
/// ```
void glBindFragDataLocation(int program, int color, String name) {
  final _glBindFragDataLocation = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 color, Pointer<Utf8>? name),
      void Function(int program, int color, Pointer<Utf8>? name)>('glBindFragDataLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glBindFragDataLocation(program, color, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI GLint APIENTRY glGetFragDataLocation (GLuint program, const GLchar *name)
/// ```
int glGetFragDataLocation(int program, String name) {
  final _glGetFragDataLocation = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetFragDataLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetFragDataLocation(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glUniform1ui (GLint location, GLuint v0)
/// ```
void glUniform1ui(int location, int v0) {
  final _glUniform1ui = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0),
      void Function(int location, int v0)>('glUniform1ui');
  return _glUniform1ui(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2ui (GLint location, GLuint v0, GLuint v1)
/// ```
void glUniform2ui(int location, int v0, int v1) {
  final _glUniform2ui = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1),
      void Function(int location, int v0, int v1)>('glUniform2ui');
  return _glUniform2ui(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3ui (GLint location, GLuint v0, GLuint v1, GLuint v2)
/// ```
void glUniform3ui(int location, int v0, int v1, int v2) {
  final _glUniform3ui = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1, Uint32 v2),
      void Function(int location, int v0, int v1, int v2)>('glUniform3ui');
  return _glUniform3ui(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4ui (GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
/// ```
void glUniform4ui(int location, int v0, int v1, int v2, int v3) {
  final _glUniform4ui = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1, Uint32 v2, Uint32 v3),
      void Function(int location, int v0, int v1, int v2, int v3)>('glUniform4ui');
  return _glUniform4ui(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1uiv (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform1uiv(int location, int count, Pointer<Uint32>? value) {
  final _glUniform1uiv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform1uiv');
  return _glUniform1uiv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2uiv (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform2uiv(int location, int count, Pointer<Uint32>? value) {
  final _glUniform2uiv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform2uiv');
  return _glUniform2uiv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3uiv (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform3uiv(int location, int count, Pointer<Uint32>? value) {
  final _glUniform3uiv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform3uiv');
  return _glUniform3uiv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4uiv (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform4uiv(int location, int count, Pointer<Uint32>? value) {
  final _glUniform4uiv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform4uiv');
  return _glUniform4uiv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glTexParameterIiv (GLenum target, GLenum pname, const GLint *params)
/// ```
void glTexParameterIiv(int target, int pname, Pointer<Int32>? params) {
  final _glTexParameterIiv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glTexParameterIiv');
  return _glTexParameterIiv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTexParameterIuiv (GLenum target, GLenum pname, const GLuint *params)
/// ```
void glTexParameterIuiv(int target, int pname, Pointer<Uint32>? params) {
  final _glTexParameterIuiv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int target, int pname, Pointer<Uint32>? params)>('glTexParameterIuiv');
  return _glTexParameterIuiv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTexParameterIiv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetTexParameterIiv(int target, int pname, Pointer<Int32>? params) {
  final _glGetTexParameterIiv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetTexParameterIiv');
  return _glGetTexParameterIiv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTexParameterIuiv (GLenum target, GLenum pname, GLuint *params)
/// ```
void glGetTexParameterIuiv(int target, int pname, Pointer<Uint32>? params) {
  final _glGetTexParameterIuiv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int target, int pname, Pointer<Uint32>? params)>('glGetTexParameterIuiv');
  return _glGetTexParameterIuiv(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glClearBufferiv (GLenum buffer, GLint drawbuffer, const GLint *value)
/// ```
void glClearBufferiv(int buffer, int drawbuffer, Pointer<Int32>? value) {
  final _glClearBufferiv = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Int32 drawbuffer, Pointer<Int32>? value),
      void Function(int buffer, int drawbuffer, Pointer<Int32>? value)>('glClearBufferiv');
  return _glClearBufferiv(buffer, drawbuffer, value);
}

/// ```c
/// GLAPI void APIENTRY glClearBufferuiv (GLenum buffer, GLint drawbuffer, const GLuint *value)
/// ```
void glClearBufferuiv(int buffer, int drawbuffer, Pointer<Uint32>? value) {
  final _glClearBufferuiv = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Int32 drawbuffer, Pointer<Uint32>? value),
      void Function(int buffer, int drawbuffer, Pointer<Uint32>? value)>('glClearBufferuiv');
  return _glClearBufferuiv(buffer, drawbuffer, value);
}

/// ```c
/// GLAPI void APIENTRY glClearBufferfv (GLenum buffer, GLint drawbuffer, const GLfloat *value)
/// ```
void glClearBufferfv(int buffer, int drawbuffer, Pointer<Float>? value) {
  final _glClearBufferfv = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Int32 drawbuffer, Pointer<Float>? value),
      void Function(int buffer, int drawbuffer, Pointer<Float>? value)>('glClearBufferfv');
  return _glClearBufferfv(buffer, drawbuffer, value);
}

/// ```c
/// GLAPI void APIENTRY glClearBufferfi (GLenum buffer, GLint drawbuffer, GLfloat depth, GLint stencil)
/// ```
void glClearBufferfi(int buffer, int drawbuffer, double depth, int stencil) {
  final _glClearBufferfi = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Int32 drawbuffer, Float depth, Int32 stencil),
      void Function(int buffer, int drawbuffer, double depth, int stencil)>('glClearBufferfi');
  return _glClearBufferfi(buffer, drawbuffer, depth, stencil);
}

/// ```c
/// GLAPI const GLubyte * APIENTRY glGetStringi (GLenum name, GLuint index)
/// ```
Pointer<Uint8>? glGetStringi(int name, int index) {
  final _glGetStringi = _SDL2.lookupFunction<
      Pointer<Uint8>? Function(Uint32 name, Uint32 index),
      Pointer<Uint8>? Function(int name, int index)>('glGetStringi');
  return _glGetStringi(name, index);
}

/// ARB_uniform_buffer_object
/// ```c
/// GLAPI void APIENTRY glDrawArraysInstanced (GLenum mode, GLint first, GLsizei count, GLsizei primcount)
/// ```
void glDrawArraysInstanced(int mode, int first, int count, int primcount) {
  final _glDrawArraysInstanced = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 first, Uint32 count, Uint32 primcount),
      void Function(int mode, int first, int count, int primcount)>('glDrawArraysInstanced');
  return _glDrawArraysInstanced(mode, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsInstanced (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
/// ```
void glDrawElementsInstanced(int mode, int count, int type, Pointer<Void>? indices, int primcount) {
  final _glDrawElementsInstanced = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count, Uint32 type, Pointer<Void>? indices, Uint32 primcount),
      void Function(int mode, int count, int type, Pointer<Void>? indices, int primcount)>('glDrawElementsInstanced');
  return _glDrawElementsInstanced(mode, count, type, indices, primcount);
}

/// ```c
/// GLAPI void APIENTRY glTexBuffer (GLenum target, GLenum internalformat, GLuint buffer)
/// ```
void glTexBuffer(int target, int internalformat, int buffer) {
  final _glTexBuffer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 buffer),
      void Function(int target, int internalformat, int buffer)>('glTexBuffer');
  return _glTexBuffer(target, internalformat, buffer);
}

/// ```c
/// GLAPI void APIENTRY glPrimitiveRestartIndex (GLuint index)
/// ```
void glPrimitiveRestartIndex(int index) {
  final _glPrimitiveRestartIndex = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glPrimitiveRestartIndex');
  return _glPrimitiveRestartIndex(index);
}

/// ARB_texture_multisample
/// ```c
/// GLAPI void APIENTRY glGetInteger64i_v (GLenum target, GLuint index, GLint64 *data)
/// ```
void glGetInteger64i_v(int target, int index, Pointer<Int64>? data) {
  final _glGetInteger64i_v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int64>? data),
      void Function(int target, int index, Pointer<Int64>? data)>('glGetInteger64i_v');
  return _glGetInteger64i_v(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferParameteri64v (GLenum target, GLenum pname, GLint64 *params)
/// ```
void glGetBufferParameteri64v(int target, int pname, Pointer<Int64>? params) {
  final _glGetBufferParameteri64v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int64>? params),
      void Function(int target, int pname, Pointer<Int64>? params)>('glGetBufferParameteri64v');
  return _glGetBufferParameteri64v(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture (GLenum target, GLenum attachment, GLuint texture, GLint level)
/// ```
void glFramebufferTexture(int target, int attachment, int texture, int level) {
  final _glFramebufferTexture = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int texture, int level)>('glFramebufferTexture');
  return _glFramebufferTexture(target, attachment, texture, level);
}

/// ARB_vertex_type_2_10_10_10_rev
/// ```c
/// GLAPI void APIENTRY glVertexAttribDivisor (GLuint index, GLuint divisor)
/// ```
void glVertexAttribDivisor(int index, int divisor) {
  final _glVertexAttribDivisor = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 divisor),
      void Function(int index, int divisor)>('glVertexAttribDivisor');
  return _glVertexAttribDivisor(index, divisor);
}

/// ARB_transform_feedback3
/// ```c
/// GLAPI void APIENTRY glMinSampleShading (GLclampf value)
/// ```
void glMinSampleShading(double value) {
  final _glMinSampleShading = _SDL2.lookupFunction<
      Void Function(Float value),
      void Function(double value)>('glMinSampleShading');
  return _glMinSampleShading(value);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationi (GLuint buf, GLenum mode)
/// ```
void glBlendEquationi(int buf, int mode) {
  final _glBlendEquationi = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 mode),
      void Function(int buf, int mode)>('glBlendEquationi');
  return _glBlendEquationi(buf, mode);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationSeparatei (GLuint buf, GLenum modeRGB, GLenum modeAlpha)
/// ```
void glBlendEquationSeparatei(int buf, int modeRGB, int modeAlpha) {
  final _glBlendEquationSeparatei = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 modeRGB, Uint32 modeAlpha),
      void Function(int buf, int modeRGB, int modeAlpha)>('glBlendEquationSeparatei');
  return _glBlendEquationSeparatei(buf, modeRGB, modeAlpha);
}

/// ```c
/// GLAPI void APIENTRY glBlendFunci (GLuint buf, GLenum src, GLenum dst)
/// ```
void glBlendFunci(int buf, int src, int dst) {
  final _glBlendFunci = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 src, Uint32 dst),
      void Function(int buf, int src, int dst)>('glBlendFunci');
  return _glBlendFunci(buf, src, dst);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparatei (GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
/// ```
void glBlendFuncSeparatei(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha) {
  final _glBlendFuncSeparatei = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 srcRGB, Uint32 dstRGB, Uint32 srcAlpha, Uint32 dstAlpha),
      void Function(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha)>('glBlendFuncSeparatei');
  return _glBlendFuncSeparatei(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
}

/// ARB_viewport_array
/// ```c
/// GLAPI void APIENTRY glActiveTextureARB (GLenum texture)
/// ```
void glActiveTextureARB(int texture) {
  final _glActiveTextureARB = _SDL2.lookupFunction<
      Void Function(Uint32 texture),
      void Function(int texture)>('glActiveTextureARB');
  return _glActiveTextureARB(texture);
}

/// ```c
/// GLAPI void APIENTRY glClientActiveTextureARB (GLenum texture)
/// ```
void glClientActiveTextureARB(int texture) {
  final _glClientActiveTextureARB = _SDL2.lookupFunction<
      Void Function(Uint32 texture),
      void Function(int texture)>('glClientActiveTextureARB');
  return _glClientActiveTextureARB(texture);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1dARB (GLenum target, GLdouble s)
/// ```
void glMultiTexCoord1dARB(int target, double s) {
  final _glMultiTexCoord1dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s),
      void Function(int target, double s)>('glMultiTexCoord1dARB');
  return _glMultiTexCoord1dARB(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1dvARB (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord1dvARB(int target, Pointer<Double>? v) {
  final _glMultiTexCoord1dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord1dvARB');
  return _glMultiTexCoord1dvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1fARB (GLenum target, GLfloat s)
/// ```
void glMultiTexCoord1fARB(int target, double s) {
  final _glMultiTexCoord1fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s),
      void Function(int target, double s)>('glMultiTexCoord1fARB');
  return _glMultiTexCoord1fARB(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1fvARB (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord1fvARB(int target, Pointer<Float>? v) {
  final _glMultiTexCoord1fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord1fvARB');
  return _glMultiTexCoord1fvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1iARB (GLenum target, GLint s)
/// ```
void glMultiTexCoord1iARB(int target, int s) {
  final _glMultiTexCoord1iARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s),
      void Function(int target, int s)>('glMultiTexCoord1iARB');
  return _glMultiTexCoord1iARB(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1ivARB (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord1ivARB(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord1ivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord1ivARB');
  return _glMultiTexCoord1ivARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1sARB (GLenum target, GLshort s)
/// ```
void glMultiTexCoord1sARB(int target, int s) {
  final _glMultiTexCoord1sARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s),
      void Function(int target, int s)>('glMultiTexCoord1sARB');
  return _glMultiTexCoord1sARB(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1svARB (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord1svARB(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord1svARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord1svARB');
  return _glMultiTexCoord1svARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2dARB (GLenum target, GLdouble s, GLdouble t)
/// ```
void glMultiTexCoord2dARB(int target, double s, double t) {
  final _glMultiTexCoord2dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t),
      void Function(int target, double s, double t)>('glMultiTexCoord2dARB');
  return _glMultiTexCoord2dARB(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2dvARB (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord2dvARB(int target, Pointer<Double>? v) {
  final _glMultiTexCoord2dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord2dvARB');
  return _glMultiTexCoord2dvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2fARB (GLenum target, GLfloat s, GLfloat t)
/// ```
void glMultiTexCoord2fARB(int target, double s, double t) {
  final _glMultiTexCoord2fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t),
      void Function(int target, double s, double t)>('glMultiTexCoord2fARB');
  return _glMultiTexCoord2fARB(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2fvARB (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord2fvARB(int target, Pointer<Float>? v) {
  final _glMultiTexCoord2fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord2fvARB');
  return _glMultiTexCoord2fvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2iARB (GLenum target, GLint s, GLint t)
/// ```
void glMultiTexCoord2iARB(int target, int s, int t) {
  final _glMultiTexCoord2iARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t),
      void Function(int target, int s, int t)>('glMultiTexCoord2iARB');
  return _glMultiTexCoord2iARB(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2ivARB (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord2ivARB(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord2ivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord2ivARB');
  return _glMultiTexCoord2ivARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2sARB (GLenum target, GLshort s, GLshort t)
/// ```
void glMultiTexCoord2sARB(int target, int s, int t) {
  final _glMultiTexCoord2sARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t),
      void Function(int target, int s, int t)>('glMultiTexCoord2sARB');
  return _glMultiTexCoord2sARB(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2svARB (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord2svARB(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord2svARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord2svARB');
  return _glMultiTexCoord2svARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3dARB (GLenum target, GLdouble s, GLdouble t, GLdouble r)
/// ```
void glMultiTexCoord3dARB(int target, double s, double t, double r) {
  final _glMultiTexCoord3dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t, Double r),
      void Function(int target, double s, double t, double r)>('glMultiTexCoord3dARB');
  return _glMultiTexCoord3dARB(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3dvARB (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord3dvARB(int target, Pointer<Double>? v) {
  final _glMultiTexCoord3dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord3dvARB');
  return _glMultiTexCoord3dvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3fARB (GLenum target, GLfloat s, GLfloat t, GLfloat r)
/// ```
void glMultiTexCoord3fARB(int target, double s, double t, double r) {
  final _glMultiTexCoord3fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t, Float r),
      void Function(int target, double s, double t, double r)>('glMultiTexCoord3fARB');
  return _glMultiTexCoord3fARB(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3fvARB (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord3fvARB(int target, Pointer<Float>? v) {
  final _glMultiTexCoord3fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord3fvARB');
  return _glMultiTexCoord3fvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3iARB (GLenum target, GLint s, GLint t, GLint r)
/// ```
void glMultiTexCoord3iARB(int target, int s, int t, int r) {
  final _glMultiTexCoord3iARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t, Int32 r),
      void Function(int target, int s, int t, int r)>('glMultiTexCoord3iARB');
  return _glMultiTexCoord3iARB(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3ivARB (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord3ivARB(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord3ivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord3ivARB');
  return _glMultiTexCoord3ivARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3sARB (GLenum target, GLshort s, GLshort t, GLshort r)
/// ```
void glMultiTexCoord3sARB(int target, int s, int t, int r) {
  final _glMultiTexCoord3sARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t, Int16 r),
      void Function(int target, int s, int t, int r)>('glMultiTexCoord3sARB');
  return _glMultiTexCoord3sARB(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3svARB (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord3svARB(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord3svARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord3svARB');
  return _glMultiTexCoord3svARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4dARB (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
/// ```
void glMultiTexCoord4dARB(int target, double s, double t, double r, double q) {
  final _glMultiTexCoord4dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double s, Double t, Double r, Double q),
      void Function(int target, double s, double t, double r, double q)>('glMultiTexCoord4dARB');
  return _glMultiTexCoord4dARB(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4dvARB (GLenum target, const GLdouble *v)
/// ```
void glMultiTexCoord4dvARB(int target, Pointer<Double>? v) {
  final _glMultiTexCoord4dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Double>? v),
      void Function(int target, Pointer<Double>? v)>('glMultiTexCoord4dvARB');
  return _glMultiTexCoord4dvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4fARB (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
/// ```
void glMultiTexCoord4fARB(int target, double s, double t, double r, double q) {
  final _glMultiTexCoord4fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float s, Float t, Float r, Float q),
      void Function(int target, double s, double t, double r, double q)>('glMultiTexCoord4fARB');
  return _glMultiTexCoord4fARB(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4fvARB (GLenum target, const GLfloat *v)
/// ```
void glMultiTexCoord4fvARB(int target, Pointer<Float>? v) {
  final _glMultiTexCoord4fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? v),
      void Function(int target, Pointer<Float>? v)>('glMultiTexCoord4fvARB');
  return _glMultiTexCoord4fvARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4iARB (GLenum target, GLint s, GLint t, GLint r, GLint q)
/// ```
void glMultiTexCoord4iARB(int target, int s, int t, int r, int q) {
  final _glMultiTexCoord4iARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 s, Int32 t, Int32 r, Int32 q),
      void Function(int target, int s, int t, int r, int q)>('glMultiTexCoord4iARB');
  return _glMultiTexCoord4iARB(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4ivARB (GLenum target, const GLint *v)
/// ```
void glMultiTexCoord4ivARB(int target, Pointer<Int32>? v) {
  final _glMultiTexCoord4ivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int32>? v),
      void Function(int target, Pointer<Int32>? v)>('glMultiTexCoord4ivARB');
  return _glMultiTexCoord4ivARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4sARB (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q)
/// ```
void glMultiTexCoord4sARB(int target, int s, int t, int r, int q) {
  final _glMultiTexCoord4sARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int16 s, Int16 t, Int16 r, Int16 q),
      void Function(int target, int s, int t, int r, int q)>('glMultiTexCoord4sARB');
  return _glMultiTexCoord4sARB(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4svARB (GLenum target, const GLshort *v)
/// ```
void glMultiTexCoord4svARB(int target, Pointer<Int16>? v) {
  final _glMultiTexCoord4svARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Int16>? v),
      void Function(int target, Pointer<Int16>? v)>('glMultiTexCoord4svARB');
  return _glMultiTexCoord4svARB(target, v);
}

/// ```c
/// GLAPI void APIENTRY glLoadTransposeMatrixfARB (const GLfloat *m)
/// ```
void glLoadTransposeMatrixfARB(Pointer<Float>? m) {
  final _glLoadTransposeMatrixfARB = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? m),
      void Function(Pointer<Float>? m)>('glLoadTransposeMatrixfARB');
  return _glLoadTransposeMatrixfARB(m);
}

/// ```c
/// GLAPI void APIENTRY glLoadTransposeMatrixdARB (const GLdouble *m)
/// ```
void glLoadTransposeMatrixdARB(Pointer<Double>? m) {
  final _glLoadTransposeMatrixdARB = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? m),
      void Function(Pointer<Double>? m)>('glLoadTransposeMatrixdARB');
  return _glLoadTransposeMatrixdARB(m);
}

/// ```c
/// GLAPI void APIENTRY glMultTransposeMatrixfARB (const GLfloat *m)
/// ```
void glMultTransposeMatrixfARB(Pointer<Float>? m) {
  final _glMultTransposeMatrixfARB = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? m),
      void Function(Pointer<Float>? m)>('glMultTransposeMatrixfARB');
  return _glMultTransposeMatrixfARB(m);
}

/// ```c
/// GLAPI void APIENTRY glMultTransposeMatrixdARB (const GLdouble *m)
/// ```
void glMultTransposeMatrixdARB(Pointer<Double>? m) {
  final _glMultTransposeMatrixdARB = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? m),
      void Function(Pointer<Double>? m)>('glMultTransposeMatrixdARB');
  return _glMultTransposeMatrixdARB(m);
}

/// ```c
/// GLAPI void APIENTRY glSampleCoverageARB (GLclampf value, GLboolean invert)
/// ```
void glSampleCoverageARB(double value, int invert) {
  final _glSampleCoverageARB = _SDL2.lookupFunction<
      Void Function(Float value, Int32 invert),
      void Function(double value, int invert)>('glSampleCoverageARB');
  return _glSampleCoverageARB(value, invert);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage3DARB (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage3DARB(int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage3DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage3DARB');
  return _glCompressedTexImage3DARB(target, level, internalformat, width, height, depth, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage2DARB (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage2DARB(int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage2DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage2DARB');
  return _glCompressedTexImage2DARB(target, level, internalformat, width, height, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexImage1DARB (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexImage1DARB(int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexImage1DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? data)>('glCompressedTexImage1DARB');
  return _glCompressedTexImage1DARB(target, level, internalformat, width, border, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage3DARB (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage3DARB(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage3DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage3DARB');
  return _glCompressedTexSubImage3DARB(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage2DARB (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage2DARB(int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage2DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage2DARB');
  return _glCompressedTexSubImage2DARB(target, level, xoffset, yoffset, width, height, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTexSubImage1DARB (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data)
/// ```
void glCompressedTexSubImage1DARB(int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? data) {
  final _glCompressedTexSubImage1DARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 imageSize, Pointer<Void>? data),
      void Function(int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? data)>('glCompressedTexSubImage1DARB');
  return _glCompressedTexSubImage1DARB(target, level, xoffset, width, format, imageSize, data);
}

/// ```c
/// GLAPI void APIENTRY glGetCompressedTexImageARB (GLenum target, GLint level, GLvoid *img)
/// ```
void glGetCompressedTexImageARB(int target, int level, Pointer<Void>? img) {
  final _glGetCompressedTexImageARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Pointer<Void>? img),
      void Function(int target, int level, Pointer<Void>? img)>('glGetCompressedTexImageARB');
  return _glGetCompressedTexImageARB(target, level, img);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfARB (GLenum pname, GLfloat param)
/// ```
void glPointParameterfARB(int pname, double param) {
  final _glPointParameterfARB = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPointParameterfARB');
  return _glPointParameterfARB(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfvARB (GLenum pname, const GLfloat *params)
/// ```
void glPointParameterfvARB(int pname, Pointer<Float>? params) {
  final _glPointParameterfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glPointParameterfvARB');
  return _glPointParameterfvARB(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glWeightbvARB (GLint size, const GLbyte *weights)
/// ```
void glWeightbvARB(int size, String weights) {
  final _glWeightbvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Utf8>? weights),
      void Function(int size, Pointer<Utf8>? weights)>('glWeightbvARB');
  final _weightsPointer = weights.toNativeUtf8();
  final _result = _glWeightbvARB(size, _weightsPointer);
  calloc.free(_weightsPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glWeightsvARB (GLint size, const GLshort *weights)
/// ```
void glWeightsvARB(int size, Pointer<Int16>? weights) {
  final _glWeightsvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Int16>? weights),
      void Function(int size, Pointer<Int16>? weights)>('glWeightsvARB');
  return _glWeightsvARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightivARB (GLint size, const GLint *weights)
/// ```
void glWeightivARB(int size, Pointer<Int32>? weights) {
  final _glWeightivARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Int32>? weights),
      void Function(int size, Pointer<Int32>? weights)>('glWeightivARB');
  return _glWeightivARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightfvARB (GLint size, const GLfloat *weights)
/// ```
void glWeightfvARB(int size, Pointer<Float>? weights) {
  final _glWeightfvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Float>? weights),
      void Function(int size, Pointer<Float>? weights)>('glWeightfvARB');
  return _glWeightfvARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightdvARB (GLint size, const GLdouble *weights)
/// ```
void glWeightdvARB(int size, Pointer<Double>? weights) {
  final _glWeightdvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Double>? weights),
      void Function(int size, Pointer<Double>? weights)>('glWeightdvARB');
  return _glWeightdvARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightubvARB (GLint size, const GLubyte *weights)
/// ```
void glWeightubvARB(int size, Pointer<Uint8>? weights) {
  final _glWeightubvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint8>? weights),
      void Function(int size, Pointer<Uint8>? weights)>('glWeightubvARB');
  return _glWeightubvARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightusvARB (GLint size, const GLushort *weights)
/// ```
void glWeightusvARB(int size, Pointer<Uint16>? weights) {
  final _glWeightusvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint16>? weights),
      void Function(int size, Pointer<Uint16>? weights)>('glWeightusvARB');
  return _glWeightusvARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightuivARB (GLint size, const GLuint *weights)
/// ```
void glWeightuivARB(int size, Pointer<Uint32>? weights) {
  final _glWeightuivARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint32>? weights),
      void Function(int size, Pointer<Uint32>? weights)>('glWeightuivARB');
  return _glWeightuivARB(size, weights);
}

/// ```c
/// GLAPI void APIENTRY glWeightPointerARB (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glWeightPointerARB(int size, int type, int stride, Pointer<Void>? pointer) {
  final _glWeightPointerARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, Pointer<Void>? pointer)>('glWeightPointerARB');
  return _glWeightPointerARB(size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glVertexBlendARB (GLint count)
/// ```
void glVertexBlendARB(int count) {
  final _glVertexBlendARB = _SDL2.lookupFunction<
      Void Function(Int32 count),
      void Function(int count)>('glVertexBlendARB');
  return _glVertexBlendARB(count);
}

/// ```c
/// GLAPI void APIENTRY glCurrentPaletteMatrixARB (GLint index)
/// ```
void glCurrentPaletteMatrixARB(int index) {
  final _glCurrentPaletteMatrixARB = _SDL2.lookupFunction<
      Void Function(Int32 index),
      void Function(int index)>('glCurrentPaletteMatrixARB');
  return _glCurrentPaletteMatrixARB(index);
}

/// ```c
/// GLAPI void APIENTRY glMatrixIndexubvARB (GLint size, const GLubyte *indices)
/// ```
void glMatrixIndexubvARB(int size, Pointer<Uint8>? indices) {
  final _glMatrixIndexubvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint8>? indices),
      void Function(int size, Pointer<Uint8>? indices)>('glMatrixIndexubvARB');
  return _glMatrixIndexubvARB(size, indices);
}

/// ```c
/// GLAPI void APIENTRY glMatrixIndexusvARB (GLint size, const GLushort *indices)
/// ```
void glMatrixIndexusvARB(int size, Pointer<Uint16>? indices) {
  final _glMatrixIndexusvARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint16>? indices),
      void Function(int size, Pointer<Uint16>? indices)>('glMatrixIndexusvARB');
  return _glMatrixIndexusvARB(size, indices);
}

/// ```c
/// GLAPI void APIENTRY glMatrixIndexuivARB (GLint size, const GLuint *indices)
/// ```
void glMatrixIndexuivARB(int size, Pointer<Uint32>? indices) {
  final _glMatrixIndexuivARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Pointer<Uint32>? indices),
      void Function(int size, Pointer<Uint32>? indices)>('glMatrixIndexuivARB');
  return _glMatrixIndexuivARB(size, indices);
}

/// ```c
/// GLAPI void APIENTRY glMatrixIndexPointerARB (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glMatrixIndexPointerARB(int size, int type, int stride, Pointer<Void>? pointer) {
  final _glMatrixIndexPointerARB = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, Pointer<Void>? pointer)>('glMatrixIndexPointerARB');
  return _glMatrixIndexPointerARB(size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2dARB (GLdouble x, GLdouble y)
/// ```
void glWindowPos2dARB(double x, double y) {
  final _glWindowPos2dARB = _SDL2.lookupFunction<
      Void Function(Double x, Double y),
      void Function(double x, double y)>('glWindowPos2dARB');
  return _glWindowPos2dARB(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2dvARB (const GLdouble *v)
/// ```
void glWindowPos2dvARB(Pointer<Double>? v) {
  final _glWindowPos2dvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos2dvARB');
  return _glWindowPos2dvARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2fARB (GLfloat x, GLfloat y)
/// ```
void glWindowPos2fARB(double x, double y) {
  final _glWindowPos2fARB = _SDL2.lookupFunction<
      Void Function(Float x, Float y),
      void Function(double x, double y)>('glWindowPos2fARB');
  return _glWindowPos2fARB(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2fvARB (const GLfloat *v)
/// ```
void glWindowPos2fvARB(Pointer<Float>? v) {
  final _glWindowPos2fvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos2fvARB');
  return _glWindowPos2fvARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2iARB (GLint x, GLint y)
/// ```
void glWindowPos2iARB(int x, int y) {
  final _glWindowPos2iARB = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y),
      void Function(int x, int y)>('glWindowPos2iARB');
  return _glWindowPos2iARB(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2ivARB (const GLint *v)
/// ```
void glWindowPos2ivARB(Pointer<Int32>? v) {
  final _glWindowPos2ivARB = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos2ivARB');
  return _glWindowPos2ivARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2sARB (GLshort x, GLshort y)
/// ```
void glWindowPos2sARB(int x, int y) {
  final _glWindowPos2sARB = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y),
      void Function(int x, int y)>('glWindowPos2sARB');
  return _glWindowPos2sARB(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2svARB (const GLshort *v)
/// ```
void glWindowPos2svARB(Pointer<Int16>? v) {
  final _glWindowPos2svARB = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos2svARB');
  return _glWindowPos2svARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3dARB (GLdouble x, GLdouble y, GLdouble z)
/// ```
void glWindowPos3dARB(double x, double y, double z) {
  final _glWindowPos3dARB = _SDL2.lookupFunction<
      Void Function(Double x, Double y, Double z),
      void Function(double x, double y, double z)>('glWindowPos3dARB');
  return _glWindowPos3dARB(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3dvARB (const GLdouble *v)
/// ```
void glWindowPos3dvARB(Pointer<Double>? v) {
  final _glWindowPos3dvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos3dvARB');
  return _glWindowPos3dvARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3fARB (GLfloat x, GLfloat y, GLfloat z)
/// ```
void glWindowPos3fARB(double x, double y, double z) {
  final _glWindowPos3fARB = _SDL2.lookupFunction<
      Void Function(Float x, Float y, Float z),
      void Function(double x, double y, double z)>('glWindowPos3fARB');
  return _glWindowPos3fARB(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3fvARB (const GLfloat *v)
/// ```
void glWindowPos3fvARB(Pointer<Float>? v) {
  final _glWindowPos3fvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos3fvARB');
  return _glWindowPos3fvARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3iARB (GLint x, GLint y, GLint z)
/// ```
void glWindowPos3iARB(int x, int y, int z) {
  final _glWindowPos3iARB = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y, Int32 z),
      void Function(int x, int y, int z)>('glWindowPos3iARB');
  return _glWindowPos3iARB(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3ivARB (const GLint *v)
/// ```
void glWindowPos3ivARB(Pointer<Int32>? v) {
  final _glWindowPos3ivARB = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos3ivARB');
  return _glWindowPos3ivARB(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3sARB (GLshort x, GLshort y, GLshort z)
/// ```
void glWindowPos3sARB(int x, int y, int z) {
  final _glWindowPos3sARB = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y, Int16 z),
      void Function(int x, int y, int z)>('glWindowPos3sARB');
  return _glWindowPos3sARB(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3svARB (const GLshort *v)
/// ```
void glWindowPos3svARB(Pointer<Int16>? v) {
  final _glWindowPos3svARB = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos3svARB');
  return _glWindowPos3svARB(v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1dARB (GLuint index, GLdouble x)
/// ```
void glVertexAttrib1dARB(int index, double x) {
  final _glVertexAttrib1dARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x),
      void Function(int index, double x)>('glVertexAttrib1dARB');
  return _glVertexAttrib1dARB(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1dvARB (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib1dvARB(int index, Pointer<Double>? v) {
  final _glVertexAttrib1dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib1dvARB');
  return _glVertexAttrib1dvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1fARB (GLuint index, GLfloat x)
/// ```
void glVertexAttrib1fARB(int index, double x) {
  final _glVertexAttrib1fARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x),
      void Function(int index, double x)>('glVertexAttrib1fARB');
  return _glVertexAttrib1fARB(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1fvARB (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib1fvARB(int index, Pointer<Float>? v) {
  final _glVertexAttrib1fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib1fvARB');
  return _glVertexAttrib1fvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1sARB (GLuint index, GLshort x)
/// ```
void glVertexAttrib1sARB(int index, int x) {
  final _glVertexAttrib1sARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x),
      void Function(int index, int x)>('glVertexAttrib1sARB');
  return _glVertexAttrib1sARB(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1svARB (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib1svARB(int index, Pointer<Int16>? v) {
  final _glVertexAttrib1svARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib1svARB');
  return _glVertexAttrib1svARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2dARB (GLuint index, GLdouble x, GLdouble y)
/// ```
void glVertexAttrib2dARB(int index, double x, double y) {
  final _glVertexAttrib2dARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y),
      void Function(int index, double x, double y)>('glVertexAttrib2dARB');
  return _glVertexAttrib2dARB(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2dvARB (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib2dvARB(int index, Pointer<Double>? v) {
  final _glVertexAttrib2dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib2dvARB');
  return _glVertexAttrib2dvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2fARB (GLuint index, GLfloat x, GLfloat y)
/// ```
void glVertexAttrib2fARB(int index, double x, double y) {
  final _glVertexAttrib2fARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y),
      void Function(int index, double x, double y)>('glVertexAttrib2fARB');
  return _glVertexAttrib2fARB(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2fvARB (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib2fvARB(int index, Pointer<Float>? v) {
  final _glVertexAttrib2fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib2fvARB');
  return _glVertexAttrib2fvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2sARB (GLuint index, GLshort x, GLshort y)
/// ```
void glVertexAttrib2sARB(int index, int x, int y) {
  final _glVertexAttrib2sARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y),
      void Function(int index, int x, int y)>('glVertexAttrib2sARB');
  return _glVertexAttrib2sARB(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2svARB (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib2svARB(int index, Pointer<Int16>? v) {
  final _glVertexAttrib2svARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib2svARB');
  return _glVertexAttrib2svARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3dARB (GLuint index, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexAttrib3dARB(int index, double x, double y, double z) {
  final _glVertexAttrib3dARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3dARB');
  return _glVertexAttrib3dARB(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3dvARB (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib3dvARB(int index, Pointer<Double>? v) {
  final _glVertexAttrib3dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib3dvARB');
  return _glVertexAttrib3dvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3fARB (GLuint index, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glVertexAttrib3fARB(int index, double x, double y, double z) {
  final _glVertexAttrib3fARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3fARB');
  return _glVertexAttrib3fARB(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3fvARB (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib3fvARB(int index, Pointer<Float>? v) {
  final _glVertexAttrib3fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib3fvARB');
  return _glVertexAttrib3fvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3sARB (GLuint index, GLshort x, GLshort y, GLshort z)
/// ```
void glVertexAttrib3sARB(int index, int x, int y, int z) {
  final _glVertexAttrib3sARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z),
      void Function(int index, int x, int y, int z)>('glVertexAttrib3sARB');
  return _glVertexAttrib3sARB(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3svARB (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib3svARB(int index, Pointer<Int16>? v) {
  final _glVertexAttrib3svARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib3svARB');
  return _glVertexAttrib3svARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NbvARB (GLuint index, const GLbyte *v)
/// ```
void glVertexAttrib4NbvARB(int index, String v) {
  final _glVertexAttrib4NbvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttrib4NbvARB');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttrib4NbvARB(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NivARB (GLuint index, const GLint *v)
/// ```
void glVertexAttrib4NivARB(int index, Pointer<Int32>? v) {
  final _glVertexAttrib4NivARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttrib4NivARB');
  return _glVertexAttrib4NivARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NsvARB (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib4NsvARB(int index, Pointer<Int16>? v) {
  final _glVertexAttrib4NsvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib4NsvARB');
  return _glVertexAttrib4NsvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NubARB (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
/// ```
void glVertexAttrib4NubARB(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4NubARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint8 x, Uint8 y, Uint8 z, Uint8 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4NubARB');
  return _glVertexAttrib4NubARB(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NubvARB (GLuint index, const GLubyte *v)
/// ```
void glVertexAttrib4NubvARB(int index, Pointer<Uint8>? v) {
  final _glVertexAttrib4NubvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttrib4NubvARB');
  return _glVertexAttrib4NubvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NuivARB (GLuint index, const GLuint *v)
/// ```
void glVertexAttrib4NuivARB(int index, Pointer<Uint32>? v) {
  final _glVertexAttrib4NuivARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttrib4NuivARB');
  return _glVertexAttrib4NuivARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4NusvARB (GLuint index, const GLushort *v)
/// ```
void glVertexAttrib4NusvARB(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib4NusvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib4NusvARB');
  return _glVertexAttrib4NusvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4bvARB (GLuint index, const GLbyte *v)
/// ```
void glVertexAttrib4bvARB(int index, String v) {
  final _glVertexAttrib4bvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttrib4bvARB');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttrib4bvARB(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4dARB (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexAttrib4dARB(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4dARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4dARB');
  return _glVertexAttrib4dARB(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4dvARB (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib4dvARB(int index, Pointer<Double>? v) {
  final _glVertexAttrib4dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib4dvARB');
  return _glVertexAttrib4dvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4fARB (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glVertexAttrib4fARB(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4fARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4fARB');
  return _glVertexAttrib4fARB(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4fvARB (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib4fvARB(int index, Pointer<Float>? v) {
  final _glVertexAttrib4fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib4fvARB');
  return _glVertexAttrib4fvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4ivARB (GLuint index, const GLint *v)
/// ```
void glVertexAttrib4ivARB(int index, Pointer<Int32>? v) {
  final _glVertexAttrib4ivARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttrib4ivARB');
  return _glVertexAttrib4ivARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4sARB (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
/// ```
void glVertexAttrib4sARB(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4sARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z, Int16 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4sARB');
  return _glVertexAttrib4sARB(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4svARB (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib4svARB(int index, Pointer<Int16>? v) {
  final _glVertexAttrib4svARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib4svARB');
  return _glVertexAttrib4svARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4ubvARB (GLuint index, const GLubyte *v)
/// ```
void glVertexAttrib4ubvARB(int index, Pointer<Uint8>? v) {
  final _glVertexAttrib4ubvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttrib4ubvARB');
  return _glVertexAttrib4ubvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4uivARB (GLuint index, const GLuint *v)
/// ```
void glVertexAttrib4uivARB(int index, Pointer<Uint32>? v) {
  final _glVertexAttrib4uivARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttrib4uivARB');
  return _glVertexAttrib4uivARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4usvARB (GLuint index, const GLushort *v)
/// ```
void glVertexAttrib4usvARB(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib4usvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib4usvARB');
  return _glVertexAttrib4usvARB(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribPointerARB (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribPointerARB(int index, int size, int type, int normalized, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribPointerARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Int32 normalized, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int normalized, int stride, Pointer<Void>? pointer)>('glVertexAttribPointerARB');
  return _glVertexAttribPointerARB(index, size, type, normalized, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glEnableVertexAttribArrayARB (GLuint index)
/// ```
void glEnableVertexAttribArrayARB(int index) {
  final _glEnableVertexAttribArrayARB = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glEnableVertexAttribArrayARB');
  return _glEnableVertexAttribArrayARB(index);
}

/// ```c
/// GLAPI void APIENTRY glDisableVertexAttribArrayARB (GLuint index)
/// ```
void glDisableVertexAttribArrayARB(int index) {
  final _glDisableVertexAttribArrayARB = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glDisableVertexAttribArrayARB');
  return _glDisableVertexAttribArrayARB(index);
}

/// ```c
/// GLAPI void APIENTRY glProgramStringARB (GLenum target, GLenum format, GLsizei len, const GLvoid *string)
/// ```
void glProgramStringARB(int target, int format, int len, Pointer<Void>? string) {
  final _glProgramStringARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 len, Pointer<Void>? string),
      void Function(int target, int format, int len, Pointer<Void>? string)>('glProgramStringARB');
  return _glProgramStringARB(target, format, len, string);
}

/// ```c
/// GLAPI void APIENTRY glBindProgramARB (GLenum target, GLuint program)
/// ```
void glBindProgramARB(int target, int program) {
  final _glBindProgramARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 program),
      void Function(int target, int program)>('glBindProgramARB');
  return _glBindProgramARB(target, program);
}

/// ```c
/// GLAPI void APIENTRY glDeleteProgramsARB (GLsizei n, const GLuint *programs)
/// ```
void glDeleteProgramsARB(int n, Pointer<Uint32>? programs) {
  final _glDeleteProgramsARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? programs),
      void Function(int n, Pointer<Uint32>? programs)>('glDeleteProgramsARB');
  return _glDeleteProgramsARB(n, programs);
}

/// ```c
/// GLAPI void APIENTRY glGenProgramsARB (GLsizei n, GLuint *programs)
/// ```
void glGenProgramsARB(int n, Pointer<Uint32>? programs) {
  final _glGenProgramsARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? programs),
      void Function(int n, Pointer<Uint32>? programs)>('glGenProgramsARB');
  return _glGenProgramsARB(n, programs);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameter4dARB (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glProgramEnvParameter4dARB(int target, int index, double x, double y, double z, double w) {
  final _glProgramEnvParameter4dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramEnvParameter4dARB');
  return _glProgramEnvParameter4dARB(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameter4dvARB (GLenum target, GLuint index, const GLdouble *params)
/// ```
void glProgramEnvParameter4dvARB(int target, int index, Pointer<Double>? params) {
  final _glProgramEnvParameter4dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int target, int index, Pointer<Double>? params)>('glProgramEnvParameter4dvARB');
  return _glProgramEnvParameter4dvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameter4fARB (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glProgramEnvParameter4fARB(int target, int index, double x, double y, double z, double w) {
  final _glProgramEnvParameter4fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramEnvParameter4fARB');
  return _glProgramEnvParameter4fARB(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameter4fvARB (GLenum target, GLuint index, const GLfloat *params)
/// ```
void glProgramEnvParameter4fvARB(int target, int index, Pointer<Float>? params) {
  final _glProgramEnvParameter4fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int target, int index, Pointer<Float>? params)>('glProgramEnvParameter4fvARB');
  return _glProgramEnvParameter4fvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameter4dARB (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glProgramLocalParameter4dARB(int target, int index, double x, double y, double z, double w) {
  final _glProgramLocalParameter4dARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramLocalParameter4dARB');
  return _glProgramLocalParameter4dARB(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameter4dvARB (GLenum target, GLuint index, const GLdouble *params)
/// ```
void glProgramLocalParameter4dvARB(int target, int index, Pointer<Double>? params) {
  final _glProgramLocalParameter4dvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int target, int index, Pointer<Double>? params)>('glProgramLocalParameter4dvARB');
  return _glProgramLocalParameter4dvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameter4fARB (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glProgramLocalParameter4fARB(int target, int index, double x, double y, double z, double w) {
  final _glProgramLocalParameter4fARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramLocalParameter4fARB');
  return _glProgramLocalParameter4fARB(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameter4fvARB (GLenum target, GLuint index, const GLfloat *params)
/// ```
void glProgramLocalParameter4fvARB(int target, int index, Pointer<Float>? params) {
  final _glProgramLocalParameter4fvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int target, int index, Pointer<Float>? params)>('glProgramLocalParameter4fvARB');
  return _glProgramLocalParameter4fvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramEnvParameterdvARB (GLenum target, GLuint index, GLdouble *params)
/// ```
void glGetProgramEnvParameterdvARB(int target, int index, Pointer<Double>? params) {
  final _glGetProgramEnvParameterdvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int target, int index, Pointer<Double>? params)>('glGetProgramEnvParameterdvARB');
  return _glGetProgramEnvParameterdvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramEnvParameterfvARB (GLenum target, GLuint index, GLfloat *params)
/// ```
void glGetProgramEnvParameterfvARB(int target, int index, Pointer<Float>? params) {
  final _glGetProgramEnvParameterfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int target, int index, Pointer<Float>? params)>('glGetProgramEnvParameterfvARB');
  return _glGetProgramEnvParameterfvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramLocalParameterdvARB (GLenum target, GLuint index, GLdouble *params)
/// ```
void glGetProgramLocalParameterdvARB(int target, int index, Pointer<Double>? params) {
  final _glGetProgramLocalParameterdvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int target, int index, Pointer<Double>? params)>('glGetProgramLocalParameterdvARB');
  return _glGetProgramLocalParameterdvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramLocalParameterfvARB (GLenum target, GLuint index, GLfloat *params)
/// ```
void glGetProgramLocalParameterfvARB(int target, int index, Pointer<Float>? params) {
  final _glGetProgramLocalParameterfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int target, int index, Pointer<Float>? params)>('glGetProgramLocalParameterfvARB');
  return _glGetProgramLocalParameterfvARB(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramivARB (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetProgramivARB(int target, int pname, Pointer<Int32>? params) {
  final _glGetProgramivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetProgramivARB');
  return _glGetProgramivARB(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramStringARB (GLenum target, GLenum pname, GLvoid *string)
/// ```
void glGetProgramStringARB(int target, int pname, Pointer<Void>? string) {
  final _glGetProgramStringARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Void>? string),
      void Function(int target, int pname, Pointer<Void>? string)>('glGetProgramStringARB');
  return _glGetProgramStringARB(target, pname, string);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribdvARB (GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetVertexAttribdvARB(int index, int pname, Pointer<Double>? params) {
  final _glGetVertexAttribdvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int index, int pname, Pointer<Double>? params)>('glGetVertexAttribdvARB');
  return _glGetVertexAttribdvARB(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribfvARB (GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetVertexAttribfvARB(int index, int pname, Pointer<Float>? params) {
  final _glGetVertexAttribfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int index, int pname, Pointer<Float>? params)>('glGetVertexAttribfvARB');
  return _glGetVertexAttribfvARB(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribivARB (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribivARB(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribivARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribivARB');
  return _glGetVertexAttribivARB(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribPointervARB (GLuint index, GLenum pname, GLvoid* *pointer)
/// ```
void glGetVertexAttribPointervARB(int index, int pname, Pointer<Pointer<Void>>? pointer) {
  final _glGetVertexAttribPointervARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Pointer<Void>>? pointer),
      void Function(int index, int pname, Pointer<Pointer<Void>>? pointer)>('glGetVertexAttribPointervARB');
  return _glGetVertexAttribPointervARB(index, pname, pointer);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsProgramARB (GLuint program)
/// ```
int glIsProgramARB(int program) {
  final _glIsProgramARB = _SDL2.lookupFunction<
      Int32 Function(Uint32 program),
      int Function(int program)>('glIsProgramARB');
  return _glIsProgramARB(program);
}

/// All ARB_fragment_program entry points are shared with ARB_vertex_program.
/// ```c
/// GLAPI void APIENTRY glBindBufferARB (GLenum target, GLuint buffer)
/// ```
void glBindBufferARB(int target, int buffer) {
  final _glBindBufferARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 buffer),
      void Function(int target, int buffer)>('glBindBufferARB');
  return _glBindBufferARB(target, buffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteBuffersARB (GLsizei n, const GLuint *buffers)
/// ```
void glDeleteBuffersARB(int n, Pointer<Uint32>? buffers) {
  final _glDeleteBuffersARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? buffers),
      void Function(int n, Pointer<Uint32>? buffers)>('glDeleteBuffersARB');
  return _glDeleteBuffersARB(n, buffers);
}

/// ```c
/// GLAPI void APIENTRY glGenBuffersARB (GLsizei n, GLuint *buffers)
/// ```
void glGenBuffersARB(int n, Pointer<Uint32>? buffers) {
  final _glGenBuffersARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? buffers),
      void Function(int n, Pointer<Uint32>? buffers)>('glGenBuffersARB');
  return _glGenBuffersARB(n, buffers);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsBufferARB (GLuint buffer)
/// ```
int glIsBufferARB(int buffer) {
  final _glIsBufferARB = _SDL2.lookupFunction<
      Int32 Function(Uint32 buffer),
      int Function(int buffer)>('glIsBufferARB');
  return _glIsBufferARB(buffer);
}

/// ```c
/// GLAPI void APIENTRY glBufferDataARB (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage)
/// ```
void glBufferDataARB(int target, int size, Pointer<Void>? data, int usage) {
  final _glBufferDataARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 size, Pointer<Void>? data, Uint32 usage),
      void Function(int target, int size, Pointer<Void>? data, int usage)>('glBufferDataARB');
  return _glBufferDataARB(target, size, data, usage);
}

/// ```c
/// GLAPI void APIENTRY glBufferSubDataARB (GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data)
/// ```
void glBufferSubDataARB(int target, int offset, int size, Pointer<Void>? data) {
  final _glBufferSubDataARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 offset, Int32 size, Pointer<Void>? data),
      void Function(int target, int offset, int size, Pointer<Void>? data)>('glBufferSubDataARB');
  return _glBufferSubDataARB(target, offset, size, data);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferSubDataARB (GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data)
/// ```
void glGetBufferSubDataARB(int target, int offset, int size, Pointer<Void>? data) {
  final _glGetBufferSubDataARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 offset, Int32 size, Pointer<Void>? data),
      void Function(int target, int offset, int size, Pointer<Void>? data)>('glGetBufferSubDataARB');
  return _glGetBufferSubDataARB(target, offset, size, data);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapBufferARB (GLenum target, GLenum access)
/// ```
Pointer<Void>? glMapBufferARB(int target, int access) {
  final _glMapBufferARB = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 target, Uint32 access),
      Pointer<Void>? Function(int target, int access)>('glMapBufferARB');
  return _glMapBufferARB(target, access);
}

/// ```c
/// GLAPI GLboolean APIENTRY glUnmapBufferARB (GLenum target)
/// ```
int glUnmapBufferARB(int target) {
  final _glUnmapBufferARB = _SDL2.lookupFunction<
      Int32 Function(Uint32 target),
      int Function(int target)>('glUnmapBufferARB');
  return _glUnmapBufferARB(target);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferParameterivARB (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetBufferParameterivARB(int target, int pname, Pointer<Int32>? params) {
  final _glGetBufferParameterivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetBufferParameterivARB');
  return _glGetBufferParameterivARB(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferPointervARB (GLenum target, GLenum pname, GLvoid* *params)
/// ```
void glGetBufferPointervARB(int target, int pname, Pointer<Pointer<Void>>? params) {
  final _glGetBufferPointervARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Pointer<Void>>? params),
      void Function(int target, int pname, Pointer<Pointer<Void>>? params)>('glGetBufferPointervARB');
  return _glGetBufferPointervARB(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGenQueriesARB (GLsizei n, GLuint *ids)
/// ```
void glGenQueriesARB(int n, Pointer<Uint32>? ids) {
  final _glGenQueriesARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glGenQueriesARB');
  return _glGenQueriesARB(n, ids);
}

/// ```c
/// GLAPI void APIENTRY glDeleteQueriesARB (GLsizei n, const GLuint *ids)
/// ```
void glDeleteQueriesARB(int n, Pointer<Uint32>? ids) {
  final _glDeleteQueriesARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glDeleteQueriesARB');
  return _glDeleteQueriesARB(n, ids);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsQueryARB (GLuint id)
/// ```
int glIsQueryARB(int id) {
  final _glIsQueryARB = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsQueryARB');
  return _glIsQueryARB(id);
}

/// ```c
/// GLAPI void APIENTRY glBeginQueryARB (GLenum target, GLuint id)
/// ```
void glBeginQueryARB(int target, int id) {
  final _glBeginQueryARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id),
      void Function(int target, int id)>('glBeginQueryARB');
  return _glBeginQueryARB(target, id);
}

/// ```c
/// GLAPI void APIENTRY glEndQueryARB (GLenum target)
/// ```
void glEndQueryARB(int target) {
  final _glEndQueryARB = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glEndQueryARB');
  return _glEndQueryARB(target);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryivARB (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetQueryivARB(int target, int pname, Pointer<Int32>? params) {
  final _glGetQueryivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetQueryivARB');
  return _glGetQueryivARB(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectivARB (GLuint id, GLenum pname, GLint *params)
/// ```
void glGetQueryObjectivARB(int id, int pname, Pointer<Int32>? params) {
  final _glGetQueryObjectivARB = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int32>? params),
      void Function(int id, int pname, Pointer<Int32>? params)>('glGetQueryObjectivARB');
  return _glGetQueryObjectivARB(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectuivARB (GLuint id, GLenum pname, GLuint *params)
/// ```
void glGetQueryObjectuivARB(int id, int pname, Pointer<Uint32>? params) {
  final _glGetQueryObjectuivARB = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint32>? params),
      void Function(int id, int pname, Pointer<Uint32>? params)>('glGetQueryObjectuivARB');
  return _glGetQueryObjectuivARB(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glDeleteObjectARB (GLhandleARB obj)
/// ```
void glDeleteObjectARB(Pointer<Void>? obj) {
  final _glDeleteObjectARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? obj),
      void Function(Pointer<Void>? obj)>('glDeleteObjectARB');
  return _glDeleteObjectARB(obj);
}

/// ```c
/// GLAPI GLhandleARB APIENTRY glGetHandleARB (GLenum pname)
/// ```
Pointer<Void>? glGetHandleARB(int pname) {
  final _glGetHandleARB = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 pname),
      Pointer<Void>? Function(int pname)>('glGetHandleARB');
  return _glGetHandleARB(pname);
}

/// ```c
/// GLAPI void APIENTRY glDetachObjectARB (GLhandleARB containerObj, GLhandleARB attachedObj)
/// ```
void glDetachObjectARB(Pointer<Void>? containerObj, Pointer<Void>? attachedObj) {
  final _glDetachObjectARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? containerObj, Pointer<Void>? attachedObj),
      void Function(Pointer<Void>? containerObj, Pointer<Void>? attachedObj)>('glDetachObjectARB');
  return _glDetachObjectARB(containerObj, attachedObj);
}

/// ```c
/// GLAPI GLhandleARB APIENTRY glCreateShaderObjectARB (GLenum shaderType)
/// ```
Pointer<Void>? glCreateShaderObjectARB(int shaderType) {
  final _glCreateShaderObjectARB = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 shaderType),
      Pointer<Void>? Function(int shaderType)>('glCreateShaderObjectARB');
  return _glCreateShaderObjectARB(shaderType);
}

/// ```c
/// GLAPI void APIENTRY glShaderSourceARB (GLhandleARB shaderObj, GLsizei count, const GLcharARB* *string, const GLint *length)
/// ```
void glShaderSourceARB(Pointer<Void>? shaderObj, int count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length) {
  final _glShaderSourceARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? shaderObj, Uint32 count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length),
      void Function(Pointer<Void>? shaderObj, int count, Pointer<Pointer<Int8>>? string, Pointer<Int32>? length)>('glShaderSourceARB');
  return _glShaderSourceARB(shaderObj, count, string, length);
}

/// ```c
/// GLAPI void APIENTRY glCompileShaderARB (GLhandleARB shaderObj)
/// ```
void glCompileShaderARB(Pointer<Void>? shaderObj) {
  final _glCompileShaderARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? shaderObj),
      void Function(Pointer<Void>? shaderObj)>('glCompileShaderARB');
  return _glCompileShaderARB(shaderObj);
}

/// ```c
/// GLAPI GLhandleARB APIENTRY glCreateProgramObjectARB (void)
/// ```
Pointer<Void>? glCreateProgramObjectARB() {
  final _glCreateProgramObjectARB = _SDL2.lookupFunction<
      Pointer<Void>? Function(),
      Pointer<Void>? Function()>('glCreateProgramObjectARB');
  return _glCreateProgramObjectARB();
}

/// ```c
/// GLAPI void APIENTRY glAttachObjectARB (GLhandleARB containerObj, GLhandleARB obj)
/// ```
void glAttachObjectARB(Pointer<Void>? containerObj, Pointer<Void>? obj) {
  final _glAttachObjectARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? containerObj, Pointer<Void>? obj),
      void Function(Pointer<Void>? containerObj, Pointer<Void>? obj)>('glAttachObjectARB');
  return _glAttachObjectARB(containerObj, obj);
}

/// ```c
/// GLAPI void APIENTRY glLinkProgramARB (GLhandleARB programObj)
/// ```
void glLinkProgramARB(Pointer<Void>? programObj) {
  final _glLinkProgramARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj),
      void Function(Pointer<Void>? programObj)>('glLinkProgramARB');
  return _glLinkProgramARB(programObj);
}

/// ```c
/// GLAPI void APIENTRY glUseProgramObjectARB (GLhandleARB programObj)
/// ```
void glUseProgramObjectARB(Pointer<Void>? programObj) {
  final _glUseProgramObjectARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj),
      void Function(Pointer<Void>? programObj)>('glUseProgramObjectARB');
  return _glUseProgramObjectARB(programObj);
}

/// ```c
/// GLAPI void APIENTRY glValidateProgramARB (GLhandleARB programObj)
/// ```
void glValidateProgramARB(Pointer<Void>? programObj) {
  final _glValidateProgramARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj),
      void Function(Pointer<Void>? programObj)>('glValidateProgramARB');
  return _glValidateProgramARB(programObj);
}

/// ```c
/// GLAPI void APIENTRY glUniform1fARB (GLint location, GLfloat v0)
/// ```
void glUniform1fARB(int location, double v0) {
  final _glUniform1fARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0),
      void Function(int location, double v0)>('glUniform1fARB');
  return _glUniform1fARB(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2fARB (GLint location, GLfloat v0, GLfloat v1)
/// ```
void glUniform2fARB(int location, double v0, double v1) {
  final _glUniform2fARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1),
      void Function(int location, double v0, double v1)>('glUniform2fARB');
  return _glUniform2fARB(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3fARB (GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
/// ```
void glUniform3fARB(int location, double v0, double v1, double v2) {
  final _glUniform3fARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1, Float v2),
      void Function(int location, double v0, double v1, double v2)>('glUniform3fARB');
  return _glUniform3fARB(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4fARB (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
/// ```
void glUniform4fARB(int location, double v0, double v1, double v2, double v3) {
  final _glUniform4fARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Float v0, Float v1, Float v2, Float v3),
      void Function(int location, double v0, double v1, double v2, double v3)>('glUniform4fARB');
  return _glUniform4fARB(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1iARB (GLint location, GLint v0)
/// ```
void glUniform1iARB(int location, int v0) {
  final _glUniform1iARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0),
      void Function(int location, int v0)>('glUniform1iARB');
  return _glUniform1iARB(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2iARB (GLint location, GLint v0, GLint v1)
/// ```
void glUniform2iARB(int location, int v0, int v1) {
  final _glUniform2iARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1),
      void Function(int location, int v0, int v1)>('glUniform2iARB');
  return _glUniform2iARB(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3iARB (GLint location, GLint v0, GLint v1, GLint v2)
/// ```
void glUniform3iARB(int location, int v0, int v1, int v2) {
  final _glUniform3iARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1, Int32 v2),
      void Function(int location, int v0, int v1, int v2)>('glUniform3iARB');
  return _glUniform3iARB(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4iARB (GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
/// ```
void glUniform4iARB(int location, int v0, int v1, int v2, int v3) {
  final _glUniform4iARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3),
      void Function(int location, int v0, int v1, int v2, int v3)>('glUniform4iARB');
  return _glUniform4iARB(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1fvARB (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform1fvARB(int location, int count, Pointer<Float>? value) {
  final _glUniform1fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform1fvARB');
  return _glUniform1fvARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2fvARB (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform2fvARB(int location, int count, Pointer<Float>? value) {
  final _glUniform2fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform2fvARB');
  return _glUniform2fvARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3fvARB (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform3fvARB(int location, int count, Pointer<Float>? value) {
  final _glUniform3fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform3fvARB');
  return _glUniform3fvARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4fvARB (GLint location, GLsizei count, const GLfloat *value)
/// ```
void glUniform4fvARB(int location, int count, Pointer<Float>? value) {
  final _glUniform4fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int location, int count, Pointer<Float>? value)>('glUniform4fvARB');
  return _glUniform4fvARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform1ivARB (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform1ivARB(int location, int count, Pointer<Int32>? value) {
  final _glUniform1ivARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform1ivARB');
  return _glUniform1ivARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2ivARB (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform2ivARB(int location, int count, Pointer<Int32>? value) {
  final _glUniform2ivARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform2ivARB');
  return _glUniform2ivARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3ivARB (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform3ivARB(int location, int count, Pointer<Int32>? value) {
  final _glUniform3ivARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform3ivARB');
  return _glUniform3ivARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4ivARB (GLint location, GLsizei count, const GLint *value)
/// ```
void glUniform4ivARB(int location, int count, Pointer<Int32>? value) {
  final _glUniform4ivARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int location, int count, Pointer<Int32>? value)>('glUniform4ivARB');
  return _glUniform4ivARB(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2fvARB (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix2fvARB(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix2fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix2fvARB');
  return _glUniformMatrix2fvARB(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3fvARB (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix3fvARB(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix3fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix3fvARB');
  return _glUniformMatrix3fvARB(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4fvARB (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glUniformMatrix4fvARB(int location, int count, int transpose, Pointer<Float>? value) {
  final _glUniformMatrix4fvARB = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int location, int count, int transpose, Pointer<Float>? value)>('glUniformMatrix4fvARB');
  return _glUniformMatrix4fvARB(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glGetObjectParameterfvARB (GLhandleARB obj, GLenum pname, GLfloat *params)
/// ```
void glGetObjectParameterfvARB(Pointer<Void>? obj, int pname, Pointer<Float>? params) {
  final _glGetObjectParameterfvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? obj, Uint32 pname, Pointer<Float>? params),
      void Function(Pointer<Void>? obj, int pname, Pointer<Float>? params)>('glGetObjectParameterfvARB');
  return _glGetObjectParameterfvARB(obj, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetObjectParameterivARB (GLhandleARB obj, GLenum pname, GLint *params)
/// ```
void glGetObjectParameterivARB(Pointer<Void>? obj, int pname, Pointer<Int32>? params) {
  final _glGetObjectParameterivARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? obj, Uint32 pname, Pointer<Int32>? params),
      void Function(Pointer<Void>? obj, int pname, Pointer<Int32>? params)>('glGetObjectParameterivARB');
  return _glGetObjectParameterivARB(obj, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetInfoLogARB (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog)
/// ```
void glGetInfoLogARB(Pointer<Void>? obj, int maxLength, Pointer<Uint32>? length, Pointer<Int8>? infoLog) {
  final _glGetInfoLogARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? obj, Uint32 maxLength, Pointer<Uint32>? length, Pointer<Int8>? infoLog),
      void Function(Pointer<Void>? obj, int maxLength, Pointer<Uint32>? length, Pointer<Int8>? infoLog)>('glGetInfoLogARB');
  return _glGetInfoLogARB(obj, maxLength, length, infoLog);
}

/// ```c
/// GLAPI void APIENTRY glGetAttachedObjectsARB (GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj)
/// ```
void glGetAttachedObjectsARB(Pointer<Void>? containerObj, int maxCount, Pointer<Uint32>? count, Pointer<Pointer<Void>>? obj) {
  final _glGetAttachedObjectsARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? containerObj, Uint32 maxCount, Pointer<Uint32>? count, Pointer<Pointer<Void>>? obj),
      void Function(Pointer<Void>? containerObj, int maxCount, Pointer<Uint32>? count, Pointer<Pointer<Void>>? obj)>('glGetAttachedObjectsARB');
  return _glGetAttachedObjectsARB(containerObj, maxCount, count, obj);
}

/// ```c
/// GLAPI GLint APIENTRY glGetUniformLocationARB (GLhandleARB programObj, const GLcharARB *name)
/// ```
int glGetUniformLocationARB(Pointer<Void>? programObj, String name) {
  final _glGetUniformLocationARB = _SDL2.lookupFunction<
      Int32 Function(Pointer<Void>? programObj, Pointer<Utf8>? name),
      int Function(Pointer<Void>? programObj, Pointer<Utf8>? name)>('glGetUniformLocationARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetUniformLocationARB(programObj, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniformARB (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name)
/// ```
void glGetActiveUniformARB(Pointer<Void>? programObj, int index, int maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetActiveUniformARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj, Uint32 index, Uint32 maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(Pointer<Void>? programObj, int index, int maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetActiveUniformARB');
  return _glGetActiveUniformARB(programObj, index, maxLength, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformfvARB (GLhandleARB programObj, GLint location, GLfloat *params)
/// ```
void glGetUniformfvARB(Pointer<Void>? programObj, int location, Pointer<Float>? params) {
  final _glGetUniformfvARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj, Int32 location, Pointer<Float>? params),
      void Function(Pointer<Void>? programObj, int location, Pointer<Float>? params)>('glGetUniformfvARB');
  return _glGetUniformfvARB(programObj, location, params);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformivARB (GLhandleARB programObj, GLint location, GLint *params)
/// ```
void glGetUniformivARB(Pointer<Void>? programObj, int location, Pointer<Int32>? params) {
  final _glGetUniformivARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj, Int32 location, Pointer<Int32>? params),
      void Function(Pointer<Void>? programObj, int location, Pointer<Int32>? params)>('glGetUniformivARB');
  return _glGetUniformivARB(programObj, location, params);
}

/// ```c
/// GLAPI void APIENTRY glGetShaderSourceARB (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source)
/// ```
void glGetShaderSourceARB(Pointer<Void>? obj, int maxLength, Pointer<Uint32>? length, Pointer<Int8>? source) {
  final _glGetShaderSourceARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? obj, Uint32 maxLength, Pointer<Uint32>? length, Pointer<Int8>? source),
      void Function(Pointer<Void>? obj, int maxLength, Pointer<Uint32>? length, Pointer<Int8>? source)>('glGetShaderSourceARB');
  return _glGetShaderSourceARB(obj, maxLength, length, source);
}

/// ```c
/// GLAPI void APIENTRY glBindAttribLocationARB (GLhandleARB programObj, GLuint index, const GLcharARB *name)
/// ```
void glBindAttribLocationARB(Pointer<Void>? programObj, int index, String name) {
  final _glBindAttribLocationARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj, Uint32 index, Pointer<Utf8>? name),
      void Function(Pointer<Void>? programObj, int index, Pointer<Utf8>? name)>('glBindAttribLocationARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glBindAttribLocationARB(programObj, index, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetActiveAttribARB (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name)
/// ```
void glGetActiveAttribARB(Pointer<Void>? programObj, int index, int maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetActiveAttribARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? programObj, Uint32 index, Uint32 maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(Pointer<Void>? programObj, int index, int maxLength, Pointer<Uint32>? length, Pointer<Int32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetActiveAttribARB');
  return _glGetActiveAttribARB(programObj, index, maxLength, length, size, type, name);
}

/// ```c
/// GLAPI GLint APIENTRY glGetAttribLocationARB (GLhandleARB programObj, const GLcharARB *name)
/// ```
int glGetAttribLocationARB(Pointer<Void>? programObj, String name) {
  final _glGetAttribLocationARB = _SDL2.lookupFunction<
      Int32 Function(Pointer<Void>? programObj, Pointer<Utf8>? name),
      int Function(Pointer<Void>? programObj, Pointer<Utf8>? name)>('glGetAttribLocationARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetAttribLocationARB(programObj, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glDrawBuffersARB (GLsizei n, const GLenum *bufs)
/// ```
void glDrawBuffersARB(int n, Pointer<Uint32>? bufs) {
  final _glDrawBuffersARB = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? bufs),
      void Function(int n, Pointer<Uint32>? bufs)>('glDrawBuffersARB');
  return _glDrawBuffersARB(n, bufs);
}

/// ```c
/// GLAPI void APIENTRY glClampColorARB (GLenum target, GLenum clamp)
/// ```
void glClampColorARB(int target, int clamp) {
  final _glClampColorARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 clamp),
      void Function(int target, int clamp)>('glClampColorARB');
  return _glClampColorARB(target, clamp);
}

/// ```c
/// GLAPI void APIENTRY glDrawArraysInstancedARB (GLenum mode, GLint first, GLsizei count, GLsizei primcount)
/// ```
void glDrawArraysInstancedARB(int mode, int first, int count, int primcount) {
  final _glDrawArraysInstancedARB = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 first, Uint32 count, Uint32 primcount),
      void Function(int mode, int first, int count, int primcount)>('glDrawArraysInstancedARB');
  return _glDrawArraysInstancedARB(mode, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsInstancedARB (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
/// ```
void glDrawElementsInstancedARB(int mode, int count, int type, Pointer<Void>? indices, int primcount) {
  final _glDrawElementsInstancedARB = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count, Uint32 type, Pointer<Void>? indices, Uint32 primcount),
      void Function(int mode, int count, int type, Pointer<Void>? indices, int primcount)>('glDrawElementsInstancedARB');
  return _glDrawElementsInstancedARB(mode, count, type, indices, primcount);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsRenderbuffer (GLuint renderbuffer)
/// ```
int glIsRenderbuffer(int renderbuffer) {
  final _glIsRenderbuffer = _SDL2.lookupFunction<
      Int32 Function(Uint32 renderbuffer),
      int Function(int renderbuffer)>('glIsRenderbuffer');
  return _glIsRenderbuffer(renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glBindRenderbuffer (GLenum target, GLuint renderbuffer)
/// ```
void glBindRenderbuffer(int target, int renderbuffer) {
  final _glBindRenderbuffer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 renderbuffer),
      void Function(int target, int renderbuffer)>('glBindRenderbuffer');
  return _glBindRenderbuffer(target, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteRenderbuffers (GLsizei n, const GLuint *renderbuffers)
/// ```
void glDeleteRenderbuffers(int n, Pointer<Uint32>? renderbuffers) {
  final _glDeleteRenderbuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? renderbuffers),
      void Function(int n, Pointer<Uint32>? renderbuffers)>('glDeleteRenderbuffers');
  return _glDeleteRenderbuffers(n, renderbuffers);
}

/// ```c
/// GLAPI void APIENTRY glGenRenderbuffers (GLsizei n, GLuint *renderbuffers)
/// ```
void glGenRenderbuffers(int n, Pointer<Uint32>? renderbuffers) {
  final _glGenRenderbuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? renderbuffers),
      void Function(int n, Pointer<Uint32>? renderbuffers)>('glGenRenderbuffers');
  return _glGenRenderbuffers(n, renderbuffers);
}

/// ```c
/// GLAPI void APIENTRY glRenderbufferStorage (GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glRenderbufferStorage(int target, int internalformat, int width, int height) {
  final _glRenderbufferStorage = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int target, int internalformat, int width, int height)>('glRenderbufferStorage');
  return _glRenderbufferStorage(target, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetRenderbufferParameteriv (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetRenderbufferParameteriv(int target, int pname, Pointer<Int32>? params) {
  final _glGetRenderbufferParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetRenderbufferParameteriv');
  return _glGetRenderbufferParameteriv(target, pname, params);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsFramebuffer (GLuint framebuffer)
/// ```
int glIsFramebuffer(int framebuffer) {
  final _glIsFramebuffer = _SDL2.lookupFunction<
      Int32 Function(Uint32 framebuffer),
      int Function(int framebuffer)>('glIsFramebuffer');
  return _glIsFramebuffer(framebuffer);
}

/// ```c
/// GLAPI void APIENTRY glBindFramebuffer (GLenum target, GLuint framebuffer)
/// ```
void glBindFramebuffer(int target, int framebuffer) {
  final _glBindFramebuffer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 framebuffer),
      void Function(int target, int framebuffer)>('glBindFramebuffer');
  return _glBindFramebuffer(target, framebuffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteFramebuffers (GLsizei n, const GLuint *framebuffers)
/// ```
void glDeleteFramebuffers(int n, Pointer<Uint32>? framebuffers) {
  final _glDeleteFramebuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? framebuffers),
      void Function(int n, Pointer<Uint32>? framebuffers)>('glDeleteFramebuffers');
  return _glDeleteFramebuffers(n, framebuffers);
}

/// ```c
/// GLAPI void APIENTRY glGenFramebuffers (GLsizei n, GLuint *framebuffers)
/// ```
void glGenFramebuffers(int n, Pointer<Uint32>? framebuffers) {
  final _glGenFramebuffers = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? framebuffers),
      void Function(int n, Pointer<Uint32>? framebuffers)>('glGenFramebuffers');
  return _glGenFramebuffers(n, framebuffers);
}

/// ```c
/// GLAPI GLenum APIENTRY glCheckFramebufferStatus (GLenum target)
/// ```
int glCheckFramebufferStatus(int target) {
  final _glCheckFramebufferStatus = _SDL2.lookupFunction<
      Uint32 Function(Uint32 target),
      int Function(int target)>('glCheckFramebufferStatus');
  return _glCheckFramebufferStatus(target);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture1D (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glFramebufferTexture1D(int target, int attachment, int textarget, int texture, int level) {
  final _glFramebufferTexture1D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int textarget, int texture, int level)>('glFramebufferTexture1D');
  return _glFramebufferTexture1D(target, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture2D (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glFramebufferTexture2D(int target, int attachment, int textarget, int texture, int level) {
  final _glFramebufferTexture2D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int textarget, int texture, int level)>('glFramebufferTexture2D');
  return _glFramebufferTexture2D(target, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture3D (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
/// ```
void glFramebufferTexture3D(int target, int attachment, int textarget, int texture, int level, int zoffset) {
  final _glFramebufferTexture3D = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level, Int32 zoffset),
      void Function(int target, int attachment, int textarget, int texture, int level, int zoffset)>('glFramebufferTexture3D');
  return _glFramebufferTexture3D(target, attachment, textarget, texture, level, zoffset);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferRenderbuffer (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
/// ```
void glFramebufferRenderbuffer(int target, int attachment, int renderbuffertarget, int renderbuffer) {
  final _glFramebufferRenderbuffer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 renderbuffertarget, Uint32 renderbuffer),
      void Function(int target, int attachment, int renderbuffertarget, int renderbuffer)>('glFramebufferRenderbuffer');
  return _glFramebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glGetFramebufferAttachmentParameteriv (GLenum target, GLenum attachment, GLenum pname, GLint *params)
/// ```
void glGetFramebufferAttachmentParameteriv(int target, int attachment, int pname, Pointer<Int32>? params) {
  final _glGetFramebufferAttachmentParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int attachment, int pname, Pointer<Int32>? params)>('glGetFramebufferAttachmentParameteriv');
  return _glGetFramebufferAttachmentParameteriv(target, attachment, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGenerateMipmap (GLenum target)
/// ```
void glGenerateMipmap(int target) {
  final _glGenerateMipmap = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glGenerateMipmap');
  return _glGenerateMipmap(target);
}

/// ```c
/// GLAPI void APIENTRY glBlitFramebuffer (GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
/// ```
void glBlitFramebuffer(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter) {
  final _glBlitFramebuffer = _SDL2.lookupFunction<
      Void Function(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, Uint32 mask, Uint32 filter),
      void Function(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)>('glBlitFramebuffer');
  return _glBlitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

/// ```c
/// GLAPI void APIENTRY glRenderbufferStorageMultisample (GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glRenderbufferStorageMultisample(int target, int samples, int internalformat, int width, int height) {
  final _glRenderbufferStorageMultisample = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 samples, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int target, int samples, int internalformat, int width, int height)>('glRenderbufferStorageMultisample');
  return _glRenderbufferStorageMultisample(target, samples, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureLayer (GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
/// ```
void glFramebufferTextureLayer(int target, int attachment, int texture, int level, int layer) {
  final _glFramebufferTextureLayer = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level, Int32 layer),
      void Function(int target, int attachment, int texture, int level, int layer)>('glFramebufferTextureLayer');
  return _glFramebufferTextureLayer(target, attachment, texture, level, layer);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameteriARB (GLuint program, GLenum pname, GLint value)
/// ```
void glProgramParameteriARB(int program, int pname, int value) {
  final _glProgramParameteriARB = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 pname, Int32 value),
      void Function(int program, int pname, int value)>('glProgramParameteriARB');
  return _glProgramParameteriARB(program, pname, value);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureARB (GLenum target, GLenum attachment, GLuint texture, GLint level)
/// ```
void glFramebufferTextureARB(int target, int attachment, int texture, int level) {
  final _glFramebufferTextureARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int texture, int level)>('glFramebufferTextureARB');
  return _glFramebufferTextureARB(target, attachment, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureLayerARB (GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
/// ```
void glFramebufferTextureLayerARB(int target, int attachment, int texture, int level, int layer) {
  final _glFramebufferTextureLayerARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level, Int32 layer),
      void Function(int target, int attachment, int texture, int level, int layer)>('glFramebufferTextureLayerARB');
  return _glFramebufferTextureLayerARB(target, attachment, texture, level, layer);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureFaceARB (GLenum target, GLenum attachment, GLuint texture, GLint level, GLenum face)
/// ```
void glFramebufferTextureFaceARB(int target, int attachment, int texture, int level, int face) {
  final _glFramebufferTextureFaceARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level, Uint32 face),
      void Function(int target, int attachment, int texture, int level, int face)>('glFramebufferTextureFaceARB');
  return _glFramebufferTextureFaceARB(target, attachment, texture, level, face);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribDivisorARB (GLuint index, GLuint divisor)
/// ```
void glVertexAttribDivisorARB(int index, int divisor) {
  final _glVertexAttribDivisorARB = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 divisor),
      void Function(int index, int divisor)>('glVertexAttribDivisorARB');
  return _glVertexAttribDivisorARB(index, divisor);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapBufferRange (GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access)
/// ```
Pointer<Void>? glMapBufferRange(int target, Pointer<Void>? offset, Pointer<Void>? length, int access) {
  final _glMapBufferRange = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 target, Pointer<Void>? offset, Pointer<Void>? length, Uint32 access),
      Pointer<Void>? Function(int target, Pointer<Void>? offset, Pointer<Void>? length, int access)>('glMapBufferRange');
  return _glMapBufferRange(target, offset, length, access);
}

/// ```c
/// GLAPI void APIENTRY glFlushMappedBufferRange (GLenum target, GLintptr offset, GLsizeiptr length)
/// ```
void glFlushMappedBufferRange(int target, Pointer<Void>? offset, Pointer<Void>? length) {
  final _glFlushMappedBufferRange = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Void>? offset, Pointer<Void>? length),
      void Function(int target, Pointer<Void>? offset, Pointer<Void>? length)>('glFlushMappedBufferRange');
  return _glFlushMappedBufferRange(target, offset, length);
}

/// ```c
/// GLAPI void APIENTRY glTexBufferARB (GLenum target, GLenum internalformat, GLuint buffer)
/// ```
void glTexBufferARB(int target, int internalformat, int buffer) {
  final _glTexBufferARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 buffer),
      void Function(int target, int internalformat, int buffer)>('glTexBufferARB');
  return _glTexBufferARB(target, internalformat, buffer);
}

/// ```c
/// GLAPI void APIENTRY glBindVertexArray (GLuint array)
/// ```
void glBindVertexArray(int array) {
  final _glBindVertexArray = _SDL2.lookupFunction<
      Void Function(Uint32 array),
      void Function(int array)>('glBindVertexArray');
  return _glBindVertexArray(array);
}

/// ```c
/// GLAPI void APIENTRY glDeleteVertexArrays (GLsizei n, const GLuint *arrays)
/// ```
void glDeleteVertexArrays(int n, Pointer<Uint32>? arrays) {
  final _glDeleteVertexArrays = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? arrays),
      void Function(int n, Pointer<Uint32>? arrays)>('glDeleteVertexArrays');
  return _glDeleteVertexArrays(n, arrays);
}

/// ```c
/// GLAPI void APIENTRY glGenVertexArrays (GLsizei n, GLuint *arrays)
/// ```
void glGenVertexArrays(int n, Pointer<Uint32>? arrays) {
  final _glGenVertexArrays = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? arrays),
      void Function(int n, Pointer<Uint32>? arrays)>('glGenVertexArrays');
  return _glGenVertexArrays(n, arrays);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsVertexArray (GLuint array)
/// ```
int glIsVertexArray(int array) {
  final _glIsVertexArray = _SDL2.lookupFunction<
      Int32 Function(Uint32 array),
      int Function(int array)>('glIsVertexArray');
  return _glIsVertexArray(array);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformIndices (GLuint program, GLsizei uniformCount, const GLchar* *uniformNames, GLuint *uniformIndices)
/// ```
void glGetUniformIndices(int program, int uniformCount, Pointer<Pointer<Int8>>? uniformNames, Pointer<Uint32>? uniformIndices) {
  final _glGetUniformIndices = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformCount, Pointer<Pointer<Int8>>? uniformNames, Pointer<Uint32>? uniformIndices),
      void Function(int program, int uniformCount, Pointer<Pointer<Int8>>? uniformNames, Pointer<Uint32>? uniformIndices)>('glGetUniformIndices');
  return _glGetUniformIndices(program, uniformCount, uniformNames, uniformIndices);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniformsiv (GLuint program, GLsizei uniformCount, const GLuint *uniformIndices, GLenum pname, GLint *params)
/// ```
void glGetActiveUniformsiv(int program, int uniformCount, Pointer<Uint32>? uniformIndices, int pname, Pointer<Int32>? params) {
  final _glGetActiveUniformsiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformCount, Pointer<Uint32>? uniformIndices, Uint32 pname, Pointer<Int32>? params),
      void Function(int program, int uniformCount, Pointer<Uint32>? uniformIndices, int pname, Pointer<Int32>? params)>('glGetActiveUniformsiv');
  return _glGetActiveUniformsiv(program, uniformCount, uniformIndices, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniformName (GLuint program, GLuint uniformIndex, GLsizei bufSize, GLsizei *length, GLchar *uniformName)
/// ```
void glGetActiveUniformName(int program, int uniformIndex, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformName) {
  final _glGetActiveUniformName = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformIndex, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformName),
      void Function(int program, int uniformIndex, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformName)>('glGetActiveUniformName');
  return _glGetActiveUniformName(program, uniformIndex, bufSize, length, uniformName);
}

/// ```c
/// GLAPI GLuint APIENTRY glGetUniformBlockIndex (GLuint program, const GLchar *uniformBlockName)
/// ```
int glGetUniformBlockIndex(int program, String uniformBlockName) {
  final _glGetUniformBlockIndex = _SDL2.lookupFunction<
      Uint32 Function(Uint32 program, Pointer<Utf8>? uniformBlockName),
      int Function(int program, Pointer<Utf8>? uniformBlockName)>('glGetUniformBlockIndex');
  final _uniformBlockNamePointer = uniformBlockName.toNativeUtf8();
  final _result = _glGetUniformBlockIndex(program, _uniformBlockNamePointer);
  calloc.free(_uniformBlockNamePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniformBlockiv (GLuint program, GLuint uniformBlockIndex, GLenum pname, GLint *params)
/// ```
void glGetActiveUniformBlockiv(int program, int uniformBlockIndex, int pname, Pointer<Int32>? params) {
  final _glGetActiveUniformBlockiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformBlockIndex, Uint32 pname, Pointer<Int32>? params),
      void Function(int program, int uniformBlockIndex, int pname, Pointer<Int32>? params)>('glGetActiveUniformBlockiv');
  return _glGetActiveUniformBlockiv(program, uniformBlockIndex, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveUniformBlockName (GLuint program, GLuint uniformBlockIndex, GLsizei bufSize, GLsizei *length, GLchar *uniformBlockName)
/// ```
void glGetActiveUniformBlockName(int program, int uniformBlockIndex, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformBlockName) {
  final _glGetActiveUniformBlockName = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformBlockIndex, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformBlockName),
      void Function(int program, int uniformBlockIndex, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? uniformBlockName)>('glGetActiveUniformBlockName');
  return _glGetActiveUniformBlockName(program, uniformBlockIndex, bufSize, length, uniformBlockName);
}

/// ```c
/// GLAPI void APIENTRY glUniformBlockBinding (GLuint program, GLuint uniformBlockIndex, GLuint uniformBlockBinding)
/// ```
void glUniformBlockBinding(int program, int uniformBlockIndex, int uniformBlockBinding) {
  final _glUniformBlockBinding = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 uniformBlockIndex, Uint32 uniformBlockBinding),
      void Function(int program, int uniformBlockIndex, int uniformBlockBinding)>('glUniformBlockBinding');
  return _glUniformBlockBinding(program, uniformBlockIndex, uniformBlockBinding);
}

/// ```c
/// GLAPI void APIENTRY glCopyBufferSubData (GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size)
/// ```
void glCopyBufferSubData(int readTarget, int writeTarget, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size) {
  final _glCopyBufferSubData = _SDL2.lookupFunction<
      Void Function(Uint32 readTarget, Uint32 writeTarget, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size),
      void Function(int readTarget, int writeTarget, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size)>('glCopyBufferSubData');
  return _glCopyBufferSubData(readTarget, writeTarget, readOffset, writeOffset, size);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsBaseVertex (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLint basevertex)
/// ```
void glDrawElementsBaseVertex(int mode, int count, int type, Pointer<Void>? indices, int basevertex) {
  final _glDrawElementsBaseVertex = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count, Uint32 type, Pointer<Void>? indices, Int32 basevertex),
      void Function(int mode, int count, int type, Pointer<Void>? indices, int basevertex)>('glDrawElementsBaseVertex');
  return _glDrawElementsBaseVertex(mode, count, type, indices, basevertex);
}

/// ```c
/// GLAPI void APIENTRY glDrawRangeElementsBaseVertex (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices, GLint basevertex)
/// ```
void glDrawRangeElementsBaseVertex(int mode, int start, int end, int count, int type, Pointer<Void>? indices, int basevertex) {
  final _glDrawRangeElementsBaseVertex = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Uint32 count, Uint32 type, Pointer<Void>? indices, Int32 basevertex),
      void Function(int mode, int start, int end, int count, int type, Pointer<Void>? indices, int basevertex)>('glDrawRangeElementsBaseVertex');
  return _glDrawRangeElementsBaseVertex(mode, start, end, count, type, indices, basevertex);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsInstancedBaseVertex (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount, GLint basevertex)
/// ```
void glDrawElementsInstancedBaseVertex(int mode, int count, int type, Pointer<Void>? indices, int primcount, int basevertex) {
  final _glDrawElementsInstancedBaseVertex = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count, Uint32 type, Pointer<Void>? indices, Uint32 primcount, Int32 basevertex),
      void Function(int mode, int count, int type, Pointer<Void>? indices, int primcount, int basevertex)>('glDrawElementsInstancedBaseVertex');
  return _glDrawElementsInstancedBaseVertex(mode, count, type, indices, primcount, basevertex);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawElementsBaseVertex (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount, const GLint *basevertex)
/// ```
void glMultiDrawElementsBaseVertex(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount, Pointer<Int32>? basevertex) {
  final _glMultiDrawElementsBaseVertex = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Uint32>? count, Uint32 type, Pointer<Pointer<Void>>? indices, Uint32 primcount, Pointer<Int32>? basevertex),
      void Function(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount, Pointer<Int32>? basevertex)>('glMultiDrawElementsBaseVertex');
  return _glMultiDrawElementsBaseVertex(mode, count, type, indices, primcount, basevertex);
}

/// ```c
/// GLAPI void APIENTRY glProvokingVertex (GLenum mode)
/// ```
void glProvokingVertex(int mode) {
  final _glProvokingVertex = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glProvokingVertex');
  return _glProvokingVertex(mode);
}

/// ```c
/// GLAPI GLsync APIENTRY glFenceSync (GLenum condition, GLbitfield flags)
/// ```
Pointer<Void>? glFenceSync(int condition, int flags) {
  final _glFenceSync = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 condition, Uint32 flags),
      Pointer<Void>? Function(int condition, int flags)>('glFenceSync');
  return _glFenceSync(condition, flags);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsSync (GLsync sync)
/// ```
int glIsSync(Pointer<Void>? sync) {
  final _glIsSync = _SDL2.lookupFunction<
      Int32 Function(Pointer<Void>? sync),
      int Function(Pointer<Void>? sync)>('glIsSync');
  return _glIsSync(sync);
}

/// ```c
/// GLAPI void APIENTRY glDeleteSync (GLsync sync)
/// ```
void glDeleteSync(Pointer<Void>? sync) {
  final _glDeleteSync = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? sync),
      void Function(Pointer<Void>? sync)>('glDeleteSync');
  return _glDeleteSync(sync);
}

/// ```c
/// GLAPI GLenum APIENTRY glClientWaitSync (GLsync sync, GLbitfield flags, GLuint64 timeout)
/// ```
int glClientWaitSync(Pointer<Void>? sync, int flags, int timeout) {
  final _glClientWaitSync = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Void>? sync, Uint32 flags, Uint64 timeout),
      int Function(Pointer<Void>? sync, int flags, int timeout)>('glClientWaitSync');
  return _glClientWaitSync(sync, flags, timeout);
}

/// ```c
/// GLAPI void APIENTRY glWaitSync (GLsync sync, GLbitfield flags, GLuint64 timeout)
/// ```
void glWaitSync(Pointer<Void>? sync, int flags, int timeout) {
  final _glWaitSync = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? sync, Uint32 flags, Uint64 timeout),
      void Function(Pointer<Void>? sync, int flags, int timeout)>('glWaitSync');
  return _glWaitSync(sync, flags, timeout);
}

/// ```c
/// GLAPI void APIENTRY glGetInteger64v (GLenum pname, GLint64 *params)
/// ```
void glGetInteger64v(int pname, Pointer<Int64>? params) {
  final _glGetInteger64v = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int64>? params),
      void Function(int pname, Pointer<Int64>? params)>('glGetInteger64v');
  return _glGetInteger64v(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSynciv (GLsync sync, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values)
/// ```
void glGetSynciv(Pointer<Void>? sync, int pname, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? values) {
  final _glGetSynciv = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? sync, Uint32 pname, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int32>? values),
      void Function(Pointer<Void>? sync, int pname, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? values)>('glGetSynciv');
  return _glGetSynciv(sync, pname, bufSize, length, values);
}

/// ```c
/// GLAPI void APIENTRY glTexImage2DMultisample (GLenum target, GLsizei samples, GLint internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations)
/// ```
void glTexImage2DMultisample(int target, int samples, int internalformat, int width, int height, int fixedsamplelocations) {
  final _glTexImage2DMultisample = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 samples, Int32 internalformat, Uint32 width, Uint32 height, Int32 fixedsamplelocations),
      void Function(int target, int samples, int internalformat, int width, int height, int fixedsamplelocations)>('glTexImage2DMultisample');
  return _glTexImage2DMultisample(target, samples, internalformat, width, height, fixedsamplelocations);
}

/// ```c
/// GLAPI void APIENTRY glTexImage3DMultisample (GLenum target, GLsizei samples, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
/// ```
void glTexImage3DMultisample(int target, int samples, int internalformat, int width, int height, int depth, int fixedsamplelocations) {
  final _glTexImage3DMultisample = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 samples, Int32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 fixedsamplelocations),
      void Function(int target, int samples, int internalformat, int width, int height, int depth, int fixedsamplelocations)>('glTexImage3DMultisample');
  return _glTexImage3DMultisample(target, samples, internalformat, width, height, depth, fixedsamplelocations);
}

/// ```c
/// GLAPI void APIENTRY glGetMultisamplefv (GLenum pname, GLuint index, GLfloat *val)
/// ```
void glGetMultisamplefv(int pname, int index, Pointer<Float>? val) {
  final _glGetMultisamplefv = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Uint32 index, Pointer<Float>? val),
      void Function(int pname, int index, Pointer<Float>? val)>('glGetMultisamplefv');
  return _glGetMultisamplefv(pname, index, val);
}

/// ```c
/// GLAPI void APIENTRY glSampleMaski (GLuint index, GLbitfield mask)
/// ```
void glSampleMaski(int index, int mask) {
  final _glSampleMaski = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 mask),
      void Function(int index, int mask)>('glSampleMaski');
  return _glSampleMaski(index, mask);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationiARB (GLuint buf, GLenum mode)
/// ```
void glBlendEquationiARB(int buf, int mode) {
  final _glBlendEquationiARB = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 mode),
      void Function(int buf, int mode)>('glBlendEquationiARB');
  return _glBlendEquationiARB(buf, mode);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationSeparateiARB (GLuint buf, GLenum modeRGB, GLenum modeAlpha)
/// ```
void glBlendEquationSeparateiARB(int buf, int modeRGB, int modeAlpha) {
  final _glBlendEquationSeparateiARB = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 modeRGB, Uint32 modeAlpha),
      void Function(int buf, int modeRGB, int modeAlpha)>('glBlendEquationSeparateiARB');
  return _glBlendEquationSeparateiARB(buf, modeRGB, modeAlpha);
}

/// ```c
/// GLAPI void APIENTRY glBlendFunciARB (GLuint buf, GLenum src, GLenum dst)
/// ```
void glBlendFunciARB(int buf, int src, int dst) {
  final _glBlendFunciARB = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 src, Uint32 dst),
      void Function(int buf, int src, int dst)>('glBlendFunciARB');
  return _glBlendFunciARB(buf, src, dst);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparateiARB (GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
/// ```
void glBlendFuncSeparateiARB(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha) {
  final _glBlendFuncSeparateiARB = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 srcRGB, Uint32 dstRGB, Uint32 srcAlpha, Uint32 dstAlpha),
      void Function(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha)>('glBlendFuncSeparateiARB');
  return _glBlendFuncSeparateiARB(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
}

/// ```c
/// GLAPI void APIENTRY glMinSampleShadingARB (GLclampf value)
/// ```
void glMinSampleShadingARB(double value) {
  final _glMinSampleShadingARB = _SDL2.lookupFunction<
      Void Function(Float value),
      void Function(double value)>('glMinSampleShadingARB');
  return _glMinSampleShadingARB(value);
}

/// ```c
/// GLAPI void APIENTRY glNamedStringARB (GLenum type, GLint namelen, const GLchar *name, GLint stringlen, const GLchar *string)
/// ```
void glNamedStringARB(int type, int namelen, String name, int stringlen, String string) {
  final _glNamedStringARB = _SDL2.lookupFunction<
      Void Function(Uint32 type, Int32 namelen, Pointer<Utf8>? name, Int32 stringlen, Pointer<Utf8>? string),
      void Function(int type, int namelen, Pointer<Utf8>? name, int stringlen, Pointer<Utf8>? string)>('glNamedStringARB');
  final _namePointer = name.toNativeUtf8();
  final _stringPointer = string.toNativeUtf8();
  final _result = _glNamedStringARB(type, namelen, _namePointer, stringlen, _stringPointer);
  calloc.free(_namePointer);
  calloc.free(_stringPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glDeleteNamedStringARB (GLint namelen, const GLchar *name)
/// ```
void glDeleteNamedStringARB(int namelen, String name) {
  final _glDeleteNamedStringARB = _SDL2.lookupFunction<
      Void Function(Int32 namelen, Pointer<Utf8>? name),
      void Function(int namelen, Pointer<Utf8>? name)>('glDeleteNamedStringARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glDeleteNamedStringARB(namelen, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glCompileShaderIncludeARB (GLuint shader, GLsizei count, const GLchar* *path, const GLint *length)
/// ```
void glCompileShaderIncludeARB(int shader, int count, Pointer<Pointer<Int8>>? path, Pointer<Int32>? length) {
  final _glCompileShaderIncludeARB = _SDL2.lookupFunction<
      Void Function(Uint32 shader, Uint32 count, Pointer<Pointer<Int8>>? path, Pointer<Int32>? length),
      void Function(int shader, int count, Pointer<Pointer<Int8>>? path, Pointer<Int32>? length)>('glCompileShaderIncludeARB');
  return _glCompileShaderIncludeARB(shader, count, path, length);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsNamedStringARB (GLint namelen, const GLchar *name)
/// ```
int glIsNamedStringARB(int namelen, String name) {
  final _glIsNamedStringARB = _SDL2.lookupFunction<
      Int32 Function(Int32 namelen, Pointer<Utf8>? name),
      int Function(int namelen, Pointer<Utf8>? name)>('glIsNamedStringARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glIsNamedStringARB(namelen, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetNamedStringARB (GLint namelen, const GLchar *name, GLsizei bufSize, GLint *stringlen, GLchar *string)
/// ```
void glGetNamedStringARB(int namelen, String name, int bufSize, Pointer<Int32>? stringlen, Pointer<Int8>? string) {
  final _glGetNamedStringARB = _SDL2.lookupFunction<
      Void Function(Int32 namelen, Pointer<Utf8>? name, Uint32 bufSize, Pointer<Int32>? stringlen, Pointer<Int8>? string),
      void Function(int namelen, Pointer<Utf8>? name, int bufSize, Pointer<Int32>? stringlen, Pointer<Int8>? string)>('glGetNamedStringARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetNamedStringARB(namelen, _namePointer, bufSize, stringlen, string);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetNamedStringivARB (GLint namelen, const GLchar *name, GLenum pname, GLint *params)
/// ```
void glGetNamedStringivARB(int namelen, String name, int pname, Pointer<Int32>? params) {
  final _glGetNamedStringivARB = _SDL2.lookupFunction<
      Void Function(Int32 namelen, Pointer<Utf8>? name, Uint32 pname, Pointer<Int32>? params),
      void Function(int namelen, Pointer<Utf8>? name, int pname, Pointer<Int32>? params)>('glGetNamedStringivARB');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetNamedStringivARB(namelen, _namePointer, pname, params);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glBindFragDataLocationIndexed (GLuint program, GLuint colorNumber, GLuint index, const GLchar *name)
/// ```
void glBindFragDataLocationIndexed(int program, int colorNumber, int index, String name) {
  final _glBindFragDataLocationIndexed = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 colorNumber, Uint32 index, Pointer<Utf8>? name),
      void Function(int program, int colorNumber, int index, Pointer<Utf8>? name)>('glBindFragDataLocationIndexed');
  final _namePointer = name.toNativeUtf8();
  final _result = _glBindFragDataLocationIndexed(program, colorNumber, index, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI GLint APIENTRY glGetFragDataIndex (GLuint program, const GLchar *name)
/// ```
int glGetFragDataIndex(int program, String name) {
  final _glGetFragDataIndex = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetFragDataIndex');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetFragDataIndex(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGenSamplers (GLsizei count, GLuint *samplers)
/// ```
void glGenSamplers(int count, Pointer<Uint32>? samplers) {
  final _glGenSamplers = _SDL2.lookupFunction<
      Void Function(Uint32 count, Pointer<Uint32>? samplers),
      void Function(int count, Pointer<Uint32>? samplers)>('glGenSamplers');
  return _glGenSamplers(count, samplers);
}

/// ```c
/// GLAPI void APIENTRY glDeleteSamplers (GLsizei count, const GLuint *samplers)
/// ```
void glDeleteSamplers(int count, Pointer<Uint32>? samplers) {
  final _glDeleteSamplers = _SDL2.lookupFunction<
      Void Function(Uint32 count, Pointer<Uint32>? samplers),
      void Function(int count, Pointer<Uint32>? samplers)>('glDeleteSamplers');
  return _glDeleteSamplers(count, samplers);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsSampler (GLuint sampler)
/// ```
int glIsSampler(int sampler) {
  final _glIsSampler = _SDL2.lookupFunction<
      Int32 Function(Uint32 sampler),
      int Function(int sampler)>('glIsSampler');
  return _glIsSampler(sampler);
}

/// ```c
/// GLAPI void APIENTRY glBindSampler (GLuint unit, GLuint sampler)
/// ```
void glBindSampler(int unit, int sampler) {
  final _glBindSampler = _SDL2.lookupFunction<
      Void Function(Uint32 unit, Uint32 sampler),
      void Function(int unit, int sampler)>('glBindSampler');
  return _glBindSampler(unit, sampler);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameteri (GLuint sampler, GLenum pname, GLint param)
/// ```
void glSamplerParameteri(int sampler, int pname, int param) {
  final _glSamplerParameteri = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Int32 param),
      void Function(int sampler, int pname, int param)>('glSamplerParameteri');
  return _glSamplerParameteri(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameteriv (GLuint sampler, GLenum pname, const GLint *param)
/// ```
void glSamplerParameteriv(int sampler, int pname, Pointer<Int32>? param) {
  final _glSamplerParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Int32>? param),
      void Function(int sampler, int pname, Pointer<Int32>? param)>('glSamplerParameteriv');
  return _glSamplerParameteriv(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameterf (GLuint sampler, GLenum pname, GLfloat param)
/// ```
void glSamplerParameterf(int sampler, int pname, double param) {
  final _glSamplerParameterf = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Float param),
      void Function(int sampler, int pname, double param)>('glSamplerParameterf');
  return _glSamplerParameterf(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameterfv (GLuint sampler, GLenum pname, const GLfloat *param)
/// ```
void glSamplerParameterfv(int sampler, int pname, Pointer<Float>? param) {
  final _glSamplerParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Float>? param),
      void Function(int sampler, int pname, Pointer<Float>? param)>('glSamplerParameterfv');
  return _glSamplerParameterfv(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameterIiv (GLuint sampler, GLenum pname, const GLint *param)
/// ```
void glSamplerParameterIiv(int sampler, int pname, Pointer<Int32>? param) {
  final _glSamplerParameterIiv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Int32>? param),
      void Function(int sampler, int pname, Pointer<Int32>? param)>('glSamplerParameterIiv');
  return _glSamplerParameterIiv(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSamplerParameterIuiv (GLuint sampler, GLenum pname, const GLuint *param)
/// ```
void glSamplerParameterIuiv(int sampler, int pname, Pointer<Uint32>? param) {
  final _glSamplerParameterIuiv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Uint32>? param),
      void Function(int sampler, int pname, Pointer<Uint32>? param)>('glSamplerParameterIuiv');
  return _glSamplerParameterIuiv(sampler, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glGetSamplerParameteriv (GLuint sampler, GLenum pname, GLint *params)
/// ```
void glGetSamplerParameteriv(int sampler, int pname, Pointer<Int32>? params) {
  final _glGetSamplerParameteriv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Int32>? params),
      void Function(int sampler, int pname, Pointer<Int32>? params)>('glGetSamplerParameteriv');
  return _glGetSamplerParameteriv(sampler, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSamplerParameterIiv (GLuint sampler, GLenum pname, GLint *params)
/// ```
void glGetSamplerParameterIiv(int sampler, int pname, Pointer<Int32>? params) {
  final _glGetSamplerParameterIiv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Int32>? params),
      void Function(int sampler, int pname, Pointer<Int32>? params)>('glGetSamplerParameterIiv');
  return _glGetSamplerParameterIiv(sampler, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSamplerParameterfv (GLuint sampler, GLenum pname, GLfloat *params)
/// ```
void glGetSamplerParameterfv(int sampler, int pname, Pointer<Float>? params) {
  final _glGetSamplerParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Float>? params),
      void Function(int sampler, int pname, Pointer<Float>? params)>('glGetSamplerParameterfv');
  return _glGetSamplerParameterfv(sampler, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSamplerParameterIuiv (GLuint sampler, GLenum pname, GLuint *params)
/// ```
void glGetSamplerParameterIuiv(int sampler, int pname, Pointer<Uint32>? params) {
  final _glGetSamplerParameterIuiv = _SDL2.lookupFunction<
      Void Function(Uint32 sampler, Uint32 pname, Pointer<Uint32>? params),
      void Function(int sampler, int pname, Pointer<Uint32>? params)>('glGetSamplerParameterIuiv');
  return _glGetSamplerParameterIuiv(sampler, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glQueryCounter (GLuint id, GLenum target)
/// ```
void glQueryCounter(int id, int target) {
  final _glQueryCounter = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 target),
      void Function(int id, int target)>('glQueryCounter');
  return _glQueryCounter(id, target);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjecti64v (GLuint id, GLenum pname, GLint64 *params)
/// ```
void glGetQueryObjecti64v(int id, int pname, Pointer<Int64>? params) {
  final _glGetQueryObjecti64v = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int64>? params),
      void Function(int id, int pname, Pointer<Int64>? params)>('glGetQueryObjecti64v');
  return _glGetQueryObjecti64v(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectui64v (GLuint id, GLenum pname, GLuint64 *params)
/// ```
void glGetQueryObjectui64v(int id, int pname, Pointer<Uint64>? params) {
  final _glGetQueryObjectui64v = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint64>? params),
      void Function(int id, int pname, Pointer<Uint64>? params)>('glGetQueryObjectui64v');
  return _glGetQueryObjectui64v(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVertexP2ui (GLenum type, GLuint value)
/// ```
void glVertexP2ui(int type, int value) {
  final _glVertexP2ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 value),
      void Function(int type, int value)>('glVertexP2ui');
  return _glVertexP2ui(type, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexP2uiv (GLenum type, const GLuint *value)
/// ```
void glVertexP2uiv(int type, Pointer<Uint32>? value) {
  final _glVertexP2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? value),
      void Function(int type, Pointer<Uint32>? value)>('glVertexP2uiv');
  return _glVertexP2uiv(type, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexP3ui (GLenum type, GLuint value)
/// ```
void glVertexP3ui(int type, int value) {
  final _glVertexP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 value),
      void Function(int type, int value)>('glVertexP3ui');
  return _glVertexP3ui(type, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexP3uiv (GLenum type, const GLuint *value)
/// ```
void glVertexP3uiv(int type, Pointer<Uint32>? value) {
  final _glVertexP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? value),
      void Function(int type, Pointer<Uint32>? value)>('glVertexP3uiv');
  return _glVertexP3uiv(type, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexP4ui (GLenum type, GLuint value)
/// ```
void glVertexP4ui(int type, int value) {
  final _glVertexP4ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 value),
      void Function(int type, int value)>('glVertexP4ui');
  return _glVertexP4ui(type, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexP4uiv (GLenum type, const GLuint *value)
/// ```
void glVertexP4uiv(int type, Pointer<Uint32>? value) {
  final _glVertexP4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? value),
      void Function(int type, Pointer<Uint32>? value)>('glVertexP4uiv');
  return _glVertexP4uiv(type, value);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP1ui (GLenum type, GLuint coords)
/// ```
void glTexCoordP1ui(int type, int coords) {
  final _glTexCoordP1ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 coords),
      void Function(int type, int coords)>('glTexCoordP1ui');
  return _glTexCoordP1ui(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP1uiv (GLenum type, const GLuint *coords)
/// ```
void glTexCoordP1uiv(int type, Pointer<Uint32>? coords) {
  final _glTexCoordP1uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? coords),
      void Function(int type, Pointer<Uint32>? coords)>('glTexCoordP1uiv');
  return _glTexCoordP1uiv(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP2ui (GLenum type, GLuint coords)
/// ```
void glTexCoordP2ui(int type, int coords) {
  final _glTexCoordP2ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 coords),
      void Function(int type, int coords)>('glTexCoordP2ui');
  return _glTexCoordP2ui(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP2uiv (GLenum type, const GLuint *coords)
/// ```
void glTexCoordP2uiv(int type, Pointer<Uint32>? coords) {
  final _glTexCoordP2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? coords),
      void Function(int type, Pointer<Uint32>? coords)>('glTexCoordP2uiv');
  return _glTexCoordP2uiv(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP3ui (GLenum type, GLuint coords)
/// ```
void glTexCoordP3ui(int type, int coords) {
  final _glTexCoordP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 coords),
      void Function(int type, int coords)>('glTexCoordP3ui');
  return _glTexCoordP3ui(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP3uiv (GLenum type, const GLuint *coords)
/// ```
void glTexCoordP3uiv(int type, Pointer<Uint32>? coords) {
  final _glTexCoordP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? coords),
      void Function(int type, Pointer<Uint32>? coords)>('glTexCoordP3uiv');
  return _glTexCoordP3uiv(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP4ui (GLenum type, GLuint coords)
/// ```
void glTexCoordP4ui(int type, int coords) {
  final _glTexCoordP4ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 coords),
      void Function(int type, int coords)>('glTexCoordP4ui');
  return _glTexCoordP4ui(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordP4uiv (GLenum type, const GLuint *coords)
/// ```
void glTexCoordP4uiv(int type, Pointer<Uint32>? coords) {
  final _glTexCoordP4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? coords),
      void Function(int type, Pointer<Uint32>? coords)>('glTexCoordP4uiv');
  return _glTexCoordP4uiv(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP1ui (GLenum texture, GLenum type, GLuint coords)
/// ```
void glMultiTexCoordP1ui(int texture, int type, int coords) {
  final _glMultiTexCoordP1ui = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Uint32 coords),
      void Function(int texture, int type, int coords)>('glMultiTexCoordP1ui');
  return _glMultiTexCoordP1ui(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP1uiv (GLenum texture, GLenum type, const GLuint *coords)
/// ```
void glMultiTexCoordP1uiv(int texture, int type, Pointer<Uint32>? coords) {
  final _glMultiTexCoordP1uiv = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Pointer<Uint32>? coords),
      void Function(int texture, int type, Pointer<Uint32>? coords)>('glMultiTexCoordP1uiv');
  return _glMultiTexCoordP1uiv(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP2ui (GLenum texture, GLenum type, GLuint coords)
/// ```
void glMultiTexCoordP2ui(int texture, int type, int coords) {
  final _glMultiTexCoordP2ui = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Uint32 coords),
      void Function(int texture, int type, int coords)>('glMultiTexCoordP2ui');
  return _glMultiTexCoordP2ui(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP2uiv (GLenum texture, GLenum type, const GLuint *coords)
/// ```
void glMultiTexCoordP2uiv(int texture, int type, Pointer<Uint32>? coords) {
  final _glMultiTexCoordP2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Pointer<Uint32>? coords),
      void Function(int texture, int type, Pointer<Uint32>? coords)>('glMultiTexCoordP2uiv');
  return _glMultiTexCoordP2uiv(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP3ui (GLenum texture, GLenum type, GLuint coords)
/// ```
void glMultiTexCoordP3ui(int texture, int type, int coords) {
  final _glMultiTexCoordP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Uint32 coords),
      void Function(int texture, int type, int coords)>('glMultiTexCoordP3ui');
  return _glMultiTexCoordP3ui(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP3uiv (GLenum texture, GLenum type, const GLuint *coords)
/// ```
void glMultiTexCoordP3uiv(int texture, int type, Pointer<Uint32>? coords) {
  final _glMultiTexCoordP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Pointer<Uint32>? coords),
      void Function(int texture, int type, Pointer<Uint32>? coords)>('glMultiTexCoordP3uiv');
  return _glMultiTexCoordP3uiv(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP4ui (GLenum texture, GLenum type, GLuint coords)
/// ```
void glMultiTexCoordP4ui(int texture, int type, int coords) {
  final _glMultiTexCoordP4ui = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Uint32 coords),
      void Function(int texture, int type, int coords)>('glMultiTexCoordP4ui');
  return _glMultiTexCoordP4ui(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordP4uiv (GLenum texture, GLenum type, const GLuint *coords)
/// ```
void glMultiTexCoordP4uiv(int texture, int type, Pointer<Uint32>? coords) {
  final _glMultiTexCoordP4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 type, Pointer<Uint32>? coords),
      void Function(int texture, int type, Pointer<Uint32>? coords)>('glMultiTexCoordP4uiv');
  return _glMultiTexCoordP4uiv(texture, type, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalP3ui (GLenum type, GLuint coords)
/// ```
void glNormalP3ui(int type, int coords) {
  final _glNormalP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 coords),
      void Function(int type, int coords)>('glNormalP3ui');
  return _glNormalP3ui(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalP3uiv (GLenum type, const GLuint *coords)
/// ```
void glNormalP3uiv(int type, Pointer<Uint32>? coords) {
  final _glNormalP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? coords),
      void Function(int type, Pointer<Uint32>? coords)>('glNormalP3uiv');
  return _glNormalP3uiv(type, coords);
}

/// ```c
/// GLAPI void APIENTRY glColorP3ui (GLenum type, GLuint color)
/// ```
void glColorP3ui(int type, int color) {
  final _glColorP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 color),
      void Function(int type, int color)>('glColorP3ui');
  return _glColorP3ui(type, color);
}

/// ```c
/// GLAPI void APIENTRY glColorP3uiv (GLenum type, const GLuint *color)
/// ```
void glColorP3uiv(int type, Pointer<Uint32>? color) {
  final _glColorP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? color),
      void Function(int type, Pointer<Uint32>? color)>('glColorP3uiv');
  return _glColorP3uiv(type, color);
}

/// ```c
/// GLAPI void APIENTRY glColorP4ui (GLenum type, GLuint color)
/// ```
void glColorP4ui(int type, int color) {
  final _glColorP4ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 color),
      void Function(int type, int color)>('glColorP4ui');
  return _glColorP4ui(type, color);
}

/// ```c
/// GLAPI void APIENTRY glColorP4uiv (GLenum type, const GLuint *color)
/// ```
void glColorP4uiv(int type, Pointer<Uint32>? color) {
  final _glColorP4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? color),
      void Function(int type, Pointer<Uint32>? color)>('glColorP4uiv');
  return _glColorP4uiv(type, color);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorP3ui (GLenum type, GLuint color)
/// ```
void glSecondaryColorP3ui(int type, int color) {
  final _glSecondaryColorP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 color),
      void Function(int type, int color)>('glSecondaryColorP3ui');
  return _glSecondaryColorP3ui(type, color);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorP3uiv (GLenum type, const GLuint *color)
/// ```
void glSecondaryColorP3uiv(int type, Pointer<Uint32>? color) {
  final _glSecondaryColorP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Uint32>? color),
      void Function(int type, Pointer<Uint32>? color)>('glSecondaryColorP3uiv');
  return _glSecondaryColorP3uiv(type, color);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP1ui (GLuint index, GLenum type, GLboolean normalized, GLuint value)
/// ```
void glVertexAttribP1ui(int index, int type, int normalized, int value) {
  final _glVertexAttribP1ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Uint32 value),
      void Function(int index, int type, int normalized, int value)>('glVertexAttribP1ui');
  return _glVertexAttribP1ui(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP1uiv (GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
/// ```
void glVertexAttribP1uiv(int index, int type, int normalized, Pointer<Uint32>? value) {
  final _glVertexAttribP1uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Pointer<Uint32>? value),
      void Function(int index, int type, int normalized, Pointer<Uint32>? value)>('glVertexAttribP1uiv');
  return _glVertexAttribP1uiv(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP2ui (GLuint index, GLenum type, GLboolean normalized, GLuint value)
/// ```
void glVertexAttribP2ui(int index, int type, int normalized, int value) {
  final _glVertexAttribP2ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Uint32 value),
      void Function(int index, int type, int normalized, int value)>('glVertexAttribP2ui');
  return _glVertexAttribP2ui(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP2uiv (GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
/// ```
void glVertexAttribP2uiv(int index, int type, int normalized, Pointer<Uint32>? value) {
  final _glVertexAttribP2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Pointer<Uint32>? value),
      void Function(int index, int type, int normalized, Pointer<Uint32>? value)>('glVertexAttribP2uiv');
  return _glVertexAttribP2uiv(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP3ui (GLuint index, GLenum type, GLboolean normalized, GLuint value)
/// ```
void glVertexAttribP3ui(int index, int type, int normalized, int value) {
  final _glVertexAttribP3ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Uint32 value),
      void Function(int index, int type, int normalized, int value)>('glVertexAttribP3ui');
  return _glVertexAttribP3ui(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP3uiv (GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
/// ```
void glVertexAttribP3uiv(int index, int type, int normalized, Pointer<Uint32>? value) {
  final _glVertexAttribP3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Pointer<Uint32>? value),
      void Function(int index, int type, int normalized, Pointer<Uint32>? value)>('glVertexAttribP3uiv');
  return _glVertexAttribP3uiv(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP4ui (GLuint index, GLenum type, GLboolean normalized, GLuint value)
/// ```
void glVertexAttribP4ui(int index, int type, int normalized, int value) {
  final _glVertexAttribP4ui = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Uint32 value),
      void Function(int index, int type, int normalized, int value)>('glVertexAttribP4ui');
  return _glVertexAttribP4ui(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribP4uiv (GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
/// ```
void glVertexAttribP4uiv(int index, int type, int normalized, Pointer<Uint32>? value) {
  final _glVertexAttribP4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 type, Int32 normalized, Pointer<Uint32>? value),
      void Function(int index, int type, int normalized, Pointer<Uint32>? value)>('glVertexAttribP4uiv');
  return _glVertexAttribP4uiv(index, type, normalized, value);
}

/// ```c
/// GLAPI void APIENTRY glDrawArraysIndirect (GLenum mode, const GLvoid *indirect)
/// ```
void glDrawArraysIndirect(int mode, Pointer<Void>? indirect) {
  final _glDrawArraysIndirect = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Void>? indirect),
      void Function(int mode, Pointer<Void>? indirect)>('glDrawArraysIndirect');
  return _glDrawArraysIndirect(mode, indirect);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsIndirect (GLenum mode, GLenum type, const GLvoid *indirect)
/// ```
void glDrawElementsIndirect(int mode, int type, Pointer<Void>? indirect) {
  final _glDrawElementsIndirect = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 type, Pointer<Void>? indirect),
      void Function(int mode, int type, Pointer<Void>? indirect)>('glDrawElementsIndirect');
  return _glDrawElementsIndirect(mode, type, indirect);
}

/// ```c
/// GLAPI void APIENTRY glUniform1d (GLint location, GLdouble x)
/// ```
void glUniform1d(int location, double x) {
  final _glUniform1d = _SDL2.lookupFunction<
      Void Function(Int32 location, Double x),
      void Function(int location, double x)>('glUniform1d');
  return _glUniform1d(location, x);
}

/// ```c
/// GLAPI void APIENTRY glUniform2d (GLint location, GLdouble x, GLdouble y)
/// ```
void glUniform2d(int location, double x, double y) {
  final _glUniform2d = _SDL2.lookupFunction<
      Void Function(Int32 location, Double x, Double y),
      void Function(int location, double x, double y)>('glUniform2d');
  return _glUniform2d(location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glUniform3d (GLint location, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glUniform3d(int location, double x, double y, double z) {
  final _glUniform3d = _SDL2.lookupFunction<
      Void Function(Int32 location, Double x, Double y, Double z),
      void Function(int location, double x, double y, double z)>('glUniform3d');
  return _glUniform3d(location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glUniform4d (GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glUniform4d(int location, double x, double y, double z, double w) {
  final _glUniform4d = _SDL2.lookupFunction<
      Void Function(Int32 location, Double x, Double y, Double z, Double w),
      void Function(int location, double x, double y, double z, double w)>('glUniform4d');
  return _glUniform4d(location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glUniform1dv (GLint location, GLsizei count, const GLdouble *value)
/// ```
void glUniform1dv(int location, int count, Pointer<Double>? value) {
  final _glUniform1dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int location, int count, Pointer<Double>? value)>('glUniform1dv');
  return _glUniform1dv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2dv (GLint location, GLsizei count, const GLdouble *value)
/// ```
void glUniform2dv(int location, int count, Pointer<Double>? value) {
  final _glUniform2dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int location, int count, Pointer<Double>? value)>('glUniform2dv');
  return _glUniform2dv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3dv (GLint location, GLsizei count, const GLdouble *value)
/// ```
void glUniform3dv(int location, int count, Pointer<Double>? value) {
  final _glUniform3dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int location, int count, Pointer<Double>? value)>('glUniform3dv');
  return _glUniform3dv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4dv (GLint location, GLsizei count, const GLdouble *value)
/// ```
void glUniform4dv(int location, int count, Pointer<Double>? value) {
  final _glUniform4dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int location, int count, Pointer<Double>? value)>('glUniform4dv');
  return _glUniform4dv(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix2dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix2dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix2dv');
  return _glUniformMatrix2dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix3dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix3dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix3dv');
  return _glUniformMatrix3dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix4dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix4dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix4dv');
  return _glUniformMatrix4dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2x3dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix2x3dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix2x3dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix2x3dv');
  return _glUniformMatrix2x3dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix2x4dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix2x4dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix2x4dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix2x4dv');
  return _glUniformMatrix2x4dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3x2dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix3x2dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix3x2dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix3x2dv');
  return _glUniformMatrix3x2dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix3x4dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix3x4dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix3x4dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix3x4dv');
  return _glUniformMatrix3x4dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4x2dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix4x2dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix4x2dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix4x2dv');
  return _glUniformMatrix4x2dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformMatrix4x3dv (GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glUniformMatrix4x3dv(int location, int count, int transpose, Pointer<Double>? value) {
  final _glUniformMatrix4x3dv = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int location, int count, int transpose, Pointer<Double>? value)>('glUniformMatrix4x3dv');
  return _glUniformMatrix4x3dv(location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformdv (GLuint program, GLint location, GLdouble *params)
/// ```
void glGetUniformdv(int program, int location, Pointer<Double>? params) {
  final _glGetUniformdv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Double>? params),
      void Function(int program, int location, Pointer<Double>? params)>('glGetUniformdv');
  return _glGetUniformdv(program, location, params);
}

/// ```c
/// GLAPI GLint APIENTRY glGetSubroutineUniformLocation (GLuint program, GLenum shadertype, const GLchar *name)
/// ```
int glGetSubroutineUniformLocation(int program, int shadertype, String name) {
  final _glGetSubroutineUniformLocation = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Uint32 shadertype, Pointer<Utf8>? name),
      int Function(int program, int shadertype, Pointer<Utf8>? name)>('glGetSubroutineUniformLocation');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetSubroutineUniformLocation(program, shadertype, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI GLuint APIENTRY glGetSubroutineIndex (GLuint program, GLenum shadertype, const GLchar *name)
/// ```
int glGetSubroutineIndex(int program, int shadertype, String name) {
  final _glGetSubroutineIndex = _SDL2.lookupFunction<
      Uint32 Function(Uint32 program, Uint32 shadertype, Pointer<Utf8>? name),
      int Function(int program, int shadertype, Pointer<Utf8>? name)>('glGetSubroutineIndex');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetSubroutineIndex(program, shadertype, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetActiveSubroutineUniformiv (GLuint program, GLenum shadertype, GLuint index, GLenum pname, GLint *values)
/// ```
void glGetActiveSubroutineUniformiv(int program, int shadertype, int index, int pname, Pointer<Int32>? values) {
  final _glGetActiveSubroutineUniformiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shadertype, Uint32 index, Uint32 pname, Pointer<Int32>? values),
      void Function(int program, int shadertype, int index, int pname, Pointer<Int32>? values)>('glGetActiveSubroutineUniformiv');
  return _glGetActiveSubroutineUniformiv(program, shadertype, index, pname, values);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveSubroutineUniformName (GLuint program, GLenum shadertype, GLuint index, GLsizei bufsize, GLsizei *length, GLchar *name)
/// ```
void glGetActiveSubroutineUniformName(int program, int shadertype, int index, int bufsize, Pointer<Uint32>? length, Pointer<Int8>? name) {
  final _glGetActiveSubroutineUniformName = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shadertype, Uint32 index, Uint32 bufsize, Pointer<Uint32>? length, Pointer<Int8>? name),
      void Function(int program, int shadertype, int index, int bufsize, Pointer<Uint32>? length, Pointer<Int8>? name)>('glGetActiveSubroutineUniformName');
  return _glGetActiveSubroutineUniformName(program, shadertype, index, bufsize, length, name);
}

/// ```c
/// GLAPI void APIENTRY glGetActiveSubroutineName (GLuint program, GLenum shadertype, GLuint index, GLsizei bufsize, GLsizei *length, GLchar *name)
/// ```
void glGetActiveSubroutineName(int program, int shadertype, int index, int bufsize, Pointer<Uint32>? length, Pointer<Int8>? name) {
  final _glGetActiveSubroutineName = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shadertype, Uint32 index, Uint32 bufsize, Pointer<Uint32>? length, Pointer<Int8>? name),
      void Function(int program, int shadertype, int index, int bufsize, Pointer<Uint32>? length, Pointer<Int8>? name)>('glGetActiveSubroutineName');
  return _glGetActiveSubroutineName(program, shadertype, index, bufsize, length, name);
}

/// ```c
/// GLAPI void APIENTRY glUniformSubroutinesuiv (GLenum shadertype, GLsizei count, const GLuint *indices)
/// ```
void glUniformSubroutinesuiv(int shadertype, int count, Pointer<Uint32>? indices) {
  final _glUniformSubroutinesuiv = _SDL2.lookupFunction<
      Void Function(Uint32 shadertype, Uint32 count, Pointer<Uint32>? indices),
      void Function(int shadertype, int count, Pointer<Uint32>? indices)>('glUniformSubroutinesuiv');
  return _glUniformSubroutinesuiv(shadertype, count, indices);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformSubroutineuiv (GLenum shadertype, GLint location, GLuint *params)
/// ```
void glGetUniformSubroutineuiv(int shadertype, int location, Pointer<Uint32>? params) {
  final _glGetUniformSubroutineuiv = _SDL2.lookupFunction<
      Void Function(Uint32 shadertype, Int32 location, Pointer<Uint32>? params),
      void Function(int shadertype, int location, Pointer<Uint32>? params)>('glGetUniformSubroutineuiv');
  return _glGetUniformSubroutineuiv(shadertype, location, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramStageiv (GLuint program, GLenum shadertype, GLenum pname, GLint *values)
/// ```
void glGetProgramStageiv(int program, int shadertype, int pname, Pointer<Int32>? values) {
  final _glGetProgramStageiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 shadertype, Uint32 pname, Pointer<Int32>? values),
      void Function(int program, int shadertype, int pname, Pointer<Int32>? values)>('glGetProgramStageiv');
  return _glGetProgramStageiv(program, shadertype, pname, values);
}

/// ```c
/// GLAPI void APIENTRY glPatchParameteri (GLenum pname, GLint value)
/// ```
void glPatchParameteri(int pname, int value) {
  final _glPatchParameteri = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 value),
      void Function(int pname, int value)>('glPatchParameteri');
  return _glPatchParameteri(pname, value);
}

/// ```c
/// GLAPI void APIENTRY glPatchParameterfv (GLenum pname, const GLfloat *values)
/// ```
void glPatchParameterfv(int pname, Pointer<Float>? values) {
  final _glPatchParameterfv = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? values),
      void Function(int pname, Pointer<Float>? values)>('glPatchParameterfv');
  return _glPatchParameterfv(pname, values);
}

/// ```c
/// GLAPI void APIENTRY glBindTransformFeedback (GLenum target, GLuint id)
/// ```
void glBindTransformFeedback(int target, int id) {
  final _glBindTransformFeedback = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id),
      void Function(int target, int id)>('glBindTransformFeedback');
  return _glBindTransformFeedback(target, id);
}

/// ```c
/// GLAPI void APIENTRY glDeleteTransformFeedbacks (GLsizei n, const GLuint *ids)
/// ```
void glDeleteTransformFeedbacks(int n, Pointer<Uint32>? ids) {
  final _glDeleteTransformFeedbacks = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glDeleteTransformFeedbacks');
  return _glDeleteTransformFeedbacks(n, ids);
}

/// ```c
/// GLAPI void APIENTRY glGenTransformFeedbacks (GLsizei n, GLuint *ids)
/// ```
void glGenTransformFeedbacks(int n, Pointer<Uint32>? ids) {
  final _glGenTransformFeedbacks = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glGenTransformFeedbacks');
  return _glGenTransformFeedbacks(n, ids);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsTransformFeedback (GLuint id)
/// ```
int glIsTransformFeedback(int id) {
  final _glIsTransformFeedback = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsTransformFeedback');
  return _glIsTransformFeedback(id);
}

/// ```c
/// GLAPI void APIENTRY glPauseTransformFeedback (void)
/// ```
void glPauseTransformFeedback() {
  final _glPauseTransformFeedback = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glPauseTransformFeedback');
  return _glPauseTransformFeedback();
}

/// ```c
/// GLAPI void APIENTRY glResumeTransformFeedback (void)
/// ```
void glResumeTransformFeedback() {
  final _glResumeTransformFeedback = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glResumeTransformFeedback');
  return _glResumeTransformFeedback();
}

/// ```c
/// GLAPI void APIENTRY glDrawTransformFeedback (GLenum mode, GLuint id)
/// ```
void glDrawTransformFeedback(int mode, int id) {
  final _glDrawTransformFeedback = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 id),
      void Function(int mode, int id)>('glDrawTransformFeedback');
  return _glDrawTransformFeedback(mode, id);
}

/// ```c
/// GLAPI void APIENTRY glDrawTransformFeedbackStream (GLenum mode, GLuint id, GLuint stream)
/// ```
void glDrawTransformFeedbackStream(int mode, int id, int stream) {
  final _glDrawTransformFeedbackStream = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 id, Uint32 stream),
      void Function(int mode, int id, int stream)>('glDrawTransformFeedbackStream');
  return _glDrawTransformFeedbackStream(mode, id, stream);
}

/// ```c
/// GLAPI void APIENTRY glBeginQueryIndexed (GLenum target, GLuint index, GLuint id)
/// ```
void glBeginQueryIndexed(int target, int index, int id) {
  final _glBeginQueryIndexed = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 id),
      void Function(int target, int index, int id)>('glBeginQueryIndexed');
  return _glBeginQueryIndexed(target, index, id);
}

/// ```c
/// GLAPI void APIENTRY glEndQueryIndexed (GLenum target, GLuint index)
/// ```
void glEndQueryIndexed(int target, int index) {
  final _glEndQueryIndexed = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index),
      void Function(int target, int index)>('glEndQueryIndexed');
  return _glEndQueryIndexed(target, index);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryIndexediv (GLenum target, GLuint index, GLenum pname, GLint *params)
/// ```
void glGetQueryIndexediv(int target, int index, int pname, Pointer<Int32>? params) {
  final _glGetQueryIndexediv = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int index, int pname, Pointer<Int32>? params)>('glGetQueryIndexediv');
  return _glGetQueryIndexediv(target, index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glReleaseShaderCompiler (void)
/// ```
void glReleaseShaderCompiler() {
  final _glReleaseShaderCompiler = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glReleaseShaderCompiler');
  return _glReleaseShaderCompiler();
}

/// ```c
/// GLAPI void APIENTRY glShaderBinary (GLsizei count, const GLuint *shaders, GLenum binaryformat, const GLvoid *binary, GLsizei length)
/// ```
void glShaderBinary(int count, Pointer<Uint32>? shaders, int binaryformat, Pointer<Void>? binary, int length) {
  final _glShaderBinary = _SDL2.lookupFunction<
      Void Function(Uint32 count, Pointer<Uint32>? shaders, Uint32 binaryformat, Pointer<Void>? binary, Uint32 length),
      void Function(int count, Pointer<Uint32>? shaders, int binaryformat, Pointer<Void>? binary, int length)>('glShaderBinary');
  return _glShaderBinary(count, shaders, binaryformat, binary, length);
}

/// ```c
/// GLAPI void APIENTRY glGetShaderPrecisionFormat (GLenum shadertype, GLenum precisiontype, GLint *range, GLint *precision)
/// ```
void glGetShaderPrecisionFormat(int shadertype, int precisiontype, Pointer<Int32>? range, Pointer<Int32>? precision) {
  final _glGetShaderPrecisionFormat = _SDL2.lookupFunction<
      Void Function(Uint32 shadertype, Uint32 precisiontype, Pointer<Int32>? range, Pointer<Int32>? precision),
      void Function(int shadertype, int precisiontype, Pointer<Int32>? range, Pointer<Int32>? precision)>('glGetShaderPrecisionFormat');
  return _glGetShaderPrecisionFormat(shadertype, precisiontype, range, precision);
}

/// ```c
/// GLAPI void APIENTRY glDepthRangef (GLclampf n, GLclampf f)
/// ```
void glDepthRangef(double n, double f) {
  final _glDepthRangef = _SDL2.lookupFunction<
      Void Function(Float n, Float f),
      void Function(double n, double f)>('glDepthRangef');
  return _glDepthRangef(n, f);
}

/// ```c
/// GLAPI void APIENTRY glClearDepthf (GLclampf d)
/// ```
void glClearDepthf(double d) {
  final _glClearDepthf = _SDL2.lookupFunction<
      Void Function(Float d),
      void Function(double d)>('glClearDepthf');
  return _glClearDepthf(d);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramBinary (GLuint program, GLsizei bufSize, GLsizei *length, GLenum *binaryFormat, GLvoid *binary)
/// ```
void glGetProgramBinary(int program, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? binaryFormat, Pointer<Void>? binary) {
  final _glGetProgramBinary = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Uint32>? binaryFormat, Pointer<Void>? binary),
      void Function(int program, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? binaryFormat, Pointer<Void>? binary)>('glGetProgramBinary');
  return _glGetProgramBinary(program, bufSize, length, binaryFormat, binary);
}

/// ```c
/// GLAPI void APIENTRY glProgramBinary (GLuint program, GLenum binaryFormat, const GLvoid *binary, GLsizei length)
/// ```
void glProgramBinary(int program, int binaryFormat, Pointer<Void>? binary, int length) {
  final _glProgramBinary = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 binaryFormat, Pointer<Void>? binary, Uint32 length),
      void Function(int program, int binaryFormat, Pointer<Void>? binary, int length)>('glProgramBinary');
  return _glProgramBinary(program, binaryFormat, binary, length);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameteri (GLuint program, GLenum pname, GLint value)
/// ```
void glProgramParameteri(int program, int pname, int value) {
  final _glProgramParameteri = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 pname, Int32 value),
      void Function(int program, int pname, int value)>('glProgramParameteri');
  return _glProgramParameteri(program, pname, value);
}

/// ```c
/// GLAPI void APIENTRY glUseProgramStages (GLuint pipeline, GLbitfield stages, GLuint program)
/// ```
void glUseProgramStages(int pipeline, int stages, int program) {
  final _glUseProgramStages = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline, Uint32 stages, Uint32 program),
      void Function(int pipeline, int stages, int program)>('glUseProgramStages');
  return _glUseProgramStages(pipeline, stages, program);
}

/// ```c
/// GLAPI void APIENTRY glActiveShaderProgram (GLuint pipeline, GLuint program)
/// ```
void glActiveShaderProgram(int pipeline, int program) {
  final _glActiveShaderProgram = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline, Uint32 program),
      void Function(int pipeline, int program)>('glActiveShaderProgram');
  return _glActiveShaderProgram(pipeline, program);
}

/// ```c
/// GLAPI GLuint APIENTRY glCreateShaderProgramv (GLenum type, GLsizei count, const GLchar* *strings)
/// ```
int glCreateShaderProgramv(int type, int count, Pointer<Pointer<Int8>>? strings) {
  final _glCreateShaderProgramv = _SDL2.lookupFunction<
      Uint32 Function(Uint32 type, Uint32 count, Pointer<Pointer<Int8>>? strings),
      int Function(int type, int count, Pointer<Pointer<Int8>>? strings)>('glCreateShaderProgramv');
  return _glCreateShaderProgramv(type, count, strings);
}

/// ```c
/// GLAPI void APIENTRY glBindProgramPipeline (GLuint pipeline)
/// ```
void glBindProgramPipeline(int pipeline) {
  final _glBindProgramPipeline = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline),
      void Function(int pipeline)>('glBindProgramPipeline');
  return _glBindProgramPipeline(pipeline);
}

/// ```c
/// GLAPI void APIENTRY glDeleteProgramPipelines (GLsizei n, const GLuint *pipelines)
/// ```
void glDeleteProgramPipelines(int n, Pointer<Uint32>? pipelines) {
  final _glDeleteProgramPipelines = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? pipelines),
      void Function(int n, Pointer<Uint32>? pipelines)>('glDeleteProgramPipelines');
  return _glDeleteProgramPipelines(n, pipelines);
}

/// ```c
/// GLAPI void APIENTRY glGenProgramPipelines (GLsizei n, GLuint *pipelines)
/// ```
void glGenProgramPipelines(int n, Pointer<Uint32>? pipelines) {
  final _glGenProgramPipelines = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? pipelines),
      void Function(int n, Pointer<Uint32>? pipelines)>('glGenProgramPipelines');
  return _glGenProgramPipelines(n, pipelines);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsProgramPipeline (GLuint pipeline)
/// ```
int glIsProgramPipeline(int pipeline) {
  final _glIsProgramPipeline = _SDL2.lookupFunction<
      Int32 Function(Uint32 pipeline),
      int Function(int pipeline)>('glIsProgramPipeline');
  return _glIsProgramPipeline(pipeline);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramPipelineiv (GLuint pipeline, GLenum pname, GLint *params)
/// ```
void glGetProgramPipelineiv(int pipeline, int pname, Pointer<Int32>? params) {
  final _glGetProgramPipelineiv = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline, Uint32 pname, Pointer<Int32>? params),
      void Function(int pipeline, int pname, Pointer<Int32>? params)>('glGetProgramPipelineiv');
  return _glGetProgramPipelineiv(pipeline, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1i (GLuint program, GLint location, GLint v0)
/// ```
void glProgramUniform1i(int program, int location, int v0) {
  final _glProgramUniform1i = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0),
      void Function(int program, int location, int v0)>('glProgramUniform1i');
  return _glProgramUniform1i(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1iv (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform1iv(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform1iv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform1iv');
  return _glProgramUniform1iv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1f (GLuint program, GLint location, GLfloat v0)
/// ```
void glProgramUniform1f(int program, int location, double v0) {
  final _glProgramUniform1f = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0),
      void Function(int program, int location, double v0)>('glProgramUniform1f');
  return _glProgramUniform1f(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1fv (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform1fv(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform1fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform1fv');
  return _glProgramUniform1fv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1d (GLuint program, GLint location, GLdouble v0)
/// ```
void glProgramUniform1d(int program, int location, double v0) {
  final _glProgramUniform1d = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double v0),
      void Function(int program, int location, double v0)>('glProgramUniform1d');
  return _glProgramUniform1d(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1dv (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform1dv(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform1dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform1dv');
  return _glProgramUniform1dv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1ui (GLuint program, GLint location, GLuint v0)
/// ```
void glProgramUniform1ui(int program, int location, int v0) {
  final _glProgramUniform1ui = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0),
      void Function(int program, int location, int v0)>('glProgramUniform1ui');
  return _glProgramUniform1ui(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1uiv (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform1uiv(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform1uiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform1uiv');
  return _glProgramUniform1uiv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2i (GLuint program, GLint location, GLint v0, GLint v1)
/// ```
void glProgramUniform2i(int program, int location, int v0, int v1) {
  final _glProgramUniform2i = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1),
      void Function(int program, int location, int v0, int v1)>('glProgramUniform2i');
  return _glProgramUniform2i(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2iv (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform2iv(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform2iv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform2iv');
  return _glProgramUniform2iv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2f (GLuint program, GLint location, GLfloat v0, GLfloat v1)
/// ```
void glProgramUniform2f(int program, int location, double v0, double v1) {
  final _glProgramUniform2f = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1),
      void Function(int program, int location, double v0, double v1)>('glProgramUniform2f');
  return _glProgramUniform2f(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2fv (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform2fv(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform2fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform2fv');
  return _glProgramUniform2fv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2d (GLuint program, GLint location, GLdouble v0, GLdouble v1)
/// ```
void glProgramUniform2d(int program, int location, double v0, double v1) {
  final _glProgramUniform2d = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double v0, Double v1),
      void Function(int program, int location, double v0, double v1)>('glProgramUniform2d');
  return _glProgramUniform2d(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2dv (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform2dv(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform2dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform2dv');
  return _glProgramUniform2dv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2ui (GLuint program, GLint location, GLuint v0, GLuint v1)
/// ```
void glProgramUniform2ui(int program, int location, int v0, int v1) {
  final _glProgramUniform2ui = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1),
      void Function(int program, int location, int v0, int v1)>('glProgramUniform2ui');
  return _glProgramUniform2ui(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2uiv (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform2uiv(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform2uiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform2uiv');
  return _glProgramUniform2uiv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3i (GLuint program, GLint location, GLint v0, GLint v1, GLint v2)
/// ```
void glProgramUniform3i(int program, int location, int v0, int v1, int v2) {
  final _glProgramUniform3i = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2),
      void Function(int program, int location, int v0, int v1, int v2)>('glProgramUniform3i');
  return _glProgramUniform3i(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3iv (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform3iv(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform3iv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform3iv');
  return _glProgramUniform3iv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3f (GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
/// ```
void glProgramUniform3f(int program, int location, double v0, double v1, double v2) {
  final _glProgramUniform3f = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1, Float v2),
      void Function(int program, int location, double v0, double v1, double v2)>('glProgramUniform3f');
  return _glProgramUniform3f(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3fv (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform3fv(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform3fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform3fv');
  return _glProgramUniform3fv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3d (GLuint program, GLint location, GLdouble v0, GLdouble v1, GLdouble v2)
/// ```
void glProgramUniform3d(int program, int location, double v0, double v1, double v2) {
  final _glProgramUniform3d = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double v0, Double v1, Double v2),
      void Function(int program, int location, double v0, double v1, double v2)>('glProgramUniform3d');
  return _glProgramUniform3d(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3dv (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform3dv(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform3dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform3dv');
  return _glProgramUniform3dv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3ui (GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2)
/// ```
void glProgramUniform3ui(int program, int location, int v0, int v1, int v2) {
  final _glProgramUniform3ui = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1, Uint32 v2),
      void Function(int program, int location, int v0, int v1, int v2)>('glProgramUniform3ui');
  return _glProgramUniform3ui(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3uiv (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform3uiv(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform3uiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform3uiv');
  return _glProgramUniform3uiv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4i (GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
/// ```
void glProgramUniform4i(int program, int location, int v0, int v1, int v2, int v3) {
  final _glProgramUniform4i = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3),
      void Function(int program, int location, int v0, int v1, int v2, int v3)>('glProgramUniform4i');
  return _glProgramUniform4i(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4iv (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform4iv(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform4iv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform4iv');
  return _glProgramUniform4iv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4f (GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
/// ```
void glProgramUniform4f(int program, int location, double v0, double v1, double v2, double v3) {
  final _glProgramUniform4f = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1, Float v2, Float v3),
      void Function(int program, int location, double v0, double v1, double v2, double v3)>('glProgramUniform4f');
  return _glProgramUniform4f(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4fv (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform4fv(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform4fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform4fv');
  return _glProgramUniform4fv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4d (GLuint program, GLint location, GLdouble v0, GLdouble v1, GLdouble v2, GLdouble v3)
/// ```
void glProgramUniform4d(int program, int location, double v0, double v1, double v2, double v3) {
  final _glProgramUniform4d = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double v0, Double v1, Double v2, Double v3),
      void Function(int program, int location, double v0, double v1, double v2, double v3)>('glProgramUniform4d');
  return _glProgramUniform4d(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4dv (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform4dv(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform4dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform4dv');
  return _glProgramUniform4dv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4ui (GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
/// ```
void glProgramUniform4ui(int program, int location, int v0, int v1, int v2, int v3) {
  final _glProgramUniform4ui = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1, Uint32 v2, Uint32 v3),
      void Function(int program, int location, int v0, int v1, int v2, int v3)>('glProgramUniform4ui');
  return _glProgramUniform4ui(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4uiv (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform4uiv(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform4uiv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform4uiv');
  return _glProgramUniform4uiv(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2fv');
  return _glProgramUniformMatrix2fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3fv');
  return _glProgramUniformMatrix3fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4fv');
  return _glProgramUniformMatrix4fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2dv');
  return _glProgramUniformMatrix2dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3dv');
  return _glProgramUniformMatrix3dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4dv');
  return _glProgramUniformMatrix4dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x3fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2x3fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2x3fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2x3fv');
  return _glProgramUniformMatrix2x3fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x2fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3x2fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3x2fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3x2fv');
  return _glProgramUniformMatrix3x2fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x4fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2x4fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2x4fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2x4fv');
  return _glProgramUniformMatrix2x4fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x2fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4x2fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4x2fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4x2fv');
  return _glProgramUniformMatrix4x2fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x4fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3x4fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3x4fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3x4fv');
  return _glProgramUniformMatrix3x4fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x3fv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4x3fv(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4x3fv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4x3fv');
  return _glProgramUniformMatrix4x3fv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x3dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2x3dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2x3dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2x3dv');
  return _glProgramUniformMatrix2x3dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x2dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3x2dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3x2dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3x2dv');
  return _glProgramUniformMatrix3x2dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x4dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2x4dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2x4dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2x4dv');
  return _glProgramUniformMatrix2x4dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x2dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4x2dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4x2dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4x2dv');
  return _glProgramUniformMatrix4x2dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x4dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3x4dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3x4dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3x4dv');
  return _glProgramUniformMatrix3x4dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x3dv (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4x3dv(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4x3dv = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4x3dv');
  return _glProgramUniformMatrix4x3dv(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glValidateProgramPipeline (GLuint pipeline)
/// ```
void glValidateProgramPipeline(int pipeline) {
  final _glValidateProgramPipeline = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline),
      void Function(int pipeline)>('glValidateProgramPipeline');
  return _glValidateProgramPipeline(pipeline);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramPipelineInfoLog (GLuint pipeline, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
/// ```
void glGetProgramPipelineInfoLog(int pipeline, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog) {
  final _glGetProgramPipelineInfoLog = _SDL2.lookupFunction<
      Void Function(Uint32 pipeline, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog),
      void Function(int pipeline, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? infoLog)>('glGetProgramPipelineInfoLog');
  return _glGetProgramPipelineInfoLog(pipeline, bufSize, length, infoLog);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1d (GLuint index, GLdouble x)
/// ```
void glVertexAttribL1d(int index, double x) {
  final _glVertexAttribL1d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x),
      void Function(int index, double x)>('glVertexAttribL1d');
  return _glVertexAttribL1d(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2d (GLuint index, GLdouble x, GLdouble y)
/// ```
void glVertexAttribL2d(int index, double x, double y) {
  final _glVertexAttribL2d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y),
      void Function(int index, double x, double y)>('glVertexAttribL2d');
  return _glVertexAttribL2d(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3d (GLuint index, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexAttribL3d(int index, double x, double y, double z) {
  final _glVertexAttribL3d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z),
      void Function(int index, double x, double y, double z)>('glVertexAttribL3d');
  return _glVertexAttribL3d(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4d (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexAttribL4d(int index, double x, double y, double z, double w) {
  final _glVertexAttribL4d = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttribL4d');
  return _glVertexAttribL4d(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL1dv(int index, Pointer<Double>? v) {
  final _glVertexAttribL1dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL1dv');
  return _glVertexAttribL1dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL2dv(int index, Pointer<Double>? v) {
  final _glVertexAttribL2dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL2dv');
  return _glVertexAttribL2dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL3dv(int index, Pointer<Double>? v) {
  final _glVertexAttribL3dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL3dv');
  return _glVertexAttribL3dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4dv (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL4dv(int index, Pointer<Double>? v) {
  final _glVertexAttribL4dv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL4dv');
  return _glVertexAttribL4dv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribLPointer (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribLPointer(int index, int size, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribLPointer = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int stride, Pointer<Void>? pointer)>('glVertexAttribLPointer');
  return _glVertexAttribLPointer(index, size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribLdv (GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetVertexAttribLdv(int index, int pname, Pointer<Double>? params) {
  final _glGetVertexAttribLdv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int index, int pname, Pointer<Double>? params)>('glGetVertexAttribLdv');
  return _glGetVertexAttribLdv(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glViewportArrayv (GLuint first, GLsizei count, const GLfloat *v)
/// ```
void glViewportArrayv(int first, int count, Pointer<Float>? v) {
  final _glViewportArrayv = _SDL2.lookupFunction<
      Void Function(Uint32 first, Uint32 count, Pointer<Float>? v),
      void Function(int first, int count, Pointer<Float>? v)>('glViewportArrayv');
  return _glViewportArrayv(first, count, v);
}

/// ```c
/// GLAPI void APIENTRY glViewportIndexedf (GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h)
/// ```
void glViewportIndexedf(int index, double x, double y, double w, double h) {
  final _glViewportIndexedf = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float w, Float h),
      void Function(int index, double x, double y, double w, double h)>('glViewportIndexedf');
  return _glViewportIndexedf(index, x, y, w, h);
}

/// ```c
/// GLAPI void APIENTRY glViewportIndexedfv (GLuint index, const GLfloat *v)
/// ```
void glViewportIndexedfv(int index, Pointer<Float>? v) {
  final _glViewportIndexedfv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glViewportIndexedfv');
  return _glViewportIndexedfv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glScissorArrayv (GLuint first, GLsizei count, const GLint *v)
/// ```
void glScissorArrayv(int first, int count, Pointer<Int32>? v) {
  final _glScissorArrayv = _SDL2.lookupFunction<
      Void Function(Uint32 first, Uint32 count, Pointer<Int32>? v),
      void Function(int first, int count, Pointer<Int32>? v)>('glScissorArrayv');
  return _glScissorArrayv(first, count, v);
}

/// ```c
/// GLAPI void APIENTRY glScissorIndexed (GLuint index, GLint left, GLint bottom, GLsizei width, GLsizei height)
/// ```
void glScissorIndexed(int index, int left, int bottom, int width, int height) {
  final _glScissorIndexed = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 left, Int32 bottom, Uint32 width, Uint32 height),
      void Function(int index, int left, int bottom, int width, int height)>('glScissorIndexed');
  return _glScissorIndexed(index, left, bottom, width, height);
}

/// ```c
/// GLAPI void APIENTRY glScissorIndexedv (GLuint index, const GLint *v)
/// ```
void glScissorIndexedv(int index, Pointer<Int32>? v) {
  final _glScissorIndexedv = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glScissorIndexedv');
  return _glScissorIndexedv(index, v);
}

/// ```c
/// GLAPI void APIENTRY glDepthRangeArrayv (GLuint first, GLsizei count, const GLclampd *v)
/// ```
void glDepthRangeArrayv(int first, int count, Pointer<Double>? v) {
  final _glDepthRangeArrayv = _SDL2.lookupFunction<
      Void Function(Uint32 first, Uint32 count, Pointer<Double>? v),
      void Function(int first, int count, Pointer<Double>? v)>('glDepthRangeArrayv');
  return _glDepthRangeArrayv(first, count, v);
}

/// ```c
/// GLAPI void APIENTRY glDepthRangeIndexed (GLuint index, GLclampd n, GLclampd f)
/// ```
void glDepthRangeIndexed(int index, double n, double f) {
  final _glDepthRangeIndexed = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double n, Double f),
      void Function(int index, double n, double f)>('glDepthRangeIndexed');
  return _glDepthRangeIndexed(index, n, f);
}

/// ```c
/// GLAPI void APIENTRY glGetFloati_v (GLenum target, GLuint index, GLfloat *data)
/// ```
void glGetFloati_v(int target, int index, Pointer<Float>? data) {
  final _glGetFloati_v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? data),
      void Function(int target, int index, Pointer<Float>? data)>('glGetFloati_v');
  return _glGetFloati_v(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetDoublei_v (GLenum target, GLuint index, GLdouble *data)
/// ```
void glGetDoublei_v(int target, int index, Pointer<Double>? data) {
  final _glGetDoublei_v = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? data),
      void Function(int target, int index, Pointer<Double>? data)>('glGetDoublei_v');
  return _glGetDoublei_v(target, index, data);
}

/// ```c
/// GLAPI GLsync APIENTRY glCreateSyncFromCLeventARB (struct _cl_context * context, struct _cl_event * event, GLbitfield flags)
/// ```
Pointer<Void>? glCreateSyncFromCLeventARB(Pointer<Pointer<Void>>? context, Pointer<Pointer<Void>>? event, int flags) {
  final _glCreateSyncFromCLeventARB = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Pointer<Void>>? context, Pointer<Pointer<Void>>? event, Uint32 flags),
      Pointer<Void>? Function(Pointer<Pointer<Void>>? context, Pointer<Pointer<Void>>? event, int flags)>('glCreateSyncFromCLeventARB');
  return _glCreateSyncFromCLeventARB(context, event, flags);
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageControlARB (GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled)
/// ```
void glDebugMessageControlARB(int source, int type, int severity, int count, Pointer<Uint32>? ids, int enabled) {
  final _glDebugMessageControlARB = _SDL2.lookupFunction<
      Void Function(Uint32 source, Uint32 type, Uint32 severity, Uint32 count, Pointer<Uint32>? ids, Int32 enabled),
      void Function(int source, int type, int severity, int count, Pointer<Uint32>? ids, int enabled)>('glDebugMessageControlARB');
  return _glDebugMessageControlARB(source, type, severity, count, ids, enabled);
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageInsertARB (GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar *buf)
/// ```
void glDebugMessageInsertARB(int source, int type, int id, int severity, int length, String buf) {
  final _glDebugMessageInsertARB = _SDL2.lookupFunction<
      Void Function(Uint32 source, Uint32 type, Uint32 id, Uint32 severity, Uint32 length, Pointer<Utf8>? buf),
      void Function(int source, int type, int id, int severity, int length, Pointer<Utf8>? buf)>('glDebugMessageInsertARB');
  final _bufPointer = buf.toNativeUtf8();
  final _result = _glDebugMessageInsertARB(source, type, id, severity, length, _bufPointer);
  calloc.free(_bufPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageCallbackARB (GLDEBUGPROCARB callback, const GLvoid *userParam)
/// ```
void glDebugMessageCallbackARB(Pointer<Void>? callback, Pointer<Void>? userParam) {
  final _glDebugMessageCallbackARB = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? callback, Pointer<Void>? userParam),
      void Function(Pointer<Void>? callback, Pointer<Void>? userParam)>('glDebugMessageCallbackARB');
  return _glDebugMessageCallbackARB(callback, userParam);
}

/// ```c
/// GLAPI GLuint APIENTRY glGetDebugMessageLogARB (GLuint count, GLsizei bufsize, GLenum *sources, GLenum *types, GLuint *ids, GLenum *severities, GLsizei *lengths, GLchar *messageLog)
/// ```
int glGetDebugMessageLogARB(int count, int bufsize, Pointer<Uint32>? sources, Pointer<Uint32>? types, Pointer<Uint32>? ids, Pointer<Uint32>? severities, Pointer<Uint32>? lengths, Pointer<Int8>? messageLog) {
  final _glGetDebugMessageLogARB = _SDL2.lookupFunction<
      Uint32 Function(Uint32 count, Uint32 bufsize, Pointer<Uint32>? sources, Pointer<Uint32>? types, Pointer<Uint32>? ids, Pointer<Uint32>? severities, Pointer<Uint32>? lengths, Pointer<Int8>? messageLog),
      int Function(int count, int bufsize, Pointer<Uint32>? sources, Pointer<Uint32>? types, Pointer<Uint32>? ids, Pointer<Uint32>? severities, Pointer<Uint32>? lengths, Pointer<Int8>? messageLog)>('glGetDebugMessageLogARB');
  return _glGetDebugMessageLogARB(count, bufsize, sources, types, ids, severities, lengths, messageLog);
}

/// ```c
/// GLAPI GLenum APIENTRY glGetGraphicsResetStatusARB (void)
/// ```
int glGetGraphicsResetStatusARB() {
  final _glGetGraphicsResetStatusARB = _SDL2.lookupFunction<
      Uint32 Function(),
      int Function()>('glGetGraphicsResetStatusARB');
  return _glGetGraphicsResetStatusARB();
}

/// ```c
/// GLAPI void APIENTRY glGetnMapdvARB (GLenum target, GLenum query, GLsizei bufSize, GLdouble *v)
/// ```
void glGetnMapdvARB(int target, int query, int bufSize, Pointer<Double>? v) {
  final _glGetnMapdvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 query, Uint32 bufSize, Pointer<Double>? v),
      void Function(int target, int query, int bufSize, Pointer<Double>? v)>('glGetnMapdvARB');
  return _glGetnMapdvARB(target, query, bufSize, v);
}

/// ```c
/// GLAPI void APIENTRY glGetnMapfvARB (GLenum target, GLenum query, GLsizei bufSize, GLfloat *v)
/// ```
void glGetnMapfvARB(int target, int query, int bufSize, Pointer<Float>? v) {
  final _glGetnMapfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 query, Uint32 bufSize, Pointer<Float>? v),
      void Function(int target, int query, int bufSize, Pointer<Float>? v)>('glGetnMapfvARB');
  return _glGetnMapfvARB(target, query, bufSize, v);
}

/// ```c
/// GLAPI void APIENTRY glGetnMapivARB (GLenum target, GLenum query, GLsizei bufSize, GLint *v)
/// ```
void glGetnMapivARB(int target, int query, int bufSize, Pointer<Int32>? v) {
  final _glGetnMapivARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 query, Uint32 bufSize, Pointer<Int32>? v),
      void Function(int target, int query, int bufSize, Pointer<Int32>? v)>('glGetnMapivARB');
  return _glGetnMapivARB(target, query, bufSize, v);
}

/// ```c
/// GLAPI void APIENTRY glGetnPixelMapfvARB (GLenum map, GLsizei bufSize, GLfloat *values)
/// ```
void glGetnPixelMapfvARB(int map, int bufSize, Pointer<Float>? values) {
  final _glGetnPixelMapfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 map, Uint32 bufSize, Pointer<Float>? values),
      void Function(int map, int bufSize, Pointer<Float>? values)>('glGetnPixelMapfvARB');
  return _glGetnPixelMapfvARB(map, bufSize, values);
}

/// ```c
/// GLAPI void APIENTRY glGetnPixelMapuivARB (GLenum map, GLsizei bufSize, GLuint *values)
/// ```
void glGetnPixelMapuivARB(int map, int bufSize, Pointer<Uint32>? values) {
  final _glGetnPixelMapuivARB = _SDL2.lookupFunction<
      Void Function(Uint32 map, Uint32 bufSize, Pointer<Uint32>? values),
      void Function(int map, int bufSize, Pointer<Uint32>? values)>('glGetnPixelMapuivARB');
  return _glGetnPixelMapuivARB(map, bufSize, values);
}

/// ```c
/// GLAPI void APIENTRY glGetnPixelMapusvARB (GLenum map, GLsizei bufSize, GLushort *values)
/// ```
void glGetnPixelMapusvARB(int map, int bufSize, Pointer<Uint16>? values) {
  final _glGetnPixelMapusvARB = _SDL2.lookupFunction<
      Void Function(Uint32 map, Uint32 bufSize, Pointer<Uint16>? values),
      void Function(int map, int bufSize, Pointer<Uint16>? values)>('glGetnPixelMapusvARB');
  return _glGetnPixelMapusvARB(map, bufSize, values);
}

/// ```c
/// GLAPI void APIENTRY glGetnPolygonStippleARB (GLsizei bufSize, GLubyte *pattern)
/// ```
void glGetnPolygonStippleARB(int bufSize, Pointer<Uint8>? pattern) {
  final _glGetnPolygonStippleARB = _SDL2.lookupFunction<
      Void Function(Uint32 bufSize, Pointer<Uint8>? pattern),
      void Function(int bufSize, Pointer<Uint8>? pattern)>('glGetnPolygonStippleARB');
  return _glGetnPolygonStippleARB(bufSize, pattern);
}

/// ```c
/// GLAPI void APIENTRY glGetnColorTableARB (GLenum target, GLenum format, GLenum type, GLsizei bufSize, GLvoid *table)
/// ```
void glGetnColorTableARB(int target, int format, int type, int bufSize, Pointer<Void>? table) {
  final _glGetnColorTableARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? table),
      void Function(int target, int format, int type, int bufSize, Pointer<Void>? table)>('glGetnColorTableARB');
  return _glGetnColorTableARB(target, format, type, bufSize, table);
}

/// ```c
/// GLAPI void APIENTRY glGetnConvolutionFilterARB (GLenum target, GLenum format, GLenum type, GLsizei bufSize, GLvoid *image)
/// ```
void glGetnConvolutionFilterARB(int target, int format, int type, int bufSize, Pointer<Void>? image) {
  final _glGetnConvolutionFilterARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? image),
      void Function(int target, int format, int type, int bufSize, Pointer<Void>? image)>('glGetnConvolutionFilterARB');
  return _glGetnConvolutionFilterARB(target, format, type, bufSize, image);
}

/// ```c
/// GLAPI void APIENTRY glGetnSeparableFilterARB (GLenum target, GLenum format, GLenum type, GLsizei rowBufSize, GLvoid *row, GLsizei columnBufSize, GLvoid *column, GLvoid *span)
/// ```
void glGetnSeparableFilterARB(int target, int format, int type, int rowBufSize, Pointer<Void>? row, int columnBufSize, Pointer<Void>? column, Pointer<Void>? span) {
  final _glGetnSeparableFilterARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Uint32 rowBufSize, Pointer<Void>? row, Uint32 columnBufSize, Pointer<Void>? column, Pointer<Void>? span),
      void Function(int target, int format, int type, int rowBufSize, Pointer<Void>? row, int columnBufSize, Pointer<Void>? column, Pointer<Void>? span)>('glGetnSeparableFilterARB');
  return _glGetnSeparableFilterARB(target, format, type, rowBufSize, row, columnBufSize, column, span);
}

/// ```c
/// GLAPI void APIENTRY glGetnHistogramARB (GLenum target, GLboolean reset, GLenum format, GLenum type, GLsizei bufSize, GLvoid *values)
/// ```
void glGetnHistogramARB(int target, int reset, int format, int type, int bufSize, Pointer<Void>? values) {
  final _glGetnHistogramARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, int bufSize, Pointer<Void>? values)>('glGetnHistogramARB');
  return _glGetnHistogramARB(target, reset, format, type, bufSize, values);
}

/// ```c
/// GLAPI void APIENTRY glGetnMinmaxARB (GLenum target, GLboolean reset, GLenum format, GLenum type, GLsizei bufSize, GLvoid *values)
/// ```
void glGetnMinmaxARB(int target, int reset, int format, int type, int bufSize, Pointer<Void>? values) {
  final _glGetnMinmaxARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, int bufSize, Pointer<Void>? values)>('glGetnMinmaxARB');
  return _glGetnMinmaxARB(target, reset, format, type, bufSize, values);
}

/// ```c
/// GLAPI void APIENTRY glGetnTexImageARB (GLenum target, GLint level, GLenum format, GLenum type, GLsizei bufSize, GLvoid *img)
/// ```
void glGetnTexImageARB(int target, int level, int format, int type, int bufSize, Pointer<Void>? img) {
  final _glGetnTexImageARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? img),
      void Function(int target, int level, int format, int type, int bufSize, Pointer<Void>? img)>('glGetnTexImageARB');
  return _glGetnTexImageARB(target, level, format, type, bufSize, img);
}

/// ```c
/// GLAPI void APIENTRY glReadnPixelsARB (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, GLvoid *data)
/// ```
void glReadnPixelsARB(int x, int y, int width, int height, int format, int type, int bufSize, Pointer<Void>? data) {
  final _glReadnPixelsARB = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Uint32 bufSize, Pointer<Void>? data),
      void Function(int x, int y, int width, int height, int format, int type, int bufSize, Pointer<Void>? data)>('glReadnPixelsARB');
  return _glReadnPixelsARB(x, y, width, height, format, type, bufSize, data);
}

/// ```c
/// GLAPI void APIENTRY glGetnCompressedTexImageARB (GLenum target, GLint lod, GLsizei bufSize, GLvoid *img)
/// ```
void glGetnCompressedTexImageARB(int target, int lod, int bufSize, Pointer<Void>? img) {
  final _glGetnCompressedTexImageARB = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 lod, Uint32 bufSize, Pointer<Void>? img),
      void Function(int target, int lod, int bufSize, Pointer<Void>? img)>('glGetnCompressedTexImageARB');
  return _glGetnCompressedTexImageARB(target, lod, bufSize, img);
}

/// ```c
/// GLAPI void APIENTRY glGetnUniformfvARB (GLuint program, GLint location, GLsizei bufSize, GLfloat *params)
/// ```
void glGetnUniformfvARB(int program, int location, int bufSize, Pointer<Float>? params) {
  final _glGetnUniformfvARB = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 bufSize, Pointer<Float>? params),
      void Function(int program, int location, int bufSize, Pointer<Float>? params)>('glGetnUniformfvARB');
  return _glGetnUniformfvARB(program, location, bufSize, params);
}

/// ```c
/// GLAPI void APIENTRY glGetnUniformivARB (GLuint program, GLint location, GLsizei bufSize, GLint *params)
/// ```
void glGetnUniformivARB(int program, int location, int bufSize, Pointer<Int32>? params) {
  final _glGetnUniformivARB = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 bufSize, Pointer<Int32>? params),
      void Function(int program, int location, int bufSize, Pointer<Int32>? params)>('glGetnUniformivARB');
  return _glGetnUniformivARB(program, location, bufSize, params);
}

/// ```c
/// GLAPI void APIENTRY glGetnUniformuivARB (GLuint program, GLint location, GLsizei bufSize, GLuint *params)
/// ```
void glGetnUniformuivARB(int program, int location, int bufSize, Pointer<Uint32>? params) {
  final _glGetnUniformuivARB = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 bufSize, Pointer<Uint32>? params),
      void Function(int program, int location, int bufSize, Pointer<Uint32>? params)>('glGetnUniformuivARB');
  return _glGetnUniformuivARB(program, location, bufSize, params);
}

/// ```c
/// GLAPI void APIENTRY glGetnUniformdvARB (GLuint program, GLint location, GLsizei bufSize, GLdouble *params)
/// ```
void glGetnUniformdvARB(int program, int location, int bufSize, Pointer<Double>? params) {
  final _glGetnUniformdvARB = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 bufSize, Pointer<Double>? params),
      void Function(int program, int location, int bufSize, Pointer<Double>? params)>('glGetnUniformdvARB');
  return _glGetnUniformdvARB(program, location, bufSize, params);
}

/// ```c
/// GLAPI void APIENTRY glBlendColorEXT (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
/// ```
void glBlendColorEXT(double red, double green, double blue, double alpha) {
  final _glBlendColorEXT = _SDL2.lookupFunction<
      Void Function(Float red, Float green, Float blue, Float alpha),
      void Function(double red, double green, double blue, double alpha)>('glBlendColorEXT');
  return _glBlendColorEXT(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glPolygonOffsetEXT (GLfloat factor, GLfloat bias)
/// ```
void glPolygonOffsetEXT(double factor, double bias) {
  final _glPolygonOffsetEXT = _SDL2.lookupFunction<
      Void Function(Float factor, Float bias),
      void Function(double factor, double bias)>('glPolygonOffsetEXT');
  return _glPolygonOffsetEXT(factor, bias);
}

/// ```c
/// GLAPI void APIENTRY glTexImage3DEXT (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexImage3DEXT(int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTexImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels)>('glTexImage3DEXT');
  return _glTexImage3DEXT(target, level, internalformat, width, height, depth, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTexSubImage3DEXT (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexSubImage3DEXT(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels) {
  final _glTexSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels)>('glTexSubImage3DEXT');
  return _glTexSubImage3DEXT(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glGetTexFilterFuncSGIS (GLenum target, GLenum filter, GLfloat *weights)
/// ```
void glGetTexFilterFuncSGIS(int target, int filter, Pointer<Float>? weights) {
  final _glGetTexFilterFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 filter, Pointer<Float>? weights),
      void Function(int target, int filter, Pointer<Float>? weights)>('glGetTexFilterFuncSGIS');
  return _glGetTexFilterFuncSGIS(target, filter, weights);
}

/// ```c
/// GLAPI void APIENTRY glTexFilterFuncSGIS (GLenum target, GLenum filter, GLsizei n, const GLfloat *weights)
/// ```
void glTexFilterFuncSGIS(int target, int filter, int n, Pointer<Float>? weights) {
  final _glTexFilterFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 filter, Uint32 n, Pointer<Float>? weights),
      void Function(int target, int filter, int n, Pointer<Float>? weights)>('glTexFilterFuncSGIS');
  return _glTexFilterFuncSGIS(target, filter, n, weights);
}

/// ```c
/// GLAPI void APIENTRY glTexSubImage1DEXT (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexSubImage1DEXT(int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels) {
  final _glTexSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels)>('glTexSubImage1DEXT');
  return _glTexSubImage1DEXT(target, level, xoffset, width, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTexSubImage2DEXT (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexSubImage2DEXT(int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels) {
  final _glTexSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels)>('glTexSubImage2DEXT');
  return _glTexSubImage2DEXT(target, level, xoffset, yoffset, width, height, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexImage1DEXT (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
/// ```
void glCopyTexImage1DEXT(int target, int level, int internalformat, int x, int y, int width, int border) {
  final _glCopyTexImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Int32 border),
      void Function(int target, int level, int internalformat, int x, int y, int width, int border)>('glCopyTexImage1DEXT');
  return _glCopyTexImage1DEXT(target, level, internalformat, x, y, width, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexImage2DEXT (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
/// ```
void glCopyTexImage2DEXT(int target, int level, int internalformat, int x, int y, int width, int height, int border) {
  final _glCopyTexImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Uint32 height, Int32 border),
      void Function(int target, int level, int internalformat, int x, int y, int width, int height, int border)>('glCopyTexImage2DEXT');
  return _glCopyTexImage2DEXT(target, level, internalformat, x, y, width, height, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexSubImage1DEXT (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
/// ```
void glCopyTexSubImage1DEXT(int target, int level, int xoffset, int x, int y, int width) {
  final _glCopyTexSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int level, int xoffset, int x, int y, int width)>('glCopyTexSubImage1DEXT');
  return _glCopyTexSubImage1DEXT(target, level, xoffset, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexSubImage2DEXT (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyTexSubImage2DEXT(int target, int level, int xoffset, int yoffset, int x, int y, int width, int height) {
  final _glCopyTexSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int target, int level, int xoffset, int yoffset, int x, int y, int width, int height)>('glCopyTexSubImage2DEXT');
  return _glCopyTexSubImage2DEXT(target, level, xoffset, yoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glCopyTexSubImage3DEXT (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyTexSubImage3DEXT(int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height) {
  final _glCopyTexSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height)>('glCopyTexSubImage3DEXT');
  return _glCopyTexSubImage3DEXT(target, level, xoffset, yoffset, zoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogramEXT (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
/// ```
void glGetHistogramEXT(int target, int reset, int format, int type, Pointer<Void>? values) {
  final _glGetHistogramEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, Pointer<Void>? values)>('glGetHistogramEXT');
  return _glGetHistogramEXT(target, reset, format, type, values);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogramParameterfvEXT (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetHistogramParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glGetHistogramParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetHistogramParameterfvEXT');
  return _glGetHistogramParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetHistogramParameterivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetHistogramParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetHistogramParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetHistogramParameterivEXT');
  return _glGetHistogramParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmaxEXT (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
/// ```
void glGetMinmaxEXT(int target, int reset, int format, int type, Pointer<Void>? values) {
  final _glGetMinmaxEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 reset, Uint32 format, Uint32 type, Pointer<Void>? values),
      void Function(int target, int reset, int format, int type, Pointer<Void>? values)>('glGetMinmaxEXT');
  return _glGetMinmaxEXT(target, reset, format, type, values);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmaxParameterfvEXT (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetMinmaxParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glGetMinmaxParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetMinmaxParameterfvEXT');
  return _glGetMinmaxParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMinmaxParameterivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMinmaxParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetMinmaxParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetMinmaxParameterivEXT');
  return _glGetMinmaxParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glHistogramEXT (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink)
/// ```
void glHistogramEXT(int target, int width, int internalformat, int sink) {
  final _glHistogramEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 width, Uint32 internalformat, Int32 sink),
      void Function(int target, int width, int internalformat, int sink)>('glHistogramEXT');
  return _glHistogramEXT(target, width, internalformat, sink);
}

/// ```c
/// GLAPI void APIENTRY glMinmaxEXT (GLenum target, GLenum internalformat, GLboolean sink)
/// ```
void glMinmaxEXT(int target, int internalformat, int sink) {
  final _glMinmaxEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 sink),
      void Function(int target, int internalformat, int sink)>('glMinmaxEXT');
  return _glMinmaxEXT(target, internalformat, sink);
}

/// ```c
/// GLAPI void APIENTRY glResetHistogramEXT (GLenum target)
/// ```
void glResetHistogramEXT(int target) {
  final _glResetHistogramEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glResetHistogramEXT');
  return _glResetHistogramEXT(target);
}

/// ```c
/// GLAPI void APIENTRY glResetMinmaxEXT (GLenum target)
/// ```
void glResetMinmaxEXT(int target) {
  final _glResetMinmaxEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glResetMinmaxEXT');
  return _glResetMinmaxEXT(target);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionFilter1DEXT (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image)
/// ```
void glConvolutionFilter1DEXT(int target, int internalformat, int width, int format, int type, Pointer<Void>? image) {
  final _glConvolutionFilter1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int internalformat, int width, int format, int type, Pointer<Void>? image)>('glConvolutionFilter1DEXT');
  return _glConvolutionFilter1DEXT(target, internalformat, width, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionFilter2DEXT (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image)
/// ```
void glConvolutionFilter2DEXT(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? image) {
  final _glConvolutionFilter2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? image)>('glConvolutionFilter2DEXT');
  return _glConvolutionFilter2DEXT(target, internalformat, width, height, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameterfEXT (GLenum target, GLenum pname, GLfloat params)
/// ```
void glConvolutionParameterfEXT(int target, int pname, double params) {
  final _glConvolutionParameterfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Float params),
      void Function(int target, int pname, double params)>('glConvolutionParameterfEXT');
  return _glConvolutionParameterfEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameterfvEXT (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glConvolutionParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glConvolutionParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glConvolutionParameterfvEXT');
  return _glConvolutionParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameteriEXT (GLenum target, GLenum pname, GLint params)
/// ```
void glConvolutionParameteriEXT(int target, int pname, int params) {
  final _glConvolutionParameteriEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Int32 params),
      void Function(int target, int pname, int params)>('glConvolutionParameteriEXT');
  return _glConvolutionParameteriEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glConvolutionParameterivEXT (GLenum target, GLenum pname, const GLint *params)
/// ```
void glConvolutionParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glConvolutionParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glConvolutionParameterivEXT');
  return _glConvolutionParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCopyConvolutionFilter1DEXT (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
/// ```
void glCopyConvolutionFilter1DEXT(int target, int internalformat, int x, int y, int width) {
  final _glCopyConvolutionFilter1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int internalformat, int x, int y, int width)>('glCopyConvolutionFilter1DEXT');
  return _glCopyConvolutionFilter1DEXT(target, internalformat, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glCopyConvolutionFilter2DEXT (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyConvolutionFilter2DEXT(int target, int internalformat, int x, int y, int width, int height) {
  final _glCopyConvolutionFilter2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int target, int internalformat, int x, int y, int width, int height)>('glCopyConvolutionFilter2DEXT');
  return _glCopyConvolutionFilter2DEXT(target, internalformat, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionFilterEXT (GLenum target, GLenum format, GLenum type, GLvoid *image)
/// ```
void glGetConvolutionFilterEXT(int target, int format, int type, Pointer<Void>? image) {
  final _glGetConvolutionFilterEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? image),
      void Function(int target, int format, int type, Pointer<Void>? image)>('glGetConvolutionFilterEXT');
  return _glGetConvolutionFilterEXT(target, format, type, image);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionParameterfvEXT (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetConvolutionParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glGetConvolutionParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetConvolutionParameterfvEXT');
  return _glGetConvolutionParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetConvolutionParameterivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetConvolutionParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetConvolutionParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetConvolutionParameterivEXT');
  return _glGetConvolutionParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetSeparableFilterEXT (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span)
/// ```
void glGetSeparableFilterEXT(int target, int format, int type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span) {
  final _glGetSeparableFilterEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span),
      void Function(int target, int format, int type, Pointer<Void>? row, Pointer<Void>? column, Pointer<Void>? span)>('glGetSeparableFilterEXT');
  return _glGetSeparableFilterEXT(target, format, type, row, column, span);
}

/// ```c
/// GLAPI void APIENTRY glSeparableFilter2DEXT (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column)
/// ```
void glSeparableFilter2DEXT(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? row, Pointer<Void>? column) {
  final _glSeparableFilter2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? row, Pointer<Void>? column),
      void Function(int target, int internalformat, int width, int height, int format, int type, Pointer<Void>? row, Pointer<Void>? column)>('glSeparableFilter2DEXT');
  return _glSeparableFilter2DEXT(target, internalformat, width, height, format, type, row, column);
}

/// ```c
/// GLAPI void APIENTRY glColorTableSGI (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
/// ```
void glColorTableSGI(int target, int internalformat, int width, int format, int type, Pointer<Void>? table) {
  final _glColorTableSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? table),
      void Function(int target, int internalformat, int width, int format, int type, Pointer<Void>? table)>('glColorTableSGI');
  return _glColorTableSGI(target, internalformat, width, format, type, table);
}

/// ```c
/// GLAPI void APIENTRY glColorTableParameterfvSGI (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glColorTableParameterfvSGI(int target, int pname, Pointer<Float>? params) {
  final _glColorTableParameterfvSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glColorTableParameterfvSGI');
  return _glColorTableParameterfvSGI(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glColorTableParameterivSGI (GLenum target, GLenum pname, const GLint *params)
/// ```
void glColorTableParameterivSGI(int target, int pname, Pointer<Int32>? params) {
  final _glColorTableParameterivSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glColorTableParameterivSGI');
  return _glColorTableParameterivSGI(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCopyColorTableSGI (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
/// ```
void glCopyColorTableSGI(int target, int internalformat, int x, int y, int width) {
  final _glCopyColorTableSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int internalformat, int x, int y, int width)>('glCopyColorTableSGI');
  return _glCopyColorTableSGI(target, internalformat, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableSGI (GLenum target, GLenum format, GLenum type, GLvoid *table)
/// ```
void glGetColorTableSGI(int target, int format, int type, Pointer<Void>? table) {
  final _glGetColorTableSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? table),
      void Function(int target, int format, int type, Pointer<Void>? table)>('glGetColorTableSGI');
  return _glGetColorTableSGI(target, format, type, table);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameterfvSGI (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetColorTableParameterfvSGI(int target, int pname, Pointer<Float>? params) {
  final _glGetColorTableParameterfvSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetColorTableParameterfvSGI');
  return _glGetColorTableParameterfvSGI(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameterivSGI (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetColorTableParameterivSGI(int target, int pname, Pointer<Int32>? params) {
  final _glGetColorTableParameterivSGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetColorTableParameterivSGI');
  return _glGetColorTableParameterivSGI(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPixelTexGenSGIX (GLenum mode)
/// ```
void glPixelTexGenSGIX(int mode) {
  final _glPixelTexGenSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glPixelTexGenSGIX');
  return _glPixelTexGenSGIX(mode);
}

/// ```c
/// GLAPI void APIENTRY glPixelTexGenParameteriSGIS (GLenum pname, GLint param)
/// ```
void glPixelTexGenParameteriSGIS(int pname, int param) {
  final _glPixelTexGenParameteriSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glPixelTexGenParameteriSGIS');
  return _glPixelTexGenParameteriSGIS(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPixelTexGenParameterivSGIS (GLenum pname, const GLint *params)
/// ```
void glPixelTexGenParameterivSGIS(int pname, Pointer<Int32>? params) {
  final _glPixelTexGenParameterivSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glPixelTexGenParameterivSGIS');
  return _glPixelTexGenParameterivSGIS(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPixelTexGenParameterfSGIS (GLenum pname, GLfloat param)
/// ```
void glPixelTexGenParameterfSGIS(int pname, double param) {
  final _glPixelTexGenParameterfSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPixelTexGenParameterfSGIS');
  return _glPixelTexGenParameterfSGIS(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPixelTexGenParameterfvSGIS (GLenum pname, const GLfloat *params)
/// ```
void glPixelTexGenParameterfvSGIS(int pname, Pointer<Float>? params) {
  final _glPixelTexGenParameterfvSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glPixelTexGenParameterfvSGIS');
  return _glPixelTexGenParameterfvSGIS(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetPixelTexGenParameterivSGIS (GLenum pname, GLint *params)
/// ```
void glGetPixelTexGenParameterivSGIS(int pname, Pointer<Int32>? params) {
  final _glGetPixelTexGenParameterivSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glGetPixelTexGenParameterivSGIS');
  return _glGetPixelTexGenParameterivSGIS(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetPixelTexGenParameterfvSGIS (GLenum pname, GLfloat *params)
/// ```
void glGetPixelTexGenParameterfvSGIS(int pname, Pointer<Float>? params) {
  final _glGetPixelTexGenParameterfvSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glGetPixelTexGenParameterfvSGIS');
  return _glGetPixelTexGenParameterfvSGIS(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTexImage4DSGIS (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexImage4DSGIS(int target, int level, int internalformat, int width, int height, int depth, int size4d, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTexImage4DSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Uint32 size4d, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int internalformat, int width, int height, int depth, int size4d, int border, int format, int type, Pointer<Void>? pixels)>('glTexImage4DSGIS');
  return _glTexImage4DSGIS(target, level, internalformat, width, height, depth, size4d, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTexSubImage4DSGIS (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTexSubImage4DSGIS(int target, int level, int xoffset, int yoffset, int zoffset, int woffset, int width, int height, int depth, int size4d, int format, int type, Pointer<Void>? pixels) {
  final _glTexSubImage4DSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 woffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 size4d, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int target, int level, int xoffset, int yoffset, int zoffset, int woffset, int width, int height, int depth, int size4d, int format, int type, Pointer<Void>? pixels)>('glTexSubImage4DSGIS');
  return _glTexSubImage4DSGIS(target, level, xoffset, yoffset, zoffset, woffset, width, height, depth, size4d, format, type, pixels);
}

/// ```c
/// GLAPI GLboolean APIENTRY glAreTexturesResidentEXT (GLsizei n, const GLuint *textures, GLboolean *residences)
/// ```
int glAreTexturesResidentEXT(int n, Pointer<Uint32>? textures, Pointer<Int32>? residences) {
  final _glAreTexturesResidentEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 n, Pointer<Uint32>? textures, Pointer<Int32>? residences),
      int Function(int n, Pointer<Uint32>? textures, Pointer<Int32>? residences)>('glAreTexturesResidentEXT');
  return _glAreTexturesResidentEXT(n, textures, residences);
}

/// ```c
/// GLAPI void APIENTRY glBindTextureEXT (GLenum target, GLuint texture)
/// ```
void glBindTextureEXT(int target, int texture) {
  final _glBindTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 texture),
      void Function(int target, int texture)>('glBindTextureEXT');
  return _glBindTextureEXT(target, texture);
}

/// ```c
/// GLAPI void APIENTRY glDeleteTexturesEXT (GLsizei n, const GLuint *textures)
/// ```
void glDeleteTexturesEXT(int n, Pointer<Uint32>? textures) {
  final _glDeleteTexturesEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? textures),
      void Function(int n, Pointer<Uint32>? textures)>('glDeleteTexturesEXT');
  return _glDeleteTexturesEXT(n, textures);
}

/// ```c
/// GLAPI void APIENTRY glGenTexturesEXT (GLsizei n, GLuint *textures)
/// ```
void glGenTexturesEXT(int n, Pointer<Uint32>? textures) {
  final _glGenTexturesEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? textures),
      void Function(int n, Pointer<Uint32>? textures)>('glGenTexturesEXT');
  return _glGenTexturesEXT(n, textures);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsTextureEXT (GLuint texture)
/// ```
int glIsTextureEXT(int texture) {
  final _glIsTextureEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 texture),
      int Function(int texture)>('glIsTextureEXT');
  return _glIsTextureEXT(texture);
}

/// ```c
/// GLAPI void APIENTRY glPrioritizeTexturesEXT (GLsizei n, const GLuint *textures, const GLclampf *priorities)
/// ```
void glPrioritizeTexturesEXT(int n, Pointer<Uint32>? textures, Pointer<Float>? priorities) {
  final _glPrioritizeTexturesEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? textures, Pointer<Float>? priorities),
      void Function(int n, Pointer<Uint32>? textures, Pointer<Float>? priorities)>('glPrioritizeTexturesEXT');
  return _glPrioritizeTexturesEXT(n, textures, priorities);
}

/// ```c
/// GLAPI void APIENTRY glDetailTexFuncSGIS (GLenum target, GLsizei n, const GLfloat *points)
/// ```
void glDetailTexFuncSGIS(int target, int n, Pointer<Float>? points) {
  final _glDetailTexFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 n, Pointer<Float>? points),
      void Function(int target, int n, Pointer<Float>? points)>('glDetailTexFuncSGIS');
  return _glDetailTexFuncSGIS(target, n, points);
}

/// ```c
/// GLAPI void APIENTRY glGetDetailTexFuncSGIS (GLenum target, GLfloat *points)
/// ```
void glGetDetailTexFuncSGIS(int target, Pointer<Float>? points) {
  final _glGetDetailTexFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? points),
      void Function(int target, Pointer<Float>? points)>('glGetDetailTexFuncSGIS');
  return _glGetDetailTexFuncSGIS(target, points);
}

/// ```c
/// GLAPI void APIENTRY glSharpenTexFuncSGIS (GLenum target, GLsizei n, const GLfloat *points)
/// ```
void glSharpenTexFuncSGIS(int target, int n, Pointer<Float>? points) {
  final _glSharpenTexFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 n, Pointer<Float>? points),
      void Function(int target, int n, Pointer<Float>? points)>('glSharpenTexFuncSGIS');
  return _glSharpenTexFuncSGIS(target, n, points);
}

/// ```c
/// GLAPI void APIENTRY glGetSharpenTexFuncSGIS (GLenum target, GLfloat *points)
/// ```
void glGetSharpenTexFuncSGIS(int target, Pointer<Float>? points) {
  final _glGetSharpenTexFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Float>? points),
      void Function(int target, Pointer<Float>? points)>('glGetSharpenTexFuncSGIS');
  return _glGetSharpenTexFuncSGIS(target, points);
}

/// ```c
/// GLAPI void APIENTRY glSampleMaskSGIS (GLclampf value, GLboolean invert)
/// ```
void glSampleMaskSGIS(double value, int invert) {
  final _glSampleMaskSGIS = _SDL2.lookupFunction<
      Void Function(Float value, Int32 invert),
      void Function(double value, int invert)>('glSampleMaskSGIS');
  return _glSampleMaskSGIS(value, invert);
}

/// ```c
/// GLAPI void APIENTRY glSamplePatternSGIS (GLenum pattern)
/// ```
void glSamplePatternSGIS(int pattern) {
  final _glSamplePatternSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pattern),
      void Function(int pattern)>('glSamplePatternSGIS');
  return _glSamplePatternSGIS(pattern);
}

/// ```c
/// GLAPI void APIENTRY glArrayElementEXT (GLint i)
/// ```
void glArrayElementEXT(int i) {
  final _glArrayElementEXT = _SDL2.lookupFunction<
      Void Function(Int32 i),
      void Function(int i)>('glArrayElementEXT');
  return _glArrayElementEXT(i);
}

/// ```c
/// GLAPI void APIENTRY glColorPointerEXT (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
/// ```
void glColorPointerEXT(int size, int type, int stride, int count, Pointer<Void>? pointer) {
  final _glColorPointerEXT = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Uint32 count, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, int count, Pointer<Void>? pointer)>('glColorPointerEXT');
  return _glColorPointerEXT(size, type, stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glDrawArraysEXT (GLenum mode, GLint first, GLsizei count)
/// ```
void glDrawArraysEXT(int mode, int first, int count) {
  final _glDrawArraysEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 first, Uint32 count),
      void Function(int mode, int first, int count)>('glDrawArraysEXT');
  return _glDrawArraysEXT(mode, first, count);
}

/// ```c
/// GLAPI void APIENTRY glEdgeFlagPointerEXT (GLsizei stride, GLsizei count, const GLboolean *pointer)
/// ```
void glEdgeFlagPointerEXT(int stride, int count, Pointer<Int32>? pointer) {
  final _glEdgeFlagPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 stride, Uint32 count, Pointer<Int32>? pointer),
      void Function(int stride, int count, Pointer<Int32>? pointer)>('glEdgeFlagPointerEXT');
  return _glEdgeFlagPointerEXT(stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetPointervEXT (GLenum pname, GLvoid* *params)
/// ```
void glGetPointervEXT(int pname, Pointer<Pointer<Void>>? params) {
  final _glGetPointervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Pointer<Void>>? params),
      void Function(int pname, Pointer<Pointer<Void>>? params)>('glGetPointervEXT');
  return _glGetPointervEXT(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glIndexPointerEXT (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
/// ```
void glIndexPointerEXT(int type, int stride, int count, Pointer<Void>? pointer) {
  final _glIndexPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Uint32 count, Pointer<Void>? pointer),
      void Function(int type, int stride, int count, Pointer<Void>? pointer)>('glIndexPointerEXT');
  return _glIndexPointerEXT(type, stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glNormalPointerEXT (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
/// ```
void glNormalPointerEXT(int type, int stride, int count, Pointer<Void>? pointer) {
  final _glNormalPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Uint32 count, Pointer<Void>? pointer),
      void Function(int type, int stride, int count, Pointer<Void>? pointer)>('glNormalPointerEXT');
  return _glNormalPointerEXT(type, stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordPointerEXT (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
/// ```
void glTexCoordPointerEXT(int size, int type, int stride, int count, Pointer<Void>? pointer) {
  final _glTexCoordPointerEXT = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Uint32 count, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, int count, Pointer<Void>? pointer)>('glTexCoordPointerEXT');
  return _glTexCoordPointerEXT(size, type, stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glVertexPointerEXT (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
/// ```
void glVertexPointerEXT(int size, int type, int stride, int count, Pointer<Void>? pointer) {
  final _glVertexPointerEXT = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Uint32 count, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, int count, Pointer<Void>? pointer)>('glVertexPointerEXT');
  return _glVertexPointerEXT(size, type, stride, count, pointer);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationEXT (GLenum mode)
/// ```
void glBlendEquationEXT(int mode) {
  final _glBlendEquationEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glBlendEquationEXT');
  return _glBlendEquationEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glSpriteParameterfSGIX (GLenum pname, GLfloat param)
/// ```
void glSpriteParameterfSGIX(int pname, double param) {
  final _glSpriteParameterfSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glSpriteParameterfSGIX');
  return _glSpriteParameterfSGIX(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSpriteParameterfvSGIX (GLenum pname, const GLfloat *params)
/// ```
void glSpriteParameterfvSGIX(int pname, Pointer<Float>? params) {
  final _glSpriteParameterfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glSpriteParameterfvSGIX');
  return _glSpriteParameterfvSGIX(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glSpriteParameteriSGIX (GLenum pname, GLint param)
/// ```
void glSpriteParameteriSGIX(int pname, int param) {
  final _glSpriteParameteriSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glSpriteParameteriSGIX');
  return _glSpriteParameteriSGIX(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glSpriteParameterivSGIX (GLenum pname, const GLint *params)
/// ```
void glSpriteParameterivSGIX(int pname, Pointer<Int32>? params) {
  final _glSpriteParameterivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glSpriteParameterivSGIX');
  return _glSpriteParameterivSGIX(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfEXT (GLenum pname, GLfloat param)
/// ```
void glPointParameterfEXT(int pname, double param) {
  final _glPointParameterfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPointParameterfEXT');
  return _glPointParameterfEXT(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfvEXT (GLenum pname, const GLfloat *params)
/// ```
void glPointParameterfvEXT(int pname, Pointer<Float>? params) {
  final _glPointParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glPointParameterfvEXT');
  return _glPointParameterfvEXT(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfSGIS (GLenum pname, GLfloat param)
/// ```
void glPointParameterfSGIS(int pname, double param) {
  final _glPointParameterfSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPointParameterfSGIS');
  return _glPointParameterfSGIS(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterfvSGIS (GLenum pname, const GLfloat *params)
/// ```
void glPointParameterfvSGIS(int pname, Pointer<Float>? params) {
  final _glPointParameterfvSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glPointParameterfvSGIS');
  return _glPointParameterfvSGIS(pname, params);
}

/// ```c
/// GLAPI GLint APIENTRY glGetInstrumentsSGIX (void)
/// ```
int glGetInstrumentsSGIX() {
  final _glGetInstrumentsSGIX = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('glGetInstrumentsSGIX');
  return _glGetInstrumentsSGIX();
}

/// ```c
/// GLAPI void APIENTRY glInstrumentsBufferSGIX (GLsizei size, GLint *buffer)
/// ```
void glInstrumentsBufferSGIX(int size, Pointer<Int32>? buffer) {
  final _glInstrumentsBufferSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 size, Pointer<Int32>? buffer),
      void Function(int size, Pointer<Int32>? buffer)>('glInstrumentsBufferSGIX');
  return _glInstrumentsBufferSGIX(size, buffer);
}

/// ```c
/// GLAPI GLint APIENTRY glPollInstrumentsSGIX (GLint *marker_p)
/// ```
int glPollInstrumentsSGIX(Pointer<Int32>? marker_p) {
  final _glPollInstrumentsSGIX = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int32>? marker_p),
      int Function(Pointer<Int32>? marker_p)>('glPollInstrumentsSGIX');
  return _glPollInstrumentsSGIX(marker_p);
}

/// ```c
/// GLAPI void APIENTRY glReadInstrumentsSGIX (GLint marker)
/// ```
void glReadInstrumentsSGIX(int marker) {
  final _glReadInstrumentsSGIX = _SDL2.lookupFunction<
      Void Function(Int32 marker),
      void Function(int marker)>('glReadInstrumentsSGIX');
  return _glReadInstrumentsSGIX(marker);
}

/// ```c
/// GLAPI void APIENTRY glStartInstrumentsSGIX (void)
/// ```
void glStartInstrumentsSGIX() {
  final _glStartInstrumentsSGIX = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glStartInstrumentsSGIX');
  return _glStartInstrumentsSGIX();
}

/// ```c
/// GLAPI void APIENTRY glStopInstrumentsSGIX (GLint marker)
/// ```
void glStopInstrumentsSGIX(int marker) {
  final _glStopInstrumentsSGIX = _SDL2.lookupFunction<
      Void Function(Int32 marker),
      void Function(int marker)>('glStopInstrumentsSGIX');
  return _glStopInstrumentsSGIX(marker);
}

/// ```c
/// GLAPI void APIENTRY glFrameZoomSGIX (GLint factor)
/// ```
void glFrameZoomSGIX(int factor) {
  final _glFrameZoomSGIX = _SDL2.lookupFunction<
      Void Function(Int32 factor),
      void Function(int factor)>('glFrameZoomSGIX');
  return _glFrameZoomSGIX(factor);
}

/// ```c
/// GLAPI void APIENTRY glTagSampleBufferSGIX (void)
/// ```
void glTagSampleBufferSGIX() {
  final _glTagSampleBufferSGIX = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glTagSampleBufferSGIX');
  return _glTagSampleBufferSGIX();
}

/// ```c
/// GLAPI void APIENTRY glDeformationMap3dSGIX (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const GLdouble *points)
/// ```
void glDeformationMap3dSGIX(int target, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, double w1, double w2, int wstride, int worder, Pointer<Double>? points) {
  final _glDeformationMap3dSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 target, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Double w1, Double w2, Int32 wstride, Int32 worder, Pointer<Double>? points),
      void Function(int target, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, double w1, double w2, int wstride, int worder, Pointer<Double>? points)>('glDeformationMap3dSGIX');
  return _glDeformationMap3dSGIX(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
}

/// ```c
/// GLAPI void APIENTRY glDeformationMap3fSGIX (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const GLfloat *points)
/// ```
void glDeformationMap3fSGIX(int target, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, double w1, double w2, int wstride, int worder, Pointer<Float>? points) {
  final _glDeformationMap3fSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 target, Float u1, Float u2, Int32 ustride, Int32 uorder, Float v1, Float v2, Int32 vstride, Int32 vorder, Float w1, Float w2, Int32 wstride, Int32 worder, Pointer<Float>? points),
      void Function(int target, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, double w1, double w2, int wstride, int worder, Pointer<Float>? points)>('glDeformationMap3fSGIX');
  return _glDeformationMap3fSGIX(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
}

/// ```c
/// GLAPI void APIENTRY glDeformSGIX (GLbitfield mask)
/// ```
void glDeformSGIX(int mask) {
  final _glDeformSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 mask),
      void Function(int mask)>('glDeformSGIX');
  return _glDeformSGIX(mask);
}

/// ```c
/// GLAPI void APIENTRY glLoadIdentityDeformationMapSGIX (GLbitfield mask)
/// ```
void glLoadIdentityDeformationMapSGIX(int mask) {
  final _glLoadIdentityDeformationMapSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 mask),
      void Function(int mask)>('glLoadIdentityDeformationMapSGIX');
  return _glLoadIdentityDeformationMapSGIX(mask);
}

/// ```c
/// GLAPI void APIENTRY glReferencePlaneSGIX (const GLdouble *equation)
/// ```
void glReferencePlaneSGIX(Pointer<Double>? equation) {
  final _glReferencePlaneSGIX = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? equation),
      void Function(Pointer<Double>? equation)>('glReferencePlaneSGIX');
  return _glReferencePlaneSGIX(equation);
}

/// ```c
/// GLAPI void APIENTRY glFlushRasterSGIX (void)
/// ```
void glFlushRasterSGIX() {
  final _glFlushRasterSGIX = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glFlushRasterSGIX');
  return _glFlushRasterSGIX();
}

/// ```c
/// GLAPI void APIENTRY glFogFuncSGIS (GLsizei n, const GLfloat *points)
/// ```
void glFogFuncSGIS(int n, Pointer<Float>? points) {
  final _glFogFuncSGIS = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Float>? points),
      void Function(int n, Pointer<Float>? points)>('glFogFuncSGIS');
  return _glFogFuncSGIS(n, points);
}

/// ```c
/// GLAPI void APIENTRY glGetFogFuncSGIS (GLfloat *points)
/// ```
void glGetFogFuncSGIS(Pointer<Float>? points) {
  final _glGetFogFuncSGIS = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? points),
      void Function(Pointer<Float>? points)>('glGetFogFuncSGIS');
  return _glGetFogFuncSGIS(points);
}

/// ```c
/// GLAPI void APIENTRY glImageTransformParameteriHP (GLenum target, GLenum pname, GLint param)
/// ```
void glImageTransformParameteriHP(int target, int pname, int param) {
  final _glImageTransformParameteriHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Int32 param),
      void Function(int target, int pname, int param)>('glImageTransformParameteriHP');
  return _glImageTransformParameteriHP(target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glImageTransformParameterfHP (GLenum target, GLenum pname, GLfloat param)
/// ```
void glImageTransformParameterfHP(int target, int pname, double param) {
  final _glImageTransformParameterfHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Float param),
      void Function(int target, int pname, double param)>('glImageTransformParameterfHP');
  return _glImageTransformParameterfHP(target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glImageTransformParameterivHP (GLenum target, GLenum pname, const GLint *params)
/// ```
void glImageTransformParameterivHP(int target, int pname, Pointer<Int32>? params) {
  final _glImageTransformParameterivHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glImageTransformParameterivHP');
  return _glImageTransformParameterivHP(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glImageTransformParameterfvHP (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glImageTransformParameterfvHP(int target, int pname, Pointer<Float>? params) {
  final _glImageTransformParameterfvHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glImageTransformParameterfvHP');
  return _glImageTransformParameterfvHP(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetImageTransformParameterivHP (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetImageTransformParameterivHP(int target, int pname, Pointer<Int32>? params) {
  final _glGetImageTransformParameterivHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetImageTransformParameterivHP');
  return _glGetImageTransformParameterivHP(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetImageTransformParameterfvHP (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetImageTransformParameterfvHP(int target, int pname, Pointer<Float>? params) {
  final _glGetImageTransformParameterfvHP = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetImageTransformParameterfvHP');
  return _glGetImageTransformParameterfvHP(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glColorSubTableEXT (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data)
/// ```
void glColorSubTableEXT(int target, int start, int count, int format, int type, Pointer<Void>? data) {
  final _glColorSubTableEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 start, Uint32 count, Uint32 format, Uint32 type, Pointer<Void>? data),
      void Function(int target, int start, int count, int format, int type, Pointer<Void>? data)>('glColorSubTableEXT');
  return _glColorSubTableEXT(target, start, count, format, type, data);
}

/// ```c
/// GLAPI void APIENTRY glCopyColorSubTableEXT (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width)
/// ```
void glCopyColorSubTableEXT(int target, int start, int x, int y, int width) {
  final _glCopyColorSubTableEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 start, Int32 x, Int32 y, Uint32 width),
      void Function(int target, int start, int x, int y, int width)>('glCopyColorSubTableEXT');
  return _glCopyColorSubTableEXT(target, start, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glHintPGI (GLenum target, GLint mode)
/// ```
void glHintPGI(int target, int mode) {
  final _glHintPGI = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 mode),
      void Function(int target, int mode)>('glHintPGI');
  return _glHintPGI(target, mode);
}

/// ```c
/// GLAPI void APIENTRY glColorTableEXT (GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
/// ```
void glColorTableEXT(int target, int internalFormat, int width, int format, int type, Pointer<Void>? table) {
  final _glColorTableEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalFormat, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? table),
      void Function(int target, int internalFormat, int width, int format, int type, Pointer<Void>? table)>('glColorTableEXT');
  return _glColorTableEXT(target, internalFormat, width, format, type, table);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableEXT (GLenum target, GLenum format, GLenum type, GLvoid *data)
/// ```
void glGetColorTableEXT(int target, int format, int type, Pointer<Void>? data) {
  final _glGetColorTableEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 format, Uint32 type, Pointer<Void>? data),
      void Function(int target, int format, int type, Pointer<Void>? data)>('glGetColorTableEXT');
  return _glGetColorTableEXT(target, format, type, data);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameterivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetColorTableParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetColorTableParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetColorTableParameterivEXT');
  return _glGetColorTableParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetColorTableParameterfvEXT (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetColorTableParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glGetColorTableParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetColorTableParameterfvEXT');
  return _glGetColorTableParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetListParameterfvSGIX (GLuint list, GLenum pname, GLfloat *params)
/// ```
void glGetListParameterfvSGIX(int list, int pname, Pointer<Float>? params) {
  final _glGetListParameterfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Pointer<Float>? params),
      void Function(int list, int pname, Pointer<Float>? params)>('glGetListParameterfvSGIX');
  return _glGetListParameterfvSGIX(list, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetListParameterivSGIX (GLuint list, GLenum pname, GLint *params)
/// ```
void glGetListParameterivSGIX(int list, int pname, Pointer<Int32>? params) {
  final _glGetListParameterivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Pointer<Int32>? params),
      void Function(int list, int pname, Pointer<Int32>? params)>('glGetListParameterivSGIX');
  return _glGetListParameterivSGIX(list, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glListParameterfSGIX (GLuint list, GLenum pname, GLfloat param)
/// ```
void glListParameterfSGIX(int list, int pname, double param) {
  final _glListParameterfSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Float param),
      void Function(int list, int pname, double param)>('glListParameterfSGIX');
  return _glListParameterfSGIX(list, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glListParameterfvSGIX (GLuint list, GLenum pname, const GLfloat *params)
/// ```
void glListParameterfvSGIX(int list, int pname, Pointer<Float>? params) {
  final _glListParameterfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Pointer<Float>? params),
      void Function(int list, int pname, Pointer<Float>? params)>('glListParameterfvSGIX');
  return _glListParameterfvSGIX(list, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glListParameteriSGIX (GLuint list, GLenum pname, GLint param)
/// ```
void glListParameteriSGIX(int list, int pname, int param) {
  final _glListParameteriSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Int32 param),
      void Function(int list, int pname, int param)>('glListParameteriSGIX');
  return _glListParameteriSGIX(list, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glListParameterivSGIX (GLuint list, GLenum pname, const GLint *params)
/// ```
void glListParameterivSGIX(int list, int pname, Pointer<Int32>? params) {
  final _glListParameterivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 list, Uint32 pname, Pointer<Int32>? params),
      void Function(int list, int pname, Pointer<Int32>? params)>('glListParameterivSGIX');
  return _glListParameterivSGIX(list, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glIndexMaterialEXT (GLenum face, GLenum mode)
/// ```
void glIndexMaterialEXT(int face, int mode) {
  final _glIndexMaterialEXT = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 mode),
      void Function(int face, int mode)>('glIndexMaterialEXT');
  return _glIndexMaterialEXT(face, mode);
}

/// ```c
/// GLAPI void APIENTRY glIndexFuncEXT (GLenum func, GLclampf ref)
/// ```
void glIndexFuncEXT(int func, double ref) {
  final _glIndexFuncEXT = _SDL2.lookupFunction<
      Void Function(Uint32 func, Float ref),
      void Function(int func, double ref)>('glIndexFuncEXT');
  return _glIndexFuncEXT(func, ref);
}

/// ```c
/// GLAPI void APIENTRY glLockArraysEXT (GLint first, GLsizei count)
/// ```
void glLockArraysEXT(int first, int count) {
  final _glLockArraysEXT = _SDL2.lookupFunction<
      Void Function(Int32 first, Uint32 count),
      void Function(int first, int count)>('glLockArraysEXT');
  return _glLockArraysEXT(first, count);
}

/// ```c
/// GLAPI void APIENTRY glUnlockArraysEXT (void)
/// ```
void glUnlockArraysEXT() {
  final _glUnlockArraysEXT = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glUnlockArraysEXT');
  return _glUnlockArraysEXT();
}

/// ```c
/// GLAPI void APIENTRY glCullParameterdvEXT (GLenum pname, GLdouble *params)
/// ```
void glCullParameterdvEXT(int pname, Pointer<Double>? params) {
  final _glCullParameterdvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Double>? params),
      void Function(int pname, Pointer<Double>? params)>('glCullParameterdvEXT');
  return _glCullParameterdvEXT(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCullParameterfvEXT (GLenum pname, GLfloat *params)
/// ```
void glCullParameterfvEXT(int pname, Pointer<Float>? params) {
  final _glCullParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glCullParameterfvEXT');
  return _glCullParameterfvEXT(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentColorMaterialSGIX (GLenum face, GLenum mode)
/// ```
void glFragmentColorMaterialSGIX(int face, int mode) {
  final _glFragmentColorMaterialSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 mode),
      void Function(int face, int mode)>('glFragmentColorMaterialSGIX');
  return _glFragmentColorMaterialSGIX(face, mode);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightfSGIX (GLenum light, GLenum pname, GLfloat param)
/// ```
void glFragmentLightfSGIX(int light, int pname, double param) {
  final _glFragmentLightfSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Float param),
      void Function(int light, int pname, double param)>('glFragmentLightfSGIX');
  return _glFragmentLightfSGIX(light, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightfvSGIX (GLenum light, GLenum pname, const GLfloat *params)
/// ```
void glFragmentLightfvSGIX(int light, int pname, Pointer<Float>? params) {
  final _glFragmentLightfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Pointer<Float>? params),
      void Function(int light, int pname, Pointer<Float>? params)>('glFragmentLightfvSGIX');
  return _glFragmentLightfvSGIX(light, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightiSGIX (GLenum light, GLenum pname, GLint param)
/// ```
void glFragmentLightiSGIX(int light, int pname, int param) {
  final _glFragmentLightiSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Int32 param),
      void Function(int light, int pname, int param)>('glFragmentLightiSGIX');
  return _glFragmentLightiSGIX(light, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightivSGIX (GLenum light, GLenum pname, const GLint *params)
/// ```
void glFragmentLightivSGIX(int light, int pname, Pointer<Int32>? params) {
  final _glFragmentLightivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Pointer<Int32>? params),
      void Function(int light, int pname, Pointer<Int32>? params)>('glFragmentLightivSGIX');
  return _glFragmentLightivSGIX(light, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightModelfSGIX (GLenum pname, GLfloat param)
/// ```
void glFragmentLightModelfSGIX(int pname, double param) {
  final _glFragmentLightModelfSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glFragmentLightModelfSGIX');
  return _glFragmentLightModelfSGIX(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightModelfvSGIX (GLenum pname, const GLfloat *params)
/// ```
void glFragmentLightModelfvSGIX(int pname, Pointer<Float>? params) {
  final _glFragmentLightModelfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glFragmentLightModelfvSGIX');
  return _glFragmentLightModelfvSGIX(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightModeliSGIX (GLenum pname, GLint param)
/// ```
void glFragmentLightModeliSGIX(int pname, int param) {
  final _glFragmentLightModeliSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glFragmentLightModeliSGIX');
  return _glFragmentLightModeliSGIX(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentLightModelivSGIX (GLenum pname, const GLint *params)
/// ```
void glFragmentLightModelivSGIX(int pname, Pointer<Int32>? params) {
  final _glFragmentLightModelivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glFragmentLightModelivSGIX');
  return _glFragmentLightModelivSGIX(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentMaterialfSGIX (GLenum face, GLenum pname, GLfloat param)
/// ```
void glFragmentMaterialfSGIX(int face, int pname, double param) {
  final _glFragmentMaterialfSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Float param),
      void Function(int face, int pname, double param)>('glFragmentMaterialfSGIX');
  return _glFragmentMaterialfSGIX(face, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentMaterialfvSGIX (GLenum face, GLenum pname, const GLfloat *params)
/// ```
void glFragmentMaterialfvSGIX(int face, int pname, Pointer<Float>? params) {
  final _glFragmentMaterialfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Pointer<Float>? params),
      void Function(int face, int pname, Pointer<Float>? params)>('glFragmentMaterialfvSGIX');
  return _glFragmentMaterialfvSGIX(face, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFragmentMaterialiSGIX (GLenum face, GLenum pname, GLint param)
/// ```
void glFragmentMaterialiSGIX(int face, int pname, int param) {
  final _glFragmentMaterialiSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Int32 param),
      void Function(int face, int pname, int param)>('glFragmentMaterialiSGIX');
  return _glFragmentMaterialiSGIX(face, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFragmentMaterialivSGIX (GLenum face, GLenum pname, const GLint *params)
/// ```
void glFragmentMaterialivSGIX(int face, int pname, Pointer<Int32>? params) {
  final _glFragmentMaterialivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Pointer<Int32>? params),
      void Function(int face, int pname, Pointer<Int32>? params)>('glFragmentMaterialivSGIX');
  return _glFragmentMaterialivSGIX(face, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFragmentLightfvSGIX (GLenum light, GLenum pname, GLfloat *params)
/// ```
void glGetFragmentLightfvSGIX(int light, int pname, Pointer<Float>? params) {
  final _glGetFragmentLightfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Pointer<Float>? params),
      void Function(int light, int pname, Pointer<Float>? params)>('glGetFragmentLightfvSGIX');
  return _glGetFragmentLightfvSGIX(light, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFragmentLightivSGIX (GLenum light, GLenum pname, GLint *params)
/// ```
void glGetFragmentLightivSGIX(int light, int pname, Pointer<Int32>? params) {
  final _glGetFragmentLightivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 light, Uint32 pname, Pointer<Int32>? params),
      void Function(int light, int pname, Pointer<Int32>? params)>('glGetFragmentLightivSGIX');
  return _glGetFragmentLightivSGIX(light, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFragmentMaterialfvSGIX (GLenum face, GLenum pname, GLfloat *params)
/// ```
void glGetFragmentMaterialfvSGIX(int face, int pname, Pointer<Float>? params) {
  final _glGetFragmentMaterialfvSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Pointer<Float>? params),
      void Function(int face, int pname, Pointer<Float>? params)>('glGetFragmentMaterialfvSGIX');
  return _glGetFragmentMaterialfvSGIX(face, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFragmentMaterialivSGIX (GLenum face, GLenum pname, GLint *params)
/// ```
void glGetFragmentMaterialivSGIX(int face, int pname, Pointer<Int32>? params) {
  final _glGetFragmentMaterialivSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 pname, Pointer<Int32>? params),
      void Function(int face, int pname, Pointer<Int32>? params)>('glGetFragmentMaterialivSGIX');
  return _glGetFragmentMaterialivSGIX(face, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glLightEnviSGIX (GLenum pname, GLint param)
/// ```
void glLightEnviSGIX(int pname, int param) {
  final _glLightEnviSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glLightEnviSGIX');
  return _glLightEnviSGIX(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glDrawRangeElementsEXT (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices)
/// ```
void glDrawRangeElementsEXT(int mode, int start, int end, int count, int type, Pointer<Void>? indices) {
  final _glDrawRangeElementsEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Uint32 count, Uint32 type, Pointer<Void>? indices),
      void Function(int mode, int start, int end, int count, int type, Pointer<Void>? indices)>('glDrawRangeElementsEXT');
  return _glDrawRangeElementsEXT(mode, start, end, count, type, indices);
}

/// ```c
/// GLAPI void APIENTRY glApplyTextureEXT (GLenum mode)
/// ```
void glApplyTextureEXT(int mode) {
  final _glApplyTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glApplyTextureEXT');
  return _glApplyTextureEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glTextureLightEXT (GLenum pname)
/// ```
void glTextureLightEXT(int pname) {
  final _glTextureLightEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pname),
      void Function(int pname)>('glTextureLightEXT');
  return _glTextureLightEXT(pname);
}

/// ```c
/// GLAPI void APIENTRY glTextureMaterialEXT (GLenum face, GLenum mode)
/// ```
void glTextureMaterialEXT(int face, int mode) {
  final _glTextureMaterialEXT = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 mode),
      void Function(int face, int mode)>('glTextureMaterialEXT');
  return _glTextureMaterialEXT(face, mode);
}

/// ```c
/// GLAPI void APIENTRY glAsyncMarkerSGIX (GLuint marker)
/// ```
void glAsyncMarkerSGIX(int marker) {
  final _glAsyncMarkerSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 marker),
      void Function(int marker)>('glAsyncMarkerSGIX');
  return _glAsyncMarkerSGIX(marker);
}

/// ```c
/// GLAPI GLint APIENTRY glFinishAsyncSGIX (GLuint *markerp)
/// ```
int glFinishAsyncSGIX(Pointer<Uint32>? markerp) {
  final _glFinishAsyncSGIX = _SDL2.lookupFunction<
      Int32 Function(Pointer<Uint32>? markerp),
      int Function(Pointer<Uint32>? markerp)>('glFinishAsyncSGIX');
  return _glFinishAsyncSGIX(markerp);
}

/// ```c
/// GLAPI GLint APIENTRY glPollAsyncSGIX (GLuint *markerp)
/// ```
int glPollAsyncSGIX(Pointer<Uint32>? markerp) {
  final _glPollAsyncSGIX = _SDL2.lookupFunction<
      Int32 Function(Pointer<Uint32>? markerp),
      int Function(Pointer<Uint32>? markerp)>('glPollAsyncSGIX');
  return _glPollAsyncSGIX(markerp);
}

/// ```c
/// GLAPI GLuint APIENTRY glGenAsyncMarkersSGIX (GLsizei range)
/// ```
int glGenAsyncMarkersSGIX(int range) {
  final _glGenAsyncMarkersSGIX = _SDL2.lookupFunction<
      Uint32 Function(Uint32 range),
      int Function(int range)>('glGenAsyncMarkersSGIX');
  return _glGenAsyncMarkersSGIX(range);
}

/// ```c
/// GLAPI void APIENTRY glDeleteAsyncMarkersSGIX (GLuint marker, GLsizei range)
/// ```
void glDeleteAsyncMarkersSGIX(int marker, int range) {
  final _glDeleteAsyncMarkersSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 marker, Uint32 range),
      void Function(int marker, int range)>('glDeleteAsyncMarkersSGIX');
  return _glDeleteAsyncMarkersSGIX(marker, range);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsAsyncMarkerSGIX (GLuint marker)
/// ```
int glIsAsyncMarkerSGIX(int marker) {
  final _glIsAsyncMarkerSGIX = _SDL2.lookupFunction<
      Int32 Function(Uint32 marker),
      int Function(int marker)>('glIsAsyncMarkerSGIX');
  return _glIsAsyncMarkerSGIX(marker);
}

/// ```c
/// GLAPI void APIENTRY glVertexPointervINTEL (GLint size, GLenum type, const GLvoid* *pointer)
/// ```
void glVertexPointervINTEL(int size, int type, Pointer<Pointer<Void>>? pointer) {
  final _glVertexPointervINTEL = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Pointer<Pointer<Void>>? pointer),
      void Function(int size, int type, Pointer<Pointer<Void>>? pointer)>('glVertexPointervINTEL');
  return _glVertexPointervINTEL(size, type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glNormalPointervINTEL (GLenum type, const GLvoid* *pointer)
/// ```
void glNormalPointervINTEL(int type, Pointer<Pointer<Void>>? pointer) {
  final _glNormalPointervINTEL = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Pointer<Void>>? pointer),
      void Function(int type, Pointer<Pointer<Void>>? pointer)>('glNormalPointervINTEL');
  return _glNormalPointervINTEL(type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glColorPointervINTEL (GLint size, GLenum type, const GLvoid* *pointer)
/// ```
void glColorPointervINTEL(int size, int type, Pointer<Pointer<Void>>? pointer) {
  final _glColorPointervINTEL = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Pointer<Pointer<Void>>? pointer),
      void Function(int size, int type, Pointer<Pointer<Void>>? pointer)>('glColorPointervINTEL');
  return _glColorPointervINTEL(size, type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordPointervINTEL (GLint size, GLenum type, const GLvoid* *pointer)
/// ```
void glTexCoordPointervINTEL(int size, int type, Pointer<Pointer<Void>>? pointer) {
  final _glTexCoordPointervINTEL = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Pointer<Pointer<Void>>? pointer),
      void Function(int size, int type, Pointer<Pointer<Void>>? pointer)>('glTexCoordPointervINTEL');
  return _glTexCoordPointervINTEL(size, type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glPixelTransformParameteriEXT (GLenum target, GLenum pname, GLint param)
/// ```
void glPixelTransformParameteriEXT(int target, int pname, int param) {
  final _glPixelTransformParameteriEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Int32 param),
      void Function(int target, int pname, int param)>('glPixelTransformParameteriEXT');
  return _glPixelTransformParameteriEXT(target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPixelTransformParameterfEXT (GLenum target, GLenum pname, GLfloat param)
/// ```
void glPixelTransformParameterfEXT(int target, int pname, double param) {
  final _glPixelTransformParameterfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Float param),
      void Function(int target, int pname, double param)>('glPixelTransformParameterfEXT');
  return _glPixelTransformParameterfEXT(target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPixelTransformParameterivEXT (GLenum target, GLenum pname, const GLint *params)
/// ```
void glPixelTransformParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glPixelTransformParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glPixelTransformParameterivEXT');
  return _glPixelTransformParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPixelTransformParameterfvEXT (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glPixelTransformParameterfvEXT(int target, int pname, Pointer<Float>? params) {
  final _glPixelTransformParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glPixelTransformParameterfvEXT');
  return _glPixelTransformParameterfvEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3bEXT (GLbyte red, GLbyte green, GLbyte blue)
/// ```
void glSecondaryColor3bEXT(int red, int green, int blue) {
  final _glSecondaryColor3bEXT = _SDL2.lookupFunction<
      Void Function(Int8 red, Int8 green, Int8 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3bEXT');
  return _glSecondaryColor3bEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3bvEXT (const GLbyte *v)
/// ```
void glSecondaryColor3bvEXT(String v) {
  final _glSecondaryColor3bvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? v),
      void Function(Pointer<Utf8>? v)>('glSecondaryColor3bvEXT');
  final _vPointer = v.toNativeUtf8();
  final _result = _glSecondaryColor3bvEXT(_vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3dEXT (GLdouble red, GLdouble green, GLdouble blue)
/// ```
void glSecondaryColor3dEXT(double red, double green, double blue) {
  final _glSecondaryColor3dEXT = _SDL2.lookupFunction<
      Void Function(Double red, Double green, Double blue),
      void Function(double red, double green, double blue)>('glSecondaryColor3dEXT');
  return _glSecondaryColor3dEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3dvEXT (const GLdouble *v)
/// ```
void glSecondaryColor3dvEXT(Pointer<Double>? v) {
  final _glSecondaryColor3dvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glSecondaryColor3dvEXT');
  return _glSecondaryColor3dvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3fEXT (GLfloat red, GLfloat green, GLfloat blue)
/// ```
void glSecondaryColor3fEXT(double red, double green, double blue) {
  final _glSecondaryColor3fEXT = _SDL2.lookupFunction<
      Void Function(Float red, Float green, Float blue),
      void Function(double red, double green, double blue)>('glSecondaryColor3fEXT');
  return _glSecondaryColor3fEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3fvEXT (const GLfloat *v)
/// ```
void glSecondaryColor3fvEXT(Pointer<Float>? v) {
  final _glSecondaryColor3fvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glSecondaryColor3fvEXT');
  return _glSecondaryColor3fvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3iEXT (GLint red, GLint green, GLint blue)
/// ```
void glSecondaryColor3iEXT(int red, int green, int blue) {
  final _glSecondaryColor3iEXT = _SDL2.lookupFunction<
      Void Function(Int32 red, Int32 green, Int32 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3iEXT');
  return _glSecondaryColor3iEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ivEXT (const GLint *v)
/// ```
void glSecondaryColor3ivEXT(Pointer<Int32>? v) {
  final _glSecondaryColor3ivEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glSecondaryColor3ivEXT');
  return _glSecondaryColor3ivEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3sEXT (GLshort red, GLshort green, GLshort blue)
/// ```
void glSecondaryColor3sEXT(int red, int green, int blue) {
  final _glSecondaryColor3sEXT = _SDL2.lookupFunction<
      Void Function(Int16 red, Int16 green, Int16 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3sEXT');
  return _glSecondaryColor3sEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3svEXT (const GLshort *v)
/// ```
void glSecondaryColor3svEXT(Pointer<Int16>? v) {
  final _glSecondaryColor3svEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glSecondaryColor3svEXT');
  return _glSecondaryColor3svEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ubEXT (GLubyte red, GLubyte green, GLubyte blue)
/// ```
void glSecondaryColor3ubEXT(int red, int green, int blue) {
  final _glSecondaryColor3ubEXT = _SDL2.lookupFunction<
      Void Function(Uint8 red, Uint8 green, Uint8 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3ubEXT');
  return _glSecondaryColor3ubEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3ubvEXT (const GLubyte *v)
/// ```
void glSecondaryColor3ubvEXT(Pointer<Uint8>? v) {
  final _glSecondaryColor3ubvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? v),
      void Function(Pointer<Uint8>? v)>('glSecondaryColor3ubvEXT');
  return _glSecondaryColor3ubvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3uiEXT (GLuint red, GLuint green, GLuint blue)
/// ```
void glSecondaryColor3uiEXT(int red, int green, int blue) {
  final _glSecondaryColor3uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 red, Uint32 green, Uint32 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3uiEXT');
  return _glSecondaryColor3uiEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3uivEXT (const GLuint *v)
/// ```
void glSecondaryColor3uivEXT(Pointer<Uint32>? v) {
  final _glSecondaryColor3uivEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? v),
      void Function(Pointer<Uint32>? v)>('glSecondaryColor3uivEXT');
  return _glSecondaryColor3uivEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3usEXT (GLushort red, GLushort green, GLushort blue)
/// ```
void glSecondaryColor3usEXT(int red, int green, int blue) {
  final _glSecondaryColor3usEXT = _SDL2.lookupFunction<
      Void Function(Uint16 red, Uint16 green, Uint16 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3usEXT');
  return _glSecondaryColor3usEXT(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3usvEXT (const GLushort *v)
/// ```
void glSecondaryColor3usvEXT(Pointer<Uint16>? v) {
  final _glSecondaryColor3usvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glSecondaryColor3usvEXT');
  return _glSecondaryColor3usvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorPointerEXT (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glSecondaryColorPointerEXT(int size, int type, int stride, Pointer<Void>? pointer) {
  final _glSecondaryColorPointerEXT = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, Pointer<Void>? pointer)>('glSecondaryColorPointerEXT');
  return _glSecondaryColorPointerEXT(size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glTextureNormalEXT (GLenum mode)
/// ```
void glTextureNormalEXT(int mode) {
  final _glTextureNormalEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glTextureNormalEXT');
  return _glTextureNormalEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawArraysEXT (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
/// ```
void glMultiDrawArraysEXT(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount) {
  final _glMultiDrawArraysEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Int32>? first, Pointer<Uint32>? count, Uint32 primcount),
      void Function(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount)>('glMultiDrawArraysEXT');
  return _glMultiDrawArraysEXT(mode, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawElementsEXT (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount)
/// ```
void glMultiDrawElementsEXT(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount) {
  final _glMultiDrawElementsEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Uint32>? count, Uint32 type, Pointer<Pointer<Void>>? indices, Uint32 primcount),
      void Function(int mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount)>('glMultiDrawElementsEXT');
  return _glMultiDrawElementsEXT(mode, count, type, indices, primcount);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordfEXT (GLfloat coord)
/// ```
void glFogCoordfEXT(double coord) {
  final _glFogCoordfEXT = _SDL2.lookupFunction<
      Void Function(Float coord),
      void Function(double coord)>('glFogCoordfEXT');
  return _glFogCoordfEXT(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordfvEXT (const GLfloat *coord)
/// ```
void glFogCoordfvEXT(Pointer<Float>? coord) {
  final _glFogCoordfvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? coord),
      void Function(Pointer<Float>? coord)>('glFogCoordfvEXT');
  return _glFogCoordfvEXT(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoorddEXT (GLdouble coord)
/// ```
void glFogCoorddEXT(double coord) {
  final _glFogCoorddEXT = _SDL2.lookupFunction<
      Void Function(Double coord),
      void Function(double coord)>('glFogCoorddEXT');
  return _glFogCoorddEXT(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoorddvEXT (const GLdouble *coord)
/// ```
void glFogCoorddvEXT(Pointer<Double>? coord) {
  final _glFogCoorddvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? coord),
      void Function(Pointer<Double>? coord)>('glFogCoorddvEXT');
  return _glFogCoorddvEXT(coord);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordPointerEXT (GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glFogCoordPointerEXT(int type, int stride, Pointer<Void>? pointer) {
  final _glFogCoordPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int type, int stride, Pointer<Void>? pointer)>('glFogCoordPointerEXT');
  return _glFogCoordPointerEXT(type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glTangent3bEXT (GLbyte tx, GLbyte ty, GLbyte tz)
/// ```
void glTangent3bEXT(int tx, int ty, int tz) {
  final _glTangent3bEXT = _SDL2.lookupFunction<
      Void Function(Int8 tx, Int8 ty, Int8 tz),
      void Function(int tx, int ty, int tz)>('glTangent3bEXT');
  return _glTangent3bEXT(tx, ty, tz);
}

/// ```c
/// GLAPI void APIENTRY glTangent3bvEXT (const GLbyte *v)
/// ```
void glTangent3bvEXT(String v) {
  final _glTangent3bvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? v),
      void Function(Pointer<Utf8>? v)>('glTangent3bvEXT');
  final _vPointer = v.toNativeUtf8();
  final _result = _glTangent3bvEXT(_vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glTangent3dEXT (GLdouble tx, GLdouble ty, GLdouble tz)
/// ```
void glTangent3dEXT(double tx, double ty, double tz) {
  final _glTangent3dEXT = _SDL2.lookupFunction<
      Void Function(Double tx, Double ty, Double tz),
      void Function(double tx, double ty, double tz)>('glTangent3dEXT');
  return _glTangent3dEXT(tx, ty, tz);
}

/// ```c
/// GLAPI void APIENTRY glTangent3dvEXT (const GLdouble *v)
/// ```
void glTangent3dvEXT(Pointer<Double>? v) {
  final _glTangent3dvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glTangent3dvEXT');
  return _glTangent3dvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glTangent3fEXT (GLfloat tx, GLfloat ty, GLfloat tz)
/// ```
void glTangent3fEXT(double tx, double ty, double tz) {
  final _glTangent3fEXT = _SDL2.lookupFunction<
      Void Function(Float tx, Float ty, Float tz),
      void Function(double tx, double ty, double tz)>('glTangent3fEXT');
  return _glTangent3fEXT(tx, ty, tz);
}

/// ```c
/// GLAPI void APIENTRY glTangent3fvEXT (const GLfloat *v)
/// ```
void glTangent3fvEXT(Pointer<Float>? v) {
  final _glTangent3fvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glTangent3fvEXT');
  return _glTangent3fvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glTangent3iEXT (GLint tx, GLint ty, GLint tz)
/// ```
void glTangent3iEXT(int tx, int ty, int tz) {
  final _glTangent3iEXT = _SDL2.lookupFunction<
      Void Function(Int32 tx, Int32 ty, Int32 tz),
      void Function(int tx, int ty, int tz)>('glTangent3iEXT');
  return _glTangent3iEXT(tx, ty, tz);
}

/// ```c
/// GLAPI void APIENTRY glTangent3ivEXT (const GLint *v)
/// ```
void glTangent3ivEXT(Pointer<Int32>? v) {
  final _glTangent3ivEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glTangent3ivEXT');
  return _glTangent3ivEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glTangent3sEXT (GLshort tx, GLshort ty, GLshort tz)
/// ```
void glTangent3sEXT(int tx, int ty, int tz) {
  final _glTangent3sEXT = _SDL2.lookupFunction<
      Void Function(Int16 tx, Int16 ty, Int16 tz),
      void Function(int tx, int ty, int tz)>('glTangent3sEXT');
  return _glTangent3sEXT(tx, ty, tz);
}

/// ```c
/// GLAPI void APIENTRY glTangent3svEXT (const GLshort *v)
/// ```
void glTangent3svEXT(Pointer<Int16>? v) {
  final _glTangent3svEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glTangent3svEXT');
  return _glTangent3svEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3bEXT (GLbyte bx, GLbyte by, GLbyte bz)
/// ```
void glBinormal3bEXT(int bx, int by, int bz) {
  final _glBinormal3bEXT = _SDL2.lookupFunction<
      Void Function(Int8 bx, Int8 by, Int8 bz),
      void Function(int bx, int by, int bz)>('glBinormal3bEXT');
  return _glBinormal3bEXT(bx, by, bz);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3bvEXT (const GLbyte *v)
/// ```
void glBinormal3bvEXT(String v) {
  final _glBinormal3bvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Utf8>? v),
      void Function(Pointer<Utf8>? v)>('glBinormal3bvEXT');
  final _vPointer = v.toNativeUtf8();
  final _result = _glBinormal3bvEXT(_vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glBinormal3dEXT (GLdouble bx, GLdouble by, GLdouble bz)
/// ```
void glBinormal3dEXT(double bx, double by, double bz) {
  final _glBinormal3dEXT = _SDL2.lookupFunction<
      Void Function(Double bx, Double by, Double bz),
      void Function(double bx, double by, double bz)>('glBinormal3dEXT');
  return _glBinormal3dEXT(bx, by, bz);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3dvEXT (const GLdouble *v)
/// ```
void glBinormal3dvEXT(Pointer<Double>? v) {
  final _glBinormal3dvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glBinormal3dvEXT');
  return _glBinormal3dvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3fEXT (GLfloat bx, GLfloat by, GLfloat bz)
/// ```
void glBinormal3fEXT(double bx, double by, double bz) {
  final _glBinormal3fEXT = _SDL2.lookupFunction<
      Void Function(Float bx, Float by, Float bz),
      void Function(double bx, double by, double bz)>('glBinormal3fEXT');
  return _glBinormal3fEXT(bx, by, bz);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3fvEXT (const GLfloat *v)
/// ```
void glBinormal3fvEXT(Pointer<Float>? v) {
  final _glBinormal3fvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glBinormal3fvEXT');
  return _glBinormal3fvEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3iEXT (GLint bx, GLint by, GLint bz)
/// ```
void glBinormal3iEXT(int bx, int by, int bz) {
  final _glBinormal3iEXT = _SDL2.lookupFunction<
      Void Function(Int32 bx, Int32 by, Int32 bz),
      void Function(int bx, int by, int bz)>('glBinormal3iEXT');
  return _glBinormal3iEXT(bx, by, bz);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3ivEXT (const GLint *v)
/// ```
void glBinormal3ivEXT(Pointer<Int32>? v) {
  final _glBinormal3ivEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glBinormal3ivEXT');
  return _glBinormal3ivEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3sEXT (GLshort bx, GLshort by, GLshort bz)
/// ```
void glBinormal3sEXT(int bx, int by, int bz) {
  final _glBinormal3sEXT = _SDL2.lookupFunction<
      Void Function(Int16 bx, Int16 by, Int16 bz),
      void Function(int bx, int by, int bz)>('glBinormal3sEXT');
  return _glBinormal3sEXT(bx, by, bz);
}

/// ```c
/// GLAPI void APIENTRY glBinormal3svEXT (const GLshort *v)
/// ```
void glBinormal3svEXT(Pointer<Int16>? v) {
  final _glBinormal3svEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glBinormal3svEXT');
  return _glBinormal3svEXT(v);
}

/// ```c
/// GLAPI void APIENTRY glTangentPointerEXT (GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glTangentPointerEXT(int type, int stride, Pointer<Void>? pointer) {
  final _glTangentPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int type, int stride, Pointer<Void>? pointer)>('glTangentPointerEXT');
  return _glTangentPointerEXT(type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glBinormalPointerEXT (GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glBinormalPointerEXT(int type, int stride, Pointer<Void>? pointer) {
  final _glBinormalPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int type, int stride, Pointer<Void>? pointer)>('glBinormalPointerEXT');
  return _glBinormalPointerEXT(type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glFinishTextureSUNX (void)
/// ```
void glFinishTextureSUNX() {
  final _glFinishTextureSUNX = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glFinishTextureSUNX');
  return _glFinishTextureSUNX();
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactorbSUN (GLbyte factor)
/// ```
void glGlobalAlphaFactorbSUN(int factor) {
  final _glGlobalAlphaFactorbSUN = _SDL2.lookupFunction<
      Void Function(Int8 factor),
      void Function(int factor)>('glGlobalAlphaFactorbSUN');
  return _glGlobalAlphaFactorbSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactorsSUN (GLshort factor)
/// ```
void glGlobalAlphaFactorsSUN(int factor) {
  final _glGlobalAlphaFactorsSUN = _SDL2.lookupFunction<
      Void Function(Int16 factor),
      void Function(int factor)>('glGlobalAlphaFactorsSUN');
  return _glGlobalAlphaFactorsSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactoriSUN (GLint factor)
/// ```
void glGlobalAlphaFactoriSUN(int factor) {
  final _glGlobalAlphaFactoriSUN = _SDL2.lookupFunction<
      Void Function(Int32 factor),
      void Function(int factor)>('glGlobalAlphaFactoriSUN');
  return _glGlobalAlphaFactoriSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactorfSUN (GLfloat factor)
/// ```
void glGlobalAlphaFactorfSUN(double factor) {
  final _glGlobalAlphaFactorfSUN = _SDL2.lookupFunction<
      Void Function(Float factor),
      void Function(double factor)>('glGlobalAlphaFactorfSUN');
  return _glGlobalAlphaFactorfSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactordSUN (GLdouble factor)
/// ```
void glGlobalAlphaFactordSUN(double factor) {
  final _glGlobalAlphaFactordSUN = _SDL2.lookupFunction<
      Void Function(Double factor),
      void Function(double factor)>('glGlobalAlphaFactordSUN');
  return _glGlobalAlphaFactordSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactorubSUN (GLubyte factor)
/// ```
void glGlobalAlphaFactorubSUN(int factor) {
  final _glGlobalAlphaFactorubSUN = _SDL2.lookupFunction<
      Void Function(Uint8 factor),
      void Function(int factor)>('glGlobalAlphaFactorubSUN');
  return _glGlobalAlphaFactorubSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactorusSUN (GLushort factor)
/// ```
void glGlobalAlphaFactorusSUN(int factor) {
  final _glGlobalAlphaFactorusSUN = _SDL2.lookupFunction<
      Void Function(Uint16 factor),
      void Function(int factor)>('glGlobalAlphaFactorusSUN');
  return _glGlobalAlphaFactorusSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glGlobalAlphaFactoruiSUN (GLuint factor)
/// ```
void glGlobalAlphaFactoruiSUN(int factor) {
  final _glGlobalAlphaFactoruiSUN = _SDL2.lookupFunction<
      Void Function(Uint32 factor),
      void Function(int factor)>('glGlobalAlphaFactoruiSUN');
  return _glGlobalAlphaFactoruiSUN(factor);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiSUN (GLuint code)
/// ```
void glReplacementCodeuiSUN(int code) {
  final _glReplacementCodeuiSUN = _SDL2.lookupFunction<
      Void Function(Uint32 code),
      void Function(int code)>('glReplacementCodeuiSUN');
  return _glReplacementCodeuiSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeusSUN (GLushort code)
/// ```
void glReplacementCodeusSUN(int code) {
  final _glReplacementCodeusSUN = _SDL2.lookupFunction<
      Void Function(Uint16 code),
      void Function(int code)>('glReplacementCodeusSUN');
  return _glReplacementCodeusSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeubSUN (GLubyte code)
/// ```
void glReplacementCodeubSUN(int code) {
  final _glReplacementCodeubSUN = _SDL2.lookupFunction<
      Void Function(Uint8 code),
      void Function(int code)>('glReplacementCodeubSUN');
  return _glReplacementCodeubSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuivSUN (const GLuint *code)
/// ```
void glReplacementCodeuivSUN(Pointer<Uint32>? code) {
  final _glReplacementCodeuivSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? code),
      void Function(Pointer<Uint32>? code)>('glReplacementCodeuivSUN');
  return _glReplacementCodeuivSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeusvSUN (const GLushort *code)
/// ```
void glReplacementCodeusvSUN(Pointer<Uint16>? code) {
  final _glReplacementCodeusvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? code),
      void Function(Pointer<Uint16>? code)>('glReplacementCodeusvSUN');
  return _glReplacementCodeusvSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeubvSUN (const GLubyte *code)
/// ```
void glReplacementCodeubvSUN(Pointer<Uint8>? code) {
  final _glReplacementCodeubvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? code),
      void Function(Pointer<Uint8>? code)>('glReplacementCodeubvSUN');
  return _glReplacementCodeubvSUN(code);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodePointerSUN (GLenum type, GLsizei stride, const GLvoid* *pointer)
/// ```
void glReplacementCodePointerSUN(int type, int stride, Pointer<Pointer<Void>>? pointer) {
  final _glReplacementCodePointerSUN = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride, Pointer<Pointer<Void>>? pointer),
      void Function(int type, int stride, Pointer<Pointer<Void>>? pointer)>('glReplacementCodePointerSUN');
  return _glReplacementCodePointerSUN(type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glColor4ubVertex2fSUN (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y)
/// ```
void glColor4ubVertex2fSUN(int r, int g, int b, int a, double x, double y) {
  final _glColor4ubVertex2fSUN = _SDL2.lookupFunction<
      Void Function(Uint8 r, Uint8 g, Uint8 b, Uint8 a, Float x, Float y),
      void Function(int r, int g, int b, int a, double x, double y)>('glColor4ubVertex2fSUN');
  return _glColor4ubVertex2fSUN(r, g, b, a, x, y);
}

/// ```c
/// GLAPI void APIENTRY glColor4ubVertex2fvSUN (const GLubyte *c, const GLfloat *v)
/// ```
void glColor4ubVertex2fvSUN(Pointer<Uint8>? c, Pointer<Float>? v) {
  final _glColor4ubVertex2fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? c, Pointer<Float>? v),
      void Function(Pointer<Uint8>? c, Pointer<Float>? v)>('glColor4ubVertex2fvSUN');
  return _glColor4ubVertex2fvSUN(c, v);
}

/// ```c
/// GLAPI void APIENTRY glColor4ubVertex3fSUN (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glColor4ubVertex3fSUN(int r, int g, int b, int a, double x, double y, double z) {
  final _glColor4ubVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint8 r, Uint8 g, Uint8 b, Uint8 a, Float x, Float y, Float z),
      void Function(int r, int g, int b, int a, double x, double y, double z)>('glColor4ubVertex3fSUN');
  return _glColor4ubVertex3fSUN(r, g, b, a, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glColor4ubVertex3fvSUN (const GLubyte *c, const GLfloat *v)
/// ```
void glColor4ubVertex3fvSUN(Pointer<Uint8>? c, Pointer<Float>? v) {
  final _glColor4ubVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint8>? c, Pointer<Float>? v),
      void Function(Pointer<Uint8>? c, Pointer<Float>? v)>('glColor4ubVertex3fvSUN');
  return _glColor4ubVertex3fvSUN(c, v);
}

/// ```c
/// GLAPI void APIENTRY glColor3fVertex3fSUN (GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glColor3fVertex3fSUN(double r, double g, double b, double x, double y, double z) {
  final _glColor3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float r, Float g, Float b, Float x, Float y, Float z),
      void Function(double r, double g, double b, double x, double y, double z)>('glColor3fVertex3fSUN');
  return _glColor3fVertex3fSUN(r, g, b, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glColor3fVertex3fvSUN (const GLfloat *c, const GLfloat *v)
/// ```
void glColor3fVertex3fvSUN(Pointer<Float>? c, Pointer<Float>? v) {
  final _glColor3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? c, Pointer<Float>? v),
      void Function(Pointer<Float>? c, Pointer<Float>? v)>('glColor3fVertex3fvSUN');
  return _glColor3fVertex3fvSUN(c, v);
}

/// ```c
/// GLAPI void APIENTRY glNormal3fVertex3fSUN (GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glNormal3fVertex3fSUN(double nx, double ny, double nz, double x, double y, double z) {
  final _glNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(double nx, double ny, double nz, double x, double y, double z)>('glNormal3fVertex3fSUN');
  return _glNormal3fVertex3fSUN(nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glNormal3fVertex3fvSUN (const GLfloat *n, const GLfloat *v)
/// ```
void glNormal3fVertex3fvSUN(Pointer<Float>? n, Pointer<Float>? v) {
  final _glNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Float>? n, Pointer<Float>? v)>('glNormal3fVertex3fvSUN');
  return _glNormal3fVertex3fvSUN(n, v);
}

/// ```c
/// GLAPI void APIENTRY glColor4fNormal3fVertex3fSUN (GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glColor4fNormal3fVertex3fSUN(double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z) {
  final _glColor4fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float r, Float g, Float b, Float a, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z)>('glColor4fNormal3fVertex3fSUN');
  return _glColor4fNormal3fVertex3fSUN(r, g, b, a, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glColor4fNormal3fVertex3fvSUN (const GLfloat *c, const GLfloat *n, const GLfloat *v)
/// ```
void glColor4fNormal3fVertex3fvSUN(Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v) {
  final _glColor4fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v)>('glColor4fNormal3fVertex3fvSUN');
  return _glColor4fNormal3fVertex3fvSUN(c, n, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fVertex3fSUN (GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glTexCoord2fVertex3fSUN(double s, double t, double x, double y, double z) {
  final _glTexCoord2fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float x, Float y, Float z),
      void Function(double s, double t, double x, double y, double z)>('glTexCoord2fVertex3fSUN');
  return _glTexCoord2fVertex3fSUN(s, t, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fVertex3fvSUN (const GLfloat *tc, const GLfloat *v)
/// ```
void glTexCoord2fVertex3fvSUN(Pointer<Float>? tc, Pointer<Float>? v) {
  final _glTexCoord2fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? v)>('glTexCoord2fVertex3fvSUN');
  return _glTexCoord2fVertex3fvSUN(tc, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4fVertex4fSUN (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glTexCoord4fVertex4fSUN(double s, double t, double p, double q, double x, double y, double z, double w) {
  final _glTexCoord4fVertex4fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float p, Float q, Float x, Float y, Float z, Float w),
      void Function(double s, double t, double p, double q, double x, double y, double z, double w)>('glTexCoord4fVertex4fSUN');
  return _glTexCoord4fVertex4fSUN(s, t, p, q, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4fVertex4fvSUN (const GLfloat *tc, const GLfloat *v)
/// ```
void glTexCoord4fVertex4fvSUN(Pointer<Float>? tc, Pointer<Float>? v) {
  final _glTexCoord4fVertex4fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? v)>('glTexCoord4fVertex4fvSUN');
  return _glTexCoord4fVertex4fvSUN(tc, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fSUN (GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glTexCoord2fColor4ubVertex3fSUN(double s, double t, int r, int g, int b, int a, double x, double y, double z) {
  final _glTexCoord2fColor4ubVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Uint8 r, Uint8 g, Uint8 b, Uint8 a, Float x, Float y, Float z),
      void Function(double s, double t, int r, int g, int b, int a, double x, double y, double z)>('glTexCoord2fColor4ubVertex3fSUN');
  return _glTexCoord2fColor4ubVertex3fSUN(s, t, r, g, b, a, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fvSUN (const GLfloat *tc, const GLubyte *c, const GLfloat *v)
/// ```
void glTexCoord2fColor4ubVertex3fvSUN(Pointer<Float>? tc, Pointer<Uint8>? c, Pointer<Float>? v) {
  final _glTexCoord2fColor4ubVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Uint8>? c, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Uint8>? c, Pointer<Float>? v)>('glTexCoord2fColor4ubVertex3fvSUN');
  return _glTexCoord2fColor4ubVertex3fvSUN(tc, c, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor3fVertex3fSUN (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glTexCoord2fColor3fVertex3fSUN(double s, double t, double r, double g, double b, double x, double y, double z) {
  final _glTexCoord2fColor3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float r, Float g, Float b, Float x, Float y, Float z),
      void Function(double s, double t, double r, double g, double b, double x, double y, double z)>('glTexCoord2fColor3fVertex3fSUN');
  return _glTexCoord2fColor3fVertex3fSUN(s, t, r, g, b, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor3fVertex3fvSUN (const GLfloat *tc, const GLfloat *c, const GLfloat *v)
/// ```
void glTexCoord2fColor3fVertex3fvSUN(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? v) {
  final _glTexCoord2fColor3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? v)>('glTexCoord2fColor3fVertex3fvSUN');
  return _glTexCoord2fColor3fVertex3fvSUN(tc, c, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fSUN (GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glTexCoord2fNormal3fVertex3fSUN(double s, double t, double nx, double ny, double nz, double x, double y, double z) {
  final _glTexCoord2fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(double s, double t, double nx, double ny, double nz, double x, double y, double z)>('glTexCoord2fNormal3fVertex3fSUN');
  return _glTexCoord2fNormal3fVertex3fSUN(s, t, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fvSUN (const GLfloat *tc, const GLfloat *n, const GLfloat *v)
/// ```
void glTexCoord2fNormal3fVertex3fvSUN(Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v) {
  final _glTexCoord2fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v)>('glTexCoord2fNormal3fVertex3fvSUN');
  return _glTexCoord2fNormal3fVertex3fvSUN(tc, n, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fSUN (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glTexCoord2fColor4fNormal3fVertex3fSUN(double s, double t, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z) {
  final _glTexCoord2fColor4fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float r, Float g, Float b, Float a, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(double s, double t, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z)>('glTexCoord2fColor4fNormal3fVertex3fSUN');
  return _glTexCoord2fColor4fNormal3fVertex3fSUN(s, t, r, g, b, a, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fvSUN (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
/// ```
void glTexCoord2fColor4fNormal3fVertex3fvSUN(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v) {
  final _glTexCoord2fColor4fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v)>('glTexCoord2fColor4fNormal3fVertex3fvSUN');
  return _glTexCoord2fColor4fNormal3fVertex3fvSUN(tc, c, n, v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fSUN (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glTexCoord4fColor4fNormal3fVertex4fSUN(double s, double t, double p, double q, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z, double w) {
  final _glTexCoord4fColor4fNormal3fVertex4fSUN = _SDL2.lookupFunction<
      Void Function(Float s, Float t, Float p, Float q, Float r, Float g, Float b, Float a, Float nx, Float ny, Float nz, Float x, Float y, Float z, Float w),
      void Function(double s, double t, double p, double q, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z, double w)>('glTexCoord4fColor4fNormal3fVertex4fSUN');
  return _glTexCoord4fColor4fNormal3fVertex4fSUN(s, t, p, q, r, g, b, a, nx, ny, nz, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fvSUN (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
/// ```
void glTexCoord4fColor4fNormal3fVertex4fvSUN(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v) {
  final _glTexCoord4fColor4fNormal3fVertex4fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v)>('glTexCoord4fColor4fNormal3fVertex4fvSUN');
  return _glTexCoord4fColor4fNormal3fVertex4fvSUN(tc, c, n, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiVertex3fSUN (GLuint rc, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiVertex3fSUN(int rc, double x, double y, double z) {
  final _glReplacementCodeuiVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float x, Float y, Float z),
      void Function(int rc, double x, double y, double z)>('glReplacementCodeuiVertex3fSUN');
  return _glReplacementCodeuiVertex3fSUN(rc, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiVertex3fvSUN (const GLuint *rc, const GLfloat *v)
/// ```
void glReplacementCodeuiVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? v) {
  final _glReplacementCodeuiVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? v)>('glReplacementCodeuiVertex3fvSUN');
  return _glReplacementCodeuiVertex3fvSUN(rc, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fSUN (GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiColor4ubVertex3fSUN(int rc, int r, int g, int b, int a, double x, double y, double z) {
  final _glReplacementCodeuiColor4ubVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Uint8 r, Uint8 g, Uint8 b, Uint8 a, Float x, Float y, Float z),
      void Function(int rc, int r, int g, int b, int a, double x, double y, double z)>('glReplacementCodeuiColor4ubVertex3fSUN');
  return _glReplacementCodeuiColor4ubVertex3fSUN(rc, r, g, b, a, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fvSUN (const GLuint *rc, const GLubyte *c, const GLfloat *v)
/// ```
void glReplacementCodeuiColor4ubVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Uint8>? c, Pointer<Float>? v) {
  final _glReplacementCodeuiColor4ubVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Uint8>? c, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Uint8>? c, Pointer<Float>? v)>('glReplacementCodeuiColor4ubVertex3fvSUN');
  return _glReplacementCodeuiColor4ubVertex3fvSUN(rc, c, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fSUN (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiColor3fVertex3fSUN(int rc, double r, double g, double b, double x, double y, double z) {
  final _glReplacementCodeuiColor3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float r, Float g, Float b, Float x, Float y, Float z),
      void Function(int rc, double r, double g, double b, double x, double y, double z)>('glReplacementCodeuiColor3fVertex3fSUN');
  return _glReplacementCodeuiColor3fVertex3fSUN(rc, r, g, b, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fvSUN (const GLuint *rc, const GLfloat *c, const GLfloat *v)
/// ```
void glReplacementCodeuiColor3fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? v) {
  final _glReplacementCodeuiColor3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? v)>('glReplacementCodeuiColor3fVertex3fvSUN');
  return _glReplacementCodeuiColor3fVertex3fvSUN(rc, c, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fSUN (GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiNormal3fVertex3fSUN(int rc, double nx, double ny, double nz, double x, double y, double z) {
  final _glReplacementCodeuiNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(int rc, double nx, double ny, double nz, double x, double y, double z)>('glReplacementCodeuiNormal3fVertex3fSUN');
  return _glReplacementCodeuiNormal3fVertex3fSUN(rc, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fvSUN (const GLuint *rc, const GLfloat *n, const GLfloat *v)
/// ```
void glReplacementCodeuiNormal3fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? n, Pointer<Float>? v) {
  final _glReplacementCodeuiNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? n, Pointer<Float>? v)>('glReplacementCodeuiNormal3fVertex3fvSUN');
  return _glReplacementCodeuiNormal3fVertex3fvSUN(rc, n, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fSUN (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiColor4fNormal3fVertex3fSUN(int rc, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z) {
  final _glReplacementCodeuiColor4fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float r, Float g, Float b, Float a, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(int rc, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z)>('glReplacementCodeuiColor4fNormal3fVertex3fSUN');
  return _glReplacementCodeuiColor4fNormal3fVertex3fSUN(rc, r, g, b, a, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fvSUN (const GLuint *rc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
/// ```
void glReplacementCodeuiColor4fNormal3fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v) {
  final _glReplacementCodeuiColor4fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v)>('glReplacementCodeuiColor4fNormal3fVertex3fvSUN');
  return _glReplacementCodeuiColor4fNormal3fVertex3fvSUN(rc, c, n, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fSUN (GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiTexCoord2fVertex3fSUN(int rc, double s, double t, double x, double y, double z) {
  final _glReplacementCodeuiTexCoord2fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float s, Float t, Float x, Float y, Float z),
      void Function(int rc, double s, double t, double x, double y, double z)>('glReplacementCodeuiTexCoord2fVertex3fSUN');
  return _glReplacementCodeuiTexCoord2fVertex3fSUN(rc, s, t, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fvSUN (const GLuint *rc, const GLfloat *tc, const GLfloat *v)
/// ```
void glReplacementCodeuiTexCoord2fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? v) {
  final _glReplacementCodeuiTexCoord2fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? v)>('glReplacementCodeuiTexCoord2fVertex3fvSUN');
  return _glReplacementCodeuiTexCoord2fVertex3fvSUN(rc, tc, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN (GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(int rc, double s, double t, double nx, double ny, double nz, double x, double y, double z) {
  final _glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float s, Float t, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(int rc, double s, double t, double nx, double ny, double nz, double x, double y, double z)>('glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN');
  return _glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(rc, s, t, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN (const GLuint *rc, const GLfloat *tc, const GLfloat *n, const GLfloat *v)
/// ```
void glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v) {
  final _glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? n, Pointer<Float>? v)>('glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN');
  return _glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(rc, tc, n, v);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN (GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(int rc, double s, double t, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z) {
  final _glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN = _SDL2.lookupFunction<
      Void Function(Uint32 rc, Float s, Float t, Float r, Float g, Float b, Float a, Float nx, Float ny, Float nz, Float x, Float y, Float z),
      void Function(int rc, double s, double t, double r, double g, double b, double a, double nx, double ny, double nz, double x, double y, double z)>('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN');
  return _glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(rc, s, t, r, g, b, a, nx, ny, nz, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN (const GLuint *rc, const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
/// ```
void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v) {
  final _glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v),
      void Function(Pointer<Uint32>? rc, Pointer<Float>? tc, Pointer<Float>? c, Pointer<Float>? n, Pointer<Float>? v)>('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN');
  return _glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(rc, tc, c, n, v);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparateEXT (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
/// ```
void glBlendFuncSeparateEXT(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha) {
  final _glBlendFuncSeparateEXT = _SDL2.lookupFunction<
      Void Function(Uint32 sfactorRGB, Uint32 dfactorRGB, Uint32 sfactorAlpha, Uint32 dfactorAlpha),
      void Function(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha)>('glBlendFuncSeparateEXT');
  return _glBlendFuncSeparateEXT(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparateINGR (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
/// ```
void glBlendFuncSeparateINGR(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha) {
  final _glBlendFuncSeparateINGR = _SDL2.lookupFunction<
      Void Function(Uint32 sfactorRGB, Uint32 dfactorRGB, Uint32 sfactorAlpha, Uint32 dfactorAlpha),
      void Function(int sfactorRGB, int dfactorRGB, int sfactorAlpha, int dfactorAlpha)>('glBlendFuncSeparateINGR');
  return _glBlendFuncSeparateINGR(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
}

/// ```c
/// GLAPI void APIENTRY glVertexWeightfEXT (GLfloat weight)
/// ```
void glVertexWeightfEXT(double weight) {
  final _glVertexWeightfEXT = _SDL2.lookupFunction<
      Void Function(Float weight),
      void Function(double weight)>('glVertexWeightfEXT');
  return _glVertexWeightfEXT(weight);
}

/// ```c
/// GLAPI void APIENTRY glVertexWeightfvEXT (const GLfloat *weight)
/// ```
void glVertexWeightfvEXT(Pointer<Float>? weight) {
  final _glVertexWeightfvEXT = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? weight),
      void Function(Pointer<Float>? weight)>('glVertexWeightfvEXT');
  return _glVertexWeightfvEXT(weight);
}

/// ```c
/// GLAPI void APIENTRY glVertexWeightPointerEXT (GLsizei size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexWeightPointerEXT(int size, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexWeightPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int size, int type, int stride, Pointer<Void>? pointer)>('glVertexWeightPointerEXT');
  return _glVertexWeightPointerEXT(size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glFlushVertexArrayRangeNV (void)
/// ```
void glFlushVertexArrayRangeNV() {
  final _glFlushVertexArrayRangeNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glFlushVertexArrayRangeNV');
  return _glFlushVertexArrayRangeNV();
}

/// ```c
/// GLAPI void APIENTRY glVertexArrayRangeNV (GLsizei length, const GLvoid *pointer)
/// ```
void glVertexArrayRangeNV(int length, Pointer<Void>? pointer) {
  final _glVertexArrayRangeNV = _SDL2.lookupFunction<
      Void Function(Uint32 length, Pointer<Void>? pointer),
      void Function(int length, Pointer<Void>? pointer)>('glVertexArrayRangeNV');
  return _glVertexArrayRangeNV(length, pointer);
}

/// ```c
/// GLAPI void APIENTRY glCombinerParameterfvNV (GLenum pname, const GLfloat *params)
/// ```
void glCombinerParameterfvNV(int pname, Pointer<Float>? params) {
  final _glCombinerParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? params),
      void Function(int pname, Pointer<Float>? params)>('glCombinerParameterfvNV');
  return _glCombinerParameterfvNV(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCombinerParameterfNV (GLenum pname, GLfloat param)
/// ```
void glCombinerParameterfNV(int pname, double param) {
  final _glCombinerParameterfNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glCombinerParameterfNV');
  return _glCombinerParameterfNV(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glCombinerParameterivNV (GLenum pname, const GLint *params)
/// ```
void glCombinerParameterivNV(int pname, Pointer<Int32>? params) {
  final _glCombinerParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glCombinerParameterivNV');
  return _glCombinerParameterivNV(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCombinerParameteriNV (GLenum pname, GLint param)
/// ```
void glCombinerParameteriNV(int pname, int param) {
  final _glCombinerParameteriNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glCombinerParameteriNV');
  return _glCombinerParameteriNV(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glCombinerInputNV (GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
/// ```
void glCombinerInputNV(int stage, int portion, int variable, int input, int mapping, int componentUsage) {
  final _glCombinerInputNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 variable, Uint32 input, Uint32 mapping, Uint32 componentUsage),
      void Function(int stage, int portion, int variable, int input, int mapping, int componentUsage)>('glCombinerInputNV');
  return _glCombinerInputNV(stage, portion, variable, input, mapping, componentUsage);
}

/// ```c
/// GLAPI void APIENTRY glCombinerOutputNV (GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum)
/// ```
void glCombinerOutputNV(int stage, int portion, int abOutput, int cdOutput, int sumOutput, int scale, int bias, int abDotProduct, int cdDotProduct, int muxSum) {
  final _glCombinerOutputNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 abOutput, Uint32 cdOutput, Uint32 sumOutput, Uint32 scale, Uint32 bias, Int32 abDotProduct, Int32 cdDotProduct, Int32 muxSum),
      void Function(int stage, int portion, int abOutput, int cdOutput, int sumOutput, int scale, int bias, int abDotProduct, int cdDotProduct, int muxSum)>('glCombinerOutputNV');
  return _glCombinerOutputNV(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
}

/// ```c
/// GLAPI void APIENTRY glFinalCombinerInputNV (GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
/// ```
void glFinalCombinerInputNV(int variable, int input, int mapping, int componentUsage) {
  final _glFinalCombinerInputNV = _SDL2.lookupFunction<
      Void Function(Uint32 variable, Uint32 input, Uint32 mapping, Uint32 componentUsage),
      void Function(int variable, int input, int mapping, int componentUsage)>('glFinalCombinerInputNV');
  return _glFinalCombinerInputNV(variable, input, mapping, componentUsage);
}

/// ```c
/// GLAPI void APIENTRY glGetCombinerInputParameterfvNV (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat *params)
/// ```
void glGetCombinerInputParameterfvNV(int stage, int portion, int variable, int pname, Pointer<Float>? params) {
  final _glGetCombinerInputParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 variable, Uint32 pname, Pointer<Float>? params),
      void Function(int stage, int portion, int variable, int pname, Pointer<Float>? params)>('glGetCombinerInputParameterfvNV');
  return _glGetCombinerInputParameterfvNV(stage, portion, variable, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetCombinerInputParameterivNV (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint *params)
/// ```
void glGetCombinerInputParameterivNV(int stage, int portion, int variable, int pname, Pointer<Int32>? params) {
  final _glGetCombinerInputParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 variable, Uint32 pname, Pointer<Int32>? params),
      void Function(int stage, int portion, int variable, int pname, Pointer<Int32>? params)>('glGetCombinerInputParameterivNV');
  return _glGetCombinerInputParameterivNV(stage, portion, variable, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetCombinerOutputParameterfvNV (GLenum stage, GLenum portion, GLenum pname, GLfloat *params)
/// ```
void glGetCombinerOutputParameterfvNV(int stage, int portion, int pname, Pointer<Float>? params) {
  final _glGetCombinerOutputParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 pname, Pointer<Float>? params),
      void Function(int stage, int portion, int pname, Pointer<Float>? params)>('glGetCombinerOutputParameterfvNV');
  return _glGetCombinerOutputParameterfvNV(stage, portion, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetCombinerOutputParameterivNV (GLenum stage, GLenum portion, GLenum pname, GLint *params)
/// ```
void glGetCombinerOutputParameterivNV(int stage, int portion, int pname, Pointer<Int32>? params) {
  final _glGetCombinerOutputParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 portion, Uint32 pname, Pointer<Int32>? params),
      void Function(int stage, int portion, int pname, Pointer<Int32>? params)>('glGetCombinerOutputParameterivNV');
  return _glGetCombinerOutputParameterivNV(stage, portion, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFinalCombinerInputParameterfvNV (GLenum variable, GLenum pname, GLfloat *params)
/// ```
void glGetFinalCombinerInputParameterfvNV(int variable, int pname, Pointer<Float>? params) {
  final _glGetFinalCombinerInputParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 variable, Uint32 pname, Pointer<Float>? params),
      void Function(int variable, int pname, Pointer<Float>? params)>('glGetFinalCombinerInputParameterfvNV');
  return _glGetFinalCombinerInputParameterfvNV(variable, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFinalCombinerInputParameterivNV (GLenum variable, GLenum pname, GLint *params)
/// ```
void glGetFinalCombinerInputParameterivNV(int variable, int pname, Pointer<Int32>? params) {
  final _glGetFinalCombinerInputParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 variable, Uint32 pname, Pointer<Int32>? params),
      void Function(int variable, int pname, Pointer<Int32>? params)>('glGetFinalCombinerInputParameterivNV');
  return _glGetFinalCombinerInputParameterivNV(variable, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glResizeBuffersMESA (void)
/// ```
void glResizeBuffersMESA() {
  final _glResizeBuffersMESA = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glResizeBuffersMESA');
  return _glResizeBuffersMESA();
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2dMESA (GLdouble x, GLdouble y)
/// ```
void glWindowPos2dMESA(double x, double y) {
  final _glWindowPos2dMESA = _SDL2.lookupFunction<
      Void Function(Double x, Double y),
      void Function(double x, double y)>('glWindowPos2dMESA');
  return _glWindowPos2dMESA(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2dvMESA (const GLdouble *v)
/// ```
void glWindowPos2dvMESA(Pointer<Double>? v) {
  final _glWindowPos2dvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos2dvMESA');
  return _glWindowPos2dvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2fMESA (GLfloat x, GLfloat y)
/// ```
void glWindowPos2fMESA(double x, double y) {
  final _glWindowPos2fMESA = _SDL2.lookupFunction<
      Void Function(Float x, Float y),
      void Function(double x, double y)>('glWindowPos2fMESA');
  return _glWindowPos2fMESA(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2fvMESA (const GLfloat *v)
/// ```
void glWindowPos2fvMESA(Pointer<Float>? v) {
  final _glWindowPos2fvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos2fvMESA');
  return _glWindowPos2fvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2iMESA (GLint x, GLint y)
/// ```
void glWindowPos2iMESA(int x, int y) {
  final _glWindowPos2iMESA = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y),
      void Function(int x, int y)>('glWindowPos2iMESA');
  return _glWindowPos2iMESA(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2ivMESA (const GLint *v)
/// ```
void glWindowPos2ivMESA(Pointer<Int32>? v) {
  final _glWindowPos2ivMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos2ivMESA');
  return _glWindowPos2ivMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2sMESA (GLshort x, GLshort y)
/// ```
void glWindowPos2sMESA(int x, int y) {
  final _glWindowPos2sMESA = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y),
      void Function(int x, int y)>('glWindowPos2sMESA');
  return _glWindowPos2sMESA(x, y);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos2svMESA (const GLshort *v)
/// ```
void glWindowPos2svMESA(Pointer<Int16>? v) {
  final _glWindowPos2svMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos2svMESA');
  return _glWindowPos2svMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3dMESA (GLdouble x, GLdouble y, GLdouble z)
/// ```
void glWindowPos3dMESA(double x, double y, double z) {
  final _glWindowPos3dMESA = _SDL2.lookupFunction<
      Void Function(Double x, Double y, Double z),
      void Function(double x, double y, double z)>('glWindowPos3dMESA');
  return _glWindowPos3dMESA(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3dvMESA (const GLdouble *v)
/// ```
void glWindowPos3dvMESA(Pointer<Double>? v) {
  final _glWindowPos3dvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos3dvMESA');
  return _glWindowPos3dvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3fMESA (GLfloat x, GLfloat y, GLfloat z)
/// ```
void glWindowPos3fMESA(double x, double y, double z) {
  final _glWindowPos3fMESA = _SDL2.lookupFunction<
      Void Function(Float x, Float y, Float z),
      void Function(double x, double y, double z)>('glWindowPos3fMESA');
  return _glWindowPos3fMESA(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3fvMESA (const GLfloat *v)
/// ```
void glWindowPos3fvMESA(Pointer<Float>? v) {
  final _glWindowPos3fvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos3fvMESA');
  return _glWindowPos3fvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3iMESA (GLint x, GLint y, GLint z)
/// ```
void glWindowPos3iMESA(int x, int y, int z) {
  final _glWindowPos3iMESA = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y, Int32 z),
      void Function(int x, int y, int z)>('glWindowPos3iMESA');
  return _glWindowPos3iMESA(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3ivMESA (const GLint *v)
/// ```
void glWindowPos3ivMESA(Pointer<Int32>? v) {
  final _glWindowPos3ivMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos3ivMESA');
  return _glWindowPos3ivMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3sMESA (GLshort x, GLshort y, GLshort z)
/// ```
void glWindowPos3sMESA(int x, int y, int z) {
  final _glWindowPos3sMESA = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y, Int16 z),
      void Function(int x, int y, int z)>('glWindowPos3sMESA');
  return _glWindowPos3sMESA(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos3svMESA (const GLshort *v)
/// ```
void glWindowPos3svMESA(Pointer<Int16>? v) {
  final _glWindowPos3svMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos3svMESA');
  return _glWindowPos3svMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4dMESA (GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glWindowPos4dMESA(double x, double y, double z, double w) {
  final _glWindowPos4dMESA = _SDL2.lookupFunction<
      Void Function(Double x, Double y, Double z, Double w),
      void Function(double x, double y, double z, double w)>('glWindowPos4dMESA');
  return _glWindowPos4dMESA(x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4dvMESA (const GLdouble *v)
/// ```
void glWindowPos4dvMESA(Pointer<Double>? v) {
  final _glWindowPos4dvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Double>? v),
      void Function(Pointer<Double>? v)>('glWindowPos4dvMESA');
  return _glWindowPos4dvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4fMESA (GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glWindowPos4fMESA(double x, double y, double z, double w) {
  final _glWindowPos4fMESA = _SDL2.lookupFunction<
      Void Function(Float x, Float y, Float z, Float w),
      void Function(double x, double y, double z, double w)>('glWindowPos4fMESA');
  return _glWindowPos4fMESA(x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4fvMESA (const GLfloat *v)
/// ```
void glWindowPos4fvMESA(Pointer<Float>? v) {
  final _glWindowPos4fvMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Float>? v),
      void Function(Pointer<Float>? v)>('glWindowPos4fvMESA');
  return _glWindowPos4fvMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4iMESA (GLint x, GLint y, GLint z, GLint w)
/// ```
void glWindowPos4iMESA(int x, int y, int z, int w) {
  final _glWindowPos4iMESA = _SDL2.lookupFunction<
      Void Function(Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int x, int y, int z, int w)>('glWindowPos4iMESA');
  return _glWindowPos4iMESA(x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4ivMESA (const GLint *v)
/// ```
void glWindowPos4ivMESA(Pointer<Int32>? v) {
  final _glWindowPos4ivMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? v),
      void Function(Pointer<Int32>? v)>('glWindowPos4ivMESA');
  return _glWindowPos4ivMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4sMESA (GLshort x, GLshort y, GLshort z, GLshort w)
/// ```
void glWindowPos4sMESA(int x, int y, int z, int w) {
  final _glWindowPos4sMESA = _SDL2.lookupFunction<
      Void Function(Int16 x, Int16 y, Int16 z, Int16 w),
      void Function(int x, int y, int z, int w)>('glWindowPos4sMESA');
  return _glWindowPos4sMESA(x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glWindowPos4svMESA (const GLshort *v)
/// ```
void glWindowPos4svMESA(Pointer<Int16>? v) {
  final _glWindowPos4svMESA = _SDL2.lookupFunction<
      Void Function(Pointer<Int16>? v),
      void Function(Pointer<Int16>? v)>('glWindowPos4svMESA');
  return _glWindowPos4svMESA(v);
}

/// ```c
/// GLAPI void APIENTRY glMultiModeDrawArraysIBM (const GLenum *mode, const GLint *first, const GLsizei *count, GLsizei primcount, GLint modestride)
/// ```
void glMultiModeDrawArraysIBM(Pointer<Uint32>? mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount, int modestride) {
  final _glMultiModeDrawArraysIBM = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? mode, Pointer<Int32>? first, Pointer<Uint32>? count, Uint32 primcount, Int32 modestride),
      void Function(Pointer<Uint32>? mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount, int modestride)>('glMultiModeDrawArraysIBM');
  return _glMultiModeDrawArraysIBM(mode, first, count, primcount, modestride);
}

/// ```c
/// GLAPI void APIENTRY glMultiModeDrawElementsIBM (const GLenum *mode, const GLsizei *count, GLenum type, const GLvoid* const *indices, GLsizei primcount, GLint modestride)
/// ```
void glMultiModeDrawElementsIBM(Pointer<Uint32>? mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount, int modestride) {
  final _glMultiModeDrawElementsIBM = _SDL2.lookupFunction<
      Void Function(Pointer<Uint32>? mode, Pointer<Uint32>? count, Uint32 type, Pointer<Pointer<Void>>? indices, Uint32 primcount, Int32 modestride),
      void Function(Pointer<Uint32>? mode, Pointer<Uint32>? count, int type, Pointer<Pointer<Void>>? indices, int primcount, int modestride)>('glMultiModeDrawElementsIBM');
  return _glMultiModeDrawElementsIBM(mode, count, type, indices, primcount, modestride);
}

/// ```c
/// GLAPI void APIENTRY glColorPointerListIBM (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glColorPointerListIBM(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glColorPointerListIBM = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glColorPointerListIBM');
  return _glColorPointerListIBM(size, type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorPointerListIBM (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glSecondaryColorPointerListIBM(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glSecondaryColorPointerListIBM = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glSecondaryColorPointerListIBM');
  return _glSecondaryColorPointerListIBM(size, type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glEdgeFlagPointerListIBM (GLint stride, const GLboolean* *pointer, GLint ptrstride)
/// ```
void glEdgeFlagPointerListIBM(int stride, Pointer<Pointer<Int32>>? pointer, int ptrstride) {
  final _glEdgeFlagPointerListIBM = _SDL2.lookupFunction<
      Void Function(Int32 stride, Pointer<Pointer<Int32>>? pointer, Int32 ptrstride),
      void Function(int stride, Pointer<Pointer<Int32>>? pointer, int ptrstride)>('glEdgeFlagPointerListIBM');
  return _glEdgeFlagPointerListIBM(stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordPointerListIBM (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glFogCoordPointerListIBM(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glFogCoordPointerListIBM = _SDL2.lookupFunction<
      Void Function(Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glFogCoordPointerListIBM');
  return _glFogCoordPointerListIBM(type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glIndexPointerListIBM (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glIndexPointerListIBM(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glIndexPointerListIBM = _SDL2.lookupFunction<
      Void Function(Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glIndexPointerListIBM');
  return _glIndexPointerListIBM(type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glNormalPointerListIBM (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glNormalPointerListIBM(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glNormalPointerListIBM = _SDL2.lookupFunction<
      Void Function(Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glNormalPointerListIBM');
  return _glNormalPointerListIBM(type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordPointerListIBM (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glTexCoordPointerListIBM(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glTexCoordPointerListIBM = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glTexCoordPointerListIBM');
  return _glTexCoordPointerListIBM(size, type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glVertexPointerListIBM (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride)
/// ```
void glVertexPointerListIBM(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride) {
  final _glVertexPointerListIBM = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Int32 stride, Pointer<Pointer<Void>>? pointer, Int32 ptrstride),
      void Function(int size, int type, int stride, Pointer<Pointer<Void>>? pointer, int ptrstride)>('glVertexPointerListIBM');
  return _glVertexPointerListIBM(size, type, stride, pointer, ptrstride);
}

/// ```c
/// GLAPI void APIENTRY glTbufferMask3DFX (GLuint mask)
/// ```
void glTbufferMask3DFX(int mask) {
  final _glTbufferMask3DFX = _SDL2.lookupFunction<
      Void Function(Uint32 mask),
      void Function(int mask)>('glTbufferMask3DFX');
  return _glTbufferMask3DFX(mask);
}

/// ```c
/// GLAPI void APIENTRY glSampleMaskEXT (GLclampf value, GLboolean invert)
/// ```
void glSampleMaskEXT(double value, int invert) {
  final _glSampleMaskEXT = _SDL2.lookupFunction<
      Void Function(Float value, Int32 invert),
      void Function(double value, int invert)>('glSampleMaskEXT');
  return _glSampleMaskEXT(value, invert);
}

/// ```c
/// GLAPI void APIENTRY glSamplePatternEXT (GLenum pattern)
/// ```
void glSamplePatternEXT(int pattern) {
  final _glSamplePatternEXT = _SDL2.lookupFunction<
      Void Function(Uint32 pattern),
      void Function(int pattern)>('glSamplePatternEXT');
  return _glSamplePatternEXT(pattern);
}

/// ```c
/// GLAPI void APIENTRY glTextureColorMaskSGIS (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
/// ```
void glTextureColorMaskSGIS(int red, int green, int blue, int alpha) {
  final _glTextureColorMaskSGIS = _SDL2.lookupFunction<
      Void Function(Int32 red, Int32 green, Int32 blue, Int32 alpha),
      void Function(int red, int green, int blue, int alpha)>('glTextureColorMaskSGIS');
  return _glTextureColorMaskSGIS(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glIglooInterfaceSGIX (GLenum pname, const GLvoid *params)
/// ```
void glIglooInterfaceSGIX(int pname, Pointer<Void>? params) {
  final _glIglooInterfaceSGIX = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Void>? params),
      void Function(int pname, Pointer<Void>? params)>('glIglooInterfaceSGIX');
  return _glIglooInterfaceSGIX(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glDeleteFencesNV (GLsizei n, const GLuint *fences)
/// ```
void glDeleteFencesNV(int n, Pointer<Uint32>? fences) {
  final _glDeleteFencesNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? fences),
      void Function(int n, Pointer<Uint32>? fences)>('glDeleteFencesNV');
  return _glDeleteFencesNV(n, fences);
}

/// ```c
/// GLAPI void APIENTRY glGenFencesNV (GLsizei n, GLuint *fences)
/// ```
void glGenFencesNV(int n, Pointer<Uint32>? fences) {
  final _glGenFencesNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? fences),
      void Function(int n, Pointer<Uint32>? fences)>('glGenFencesNV');
  return _glGenFencesNV(n, fences);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsFenceNV (GLuint fence)
/// ```
int glIsFenceNV(int fence) {
  final _glIsFenceNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 fence),
      int Function(int fence)>('glIsFenceNV');
  return _glIsFenceNV(fence);
}

/// ```c
/// GLAPI GLboolean APIENTRY glTestFenceNV (GLuint fence)
/// ```
int glTestFenceNV(int fence) {
  final _glTestFenceNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 fence),
      int Function(int fence)>('glTestFenceNV');
  return _glTestFenceNV(fence);
}

/// ```c
/// GLAPI void APIENTRY glGetFenceivNV (GLuint fence, GLenum pname, GLint *params)
/// ```
void glGetFenceivNV(int fence, int pname, Pointer<Int32>? params) {
  final _glGetFenceivNV = _SDL2.lookupFunction<
      Void Function(Uint32 fence, Uint32 pname, Pointer<Int32>? params),
      void Function(int fence, int pname, Pointer<Int32>? params)>('glGetFenceivNV');
  return _glGetFenceivNV(fence, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFinishFenceNV (GLuint fence)
/// ```
void glFinishFenceNV(int fence) {
  final _glFinishFenceNV = _SDL2.lookupFunction<
      Void Function(Uint32 fence),
      void Function(int fence)>('glFinishFenceNV');
  return _glFinishFenceNV(fence);
}

/// ```c
/// GLAPI void APIENTRY glSetFenceNV (GLuint fence, GLenum condition)
/// ```
void glSetFenceNV(int fence, int condition) {
  final _glSetFenceNV = _SDL2.lookupFunction<
      Void Function(Uint32 fence, Uint32 condition),
      void Function(int fence, int condition)>('glSetFenceNV');
  return _glSetFenceNV(fence, condition);
}

/// ```c
/// GLAPI void APIENTRY glMapControlPointsNV (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const GLvoid *points)
/// ```
void glMapControlPointsNV(int target, int index, int type, int ustride, int vstride, int uorder, int vorder, int packed, Pointer<Void>? points) {
  final _glMapControlPointsNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 type, Uint32 ustride, Uint32 vstride, Int32 uorder, Int32 vorder, Int32 packed, Pointer<Void>? points),
      void Function(int target, int index, int type, int ustride, int vstride, int uorder, int vorder, int packed, Pointer<Void>? points)>('glMapControlPointsNV');
  return _glMapControlPointsNV(target, index, type, ustride, vstride, uorder, vorder, packed, points);
}

/// ```c
/// GLAPI void APIENTRY glMapParameterivNV (GLenum target, GLenum pname, const GLint *params)
/// ```
void glMapParameterivNV(int target, int pname, Pointer<Int32>? params) {
  final _glMapParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glMapParameterivNV');
  return _glMapParameterivNV(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMapParameterfvNV (GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glMapParameterfvNV(int target, int pname, Pointer<Float>? params) {
  final _glMapParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glMapParameterfvNV');
  return _glMapParameterfvNV(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMapControlPointsNV (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid *points)
/// ```
void glGetMapControlPointsNV(int target, int index, int type, int ustride, int vstride, int packed, Pointer<Void>? points) {
  final _glGetMapControlPointsNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 type, Uint32 ustride, Uint32 vstride, Int32 packed, Pointer<Void>? points),
      void Function(int target, int index, int type, int ustride, int vstride, int packed, Pointer<Void>? points)>('glGetMapControlPointsNV');
  return _glGetMapControlPointsNV(target, index, type, ustride, vstride, packed, points);
}

/// ```c
/// GLAPI void APIENTRY glGetMapParameterivNV (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMapParameterivNV(int target, int pname, Pointer<Int32>? params) {
  final _glGetMapParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetMapParameterivNV');
  return _glGetMapParameterivNV(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMapParameterfvNV (GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetMapParameterfvNV(int target, int pname, Pointer<Float>? params) {
  final _glGetMapParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int pname, Pointer<Float>? params)>('glGetMapParameterfvNV');
  return _glGetMapParameterfvNV(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMapAttribParameterivNV (GLenum target, GLuint index, GLenum pname, GLint *params)
/// ```
void glGetMapAttribParameterivNV(int target, int index, int pname, Pointer<Int32>? params) {
  final _glGetMapAttribParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int index, int pname, Pointer<Int32>? params)>('glGetMapAttribParameterivNV');
  return _glGetMapAttribParameterivNV(target, index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMapAttribParameterfvNV (GLenum target, GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetMapAttribParameterfvNV(int target, int index, int pname, Pointer<Float>? params) {
  final _glGetMapAttribParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int index, int pname, Pointer<Float>? params)>('glGetMapAttribParameterfvNV');
  return _glGetMapAttribParameterfvNV(target, index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glEvalMapsNV (GLenum target, GLenum mode)
/// ```
void glEvalMapsNV(int target, int mode) {
  final _glEvalMapsNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 mode),
      void Function(int target, int mode)>('glEvalMapsNV');
  return _glEvalMapsNV(target, mode);
}

/// ```c
/// GLAPI void APIENTRY glCombinerStageParameterfvNV (GLenum stage, GLenum pname, const GLfloat *params)
/// ```
void glCombinerStageParameterfvNV(int stage, int pname, Pointer<Float>? params) {
  final _glCombinerStageParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 pname, Pointer<Float>? params),
      void Function(int stage, int pname, Pointer<Float>? params)>('glCombinerStageParameterfvNV');
  return _glCombinerStageParameterfvNV(stage, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetCombinerStageParameterfvNV (GLenum stage, GLenum pname, GLfloat *params)
/// ```
void glGetCombinerStageParameterfvNV(int stage, int pname, Pointer<Float>? params) {
  final _glGetCombinerStageParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 stage, Uint32 pname, Pointer<Float>? params),
      void Function(int stage, int pname, Pointer<Float>? params)>('glGetCombinerStageParameterfvNV');
  return _glGetCombinerStageParameterfvNV(stage, pname, params);
}

/// ```c
/// GLAPI GLboolean APIENTRY glAreProgramsResidentNV (GLsizei n, const GLuint *programs, GLboolean *residences)
/// ```
int glAreProgramsResidentNV(int n, Pointer<Uint32>? programs, Pointer<Int32>? residences) {
  final _glAreProgramsResidentNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 n, Pointer<Uint32>? programs, Pointer<Int32>? residences),
      int Function(int n, Pointer<Uint32>? programs, Pointer<Int32>? residences)>('glAreProgramsResidentNV');
  return _glAreProgramsResidentNV(n, programs, residences);
}

/// ```c
/// GLAPI void APIENTRY glBindProgramNV (GLenum target, GLuint id)
/// ```
void glBindProgramNV(int target, int id) {
  final _glBindProgramNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id),
      void Function(int target, int id)>('glBindProgramNV');
  return _glBindProgramNV(target, id);
}

/// ```c
/// GLAPI void APIENTRY glDeleteProgramsNV (GLsizei n, const GLuint *programs)
/// ```
void glDeleteProgramsNV(int n, Pointer<Uint32>? programs) {
  final _glDeleteProgramsNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? programs),
      void Function(int n, Pointer<Uint32>? programs)>('glDeleteProgramsNV');
  return _glDeleteProgramsNV(n, programs);
}

/// ```c
/// GLAPI void APIENTRY glExecuteProgramNV (GLenum target, GLuint id, const GLfloat *params)
/// ```
void glExecuteProgramNV(int target, int id, Pointer<Float>? params) {
  final _glExecuteProgramNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id, Pointer<Float>? params),
      void Function(int target, int id, Pointer<Float>? params)>('glExecuteProgramNV');
  return _glExecuteProgramNV(target, id, params);
}

/// ```c
/// GLAPI void APIENTRY glGenProgramsNV (GLsizei n, GLuint *programs)
/// ```
void glGenProgramsNV(int n, Pointer<Uint32>? programs) {
  final _glGenProgramsNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? programs),
      void Function(int n, Pointer<Uint32>? programs)>('glGenProgramsNV');
  return _glGenProgramsNV(n, programs);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramParameterdvNV (GLenum target, GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetProgramParameterdvNV(int target, int index, int pname, Pointer<Double>? params) {
  final _glGetProgramParameterdvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int target, int index, int pname, Pointer<Double>? params)>('glGetProgramParameterdvNV');
  return _glGetProgramParameterdvNV(target, index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramParameterfvNV (GLenum target, GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetProgramParameterfvNV(int target, int index, int pname, Pointer<Float>? params) {
  final _glGetProgramParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int target, int index, int pname, Pointer<Float>? params)>('glGetProgramParameterfvNV');
  return _glGetProgramParameterfvNV(target, index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramivNV (GLuint id, GLenum pname, GLint *params)
/// ```
void glGetProgramivNV(int id, int pname, Pointer<Int32>? params) {
  final _glGetProgramivNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int32>? params),
      void Function(int id, int pname, Pointer<Int32>? params)>('glGetProgramivNV');
  return _glGetProgramivNV(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramStringNV (GLuint id, GLenum pname, GLubyte *program)
/// ```
void glGetProgramStringNV(int id, int pname, Pointer<Uint8>? program) {
  final _glGetProgramStringNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint8>? program),
      void Function(int id, int pname, Pointer<Uint8>? program)>('glGetProgramStringNV');
  return _glGetProgramStringNV(id, pname, program);
}

/// ```c
/// GLAPI void APIENTRY glGetTrackMatrixivNV (GLenum target, GLuint address, GLenum pname, GLint *params)
/// ```
void glGetTrackMatrixivNV(int target, int address, int pname, Pointer<Int32>? params) {
  final _glGetTrackMatrixivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 address, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int address, int pname, Pointer<Int32>? params)>('glGetTrackMatrixivNV');
  return _glGetTrackMatrixivNV(target, address, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribdvNV (GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetVertexAttribdvNV(int index, int pname, Pointer<Double>? params) {
  final _glGetVertexAttribdvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int index, int pname, Pointer<Double>? params)>('glGetVertexAttribdvNV');
  return _glGetVertexAttribdvNV(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribfvNV (GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetVertexAttribfvNV(int index, int pname, Pointer<Float>? params) {
  final _glGetVertexAttribfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int index, int pname, Pointer<Float>? params)>('glGetVertexAttribfvNV');
  return _glGetVertexAttribfvNV(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribivNV (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribivNV(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribivNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribivNV');
  return _glGetVertexAttribivNV(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribPointervNV (GLuint index, GLenum pname, GLvoid* *pointer)
/// ```
void glGetVertexAttribPointervNV(int index, int pname, Pointer<Pointer<Void>>? pointer) {
  final _glGetVertexAttribPointervNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Pointer<Void>>? pointer),
      void Function(int index, int pname, Pointer<Pointer<Void>>? pointer)>('glGetVertexAttribPointervNV');
  return _glGetVertexAttribPointervNV(index, pname, pointer);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsProgramNV (GLuint id)
/// ```
int glIsProgramNV(int id) {
  final _glIsProgramNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsProgramNV');
  return _glIsProgramNV(id);
}

/// ```c
/// GLAPI void APIENTRY glLoadProgramNV (GLenum target, GLuint id, GLsizei len, const GLubyte *program)
/// ```
void glLoadProgramNV(int target, int id, int len, Pointer<Uint8>? program) {
  final _glLoadProgramNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id, Uint32 len, Pointer<Uint8>? program),
      void Function(int target, int id, int len, Pointer<Uint8>? program)>('glLoadProgramNV');
  return _glLoadProgramNV(target, id, len, program);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameter4dNV (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glProgramParameter4dNV(int target, int index, double x, double y, double z, double w) {
  final _glProgramParameter4dNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramParameter4dNV');
  return _glProgramParameter4dNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameter4dvNV (GLenum target, GLuint index, const GLdouble *v)
/// ```
void glProgramParameter4dvNV(int target, int index, Pointer<Double>? v) {
  final _glProgramParameter4dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? v),
      void Function(int target, int index, Pointer<Double>? v)>('glProgramParameter4dvNV');
  return _glProgramParameter4dvNV(target, index, v);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameter4fNV (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glProgramParameter4fNV(int target, int index, double x, double y, double z, double w) {
  final _glProgramParameter4fNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int target, int index, double x, double y, double z, double w)>('glProgramParameter4fNV');
  return _glProgramParameter4fNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameter4fvNV (GLenum target, GLuint index, const GLfloat *v)
/// ```
void glProgramParameter4fvNV(int target, int index, Pointer<Float>? v) {
  final _glProgramParameter4fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? v),
      void Function(int target, int index, Pointer<Float>? v)>('glProgramParameter4fvNV');
  return _glProgramParameter4fvNV(target, index, v);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameters4dvNV (GLenum target, GLuint index, GLuint count, const GLdouble *v)
/// ```
void glProgramParameters4dvNV(int target, int index, int count, Pointer<Double>? v) {
  final _glProgramParameters4dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Double>? v),
      void Function(int target, int index, int count, Pointer<Double>? v)>('glProgramParameters4dvNV');
  return _glProgramParameters4dvNV(target, index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameters4fvNV (GLenum target, GLuint index, GLuint count, const GLfloat *v)
/// ```
void glProgramParameters4fvNV(int target, int index, int count, Pointer<Float>? v) {
  final _glProgramParameters4fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Float>? v),
      void Function(int target, int index, int count, Pointer<Float>? v)>('glProgramParameters4fvNV');
  return _glProgramParameters4fvNV(target, index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glRequestResidentProgramsNV (GLsizei n, const GLuint *programs)
/// ```
void glRequestResidentProgramsNV(int n, Pointer<Uint32>? programs) {
  final _glRequestResidentProgramsNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? programs),
      void Function(int n, Pointer<Uint32>? programs)>('glRequestResidentProgramsNV');
  return _glRequestResidentProgramsNV(n, programs);
}

/// ```c
/// GLAPI void APIENTRY glTrackMatrixNV (GLenum target, GLuint address, GLenum matrix, GLenum transform)
/// ```
void glTrackMatrixNV(int target, int address, int matrix, int transform) {
  final _glTrackMatrixNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 address, Uint32 matrix, Uint32 transform),
      void Function(int target, int address, int matrix, int transform)>('glTrackMatrixNV');
  return _glTrackMatrixNV(target, address, matrix, transform);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribPointerNV (GLuint index, GLint fsize, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribPointerNV(int index, int fsize, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribPointerNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 fsize, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int fsize, int type, int stride, Pointer<Void>? pointer)>('glVertexAttribPointerNV');
  return _glVertexAttribPointerNV(index, fsize, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1dNV (GLuint index, GLdouble x)
/// ```
void glVertexAttrib1dNV(int index, double x) {
  final _glVertexAttrib1dNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x),
      void Function(int index, double x)>('glVertexAttrib1dNV');
  return _glVertexAttrib1dNV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1dvNV (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib1dvNV(int index, Pointer<Double>? v) {
  final _glVertexAttrib1dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib1dvNV');
  return _glVertexAttrib1dvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1fNV (GLuint index, GLfloat x)
/// ```
void glVertexAttrib1fNV(int index, double x) {
  final _glVertexAttrib1fNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x),
      void Function(int index, double x)>('glVertexAttrib1fNV');
  return _glVertexAttrib1fNV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1fvNV (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib1fvNV(int index, Pointer<Float>? v) {
  final _glVertexAttrib1fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib1fvNV');
  return _glVertexAttrib1fvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1sNV (GLuint index, GLshort x)
/// ```
void glVertexAttrib1sNV(int index, int x) {
  final _glVertexAttrib1sNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x),
      void Function(int index, int x)>('glVertexAttrib1sNV');
  return _glVertexAttrib1sNV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1svNV (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib1svNV(int index, Pointer<Int16>? v) {
  final _glVertexAttrib1svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib1svNV');
  return _glVertexAttrib1svNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2dNV (GLuint index, GLdouble x, GLdouble y)
/// ```
void glVertexAttrib2dNV(int index, double x, double y) {
  final _glVertexAttrib2dNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y),
      void Function(int index, double x, double y)>('glVertexAttrib2dNV');
  return _glVertexAttrib2dNV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2dvNV (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib2dvNV(int index, Pointer<Double>? v) {
  final _glVertexAttrib2dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib2dvNV');
  return _glVertexAttrib2dvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2fNV (GLuint index, GLfloat x, GLfloat y)
/// ```
void glVertexAttrib2fNV(int index, double x, double y) {
  final _glVertexAttrib2fNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y),
      void Function(int index, double x, double y)>('glVertexAttrib2fNV');
  return _glVertexAttrib2fNV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2fvNV (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib2fvNV(int index, Pointer<Float>? v) {
  final _glVertexAttrib2fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib2fvNV');
  return _glVertexAttrib2fvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2sNV (GLuint index, GLshort x, GLshort y)
/// ```
void glVertexAttrib2sNV(int index, int x, int y) {
  final _glVertexAttrib2sNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y),
      void Function(int index, int x, int y)>('glVertexAttrib2sNV');
  return _glVertexAttrib2sNV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2svNV (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib2svNV(int index, Pointer<Int16>? v) {
  final _glVertexAttrib2svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib2svNV');
  return _glVertexAttrib2svNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3dNV (GLuint index, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexAttrib3dNV(int index, double x, double y, double z) {
  final _glVertexAttrib3dNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3dNV');
  return _glVertexAttrib3dNV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3dvNV (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib3dvNV(int index, Pointer<Double>? v) {
  final _glVertexAttrib3dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib3dvNV');
  return _glVertexAttrib3dvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3fNV (GLuint index, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glVertexAttrib3fNV(int index, double x, double y, double z) {
  final _glVertexAttrib3fNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z),
      void Function(int index, double x, double y, double z)>('glVertexAttrib3fNV');
  return _glVertexAttrib3fNV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3fvNV (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib3fvNV(int index, Pointer<Float>? v) {
  final _glVertexAttrib3fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib3fvNV');
  return _glVertexAttrib3fvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3sNV (GLuint index, GLshort x, GLshort y, GLshort z)
/// ```
void glVertexAttrib3sNV(int index, int x, int y, int z) {
  final _glVertexAttrib3sNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z),
      void Function(int index, int x, int y, int z)>('glVertexAttrib3sNV');
  return _glVertexAttrib3sNV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3svNV (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib3svNV(int index, Pointer<Int16>? v) {
  final _glVertexAttrib3svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib3svNV');
  return _glVertexAttrib3svNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4dNV (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexAttrib4dNV(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4dNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4dNV');
  return _glVertexAttrib4dNV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4dvNV (GLuint index, const GLdouble *v)
/// ```
void glVertexAttrib4dvNV(int index, Pointer<Double>? v) {
  final _glVertexAttrib4dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttrib4dvNV');
  return _glVertexAttrib4dvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4fNV (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glVertexAttrib4fNV(int index, double x, double y, double z, double w) {
  final _glVertexAttrib4fNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttrib4fNV');
  return _glVertexAttrib4fNV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4fvNV (GLuint index, const GLfloat *v)
/// ```
void glVertexAttrib4fvNV(int index, Pointer<Float>? v) {
  final _glVertexAttrib4fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Float>? v),
      void Function(int index, Pointer<Float>? v)>('glVertexAttrib4fvNV');
  return _glVertexAttrib4fvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4sNV (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
/// ```
void glVertexAttrib4sNV(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4sNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int16 x, Int16 y, Int16 z, Int16 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4sNV');
  return _glVertexAttrib4sNV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4svNV (GLuint index, const GLshort *v)
/// ```
void glVertexAttrib4svNV(int index, Pointer<Int16>? v) {
  final _glVertexAttrib4svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttrib4svNV');
  return _glVertexAttrib4svNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4ubNV (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
/// ```
void glVertexAttrib4ubNV(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4ubNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint8 x, Uint8 y, Uint8 z, Uint8 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4ubNV');
  return _glVertexAttrib4ubNV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4ubvNV (GLuint index, const GLubyte *v)
/// ```
void glVertexAttrib4ubvNV(int index, Pointer<Uint8>? v) {
  final _glVertexAttrib4ubvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttrib4ubvNV');
  return _glVertexAttrib4ubvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs1dvNV (GLuint index, GLsizei count, const GLdouble *v)
/// ```
void glVertexAttribs1dvNV(int index, int count, Pointer<Double>? v) {
  final _glVertexAttribs1dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Double>? v),
      void Function(int index, int count, Pointer<Double>? v)>('glVertexAttribs1dvNV');
  return _glVertexAttribs1dvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs1fvNV (GLuint index, GLsizei count, const GLfloat *v)
/// ```
void glVertexAttribs1fvNV(int index, int count, Pointer<Float>? v) {
  final _glVertexAttribs1fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Float>? v),
      void Function(int index, int count, Pointer<Float>? v)>('glVertexAttribs1fvNV');
  return _glVertexAttribs1fvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs1svNV (GLuint index, GLsizei count, const GLshort *v)
/// ```
void glVertexAttribs1svNV(int index, int count, Pointer<Int16>? v) {
  final _glVertexAttribs1svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Int16>? v),
      void Function(int index, int count, Pointer<Int16>? v)>('glVertexAttribs1svNV');
  return _glVertexAttribs1svNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs2dvNV (GLuint index, GLsizei count, const GLdouble *v)
/// ```
void glVertexAttribs2dvNV(int index, int count, Pointer<Double>? v) {
  final _glVertexAttribs2dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Double>? v),
      void Function(int index, int count, Pointer<Double>? v)>('glVertexAttribs2dvNV');
  return _glVertexAttribs2dvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs2fvNV (GLuint index, GLsizei count, const GLfloat *v)
/// ```
void glVertexAttribs2fvNV(int index, int count, Pointer<Float>? v) {
  final _glVertexAttribs2fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Float>? v),
      void Function(int index, int count, Pointer<Float>? v)>('glVertexAttribs2fvNV');
  return _glVertexAttribs2fvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs2svNV (GLuint index, GLsizei count, const GLshort *v)
/// ```
void glVertexAttribs2svNV(int index, int count, Pointer<Int16>? v) {
  final _glVertexAttribs2svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Int16>? v),
      void Function(int index, int count, Pointer<Int16>? v)>('glVertexAttribs2svNV');
  return _glVertexAttribs2svNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs3dvNV (GLuint index, GLsizei count, const GLdouble *v)
/// ```
void glVertexAttribs3dvNV(int index, int count, Pointer<Double>? v) {
  final _glVertexAttribs3dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Double>? v),
      void Function(int index, int count, Pointer<Double>? v)>('glVertexAttribs3dvNV');
  return _glVertexAttribs3dvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs3fvNV (GLuint index, GLsizei count, const GLfloat *v)
/// ```
void glVertexAttribs3fvNV(int index, int count, Pointer<Float>? v) {
  final _glVertexAttribs3fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Float>? v),
      void Function(int index, int count, Pointer<Float>? v)>('glVertexAttribs3fvNV');
  return _glVertexAttribs3fvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs3svNV (GLuint index, GLsizei count, const GLshort *v)
/// ```
void glVertexAttribs3svNV(int index, int count, Pointer<Int16>? v) {
  final _glVertexAttribs3svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Int16>? v),
      void Function(int index, int count, Pointer<Int16>? v)>('glVertexAttribs3svNV');
  return _glVertexAttribs3svNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs4dvNV (GLuint index, GLsizei count, const GLdouble *v)
/// ```
void glVertexAttribs4dvNV(int index, int count, Pointer<Double>? v) {
  final _glVertexAttribs4dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Double>? v),
      void Function(int index, int count, Pointer<Double>? v)>('glVertexAttribs4dvNV');
  return _glVertexAttribs4dvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs4fvNV (GLuint index, GLsizei count, const GLfloat *v)
/// ```
void glVertexAttribs4fvNV(int index, int count, Pointer<Float>? v) {
  final _glVertexAttribs4fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Float>? v),
      void Function(int index, int count, Pointer<Float>? v)>('glVertexAttribs4fvNV');
  return _glVertexAttribs4fvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs4svNV (GLuint index, GLsizei count, const GLshort *v)
/// ```
void glVertexAttribs4svNV(int index, int count, Pointer<Int16>? v) {
  final _glVertexAttribs4svNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Int16>? v),
      void Function(int index, int count, Pointer<Int16>? v)>('glVertexAttribs4svNV');
  return _glVertexAttribs4svNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs4ubvNV (GLuint index, GLsizei count, const GLubyte *v)
/// ```
void glVertexAttribs4ubvNV(int index, int count, Pointer<Uint8>? v) {
  final _glVertexAttribs4ubvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 count, Pointer<Uint8>? v),
      void Function(int index, int count, Pointer<Uint8>? v)>('glVertexAttribs4ubvNV');
  return _glVertexAttribs4ubvNV(index, count, v);
}

/// ```c
/// GLAPI void APIENTRY glTexBumpParameterivATI (GLenum pname, const GLint *param)
/// ```
void glTexBumpParameterivATI(int pname, Pointer<Int32>? param) {
  final _glTexBumpParameterivATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? param),
      void Function(int pname, Pointer<Int32>? param)>('glTexBumpParameterivATI');
  return _glTexBumpParameterivATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glTexBumpParameterfvATI (GLenum pname, const GLfloat *param)
/// ```
void glTexBumpParameterfvATI(int pname, Pointer<Float>? param) {
  final _glTexBumpParameterfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? param),
      void Function(int pname, Pointer<Float>? param)>('glTexBumpParameterfvATI');
  return _glTexBumpParameterfvATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glGetTexBumpParameterivATI (GLenum pname, GLint *param)
/// ```
void glGetTexBumpParameterivATI(int pname, Pointer<Int32>? param) {
  final _glGetTexBumpParameterivATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? param),
      void Function(int pname, Pointer<Int32>? param)>('glGetTexBumpParameterivATI');
  return _glGetTexBumpParameterivATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glGetTexBumpParameterfvATI (GLenum pname, GLfloat *param)
/// ```
void glGetTexBumpParameterfvATI(int pname, Pointer<Float>? param) {
  final _glGetTexBumpParameterfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Float>? param),
      void Function(int pname, Pointer<Float>? param)>('glGetTexBumpParameterfvATI');
  return _glGetTexBumpParameterfvATI(pname, param);
}

/// ```c
/// GLAPI GLuint APIENTRY glGenFragmentShadersATI (GLuint range)
/// ```
int glGenFragmentShadersATI(int range) {
  final _glGenFragmentShadersATI = _SDL2.lookupFunction<
      Uint32 Function(Uint32 range),
      int Function(int range)>('glGenFragmentShadersATI');
  return _glGenFragmentShadersATI(range);
}

/// ```c
/// GLAPI void APIENTRY glBindFragmentShaderATI (GLuint id)
/// ```
void glBindFragmentShaderATI(int id) {
  final _glBindFragmentShaderATI = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glBindFragmentShaderATI');
  return _glBindFragmentShaderATI(id);
}

/// ```c
/// GLAPI void APIENTRY glDeleteFragmentShaderATI (GLuint id)
/// ```
void glDeleteFragmentShaderATI(int id) {
  final _glDeleteFragmentShaderATI = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glDeleteFragmentShaderATI');
  return _glDeleteFragmentShaderATI(id);
}

/// ```c
/// GLAPI void APIENTRY glBeginFragmentShaderATI (void)
/// ```
void glBeginFragmentShaderATI() {
  final _glBeginFragmentShaderATI = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glBeginFragmentShaderATI');
  return _glBeginFragmentShaderATI();
}

/// ```c
/// GLAPI void APIENTRY glEndFragmentShaderATI (void)
/// ```
void glEndFragmentShaderATI() {
  final _glEndFragmentShaderATI = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndFragmentShaderATI');
  return _glEndFragmentShaderATI();
}

/// ```c
/// GLAPI void APIENTRY glPassTexCoordATI (GLuint dst, GLuint coord, GLenum swizzle)
/// ```
void glPassTexCoordATI(int dst, int coord, int swizzle) {
  final _glPassTexCoordATI = _SDL2.lookupFunction<
      Void Function(Uint32 dst, Uint32 coord, Uint32 swizzle),
      void Function(int dst, int coord, int swizzle)>('glPassTexCoordATI');
  return _glPassTexCoordATI(dst, coord, swizzle);
}

/// ```c
/// GLAPI void APIENTRY glSampleMapATI (GLuint dst, GLuint interp, GLenum swizzle)
/// ```
void glSampleMapATI(int dst, int interp, int swizzle) {
  final _glSampleMapATI = _SDL2.lookupFunction<
      Void Function(Uint32 dst, Uint32 interp, Uint32 swizzle),
      void Function(int dst, int interp, int swizzle)>('glSampleMapATI');
  return _glSampleMapATI(dst, interp, swizzle);
}

/// ```c
/// GLAPI void APIENTRY glColorFragmentOp1ATI (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod)
/// ```
void glColorFragmentOp1ATI(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod) {
  final _glColorFragmentOp1ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMask, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod),
      void Function(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod)>('glColorFragmentOp1ATI');
  return _glColorFragmentOp1ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod);
}

/// ```c
/// GLAPI void APIENTRY glColorFragmentOp2ATI (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod)
/// ```
void glColorFragmentOp2ATI(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod) {
  final _glColorFragmentOp2ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMask, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod, Uint32 arg2, Uint32 arg2Rep, Uint32 arg2Mod),
      void Function(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod)>('glColorFragmentOp2ATI');
  return _glColorFragmentOp2ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
}

/// ```c
/// GLAPI void APIENTRY glColorFragmentOp3ATI (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod)
/// ```
void glColorFragmentOp3ATI(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod, int arg3, int arg3Rep, int arg3Mod) {
  final _glColorFragmentOp3ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMask, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod, Uint32 arg2, Uint32 arg2Rep, Uint32 arg2Mod, Uint32 arg3, Uint32 arg3Rep, Uint32 arg3Mod),
      void Function(int op, int dst, int dstMask, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod, int arg3, int arg3Rep, int arg3Mod)>('glColorFragmentOp3ATI');
  return _glColorFragmentOp3ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
}

/// ```c
/// GLAPI void APIENTRY glAlphaFragmentOp1ATI (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod)
/// ```
void glAlphaFragmentOp1ATI(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod) {
  final _glAlphaFragmentOp1ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod),
      void Function(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod)>('glAlphaFragmentOp1ATI');
  return _glAlphaFragmentOp1ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod);
}

/// ```c
/// GLAPI void APIENTRY glAlphaFragmentOp2ATI (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod)
/// ```
void glAlphaFragmentOp2ATI(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod) {
  final _glAlphaFragmentOp2ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod, Uint32 arg2, Uint32 arg2Rep, Uint32 arg2Mod),
      void Function(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod)>('glAlphaFragmentOp2ATI');
  return _glAlphaFragmentOp2ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
}

/// ```c
/// GLAPI void APIENTRY glAlphaFragmentOp3ATI (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod)
/// ```
void glAlphaFragmentOp3ATI(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod, int arg3, int arg3Rep, int arg3Mod) {
  final _glAlphaFragmentOp3ATI = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 dst, Uint32 dstMod, Uint32 arg1, Uint32 arg1Rep, Uint32 arg1Mod, Uint32 arg2, Uint32 arg2Rep, Uint32 arg2Mod, Uint32 arg3, Uint32 arg3Rep, Uint32 arg3Mod),
      void Function(int op, int dst, int dstMod, int arg1, int arg1Rep, int arg1Mod, int arg2, int arg2Rep, int arg2Mod, int arg3, int arg3Rep, int arg3Mod)>('glAlphaFragmentOp3ATI');
  return _glAlphaFragmentOp3ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
}

/// ```c
/// GLAPI void APIENTRY glSetFragmentShaderConstantATI (GLuint dst, const GLfloat *value)
/// ```
void glSetFragmentShaderConstantATI(int dst, Pointer<Float>? value) {
  final _glSetFragmentShaderConstantATI = _SDL2.lookupFunction<
      Void Function(Uint32 dst, Pointer<Float>? value),
      void Function(int dst, Pointer<Float>? value)>('glSetFragmentShaderConstantATI');
  return _glSetFragmentShaderConstantATI(dst, value);
}

/// ```c
/// GLAPI void APIENTRY glPNTrianglesiATI (GLenum pname, GLint param)
/// ```
void glPNTrianglesiATI(int pname, int param) {
  final _glPNTrianglesiATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glPNTrianglesiATI');
  return _glPNTrianglesiATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPNTrianglesfATI (GLenum pname, GLfloat param)
/// ```
void glPNTrianglesfATI(int pname, double param) {
  final _glPNTrianglesfATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glPNTrianglesfATI');
  return _glPNTrianglesfATI(pname, param);
}

/// ```c
/// GLAPI GLuint APIENTRY glNewObjectBufferATI (GLsizei size, const GLvoid *pointer, GLenum usage)
/// ```
int glNewObjectBufferATI(int size, Pointer<Void>? pointer, int usage) {
  final _glNewObjectBufferATI = _SDL2.lookupFunction<
      Uint32 Function(Uint32 size, Pointer<Void>? pointer, Uint32 usage),
      int Function(int size, Pointer<Void>? pointer, int usage)>('glNewObjectBufferATI');
  return _glNewObjectBufferATI(size, pointer, usage);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsObjectBufferATI (GLuint buffer)
/// ```
int glIsObjectBufferATI(int buffer) {
  final _glIsObjectBufferATI = _SDL2.lookupFunction<
      Int32 Function(Uint32 buffer),
      int Function(int buffer)>('glIsObjectBufferATI');
  return _glIsObjectBufferATI(buffer);
}

/// ```c
/// GLAPI void APIENTRY glUpdateObjectBufferATI (GLuint buffer, GLuint offset, GLsizei size, const GLvoid *pointer, GLenum preserve)
/// ```
void glUpdateObjectBufferATI(int buffer, int offset, int size, Pointer<Void>? pointer, int preserve) {
  final _glUpdateObjectBufferATI = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 offset, Uint32 size, Pointer<Void>? pointer, Uint32 preserve),
      void Function(int buffer, int offset, int size, Pointer<Void>? pointer, int preserve)>('glUpdateObjectBufferATI');
  return _glUpdateObjectBufferATI(buffer, offset, size, pointer, preserve);
}

/// ```c
/// GLAPI void APIENTRY glGetObjectBufferfvATI (GLuint buffer, GLenum pname, GLfloat *params)
/// ```
void glGetObjectBufferfvATI(int buffer, int pname, Pointer<Float>? params) {
  final _glGetObjectBufferfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 pname, Pointer<Float>? params),
      void Function(int buffer, int pname, Pointer<Float>? params)>('glGetObjectBufferfvATI');
  return _glGetObjectBufferfvATI(buffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetObjectBufferivATI (GLuint buffer, GLenum pname, GLint *params)
/// ```
void glGetObjectBufferivATI(int buffer, int pname, Pointer<Int32>? params) {
  final _glGetObjectBufferivATI = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 pname, Pointer<Int32>? params),
      void Function(int buffer, int pname, Pointer<Int32>? params)>('glGetObjectBufferivATI');
  return _glGetObjectBufferivATI(buffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glFreeObjectBufferATI (GLuint buffer)
/// ```
void glFreeObjectBufferATI(int buffer) {
  final _glFreeObjectBufferATI = _SDL2.lookupFunction<
      Void Function(Uint32 buffer),
      void Function(int buffer)>('glFreeObjectBufferATI');
  return _glFreeObjectBufferATI(buffer);
}

/// ```c
/// GLAPI void APIENTRY glArrayObjectATI (GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset)
/// ```
void glArrayObjectATI(int array, int size, int type, int stride, int buffer, int offset) {
  final _glArrayObjectATI = _SDL2.lookupFunction<
      Void Function(Uint32 array, Int32 size, Uint32 type, Uint32 stride, Uint32 buffer, Uint32 offset),
      void Function(int array, int size, int type, int stride, int buffer, int offset)>('glArrayObjectATI');
  return _glArrayObjectATI(array, size, type, stride, buffer, offset);
}

/// ```c
/// GLAPI void APIENTRY glGetArrayObjectfvATI (GLenum array, GLenum pname, GLfloat *params)
/// ```
void glGetArrayObjectfvATI(int array, int pname, Pointer<Float>? params) {
  final _glGetArrayObjectfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 array, Uint32 pname, Pointer<Float>? params),
      void Function(int array, int pname, Pointer<Float>? params)>('glGetArrayObjectfvATI');
  return _glGetArrayObjectfvATI(array, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetArrayObjectivATI (GLenum array, GLenum pname, GLint *params)
/// ```
void glGetArrayObjectivATI(int array, int pname, Pointer<Int32>? params) {
  final _glGetArrayObjectivATI = _SDL2.lookupFunction<
      Void Function(Uint32 array, Uint32 pname, Pointer<Int32>? params),
      void Function(int array, int pname, Pointer<Int32>? params)>('glGetArrayObjectivATI');
  return _glGetArrayObjectivATI(array, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVariantArrayObjectATI (GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset)
/// ```
void glVariantArrayObjectATI(int id, int type, int stride, int buffer, int offset) {
  final _glVariantArrayObjectATI = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 type, Uint32 stride, Uint32 buffer, Uint32 offset),
      void Function(int id, int type, int stride, int buffer, int offset)>('glVariantArrayObjectATI');
  return _glVariantArrayObjectATI(id, type, stride, buffer, offset);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantArrayObjectfvATI (GLuint id, GLenum pname, GLfloat *params)
/// ```
void glGetVariantArrayObjectfvATI(int id, int pname, Pointer<Float>? params) {
  final _glGetVariantArrayObjectfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Float>? params),
      void Function(int id, int pname, Pointer<Float>? params)>('glGetVariantArrayObjectfvATI');
  return _glGetVariantArrayObjectfvATI(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantArrayObjectivATI (GLuint id, GLenum pname, GLint *params)
/// ```
void glGetVariantArrayObjectivATI(int id, int pname, Pointer<Int32>? params) {
  final _glGetVariantArrayObjectivATI = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int32>? params),
      void Function(int id, int pname, Pointer<Int32>? params)>('glGetVariantArrayObjectivATI');
  return _glGetVariantArrayObjectivATI(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glBeginVertexShaderEXT (void)
/// ```
void glBeginVertexShaderEXT() {
  final _glBeginVertexShaderEXT = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glBeginVertexShaderEXT');
  return _glBeginVertexShaderEXT();
}

/// ```c
/// GLAPI void APIENTRY glEndVertexShaderEXT (void)
/// ```
void glEndVertexShaderEXT() {
  final _glEndVertexShaderEXT = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndVertexShaderEXT');
  return _glEndVertexShaderEXT();
}

/// ```c
/// GLAPI void APIENTRY glBindVertexShaderEXT (GLuint id)
/// ```
void glBindVertexShaderEXT(int id) {
  final _glBindVertexShaderEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glBindVertexShaderEXT');
  return _glBindVertexShaderEXT(id);
}

/// ```c
/// GLAPI GLuint APIENTRY glGenVertexShadersEXT (GLuint range)
/// ```
int glGenVertexShadersEXT(int range) {
  final _glGenVertexShadersEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 range),
      int Function(int range)>('glGenVertexShadersEXT');
  return _glGenVertexShadersEXT(range);
}

/// ```c
/// GLAPI void APIENTRY glDeleteVertexShaderEXT (GLuint id)
/// ```
void glDeleteVertexShaderEXT(int id) {
  final _glDeleteVertexShaderEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glDeleteVertexShaderEXT');
  return _glDeleteVertexShaderEXT(id);
}

/// ```c
/// GLAPI void APIENTRY glShaderOp1EXT (GLenum op, GLuint res, GLuint arg1)
/// ```
void glShaderOp1EXT(int op, int res, int arg1) {
  final _glShaderOp1EXT = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 res, Uint32 arg1),
      void Function(int op, int res, int arg1)>('glShaderOp1EXT');
  return _glShaderOp1EXT(op, res, arg1);
}

/// ```c
/// GLAPI void APIENTRY glShaderOp2EXT (GLenum op, GLuint res, GLuint arg1, GLuint arg2)
/// ```
void glShaderOp2EXT(int op, int res, int arg1, int arg2) {
  final _glShaderOp2EXT = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 res, Uint32 arg1, Uint32 arg2),
      void Function(int op, int res, int arg1, int arg2)>('glShaderOp2EXT');
  return _glShaderOp2EXT(op, res, arg1, arg2);
}

/// ```c
/// GLAPI void APIENTRY glShaderOp3EXT (GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3)
/// ```
void glShaderOp3EXT(int op, int res, int arg1, int arg2, int arg3) {
  final _glShaderOp3EXT = _SDL2.lookupFunction<
      Void Function(Uint32 op, Uint32 res, Uint32 arg1, Uint32 arg2, Uint32 arg3),
      void Function(int op, int res, int arg1, int arg2, int arg3)>('glShaderOp3EXT');
  return _glShaderOp3EXT(op, res, arg1, arg2, arg3);
}

/// ```c
/// GLAPI void APIENTRY glSwizzleEXT (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW)
/// ```
void glSwizzleEXT(int res, int in_, int outX, int outY, int outZ, int outW) {
  final _glSwizzleEXT = _SDL2.lookupFunction<
      Void Function(Uint32 res, Uint32 in_, Uint32 outX, Uint32 outY, Uint32 outZ, Uint32 outW),
      void Function(int res, int in_, int outX, int outY, int outZ, int outW)>('glSwizzleEXT');
  return _glSwizzleEXT(res, in_, outX, outY, outZ, outW);
}

/// ```c
/// GLAPI void APIENTRY glWriteMaskEXT (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW)
/// ```
void glWriteMaskEXT(int res, int in_, int outX, int outY, int outZ, int outW) {
  final _glWriteMaskEXT = _SDL2.lookupFunction<
      Void Function(Uint32 res, Uint32 in_, Uint32 outX, Uint32 outY, Uint32 outZ, Uint32 outW),
      void Function(int res, int in_, int outX, int outY, int outZ, int outW)>('glWriteMaskEXT');
  return _glWriteMaskEXT(res, in_, outX, outY, outZ, outW);
}

/// ```c
/// GLAPI void APIENTRY glInsertComponentEXT (GLuint res, GLuint src, GLuint num)
/// ```
void glInsertComponentEXT(int res, int src, int num) {
  final _glInsertComponentEXT = _SDL2.lookupFunction<
      Void Function(Uint32 res, Uint32 src, Uint32 num),
      void Function(int res, int src, int num)>('glInsertComponentEXT');
  return _glInsertComponentEXT(res, src, num);
}

/// ```c
/// GLAPI void APIENTRY glExtractComponentEXT (GLuint res, GLuint src, GLuint num)
/// ```
void glExtractComponentEXT(int res, int src, int num) {
  final _glExtractComponentEXT = _SDL2.lookupFunction<
      Void Function(Uint32 res, Uint32 src, Uint32 num),
      void Function(int res, int src, int num)>('glExtractComponentEXT');
  return _glExtractComponentEXT(res, src, num);
}

/// ```c
/// GLAPI GLuint APIENTRY glGenSymbolsEXT (GLenum datatype, GLenum storagetype, GLenum range, GLuint components)
/// ```
int glGenSymbolsEXT(int datatype, int storagetype, int range, int components) {
  final _glGenSymbolsEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 datatype, Uint32 storagetype, Uint32 range, Uint32 components),
      int Function(int datatype, int storagetype, int range, int components)>('glGenSymbolsEXT');
  return _glGenSymbolsEXT(datatype, storagetype, range, components);
}

/// ```c
/// GLAPI void APIENTRY glSetInvariantEXT (GLuint id, GLenum type, const GLvoid *addr)
/// ```
void glSetInvariantEXT(int id, int type, Pointer<Void>? addr) {
  final _glSetInvariantEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 type, Pointer<Void>? addr),
      void Function(int id, int type, Pointer<Void>? addr)>('glSetInvariantEXT');
  return _glSetInvariantEXT(id, type, addr);
}

/// ```c
/// GLAPI void APIENTRY glSetLocalConstantEXT (GLuint id, GLenum type, const GLvoid *addr)
/// ```
void glSetLocalConstantEXT(int id, int type, Pointer<Void>? addr) {
  final _glSetLocalConstantEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 type, Pointer<Void>? addr),
      void Function(int id, int type, Pointer<Void>? addr)>('glSetLocalConstantEXT');
  return _glSetLocalConstantEXT(id, type, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantbvEXT (GLuint id, const GLbyte *addr)
/// ```
void glVariantbvEXT(int id, String addr) {
  final _glVariantbvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Utf8>? addr),
      void Function(int id, Pointer<Utf8>? addr)>('glVariantbvEXT');
  final _addrPointer = addr.toNativeUtf8();
  final _result = _glVariantbvEXT(id, _addrPointer);
  calloc.free(_addrPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVariantsvEXT (GLuint id, const GLshort *addr)
/// ```
void glVariantsvEXT(int id, Pointer<Int16>? addr) {
  final _glVariantsvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Int16>? addr),
      void Function(int id, Pointer<Int16>? addr)>('glVariantsvEXT');
  return _glVariantsvEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantivEXT (GLuint id, const GLint *addr)
/// ```
void glVariantivEXT(int id, Pointer<Int32>? addr) {
  final _glVariantivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Int32>? addr),
      void Function(int id, Pointer<Int32>? addr)>('glVariantivEXT');
  return _glVariantivEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantfvEXT (GLuint id, const GLfloat *addr)
/// ```
void glVariantfvEXT(int id, Pointer<Float>? addr) {
  final _glVariantfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Float>? addr),
      void Function(int id, Pointer<Float>? addr)>('glVariantfvEXT');
  return _glVariantfvEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantdvEXT (GLuint id, const GLdouble *addr)
/// ```
void glVariantdvEXT(int id, Pointer<Double>? addr) {
  final _glVariantdvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Double>? addr),
      void Function(int id, Pointer<Double>? addr)>('glVariantdvEXT');
  return _glVariantdvEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantubvEXT (GLuint id, const GLubyte *addr)
/// ```
void glVariantubvEXT(int id, Pointer<Uint8>? addr) {
  final _glVariantubvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Uint8>? addr),
      void Function(int id, Pointer<Uint8>? addr)>('glVariantubvEXT');
  return _glVariantubvEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantusvEXT (GLuint id, const GLushort *addr)
/// ```
void glVariantusvEXT(int id, Pointer<Uint16>? addr) {
  final _glVariantusvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Uint16>? addr),
      void Function(int id, Pointer<Uint16>? addr)>('glVariantusvEXT');
  return _glVariantusvEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantuivEXT (GLuint id, const GLuint *addr)
/// ```
void glVariantuivEXT(int id, Pointer<Uint32>? addr) {
  final _glVariantuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Pointer<Uint32>? addr),
      void Function(int id, Pointer<Uint32>? addr)>('glVariantuivEXT');
  return _glVariantuivEXT(id, addr);
}

/// ```c
/// GLAPI void APIENTRY glVariantPointerEXT (GLuint id, GLenum type, GLuint stride, const GLvoid *addr)
/// ```
void glVariantPointerEXT(int id, int type, int stride, Pointer<Void>? addr) {
  final _glVariantPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 type, Uint32 stride, Pointer<Void>? addr),
      void Function(int id, int type, int stride, Pointer<Void>? addr)>('glVariantPointerEXT');
  return _glVariantPointerEXT(id, type, stride, addr);
}

/// ```c
/// GLAPI void APIENTRY glEnableVariantClientStateEXT (GLuint id)
/// ```
void glEnableVariantClientStateEXT(int id) {
  final _glEnableVariantClientStateEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glEnableVariantClientStateEXT');
  return _glEnableVariantClientStateEXT(id);
}

/// ```c
/// GLAPI void APIENTRY glDisableVariantClientStateEXT (GLuint id)
/// ```
void glDisableVariantClientStateEXT(int id) {
  final _glDisableVariantClientStateEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glDisableVariantClientStateEXT');
  return _glDisableVariantClientStateEXT(id);
}

/// ```c
/// GLAPI GLuint APIENTRY glBindLightParameterEXT (GLenum light, GLenum value)
/// ```
int glBindLightParameterEXT(int light, int value) {
  final _glBindLightParameterEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 light, Uint32 value),
      int Function(int light, int value)>('glBindLightParameterEXT');
  return _glBindLightParameterEXT(light, value);
}

/// ```c
/// GLAPI GLuint APIENTRY glBindMaterialParameterEXT (GLenum face, GLenum value)
/// ```
int glBindMaterialParameterEXT(int face, int value) {
  final _glBindMaterialParameterEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 face, Uint32 value),
      int Function(int face, int value)>('glBindMaterialParameterEXT');
  return _glBindMaterialParameterEXT(face, value);
}

/// ```c
/// GLAPI GLuint APIENTRY glBindTexGenParameterEXT (GLenum unit, GLenum coord, GLenum value)
/// ```
int glBindTexGenParameterEXT(int unit, int coord, int value) {
  final _glBindTexGenParameterEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 unit, Uint32 coord, Uint32 value),
      int Function(int unit, int coord, int value)>('glBindTexGenParameterEXT');
  return _glBindTexGenParameterEXT(unit, coord, value);
}

/// ```c
/// GLAPI GLuint APIENTRY glBindTextureUnitParameterEXT (GLenum unit, GLenum value)
/// ```
int glBindTextureUnitParameterEXT(int unit, int value) {
  final _glBindTextureUnitParameterEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 unit, Uint32 value),
      int Function(int unit, int value)>('glBindTextureUnitParameterEXT');
  return _glBindTextureUnitParameterEXT(unit, value);
}

/// ```c
/// GLAPI GLuint APIENTRY glBindParameterEXT (GLenum value)
/// ```
int glBindParameterEXT(int value) {
  final _glBindParameterEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 value),
      int Function(int value)>('glBindParameterEXT');
  return _glBindParameterEXT(value);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsVariantEnabledEXT (GLuint id, GLenum cap)
/// ```
int glIsVariantEnabledEXT(int id, int cap) {
  final _glIsVariantEnabledEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 id, Uint32 cap),
      int Function(int id, int cap)>('glIsVariantEnabledEXT');
  return _glIsVariantEnabledEXT(id, cap);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantBooleanvEXT (GLuint id, GLenum value, GLboolean *data)
/// ```
void glGetVariantBooleanvEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetVariantBooleanvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetVariantBooleanvEXT');
  return _glGetVariantBooleanvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantIntegervEXT (GLuint id, GLenum value, GLint *data)
/// ```
void glGetVariantIntegervEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetVariantIntegervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetVariantIntegervEXT');
  return _glGetVariantIntegervEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantFloatvEXT (GLuint id, GLenum value, GLfloat *data)
/// ```
void glGetVariantFloatvEXT(int id, int value, Pointer<Float>? data) {
  final _glGetVariantFloatvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Float>? data),
      void Function(int id, int value, Pointer<Float>? data)>('glGetVariantFloatvEXT');
  return _glGetVariantFloatvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetVariantPointervEXT (GLuint id, GLenum value, GLvoid* *data)
/// ```
void glGetVariantPointervEXT(int id, int value, Pointer<Pointer<Void>>? data) {
  final _glGetVariantPointervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Pointer<Void>>? data),
      void Function(int id, int value, Pointer<Pointer<Void>>? data)>('glGetVariantPointervEXT');
  return _glGetVariantPointervEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetInvariantBooleanvEXT (GLuint id, GLenum value, GLboolean *data)
/// ```
void glGetInvariantBooleanvEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetInvariantBooleanvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetInvariantBooleanvEXT');
  return _glGetInvariantBooleanvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetInvariantIntegervEXT (GLuint id, GLenum value, GLint *data)
/// ```
void glGetInvariantIntegervEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetInvariantIntegervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetInvariantIntegervEXT');
  return _glGetInvariantIntegervEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetInvariantFloatvEXT (GLuint id, GLenum value, GLfloat *data)
/// ```
void glGetInvariantFloatvEXT(int id, int value, Pointer<Float>? data) {
  final _glGetInvariantFloatvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Float>? data),
      void Function(int id, int value, Pointer<Float>? data)>('glGetInvariantFloatvEXT');
  return _glGetInvariantFloatvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetLocalConstantBooleanvEXT (GLuint id, GLenum value, GLboolean *data)
/// ```
void glGetLocalConstantBooleanvEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetLocalConstantBooleanvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetLocalConstantBooleanvEXT');
  return _glGetLocalConstantBooleanvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetLocalConstantIntegervEXT (GLuint id, GLenum value, GLint *data)
/// ```
void glGetLocalConstantIntegervEXT(int id, int value, Pointer<Int32>? data) {
  final _glGetLocalConstantIntegervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Int32>? data),
      void Function(int id, int value, Pointer<Int32>? data)>('glGetLocalConstantIntegervEXT');
  return _glGetLocalConstantIntegervEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glGetLocalConstantFloatvEXT (GLuint id, GLenum value, GLfloat *data)
/// ```
void glGetLocalConstantFloatvEXT(int id, int value, Pointer<Float>? data) {
  final _glGetLocalConstantFloatvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 value, Pointer<Float>? data),
      void Function(int id, int value, Pointer<Float>? data)>('glGetLocalConstantFloatvEXT');
  return _glGetLocalConstantFloatvEXT(id, value, data);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1sATI (GLenum stream, GLshort x)
/// ```
void glVertexStream1sATI(int stream, int x) {
  final _glVertexStream1sATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int16 x),
      void Function(int stream, int x)>('glVertexStream1sATI');
  return _glVertexStream1sATI(stream, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1svATI (GLenum stream, const GLshort *coords)
/// ```
void glVertexStream1svATI(int stream, Pointer<Int16>? coords) {
  final _glVertexStream1svATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int16>? coords),
      void Function(int stream, Pointer<Int16>? coords)>('glVertexStream1svATI');
  return _glVertexStream1svATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1iATI (GLenum stream, GLint x)
/// ```
void glVertexStream1iATI(int stream, int x) {
  final _glVertexStream1iATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int32 x),
      void Function(int stream, int x)>('glVertexStream1iATI');
  return _glVertexStream1iATI(stream, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1ivATI (GLenum stream, const GLint *coords)
/// ```
void glVertexStream1ivATI(int stream, Pointer<Int32>? coords) {
  final _glVertexStream1ivATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int32>? coords),
      void Function(int stream, Pointer<Int32>? coords)>('glVertexStream1ivATI');
  return _glVertexStream1ivATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1fATI (GLenum stream, GLfloat x)
/// ```
void glVertexStream1fATI(int stream, double x) {
  final _glVertexStream1fATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Float x),
      void Function(int stream, double x)>('glVertexStream1fATI');
  return _glVertexStream1fATI(stream, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1fvATI (GLenum stream, const GLfloat *coords)
/// ```
void glVertexStream1fvATI(int stream, Pointer<Float>? coords) {
  final _glVertexStream1fvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Float>? coords),
      void Function(int stream, Pointer<Float>? coords)>('glVertexStream1fvATI');
  return _glVertexStream1fvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1dATI (GLenum stream, GLdouble x)
/// ```
void glVertexStream1dATI(int stream, double x) {
  final _glVertexStream1dATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Double x),
      void Function(int stream, double x)>('glVertexStream1dATI');
  return _glVertexStream1dATI(stream, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream1dvATI (GLenum stream, const GLdouble *coords)
/// ```
void glVertexStream1dvATI(int stream, Pointer<Double>? coords) {
  final _glVertexStream1dvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Double>? coords),
      void Function(int stream, Pointer<Double>? coords)>('glVertexStream1dvATI');
  return _glVertexStream1dvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2sATI (GLenum stream, GLshort x, GLshort y)
/// ```
void glVertexStream2sATI(int stream, int x, int y) {
  final _glVertexStream2sATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int16 x, Int16 y),
      void Function(int stream, int x, int y)>('glVertexStream2sATI');
  return _glVertexStream2sATI(stream, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2svATI (GLenum stream, const GLshort *coords)
/// ```
void glVertexStream2svATI(int stream, Pointer<Int16>? coords) {
  final _glVertexStream2svATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int16>? coords),
      void Function(int stream, Pointer<Int16>? coords)>('glVertexStream2svATI');
  return _glVertexStream2svATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2iATI (GLenum stream, GLint x, GLint y)
/// ```
void glVertexStream2iATI(int stream, int x, int y) {
  final _glVertexStream2iATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int32 x, Int32 y),
      void Function(int stream, int x, int y)>('glVertexStream2iATI');
  return _glVertexStream2iATI(stream, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2ivATI (GLenum stream, const GLint *coords)
/// ```
void glVertexStream2ivATI(int stream, Pointer<Int32>? coords) {
  final _glVertexStream2ivATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int32>? coords),
      void Function(int stream, Pointer<Int32>? coords)>('glVertexStream2ivATI');
  return _glVertexStream2ivATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2fATI (GLenum stream, GLfloat x, GLfloat y)
/// ```
void glVertexStream2fATI(int stream, double x, double y) {
  final _glVertexStream2fATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Float x, Float y),
      void Function(int stream, double x, double y)>('glVertexStream2fATI');
  return _glVertexStream2fATI(stream, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2fvATI (GLenum stream, const GLfloat *coords)
/// ```
void glVertexStream2fvATI(int stream, Pointer<Float>? coords) {
  final _glVertexStream2fvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Float>? coords),
      void Function(int stream, Pointer<Float>? coords)>('glVertexStream2fvATI');
  return _glVertexStream2fvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2dATI (GLenum stream, GLdouble x, GLdouble y)
/// ```
void glVertexStream2dATI(int stream, double x, double y) {
  final _glVertexStream2dATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Double x, Double y),
      void Function(int stream, double x, double y)>('glVertexStream2dATI');
  return _glVertexStream2dATI(stream, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream2dvATI (GLenum stream, const GLdouble *coords)
/// ```
void glVertexStream2dvATI(int stream, Pointer<Double>? coords) {
  final _glVertexStream2dvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Double>? coords),
      void Function(int stream, Pointer<Double>? coords)>('glVertexStream2dvATI');
  return _glVertexStream2dvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3sATI (GLenum stream, GLshort x, GLshort y, GLshort z)
/// ```
void glVertexStream3sATI(int stream, int x, int y, int z) {
  final _glVertexStream3sATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int16 x, Int16 y, Int16 z),
      void Function(int stream, int x, int y, int z)>('glVertexStream3sATI');
  return _glVertexStream3sATI(stream, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3svATI (GLenum stream, const GLshort *coords)
/// ```
void glVertexStream3svATI(int stream, Pointer<Int16>? coords) {
  final _glVertexStream3svATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int16>? coords),
      void Function(int stream, Pointer<Int16>? coords)>('glVertexStream3svATI');
  return _glVertexStream3svATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3iATI (GLenum stream, GLint x, GLint y, GLint z)
/// ```
void glVertexStream3iATI(int stream, int x, int y, int z) {
  final _glVertexStream3iATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int32 x, Int32 y, Int32 z),
      void Function(int stream, int x, int y, int z)>('glVertexStream3iATI');
  return _glVertexStream3iATI(stream, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3ivATI (GLenum stream, const GLint *coords)
/// ```
void glVertexStream3ivATI(int stream, Pointer<Int32>? coords) {
  final _glVertexStream3ivATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int32>? coords),
      void Function(int stream, Pointer<Int32>? coords)>('glVertexStream3ivATI');
  return _glVertexStream3ivATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3fATI (GLenum stream, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glVertexStream3fATI(int stream, double x, double y, double z) {
  final _glVertexStream3fATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Float x, Float y, Float z),
      void Function(int stream, double x, double y, double z)>('glVertexStream3fATI');
  return _glVertexStream3fATI(stream, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3fvATI (GLenum stream, const GLfloat *coords)
/// ```
void glVertexStream3fvATI(int stream, Pointer<Float>? coords) {
  final _glVertexStream3fvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Float>? coords),
      void Function(int stream, Pointer<Float>? coords)>('glVertexStream3fvATI');
  return _glVertexStream3fvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3dATI (GLenum stream, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexStream3dATI(int stream, double x, double y, double z) {
  final _glVertexStream3dATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Double x, Double y, Double z),
      void Function(int stream, double x, double y, double z)>('glVertexStream3dATI');
  return _glVertexStream3dATI(stream, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream3dvATI (GLenum stream, const GLdouble *coords)
/// ```
void glVertexStream3dvATI(int stream, Pointer<Double>? coords) {
  final _glVertexStream3dvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Double>? coords),
      void Function(int stream, Pointer<Double>? coords)>('glVertexStream3dvATI');
  return _glVertexStream3dvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4sATI (GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w)
/// ```
void glVertexStream4sATI(int stream, int x, int y, int z, int w) {
  final _glVertexStream4sATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int16 x, Int16 y, Int16 z, Int16 w),
      void Function(int stream, int x, int y, int z, int w)>('glVertexStream4sATI');
  return _glVertexStream4sATI(stream, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4svATI (GLenum stream, const GLshort *coords)
/// ```
void glVertexStream4svATI(int stream, Pointer<Int16>? coords) {
  final _glVertexStream4svATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int16>? coords),
      void Function(int stream, Pointer<Int16>? coords)>('glVertexStream4svATI');
  return _glVertexStream4svATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4iATI (GLenum stream, GLint x, GLint y, GLint z, GLint w)
/// ```
void glVertexStream4iATI(int stream, int x, int y, int z, int w) {
  final _glVertexStream4iATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int stream, int x, int y, int z, int w)>('glVertexStream4iATI');
  return _glVertexStream4iATI(stream, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4ivATI (GLenum stream, const GLint *coords)
/// ```
void glVertexStream4ivATI(int stream, Pointer<Int32>? coords) {
  final _glVertexStream4ivATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int32>? coords),
      void Function(int stream, Pointer<Int32>? coords)>('glVertexStream4ivATI');
  return _glVertexStream4ivATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4fATI (GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glVertexStream4fATI(int stream, double x, double y, double z, double w) {
  final _glVertexStream4fATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Float x, Float y, Float z, Float w),
      void Function(int stream, double x, double y, double z, double w)>('glVertexStream4fATI');
  return _glVertexStream4fATI(stream, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4fvATI (GLenum stream, const GLfloat *coords)
/// ```
void glVertexStream4fvATI(int stream, Pointer<Float>? coords) {
  final _glVertexStream4fvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Float>? coords),
      void Function(int stream, Pointer<Float>? coords)>('glVertexStream4fvATI');
  return _glVertexStream4fvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4dATI (GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexStream4dATI(int stream, double x, double y, double z, double w) {
  final _glVertexStream4dATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Double x, Double y, Double z, Double w),
      void Function(int stream, double x, double y, double z, double w)>('glVertexStream4dATI');
  return _glVertexStream4dATI(stream, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexStream4dvATI (GLenum stream, const GLdouble *coords)
/// ```
void glVertexStream4dvATI(int stream, Pointer<Double>? coords) {
  final _glVertexStream4dvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Double>? coords),
      void Function(int stream, Pointer<Double>? coords)>('glVertexStream4dvATI');
  return _glVertexStream4dvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3bATI (GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz)
/// ```
void glNormalStream3bATI(int stream, int nx, int ny, int nz) {
  final _glNormalStream3bATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int8 nx, Int8 ny, Int8 nz),
      void Function(int stream, int nx, int ny, int nz)>('glNormalStream3bATI');
  return _glNormalStream3bATI(stream, nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3bvATI (GLenum stream, const GLbyte *coords)
/// ```
void glNormalStream3bvATI(int stream, String coords) {
  final _glNormalStream3bvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Utf8>? coords),
      void Function(int stream, Pointer<Utf8>? coords)>('glNormalStream3bvATI');
  final _coordsPointer = coords.toNativeUtf8();
  final _result = _glNormalStream3bvATI(stream, _coordsPointer);
  calloc.free(_coordsPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3sATI (GLenum stream, GLshort nx, GLshort ny, GLshort nz)
/// ```
void glNormalStream3sATI(int stream, int nx, int ny, int nz) {
  final _glNormalStream3sATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int16 nx, Int16 ny, Int16 nz),
      void Function(int stream, int nx, int ny, int nz)>('glNormalStream3sATI');
  return _glNormalStream3sATI(stream, nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3svATI (GLenum stream, const GLshort *coords)
/// ```
void glNormalStream3svATI(int stream, Pointer<Int16>? coords) {
  final _glNormalStream3svATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int16>? coords),
      void Function(int stream, Pointer<Int16>? coords)>('glNormalStream3svATI');
  return _glNormalStream3svATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3iATI (GLenum stream, GLint nx, GLint ny, GLint nz)
/// ```
void glNormalStream3iATI(int stream, int nx, int ny, int nz) {
  final _glNormalStream3iATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Int32 nx, Int32 ny, Int32 nz),
      void Function(int stream, int nx, int ny, int nz)>('glNormalStream3iATI');
  return _glNormalStream3iATI(stream, nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3ivATI (GLenum stream, const GLint *coords)
/// ```
void glNormalStream3ivATI(int stream, Pointer<Int32>? coords) {
  final _glNormalStream3ivATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Int32>? coords),
      void Function(int stream, Pointer<Int32>? coords)>('glNormalStream3ivATI');
  return _glNormalStream3ivATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3fATI (GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz)
/// ```
void glNormalStream3fATI(int stream, double nx, double ny, double nz) {
  final _glNormalStream3fATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Float nx, Float ny, Float nz),
      void Function(int stream, double nx, double ny, double nz)>('glNormalStream3fATI');
  return _glNormalStream3fATI(stream, nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3fvATI (GLenum stream, const GLfloat *coords)
/// ```
void glNormalStream3fvATI(int stream, Pointer<Float>? coords) {
  final _glNormalStream3fvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Float>? coords),
      void Function(int stream, Pointer<Float>? coords)>('glNormalStream3fvATI');
  return _glNormalStream3fvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3dATI (GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz)
/// ```
void glNormalStream3dATI(int stream, double nx, double ny, double nz) {
  final _glNormalStream3dATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Double nx, Double ny, Double nz),
      void Function(int stream, double nx, double ny, double nz)>('glNormalStream3dATI');
  return _glNormalStream3dATI(stream, nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormalStream3dvATI (GLenum stream, const GLdouble *coords)
/// ```
void glNormalStream3dvATI(int stream, Pointer<Double>? coords) {
  final _glNormalStream3dvATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream, Pointer<Double>? coords),
      void Function(int stream, Pointer<Double>? coords)>('glNormalStream3dvATI');
  return _glNormalStream3dvATI(stream, coords);
}

/// ```c
/// GLAPI void APIENTRY glClientActiveVertexStreamATI (GLenum stream)
/// ```
void glClientActiveVertexStreamATI(int stream) {
  final _glClientActiveVertexStreamATI = _SDL2.lookupFunction<
      Void Function(Uint32 stream),
      void Function(int stream)>('glClientActiveVertexStreamATI');
  return _glClientActiveVertexStreamATI(stream);
}

/// ```c
/// GLAPI void APIENTRY glVertexBlendEnviATI (GLenum pname, GLint param)
/// ```
void glVertexBlendEnviATI(int pname, int param) {
  final _glVertexBlendEnviATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glVertexBlendEnviATI');
  return _glVertexBlendEnviATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glVertexBlendEnvfATI (GLenum pname, GLfloat param)
/// ```
void glVertexBlendEnvfATI(int pname, double param) {
  final _glVertexBlendEnvfATI = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Float param),
      void Function(int pname, double param)>('glVertexBlendEnvfATI');
  return _glVertexBlendEnvfATI(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glElementPointerATI (GLenum type, const GLvoid *pointer)
/// ```
void glElementPointerATI(int type, Pointer<Void>? pointer) {
  final _glElementPointerATI = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Void>? pointer),
      void Function(int type, Pointer<Void>? pointer)>('glElementPointerATI');
  return _glElementPointerATI(type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementArrayATI (GLenum mode, GLsizei count)
/// ```
void glDrawElementArrayATI(int mode, int count) {
  final _glDrawElementArrayATI = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count),
      void Function(int mode, int count)>('glDrawElementArrayATI');
  return _glDrawElementArrayATI(mode, count);
}

/// ```c
/// GLAPI void APIENTRY glDrawRangeElementArrayATI (GLenum mode, GLuint start, GLuint end, GLsizei count)
/// ```
void glDrawRangeElementArrayATI(int mode, int start, int end, int count) {
  final _glDrawRangeElementArrayATI = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Uint32 count),
      void Function(int mode, int start, int end, int count)>('glDrawRangeElementArrayATI');
  return _glDrawRangeElementArrayATI(mode, start, end, count);
}

/// ```c
/// GLAPI void APIENTRY glDrawMeshArraysSUN (GLenum mode, GLint first, GLsizei count, GLsizei width)
/// ```
void glDrawMeshArraysSUN(int mode, int first, int count, int width) {
  final _glDrawMeshArraysSUN = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 first, Uint32 count, Uint32 width),
      void Function(int mode, int first, int count, int width)>('glDrawMeshArraysSUN');
  return _glDrawMeshArraysSUN(mode, first, count, width);
}

/// ```c
/// GLAPI void APIENTRY glGenOcclusionQueriesNV (GLsizei n, GLuint *ids)
/// ```
void glGenOcclusionQueriesNV(int n, Pointer<Uint32>? ids) {
  final _glGenOcclusionQueriesNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glGenOcclusionQueriesNV');
  return _glGenOcclusionQueriesNV(n, ids);
}

/// ```c
/// GLAPI void APIENTRY glDeleteOcclusionQueriesNV (GLsizei n, const GLuint *ids)
/// ```
void glDeleteOcclusionQueriesNV(int n, Pointer<Uint32>? ids) {
  final _glDeleteOcclusionQueriesNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glDeleteOcclusionQueriesNV');
  return _glDeleteOcclusionQueriesNV(n, ids);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsOcclusionQueryNV (GLuint id)
/// ```
int glIsOcclusionQueryNV(int id) {
  final _glIsOcclusionQueryNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsOcclusionQueryNV');
  return _glIsOcclusionQueryNV(id);
}

/// ```c
/// GLAPI void APIENTRY glBeginOcclusionQueryNV (GLuint id)
/// ```
void glBeginOcclusionQueryNV(int id) {
  final _glBeginOcclusionQueryNV = _SDL2.lookupFunction<
      Void Function(Uint32 id),
      void Function(int id)>('glBeginOcclusionQueryNV');
  return _glBeginOcclusionQueryNV(id);
}

/// ```c
/// GLAPI void APIENTRY glEndOcclusionQueryNV (void)
/// ```
void glEndOcclusionQueryNV() {
  final _glEndOcclusionQueryNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndOcclusionQueryNV');
  return _glEndOcclusionQueryNV();
}

/// ```c
/// GLAPI void APIENTRY glGetOcclusionQueryivNV (GLuint id, GLenum pname, GLint *params)
/// ```
void glGetOcclusionQueryivNV(int id, int pname, Pointer<Int32>? params) {
  final _glGetOcclusionQueryivNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int32>? params),
      void Function(int id, int pname, Pointer<Int32>? params)>('glGetOcclusionQueryivNV');
  return _glGetOcclusionQueryivNV(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetOcclusionQueryuivNV (GLuint id, GLenum pname, GLuint *params)
/// ```
void glGetOcclusionQueryuivNV(int id, int pname, Pointer<Uint32>? params) {
  final _glGetOcclusionQueryuivNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint32>? params),
      void Function(int id, int pname, Pointer<Uint32>? params)>('glGetOcclusionQueryuivNV');
  return _glGetOcclusionQueryuivNV(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glPointParameteriNV (GLenum pname, GLint param)
/// ```
void glPointParameteriNV(int pname, int param) {
  final _glPointParameteriNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glPointParameteriNV');
  return _glPointParameteriNV(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glPointParameterivNV (GLenum pname, const GLint *params)
/// ```
void glPointParameterivNV(int pname, Pointer<Int32>? params) {
  final _glPointParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Pointer<Int32>? params),
      void Function(int pname, Pointer<Int32>? params)>('glPointParameterivNV');
  return _glPointParameterivNV(pname, params);
}

/// ```c
/// GLAPI void APIENTRY glActiveStencilFaceEXT (GLenum face)
/// ```
void glActiveStencilFaceEXT(int face) {
  final _glActiveStencilFaceEXT = _SDL2.lookupFunction<
      Void Function(Uint32 face),
      void Function(int face)>('glActiveStencilFaceEXT');
  return _glActiveStencilFaceEXT(face);
}

/// ```c
/// GLAPI void APIENTRY glElementPointerAPPLE (GLenum type, const GLvoid *pointer)
/// ```
void glElementPointerAPPLE(int type, Pointer<Void>? pointer) {
  final _glElementPointerAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 type, Pointer<Void>? pointer),
      void Function(int type, Pointer<Void>? pointer)>('glElementPointerAPPLE');
  return _glElementPointerAPPLE(type, pointer);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementArrayAPPLE (GLenum mode, GLint first, GLsizei count)
/// ```
void glDrawElementArrayAPPLE(int mode, int first, int count) {
  final _glDrawElementArrayAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 first, Uint32 count),
      void Function(int mode, int first, int count)>('glDrawElementArrayAPPLE');
  return _glDrawElementArrayAPPLE(mode, first, count);
}

/// ```c
/// GLAPI void APIENTRY glDrawRangeElementArrayAPPLE (GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count)
/// ```
void glDrawRangeElementArrayAPPLE(int mode, int start, int end, int first, int count) {
  final _glDrawRangeElementArrayAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Int32 first, Uint32 count),
      void Function(int mode, int start, int end, int first, int count)>('glDrawRangeElementArrayAPPLE');
  return _glDrawRangeElementArrayAPPLE(mode, start, end, first, count);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawElementArrayAPPLE (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
/// ```
void glMultiDrawElementArrayAPPLE(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount) {
  final _glMultiDrawElementArrayAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Int32>? first, Pointer<Uint32>? count, Uint32 primcount),
      void Function(int mode, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount)>('glMultiDrawElementArrayAPPLE');
  return _glMultiDrawElementArrayAPPLE(mode, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glMultiDrawRangeElementArrayAPPLE (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount)
/// ```
void glMultiDrawRangeElementArrayAPPLE(int mode, int start, int end, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount) {
  final _glMultiDrawRangeElementArrayAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 start, Uint32 end, Pointer<Int32>? first, Pointer<Uint32>? count, Uint32 primcount),
      void Function(int mode, int start, int end, Pointer<Int32>? first, Pointer<Uint32>? count, int primcount)>('glMultiDrawRangeElementArrayAPPLE');
  return _glMultiDrawRangeElementArrayAPPLE(mode, start, end, first, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glGenFencesAPPLE (GLsizei n, GLuint *fences)
/// ```
void glGenFencesAPPLE(int n, Pointer<Uint32>? fences) {
  final _glGenFencesAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? fences),
      void Function(int n, Pointer<Uint32>? fences)>('glGenFencesAPPLE');
  return _glGenFencesAPPLE(n, fences);
}

/// ```c
/// GLAPI void APIENTRY glDeleteFencesAPPLE (GLsizei n, const GLuint *fences)
/// ```
void glDeleteFencesAPPLE(int n, Pointer<Uint32>? fences) {
  final _glDeleteFencesAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? fences),
      void Function(int n, Pointer<Uint32>? fences)>('glDeleteFencesAPPLE');
  return _glDeleteFencesAPPLE(n, fences);
}

/// ```c
/// GLAPI void APIENTRY glSetFenceAPPLE (GLuint fence)
/// ```
void glSetFenceAPPLE(int fence) {
  final _glSetFenceAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 fence),
      void Function(int fence)>('glSetFenceAPPLE');
  return _glSetFenceAPPLE(fence);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsFenceAPPLE (GLuint fence)
/// ```
int glIsFenceAPPLE(int fence) {
  final _glIsFenceAPPLE = _SDL2.lookupFunction<
      Int32 Function(Uint32 fence),
      int Function(int fence)>('glIsFenceAPPLE');
  return _glIsFenceAPPLE(fence);
}

/// ```c
/// GLAPI GLboolean APIENTRY glTestFenceAPPLE (GLuint fence)
/// ```
int glTestFenceAPPLE(int fence) {
  final _glTestFenceAPPLE = _SDL2.lookupFunction<
      Int32 Function(Uint32 fence),
      int Function(int fence)>('glTestFenceAPPLE');
  return _glTestFenceAPPLE(fence);
}

/// ```c
/// GLAPI void APIENTRY glFinishFenceAPPLE (GLuint fence)
/// ```
void glFinishFenceAPPLE(int fence) {
  final _glFinishFenceAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 fence),
      void Function(int fence)>('glFinishFenceAPPLE');
  return _glFinishFenceAPPLE(fence);
}

/// ```c
/// GLAPI GLboolean APIENTRY glTestObjectAPPLE (GLenum object, GLuint name)
/// ```
int glTestObjectAPPLE(int object, int name) {
  final _glTestObjectAPPLE = _SDL2.lookupFunction<
      Int32 Function(Uint32 object, Uint32 name),
      int Function(int object, int name)>('glTestObjectAPPLE');
  return _glTestObjectAPPLE(object, name);
}

/// ```c
/// GLAPI void APIENTRY glFinishObjectAPPLE (GLenum object, GLint name)
/// ```
void glFinishObjectAPPLE(int object, int name) {
  final _glFinishObjectAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 object, Int32 name),
      void Function(int object, int name)>('glFinishObjectAPPLE');
  return _glFinishObjectAPPLE(object, name);
}

/// ```c
/// GLAPI void APIENTRY glBindVertexArrayAPPLE (GLuint array)
/// ```
void glBindVertexArrayAPPLE(int array) {
  final _glBindVertexArrayAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 array),
      void Function(int array)>('glBindVertexArrayAPPLE');
  return _glBindVertexArrayAPPLE(array);
}

/// ```c
/// GLAPI void APIENTRY glDeleteVertexArraysAPPLE (GLsizei n, const GLuint *arrays)
/// ```
void glDeleteVertexArraysAPPLE(int n, Pointer<Uint32>? arrays) {
  final _glDeleteVertexArraysAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? arrays),
      void Function(int n, Pointer<Uint32>? arrays)>('glDeleteVertexArraysAPPLE');
  return _glDeleteVertexArraysAPPLE(n, arrays);
}

/// ```c
/// GLAPI void APIENTRY glGenVertexArraysAPPLE (GLsizei n, GLuint *arrays)
/// ```
void glGenVertexArraysAPPLE(int n, Pointer<Uint32>? arrays) {
  final _glGenVertexArraysAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? arrays),
      void Function(int n, Pointer<Uint32>? arrays)>('glGenVertexArraysAPPLE');
  return _glGenVertexArraysAPPLE(n, arrays);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsVertexArrayAPPLE (GLuint array)
/// ```
int glIsVertexArrayAPPLE(int array) {
  final _glIsVertexArrayAPPLE = _SDL2.lookupFunction<
      Int32 Function(Uint32 array),
      int Function(int array)>('glIsVertexArrayAPPLE');
  return _glIsVertexArrayAPPLE(array);
}

/// ```c
/// GLAPI void APIENTRY glVertexArrayRangeAPPLE (GLsizei length, GLvoid *pointer)
/// ```
void glVertexArrayRangeAPPLE(int length, Pointer<Void>? pointer) {
  final _glVertexArrayRangeAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 length, Pointer<Void>? pointer),
      void Function(int length, Pointer<Void>? pointer)>('glVertexArrayRangeAPPLE');
  return _glVertexArrayRangeAPPLE(length, pointer);
}

/// ```c
/// GLAPI void APIENTRY glFlushVertexArrayRangeAPPLE (GLsizei length, GLvoid *pointer)
/// ```
void glFlushVertexArrayRangeAPPLE(int length, Pointer<Void>? pointer) {
  final _glFlushVertexArrayRangeAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 length, Pointer<Void>? pointer),
      void Function(int length, Pointer<Void>? pointer)>('glFlushVertexArrayRangeAPPLE');
  return _glFlushVertexArrayRangeAPPLE(length, pointer);
}

/// ```c
/// GLAPI void APIENTRY glVertexArrayParameteriAPPLE (GLenum pname, GLint param)
/// ```
void glVertexArrayParameteriAPPLE(int pname, int param) {
  final _glVertexArrayParameteriAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Int32 param),
      void Function(int pname, int param)>('glVertexArrayParameteriAPPLE');
  return _glVertexArrayParameteriAPPLE(pname, param);
}

/// ```c
/// GLAPI void APIENTRY glDrawBuffersATI (GLsizei n, const GLenum *bufs)
/// ```
void glDrawBuffersATI(int n, Pointer<Uint32>? bufs) {
  final _glDrawBuffersATI = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? bufs),
      void Function(int n, Pointer<Uint32>? bufs)>('glDrawBuffersATI');
  return _glDrawBuffersATI(n, bufs);
}

/// Some NV_fragment_program entry points are shared with ARB_vertex_program.
/// ```c
/// GLAPI void APIENTRY glProgramNamedParameter4fNV (GLuint id, GLsizei len, const GLubyte *name, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glProgramNamedParameter4fNV(int id, int len, Pointer<Uint8>? name, double x, double y, double z, double w) {
  final _glProgramNamedParameter4fNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Float x, Float y, Float z, Float w),
      void Function(int id, int len, Pointer<Uint8>? name, double x, double y, double z, double w)>('glProgramNamedParameter4fNV');
  return _glProgramNamedParameter4fNV(id, len, name, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramNamedParameter4dNV (GLuint id, GLsizei len, const GLubyte *name, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glProgramNamedParameter4dNV(int id, int len, Pointer<Uint8>? name, double x, double y, double z, double w) {
  final _glProgramNamedParameter4dNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Double x, Double y, Double z, Double w),
      void Function(int id, int len, Pointer<Uint8>? name, double x, double y, double z, double w)>('glProgramNamedParameter4dNV');
  return _glProgramNamedParameter4dNV(id, len, name, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramNamedParameter4fvNV (GLuint id, GLsizei len, const GLubyte *name, const GLfloat *v)
/// ```
void glProgramNamedParameter4fvNV(int id, int len, Pointer<Uint8>? name, Pointer<Float>? v) {
  final _glProgramNamedParameter4fvNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Pointer<Float>? v),
      void Function(int id, int len, Pointer<Uint8>? name, Pointer<Float>? v)>('glProgramNamedParameter4fvNV');
  return _glProgramNamedParameter4fvNV(id, len, name, v);
}

/// ```c
/// GLAPI void APIENTRY glProgramNamedParameter4dvNV (GLuint id, GLsizei len, const GLubyte *name, const GLdouble *v)
/// ```
void glProgramNamedParameter4dvNV(int id, int len, Pointer<Uint8>? name, Pointer<Double>? v) {
  final _glProgramNamedParameter4dvNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Pointer<Double>? v),
      void Function(int id, int len, Pointer<Uint8>? name, Pointer<Double>? v)>('glProgramNamedParameter4dvNV');
  return _glProgramNamedParameter4dvNV(id, len, name, v);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramNamedParameterfvNV (GLuint id, GLsizei len, const GLubyte *name, GLfloat *params)
/// ```
void glGetProgramNamedParameterfvNV(int id, int len, Pointer<Uint8>? name, Pointer<Float>? params) {
  final _glGetProgramNamedParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Pointer<Float>? params),
      void Function(int id, int len, Pointer<Uint8>? name, Pointer<Float>? params)>('glGetProgramNamedParameterfvNV');
  return _glGetProgramNamedParameterfvNV(id, len, name, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramNamedParameterdvNV (GLuint id, GLsizei len, const GLubyte *name, GLdouble *params)
/// ```
void glGetProgramNamedParameterdvNV(int id, int len, Pointer<Uint8>? name, Pointer<Double>? params) {
  final _glGetProgramNamedParameterdvNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 len, Pointer<Uint8>? name, Pointer<Double>? params),
      void Function(int id, int len, Pointer<Uint8>? name, Pointer<Double>? params)>('glGetProgramNamedParameterdvNV');
  return _glGetProgramNamedParameterdvNV(id, len, name, params);
}

/// ```c
/// GLAPI void APIENTRY glVertex2hNV (GLhalfNV x, GLhalfNV y)
/// ```
void glVertex2hNV(int x, int y) {
  final _glVertex2hNV = _SDL2.lookupFunction<
      Void Function(Uint16 x, Uint16 y),
      void Function(int x, int y)>('glVertex2hNV');
  return _glVertex2hNV(x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertex2hvNV (const GLhalfNV *v)
/// ```
void glVertex2hvNV(Pointer<Uint16>? v) {
  final _glVertex2hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glVertex2hvNV');
  return _glVertex2hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glVertex3hNV (GLhalfNV x, GLhalfNV y, GLhalfNV z)
/// ```
void glVertex3hNV(int x, int y, int z) {
  final _glVertex3hNV = _SDL2.lookupFunction<
      Void Function(Uint16 x, Uint16 y, Uint16 z),
      void Function(int x, int y, int z)>('glVertex3hNV');
  return _glVertex3hNV(x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertex3hvNV (const GLhalfNV *v)
/// ```
void glVertex3hvNV(Pointer<Uint16>? v) {
  final _glVertex3hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glVertex3hvNV');
  return _glVertex3hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glVertex4hNV (GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w)
/// ```
void glVertex4hNV(int x, int y, int z, int w) {
  final _glVertex4hNV = _SDL2.lookupFunction<
      Void Function(Uint16 x, Uint16 y, Uint16 z, Uint16 w),
      void Function(int x, int y, int z, int w)>('glVertex4hNV');
  return _glVertex4hNV(x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertex4hvNV (const GLhalfNV *v)
/// ```
void glVertex4hvNV(Pointer<Uint16>? v) {
  final _glVertex4hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glVertex4hvNV');
  return _glVertex4hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glNormal3hNV (GLhalfNV nx, GLhalfNV ny, GLhalfNV nz)
/// ```
void glNormal3hNV(int nx, int ny, int nz) {
  final _glNormal3hNV = _SDL2.lookupFunction<
      Void Function(Uint16 nx, Uint16 ny, Uint16 nz),
      void Function(int nx, int ny, int nz)>('glNormal3hNV');
  return _glNormal3hNV(nx, ny, nz);
}

/// ```c
/// GLAPI void APIENTRY glNormal3hvNV (const GLhalfNV *v)
/// ```
void glNormal3hvNV(Pointer<Uint16>? v) {
  final _glNormal3hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glNormal3hvNV');
  return _glNormal3hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glColor3hNV (GLhalfNV red, GLhalfNV green, GLhalfNV blue)
/// ```
void glColor3hNV(int red, int green, int blue) {
  final _glColor3hNV = _SDL2.lookupFunction<
      Void Function(Uint16 red, Uint16 green, Uint16 blue),
      void Function(int red, int green, int blue)>('glColor3hNV');
  return _glColor3hNV(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glColor3hvNV (const GLhalfNV *v)
/// ```
void glColor3hvNV(Pointer<Uint16>? v) {
  final _glColor3hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glColor3hvNV');
  return _glColor3hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glColor4hNV (GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha)
/// ```
void glColor4hNV(int red, int green, int blue, int alpha) {
  final _glColor4hNV = _SDL2.lookupFunction<
      Void Function(Uint16 red, Uint16 green, Uint16 blue, Uint16 alpha),
      void Function(int red, int green, int blue, int alpha)>('glColor4hNV');
  return _glColor4hNV(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glColor4hvNV (const GLhalfNV *v)
/// ```
void glColor4hvNV(Pointer<Uint16>? v) {
  final _glColor4hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glColor4hvNV');
  return _glColor4hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord1hNV (GLhalfNV s)
/// ```
void glTexCoord1hNV(int s) {
  final _glTexCoord1hNV = _SDL2.lookupFunction<
      Void Function(Uint16 s),
      void Function(int s)>('glTexCoord1hNV');
  return _glTexCoord1hNV(s);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord1hvNV (const GLhalfNV *v)
/// ```
void glTexCoord1hvNV(Pointer<Uint16>? v) {
  final _glTexCoord1hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glTexCoord1hvNV');
  return _glTexCoord1hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2hNV (GLhalfNV s, GLhalfNV t)
/// ```
void glTexCoord2hNV(int s, int t) {
  final _glTexCoord2hNV = _SDL2.lookupFunction<
      Void Function(Uint16 s, Uint16 t),
      void Function(int s, int t)>('glTexCoord2hNV');
  return _glTexCoord2hNV(s, t);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord2hvNV (const GLhalfNV *v)
/// ```
void glTexCoord2hvNV(Pointer<Uint16>? v) {
  final _glTexCoord2hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glTexCoord2hvNV');
  return _glTexCoord2hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord3hNV (GLhalfNV s, GLhalfNV t, GLhalfNV r)
/// ```
void glTexCoord3hNV(int s, int t, int r) {
  final _glTexCoord3hNV = _SDL2.lookupFunction<
      Void Function(Uint16 s, Uint16 t, Uint16 r),
      void Function(int s, int t, int r)>('glTexCoord3hNV');
  return _glTexCoord3hNV(s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord3hvNV (const GLhalfNV *v)
/// ```
void glTexCoord3hvNV(Pointer<Uint16>? v) {
  final _glTexCoord3hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glTexCoord3hvNV');
  return _glTexCoord3hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4hNV (GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q)
/// ```
void glTexCoord4hNV(int s, int t, int r, int q) {
  final _glTexCoord4hNV = _SDL2.lookupFunction<
      Void Function(Uint16 s, Uint16 t, Uint16 r, Uint16 q),
      void Function(int s, int t, int r, int q)>('glTexCoord4hNV');
  return _glTexCoord4hNV(s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glTexCoord4hvNV (const GLhalfNV *v)
/// ```
void glTexCoord4hvNV(Pointer<Uint16>? v) {
  final _glTexCoord4hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glTexCoord4hvNV');
  return _glTexCoord4hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1hNV (GLenum target, GLhalfNV s)
/// ```
void glMultiTexCoord1hNV(int target, int s) {
  final _glMultiTexCoord1hNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint16 s),
      void Function(int target, int s)>('glMultiTexCoord1hNV');
  return _glMultiTexCoord1hNV(target, s);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord1hvNV (GLenum target, const GLhalfNV *v)
/// ```
void glMultiTexCoord1hvNV(int target, Pointer<Uint16>? v) {
  final _glMultiTexCoord1hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Uint16>? v),
      void Function(int target, Pointer<Uint16>? v)>('glMultiTexCoord1hvNV');
  return _glMultiTexCoord1hvNV(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2hNV (GLenum target, GLhalfNV s, GLhalfNV t)
/// ```
void glMultiTexCoord2hNV(int target, int s, int t) {
  final _glMultiTexCoord2hNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint16 s, Uint16 t),
      void Function(int target, int s, int t)>('glMultiTexCoord2hNV');
  return _glMultiTexCoord2hNV(target, s, t);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord2hvNV (GLenum target, const GLhalfNV *v)
/// ```
void glMultiTexCoord2hvNV(int target, Pointer<Uint16>? v) {
  final _glMultiTexCoord2hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Uint16>? v),
      void Function(int target, Pointer<Uint16>? v)>('glMultiTexCoord2hvNV');
  return _glMultiTexCoord2hvNV(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3hNV (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r)
/// ```
void glMultiTexCoord3hNV(int target, int s, int t, int r) {
  final _glMultiTexCoord3hNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint16 s, Uint16 t, Uint16 r),
      void Function(int target, int s, int t, int r)>('glMultiTexCoord3hNV');
  return _glMultiTexCoord3hNV(target, s, t, r);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord3hvNV (GLenum target, const GLhalfNV *v)
/// ```
void glMultiTexCoord3hvNV(int target, Pointer<Uint16>? v) {
  final _glMultiTexCoord3hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Uint16>? v),
      void Function(int target, Pointer<Uint16>? v)>('glMultiTexCoord3hvNV');
  return _glMultiTexCoord3hvNV(target, v);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4hNV (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q)
/// ```
void glMultiTexCoord4hNV(int target, int s, int t, int r, int q) {
  final _glMultiTexCoord4hNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint16 s, Uint16 t, Uint16 r, Uint16 q),
      void Function(int target, int s, int t, int r, int q)>('glMultiTexCoord4hNV');
  return _glMultiTexCoord4hNV(target, s, t, r, q);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoord4hvNV (GLenum target, const GLhalfNV *v)
/// ```
void glMultiTexCoord4hvNV(int target, Pointer<Uint16>? v) {
  final _glMultiTexCoord4hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Uint16>? v),
      void Function(int target, Pointer<Uint16>? v)>('glMultiTexCoord4hvNV');
  return _glMultiTexCoord4hvNV(target, v);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordhNV (GLhalfNV fog)
/// ```
void glFogCoordhNV(int fog) {
  final _glFogCoordhNV = _SDL2.lookupFunction<
      Void Function(Uint16 fog),
      void Function(int fog)>('glFogCoordhNV');
  return _glFogCoordhNV(fog);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordhvNV (const GLhalfNV *fog)
/// ```
void glFogCoordhvNV(Pointer<Uint16>? fog) {
  final _glFogCoordhvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? fog),
      void Function(Pointer<Uint16>? fog)>('glFogCoordhvNV');
  return _glFogCoordhvNV(fog);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3hNV (GLhalfNV red, GLhalfNV green, GLhalfNV blue)
/// ```
void glSecondaryColor3hNV(int red, int green, int blue) {
  final _glSecondaryColor3hNV = _SDL2.lookupFunction<
      Void Function(Uint16 red, Uint16 green, Uint16 blue),
      void Function(int red, int green, int blue)>('glSecondaryColor3hNV');
  return _glSecondaryColor3hNV(red, green, blue);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColor3hvNV (const GLhalfNV *v)
/// ```
void glSecondaryColor3hvNV(Pointer<Uint16>? v) {
  final _glSecondaryColor3hvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? v),
      void Function(Pointer<Uint16>? v)>('glSecondaryColor3hvNV');
  return _glSecondaryColor3hvNV(v);
}

/// ```c
/// GLAPI void APIENTRY glVertexWeighthNV (GLhalfNV weight)
/// ```
void glVertexWeighthNV(int weight) {
  final _glVertexWeighthNV = _SDL2.lookupFunction<
      Void Function(Uint16 weight),
      void Function(int weight)>('glVertexWeighthNV');
  return _glVertexWeighthNV(weight);
}

/// ```c
/// GLAPI void APIENTRY glVertexWeighthvNV (const GLhalfNV *weight)
/// ```
void glVertexWeighthvNV(Pointer<Uint16>? weight) {
  final _glVertexWeighthvNV = _SDL2.lookupFunction<
      Void Function(Pointer<Uint16>? weight),
      void Function(Pointer<Uint16>? weight)>('glVertexWeighthvNV');
  return _glVertexWeighthvNV(weight);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1hNV (GLuint index, GLhalfNV x)
/// ```
void glVertexAttrib1hNV(int index, int x) {
  final _glVertexAttrib1hNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint16 x),
      void Function(int index, int x)>('glVertexAttrib1hNV');
  return _glVertexAttrib1hNV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib1hvNV (GLuint index, const GLhalfNV *v)
/// ```
void glVertexAttrib1hvNV(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib1hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib1hvNV');
  return _glVertexAttrib1hvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2hNV (GLuint index, GLhalfNV x, GLhalfNV y)
/// ```
void glVertexAttrib2hNV(int index, int x, int y) {
  final _glVertexAttrib2hNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint16 x, Uint16 y),
      void Function(int index, int x, int y)>('glVertexAttrib2hNV');
  return _glVertexAttrib2hNV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib2hvNV (GLuint index, const GLhalfNV *v)
/// ```
void glVertexAttrib2hvNV(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib2hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib2hvNV');
  return _glVertexAttrib2hvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3hNV (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z)
/// ```
void glVertexAttrib3hNV(int index, int x, int y, int z) {
  final _glVertexAttrib3hNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint16 x, Uint16 y, Uint16 z),
      void Function(int index, int x, int y, int z)>('glVertexAttrib3hNV');
  return _glVertexAttrib3hNV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib3hvNV (GLuint index, const GLhalfNV *v)
/// ```
void glVertexAttrib3hvNV(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib3hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib3hvNV');
  return _glVertexAttrib3hvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4hNV (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w)
/// ```
void glVertexAttrib4hNV(int index, int x, int y, int z, int w) {
  final _glVertexAttrib4hNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint16 x, Uint16 y, Uint16 z, Uint16 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttrib4hNV');
  return _glVertexAttrib4hNV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttrib4hvNV (GLuint index, const GLhalfNV *v)
/// ```
void glVertexAttrib4hvNV(int index, Pointer<Uint16>? v) {
  final _glVertexAttrib4hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttrib4hvNV');
  return _glVertexAttrib4hvNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs1hvNV (GLuint index, GLsizei n, const GLhalfNV *v)
/// ```
void glVertexAttribs1hvNV(int index, int n, Pointer<Uint16>? v) {
  final _glVertexAttribs1hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 n, Pointer<Uint16>? v),
      void Function(int index, int n, Pointer<Uint16>? v)>('glVertexAttribs1hvNV');
  return _glVertexAttribs1hvNV(index, n, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs2hvNV (GLuint index, GLsizei n, const GLhalfNV *v)
/// ```
void glVertexAttribs2hvNV(int index, int n, Pointer<Uint16>? v) {
  final _glVertexAttribs2hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 n, Pointer<Uint16>? v),
      void Function(int index, int n, Pointer<Uint16>? v)>('glVertexAttribs2hvNV');
  return _glVertexAttribs2hvNV(index, n, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs3hvNV (GLuint index, GLsizei n, const GLhalfNV *v)
/// ```
void glVertexAttribs3hvNV(int index, int n, Pointer<Uint16>? v) {
  final _glVertexAttribs3hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 n, Pointer<Uint16>? v),
      void Function(int index, int n, Pointer<Uint16>? v)>('glVertexAttribs3hvNV');
  return _glVertexAttribs3hvNV(index, n, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribs4hvNV (GLuint index, GLsizei n, const GLhalfNV *v)
/// ```
void glVertexAttribs4hvNV(int index, int n, Pointer<Uint16>? v) {
  final _glVertexAttribs4hvNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 n, Pointer<Uint16>? v),
      void Function(int index, int n, Pointer<Uint16>? v)>('glVertexAttribs4hvNV');
  return _glVertexAttribs4hvNV(index, n, v);
}

/// ```c
/// GLAPI void APIENTRY glPixelDataRangeNV (GLenum target, GLsizei length, GLvoid *pointer)
/// ```
void glPixelDataRangeNV(int target, int length, Pointer<Void>? pointer) {
  final _glPixelDataRangeNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 length, Pointer<Void>? pointer),
      void Function(int target, int length, Pointer<Void>? pointer)>('glPixelDataRangeNV');
  return _glPixelDataRangeNV(target, length, pointer);
}

/// ```c
/// GLAPI void APIENTRY glFlushPixelDataRangeNV (GLenum target)
/// ```
void glFlushPixelDataRangeNV(int target) {
  final _glFlushPixelDataRangeNV = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glFlushPixelDataRangeNV');
  return _glFlushPixelDataRangeNV(target);
}

/// ```c
/// GLAPI void APIENTRY glPrimitiveRestartNV (void)
/// ```
void glPrimitiveRestartNV() {
  final _glPrimitiveRestartNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glPrimitiveRestartNV');
  return _glPrimitiveRestartNV();
}

/// ```c
/// GLAPI void APIENTRY glPrimitiveRestartIndexNV (GLuint index)
/// ```
void glPrimitiveRestartIndexNV(int index) {
  final _glPrimitiveRestartIndexNV = _SDL2.lookupFunction<
      Void Function(Uint32 index),
      void Function(int index)>('glPrimitiveRestartIndexNV');
  return _glPrimitiveRestartIndexNV(index);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapObjectBufferATI (GLuint buffer)
/// ```
Pointer<Void>? glMapObjectBufferATI(int buffer) {
  final _glMapObjectBufferATI = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 buffer),
      Pointer<Void>? Function(int buffer)>('glMapObjectBufferATI');
  return _glMapObjectBufferATI(buffer);
}

/// ```c
/// GLAPI void APIENTRY glUnmapObjectBufferATI (GLuint buffer)
/// ```
void glUnmapObjectBufferATI(int buffer) {
  final _glUnmapObjectBufferATI = _SDL2.lookupFunction<
      Void Function(Uint32 buffer),
      void Function(int buffer)>('glUnmapObjectBufferATI');
  return _glUnmapObjectBufferATI(buffer);
}

/// ```c
/// GLAPI void APIENTRY glStencilOpSeparateATI (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass)
/// ```
void glStencilOpSeparateATI(int face, int sfail, int dpfail, int dppass) {
  final _glStencilOpSeparateATI = _SDL2.lookupFunction<
      Void Function(Uint32 face, Uint32 sfail, Uint32 dpfail, Uint32 dppass),
      void Function(int face, int sfail, int dpfail, int dppass)>('glStencilOpSeparateATI');
  return _glStencilOpSeparateATI(face, sfail, dpfail, dppass);
}

/// ```c
/// GLAPI void APIENTRY glStencilFuncSeparateATI (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask)
/// ```
void glStencilFuncSeparateATI(int frontfunc, int backfunc, int ref, int mask) {
  final _glStencilFuncSeparateATI = _SDL2.lookupFunction<
      Void Function(Uint32 frontfunc, Uint32 backfunc, Int32 ref, Uint32 mask),
      void Function(int frontfunc, int backfunc, int ref, int mask)>('glStencilFuncSeparateATI');
  return _glStencilFuncSeparateATI(frontfunc, backfunc, ref, mask);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribArrayObjectATI (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset)
/// ```
void glVertexAttribArrayObjectATI(int index, int size, int type, int normalized, int stride, int buffer, int offset) {
  final _glVertexAttribArrayObjectATI = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Int32 normalized, Uint32 stride, Uint32 buffer, Uint32 offset),
      void Function(int index, int size, int type, int normalized, int stride, int buffer, int offset)>('glVertexAttribArrayObjectATI');
  return _glVertexAttribArrayObjectATI(index, size, type, normalized, stride, buffer, offset);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribArrayObjectfvATI (GLuint index, GLenum pname, GLfloat *params)
/// ```
void glGetVertexAttribArrayObjectfvATI(int index, int pname, Pointer<Float>? params) {
  final _glGetVertexAttribArrayObjectfvATI = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Float>? params),
      void Function(int index, int pname, Pointer<Float>? params)>('glGetVertexAttribArrayObjectfvATI');
  return _glGetVertexAttribArrayObjectfvATI(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribArrayObjectivATI (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribArrayObjectivATI(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribArrayObjectivATI = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribArrayObjectivATI');
  return _glGetVertexAttribArrayObjectivATI(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glDepthBoundsEXT (GLclampd zmin, GLclampd zmax)
/// ```
void glDepthBoundsEXT(double zmin, double zmax) {
  final _glDepthBoundsEXT = _SDL2.lookupFunction<
      Void Function(Double zmin, Double zmax),
      void Function(double zmin, double zmax)>('glDepthBoundsEXT');
  return _glDepthBoundsEXT(zmin, zmax);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationSeparateEXT (GLenum modeRGB, GLenum modeAlpha)
/// ```
void glBlendEquationSeparateEXT(int modeRGB, int modeAlpha) {
  final _glBlendEquationSeparateEXT = _SDL2.lookupFunction<
      Void Function(Uint32 modeRGB, Uint32 modeAlpha),
      void Function(int modeRGB, int modeAlpha)>('glBlendEquationSeparateEXT');
  return _glBlendEquationSeparateEXT(modeRGB, modeAlpha);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsRenderbufferEXT (GLuint renderbuffer)
/// ```
int glIsRenderbufferEXT(int renderbuffer) {
  final _glIsRenderbufferEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 renderbuffer),
      int Function(int renderbuffer)>('glIsRenderbufferEXT');
  return _glIsRenderbufferEXT(renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glBindRenderbufferEXT (GLenum target, GLuint renderbuffer)
/// ```
void glBindRenderbufferEXT(int target, int renderbuffer) {
  final _glBindRenderbufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 renderbuffer),
      void Function(int target, int renderbuffer)>('glBindRenderbufferEXT');
  return _glBindRenderbufferEXT(target, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteRenderbuffersEXT (GLsizei n, const GLuint *renderbuffers)
/// ```
void glDeleteRenderbuffersEXT(int n, Pointer<Uint32>? renderbuffers) {
  final _glDeleteRenderbuffersEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? renderbuffers),
      void Function(int n, Pointer<Uint32>? renderbuffers)>('glDeleteRenderbuffersEXT');
  return _glDeleteRenderbuffersEXT(n, renderbuffers);
}

/// ```c
/// GLAPI void APIENTRY glGenRenderbuffersEXT (GLsizei n, GLuint *renderbuffers)
/// ```
void glGenRenderbuffersEXT(int n, Pointer<Uint32>? renderbuffers) {
  final _glGenRenderbuffersEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? renderbuffers),
      void Function(int n, Pointer<Uint32>? renderbuffers)>('glGenRenderbuffersEXT');
  return _glGenRenderbuffersEXT(n, renderbuffers);
}

/// ```c
/// GLAPI void APIENTRY glRenderbufferStorageEXT (GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glRenderbufferStorageEXT(int target, int internalformat, int width, int height) {
  final _glRenderbufferStorageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int target, int internalformat, int width, int height)>('glRenderbufferStorageEXT');
  return _glRenderbufferStorageEXT(target, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetRenderbufferParameterivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetRenderbufferParameterivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetRenderbufferParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetRenderbufferParameterivEXT');
  return _glGetRenderbufferParameterivEXT(target, pname, params);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsFramebufferEXT (GLuint framebuffer)
/// ```
int glIsFramebufferEXT(int framebuffer) {
  final _glIsFramebufferEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 framebuffer),
      int Function(int framebuffer)>('glIsFramebufferEXT');
  return _glIsFramebufferEXT(framebuffer);
}

/// ```c
/// GLAPI void APIENTRY glBindFramebufferEXT (GLenum target, GLuint framebuffer)
/// ```
void glBindFramebufferEXT(int target, int framebuffer) {
  final _glBindFramebufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 framebuffer),
      void Function(int target, int framebuffer)>('glBindFramebufferEXT');
  return _glBindFramebufferEXT(target, framebuffer);
}

/// ```c
/// GLAPI void APIENTRY glDeleteFramebuffersEXT (GLsizei n, const GLuint *framebuffers)
/// ```
void glDeleteFramebuffersEXT(int n, Pointer<Uint32>? framebuffers) {
  final _glDeleteFramebuffersEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? framebuffers),
      void Function(int n, Pointer<Uint32>? framebuffers)>('glDeleteFramebuffersEXT');
  return _glDeleteFramebuffersEXT(n, framebuffers);
}

/// ```c
/// GLAPI void APIENTRY glGenFramebuffersEXT (GLsizei n, GLuint *framebuffers)
/// ```
void glGenFramebuffersEXT(int n, Pointer<Uint32>? framebuffers) {
  final _glGenFramebuffersEXT = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? framebuffers),
      void Function(int n, Pointer<Uint32>? framebuffers)>('glGenFramebuffersEXT');
  return _glGenFramebuffersEXT(n, framebuffers);
}

/// ```c
/// GLAPI GLenum APIENTRY glCheckFramebufferStatusEXT (GLenum target)
/// ```
int glCheckFramebufferStatusEXT(int target) {
  final _glCheckFramebufferStatusEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 target),
      int Function(int target)>('glCheckFramebufferStatusEXT');
  return _glCheckFramebufferStatusEXT(target);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture1DEXT (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glFramebufferTexture1DEXT(int target, int attachment, int textarget, int texture, int level) {
  final _glFramebufferTexture1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int textarget, int texture, int level)>('glFramebufferTexture1DEXT');
  return _glFramebufferTexture1DEXT(target, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture2DEXT (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glFramebufferTexture2DEXT(int target, int attachment, int textarget, int texture, int level) {
  final _glFramebufferTexture2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int textarget, int texture, int level)>('glFramebufferTexture2DEXT');
  return _glFramebufferTexture2DEXT(target, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTexture3DEXT (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
/// ```
void glFramebufferTexture3DEXT(int target, int attachment, int textarget, int texture, int level, int zoffset) {
  final _glFramebufferTexture3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level, Int32 zoffset),
      void Function(int target, int attachment, int textarget, int texture, int level, int zoffset)>('glFramebufferTexture3DEXT');
  return _glFramebufferTexture3DEXT(target, attachment, textarget, texture, level, zoffset);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferRenderbufferEXT (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
/// ```
void glFramebufferRenderbufferEXT(int target, int attachment, int renderbuffertarget, int renderbuffer) {
  final _glFramebufferRenderbufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 renderbuffertarget, Uint32 renderbuffer),
      void Function(int target, int attachment, int renderbuffertarget, int renderbuffer)>('glFramebufferRenderbufferEXT');
  return _glFramebufferRenderbufferEXT(target, attachment, renderbuffertarget, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glGetFramebufferAttachmentParameterivEXT (GLenum target, GLenum attachment, GLenum pname, GLint *params)
/// ```
void glGetFramebufferAttachmentParameterivEXT(int target, int attachment, int pname, Pointer<Int32>? params) {
  final _glGetFramebufferAttachmentParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int attachment, int pname, Pointer<Int32>? params)>('glGetFramebufferAttachmentParameterivEXT');
  return _glGetFramebufferAttachmentParameterivEXT(target, attachment, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGenerateMipmapEXT (GLenum target)
/// ```
void glGenerateMipmapEXT(int target) {
  final _glGenerateMipmapEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glGenerateMipmapEXT');
  return _glGenerateMipmapEXT(target);
}

/// ```c
/// GLAPI void APIENTRY glStringMarkerGREMEDY (GLsizei len, const GLvoid *string)
/// ```
void glStringMarkerGREMEDY(int len, Pointer<Void>? string) {
  final _glStringMarkerGREMEDY = _SDL2.lookupFunction<
      Void Function(Uint32 len, Pointer<Void>? string),
      void Function(int len, Pointer<Void>? string)>('glStringMarkerGREMEDY');
  return _glStringMarkerGREMEDY(len, string);
}

/// ```c
/// GLAPI void APIENTRY glStencilClearTagEXT (GLsizei stencilTagBits, GLuint stencilClearTag)
/// ```
void glStencilClearTagEXT(int stencilTagBits, int stencilClearTag) {
  final _glStencilClearTagEXT = _SDL2.lookupFunction<
      Void Function(Uint32 stencilTagBits, Uint32 stencilClearTag),
      void Function(int stencilTagBits, int stencilClearTag)>('glStencilClearTagEXT');
  return _glStencilClearTagEXT(stencilTagBits, stencilClearTag);
}

/// ```c
/// GLAPI void APIENTRY glBlitFramebufferEXT (GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
/// ```
void glBlitFramebufferEXT(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter) {
  final _glBlitFramebufferEXT = _SDL2.lookupFunction<
      Void Function(Int32 srcX0, Int32 srcY0, Int32 srcX1, Int32 srcY1, Int32 dstX0, Int32 dstY0, Int32 dstX1, Int32 dstY1, Uint32 mask, Uint32 filter),
      void Function(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)>('glBlitFramebufferEXT');
  return _glBlitFramebufferEXT(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

/// ```c
/// GLAPI void APIENTRY glRenderbufferStorageMultisampleEXT (GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glRenderbufferStorageMultisampleEXT(int target, int samples, int internalformat, int width, int height) {
  final _glRenderbufferStorageMultisampleEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 samples, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int target, int samples, int internalformat, int width, int height)>('glRenderbufferStorageMultisampleEXT');
  return _glRenderbufferStorageMultisampleEXT(target, samples, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjecti64vEXT (GLuint id, GLenum pname, GLint64EXT *params)
/// ```
void glGetQueryObjecti64vEXT(int id, int pname, Pointer<Int64>? params) {
  final _glGetQueryObjecti64vEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Int64>? params),
      void Function(int id, int pname, Pointer<Int64>? params)>('glGetQueryObjecti64vEXT');
  return _glGetQueryObjecti64vEXT(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetQueryObjectui64vEXT (GLuint id, GLenum pname, GLuint64EXT *params)
/// ```
void glGetQueryObjectui64vEXT(int id, int pname, Pointer<Uint64>? params) {
  final _glGetQueryObjectui64vEXT = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 pname, Pointer<Uint64>? params),
      void Function(int id, int pname, Pointer<Uint64>? params)>('glGetQueryObjectui64vEXT');
  return _glGetQueryObjectui64vEXT(id, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameters4fvEXT (GLenum target, GLuint index, GLsizei count, const GLfloat *params)
/// ```
void glProgramEnvParameters4fvEXT(int target, int index, int count, Pointer<Float>? params) {
  final _glProgramEnvParameters4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Float>? params),
      void Function(int target, int index, int count, Pointer<Float>? params)>('glProgramEnvParameters4fvEXT');
  return _glProgramEnvParameters4fvEXT(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameters4fvEXT (GLenum target, GLuint index, GLsizei count, const GLfloat *params)
/// ```
void glProgramLocalParameters4fvEXT(int target, int index, int count, Pointer<Float>? params) {
  final _glProgramLocalParameters4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Float>? params),
      void Function(int target, int index, int count, Pointer<Float>? params)>('glProgramLocalParameters4fvEXT');
  return _glProgramLocalParameters4fvEXT(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glBufferParameteriAPPLE (GLenum target, GLenum pname, GLint param)
/// ```
void glBufferParameteriAPPLE(int target, int pname, int param) {
  final _glBufferParameteriAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Int32 param),
      void Function(int target, int pname, int param)>('glBufferParameteriAPPLE');
  return _glBufferParameteriAPPLE(target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glFlushMappedBufferRangeAPPLE (GLenum target, GLintptr offset, GLsizeiptr size)
/// ```
void glFlushMappedBufferRangeAPPLE(int target, Pointer<Void>? offset, Pointer<Void>? size) {
  final _glFlushMappedBufferRangeAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 target, Pointer<Void>? offset, Pointer<Void>? size),
      void Function(int target, Pointer<Void>? offset, Pointer<Void>? size)>('glFlushMappedBufferRangeAPPLE');
  return _glFlushMappedBufferRangeAPPLE(target, offset, size);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameterI4iNV (GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
/// ```
void glProgramLocalParameterI4iNV(int target, int index, int x, int y, int z, int w) {
  final _glProgramLocalParameterI4iNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int target, int index, int x, int y, int z, int w)>('glProgramLocalParameterI4iNV');
  return _glProgramLocalParameterI4iNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameterI4ivNV (GLenum target, GLuint index, const GLint *params)
/// ```
void glProgramLocalParameterI4ivNV(int target, int index, Pointer<Int32>? params) {
  final _glProgramLocalParameterI4ivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int target, int index, Pointer<Int32>? params)>('glProgramLocalParameterI4ivNV');
  return _glProgramLocalParameterI4ivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParametersI4ivNV (GLenum target, GLuint index, GLsizei count, const GLint *params)
/// ```
void glProgramLocalParametersI4ivNV(int target, int index, int count, Pointer<Int32>? params) {
  final _glProgramLocalParametersI4ivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Int32>? params),
      void Function(int target, int index, int count, Pointer<Int32>? params)>('glProgramLocalParametersI4ivNV');
  return _glProgramLocalParametersI4ivNV(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameterI4uiNV (GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
/// ```
void glProgramLocalParameterI4uiNV(int target, int index, int x, int y, int z, int w) {
  final _glProgramLocalParameterI4uiNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 x, Uint32 y, Uint32 z, Uint32 w),
      void Function(int target, int index, int x, int y, int z, int w)>('glProgramLocalParameterI4uiNV');
  return _glProgramLocalParameterI4uiNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParameterI4uivNV (GLenum target, GLuint index, const GLuint *params)
/// ```
void glProgramLocalParameterI4uivNV(int target, int index, Pointer<Uint32>? params) {
  final _glProgramLocalParameterI4uivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int target, int index, Pointer<Uint32>? params)>('glProgramLocalParameterI4uivNV');
  return _glProgramLocalParameterI4uivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramLocalParametersI4uivNV (GLenum target, GLuint index, GLsizei count, const GLuint *params)
/// ```
void glProgramLocalParametersI4uivNV(int target, int index, int count, Pointer<Uint32>? params) {
  final _glProgramLocalParametersI4uivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Uint32>? params),
      void Function(int target, int index, int count, Pointer<Uint32>? params)>('glProgramLocalParametersI4uivNV');
  return _glProgramLocalParametersI4uivNV(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameterI4iNV (GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
/// ```
void glProgramEnvParameterI4iNV(int target, int index, int x, int y, int z, int w) {
  final _glProgramEnvParameterI4iNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int target, int index, int x, int y, int z, int w)>('glProgramEnvParameterI4iNV');
  return _glProgramEnvParameterI4iNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameterI4ivNV (GLenum target, GLuint index, const GLint *params)
/// ```
void glProgramEnvParameterI4ivNV(int target, int index, Pointer<Int32>? params) {
  final _glProgramEnvParameterI4ivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int target, int index, Pointer<Int32>? params)>('glProgramEnvParameterI4ivNV');
  return _glProgramEnvParameterI4ivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParametersI4ivNV (GLenum target, GLuint index, GLsizei count, const GLint *params)
/// ```
void glProgramEnvParametersI4ivNV(int target, int index, int count, Pointer<Int32>? params) {
  final _glProgramEnvParametersI4ivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Int32>? params),
      void Function(int target, int index, int count, Pointer<Int32>? params)>('glProgramEnvParametersI4ivNV');
  return _glProgramEnvParametersI4ivNV(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameterI4uiNV (GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
/// ```
void glProgramEnvParameterI4uiNV(int target, int index, int x, int y, int z, int w) {
  final _glProgramEnvParameterI4uiNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 x, Uint32 y, Uint32 z, Uint32 w),
      void Function(int target, int index, int x, int y, int z, int w)>('glProgramEnvParameterI4uiNV');
  return _glProgramEnvParameterI4uiNV(target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParameterI4uivNV (GLenum target, GLuint index, const GLuint *params)
/// ```
void glProgramEnvParameterI4uivNV(int target, int index, Pointer<Uint32>? params) {
  final _glProgramEnvParameterI4uivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int target, int index, Pointer<Uint32>? params)>('glProgramEnvParameterI4uivNV');
  return _glProgramEnvParameterI4uivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramEnvParametersI4uivNV (GLenum target, GLuint index, GLsizei count, const GLuint *params)
/// ```
void glProgramEnvParametersI4uivNV(int target, int index, int count, Pointer<Uint32>? params) {
  final _glProgramEnvParametersI4uivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 count, Pointer<Uint32>? params),
      void Function(int target, int index, int count, Pointer<Uint32>? params)>('glProgramEnvParametersI4uivNV');
  return _glProgramEnvParametersI4uivNV(target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramLocalParameterIivNV (GLenum target, GLuint index, GLint *params)
/// ```
void glGetProgramLocalParameterIivNV(int target, int index, Pointer<Int32>? params) {
  final _glGetProgramLocalParameterIivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int target, int index, Pointer<Int32>? params)>('glGetProgramLocalParameterIivNV');
  return _glGetProgramLocalParameterIivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramLocalParameterIuivNV (GLenum target, GLuint index, GLuint *params)
/// ```
void glGetProgramLocalParameterIuivNV(int target, int index, Pointer<Uint32>? params) {
  final _glGetProgramLocalParameterIuivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int target, int index, Pointer<Uint32>? params)>('glGetProgramLocalParameterIuivNV');
  return _glGetProgramLocalParameterIuivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramEnvParameterIivNV (GLenum target, GLuint index, GLint *params)
/// ```
void glGetProgramEnvParameterIivNV(int target, int index, Pointer<Int32>? params) {
  final _glGetProgramEnvParameterIivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int target, int index, Pointer<Int32>? params)>('glGetProgramEnvParameterIivNV');
  return _glGetProgramEnvParameterIivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramEnvParameterIuivNV (GLenum target, GLuint index, GLuint *params)
/// ```
void glGetProgramEnvParameterIuivNV(int target, int index, Pointer<Uint32>? params) {
  final _glGetProgramEnvParameterIuivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int target, int index, Pointer<Uint32>? params)>('glGetProgramEnvParameterIuivNV');
  return _glGetProgramEnvParameterIuivNV(target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramVertexLimitNV (GLenum target, GLint limit)
/// ```
void glProgramVertexLimitNV(int target, int limit) {
  final _glProgramVertexLimitNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Int32 limit),
      void Function(int target, int limit)>('glProgramVertexLimitNV');
  return _glProgramVertexLimitNV(target, limit);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureEXT (GLenum target, GLenum attachment, GLuint texture, GLint level)
/// ```
void glFramebufferTextureEXT(int target, int attachment, int texture, int level) {
  final _glFramebufferTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level),
      void Function(int target, int attachment, int texture, int level)>('glFramebufferTextureEXT');
  return _glFramebufferTextureEXT(target, attachment, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureLayerEXT (GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
/// ```
void glFramebufferTextureLayerEXT(int target, int attachment, int texture, int level, int layer) {
  final _glFramebufferTextureLayerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level, Int32 layer),
      void Function(int target, int attachment, int texture, int level, int layer)>('glFramebufferTextureLayerEXT');
  return _glFramebufferTextureLayerEXT(target, attachment, texture, level, layer);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferTextureFaceEXT (GLenum target, GLenum attachment, GLuint texture, GLint level, GLenum face)
/// ```
void glFramebufferTextureFaceEXT(int target, int attachment, int texture, int level, int face) {
  final _glFramebufferTextureFaceEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 attachment, Uint32 texture, Int32 level, Uint32 face),
      void Function(int target, int attachment, int texture, int level, int face)>('glFramebufferTextureFaceEXT');
  return _glFramebufferTextureFaceEXT(target, attachment, texture, level, face);
}

/// ```c
/// GLAPI void APIENTRY glProgramParameteriEXT (GLuint program, GLenum pname, GLint value)
/// ```
void glProgramParameteriEXT(int program, int pname, int value) {
  final _glProgramParameteriEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 pname, Int32 value),
      void Function(int program, int pname, int value)>('glProgramParameteriEXT');
  return _glProgramParameteriEXT(program, pname, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1iEXT (GLuint index, GLint x)
/// ```
void glVertexAttribI1iEXT(int index, int x) {
  final _glVertexAttribI1iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x),
      void Function(int index, int x)>('glVertexAttribI1iEXT');
  return _glVertexAttribI1iEXT(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2iEXT (GLuint index, GLint x, GLint y)
/// ```
void glVertexAttribI2iEXT(int index, int x, int y) {
  final _glVertexAttribI2iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y),
      void Function(int index, int x, int y)>('glVertexAttribI2iEXT');
  return _glVertexAttribI2iEXT(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3iEXT (GLuint index, GLint x, GLint y, GLint z)
/// ```
void glVertexAttribI3iEXT(int index, int x, int y, int z) {
  final _glVertexAttribI3iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y, Int32 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribI3iEXT');
  return _glVertexAttribI3iEXT(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4iEXT (GLuint index, GLint x, GLint y, GLint z, GLint w)
/// ```
void glVertexAttribI4iEXT(int index, int x, int y, int z, int w) {
  final _glVertexAttribI4iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribI4iEXT');
  return _glVertexAttribI4iEXT(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1uiEXT (GLuint index, GLuint x)
/// ```
void glVertexAttribI1uiEXT(int index, int x) {
  final _glVertexAttribI1uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x),
      void Function(int index, int x)>('glVertexAttribI1uiEXT');
  return _glVertexAttribI1uiEXT(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2uiEXT (GLuint index, GLuint x, GLuint y)
/// ```
void glVertexAttribI2uiEXT(int index, int x, int y) {
  final _glVertexAttribI2uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y),
      void Function(int index, int x, int y)>('glVertexAttribI2uiEXT');
  return _glVertexAttribI2uiEXT(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3uiEXT (GLuint index, GLuint x, GLuint y, GLuint z)
/// ```
void glVertexAttribI3uiEXT(int index, int x, int y, int z) {
  final _glVertexAttribI3uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y, Uint32 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribI3uiEXT');
  return _glVertexAttribI3uiEXT(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4uiEXT (GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
/// ```
void glVertexAttribI4uiEXT(int index, int x, int y, int z, int w) {
  final _glVertexAttribI4uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 x, Uint32 y, Uint32 z, Uint32 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribI4uiEXT');
  return _glVertexAttribI4uiEXT(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1ivEXT (GLuint index, const GLint *v)
/// ```
void glVertexAttribI1ivEXT(int index, Pointer<Int32>? v) {
  final _glVertexAttribI1ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI1ivEXT');
  return _glVertexAttribI1ivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2ivEXT (GLuint index, const GLint *v)
/// ```
void glVertexAttribI2ivEXT(int index, Pointer<Int32>? v) {
  final _glVertexAttribI2ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI2ivEXT');
  return _glVertexAttribI2ivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3ivEXT (GLuint index, const GLint *v)
/// ```
void glVertexAttribI3ivEXT(int index, Pointer<Int32>? v) {
  final _glVertexAttribI3ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI3ivEXT');
  return _glVertexAttribI3ivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4ivEXT (GLuint index, const GLint *v)
/// ```
void glVertexAttribI4ivEXT(int index, Pointer<Int32>? v) {
  final _glVertexAttribI4ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int32>? v),
      void Function(int index, Pointer<Int32>? v)>('glVertexAttribI4ivEXT');
  return _glVertexAttribI4ivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI1uivEXT (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI1uivEXT(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI1uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI1uivEXT');
  return _glVertexAttribI1uivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI2uivEXT (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI2uivEXT(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI2uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI2uivEXT');
  return _glVertexAttribI2uivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI3uivEXT (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI3uivEXT(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI3uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI3uivEXT');
  return _glVertexAttribI3uivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4uivEXT (GLuint index, const GLuint *v)
/// ```
void glVertexAttribI4uivEXT(int index, Pointer<Uint32>? v) {
  final _glVertexAttribI4uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint32>? v),
      void Function(int index, Pointer<Uint32>? v)>('glVertexAttribI4uivEXT');
  return _glVertexAttribI4uivEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4bvEXT (GLuint index, const GLbyte *v)
/// ```
void glVertexAttribI4bvEXT(int index, String v) {
  final _glVertexAttribI4bvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Utf8>? v),
      void Function(int index, Pointer<Utf8>? v)>('glVertexAttribI4bvEXT');
  final _vPointer = v.toNativeUtf8();
  final _result = _glVertexAttribI4bvEXT(index, _vPointer);
  calloc.free(_vPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4svEXT (GLuint index, const GLshort *v)
/// ```
void glVertexAttribI4svEXT(int index, Pointer<Int16>? v) {
  final _glVertexAttribI4svEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int16>? v),
      void Function(int index, Pointer<Int16>? v)>('glVertexAttribI4svEXT');
  return _glVertexAttribI4svEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4ubvEXT (GLuint index, const GLubyte *v)
/// ```
void glVertexAttribI4ubvEXT(int index, Pointer<Uint8>? v) {
  final _glVertexAttribI4ubvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint8>? v),
      void Function(int index, Pointer<Uint8>? v)>('glVertexAttribI4ubvEXT');
  return _glVertexAttribI4ubvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribI4usvEXT (GLuint index, const GLushort *v)
/// ```
void glVertexAttribI4usvEXT(int index, Pointer<Uint16>? v) {
  final _glVertexAttribI4usvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint16>? v),
      void Function(int index, Pointer<Uint16>? v)>('glVertexAttribI4usvEXT');
  return _glVertexAttribI4usvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribIPointerEXT (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribIPointerEXT(int index, int size, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribIPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int stride, Pointer<Void>? pointer)>('glVertexAttribIPointerEXT');
  return _glVertexAttribIPointerEXT(index, size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribIivEXT (GLuint index, GLenum pname, GLint *params)
/// ```
void glGetVertexAttribIivEXT(int index, int pname, Pointer<Int32>? params) {
  final _glGetVertexAttribIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int32>? params),
      void Function(int index, int pname, Pointer<Int32>? params)>('glGetVertexAttribIivEXT');
  return _glGetVertexAttribIivEXT(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribIuivEXT (GLuint index, GLenum pname, GLuint *params)
/// ```
void glGetVertexAttribIuivEXT(int index, int pname, Pointer<Uint32>? params) {
  final _glGetVertexAttribIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Uint32>? params),
      void Function(int index, int pname, Pointer<Uint32>? params)>('glGetVertexAttribIuivEXT');
  return _glGetVertexAttribIuivEXT(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformuivEXT (GLuint program, GLint location, GLuint *params)
/// ```
void glGetUniformuivEXT(int program, int location, Pointer<Uint32>? params) {
  final _glGetUniformuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Uint32>? params),
      void Function(int program, int location, Pointer<Uint32>? params)>('glGetUniformuivEXT');
  return _glGetUniformuivEXT(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glBindFragDataLocationEXT (GLuint program, GLuint color, const GLchar *name)
/// ```
void glBindFragDataLocationEXT(int program, int color, String name) {
  final _glBindFragDataLocationEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 color, Pointer<Utf8>? name),
      void Function(int program, int color, Pointer<Utf8>? name)>('glBindFragDataLocationEXT');
  final _namePointer = name.toNativeUtf8();
  final _result = _glBindFragDataLocationEXT(program, color, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI GLint APIENTRY glGetFragDataLocationEXT (GLuint program, const GLchar *name)
/// ```
int glGetFragDataLocationEXT(int program, String name) {
  final _glGetFragDataLocationEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetFragDataLocationEXT');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetFragDataLocationEXT(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glUniform1uiEXT (GLint location, GLuint v0)
/// ```
void glUniform1uiEXT(int location, int v0) {
  final _glUniform1uiEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0),
      void Function(int location, int v0)>('glUniform1uiEXT');
  return _glUniform1uiEXT(location, v0);
}

/// ```c
/// GLAPI void APIENTRY glUniform2uiEXT (GLint location, GLuint v0, GLuint v1)
/// ```
void glUniform2uiEXT(int location, int v0, int v1) {
  final _glUniform2uiEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1),
      void Function(int location, int v0, int v1)>('glUniform2uiEXT');
  return _glUniform2uiEXT(location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glUniform3uiEXT (GLint location, GLuint v0, GLuint v1, GLuint v2)
/// ```
void glUniform3uiEXT(int location, int v0, int v1, int v2) {
  final _glUniform3uiEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1, Uint32 v2),
      void Function(int location, int v0, int v1, int v2)>('glUniform3uiEXT');
  return _glUniform3uiEXT(location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glUniform4uiEXT (GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
/// ```
void glUniform4uiEXT(int location, int v0, int v1, int v2, int v3) {
  final _glUniform4uiEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 v0, Uint32 v1, Uint32 v2, Uint32 v3),
      void Function(int location, int v0, int v1, int v2, int v3)>('glUniform4uiEXT');
  return _glUniform4uiEXT(location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glUniform1uivEXT (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform1uivEXT(int location, int count, Pointer<Uint32>? value) {
  final _glUniform1uivEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform1uivEXT');
  return _glUniform1uivEXT(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2uivEXT (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform2uivEXT(int location, int count, Pointer<Uint32>? value) {
  final _glUniform2uivEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform2uivEXT');
  return _glUniform2uivEXT(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3uivEXT (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform3uivEXT(int location, int count, Pointer<Uint32>? value) {
  final _glUniform3uivEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform3uivEXT');
  return _glUniform3uivEXT(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4uivEXT (GLint location, GLsizei count, const GLuint *value)
/// ```
void glUniform4uivEXT(int location, int count, Pointer<Uint32>? value) {
  final _glUniform4uivEXT = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int location, int count, Pointer<Uint32>? value)>('glUniform4uivEXT');
  return _glUniform4uivEXT(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glDrawArraysInstancedEXT (GLenum mode, GLint start, GLsizei count, GLsizei primcount)
/// ```
void glDrawArraysInstancedEXT(int mode, int start, int count, int primcount) {
  final _glDrawArraysInstancedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Int32 start, Uint32 count, Uint32 primcount),
      void Function(int mode, int start, int count, int primcount)>('glDrawArraysInstancedEXT');
  return _glDrawArraysInstancedEXT(mode, start, count, primcount);
}

/// ```c
/// GLAPI void APIENTRY glDrawElementsInstancedEXT (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
/// ```
void glDrawElementsInstancedEXT(int mode, int count, int type, Pointer<Void>? indices, int primcount) {
  final _glDrawElementsInstancedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 count, Uint32 type, Pointer<Void>? indices, Uint32 primcount),
      void Function(int mode, int count, int type, Pointer<Void>? indices, int primcount)>('glDrawElementsInstancedEXT');
  return _glDrawElementsInstancedEXT(mode, count, type, indices, primcount);
}

/// ```c
/// GLAPI void APIENTRY glTexBufferEXT (GLenum target, GLenum internalformat, GLuint buffer)
/// ```
void glTexBufferEXT(int target, int internalformat, int buffer) {
  final _glTexBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 internalformat, Uint32 buffer),
      void Function(int target, int internalformat, int buffer)>('glTexBufferEXT');
  return _glTexBufferEXT(target, internalformat, buffer);
}

/// ```c
/// GLAPI void APIENTRY glDepthRangedNV (GLdouble zNear, GLdouble zFar)
/// ```
void glDepthRangedNV(double zNear, double zFar) {
  final _glDepthRangedNV = _SDL2.lookupFunction<
      Void Function(Double zNear, Double zFar),
      void Function(double zNear, double zFar)>('glDepthRangedNV');
  return _glDepthRangedNV(zNear, zFar);
}

/// ```c
/// GLAPI void APIENTRY glClearDepthdNV (GLdouble depth)
/// ```
void glClearDepthdNV(double depth) {
  final _glClearDepthdNV = _SDL2.lookupFunction<
      Void Function(Double depth),
      void Function(double depth)>('glClearDepthdNV');
  return _glClearDepthdNV(depth);
}

/// ```c
/// GLAPI void APIENTRY glDepthBoundsdNV (GLdouble zmin, GLdouble zmax)
/// ```
void glDepthBoundsdNV(double zmin, double zmax) {
  final _glDepthBoundsdNV = _SDL2.lookupFunction<
      Void Function(Double zmin, Double zmax),
      void Function(double zmin, double zmax)>('glDepthBoundsdNV');
  return _glDepthBoundsdNV(zmin, zmax);
}

/// ```c
/// GLAPI void APIENTRY glRenderbufferStorageMultisampleCoverageNV (GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glRenderbufferStorageMultisampleCoverageNV(int target, int coverageSamples, int colorSamples, int internalformat, int width, int height) {
  final _glRenderbufferStorageMultisampleCoverageNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 coverageSamples, Uint32 colorSamples, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int target, int coverageSamples, int colorSamples, int internalformat, int width, int height)>('glRenderbufferStorageMultisampleCoverageNV');
  return _glRenderbufferStorageMultisampleCoverageNV(target, coverageSamples, colorSamples, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glProgramBufferParametersfvNV (GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLfloat *params)
/// ```
void glProgramBufferParametersfvNV(int target, int buffer, int index, int count, Pointer<Float>? params) {
  final _glProgramBufferParametersfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 buffer, Uint32 index, Uint32 count, Pointer<Float>? params),
      void Function(int target, int buffer, int index, int count, Pointer<Float>? params)>('glProgramBufferParametersfvNV');
  return _glProgramBufferParametersfvNV(target, buffer, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramBufferParametersIivNV (GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLint *params)
/// ```
void glProgramBufferParametersIivNV(int target, int buffer, int index, int count, Pointer<Int32>? params) {
  final _glProgramBufferParametersIivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 buffer, Uint32 index, Uint32 count, Pointer<Int32>? params),
      void Function(int target, int buffer, int index, int count, Pointer<Int32>? params)>('glProgramBufferParametersIivNV');
  return _glProgramBufferParametersIivNV(target, buffer, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramBufferParametersIuivNV (GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLuint *params)
/// ```
void glProgramBufferParametersIuivNV(int target, int buffer, int index, int count, Pointer<Uint32>? params) {
  final _glProgramBufferParametersIuivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 buffer, Uint32 index, Uint32 count, Pointer<Uint32>? params),
      void Function(int target, int buffer, int index, int count, Pointer<Uint32>? params)>('glProgramBufferParametersIuivNV');
  return _glProgramBufferParametersIuivNV(target, buffer, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glColorMaskIndexedEXT (GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
/// ```
void glColorMaskIndexedEXT(int index, int r, int g, int b, int a) {
  final _glColorMaskIndexedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 r, Int32 g, Int32 b, Int32 a),
      void Function(int index, int r, int g, int b, int a)>('glColorMaskIndexedEXT');
  return _glColorMaskIndexedEXT(index, r, g, b, a);
}

/// ```c
/// GLAPI void APIENTRY glGetBooleanIndexedvEXT (GLenum target, GLuint index, GLboolean *data)
/// ```
void glGetBooleanIndexedvEXT(int target, int index, Pointer<Int32>? data) {
  final _glGetBooleanIndexedvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? data),
      void Function(int target, int index, Pointer<Int32>? data)>('glGetBooleanIndexedvEXT');
  return _glGetBooleanIndexedvEXT(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetIntegerIndexedvEXT (GLenum target, GLuint index, GLint *data)
/// ```
void glGetIntegerIndexedvEXT(int target, int index, Pointer<Int32>? data) {
  final _glGetIntegerIndexedvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Int32>? data),
      void Function(int target, int index, Pointer<Int32>? data)>('glGetIntegerIndexedvEXT');
  return _glGetIntegerIndexedvEXT(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glEnableIndexedEXT (GLenum target, GLuint index)
/// ```
void glEnableIndexedEXT(int target, int index) {
  final _glEnableIndexedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index),
      void Function(int target, int index)>('glEnableIndexedEXT');
  return _glEnableIndexedEXT(target, index);
}

/// ```c
/// GLAPI void APIENTRY glDisableIndexedEXT (GLenum target, GLuint index)
/// ```
void glDisableIndexedEXT(int target, int index) {
  final _glDisableIndexedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index),
      void Function(int target, int index)>('glDisableIndexedEXT');
  return _glDisableIndexedEXT(target, index);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsEnabledIndexedEXT (GLenum target, GLuint index)
/// ```
int glIsEnabledIndexedEXT(int target, int index) {
  final _glIsEnabledIndexedEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 target, Uint32 index),
      int Function(int target, int index)>('glIsEnabledIndexedEXT');
  return _glIsEnabledIndexedEXT(target, index);
}

/// ```c
/// GLAPI void APIENTRY glBeginTransformFeedbackNV (GLenum primitiveMode)
/// ```
void glBeginTransformFeedbackNV(int primitiveMode) {
  final _glBeginTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(Uint32 primitiveMode),
      void Function(int primitiveMode)>('glBeginTransformFeedbackNV');
  return _glBeginTransformFeedbackNV(primitiveMode);
}

/// ```c
/// GLAPI void APIENTRY glEndTransformFeedbackNV (void)
/// ```
void glEndTransformFeedbackNV() {
  final _glEndTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndTransformFeedbackNV');
  return _glEndTransformFeedbackNV();
}

/// ```c
/// GLAPI void APIENTRY glTransformFeedbackAttribsNV (GLuint count, const GLint *attribs, GLenum bufferMode)
/// ```
void glTransformFeedbackAttribsNV(int count, Pointer<Int32>? attribs, int bufferMode) {
  final _glTransformFeedbackAttribsNV = _SDL2.lookupFunction<
      Void Function(Uint32 count, Pointer<Int32>? attribs, Uint32 bufferMode),
      void Function(int count, Pointer<Int32>? attribs, int bufferMode)>('glTransformFeedbackAttribsNV');
  return _glTransformFeedbackAttribsNV(count, attribs, bufferMode);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferRangeNV (GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
/// ```
void glBindBufferRangeNV(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size) {
  final _glBindBufferRangeNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? size),
      void Function(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size)>('glBindBufferRangeNV');
  return _glBindBufferRangeNV(target, index, buffer, offset, size);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferOffsetNV (GLenum target, GLuint index, GLuint buffer, GLintptr offset)
/// ```
void glBindBufferOffsetNV(int target, int index, int buffer, Pointer<Void>? offset) {
  final _glBindBufferOffsetNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer, Pointer<Void>? offset),
      void Function(int target, int index, int buffer, Pointer<Void>? offset)>('glBindBufferOffsetNV');
  return _glBindBufferOffsetNV(target, index, buffer, offset);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferBaseNV (GLenum target, GLuint index, GLuint buffer)
/// ```
void glBindBufferBaseNV(int target, int index, int buffer) {
  final _glBindBufferBaseNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer),
      void Function(int target, int index, int buffer)>('glBindBufferBaseNV');
  return _glBindBufferBaseNV(target, index, buffer);
}

/// ```c
/// GLAPI void APIENTRY glTransformFeedbackVaryingsNV (GLuint program, GLsizei count, const GLint *locations, GLenum bufferMode)
/// ```
void glTransformFeedbackVaryingsNV(int program, int count, Pointer<Int32>? locations, int bufferMode) {
  final _glTransformFeedbackVaryingsNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 count, Pointer<Int32>? locations, Uint32 bufferMode),
      void Function(int program, int count, Pointer<Int32>? locations, int bufferMode)>('glTransformFeedbackVaryingsNV');
  return _glTransformFeedbackVaryingsNV(program, count, locations, bufferMode);
}

/// ```c
/// GLAPI void APIENTRY glActiveVaryingNV (GLuint program, const GLchar *name)
/// ```
void glActiveVaryingNV(int program, String name) {
  final _glActiveVaryingNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Pointer<Utf8>? name),
      void Function(int program, Pointer<Utf8>? name)>('glActiveVaryingNV');
  final _namePointer = name.toNativeUtf8();
  final _result = _glActiveVaryingNV(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI GLint APIENTRY glGetVaryingLocationNV (GLuint program, const GLchar *name)
/// ```
int glGetVaryingLocationNV(int program, String name) {
  final _glGetVaryingLocationNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Pointer<Utf8>? name),
      int Function(int program, Pointer<Utf8>? name)>('glGetVaryingLocationNV');
  final _namePointer = name.toNativeUtf8();
  final _result = _glGetVaryingLocationNV(program, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glGetActiveVaryingNV (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
/// ```
void glGetActiveVaryingNV(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetActiveVaryingNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetActiveVaryingNV');
  return _glGetActiveVaryingNV(program, index, bufSize, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glGetTransformFeedbackVaryingNV (GLuint program, GLuint index, GLint *location)
/// ```
void glGetTransformFeedbackVaryingNV(int program, int index, Pointer<Int32>? location) {
  final _glGetTransformFeedbackVaryingNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Pointer<Int32>? location),
      void Function(int program, int index, Pointer<Int32>? location)>('glGetTransformFeedbackVaryingNV');
  return _glGetTransformFeedbackVaryingNV(program, index, location);
}

/// ```c
/// GLAPI void APIENTRY glTransformFeedbackStreamAttribsNV (GLsizei count, const GLint *attribs, GLsizei nbuffers, const GLint *bufstreams, GLenum bufferMode)
/// ```
void glTransformFeedbackStreamAttribsNV(int count, Pointer<Int32>? attribs, int nbuffers, Pointer<Int32>? bufstreams, int bufferMode) {
  final _glTransformFeedbackStreamAttribsNV = _SDL2.lookupFunction<
      Void Function(Uint32 count, Pointer<Int32>? attribs, Uint32 nbuffers, Pointer<Int32>? bufstreams, Uint32 bufferMode),
      void Function(int count, Pointer<Int32>? attribs, int nbuffers, Pointer<Int32>? bufstreams, int bufferMode)>('glTransformFeedbackStreamAttribsNV');
  return _glTransformFeedbackStreamAttribsNV(count, attribs, nbuffers, bufstreams, bufferMode);
}

/// ```c
/// GLAPI void APIENTRY glUniformBufferEXT (GLuint program, GLint location, GLuint buffer)
/// ```
void glUniformBufferEXT(int program, int location, int buffer) {
  final _glUniformBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 buffer),
      void Function(int program, int location, int buffer)>('glUniformBufferEXT');
  return _glUniformBufferEXT(program, location, buffer);
}

/// ```c
/// GLAPI GLint APIENTRY glGetUniformBufferSizeEXT (GLuint program, GLint location)
/// ```
int glGetUniformBufferSizeEXT(int program, int location) {
  final _glGetUniformBufferSizeEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 program, Int32 location),
      int Function(int program, int location)>('glGetUniformBufferSizeEXT');
  return _glGetUniformBufferSizeEXT(program, location);
}

/// ```c
/// GLAPI GLintptr APIENTRY glGetUniformOffsetEXT (GLuint program, GLint location)
/// ```
Pointer<Void>? glGetUniformOffsetEXT(int program, int location) {
  final _glGetUniformOffsetEXT = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 program, Int32 location),
      Pointer<Void>? Function(int program, int location)>('glGetUniformOffsetEXT');
  return _glGetUniformOffsetEXT(program, location);
}

/// ```c
/// GLAPI void APIENTRY glTexParameterIivEXT (GLenum target, GLenum pname, const GLint *params)
/// ```
void glTexParameterIivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glTexParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glTexParameterIivEXT');
  return _glTexParameterIivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTexParameterIuivEXT (GLenum target, GLenum pname, const GLuint *params)
/// ```
void glTexParameterIuivEXT(int target, int pname, Pointer<Uint32>? params) {
  final _glTexParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int target, int pname, Pointer<Uint32>? params)>('glTexParameterIuivEXT');
  return _glTexParameterIuivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTexParameterIivEXT (GLenum target, GLenum pname, GLint *params)
/// ```
void glGetTexParameterIivEXT(int target, int pname, Pointer<Int32>? params) {
  final _glGetTexParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int target, int pname, Pointer<Int32>? params)>('glGetTexParameterIivEXT');
  return _glGetTexParameterIivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTexParameterIuivEXT (GLenum target, GLenum pname, GLuint *params)
/// ```
void glGetTexParameterIuivEXT(int target, int pname, Pointer<Uint32>? params) {
  final _glGetTexParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int target, int pname, Pointer<Uint32>? params)>('glGetTexParameterIuivEXT');
  return _glGetTexParameterIuivEXT(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glClearColorIiEXT (GLint red, GLint green, GLint blue, GLint alpha)
/// ```
void glClearColorIiEXT(int red, int green, int blue, int alpha) {
  final _glClearColorIiEXT = _SDL2.lookupFunction<
      Void Function(Int32 red, Int32 green, Int32 blue, Int32 alpha),
      void Function(int red, int green, int blue, int alpha)>('glClearColorIiEXT');
  return _glClearColorIiEXT(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glClearColorIuiEXT (GLuint red, GLuint green, GLuint blue, GLuint alpha)
/// ```
void glClearColorIuiEXT(int red, int green, int blue, int alpha) {
  final _glClearColorIuiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 red, Uint32 green, Uint32 blue, Uint32 alpha),
      void Function(int red, int green, int blue, int alpha)>('glClearColorIuiEXT');
  return _glClearColorIuiEXT(red, green, blue, alpha);
}

/// ```c
/// GLAPI void APIENTRY glFrameTerminatorGREMEDY (void)
/// ```
void glFrameTerminatorGREMEDY() {
  final _glFrameTerminatorGREMEDY = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glFrameTerminatorGREMEDY');
  return _glFrameTerminatorGREMEDY();
}

/// ```c
/// GLAPI void APIENTRY glBeginConditionalRenderNV (GLuint id, GLenum mode)
/// ```
void glBeginConditionalRenderNV(int id, int mode) {
  final _glBeginConditionalRenderNV = _SDL2.lookupFunction<
      Void Function(Uint32 id, Uint32 mode),
      void Function(int id, int mode)>('glBeginConditionalRenderNV');
  return _glBeginConditionalRenderNV(id, mode);
}

/// ```c
/// GLAPI void APIENTRY glEndConditionalRenderNV (void)
/// ```
void glEndConditionalRenderNV() {
  final _glEndConditionalRenderNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndConditionalRenderNV');
  return _glEndConditionalRenderNV();
}

/// ```c
/// GLAPI void APIENTRY glPresentFrameKeyedNV (GLuint video_slot, GLuint64EXT minPresentTime, GLuint beginPresentTimeId, GLuint presentDurationId, GLenum type, GLenum target0, GLuint fill0, GLuint key0, GLenum target1, GLuint fill1, GLuint key1)
/// ```
void glPresentFrameKeyedNV(int video_slot, int minPresentTime, int beginPresentTimeId, int presentDurationId, int type, int target0, int fill0, int key0, int target1, int fill1, int key1) {
  final _glPresentFrameKeyedNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint64 minPresentTime, Uint32 beginPresentTimeId, Uint32 presentDurationId, Uint32 type, Uint32 target0, Uint32 fill0, Uint32 key0, Uint32 target1, Uint32 fill1, Uint32 key1),
      void Function(int video_slot, int minPresentTime, int beginPresentTimeId, int presentDurationId, int type, int target0, int fill0, int key0, int target1, int fill1, int key1)>('glPresentFrameKeyedNV');
  return _glPresentFrameKeyedNV(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, type, target0, fill0, key0, target1, fill1, key1);
}

/// ```c
/// GLAPI void APIENTRY glPresentFrameDualFillNV (GLuint video_slot, GLuint64EXT minPresentTime, GLuint beginPresentTimeId, GLuint presentDurationId, GLenum type, GLenum target0, GLuint fill0, GLenum target1, GLuint fill1, GLenum target2, GLuint fill2, GLenum target3, GLuint fill3)
/// ```
void glPresentFrameDualFillNV(int video_slot, int minPresentTime, int beginPresentTimeId, int presentDurationId, int type, int target0, int fill0, int target1, int fill1, int target2, int fill2, int target3, int fill3) {
  final _glPresentFrameDualFillNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint64 minPresentTime, Uint32 beginPresentTimeId, Uint32 presentDurationId, Uint32 type, Uint32 target0, Uint32 fill0, Uint32 target1, Uint32 fill1, Uint32 target2, Uint32 fill2, Uint32 target3, Uint32 fill3),
      void Function(int video_slot, int minPresentTime, int beginPresentTimeId, int presentDurationId, int type, int target0, int fill0, int target1, int fill1, int target2, int fill2, int target3, int fill3)>('glPresentFrameDualFillNV');
  return _glPresentFrameDualFillNV(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, type, target0, fill0, target1, fill1, target2, fill2, target3, fill3);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoivNV (GLuint video_slot, GLenum pname, GLint *params)
/// ```
void glGetVideoivNV(int video_slot, int pname, Pointer<Int32>? params) {
  final _glGetVideoivNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint32 pname, Pointer<Int32>? params),
      void Function(int video_slot, int pname, Pointer<Int32>? params)>('glGetVideoivNV');
  return _glGetVideoivNV(video_slot, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideouivNV (GLuint video_slot, GLenum pname, GLuint *params)
/// ```
void glGetVideouivNV(int video_slot, int pname, Pointer<Uint32>? params) {
  final _glGetVideouivNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint32 pname, Pointer<Uint32>? params),
      void Function(int video_slot, int pname, Pointer<Uint32>? params)>('glGetVideouivNV');
  return _glGetVideouivNV(video_slot, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoi64vNV (GLuint video_slot, GLenum pname, GLint64EXT *params)
/// ```
void glGetVideoi64vNV(int video_slot, int pname, Pointer<Int64>? params) {
  final _glGetVideoi64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint32 pname, Pointer<Int64>? params),
      void Function(int video_slot, int pname, Pointer<Int64>? params)>('glGetVideoi64vNV');
  return _glGetVideoi64vNV(video_slot, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoui64vNV (GLuint video_slot, GLenum pname, GLuint64EXT *params)
/// ```
void glGetVideoui64vNV(int video_slot, int pname, Pointer<Uint64>? params) {
  final _glGetVideoui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_slot, Uint32 pname, Pointer<Uint64>? params),
      void Function(int video_slot, int pname, Pointer<Uint64>? params)>('glGetVideoui64vNV');
  return _glGetVideoui64vNV(video_slot, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glBeginTransformFeedbackEXT (GLenum primitiveMode)
/// ```
void glBeginTransformFeedbackEXT(int primitiveMode) {
  final _glBeginTransformFeedbackEXT = _SDL2.lookupFunction<
      Void Function(Uint32 primitiveMode),
      void Function(int primitiveMode)>('glBeginTransformFeedbackEXT');
  return _glBeginTransformFeedbackEXT(primitiveMode);
}

/// ```c
/// GLAPI void APIENTRY glEndTransformFeedbackEXT (void)
/// ```
void glEndTransformFeedbackEXT() {
  final _glEndTransformFeedbackEXT = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glEndTransformFeedbackEXT');
  return _glEndTransformFeedbackEXT();
}

/// ```c
/// GLAPI void APIENTRY glBindBufferRangeEXT (GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
/// ```
void glBindBufferRangeEXT(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size) {
  final _glBindBufferRangeEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? size),
      void Function(int target, int index, int buffer, Pointer<Void>? offset, Pointer<Void>? size)>('glBindBufferRangeEXT');
  return _glBindBufferRangeEXT(target, index, buffer, offset, size);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferOffsetEXT (GLenum target, GLuint index, GLuint buffer, GLintptr offset)
/// ```
void glBindBufferOffsetEXT(int target, int index, int buffer, Pointer<Void>? offset) {
  final _glBindBufferOffsetEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer, Pointer<Void>? offset),
      void Function(int target, int index, int buffer, Pointer<Void>? offset)>('glBindBufferOffsetEXT');
  return _glBindBufferOffsetEXT(target, index, buffer, offset);
}

/// ```c
/// GLAPI void APIENTRY glBindBufferBaseEXT (GLenum target, GLuint index, GLuint buffer)
/// ```
void glBindBufferBaseEXT(int target, int index, int buffer) {
  final _glBindBufferBaseEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Uint32 buffer),
      void Function(int target, int index, int buffer)>('glBindBufferBaseEXT');
  return _glBindBufferBaseEXT(target, index, buffer);
}

/// ```c
/// GLAPI void APIENTRY glTransformFeedbackVaryingsEXT (GLuint program, GLsizei count, const GLchar* *varyings, GLenum bufferMode)
/// ```
void glTransformFeedbackVaryingsEXT(int program, int count, Pointer<Pointer<Int8>>? varyings, int bufferMode) {
  final _glTransformFeedbackVaryingsEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 count, Pointer<Pointer<Int8>>? varyings, Uint32 bufferMode),
      void Function(int program, int count, Pointer<Pointer<Int8>>? varyings, int bufferMode)>('glTransformFeedbackVaryingsEXT');
  return _glTransformFeedbackVaryingsEXT(program, count, varyings, bufferMode);
}

/// ```c
/// GLAPI void APIENTRY glGetTransformFeedbackVaryingEXT (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
/// ```
void glGetTransformFeedbackVaryingEXT(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name) {
  final _glGetTransformFeedbackVaryingEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 index, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name),
      void Function(int program, int index, int bufSize, Pointer<Uint32>? length, Pointer<Uint32>? size, Pointer<Uint32>? type, Pointer<Int8>? name)>('glGetTransformFeedbackVaryingEXT');
  return _glGetTransformFeedbackVaryingEXT(program, index, bufSize, length, size, type, name);
}

/// ```c
/// GLAPI void APIENTRY glClientAttribDefaultEXT (GLbitfield mask)
/// ```
void glClientAttribDefaultEXT(int mask) {
  final _glClientAttribDefaultEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mask),
      void Function(int mask)>('glClientAttribDefaultEXT');
  return _glClientAttribDefaultEXT(mask);
}

/// ```c
/// GLAPI void APIENTRY glPushClientAttribDefaultEXT (GLbitfield mask)
/// ```
void glPushClientAttribDefaultEXT(int mask) {
  final _glPushClientAttribDefaultEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mask),
      void Function(int mask)>('glPushClientAttribDefaultEXT');
  return _glPushClientAttribDefaultEXT(mask);
}

/// ```c
/// GLAPI void APIENTRY glMatrixLoadfEXT (GLenum mode, const GLfloat *m)
/// ```
void glMatrixLoadfEXT(int mode, Pointer<Float>? m) {
  final _glMatrixLoadfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Float>? m),
      void Function(int mode, Pointer<Float>? m)>('glMatrixLoadfEXT');
  return _glMatrixLoadfEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixLoaddEXT (GLenum mode, const GLdouble *m)
/// ```
void glMatrixLoaddEXT(int mode, Pointer<Double>? m) {
  final _glMatrixLoaddEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Double>? m),
      void Function(int mode, Pointer<Double>? m)>('glMatrixLoaddEXT');
  return _glMatrixLoaddEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixMultfEXT (GLenum mode, const GLfloat *m)
/// ```
void glMatrixMultfEXT(int mode, Pointer<Float>? m) {
  final _glMatrixMultfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Float>? m),
      void Function(int mode, Pointer<Float>? m)>('glMatrixMultfEXT');
  return _glMatrixMultfEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixMultdEXT (GLenum mode, const GLdouble *m)
/// ```
void glMatrixMultdEXT(int mode, Pointer<Double>? m) {
  final _glMatrixMultdEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Double>? m),
      void Function(int mode, Pointer<Double>? m)>('glMatrixMultdEXT');
  return _glMatrixMultdEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixLoadIdentityEXT (GLenum mode)
/// ```
void glMatrixLoadIdentityEXT(int mode) {
  final _glMatrixLoadIdentityEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glMatrixLoadIdentityEXT');
  return _glMatrixLoadIdentityEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glMatrixRotatefEXT (GLenum mode, GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glMatrixRotatefEXT(int mode, double angle, double x, double y, double z) {
  final _glMatrixRotatefEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Float angle, Float x, Float y, Float z),
      void Function(int mode, double angle, double x, double y, double z)>('glMatrixRotatefEXT');
  return _glMatrixRotatefEXT(mode, angle, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixRotatedEXT (GLenum mode, GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glMatrixRotatedEXT(int mode, double angle, double x, double y, double z) {
  final _glMatrixRotatedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Double angle, Double x, Double y, Double z),
      void Function(int mode, double angle, double x, double y, double z)>('glMatrixRotatedEXT');
  return _glMatrixRotatedEXT(mode, angle, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixScalefEXT (GLenum mode, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glMatrixScalefEXT(int mode, double x, double y, double z) {
  final _glMatrixScalefEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Float x, Float y, Float z),
      void Function(int mode, double x, double y, double z)>('glMatrixScalefEXT');
  return _glMatrixScalefEXT(mode, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixScaledEXT (GLenum mode, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glMatrixScaledEXT(int mode, double x, double y, double z) {
  final _glMatrixScaledEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Double x, Double y, Double z),
      void Function(int mode, double x, double y, double z)>('glMatrixScaledEXT');
  return _glMatrixScaledEXT(mode, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixTranslatefEXT (GLenum mode, GLfloat x, GLfloat y, GLfloat z)
/// ```
void glMatrixTranslatefEXT(int mode, double x, double y, double z) {
  final _glMatrixTranslatefEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Float x, Float y, Float z),
      void Function(int mode, double x, double y, double z)>('glMatrixTranslatefEXT');
  return _glMatrixTranslatefEXT(mode, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixTranslatedEXT (GLenum mode, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glMatrixTranslatedEXT(int mode, double x, double y, double z) {
  final _glMatrixTranslatedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Double x, Double y, Double z),
      void Function(int mode, double x, double y, double z)>('glMatrixTranslatedEXT');
  return _glMatrixTranslatedEXT(mode, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glMatrixFrustumEXT (GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
/// ```
void glMatrixFrustumEXT(int mode, double left, double right, double bottom, double top, double zNear, double zFar) {
  final _glMatrixFrustumEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar),
      void Function(int mode, double left, double right, double bottom, double top, double zNear, double zFar)>('glMatrixFrustumEXT');
  return _glMatrixFrustumEXT(mode, left, right, bottom, top, zNear, zFar);
}

/// ```c
/// GLAPI void APIENTRY glMatrixOrthoEXT (GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
/// ```
void glMatrixOrthoEXT(int mode, double left, double right, double bottom, double top, double zNear, double zFar) {
  final _glMatrixOrthoEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Double left, Double right, Double bottom, Double top, Double zNear, Double zFar),
      void Function(int mode, double left, double right, double bottom, double top, double zNear, double zFar)>('glMatrixOrthoEXT');
  return _glMatrixOrthoEXT(mode, left, right, bottom, top, zNear, zFar);
}

/// ```c
/// GLAPI void APIENTRY glMatrixPopEXT (GLenum mode)
/// ```
void glMatrixPopEXT(int mode) {
  final _glMatrixPopEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glMatrixPopEXT');
  return _glMatrixPopEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glMatrixPushEXT (GLenum mode)
/// ```
void glMatrixPushEXT(int mode) {
  final _glMatrixPushEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glMatrixPushEXT');
  return _glMatrixPushEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glMatrixLoadTransposefEXT (GLenum mode, const GLfloat *m)
/// ```
void glMatrixLoadTransposefEXT(int mode, Pointer<Float>? m) {
  final _glMatrixLoadTransposefEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Float>? m),
      void Function(int mode, Pointer<Float>? m)>('glMatrixLoadTransposefEXT');
  return _glMatrixLoadTransposefEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixLoadTransposedEXT (GLenum mode, const GLdouble *m)
/// ```
void glMatrixLoadTransposedEXT(int mode, Pointer<Double>? m) {
  final _glMatrixLoadTransposedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Double>? m),
      void Function(int mode, Pointer<Double>? m)>('glMatrixLoadTransposedEXT');
  return _glMatrixLoadTransposedEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixMultTransposefEXT (GLenum mode, const GLfloat *m)
/// ```
void glMatrixMultTransposefEXT(int mode, Pointer<Float>? m) {
  final _glMatrixMultTransposefEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Float>? m),
      void Function(int mode, Pointer<Float>? m)>('glMatrixMultTransposefEXT');
  return _glMatrixMultTransposefEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glMatrixMultTransposedEXT (GLenum mode, const GLdouble *m)
/// ```
void glMatrixMultTransposedEXT(int mode, Pointer<Double>? m) {
  final _glMatrixMultTransposedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Pointer<Double>? m),
      void Function(int mode, Pointer<Double>? m)>('glMatrixMultTransposedEXT');
  return _glMatrixMultTransposedEXT(mode, m);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameterfEXT (GLuint texture, GLenum target, GLenum pname, GLfloat param)
/// ```
void glTextureParameterfEXT(int texture, int target, int pname, double param) {
  final _glTextureParameterfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Float param),
      void Function(int texture, int target, int pname, double param)>('glTextureParameterfEXT');
  return _glTextureParameterfEXT(texture, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameterfvEXT (GLuint texture, GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glTextureParameterfvEXT(int texture, int target, int pname, Pointer<Float>? params) {
  final _glTextureParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texture, int target, int pname, Pointer<Float>? params)>('glTextureParameterfvEXT');
  return _glTextureParameterfvEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameteriEXT (GLuint texture, GLenum target, GLenum pname, GLint param)
/// ```
void glTextureParameteriEXT(int texture, int target, int pname, int param) {
  final _glTextureParameteriEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Int32 param),
      void Function(int texture, int target, int pname, int param)>('glTextureParameteriEXT');
  return _glTextureParameteriEXT(texture, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameterivEXT (GLuint texture, GLenum target, GLenum pname, const GLint *params)
/// ```
void glTextureParameterivEXT(int texture, int target, int pname, Pointer<Int32>? params) {
  final _glTextureParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texture, int target, int pname, Pointer<Int32>? params)>('glTextureParameterivEXT');
  return _glTextureParameterivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTextureImage1DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureImage1DEXT(int texture, int target, int level, int internalformat, int width, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTextureImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int internalformat, int width, int border, int format, int type, Pointer<Void>? pixels)>('glTextureImage1DEXT');
  return _glTextureImage1DEXT(texture, target, level, internalformat, width, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTextureImage2DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureImage2DEXT(int texture, int target, int level, int internalformat, int width, int height, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTextureImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int internalformat, int width, int height, int border, int format, int type, Pointer<Void>? pixels)>('glTextureImage2DEXT');
  return _glTextureImage2DEXT(texture, target, level, internalformat, width, height, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTextureSubImage1DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureSubImage1DEXT(int texture, int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels) {
  final _glTextureSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels)>('glTextureSubImage1DEXT');
  return _glTextureSubImage1DEXT(texture, target, level, xoffset, width, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTextureSubImage2DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureSubImage2DEXT(int texture, int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels) {
  final _glTextureSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels)>('glTextureSubImage2DEXT');
  return _glTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, width, height, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyTextureImage1DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
/// ```
void glCopyTextureImage1DEXT(int texture, int target, int level, int internalformat, int x, int y, int width, int border) {
  final _glCopyTextureImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Int32 border),
      void Function(int texture, int target, int level, int internalformat, int x, int y, int width, int border)>('glCopyTextureImage1DEXT');
  return _glCopyTextureImage1DEXT(texture, target, level, internalformat, x, y, width, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyTextureImage2DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
/// ```
void glCopyTextureImage2DEXT(int texture, int target, int level, int internalformat, int x, int y, int width, int height, int border) {
  final _glCopyTextureImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Uint32 height, Int32 border),
      void Function(int texture, int target, int level, int internalformat, int x, int y, int width, int height, int border)>('glCopyTextureImage2DEXT');
  return _glCopyTextureImage2DEXT(texture, target, level, internalformat, x, y, width, height, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyTextureSubImage1DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
/// ```
void glCopyTextureSubImage1DEXT(int texture, int target, int level, int xoffset, int x, int y, int width) {
  final _glCopyTextureSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Uint32 width),
      void Function(int texture, int target, int level, int xoffset, int x, int y, int width)>('glCopyTextureSubImage1DEXT');
  return _glCopyTextureSubImage1DEXT(texture, target, level, xoffset, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glCopyTextureSubImage2DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyTextureSubImage2DEXT(int texture, int target, int level, int xoffset, int yoffset, int x, int y, int width, int height) {
  final _glCopyTextureSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int x, int y, int width, int height)>('glCopyTextureSubImage2DEXT');
  return _glCopyTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureImageEXT (GLuint texture, GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels)
/// ```
void glGetTextureImageEXT(int texture, int target, int level, int format, int type, Pointer<Void>? pixels) {
  final _glGetTextureImageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int format, int type, Pointer<Void>? pixels)>('glGetTextureImageEXT');
  return _glGetTextureImageEXT(texture, target, level, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureParameterfvEXT (GLuint texture, GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetTextureParameterfvEXT(int texture, int target, int pname, Pointer<Float>? params) {
  final _glGetTextureParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texture, int target, int pname, Pointer<Float>? params)>('glGetTextureParameterfvEXT');
  return _glGetTextureParameterfvEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureParameterivEXT (GLuint texture, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetTextureParameterivEXT(int texture, int target, int pname, Pointer<Int32>? params) {
  final _glGetTextureParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texture, int target, int pname, Pointer<Int32>? params)>('glGetTextureParameterivEXT');
  return _glGetTextureParameterivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureLevelParameterfvEXT (GLuint texture, GLenum target, GLint level, GLenum pname, GLfloat *params)
/// ```
void glGetTextureLevelParameterfvEXT(int texture, int target, int level, int pname, Pointer<Float>? params) {
  final _glGetTextureLevelParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 pname, Pointer<Float>? params),
      void Function(int texture, int target, int level, int pname, Pointer<Float>? params)>('glGetTextureLevelParameterfvEXT');
  return _glGetTextureLevelParameterfvEXT(texture, target, level, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureLevelParameterivEXT (GLuint texture, GLenum target, GLint level, GLenum pname, GLint *params)
/// ```
void glGetTextureLevelParameterivEXT(int texture, int target, int level, int pname, Pointer<Int32>? params) {
  final _glGetTextureLevelParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 pname, Pointer<Int32>? params),
      void Function(int texture, int target, int level, int pname, Pointer<Int32>? params)>('glGetTextureLevelParameterivEXT');
  return _glGetTextureLevelParameterivEXT(texture, target, level, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTextureImage3DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureImage3DEXT(int texture, int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels) {
  final _glTextureImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels)>('glTextureImage3DEXT');
  return _glTextureImage3DEXT(texture, target, level, internalformat, width, height, depth, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glTextureSubImage3DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glTextureSubImage3DEXT(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels) {
  final _glTextureSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels)>('glTextureSubImage3DEXT');
  return _glTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyTextureSubImage3DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyTextureSubImage3DEXT(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height) {
  final _glCopyTextureSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height)>('glCopyTextureSubImage3DEXT');
  return _glCopyTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameterfEXT (GLenum texunit, GLenum target, GLenum pname, GLfloat param)
/// ```
void glMultiTexParameterfEXT(int texunit, int target, int pname, double param) {
  final _glMultiTexParameterfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Float param),
      void Function(int texunit, int target, int pname, double param)>('glMultiTexParameterfEXT');
  return _glMultiTexParameterfEXT(texunit, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameterfvEXT (GLenum texunit, GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glMultiTexParameterfvEXT(int texunit, int target, int pname, Pointer<Float>? params) {
  final _glMultiTexParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int target, int pname, Pointer<Float>? params)>('glMultiTexParameterfvEXT');
  return _glMultiTexParameterfvEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameteriEXT (GLenum texunit, GLenum target, GLenum pname, GLint param)
/// ```
void glMultiTexParameteriEXT(int texunit, int target, int pname, int param) {
  final _glMultiTexParameteriEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Int32 param),
      void Function(int texunit, int target, int pname, int param)>('glMultiTexParameteriEXT');
  return _glMultiTexParameteriEXT(texunit, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameterivEXT (GLenum texunit, GLenum target, GLenum pname, const GLint *params)
/// ```
void glMultiTexParameterivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glMultiTexParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glMultiTexParameterivEXT');
  return _glMultiTexParameterivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexImage1DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexImage1DEXT(int texunit, int target, int level, int internalformat, int width, int border, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int internalformat, int width, int border, int format, int type, Pointer<Void>? pixels)>('glMultiTexImage1DEXT');
  return _glMultiTexImage1DEXT(texunit, target, level, internalformat, width, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexImage2DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexImage2DEXT(int texunit, int target, int level, int internalformat, int width, int height, int border, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int internalformat, int width, int height, int border, int format, int type, Pointer<Void>? pixels)>('glMultiTexImage2DEXT');
  return _glMultiTexImage2DEXT(texunit, target, level, internalformat, width, height, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexSubImage1DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexSubImage1DEXT(int texunit, int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int xoffset, int width, int format, int type, Pointer<Void>? pixels)>('glMultiTexSubImage1DEXT');
  return _glMultiTexSubImage1DEXT(texunit, target, level, xoffset, width, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexSubImage2DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexSubImage2DEXT(int texunit, int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, Pointer<Void>? pixels)>('glMultiTexSubImage2DEXT');
  return _glMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, width, height, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyMultiTexImage1DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
/// ```
void glCopyMultiTexImage1DEXT(int texunit, int target, int level, int internalformat, int x, int y, int width, int border) {
  final _glCopyMultiTexImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Int32 border),
      void Function(int texunit, int target, int level, int internalformat, int x, int y, int width, int border)>('glCopyMultiTexImage1DEXT');
  return _glCopyMultiTexImage1DEXT(texunit, target, level, internalformat, x, y, width, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyMultiTexImage2DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
/// ```
void glCopyMultiTexImage2DEXT(int texunit, int target, int level, int internalformat, int x, int y, int width, int height, int border) {
  final _glCopyMultiTexImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Int32 x, Int32 y, Uint32 width, Uint32 height, Int32 border),
      void Function(int texunit, int target, int level, int internalformat, int x, int y, int width, int height, int border)>('glCopyMultiTexImage2DEXT');
  return _glCopyMultiTexImage2DEXT(texunit, target, level, internalformat, x, y, width, height, border);
}

/// ```c
/// GLAPI void APIENTRY glCopyMultiTexSubImage1DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
/// ```
void glCopyMultiTexSubImage1DEXT(int texunit, int target, int level, int xoffset, int x, int y, int width) {
  final _glCopyMultiTexSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 x, Int32 y, Uint32 width),
      void Function(int texunit, int target, int level, int xoffset, int x, int y, int width)>('glCopyMultiTexSubImage1DEXT');
  return _glCopyMultiTexSubImage1DEXT(texunit, target, level, xoffset, x, y, width);
}

/// ```c
/// GLAPI void APIENTRY glCopyMultiTexSubImage2DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyMultiTexSubImage2DEXT(int texunit, int target, int level, int xoffset, int yoffset, int x, int y, int width, int height) {
  final _glCopyMultiTexSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int x, int y, int width, int height)>('glCopyMultiTexSubImage2DEXT');
  return _glCopyMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexImageEXT (GLenum texunit, GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels)
/// ```
void glGetMultiTexImageEXT(int texunit, int target, int level, int format, int type, Pointer<Void>? pixels) {
  final _glGetMultiTexImageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int format, int type, Pointer<Void>? pixels)>('glGetMultiTexImageEXT');
  return _glGetMultiTexImageEXT(texunit, target, level, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexParameterfvEXT (GLenum texunit, GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetMultiTexParameterfvEXT(int texunit, int target, int pname, Pointer<Float>? params) {
  final _glGetMultiTexParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int target, int pname, Pointer<Float>? params)>('glGetMultiTexParameterfvEXT');
  return _glGetMultiTexParameterfvEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexParameterivEXT (GLenum texunit, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMultiTexParameterivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glGetMultiTexParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glGetMultiTexParameterivEXT');
  return _glGetMultiTexParameterivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexLevelParameterfvEXT (GLenum texunit, GLenum target, GLint level, GLenum pname, GLfloat *params)
/// ```
void glGetMultiTexLevelParameterfvEXT(int texunit, int target, int level, int pname, Pointer<Float>? params) {
  final _glGetMultiTexLevelParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int target, int level, int pname, Pointer<Float>? params)>('glGetMultiTexLevelParameterfvEXT');
  return _glGetMultiTexLevelParameterfvEXT(texunit, target, level, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexLevelParameterivEXT (GLenum texunit, GLenum target, GLint level, GLenum pname, GLint *params)
/// ```
void glGetMultiTexLevelParameterivEXT(int texunit, int target, int level, int pname, Pointer<Int32>? params) {
  final _glGetMultiTexLevelParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int level, int pname, Pointer<Int32>? params)>('glGetMultiTexLevelParameterivEXT');
  return _glGetMultiTexLevelParameterivEXT(texunit, target, level, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexImage3DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexImage3DEXT(int texunit, int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int internalformat, int width, int height, int depth, int border, int format, int type, Pointer<Void>? pixels)>('glMultiTexImage3DEXT');
  return _glMultiTexImage3DEXT(texunit, target, level, internalformat, width, height, depth, border, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexSubImage3DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
/// ```
void glMultiTexSubImage3DEXT(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels) {
  final _glMultiTexSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 type, Pointer<Void>? pixels),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int type, Pointer<Void>? pixels)>('glMultiTexSubImage3DEXT');
  return _glMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
}

/// ```c
/// GLAPI void APIENTRY glCopyMultiTexSubImage3DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
/// ```
void glCopyMultiTexSubImage3DEXT(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height) {
  final _glCopyMultiTexSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Int32 x, Int32 y, Uint32 width, Uint32 height),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int x, int y, int width, int height)>('glCopyMultiTexSubImage3DEXT');
  return _glCopyMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height);
}

/// ```c
/// GLAPI void APIENTRY glBindMultiTextureEXT (GLenum texunit, GLenum target, GLuint texture)
/// ```
void glBindMultiTextureEXT(int texunit, int target, int texture) {
  final _glBindMultiTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 texture),
      void Function(int texunit, int target, int texture)>('glBindMultiTextureEXT');
  return _glBindMultiTextureEXT(texunit, target, texture);
}

/// ```c
/// GLAPI void APIENTRY glEnableClientStateIndexedEXT (GLenum array, GLuint index)
/// ```
void glEnableClientStateIndexedEXT(int array, int index) {
  final _glEnableClientStateIndexedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 array, Uint32 index),
      void Function(int array, int index)>('glEnableClientStateIndexedEXT');
  return _glEnableClientStateIndexedEXT(array, index);
}

/// ```c
/// GLAPI void APIENTRY glDisableClientStateIndexedEXT (GLenum array, GLuint index)
/// ```
void glDisableClientStateIndexedEXT(int array, int index) {
  final _glDisableClientStateIndexedEXT = _SDL2.lookupFunction<
      Void Function(Uint32 array, Uint32 index),
      void Function(int array, int index)>('glDisableClientStateIndexedEXT');
  return _glDisableClientStateIndexedEXT(array, index);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexCoordPointerEXT (GLenum texunit, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glMultiTexCoordPointerEXT(int texunit, int size, int type, int stride, Pointer<Void>? pointer) {
  final _glMultiTexCoordPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int texunit, int size, int type, int stride, Pointer<Void>? pointer)>('glMultiTexCoordPointerEXT');
  return _glMultiTexCoordPointerEXT(texunit, size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexEnvfEXT (GLenum texunit, GLenum target, GLenum pname, GLfloat param)
/// ```
void glMultiTexEnvfEXT(int texunit, int target, int pname, double param) {
  final _glMultiTexEnvfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Float param),
      void Function(int texunit, int target, int pname, double param)>('glMultiTexEnvfEXT');
  return _glMultiTexEnvfEXT(texunit, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexEnvfvEXT (GLenum texunit, GLenum target, GLenum pname, const GLfloat *params)
/// ```
void glMultiTexEnvfvEXT(int texunit, int target, int pname, Pointer<Float>? params) {
  final _glMultiTexEnvfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int target, int pname, Pointer<Float>? params)>('glMultiTexEnvfvEXT');
  return _glMultiTexEnvfvEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexEnviEXT (GLenum texunit, GLenum target, GLenum pname, GLint param)
/// ```
void glMultiTexEnviEXT(int texunit, int target, int pname, int param) {
  final _glMultiTexEnviEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Int32 param),
      void Function(int texunit, int target, int pname, int param)>('glMultiTexEnviEXT');
  return _glMultiTexEnviEXT(texunit, target, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexEnvivEXT (GLenum texunit, GLenum target, GLenum pname, const GLint *params)
/// ```
void glMultiTexEnvivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glMultiTexEnvivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glMultiTexEnvivEXT');
  return _glMultiTexEnvivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGendEXT (GLenum texunit, GLenum coord, GLenum pname, GLdouble param)
/// ```
void glMultiTexGendEXT(int texunit, int coord, int pname, double param) {
  final _glMultiTexGendEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Double param),
      void Function(int texunit, int coord, int pname, double param)>('glMultiTexGendEXT');
  return _glMultiTexGendEXT(texunit, coord, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGendvEXT (GLenum texunit, GLenum coord, GLenum pname, const GLdouble *params)
/// ```
void glMultiTexGendvEXT(int texunit, int coord, int pname, Pointer<Double>? params) {
  final _glMultiTexGendvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Double>? params),
      void Function(int texunit, int coord, int pname, Pointer<Double>? params)>('glMultiTexGendvEXT');
  return _glMultiTexGendvEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGenfEXT (GLenum texunit, GLenum coord, GLenum pname, GLfloat param)
/// ```
void glMultiTexGenfEXT(int texunit, int coord, int pname, double param) {
  final _glMultiTexGenfEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Float param),
      void Function(int texunit, int coord, int pname, double param)>('glMultiTexGenfEXT');
  return _glMultiTexGenfEXT(texunit, coord, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGenfvEXT (GLenum texunit, GLenum coord, GLenum pname, const GLfloat *params)
/// ```
void glMultiTexGenfvEXT(int texunit, int coord, int pname, Pointer<Float>? params) {
  final _glMultiTexGenfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int coord, int pname, Pointer<Float>? params)>('glMultiTexGenfvEXT');
  return _glMultiTexGenfvEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGeniEXT (GLenum texunit, GLenum coord, GLenum pname, GLint param)
/// ```
void glMultiTexGeniEXT(int texunit, int coord, int pname, int param) {
  final _glMultiTexGeniEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Int32 param),
      void Function(int texunit, int coord, int pname, int param)>('glMultiTexGeniEXT');
  return _glMultiTexGeniEXT(texunit, coord, pname, param);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexGenivEXT (GLenum texunit, GLenum coord, GLenum pname, const GLint *params)
/// ```
void glMultiTexGenivEXT(int texunit, int coord, int pname, Pointer<Int32>? params) {
  final _glMultiTexGenivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int coord, int pname, Pointer<Int32>? params)>('glMultiTexGenivEXT');
  return _glMultiTexGenivEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexEnvfvEXT (GLenum texunit, GLenum target, GLenum pname, GLfloat *params)
/// ```
void glGetMultiTexEnvfvEXT(int texunit, int target, int pname, Pointer<Float>? params) {
  final _glGetMultiTexEnvfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int target, int pname, Pointer<Float>? params)>('glGetMultiTexEnvfvEXT');
  return _glGetMultiTexEnvfvEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexEnvivEXT (GLenum texunit, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMultiTexEnvivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glGetMultiTexEnvivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glGetMultiTexEnvivEXT');
  return _glGetMultiTexEnvivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexGendvEXT (GLenum texunit, GLenum coord, GLenum pname, GLdouble *params)
/// ```
void glGetMultiTexGendvEXT(int texunit, int coord, int pname, Pointer<Double>? params) {
  final _glGetMultiTexGendvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Double>? params),
      void Function(int texunit, int coord, int pname, Pointer<Double>? params)>('glGetMultiTexGendvEXT');
  return _glGetMultiTexGendvEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexGenfvEXT (GLenum texunit, GLenum coord, GLenum pname, GLfloat *params)
/// ```
void glGetMultiTexGenfvEXT(int texunit, int coord, int pname, Pointer<Float>? params) {
  final _glGetMultiTexGenfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Float>? params),
      void Function(int texunit, int coord, int pname, Pointer<Float>? params)>('glGetMultiTexGenfvEXT');
  return _glGetMultiTexGenfvEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexGenivEXT (GLenum texunit, GLenum coord, GLenum pname, GLint *params)
/// ```
void glGetMultiTexGenivEXT(int texunit, int coord, int pname, Pointer<Int32>? params) {
  final _glGetMultiTexGenivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 coord, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int coord, int pname, Pointer<Int32>? params)>('glGetMultiTexGenivEXT');
  return _glGetMultiTexGenivEXT(texunit, coord, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetFloatIndexedvEXT (GLenum target, GLuint index, GLfloat *data)
/// ```
void glGetFloatIndexedvEXT(int target, int index, Pointer<Float>? data) {
  final _glGetFloatIndexedvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Float>? data),
      void Function(int target, int index, Pointer<Float>? data)>('glGetFloatIndexedvEXT');
  return _glGetFloatIndexedvEXT(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetDoubleIndexedvEXT (GLenum target, GLuint index, GLdouble *data)
/// ```
void glGetDoubleIndexedvEXT(int target, int index, Pointer<Double>? data) {
  final _glGetDoubleIndexedvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Double>? data),
      void Function(int target, int index, Pointer<Double>? data)>('glGetDoubleIndexedvEXT');
  return _glGetDoubleIndexedvEXT(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glGetPointerIndexedvEXT (GLenum target, GLuint index, GLvoid* *data)
/// ```
void glGetPointerIndexedvEXT(int target, int index, Pointer<Pointer<Void>>? data) {
  final _glGetPointerIndexedvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Pointer<Void>>? data),
      void Function(int target, int index, Pointer<Pointer<Void>>? data)>('glGetPointerIndexedvEXT');
  return _glGetPointerIndexedvEXT(target, index, data);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureImage3DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureImage3DEXT(int texture, int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? bits)>('glCompressedTextureImage3DEXT');
  return _glCompressedTextureImage3DEXT(texture, target, level, internalformat, width, height, depth, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureImage2DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureImage2DEXT(int texture, int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? bits)>('glCompressedTextureImage2DEXT');
  return _glCompressedTextureImage2DEXT(texture, target, level, internalformat, width, height, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureImage1DEXT (GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureImage1DEXT(int texture, int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? bits)>('glCompressedTextureImage1DEXT');
  return _glCompressedTextureImage1DEXT(texture, target, level, internalformat, width, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureSubImage3DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureSubImage3DEXT(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? bits)>('glCompressedTextureSubImage3DEXT');
  return _glCompressedTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureSubImage2DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureSubImage2DEXT(int texture, int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? bits)>('glCompressedTextureSubImage2DEXT');
  return _glCompressedTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedTextureSubImage1DEXT (GLuint texture, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedTextureSubImage1DEXT(int texture, int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedTextureSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texture, int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? bits)>('glCompressedTextureSubImage1DEXT');
  return _glCompressedTextureSubImage1DEXT(texture, target, level, xoffset, width, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glGetCompressedTextureImageEXT (GLuint texture, GLenum target, GLint lod, GLvoid *img)
/// ```
void glGetCompressedTextureImageEXT(int texture, int target, int lod, Pointer<Void>? img) {
  final _glGetCompressedTextureImageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Int32 lod, Pointer<Void>? img),
      void Function(int texture, int target, int lod, Pointer<Void>? img)>('glGetCompressedTextureImageEXT');
  return _glGetCompressedTextureImageEXT(texture, target, lod, img);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexImage3DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexImage3DEXT(int texunit, int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Uint32 depth, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int internalformat, int width, int height, int depth, int border, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexImage3DEXT');
  return _glCompressedMultiTexImage3DEXT(texunit, target, level, internalformat, width, height, depth, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexImage2DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexImage2DEXT(int texunit, int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Uint32 height, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int internalformat, int width, int height, int border, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexImage2DEXT');
  return _glCompressedMultiTexImage2DEXT(texunit, target, level, internalformat, width, height, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexImage1DEXT (GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexImage1DEXT(int texunit, int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Uint32 internalformat, Uint32 width, Int32 border, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int internalformat, int width, int border, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexImage1DEXT');
  return _glCompressedMultiTexImage1DEXT(texunit, target, level, internalformat, width, border, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexSubImage3DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexSubImage3DEXT(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexSubImage3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Int32 zoffset, Uint32 width, Uint32 height, Uint32 depth, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int zoffset, int width, int height, int depth, int format, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexSubImage3DEXT');
  return _glCompressedMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexSubImage2DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexSubImage2DEXT(int texunit, int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexSubImage2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Int32 yoffset, Uint32 width, Uint32 height, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int xoffset, int yoffset, int width, int height, int format, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexSubImage2DEXT');
  return _glCompressedMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glCompressedMultiTexSubImage1DEXT (GLenum texunit, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *bits)
/// ```
void glCompressedMultiTexSubImage1DEXT(int texunit, int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? bits) {
  final _glCompressedMultiTexSubImage1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 level, Int32 xoffset, Uint32 width, Uint32 format, Uint32 imageSize, Pointer<Void>? bits),
      void Function(int texunit, int target, int level, int xoffset, int width, int format, int imageSize, Pointer<Void>? bits)>('glCompressedMultiTexSubImage1DEXT');
  return _glCompressedMultiTexSubImage1DEXT(texunit, target, level, xoffset, width, format, imageSize, bits);
}

/// ```c
/// GLAPI void APIENTRY glGetCompressedMultiTexImageEXT (GLenum texunit, GLenum target, GLint lod, GLvoid *img)
/// ```
void glGetCompressedMultiTexImageEXT(int texunit, int target, int lod, Pointer<Void>? img) {
  final _glGetCompressedMultiTexImageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Int32 lod, Pointer<Void>? img),
      void Function(int texunit, int target, int lod, Pointer<Void>? img)>('glGetCompressedMultiTexImageEXT');
  return _glGetCompressedMultiTexImageEXT(texunit, target, lod, img);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramStringEXT (GLuint program, GLenum target, GLenum format, GLsizei len, const GLvoid *string)
/// ```
void glNamedProgramStringEXT(int program, int target, int format, int len, Pointer<Void>? string) {
  final _glNamedProgramStringEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 format, Uint32 len, Pointer<Void>? string),
      void Function(int program, int target, int format, int len, Pointer<Void>? string)>('glNamedProgramStringEXT');
  return _glNamedProgramStringEXT(program, target, format, len, string);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameter4dEXT (GLuint program, GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glNamedProgramLocalParameter4dEXT(int program, int target, int index, double x, double y, double z, double w) {
  final _glNamedProgramLocalParameter4dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int program, int target, int index, double x, double y, double z, double w)>('glNamedProgramLocalParameter4dEXT');
  return _glNamedProgramLocalParameter4dEXT(program, target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameter4dvEXT (GLuint program, GLenum target, GLuint index, const GLdouble *params)
/// ```
void glNamedProgramLocalParameter4dvEXT(int program, int target, int index, Pointer<Double>? params) {
  final _glNamedProgramLocalParameter4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int program, int target, int index, Pointer<Double>? params)>('glNamedProgramLocalParameter4dvEXT');
  return _glNamedProgramLocalParameter4dvEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameter4fEXT (GLuint program, GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
/// ```
void glNamedProgramLocalParameter4fEXT(int program, int target, int index, double x, double y, double z, double w) {
  final _glNamedProgramLocalParameter4fEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Float x, Float y, Float z, Float w),
      void Function(int program, int target, int index, double x, double y, double z, double w)>('glNamedProgramLocalParameter4fEXT');
  return _glNamedProgramLocalParameter4fEXT(program, target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameter4fvEXT (GLuint program, GLenum target, GLuint index, const GLfloat *params)
/// ```
void glNamedProgramLocalParameter4fvEXT(int program, int target, int index, Pointer<Float>? params) {
  final _glNamedProgramLocalParameter4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int program, int target, int index, Pointer<Float>? params)>('glNamedProgramLocalParameter4fvEXT');
  return _glNamedProgramLocalParameter4fvEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramLocalParameterdvEXT (GLuint program, GLenum target, GLuint index, GLdouble *params)
/// ```
void glGetNamedProgramLocalParameterdvEXT(int program, int target, int index, Pointer<Double>? params) {
  final _glGetNamedProgramLocalParameterdvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Double>? params),
      void Function(int program, int target, int index, Pointer<Double>? params)>('glGetNamedProgramLocalParameterdvEXT');
  return _glGetNamedProgramLocalParameterdvEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramLocalParameterfvEXT (GLuint program, GLenum target, GLuint index, GLfloat *params)
/// ```
void glGetNamedProgramLocalParameterfvEXT(int program, int target, int index, Pointer<Float>? params) {
  final _glGetNamedProgramLocalParameterfvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Float>? params),
      void Function(int program, int target, int index, Pointer<Float>? params)>('glGetNamedProgramLocalParameterfvEXT');
  return _glGetNamedProgramLocalParameterfvEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramivEXT (GLuint program, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetNamedProgramivEXT(int program, int target, int pname, Pointer<Int32>? params) {
  final _glGetNamedProgramivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int program, int target, int pname, Pointer<Int32>? params)>('glGetNamedProgramivEXT');
  return _glGetNamedProgramivEXT(program, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramStringEXT (GLuint program, GLenum target, GLenum pname, GLvoid *string)
/// ```
void glGetNamedProgramStringEXT(int program, int target, int pname, Pointer<Void>? string) {
  final _glGetNamedProgramStringEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 pname, Pointer<Void>? string),
      void Function(int program, int target, int pname, Pointer<Void>? string)>('glGetNamedProgramStringEXT');
  return _glGetNamedProgramStringEXT(program, target, pname, string);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameters4fvEXT (GLuint program, GLenum target, GLuint index, GLsizei count, const GLfloat *params)
/// ```
void glNamedProgramLocalParameters4fvEXT(int program, int target, int index, int count, Pointer<Float>? params) {
  final _glNamedProgramLocalParameters4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Uint32 count, Pointer<Float>? params),
      void Function(int program, int target, int index, int count, Pointer<Float>? params)>('glNamedProgramLocalParameters4fvEXT');
  return _glNamedProgramLocalParameters4fvEXT(program, target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameterI4iEXT (GLuint program, GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
/// ```
void glNamedProgramLocalParameterI4iEXT(int program, int target, int index, int x, int y, int z, int w) {
  final _glNamedProgramLocalParameterI4iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Int32 x, Int32 y, Int32 z, Int32 w),
      void Function(int program, int target, int index, int x, int y, int z, int w)>('glNamedProgramLocalParameterI4iEXT');
  return _glNamedProgramLocalParameterI4iEXT(program, target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameterI4ivEXT (GLuint program, GLenum target, GLuint index, const GLint *params)
/// ```
void glNamedProgramLocalParameterI4ivEXT(int program, int target, int index, Pointer<Int32>? params) {
  final _glNamedProgramLocalParameterI4ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int program, int target, int index, Pointer<Int32>? params)>('glNamedProgramLocalParameterI4ivEXT');
  return _glNamedProgramLocalParameterI4ivEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParametersI4ivEXT (GLuint program, GLenum target, GLuint index, GLsizei count, const GLint *params)
/// ```
void glNamedProgramLocalParametersI4ivEXT(int program, int target, int index, int count, Pointer<Int32>? params) {
  final _glNamedProgramLocalParametersI4ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Uint32 count, Pointer<Int32>? params),
      void Function(int program, int target, int index, int count, Pointer<Int32>? params)>('glNamedProgramLocalParametersI4ivEXT');
  return _glNamedProgramLocalParametersI4ivEXT(program, target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameterI4uiEXT (GLuint program, GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
/// ```
void glNamedProgramLocalParameterI4uiEXT(int program, int target, int index, int x, int y, int z, int w) {
  final _glNamedProgramLocalParameterI4uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Uint32 x, Uint32 y, Uint32 z, Uint32 w),
      void Function(int program, int target, int index, int x, int y, int z, int w)>('glNamedProgramLocalParameterI4uiEXT');
  return _glNamedProgramLocalParameterI4uiEXT(program, target, index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParameterI4uivEXT (GLuint program, GLenum target, GLuint index, const GLuint *params)
/// ```
void glNamedProgramLocalParameterI4uivEXT(int program, int target, int index, Pointer<Uint32>? params) {
  final _glNamedProgramLocalParameterI4uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int program, int target, int index, Pointer<Uint32>? params)>('glNamedProgramLocalParameterI4uivEXT');
  return _glNamedProgramLocalParameterI4uivEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedProgramLocalParametersI4uivEXT (GLuint program, GLenum target, GLuint index, GLsizei count, const GLuint *params)
/// ```
void glNamedProgramLocalParametersI4uivEXT(int program, int target, int index, int count, Pointer<Uint32>? params) {
  final _glNamedProgramLocalParametersI4uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Uint32 count, Pointer<Uint32>? params),
      void Function(int program, int target, int index, int count, Pointer<Uint32>? params)>('glNamedProgramLocalParametersI4uivEXT');
  return _glNamedProgramLocalParametersI4uivEXT(program, target, index, count, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramLocalParameterIivEXT (GLuint program, GLenum target, GLuint index, GLint *params)
/// ```
void glGetNamedProgramLocalParameterIivEXT(int program, int target, int index, Pointer<Int32>? params) {
  final _glGetNamedProgramLocalParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Int32>? params),
      void Function(int program, int target, int index, Pointer<Int32>? params)>('glGetNamedProgramLocalParameterIivEXT');
  return _glGetNamedProgramLocalParameterIivEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedProgramLocalParameterIuivEXT (GLuint program, GLenum target, GLuint index, GLuint *params)
/// ```
void glGetNamedProgramLocalParameterIuivEXT(int program, int target, int index, Pointer<Uint32>? params) {
  final _glGetNamedProgramLocalParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Uint32 target, Uint32 index, Pointer<Uint32>? params),
      void Function(int program, int target, int index, Pointer<Uint32>? params)>('glGetNamedProgramLocalParameterIuivEXT');
  return _glGetNamedProgramLocalParameterIuivEXT(program, target, index, params);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameterIivEXT (GLuint texture, GLenum target, GLenum pname, const GLint *params)
/// ```
void glTextureParameterIivEXT(int texture, int target, int pname, Pointer<Int32>? params) {
  final _glTextureParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texture, int target, int pname, Pointer<Int32>? params)>('glTextureParameterIivEXT');
  return _glTextureParameterIivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glTextureParameterIuivEXT (GLuint texture, GLenum target, GLenum pname, const GLuint *params)
/// ```
void glTextureParameterIuivEXT(int texture, int target, int pname, Pointer<Uint32>? params) {
  final _glTextureParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int texture, int target, int pname, Pointer<Uint32>? params)>('glTextureParameterIuivEXT');
  return _glTextureParameterIuivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureParameterIivEXT (GLuint texture, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetTextureParameterIivEXT(int texture, int target, int pname, Pointer<Int32>? params) {
  final _glGetTextureParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texture, int target, int pname, Pointer<Int32>? params)>('glGetTextureParameterIivEXT');
  return _glGetTextureParameterIivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetTextureParameterIuivEXT (GLuint texture, GLenum target, GLenum pname, GLuint *params)
/// ```
void glGetTextureParameterIuivEXT(int texture, int target, int pname, Pointer<Uint32>? params) {
  final _glGetTextureParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int texture, int target, int pname, Pointer<Uint32>? params)>('glGetTextureParameterIuivEXT');
  return _glGetTextureParameterIuivEXT(texture, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameterIivEXT (GLenum texunit, GLenum target, GLenum pname, const GLint *params)
/// ```
void glMultiTexParameterIivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glMultiTexParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glMultiTexParameterIivEXT');
  return _glMultiTexParameterIivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexParameterIuivEXT (GLenum texunit, GLenum target, GLenum pname, const GLuint *params)
/// ```
void glMultiTexParameterIuivEXT(int texunit, int target, int pname, Pointer<Uint32>? params) {
  final _glMultiTexParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int texunit, int target, int pname, Pointer<Uint32>? params)>('glMultiTexParameterIuivEXT');
  return _glMultiTexParameterIuivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexParameterIivEXT (GLenum texunit, GLenum target, GLenum pname, GLint *params)
/// ```
void glGetMultiTexParameterIivEXT(int texunit, int target, int pname, Pointer<Int32>? params) {
  final _glGetMultiTexParameterIivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Int32>? params),
      void Function(int texunit, int target, int pname, Pointer<Int32>? params)>('glGetMultiTexParameterIivEXT');
  return _glGetMultiTexParameterIivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetMultiTexParameterIuivEXT (GLenum texunit, GLenum target, GLenum pname, GLuint *params)
/// ```
void glGetMultiTexParameterIuivEXT(int texunit, int target, int pname, Pointer<Uint32>? params) {
  final _glGetMultiTexParameterIuivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 pname, Pointer<Uint32>? params),
      void Function(int texunit, int target, int pname, Pointer<Uint32>? params)>('glGetMultiTexParameterIuivEXT');
  return _glGetMultiTexParameterIuivEXT(texunit, target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1fEXT (GLuint program, GLint location, GLfloat v0)
/// ```
void glProgramUniform1fEXT(int program, int location, double v0) {
  final _glProgramUniform1fEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0),
      void Function(int program, int location, double v0)>('glProgramUniform1fEXT');
  return _glProgramUniform1fEXT(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2fEXT (GLuint program, GLint location, GLfloat v0, GLfloat v1)
/// ```
void glProgramUniform2fEXT(int program, int location, double v0, double v1) {
  final _glProgramUniform2fEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1),
      void Function(int program, int location, double v0, double v1)>('glProgramUniform2fEXT');
  return _glProgramUniform2fEXT(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3fEXT (GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
/// ```
void glProgramUniform3fEXT(int program, int location, double v0, double v1, double v2) {
  final _glProgramUniform3fEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1, Float v2),
      void Function(int program, int location, double v0, double v1, double v2)>('glProgramUniform3fEXT');
  return _glProgramUniform3fEXT(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4fEXT (GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
/// ```
void glProgramUniform4fEXT(int program, int location, double v0, double v1, double v2, double v3) {
  final _glProgramUniform4fEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Float v0, Float v1, Float v2, Float v3),
      void Function(int program, int location, double v0, double v1, double v2, double v3)>('glProgramUniform4fEXT');
  return _glProgramUniform4fEXT(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1iEXT (GLuint program, GLint location, GLint v0)
/// ```
void glProgramUniform1iEXT(int program, int location, int v0) {
  final _glProgramUniform1iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0),
      void Function(int program, int location, int v0)>('glProgramUniform1iEXT');
  return _glProgramUniform1iEXT(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2iEXT (GLuint program, GLint location, GLint v0, GLint v1)
/// ```
void glProgramUniform2iEXT(int program, int location, int v0, int v1) {
  final _glProgramUniform2iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1),
      void Function(int program, int location, int v0, int v1)>('glProgramUniform2iEXT');
  return _glProgramUniform2iEXT(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3iEXT (GLuint program, GLint location, GLint v0, GLint v1, GLint v2)
/// ```
void glProgramUniform3iEXT(int program, int location, int v0, int v1, int v2) {
  final _glProgramUniform3iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2),
      void Function(int program, int location, int v0, int v1, int v2)>('glProgramUniform3iEXT');
  return _glProgramUniform3iEXT(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4iEXT (GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
/// ```
void glProgramUniform4iEXT(int program, int location, int v0, int v1, int v2, int v3) {
  final _glProgramUniform4iEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int32 v0, Int32 v1, Int32 v2, Int32 v3),
      void Function(int program, int location, int v0, int v1, int v2, int v3)>('glProgramUniform4iEXT');
  return _glProgramUniform4iEXT(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1fvEXT (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform1fvEXT(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform1fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform1fvEXT');
  return _glProgramUniform1fvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2fvEXT (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform2fvEXT(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform2fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform2fvEXT');
  return _glProgramUniform2fvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3fvEXT (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform3fvEXT(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform3fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform3fvEXT');
  return _glProgramUniform3fvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4fvEXT (GLuint program, GLint location, GLsizei count, const GLfloat *value)
/// ```
void glProgramUniform4fvEXT(int program, int location, int count, Pointer<Float>? value) {
  final _glProgramUniform4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Float>? value),
      void Function(int program, int location, int count, Pointer<Float>? value)>('glProgramUniform4fvEXT');
  return _glProgramUniform4fvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1ivEXT (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform1ivEXT(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform1ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform1ivEXT');
  return _glProgramUniform1ivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2ivEXT (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform2ivEXT(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform2ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform2ivEXT');
  return _glProgramUniform2ivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3ivEXT (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform3ivEXT(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform3ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform3ivEXT');
  return _glProgramUniform3ivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4ivEXT (GLuint program, GLint location, GLsizei count, const GLint *value)
/// ```
void glProgramUniform4ivEXT(int program, int location, int count, Pointer<Int32>? value) {
  final _glProgramUniform4ivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int32>? value),
      void Function(int program, int location, int count, Pointer<Int32>? value)>('glProgramUniform4ivEXT');
  return _glProgramUniform4ivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2fvEXT');
  return _glProgramUniformMatrix2fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3fvEXT');
  return _glProgramUniformMatrix3fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4fvEXT');
  return _glProgramUniformMatrix4fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x3fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2x3fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2x3fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2x3fvEXT');
  return _glProgramUniformMatrix2x3fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x2fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3x2fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3x2fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3x2fvEXT');
  return _glProgramUniformMatrix3x2fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x4fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix2x4fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix2x4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix2x4fvEXT');
  return _glProgramUniformMatrix2x4fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x2fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4x2fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4x2fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4x2fvEXT');
  return _glProgramUniformMatrix4x2fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x4fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix3x4fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix3x4fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix3x4fvEXT');
  return _glProgramUniformMatrix3x4fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x3fvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
/// ```
void glProgramUniformMatrix4x3fvEXT(int program, int location, int count, int transpose, Pointer<Float>? value) {
  final _glProgramUniformMatrix4x3fvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Float>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Float>? value)>('glProgramUniformMatrix4x3fvEXT');
  return _glProgramUniformMatrix4x3fvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1uiEXT (GLuint program, GLint location, GLuint v0)
/// ```
void glProgramUniform1uiEXT(int program, int location, int v0) {
  final _glProgramUniform1uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0),
      void Function(int program, int location, int v0)>('glProgramUniform1uiEXT');
  return _glProgramUniform1uiEXT(program, location, v0);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2uiEXT (GLuint program, GLint location, GLuint v0, GLuint v1)
/// ```
void glProgramUniform2uiEXT(int program, int location, int v0, int v1) {
  final _glProgramUniform2uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1),
      void Function(int program, int location, int v0, int v1)>('glProgramUniform2uiEXT');
  return _glProgramUniform2uiEXT(program, location, v0, v1);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3uiEXT (GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2)
/// ```
void glProgramUniform3uiEXT(int program, int location, int v0, int v1, int v2) {
  final _glProgramUniform3uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1, Uint32 v2),
      void Function(int program, int location, int v0, int v1, int v2)>('glProgramUniform3uiEXT');
  return _glProgramUniform3uiEXT(program, location, v0, v1, v2);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4uiEXT (GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
/// ```
void glProgramUniform4uiEXT(int program, int location, int v0, int v1, int v2, int v3) {
  final _glProgramUniform4uiEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 v0, Uint32 v1, Uint32 v2, Uint32 v3),
      void Function(int program, int location, int v0, int v1, int v2, int v3)>('glProgramUniform4uiEXT');
  return _glProgramUniform4uiEXT(program, location, v0, v1, v2, v3);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1uivEXT (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform1uivEXT(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform1uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform1uivEXT');
  return _glProgramUniform1uivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2uivEXT (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform2uivEXT(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform2uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform2uivEXT');
  return _glProgramUniform2uivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3uivEXT (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform3uivEXT(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform3uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform3uivEXT');
  return _glProgramUniform3uivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4uivEXT (GLuint program, GLint location, GLsizei count, const GLuint *value)
/// ```
void glProgramUniform4uivEXT(int program, int location, int count, Pointer<Uint32>? value) {
  final _glProgramUniform4uivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint32>? value),
      void Function(int program, int location, int count, Pointer<Uint32>? value)>('glProgramUniform4uivEXT');
  return _glProgramUniform4uivEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glNamedBufferDataEXT (GLuint buffer, GLsizeiptr size, const GLvoid *data, GLenum usage)
/// ```
void glNamedBufferDataEXT(int buffer, Pointer<Void>? size, Pointer<Void>? data, int usage) {
  final _glNamedBufferDataEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Pointer<Void>? size, Pointer<Void>? data, Uint32 usage),
      void Function(int buffer, Pointer<Void>? size, Pointer<Void>? data, int usage)>('glNamedBufferDataEXT');
  return _glNamedBufferDataEXT(buffer, size, data, usage);
}

/// ```c
/// GLAPI void APIENTRY glNamedBufferSubDataEXT (GLuint buffer, GLintptr offset, GLsizeiptr size, const GLvoid *data)
/// ```
void glNamedBufferSubDataEXT(int buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data) {
  final _glNamedBufferSubDataEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data),
      void Function(int buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data)>('glNamedBufferSubDataEXT');
  return _glNamedBufferSubDataEXT(buffer, offset, size, data);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapNamedBufferEXT (GLuint buffer, GLenum access)
/// ```
Pointer<Void>? glMapNamedBufferEXT(int buffer, int access) {
  final _glMapNamedBufferEXT = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 buffer, Uint32 access),
      Pointer<Void>? Function(int buffer, int access)>('glMapNamedBufferEXT');
  return _glMapNamedBufferEXT(buffer, access);
}

/// ```c
/// GLAPI GLboolean APIENTRY glUnmapNamedBufferEXT (GLuint buffer)
/// ```
int glUnmapNamedBufferEXT(int buffer) {
  final _glUnmapNamedBufferEXT = _SDL2.lookupFunction<
      Int32 Function(Uint32 buffer),
      int Function(int buffer)>('glUnmapNamedBufferEXT');
  return _glUnmapNamedBufferEXT(buffer);
}

/// ```c
/// GLAPI GLvoid* APIENTRY glMapNamedBufferRangeEXT (GLuint buffer, GLintptr offset, GLsizeiptr length, GLbitfield access)
/// ```
Pointer<Void>? glMapNamedBufferRangeEXT(int buffer, Pointer<Void>? offset, Pointer<Void>? length, int access) {
  final _glMapNamedBufferRangeEXT = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? length, Uint32 access),
      Pointer<Void>? Function(int buffer, Pointer<Void>? offset, Pointer<Void>? length, int access)>('glMapNamedBufferRangeEXT');
  return _glMapNamedBufferRangeEXT(buffer, offset, length, access);
}

/// ```c
/// GLAPI void APIENTRY glFlushMappedNamedBufferRangeEXT (GLuint buffer, GLintptr offset, GLsizeiptr length)
/// ```
void glFlushMappedNamedBufferRangeEXT(int buffer, Pointer<Void>? offset, Pointer<Void>? length) {
  final _glFlushMappedNamedBufferRangeEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? length),
      void Function(int buffer, Pointer<Void>? offset, Pointer<Void>? length)>('glFlushMappedNamedBufferRangeEXT');
  return _glFlushMappedNamedBufferRangeEXT(buffer, offset, length);
}

/// ```c
/// GLAPI void APIENTRY glNamedCopyBufferSubDataEXT (GLuint readBuffer, GLuint writeBuffer, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size)
/// ```
void glNamedCopyBufferSubDataEXT(int readBuffer, int writeBuffer, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size) {
  final _glNamedCopyBufferSubDataEXT = _SDL2.lookupFunction<
      Void Function(Uint32 readBuffer, Uint32 writeBuffer, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size),
      void Function(int readBuffer, int writeBuffer, Pointer<Void>? readOffset, Pointer<Void>? writeOffset, Pointer<Void>? size)>('glNamedCopyBufferSubDataEXT');
  return _glNamedCopyBufferSubDataEXT(readBuffer, writeBuffer, readOffset, writeOffset, size);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedBufferParameterivEXT (GLuint buffer, GLenum pname, GLint *params)
/// ```
void glGetNamedBufferParameterivEXT(int buffer, int pname, Pointer<Int32>? params) {
  final _glGetNamedBufferParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 pname, Pointer<Int32>? params),
      void Function(int buffer, int pname, Pointer<Int32>? params)>('glGetNamedBufferParameterivEXT');
  return _glGetNamedBufferParameterivEXT(buffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedBufferPointervEXT (GLuint buffer, GLenum pname, GLvoid* *params)
/// ```
void glGetNamedBufferPointervEXT(int buffer, int pname, Pointer<Pointer<Void>>? params) {
  final _glGetNamedBufferPointervEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 pname, Pointer<Pointer<Void>>? params),
      void Function(int buffer, int pname, Pointer<Pointer<Void>>? params)>('glGetNamedBufferPointervEXT');
  return _glGetNamedBufferPointervEXT(buffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedBufferSubDataEXT (GLuint buffer, GLintptr offset, GLsizeiptr size, GLvoid *data)
/// ```
void glGetNamedBufferSubDataEXT(int buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data) {
  final _glGetNamedBufferSubDataEXT = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data),
      void Function(int buffer, Pointer<Void>? offset, Pointer<Void>? size, Pointer<Void>? data)>('glGetNamedBufferSubDataEXT');
  return _glGetNamedBufferSubDataEXT(buffer, offset, size, data);
}

/// ```c
/// GLAPI void APIENTRY glTextureBufferEXT (GLuint texture, GLenum target, GLenum internalformat, GLuint buffer)
/// ```
void glTextureBufferEXT(int texture, int target, int internalformat, int buffer) {
  final _glTextureBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 internalformat, Uint32 buffer),
      void Function(int texture, int target, int internalformat, int buffer)>('glTextureBufferEXT');
  return _glTextureBufferEXT(texture, target, internalformat, buffer);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexBufferEXT (GLenum texunit, GLenum target, GLenum internalformat, GLuint buffer)
/// ```
void glMultiTexBufferEXT(int texunit, int target, int internalformat, int buffer) {
  final _glMultiTexBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 internalformat, Uint32 buffer),
      void Function(int texunit, int target, int internalformat, int buffer)>('glMultiTexBufferEXT');
  return _glMultiTexBufferEXT(texunit, target, internalformat, buffer);
}

/// ```c
/// GLAPI void APIENTRY glNamedRenderbufferStorageEXT (GLuint renderbuffer, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glNamedRenderbufferStorageEXT(int renderbuffer, int internalformat, int width, int height) {
  final _glNamedRenderbufferStorageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 renderbuffer, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int renderbuffer, int internalformat, int width, int height)>('glNamedRenderbufferStorageEXT');
  return _glNamedRenderbufferStorageEXT(renderbuffer, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedRenderbufferParameterivEXT (GLuint renderbuffer, GLenum pname, GLint *params)
/// ```
void glGetNamedRenderbufferParameterivEXT(int renderbuffer, int pname, Pointer<Int32>? params) {
  final _glGetNamedRenderbufferParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 renderbuffer, Uint32 pname, Pointer<Int32>? params),
      void Function(int renderbuffer, int pname, Pointer<Int32>? params)>('glGetNamedRenderbufferParameterivEXT');
  return _glGetNamedRenderbufferParameterivEXT(renderbuffer, pname, params);
}

/// ```c
/// GLAPI GLenum APIENTRY glCheckNamedFramebufferStatusEXT (GLuint framebuffer, GLenum target)
/// ```
int glCheckNamedFramebufferStatusEXT(int framebuffer, int target) {
  final _glCheckNamedFramebufferStatusEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 framebuffer, Uint32 target),
      int Function(int framebuffer, int target)>('glCheckNamedFramebufferStatusEXT');
  return _glCheckNamedFramebufferStatusEXT(framebuffer, target);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTexture1DEXT (GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glNamedFramebufferTexture1DEXT(int framebuffer, int attachment, int textarget, int texture, int level) {
  final _glNamedFramebufferTexture1DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int framebuffer, int attachment, int textarget, int texture, int level)>('glNamedFramebufferTexture1DEXT');
  return _glNamedFramebufferTexture1DEXT(framebuffer, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTexture2DEXT (GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
/// ```
void glNamedFramebufferTexture2DEXT(int framebuffer, int attachment, int textarget, int texture, int level) {
  final _glNamedFramebufferTexture2DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level),
      void Function(int framebuffer, int attachment, int textarget, int texture, int level)>('glNamedFramebufferTexture2DEXT');
  return _glNamedFramebufferTexture2DEXT(framebuffer, attachment, textarget, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTexture3DEXT (GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
/// ```
void glNamedFramebufferTexture3DEXT(int framebuffer, int attachment, int textarget, int texture, int level, int zoffset) {
  final _glNamedFramebufferTexture3DEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 textarget, Uint32 texture, Int32 level, Int32 zoffset),
      void Function(int framebuffer, int attachment, int textarget, int texture, int level, int zoffset)>('glNamedFramebufferTexture3DEXT');
  return _glNamedFramebufferTexture3DEXT(framebuffer, attachment, textarget, texture, level, zoffset);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferRenderbufferEXT (GLuint framebuffer, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
/// ```
void glNamedFramebufferRenderbufferEXT(int framebuffer, int attachment, int renderbuffertarget, int renderbuffer) {
  final _glNamedFramebufferRenderbufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 renderbuffertarget, Uint32 renderbuffer),
      void Function(int framebuffer, int attachment, int renderbuffertarget, int renderbuffer)>('glNamedFramebufferRenderbufferEXT');
  return _glNamedFramebufferRenderbufferEXT(framebuffer, attachment, renderbuffertarget, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedFramebufferAttachmentParameterivEXT (GLuint framebuffer, GLenum attachment, GLenum pname, GLint *params)
/// ```
void glGetNamedFramebufferAttachmentParameterivEXT(int framebuffer, int attachment, int pname, Pointer<Int32>? params) {
  final _glGetNamedFramebufferAttachmentParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 pname, Pointer<Int32>? params),
      void Function(int framebuffer, int attachment, int pname, Pointer<Int32>? params)>('glGetNamedFramebufferAttachmentParameterivEXT');
  return _glGetNamedFramebufferAttachmentParameterivEXT(framebuffer, attachment, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGenerateTextureMipmapEXT (GLuint texture, GLenum target)
/// ```
void glGenerateTextureMipmapEXT(int texture, int target) {
  final _glGenerateTextureMipmapEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target),
      void Function(int texture, int target)>('glGenerateTextureMipmapEXT');
  return _glGenerateTextureMipmapEXT(texture, target);
}

/// ```c
/// GLAPI void APIENTRY glGenerateMultiTexMipmapEXT (GLenum texunit, GLenum target)
/// ```
void glGenerateMultiTexMipmapEXT(int texunit, int target) {
  final _glGenerateMultiTexMipmapEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target),
      void Function(int texunit, int target)>('glGenerateMultiTexMipmapEXT');
  return _glGenerateMultiTexMipmapEXT(texunit, target);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferDrawBufferEXT (GLuint framebuffer, GLenum mode)
/// ```
void glFramebufferDrawBufferEXT(int framebuffer, int mode) {
  final _glFramebufferDrawBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 mode),
      void Function(int framebuffer, int mode)>('glFramebufferDrawBufferEXT');
  return _glFramebufferDrawBufferEXT(framebuffer, mode);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferDrawBuffersEXT (GLuint framebuffer, GLsizei n, const GLenum *bufs)
/// ```
void glFramebufferDrawBuffersEXT(int framebuffer, int n, Pointer<Uint32>? bufs) {
  final _glFramebufferDrawBuffersEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 n, Pointer<Uint32>? bufs),
      void Function(int framebuffer, int n, Pointer<Uint32>? bufs)>('glFramebufferDrawBuffersEXT');
  return _glFramebufferDrawBuffersEXT(framebuffer, n, bufs);
}

/// ```c
/// GLAPI void APIENTRY glFramebufferReadBufferEXT (GLuint framebuffer, GLenum mode)
/// ```
void glFramebufferReadBufferEXT(int framebuffer, int mode) {
  final _glFramebufferReadBufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 mode),
      void Function(int framebuffer, int mode)>('glFramebufferReadBufferEXT');
  return _glFramebufferReadBufferEXT(framebuffer, mode);
}

/// ```c
/// GLAPI void APIENTRY glGetFramebufferParameterivEXT (GLuint framebuffer, GLenum pname, GLint *params)
/// ```
void glGetFramebufferParameterivEXT(int framebuffer, int pname, Pointer<Int32>? params) {
  final _glGetFramebufferParameterivEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 pname, Pointer<Int32>? params),
      void Function(int framebuffer, int pname, Pointer<Int32>? params)>('glGetFramebufferParameterivEXT');
  return _glGetFramebufferParameterivEXT(framebuffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glNamedRenderbufferStorageMultisampleEXT (GLuint renderbuffer, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glNamedRenderbufferStorageMultisampleEXT(int renderbuffer, int samples, int internalformat, int width, int height) {
  final _glNamedRenderbufferStorageMultisampleEXT = _SDL2.lookupFunction<
      Void Function(Uint32 renderbuffer, Uint32 samples, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int renderbuffer, int samples, int internalformat, int width, int height)>('glNamedRenderbufferStorageMultisampleEXT');
  return _glNamedRenderbufferStorageMultisampleEXT(renderbuffer, samples, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glNamedRenderbufferStorageMultisampleCoverageEXT (GLuint renderbuffer, GLsizei coverageSamples, GLsizei colorSamples, GLenum internalformat, GLsizei width, GLsizei height)
/// ```
void glNamedRenderbufferStorageMultisampleCoverageEXT(int renderbuffer, int coverageSamples, int colorSamples, int internalformat, int width, int height) {
  final _glNamedRenderbufferStorageMultisampleCoverageEXT = _SDL2.lookupFunction<
      Void Function(Uint32 renderbuffer, Uint32 coverageSamples, Uint32 colorSamples, Uint32 internalformat, Uint32 width, Uint32 height),
      void Function(int renderbuffer, int coverageSamples, int colorSamples, int internalformat, int width, int height)>('glNamedRenderbufferStorageMultisampleCoverageEXT');
  return _glNamedRenderbufferStorageMultisampleCoverageEXT(renderbuffer, coverageSamples, colorSamples, internalformat, width, height);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTextureEXT (GLuint framebuffer, GLenum attachment, GLuint texture, GLint level)
/// ```
void glNamedFramebufferTextureEXT(int framebuffer, int attachment, int texture, int level) {
  final _glNamedFramebufferTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 texture, Int32 level),
      void Function(int framebuffer, int attachment, int texture, int level)>('glNamedFramebufferTextureEXT');
  return _glNamedFramebufferTextureEXT(framebuffer, attachment, texture, level);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTextureLayerEXT (GLuint framebuffer, GLenum attachment, GLuint texture, GLint level, GLint layer)
/// ```
void glNamedFramebufferTextureLayerEXT(int framebuffer, int attachment, int texture, int level, int layer) {
  final _glNamedFramebufferTextureLayerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 texture, Int32 level, Int32 layer),
      void Function(int framebuffer, int attachment, int texture, int level, int layer)>('glNamedFramebufferTextureLayerEXT');
  return _glNamedFramebufferTextureLayerEXT(framebuffer, attachment, texture, level, layer);
}

/// ```c
/// GLAPI void APIENTRY glNamedFramebufferTextureFaceEXT (GLuint framebuffer, GLenum attachment, GLuint texture, GLint level, GLenum face)
/// ```
void glNamedFramebufferTextureFaceEXT(int framebuffer, int attachment, int texture, int level, int face) {
  final _glNamedFramebufferTextureFaceEXT = _SDL2.lookupFunction<
      Void Function(Uint32 framebuffer, Uint32 attachment, Uint32 texture, Int32 level, Uint32 face),
      void Function(int framebuffer, int attachment, int texture, int level, int face)>('glNamedFramebufferTextureFaceEXT');
  return _glNamedFramebufferTextureFaceEXT(framebuffer, attachment, texture, level, face);
}

/// ```c
/// GLAPI void APIENTRY glTextureRenderbufferEXT (GLuint texture, GLenum target, GLuint renderbuffer)
/// ```
void glTextureRenderbufferEXT(int texture, int target, int renderbuffer) {
  final _glTextureRenderbufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texture, Uint32 target, Uint32 renderbuffer),
      void Function(int texture, int target, int renderbuffer)>('glTextureRenderbufferEXT');
  return _glTextureRenderbufferEXT(texture, target, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glMultiTexRenderbufferEXT (GLenum texunit, GLenum target, GLuint renderbuffer)
/// ```
void glMultiTexRenderbufferEXT(int texunit, int target, int renderbuffer) {
  final _glMultiTexRenderbufferEXT = _SDL2.lookupFunction<
      Void Function(Uint32 texunit, Uint32 target, Uint32 renderbuffer),
      void Function(int texunit, int target, int renderbuffer)>('glMultiTexRenderbufferEXT');
  return _glMultiTexRenderbufferEXT(texunit, target, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1dEXT (GLuint program, GLint location, GLdouble x)
/// ```
void glProgramUniform1dEXT(int program, int location, double x) {
  final _glProgramUniform1dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double x),
      void Function(int program, int location, double x)>('glProgramUniform1dEXT');
  return _glProgramUniform1dEXT(program, location, x);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2dEXT (GLuint program, GLint location, GLdouble x, GLdouble y)
/// ```
void glProgramUniform2dEXT(int program, int location, double x, double y) {
  final _glProgramUniform2dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double x, Double y),
      void Function(int program, int location, double x, double y)>('glProgramUniform2dEXT');
  return _glProgramUniform2dEXT(program, location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3dEXT (GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glProgramUniform3dEXT(int program, int location, double x, double y, double z) {
  final _glProgramUniform3dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double x, Double y, Double z),
      void Function(int program, int location, double x, double y, double z)>('glProgramUniform3dEXT');
  return _glProgramUniform3dEXT(program, location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4dEXT (GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glProgramUniform4dEXT(int program, int location, double x, double y, double z, double w) {
  final _glProgramUniform4dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Double x, Double y, Double z, Double w),
      void Function(int program, int location, double x, double y, double z, double w)>('glProgramUniform4dEXT');
  return _glProgramUniform4dEXT(program, location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform1dvEXT(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform1dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform1dvEXT');
  return _glProgramUniform1dvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform2dvEXT(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform2dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform2dvEXT');
  return _glProgramUniform2dvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform3dvEXT(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform3dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform3dvEXT');
  return _glProgramUniform3dvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
/// ```
void glProgramUniform4dvEXT(int program, int location, int count, Pointer<Double>? value) {
  final _glProgramUniform4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Double>? value),
      void Function(int program, int location, int count, Pointer<Double>? value)>('glProgramUniform4dvEXT');
  return _glProgramUniform4dvEXT(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2dvEXT');
  return _glProgramUniformMatrix2dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3dvEXT');
  return _glProgramUniformMatrix3dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4dvEXT');
  return _glProgramUniformMatrix4dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2x3dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2x3dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2x3dvEXT');
  return _glProgramUniformMatrix2x3dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix2x4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix2x4dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix2x4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix2x4dvEXT');
  return _glProgramUniformMatrix2x4dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3x2dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3x2dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3x2dvEXT');
  return _glProgramUniformMatrix3x2dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix3x4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix3x4dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix3x4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix3x4dvEXT');
  return _glProgramUniformMatrix3x4dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4x2dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4x2dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4x2dvEXT');
  return _glProgramUniformMatrix4x2dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformMatrix4x3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
/// ```
void glProgramUniformMatrix4x3dvEXT(int program, int location, int count, int transpose, Pointer<Double>? value) {
  final _glProgramUniformMatrix4x3dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Int32 transpose, Pointer<Double>? value),
      void Function(int program, int location, int count, int transpose, Pointer<Double>? value)>('glProgramUniformMatrix4x3dvEXT');
  return _glProgramUniformMatrix4x3dvEXT(program, location, count, transpose, value);
}

/// ```c
/// GLAPI void APIENTRY glGetMultisamplefvNV (GLenum pname, GLuint index, GLfloat *val)
/// ```
void glGetMultisamplefvNV(int pname, int index, Pointer<Float>? val) {
  final _glGetMultisamplefvNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Uint32 index, Pointer<Float>? val),
      void Function(int pname, int index, Pointer<Float>? val)>('glGetMultisamplefvNV');
  return _glGetMultisamplefvNV(pname, index, val);
}

/// ```c
/// GLAPI void APIENTRY glSampleMaskIndexedNV (GLuint index, GLbitfield mask)
/// ```
void glSampleMaskIndexedNV(int index, int mask) {
  final _glSampleMaskIndexedNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 mask),
      void Function(int index, int mask)>('glSampleMaskIndexedNV');
  return _glSampleMaskIndexedNV(index, mask);
}

/// ```c
/// GLAPI void APIENTRY glTexRenderbufferNV (GLenum target, GLuint renderbuffer)
/// ```
void glTexRenderbufferNV(int target, int renderbuffer) {
  final _glTexRenderbufferNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 renderbuffer),
      void Function(int target, int renderbuffer)>('glTexRenderbufferNV');
  return _glTexRenderbufferNV(target, renderbuffer);
}

/// ```c
/// GLAPI void APIENTRY glBindTransformFeedbackNV (GLenum target, GLuint id)
/// ```
void glBindTransformFeedbackNV(int target, int id) {
  final _glBindTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 id),
      void Function(int target, int id)>('glBindTransformFeedbackNV');
  return _glBindTransformFeedbackNV(target, id);
}

/// ```c
/// GLAPI void APIENTRY glDeleteTransformFeedbacksNV (GLsizei n, const GLuint *ids)
/// ```
void glDeleteTransformFeedbacksNV(int n, Pointer<Uint32>? ids) {
  final _glDeleteTransformFeedbacksNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glDeleteTransformFeedbacksNV');
  return _glDeleteTransformFeedbacksNV(n, ids);
}

/// ```c
/// GLAPI void APIENTRY glGenTransformFeedbacksNV (GLsizei n, GLuint *ids)
/// ```
void glGenTransformFeedbacksNV(int n, Pointer<Uint32>? ids) {
  final _glGenTransformFeedbacksNV = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? ids),
      void Function(int n, Pointer<Uint32>? ids)>('glGenTransformFeedbacksNV');
  return _glGenTransformFeedbacksNV(n, ids);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsTransformFeedbackNV (GLuint id)
/// ```
int glIsTransformFeedbackNV(int id) {
  final _glIsTransformFeedbackNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 id),
      int Function(int id)>('glIsTransformFeedbackNV');
  return _glIsTransformFeedbackNV(id);
}

/// ```c
/// GLAPI void APIENTRY glPauseTransformFeedbackNV (void)
/// ```
void glPauseTransformFeedbackNV() {
  final _glPauseTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glPauseTransformFeedbackNV');
  return _glPauseTransformFeedbackNV();
}

/// ```c
/// GLAPI void APIENTRY glResumeTransformFeedbackNV (void)
/// ```
void glResumeTransformFeedbackNV() {
  final _glResumeTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glResumeTransformFeedbackNV');
  return _glResumeTransformFeedbackNV();
}

/// ```c
/// GLAPI void APIENTRY glDrawTransformFeedbackNV (GLenum mode, GLuint id)
/// ```
void glDrawTransformFeedbackNV(int mode, int id) {
  final _glDrawTransformFeedbackNV = _SDL2.lookupFunction<
      Void Function(Uint32 mode, Uint32 id),
      void Function(int mode, int id)>('glDrawTransformFeedbackNV');
  return _glDrawTransformFeedbackNV(mode, id);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorGroupsAMD (GLint *numGroups, GLsizei groupsSize, GLuint *groups)
/// ```
void glGetPerfMonitorGroupsAMD(Pointer<Int32>? numGroups, int groupsSize, Pointer<Uint32>? groups) {
  final _glGetPerfMonitorGroupsAMD = _SDL2.lookupFunction<
      Void Function(Pointer<Int32>? numGroups, Uint32 groupsSize, Pointer<Uint32>? groups),
      void Function(Pointer<Int32>? numGroups, int groupsSize, Pointer<Uint32>? groups)>('glGetPerfMonitorGroupsAMD');
  return _glGetPerfMonitorGroupsAMD(numGroups, groupsSize, groups);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorCountersAMD (GLuint group, GLint *numCounters, GLint *maxActiveCounters, GLsizei counterSize, GLuint *counters)
/// ```
void glGetPerfMonitorCountersAMD(int group, Pointer<Int32>? numCounters, Pointer<Int32>? maxActiveCounters, int counterSize, Pointer<Uint32>? counters) {
  final _glGetPerfMonitorCountersAMD = _SDL2.lookupFunction<
      Void Function(Uint32 group, Pointer<Int32>? numCounters, Pointer<Int32>? maxActiveCounters, Uint32 counterSize, Pointer<Uint32>? counters),
      void Function(int group, Pointer<Int32>? numCounters, Pointer<Int32>? maxActiveCounters, int counterSize, Pointer<Uint32>? counters)>('glGetPerfMonitorCountersAMD');
  return _glGetPerfMonitorCountersAMD(group, numCounters, maxActiveCounters, counterSize, counters);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorGroupStringAMD (GLuint group, GLsizei bufSize, GLsizei *length, GLchar *groupString)
/// ```
void glGetPerfMonitorGroupStringAMD(int group, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? groupString) {
  final _glGetPerfMonitorGroupStringAMD = _SDL2.lookupFunction<
      Void Function(Uint32 group, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? groupString),
      void Function(int group, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? groupString)>('glGetPerfMonitorGroupStringAMD');
  return _glGetPerfMonitorGroupStringAMD(group, bufSize, length, groupString);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorCounterStringAMD (GLuint group, GLuint counter, GLsizei bufSize, GLsizei *length, GLchar *counterString)
/// ```
void glGetPerfMonitorCounterStringAMD(int group, int counter, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? counterString) {
  final _glGetPerfMonitorCounterStringAMD = _SDL2.lookupFunction<
      Void Function(Uint32 group, Uint32 counter, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int8>? counterString),
      void Function(int group, int counter, int bufSize, Pointer<Uint32>? length, Pointer<Int8>? counterString)>('glGetPerfMonitorCounterStringAMD');
  return _glGetPerfMonitorCounterStringAMD(group, counter, bufSize, length, counterString);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorCounterInfoAMD (GLuint group, GLuint counter, GLenum pname, GLvoid *data)
/// ```
void glGetPerfMonitorCounterInfoAMD(int group, int counter, int pname, Pointer<Void>? data) {
  final _glGetPerfMonitorCounterInfoAMD = _SDL2.lookupFunction<
      Void Function(Uint32 group, Uint32 counter, Uint32 pname, Pointer<Void>? data),
      void Function(int group, int counter, int pname, Pointer<Void>? data)>('glGetPerfMonitorCounterInfoAMD');
  return _glGetPerfMonitorCounterInfoAMD(group, counter, pname, data);
}

/// ```c
/// GLAPI void APIENTRY glGenPerfMonitorsAMD (GLsizei n, GLuint *monitors)
/// ```
void glGenPerfMonitorsAMD(int n, Pointer<Uint32>? monitors) {
  final _glGenPerfMonitorsAMD = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? monitors),
      void Function(int n, Pointer<Uint32>? monitors)>('glGenPerfMonitorsAMD');
  return _glGenPerfMonitorsAMD(n, monitors);
}

/// ```c
/// GLAPI void APIENTRY glDeletePerfMonitorsAMD (GLsizei n, GLuint *monitors)
/// ```
void glDeletePerfMonitorsAMD(int n, Pointer<Uint32>? monitors) {
  final _glDeletePerfMonitorsAMD = _SDL2.lookupFunction<
      Void Function(Uint32 n, Pointer<Uint32>? monitors),
      void Function(int n, Pointer<Uint32>? monitors)>('glDeletePerfMonitorsAMD');
  return _glDeletePerfMonitorsAMD(n, monitors);
}

/// ```c
/// GLAPI void APIENTRY glSelectPerfMonitorCountersAMD (GLuint monitor, GLboolean enable, GLuint group, GLint numCounters, GLuint *counterList)
/// ```
void glSelectPerfMonitorCountersAMD(int monitor, int enable, int group, int numCounters, Pointer<Uint32>? counterList) {
  final _glSelectPerfMonitorCountersAMD = _SDL2.lookupFunction<
      Void Function(Uint32 monitor, Int32 enable, Uint32 group, Int32 numCounters, Pointer<Uint32>? counterList),
      void Function(int monitor, int enable, int group, int numCounters, Pointer<Uint32>? counterList)>('glSelectPerfMonitorCountersAMD');
  return _glSelectPerfMonitorCountersAMD(monitor, enable, group, numCounters, counterList);
}

/// ```c
/// GLAPI void APIENTRY glBeginPerfMonitorAMD (GLuint monitor)
/// ```
void glBeginPerfMonitorAMD(int monitor) {
  final _glBeginPerfMonitorAMD = _SDL2.lookupFunction<
      Void Function(Uint32 monitor),
      void Function(int monitor)>('glBeginPerfMonitorAMD');
  return _glBeginPerfMonitorAMD(monitor);
}

/// ```c
/// GLAPI void APIENTRY glEndPerfMonitorAMD (GLuint monitor)
/// ```
void glEndPerfMonitorAMD(int monitor) {
  final _glEndPerfMonitorAMD = _SDL2.lookupFunction<
      Void Function(Uint32 monitor),
      void Function(int monitor)>('glEndPerfMonitorAMD');
  return _glEndPerfMonitorAMD(monitor);
}

/// ```c
/// GLAPI void APIENTRY glGetPerfMonitorCounterDataAMD (GLuint monitor, GLenum pname, GLsizei dataSize, GLuint *data, GLint *bytesWritten)
/// ```
void glGetPerfMonitorCounterDataAMD(int monitor, int pname, int dataSize, Pointer<Uint32>? data, Pointer<Int32>? bytesWritten) {
  final _glGetPerfMonitorCounterDataAMD = _SDL2.lookupFunction<
      Void Function(Uint32 monitor, Uint32 pname, Uint32 dataSize, Pointer<Uint32>? data, Pointer<Int32>? bytesWritten),
      void Function(int monitor, int pname, int dataSize, Pointer<Uint32>? data, Pointer<Int32>? bytesWritten)>('glGetPerfMonitorCounterDataAMD');
  return _glGetPerfMonitorCounterDataAMD(monitor, pname, dataSize, data, bytesWritten);
}

/// ```c
/// GLAPI void APIENTRY glTessellationFactorAMD (GLfloat factor)
/// ```
void glTessellationFactorAMD(double factor) {
  final _glTessellationFactorAMD = _SDL2.lookupFunction<
      Void Function(Float factor),
      void Function(double factor)>('glTessellationFactorAMD');
  return _glTessellationFactorAMD(factor);
}

/// ```c
/// GLAPI void APIENTRY glTessellationModeAMD (GLenum mode)
/// ```
void glTessellationModeAMD(int mode) {
  final _glTessellationModeAMD = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glTessellationModeAMD');
  return _glTessellationModeAMD(mode);
}

/// ```c
/// GLAPI void APIENTRY glProvokingVertexEXT (GLenum mode)
/// ```
void glProvokingVertexEXT(int mode) {
  final _glProvokingVertexEXT = _SDL2.lookupFunction<
      Void Function(Uint32 mode),
      void Function(int mode)>('glProvokingVertexEXT');
  return _glProvokingVertexEXT(mode);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncIndexedAMD (GLuint buf, GLenum src, GLenum dst)
/// ```
void glBlendFuncIndexedAMD(int buf, int src, int dst) {
  final _glBlendFuncIndexedAMD = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 src, Uint32 dst),
      void Function(int buf, int src, int dst)>('glBlendFuncIndexedAMD');
  return _glBlendFuncIndexedAMD(buf, src, dst);
}

/// ```c
/// GLAPI void APIENTRY glBlendFuncSeparateIndexedAMD (GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
/// ```
void glBlendFuncSeparateIndexedAMD(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha) {
  final _glBlendFuncSeparateIndexedAMD = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 srcRGB, Uint32 dstRGB, Uint32 srcAlpha, Uint32 dstAlpha),
      void Function(int buf, int srcRGB, int dstRGB, int srcAlpha, int dstAlpha)>('glBlendFuncSeparateIndexedAMD');
  return _glBlendFuncSeparateIndexedAMD(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationIndexedAMD (GLuint buf, GLenum mode)
/// ```
void glBlendEquationIndexedAMD(int buf, int mode) {
  final _glBlendEquationIndexedAMD = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 mode),
      void Function(int buf, int mode)>('glBlendEquationIndexedAMD');
  return _glBlendEquationIndexedAMD(buf, mode);
}

/// ```c
/// GLAPI void APIENTRY glBlendEquationSeparateIndexedAMD (GLuint buf, GLenum modeRGB, GLenum modeAlpha)
/// ```
void glBlendEquationSeparateIndexedAMD(int buf, int modeRGB, int modeAlpha) {
  final _glBlendEquationSeparateIndexedAMD = _SDL2.lookupFunction<
      Void Function(Uint32 buf, Uint32 modeRGB, Uint32 modeAlpha),
      void Function(int buf, int modeRGB, int modeAlpha)>('glBlendEquationSeparateIndexedAMD');
  return _glBlendEquationSeparateIndexedAMD(buf, modeRGB, modeAlpha);
}

/// ```c
/// GLAPI void APIENTRY glTextureRangeAPPLE (GLenum target, GLsizei length, const GLvoid *pointer)
/// ```
void glTextureRangeAPPLE(int target, int length, Pointer<Void>? pointer) {
  final _glTextureRangeAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 length, Pointer<Void>? pointer),
      void Function(int target, int length, Pointer<Void>? pointer)>('glTextureRangeAPPLE');
  return _glTextureRangeAPPLE(target, length, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetTexParameterPointervAPPLE (GLenum target, GLenum pname, GLvoid* *params)
/// ```
void glGetTexParameterPointervAPPLE(int target, int pname, Pointer<Pointer<Void>>? params) {
  final _glGetTexParameterPointervAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Pointer<Void>>? params),
      void Function(int target, int pname, Pointer<Pointer<Void>>? params)>('glGetTexParameterPointervAPPLE');
  return _glGetTexParameterPointervAPPLE(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glEnableVertexAttribAPPLE (GLuint index, GLenum pname)
/// ```
void glEnableVertexAttribAPPLE(int index, int pname) {
  final _glEnableVertexAttribAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname),
      void Function(int index, int pname)>('glEnableVertexAttribAPPLE');
  return _glEnableVertexAttribAPPLE(index, pname);
}

/// ```c
/// GLAPI void APIENTRY glDisableVertexAttribAPPLE (GLuint index, GLenum pname)
/// ```
void glDisableVertexAttribAPPLE(int index, int pname) {
  final _glDisableVertexAttribAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname),
      void Function(int index, int pname)>('glDisableVertexAttribAPPLE');
  return _glDisableVertexAttribAPPLE(index, pname);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsVertexAttribEnabledAPPLE (GLuint index, GLenum pname)
/// ```
int glIsVertexAttribEnabledAPPLE(int index, int pname) {
  final _glIsVertexAttribEnabledAPPLE = _SDL2.lookupFunction<
      Int32 Function(Uint32 index, Uint32 pname),
      int Function(int index, int pname)>('glIsVertexAttribEnabledAPPLE');
  return _glIsVertexAttribEnabledAPPLE(index, pname);
}

/// ```c
/// GLAPI void APIENTRY glMapVertexAttrib1dAPPLE (GLuint index, GLuint size, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points)
/// ```
void glMapVertexAttrib1dAPPLE(int index, int size, double u1, double u2, int stride, int order, Pointer<Double>? points) {
  final _glMapVertexAttrib1dAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 size, Double u1, Double u2, Int32 stride, Int32 order, Pointer<Double>? points),
      void Function(int index, int size, double u1, double u2, int stride, int order, Pointer<Double>? points)>('glMapVertexAttrib1dAPPLE');
  return _glMapVertexAttrib1dAPPLE(index, size, u1, u2, stride, order, points);
}

/// ```c
/// GLAPI void APIENTRY glMapVertexAttrib1fAPPLE (GLuint index, GLuint size, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points)
/// ```
void glMapVertexAttrib1fAPPLE(int index, int size, double u1, double u2, int stride, int order, Pointer<Float>? points) {
  final _glMapVertexAttrib1fAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 size, Float u1, Float u2, Int32 stride, Int32 order, Pointer<Float>? points),
      void Function(int index, int size, double u1, double u2, int stride, int order, Pointer<Float>? points)>('glMapVertexAttrib1fAPPLE');
  return _glMapVertexAttrib1fAPPLE(index, size, u1, u2, stride, order, points);
}

/// ```c
/// GLAPI void APIENTRY glMapVertexAttrib2dAPPLE (GLuint index, GLuint size, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points)
/// ```
void glMapVertexAttrib2dAPPLE(int index, int size, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, Pointer<Double>? points) {
  final _glMapVertexAttrib2dAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 size, Double u1, Double u2, Int32 ustride, Int32 uorder, Double v1, Double v2, Int32 vstride, Int32 vorder, Pointer<Double>? points),
      void Function(int index, int size, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, Pointer<Double>? points)>('glMapVertexAttrib2dAPPLE');
  return _glMapVertexAttrib2dAPPLE(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
}

/// ```c
/// GLAPI void APIENTRY glMapVertexAttrib2fAPPLE (GLuint index, GLuint size, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points)
/// ```
void glMapVertexAttrib2fAPPLE(int index, int size, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, Pointer<Float>? points) {
  final _glMapVertexAttrib2fAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 size, Float u1, Float u2, Int32 ustride, Int32 uorder, Float v1, Float v2, Int32 vstride, Int32 vorder, Pointer<Float>? points),
      void Function(int index, int size, double u1, double u2, int ustride, int uorder, double v1, double v2, int vstride, int vorder, Pointer<Float>? points)>('glMapVertexAttrib2fAPPLE');
  return _glMapVertexAttrib2fAPPLE(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
}

/// ```c
/// GLAPI GLenum APIENTRY glObjectPurgeableAPPLE (GLenum objectType, GLuint name, GLenum option)
/// ```
int glObjectPurgeableAPPLE(int objectType, int name, int option) {
  final _glObjectPurgeableAPPLE = _SDL2.lookupFunction<
      Uint32 Function(Uint32 objectType, Uint32 name, Uint32 option),
      int Function(int objectType, int name, int option)>('glObjectPurgeableAPPLE');
  return _glObjectPurgeableAPPLE(objectType, name, option);
}

/// ```c
/// GLAPI GLenum APIENTRY glObjectUnpurgeableAPPLE (GLenum objectType, GLuint name, GLenum option)
/// ```
int glObjectUnpurgeableAPPLE(int objectType, int name, int option) {
  final _glObjectUnpurgeableAPPLE = _SDL2.lookupFunction<
      Uint32 Function(Uint32 objectType, Uint32 name, Uint32 option),
      int Function(int objectType, int name, int option)>('glObjectUnpurgeableAPPLE');
  return _glObjectUnpurgeableAPPLE(objectType, name, option);
}

/// ```c
/// GLAPI void APIENTRY glGetObjectParameterivAPPLE (GLenum objectType, GLuint name, GLenum pname, GLint *params)
/// ```
void glGetObjectParameterivAPPLE(int objectType, int name, int pname, Pointer<Int32>? params) {
  final _glGetObjectParameterivAPPLE = _SDL2.lookupFunction<
      Void Function(Uint32 objectType, Uint32 name, Uint32 pname, Pointer<Int32>? params),
      void Function(int objectType, int name, int pname, Pointer<Int32>? params)>('glGetObjectParameterivAPPLE');
  return _glGetObjectParameterivAPPLE(objectType, name, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glBeginVideoCaptureNV (GLuint video_capture_slot)
/// ```
void glBeginVideoCaptureNV(int video_capture_slot) {
  final _glBeginVideoCaptureNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot),
      void Function(int video_capture_slot)>('glBeginVideoCaptureNV');
  return _glBeginVideoCaptureNV(video_capture_slot);
}

/// ```c
/// GLAPI void APIENTRY glBindVideoCaptureStreamBufferNV (GLuint video_capture_slot, GLuint stream, GLenum frame_region, GLintptrARB offset)
/// ```
void glBindVideoCaptureStreamBufferNV(int video_capture_slot, int stream, int frame_region, int offset) {
  final _glBindVideoCaptureStreamBufferNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 frame_region, Int32 offset),
      void Function(int video_capture_slot, int stream, int frame_region, int offset)>('glBindVideoCaptureStreamBufferNV');
  return _glBindVideoCaptureStreamBufferNV(video_capture_slot, stream, frame_region, offset);
}

/// ```c
/// GLAPI void APIENTRY glBindVideoCaptureStreamTextureNV (GLuint video_capture_slot, GLuint stream, GLenum frame_region, GLenum target, GLuint texture)
/// ```
void glBindVideoCaptureStreamTextureNV(int video_capture_slot, int stream, int frame_region, int target, int texture) {
  final _glBindVideoCaptureStreamTextureNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 frame_region, Uint32 target, Uint32 texture),
      void Function(int video_capture_slot, int stream, int frame_region, int target, int texture)>('glBindVideoCaptureStreamTextureNV');
  return _glBindVideoCaptureStreamTextureNV(video_capture_slot, stream, frame_region, target, texture);
}

/// ```c
/// GLAPI void APIENTRY glEndVideoCaptureNV (GLuint video_capture_slot)
/// ```
void glEndVideoCaptureNV(int video_capture_slot) {
  final _glEndVideoCaptureNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot),
      void Function(int video_capture_slot)>('glEndVideoCaptureNV');
  return _glEndVideoCaptureNV(video_capture_slot);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoCaptureivNV (GLuint video_capture_slot, GLenum pname, GLint *params)
/// ```
void glGetVideoCaptureivNV(int video_capture_slot, int pname, Pointer<Int32>? params) {
  final _glGetVideoCaptureivNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 pname, Pointer<Int32>? params),
      void Function(int video_capture_slot, int pname, Pointer<Int32>? params)>('glGetVideoCaptureivNV');
  return _glGetVideoCaptureivNV(video_capture_slot, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoCaptureStreamivNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLint *params)
/// ```
void glGetVideoCaptureStreamivNV(int video_capture_slot, int stream, int pname, Pointer<Int32>? params) {
  final _glGetVideoCaptureStreamivNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Int32>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Int32>? params)>('glGetVideoCaptureStreamivNV');
  return _glGetVideoCaptureStreamivNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoCaptureStreamfvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLfloat *params)
/// ```
void glGetVideoCaptureStreamfvNV(int video_capture_slot, int stream, int pname, Pointer<Float>? params) {
  final _glGetVideoCaptureStreamfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Float>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Float>? params)>('glGetVideoCaptureStreamfvNV');
  return _glGetVideoCaptureStreamfvNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVideoCaptureStreamdvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLdouble *params)
/// ```
void glGetVideoCaptureStreamdvNV(int video_capture_slot, int stream, int pname, Pointer<Double>? params) {
  final _glGetVideoCaptureStreamdvNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Double>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Double>? params)>('glGetVideoCaptureStreamdvNV');
  return _glGetVideoCaptureStreamdvNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI GLenum APIENTRY glVideoCaptureNV (GLuint video_capture_slot, GLuint *sequence_num, GLuint64EXT *capture_time)
/// ```
int glVideoCaptureNV(int video_capture_slot, Pointer<Uint32>? sequence_num, Pointer<Uint64>? capture_time) {
  final _glVideoCaptureNV = _SDL2.lookupFunction<
      Uint32 Function(Uint32 video_capture_slot, Pointer<Uint32>? sequence_num, Pointer<Uint64>? capture_time),
      int Function(int video_capture_slot, Pointer<Uint32>? sequence_num, Pointer<Uint64>? capture_time)>('glVideoCaptureNV');
  return _glVideoCaptureNV(video_capture_slot, sequence_num, capture_time);
}

/// ```c
/// GLAPI void APIENTRY glVideoCaptureStreamParameterivNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLint *params)
/// ```
void glVideoCaptureStreamParameterivNV(int video_capture_slot, int stream, int pname, Pointer<Int32>? params) {
  final _glVideoCaptureStreamParameterivNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Int32>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Int32>? params)>('glVideoCaptureStreamParameterivNV');
  return _glVideoCaptureStreamParameterivNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVideoCaptureStreamParameterfvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLfloat *params)
/// ```
void glVideoCaptureStreamParameterfvNV(int video_capture_slot, int stream, int pname, Pointer<Float>? params) {
  final _glVideoCaptureStreamParameterfvNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Float>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Float>? params)>('glVideoCaptureStreamParameterfvNV');
  return _glVideoCaptureStreamParameterfvNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVideoCaptureStreamParameterdvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLdouble *params)
/// ```
void glVideoCaptureStreamParameterdvNV(int video_capture_slot, int stream, int pname, Pointer<Double>? params) {
  final _glVideoCaptureStreamParameterdvNV = _SDL2.lookupFunction<
      Void Function(Uint32 video_capture_slot, Uint32 stream, Uint32 pname, Pointer<Double>? params),
      void Function(int video_capture_slot, int stream, int pname, Pointer<Double>? params)>('glVideoCaptureStreamParameterdvNV');
  return _glVideoCaptureStreamParameterdvNV(video_capture_slot, stream, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glCopyImageSubDataNV (GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei width, GLsizei height, GLsizei depth)
/// ```
void glCopyImageSubDataNV(int srcName, int srcTarget, int srcLevel, int srcX, int srcY, int srcZ, int dstName, int dstTarget, int dstLevel, int dstX, int dstY, int dstZ, int width, int height, int depth) {
  final _glCopyImageSubDataNV = _SDL2.lookupFunction<
      Void Function(Uint32 srcName, Uint32 srcTarget, Int32 srcLevel, Int32 srcX, Int32 srcY, Int32 srcZ, Uint32 dstName, Uint32 dstTarget, Int32 dstLevel, Int32 dstX, Int32 dstY, Int32 dstZ, Uint32 width, Uint32 height, Uint32 depth),
      void Function(int srcName, int srcTarget, int srcLevel, int srcX, int srcY, int srcZ, int dstName, int dstTarget, int dstLevel, int dstX, int dstY, int dstZ, int width, int height, int depth)>('glCopyImageSubDataNV');
  return _glCopyImageSubDataNV(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
}

/// ```c
/// GLAPI void APIENTRY glUseShaderProgramEXT (GLenum type, GLuint program)
/// ```
void glUseShaderProgramEXT(int type, int program) {
  final _glUseShaderProgramEXT = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 program),
      void Function(int type, int program)>('glUseShaderProgramEXT');
  return _glUseShaderProgramEXT(type, program);
}

/// ```c
/// GLAPI void APIENTRY glActiveProgramEXT (GLuint program)
/// ```
void glActiveProgramEXT(int program) {
  final _glActiveProgramEXT = _SDL2.lookupFunction<
      Void Function(Uint32 program),
      void Function(int program)>('glActiveProgramEXT');
  return _glActiveProgramEXT(program);
}

/// ```c
/// GLAPI GLuint APIENTRY glCreateShaderProgramEXT (GLenum type, const GLchar *string)
/// ```
int glCreateShaderProgramEXT(int type, String string) {
  final _glCreateShaderProgramEXT = _SDL2.lookupFunction<
      Uint32 Function(Uint32 type, Pointer<Utf8>? string),
      int Function(int type, Pointer<Utf8>? string)>('glCreateShaderProgramEXT');
  final _stringPointer = string.toNativeUtf8();
  final _result = _glCreateShaderProgramEXT(type, _stringPointer);
  calloc.free(_stringPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glMakeBufferResidentNV (GLenum target, GLenum access)
/// ```
void glMakeBufferResidentNV(int target, int access) {
  final _glMakeBufferResidentNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 access),
      void Function(int target, int access)>('glMakeBufferResidentNV');
  return _glMakeBufferResidentNV(target, access);
}

/// ```c
/// GLAPI void APIENTRY glMakeBufferNonResidentNV (GLenum target)
/// ```
void glMakeBufferNonResidentNV(int target) {
  final _glMakeBufferNonResidentNV = _SDL2.lookupFunction<
      Void Function(Uint32 target),
      void Function(int target)>('glMakeBufferNonResidentNV');
  return _glMakeBufferNonResidentNV(target);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsBufferResidentNV (GLenum target)
/// ```
int glIsBufferResidentNV(int target) {
  final _glIsBufferResidentNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 target),
      int Function(int target)>('glIsBufferResidentNV');
  return _glIsBufferResidentNV(target);
}

/// ```c
/// GLAPI void APIENTRY glMakeNamedBufferResidentNV (GLuint buffer, GLenum access)
/// ```
void glMakeNamedBufferResidentNV(int buffer, int access) {
  final _glMakeNamedBufferResidentNV = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 access),
      void Function(int buffer, int access)>('glMakeNamedBufferResidentNV');
  return _glMakeNamedBufferResidentNV(buffer, access);
}

/// ```c
/// GLAPI void APIENTRY glMakeNamedBufferNonResidentNV (GLuint buffer)
/// ```
void glMakeNamedBufferNonResidentNV(int buffer) {
  final _glMakeNamedBufferNonResidentNV = _SDL2.lookupFunction<
      Void Function(Uint32 buffer),
      void Function(int buffer)>('glMakeNamedBufferNonResidentNV');
  return _glMakeNamedBufferNonResidentNV(buffer);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsNamedBufferResidentNV (GLuint buffer)
/// ```
int glIsNamedBufferResidentNV(int buffer) {
  final _glIsNamedBufferResidentNV = _SDL2.lookupFunction<
      Int32 Function(Uint32 buffer),
      int Function(int buffer)>('glIsNamedBufferResidentNV');
  return _glIsNamedBufferResidentNV(buffer);
}

/// ```c
/// GLAPI void APIENTRY glGetBufferParameterui64vNV (GLenum target, GLenum pname, GLuint64EXT *params)
/// ```
void glGetBufferParameterui64vNV(int target, int pname, Pointer<Uint64>? params) {
  final _glGetBufferParameterui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 pname, Pointer<Uint64>? params),
      void Function(int target, int pname, Pointer<Uint64>? params)>('glGetBufferParameterui64vNV');
  return _glGetBufferParameterui64vNV(target, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetNamedBufferParameterui64vNV (GLuint buffer, GLenum pname, GLuint64EXT *params)
/// ```
void glGetNamedBufferParameterui64vNV(int buffer, int pname, Pointer<Uint64>? params) {
  final _glGetNamedBufferParameterui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 buffer, Uint32 pname, Pointer<Uint64>? params),
      void Function(int buffer, int pname, Pointer<Uint64>? params)>('glGetNamedBufferParameterui64vNV');
  return _glGetNamedBufferParameterui64vNV(buffer, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetIntegerui64vNV (GLenum value, GLuint64EXT *result)
/// ```
void glGetIntegerui64vNV(int value, Pointer<Uint64>? result) {
  final _glGetIntegerui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 value, Pointer<Uint64>? result),
      void Function(int value, Pointer<Uint64>? result)>('glGetIntegerui64vNV');
  return _glGetIntegerui64vNV(value, result);
}

/// ```c
/// GLAPI void APIENTRY glUniformui64NV (GLint location, GLuint64EXT value)
/// ```
void glUniformui64NV(int location, int value) {
  final _glUniformui64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint64 value),
      void Function(int location, int value)>('glUniformui64NV');
  return _glUniformui64NV(location, value);
}

/// ```c
/// GLAPI void APIENTRY glUniformui64vNV (GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glUniformui64vNV(int location, int count, Pointer<Uint64>? value) {
  final _glUniformui64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int location, int count, Pointer<Uint64>? value)>('glUniformui64vNV');
  return _glUniformui64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformui64vNV (GLuint program, GLint location, GLuint64EXT *params)
/// ```
void glGetUniformui64vNV(int program, int location, Pointer<Uint64>? params) {
  final _glGetUniformui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Uint64>? params),
      void Function(int program, int location, Pointer<Uint64>? params)>('glGetUniformui64vNV');
  return _glGetUniformui64vNV(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformui64NV (GLuint program, GLint location, GLuint64EXT value)
/// ```
void glProgramUniformui64NV(int program, int location, int value) {
  final _glProgramUniformui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint64 value),
      void Function(int program, int location, int value)>('glProgramUniformui64NV');
  return _glProgramUniformui64NV(program, location, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniformui64vNV (GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glProgramUniformui64vNV(int program, int location, int count, Pointer<Uint64>? value) {
  final _glProgramUniformui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int program, int location, int count, Pointer<Uint64>? value)>('glProgramUniformui64vNV');
  return _glProgramUniformui64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glBufferAddressRangeNV (GLenum pname, GLuint index, GLuint64EXT address, GLsizeiptr length)
/// ```
void glBufferAddressRangeNV(int pname, int index, int address, Pointer<Void>? length) {
  final _glBufferAddressRangeNV = _SDL2.lookupFunction<
      Void Function(Uint32 pname, Uint32 index, Uint64 address, Pointer<Void>? length),
      void Function(int pname, int index, int address, Pointer<Void>? length)>('glBufferAddressRangeNV');
  return _glBufferAddressRangeNV(pname, index, address, length);
}

/// ```c
/// GLAPI void APIENTRY glVertexFormatNV (GLint size, GLenum type, GLsizei stride)
/// ```
void glVertexFormatNV(int size, int type, int stride) {
  final _glVertexFormatNV = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride),
      void Function(int size, int type, int stride)>('glVertexFormatNV');
  return _glVertexFormatNV(size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glNormalFormatNV (GLenum type, GLsizei stride)
/// ```
void glNormalFormatNV(int type, int stride) {
  final _glNormalFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride),
      void Function(int type, int stride)>('glNormalFormatNV');
  return _glNormalFormatNV(type, stride);
}

/// ```c
/// GLAPI void APIENTRY glColorFormatNV (GLint size, GLenum type, GLsizei stride)
/// ```
void glColorFormatNV(int size, int type, int stride) {
  final _glColorFormatNV = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride),
      void Function(int size, int type, int stride)>('glColorFormatNV');
  return _glColorFormatNV(size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glIndexFormatNV (GLenum type, GLsizei stride)
/// ```
void glIndexFormatNV(int type, int stride) {
  final _glIndexFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride),
      void Function(int type, int stride)>('glIndexFormatNV');
  return _glIndexFormatNV(type, stride);
}

/// ```c
/// GLAPI void APIENTRY glTexCoordFormatNV (GLint size, GLenum type, GLsizei stride)
/// ```
void glTexCoordFormatNV(int size, int type, int stride) {
  final _glTexCoordFormatNV = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride),
      void Function(int size, int type, int stride)>('glTexCoordFormatNV');
  return _glTexCoordFormatNV(size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glEdgeFlagFormatNV (GLsizei stride)
/// ```
void glEdgeFlagFormatNV(int stride) {
  final _glEdgeFlagFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 stride),
      void Function(int stride)>('glEdgeFlagFormatNV');
  return _glEdgeFlagFormatNV(stride);
}

/// ```c
/// GLAPI void APIENTRY glSecondaryColorFormatNV (GLint size, GLenum type, GLsizei stride)
/// ```
void glSecondaryColorFormatNV(int size, int type, int stride) {
  final _glSecondaryColorFormatNV = _SDL2.lookupFunction<
      Void Function(Int32 size, Uint32 type, Uint32 stride),
      void Function(int size, int type, int stride)>('glSecondaryColorFormatNV');
  return _glSecondaryColorFormatNV(size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glFogCoordFormatNV (GLenum type, GLsizei stride)
/// ```
void glFogCoordFormatNV(int type, int stride) {
  final _glFogCoordFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 type, Uint32 stride),
      void Function(int type, int stride)>('glFogCoordFormatNV');
  return _glFogCoordFormatNV(type, stride);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribFormatNV (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride)
/// ```
void glVertexAttribFormatNV(int index, int size, int type, int normalized, int stride) {
  final _glVertexAttribFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Int32 normalized, Uint32 stride),
      void Function(int index, int size, int type, int normalized, int stride)>('glVertexAttribFormatNV');
  return _glVertexAttribFormatNV(index, size, type, normalized, stride);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribIFormatNV (GLuint index, GLint size, GLenum type, GLsizei stride)
/// ```
void glVertexAttribIFormatNV(int index, int size, int type, int stride) {
  final _glVertexAttribIFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride),
      void Function(int index, int size, int type, int stride)>('glVertexAttribIFormatNV');
  return _glVertexAttribIFormatNV(index, size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glGetIntegerui64i_vNV (GLenum value, GLuint index, GLuint64EXT *result)
/// ```
void glGetIntegerui64i_vNV(int value, int index, Pointer<Uint64>? result) {
  final _glGetIntegerui64i_vNV = _SDL2.lookupFunction<
      Void Function(Uint32 value, Uint32 index, Pointer<Uint64>? result),
      void Function(int value, int index, Pointer<Uint64>? result)>('glGetIntegerui64i_vNV');
  return _glGetIntegerui64i_vNV(value, index, result);
}

/// ```c
/// GLAPI void APIENTRY glTextureBarrierNV (void)
/// ```
void glTextureBarrierNV() {
  final _glTextureBarrierNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glTextureBarrierNV');
  return _glTextureBarrierNV();
}

/// ```c
/// GLAPI void APIENTRY glBindImageTextureEXT (GLuint index, GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum access, GLint format)
/// ```
void glBindImageTextureEXT(int index, int texture, int level, int layered, int layer, int access, int format) {
  final _glBindImageTextureEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 texture, Int32 level, Int32 layered, Int32 layer, Uint32 access, Int32 format),
      void Function(int index, int texture, int level, int layered, int layer, int access, int format)>('glBindImageTextureEXT');
  return _glBindImageTextureEXT(index, texture, level, layered, layer, access, format);
}

/// ```c
/// GLAPI void APIENTRY glMemoryBarrierEXT (GLbitfield barriers)
/// ```
void glMemoryBarrierEXT(int barriers) {
  final _glMemoryBarrierEXT = _SDL2.lookupFunction<
      Void Function(Uint32 barriers),
      void Function(int barriers)>('glMemoryBarrierEXT');
  return _glMemoryBarrierEXT(barriers);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1dEXT (GLuint index, GLdouble x)
/// ```
void glVertexAttribL1dEXT(int index, double x) {
  final _glVertexAttribL1dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x),
      void Function(int index, double x)>('glVertexAttribL1dEXT');
  return _glVertexAttribL1dEXT(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2dEXT (GLuint index, GLdouble x, GLdouble y)
/// ```
void glVertexAttribL2dEXT(int index, double x, double y) {
  final _glVertexAttribL2dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y),
      void Function(int index, double x, double y)>('glVertexAttribL2dEXT');
  return _glVertexAttribL2dEXT(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3dEXT (GLuint index, GLdouble x, GLdouble y, GLdouble z)
/// ```
void glVertexAttribL3dEXT(int index, double x, double y, double z) {
  final _glVertexAttribL3dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z),
      void Function(int index, double x, double y, double z)>('glVertexAttribL3dEXT');
  return _glVertexAttribL3dEXT(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4dEXT (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
/// ```
void glVertexAttribL4dEXT(int index, double x, double y, double z, double w) {
  final _glVertexAttribL4dEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Double x, Double y, Double z, Double w),
      void Function(int index, double x, double y, double z, double w)>('glVertexAttribL4dEXT');
  return _glVertexAttribL4dEXT(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1dvEXT (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL1dvEXT(int index, Pointer<Double>? v) {
  final _glVertexAttribL1dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL1dvEXT');
  return _glVertexAttribL1dvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2dvEXT (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL2dvEXT(int index, Pointer<Double>? v) {
  final _glVertexAttribL2dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL2dvEXT');
  return _glVertexAttribL2dvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3dvEXT (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL3dvEXT(int index, Pointer<Double>? v) {
  final _glVertexAttribL3dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL3dvEXT');
  return _glVertexAttribL3dvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4dvEXT (GLuint index, const GLdouble *v)
/// ```
void glVertexAttribL4dvEXT(int index, Pointer<Double>? v) {
  final _glVertexAttribL4dvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Double>? v),
      void Function(int index, Pointer<Double>? v)>('glVertexAttribL4dvEXT');
  return _glVertexAttribL4dvEXT(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribLPointerEXT (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
/// ```
void glVertexAttribLPointerEXT(int index, int size, int type, int stride, Pointer<Void>? pointer) {
  final _glVertexAttribLPointerEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? pointer),
      void Function(int index, int size, int type, int stride, Pointer<Void>? pointer)>('glVertexAttribLPointerEXT');
  return _glVertexAttribLPointerEXT(index, size, type, stride, pointer);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribLdvEXT (GLuint index, GLenum pname, GLdouble *params)
/// ```
void glGetVertexAttribLdvEXT(int index, int pname, Pointer<Double>? params) {
  final _glGetVertexAttribLdvEXT = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Double>? params),
      void Function(int index, int pname, Pointer<Double>? params)>('glGetVertexAttribLdvEXT');
  return _glGetVertexAttribLdvEXT(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVertexArrayVertexAttribLOffsetEXT (GLuint vaobj, GLuint buffer, GLuint index, GLint size, GLenum type, GLsizei stride, GLintptr offset)
/// ```
void glVertexArrayVertexAttribLOffsetEXT(int vaobj, int buffer, int index, int size, int type, int stride, Pointer<Void>? offset) {
  final _glVertexArrayVertexAttribLOffsetEXT = _SDL2.lookupFunction<
      Void Function(Uint32 vaobj, Uint32 buffer, Uint32 index, Int32 size, Uint32 type, Uint32 stride, Pointer<Void>? offset),
      void Function(int vaobj, int buffer, int index, int size, int type, int stride, Pointer<Void>? offset)>('glVertexArrayVertexAttribLOffsetEXT');
  return _glVertexArrayVertexAttribLOffsetEXT(vaobj, buffer, index, size, type, stride, offset);
}

/// ```c
/// GLAPI void APIENTRY glProgramSubroutineParametersuivNV (GLenum target, GLsizei count, const GLuint *params)
/// ```
void glProgramSubroutineParametersuivNV(int target, int count, Pointer<Uint32>? params) {
  final _glProgramSubroutineParametersuivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 count, Pointer<Uint32>? params),
      void Function(int target, int count, Pointer<Uint32>? params)>('glProgramSubroutineParametersuivNV');
  return _glProgramSubroutineParametersuivNV(target, count, params);
}

/// ```c
/// GLAPI void APIENTRY glGetProgramSubroutineParameteruivNV (GLenum target, GLuint index, GLuint *param)
/// ```
void glGetProgramSubroutineParameteruivNV(int target, int index, Pointer<Uint32>? param) {
  final _glGetProgramSubroutineParameteruivNV = _SDL2.lookupFunction<
      Void Function(Uint32 target, Uint32 index, Pointer<Uint32>? param),
      void Function(int target, int index, Pointer<Uint32>? param)>('glGetProgramSubroutineParameteruivNV');
  return _glGetProgramSubroutineParameteruivNV(target, index, param);
}

/// ```c
/// GLAPI void APIENTRY glUniform1i64NV (GLint location, GLint64EXT x)
/// ```
void glUniform1i64NV(int location, int x) {
  final _glUniform1i64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Int64 x),
      void Function(int location, int x)>('glUniform1i64NV');
  return _glUniform1i64NV(location, x);
}

/// ```c
/// GLAPI void APIENTRY glUniform2i64NV (GLint location, GLint64EXT x, GLint64EXT y)
/// ```
void glUniform2i64NV(int location, int x, int y) {
  final _glUniform2i64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Int64 x, Int64 y),
      void Function(int location, int x, int y)>('glUniform2i64NV');
  return _glUniform2i64NV(location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glUniform3i64NV (GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
/// ```
void glUniform3i64NV(int location, int x, int y, int z) {
  final _glUniform3i64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Int64 x, Int64 y, Int64 z),
      void Function(int location, int x, int y, int z)>('glUniform3i64NV');
  return _glUniform3i64NV(location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glUniform4i64NV (GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
/// ```
void glUniform4i64NV(int location, int x, int y, int z, int w) {
  final _glUniform4i64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Int64 x, Int64 y, Int64 z, Int64 w),
      void Function(int location, int x, int y, int z, int w)>('glUniform4i64NV');
  return _glUniform4i64NV(location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glUniform1i64vNV (GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glUniform1i64vNV(int location, int count, Pointer<Int64>? value) {
  final _glUniform1i64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int location, int count, Pointer<Int64>? value)>('glUniform1i64vNV');
  return _glUniform1i64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2i64vNV (GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glUniform2i64vNV(int location, int count, Pointer<Int64>? value) {
  final _glUniform2i64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int location, int count, Pointer<Int64>? value)>('glUniform2i64vNV');
  return _glUniform2i64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3i64vNV (GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glUniform3i64vNV(int location, int count, Pointer<Int64>? value) {
  final _glUniform3i64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int location, int count, Pointer<Int64>? value)>('glUniform3i64vNV');
  return _glUniform3i64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4i64vNV (GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glUniform4i64vNV(int location, int count, Pointer<Int64>? value) {
  final _glUniform4i64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int location, int count, Pointer<Int64>? value)>('glUniform4i64vNV');
  return _glUniform4i64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform1ui64NV (GLint location, GLuint64EXT x)
/// ```
void glUniform1ui64NV(int location, int x) {
  final _glUniform1ui64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint64 x),
      void Function(int location, int x)>('glUniform1ui64NV');
  return _glUniform1ui64NV(location, x);
}

/// ```c
/// GLAPI void APIENTRY glUniform2ui64NV (GLint location, GLuint64EXT x, GLuint64EXT y)
/// ```
void glUniform2ui64NV(int location, int x, int y) {
  final _glUniform2ui64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint64 x, Uint64 y),
      void Function(int location, int x, int y)>('glUniform2ui64NV');
  return _glUniform2ui64NV(location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glUniform3ui64NV (GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
/// ```
void glUniform3ui64NV(int location, int x, int y, int z) {
  final _glUniform3ui64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint64 x, Uint64 y, Uint64 z),
      void Function(int location, int x, int y, int z)>('glUniform3ui64NV');
  return _glUniform3ui64NV(location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glUniform4ui64NV (GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
/// ```
void glUniform4ui64NV(int location, int x, int y, int z, int w) {
  final _glUniform4ui64NV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint64 x, Uint64 y, Uint64 z, Uint64 w),
      void Function(int location, int x, int y, int z, int w)>('glUniform4ui64NV');
  return _glUniform4ui64NV(location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glUniform1ui64vNV (GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glUniform1ui64vNV(int location, int count, Pointer<Uint64>? value) {
  final _glUniform1ui64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int location, int count, Pointer<Uint64>? value)>('glUniform1ui64vNV');
  return _glUniform1ui64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform2ui64vNV (GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glUniform2ui64vNV(int location, int count, Pointer<Uint64>? value) {
  final _glUniform2ui64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int location, int count, Pointer<Uint64>? value)>('glUniform2ui64vNV');
  return _glUniform2ui64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform3ui64vNV (GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glUniform3ui64vNV(int location, int count, Pointer<Uint64>? value) {
  final _glUniform3ui64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int location, int count, Pointer<Uint64>? value)>('glUniform3ui64vNV');
  return _glUniform3ui64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glUniform4ui64vNV (GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glUniform4ui64vNV(int location, int count, Pointer<Uint64>? value) {
  final _glUniform4ui64vNV = _SDL2.lookupFunction<
      Void Function(Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int location, int count, Pointer<Uint64>? value)>('glUniform4ui64vNV');
  return _glUniform4ui64vNV(location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glGetUniformi64vNV (GLuint program, GLint location, GLint64EXT *params)
/// ```
void glGetUniformi64vNV(int program, int location, Pointer<Int64>? params) {
  final _glGetUniformi64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Pointer<Int64>? params),
      void Function(int program, int location, Pointer<Int64>? params)>('glGetUniformi64vNV');
  return _glGetUniformi64vNV(program, location, params);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1i64NV (GLuint program, GLint location, GLint64EXT x)
/// ```
void glProgramUniform1i64NV(int program, int location, int x) {
  final _glProgramUniform1i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int64 x),
      void Function(int program, int location, int x)>('glProgramUniform1i64NV');
  return _glProgramUniform1i64NV(program, location, x);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2i64NV (GLuint program, GLint location, GLint64EXT x, GLint64EXT y)
/// ```
void glProgramUniform2i64NV(int program, int location, int x, int y) {
  final _glProgramUniform2i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int64 x, Int64 y),
      void Function(int program, int location, int x, int y)>('glProgramUniform2i64NV');
  return _glProgramUniform2i64NV(program, location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3i64NV (GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
/// ```
void glProgramUniform3i64NV(int program, int location, int x, int y, int z) {
  final _glProgramUniform3i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int64 x, Int64 y, Int64 z),
      void Function(int program, int location, int x, int y, int z)>('glProgramUniform3i64NV');
  return _glProgramUniform3i64NV(program, location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4i64NV (GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
/// ```
void glProgramUniform4i64NV(int program, int location, int x, int y, int z, int w) {
  final _glProgramUniform4i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Int64 x, Int64 y, Int64 z, Int64 w),
      void Function(int program, int location, int x, int y, int z, int w)>('glProgramUniform4i64NV');
  return _glProgramUniform4i64NV(program, location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1i64vNV (GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glProgramUniform1i64vNV(int program, int location, int count, Pointer<Int64>? value) {
  final _glProgramUniform1i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int program, int location, int count, Pointer<Int64>? value)>('glProgramUniform1i64vNV');
  return _glProgramUniform1i64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2i64vNV (GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glProgramUniform2i64vNV(int program, int location, int count, Pointer<Int64>? value) {
  final _glProgramUniform2i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int program, int location, int count, Pointer<Int64>? value)>('glProgramUniform2i64vNV');
  return _glProgramUniform2i64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3i64vNV (GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glProgramUniform3i64vNV(int program, int location, int count, Pointer<Int64>? value) {
  final _glProgramUniform3i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int program, int location, int count, Pointer<Int64>? value)>('glProgramUniform3i64vNV');
  return _glProgramUniform3i64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4i64vNV (GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
/// ```
void glProgramUniform4i64vNV(int program, int location, int count, Pointer<Int64>? value) {
  final _glProgramUniform4i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Int64>? value),
      void Function(int program, int location, int count, Pointer<Int64>? value)>('glProgramUniform4i64vNV');
  return _glProgramUniform4i64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1ui64NV (GLuint program, GLint location, GLuint64EXT x)
/// ```
void glProgramUniform1ui64NV(int program, int location, int x) {
  final _glProgramUniform1ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint64 x),
      void Function(int program, int location, int x)>('glProgramUniform1ui64NV');
  return _glProgramUniform1ui64NV(program, location, x);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2ui64NV (GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y)
/// ```
void glProgramUniform2ui64NV(int program, int location, int x, int y) {
  final _glProgramUniform2ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint64 x, Uint64 y),
      void Function(int program, int location, int x, int y)>('glProgramUniform2ui64NV');
  return _glProgramUniform2ui64NV(program, location, x, y);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3ui64NV (GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
/// ```
void glProgramUniform3ui64NV(int program, int location, int x, int y, int z) {
  final _glProgramUniform3ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint64 x, Uint64 y, Uint64 z),
      void Function(int program, int location, int x, int y, int z)>('glProgramUniform3ui64NV');
  return _glProgramUniform3ui64NV(program, location, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4ui64NV (GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
/// ```
void glProgramUniform4ui64NV(int program, int location, int x, int y, int z, int w) {
  final _glProgramUniform4ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint64 x, Uint64 y, Uint64 z, Uint64 w),
      void Function(int program, int location, int x, int y, int z, int w)>('glProgramUniform4ui64NV');
  return _glProgramUniform4ui64NV(program, location, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform1ui64vNV (GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glProgramUniform1ui64vNV(int program, int location, int count, Pointer<Uint64>? value) {
  final _glProgramUniform1ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int program, int location, int count, Pointer<Uint64>? value)>('glProgramUniform1ui64vNV');
  return _glProgramUniform1ui64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform2ui64vNV (GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glProgramUniform2ui64vNV(int program, int location, int count, Pointer<Uint64>? value) {
  final _glProgramUniform2ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int program, int location, int count, Pointer<Uint64>? value)>('glProgramUniform2ui64vNV');
  return _glProgramUniform2ui64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform3ui64vNV (GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glProgramUniform3ui64vNV(int program, int location, int count, Pointer<Uint64>? value) {
  final _glProgramUniform3ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int program, int location, int count, Pointer<Uint64>? value)>('glProgramUniform3ui64vNV');
  return _glProgramUniform3ui64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glProgramUniform4ui64vNV (GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
/// ```
void glProgramUniform4ui64vNV(int program, int location, int count, Pointer<Uint64>? value) {
  final _glProgramUniform4ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 program, Int32 location, Uint32 count, Pointer<Uint64>? value),
      void Function(int program, int location, int count, Pointer<Uint64>? value)>('glProgramUniform4ui64vNV');
  return _glProgramUniform4ui64vNV(program, location, count, value);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1i64NV (GLuint index, GLint64EXT x)
/// ```
void glVertexAttribL1i64NV(int index, int x) {
  final _glVertexAttribL1i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int64 x),
      void Function(int index, int x)>('glVertexAttribL1i64NV');
  return _glVertexAttribL1i64NV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2i64NV (GLuint index, GLint64EXT x, GLint64EXT y)
/// ```
void glVertexAttribL2i64NV(int index, int x, int y) {
  final _glVertexAttribL2i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int64 x, Int64 y),
      void Function(int index, int x, int y)>('glVertexAttribL2i64NV');
  return _glVertexAttribL2i64NV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3i64NV (GLuint index, GLint64EXT x, GLint64EXT y, GLint64EXT z)
/// ```
void glVertexAttribL3i64NV(int index, int x, int y, int z) {
  final _glVertexAttribL3i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int64 x, Int64 y, Int64 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribL3i64NV');
  return _glVertexAttribL3i64NV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4i64NV (GLuint index, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
/// ```
void glVertexAttribL4i64NV(int index, int x, int y, int z, int w) {
  final _glVertexAttribL4i64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int64 x, Int64 y, Int64 z, Int64 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribL4i64NV');
  return _glVertexAttribL4i64NV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1i64vNV (GLuint index, const GLint64EXT *v)
/// ```
void glVertexAttribL1i64vNV(int index, Pointer<Int64>? v) {
  final _glVertexAttribL1i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int64>? v),
      void Function(int index, Pointer<Int64>? v)>('glVertexAttribL1i64vNV');
  return _glVertexAttribL1i64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2i64vNV (GLuint index, const GLint64EXT *v)
/// ```
void glVertexAttribL2i64vNV(int index, Pointer<Int64>? v) {
  final _glVertexAttribL2i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int64>? v),
      void Function(int index, Pointer<Int64>? v)>('glVertexAttribL2i64vNV');
  return _glVertexAttribL2i64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3i64vNV (GLuint index, const GLint64EXT *v)
/// ```
void glVertexAttribL3i64vNV(int index, Pointer<Int64>? v) {
  final _glVertexAttribL3i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int64>? v),
      void Function(int index, Pointer<Int64>? v)>('glVertexAttribL3i64vNV');
  return _glVertexAttribL3i64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4i64vNV (GLuint index, const GLint64EXT *v)
/// ```
void glVertexAttribL4i64vNV(int index, Pointer<Int64>? v) {
  final _glVertexAttribL4i64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Int64>? v),
      void Function(int index, Pointer<Int64>? v)>('glVertexAttribL4i64vNV');
  return _glVertexAttribL4i64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1ui64NV (GLuint index, GLuint64EXT x)
/// ```
void glVertexAttribL1ui64NV(int index, int x) {
  final _glVertexAttribL1ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint64 x),
      void Function(int index, int x)>('glVertexAttribL1ui64NV');
  return _glVertexAttribL1ui64NV(index, x);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2ui64NV (GLuint index, GLuint64EXT x, GLuint64EXT y)
/// ```
void glVertexAttribL2ui64NV(int index, int x, int y) {
  final _glVertexAttribL2ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint64 x, Uint64 y),
      void Function(int index, int x, int y)>('glVertexAttribL2ui64NV');
  return _glVertexAttribL2ui64NV(index, x, y);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3ui64NV (GLuint index, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
/// ```
void glVertexAttribL3ui64NV(int index, int x, int y, int z) {
  final _glVertexAttribL3ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint64 x, Uint64 y, Uint64 z),
      void Function(int index, int x, int y, int z)>('glVertexAttribL3ui64NV');
  return _glVertexAttribL3ui64NV(index, x, y, z);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4ui64NV (GLuint index, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
/// ```
void glVertexAttribL4ui64NV(int index, int x, int y, int z, int w) {
  final _glVertexAttribL4ui64NV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint64 x, Uint64 y, Uint64 z, Uint64 w),
      void Function(int index, int x, int y, int z, int w)>('glVertexAttribL4ui64NV');
  return _glVertexAttribL4ui64NV(index, x, y, z, w);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL1ui64vNV (GLuint index, const GLuint64EXT *v)
/// ```
void glVertexAttribL1ui64vNV(int index, Pointer<Uint64>? v) {
  final _glVertexAttribL1ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint64>? v),
      void Function(int index, Pointer<Uint64>? v)>('glVertexAttribL1ui64vNV');
  return _glVertexAttribL1ui64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL2ui64vNV (GLuint index, const GLuint64EXT *v)
/// ```
void glVertexAttribL2ui64vNV(int index, Pointer<Uint64>? v) {
  final _glVertexAttribL2ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint64>? v),
      void Function(int index, Pointer<Uint64>? v)>('glVertexAttribL2ui64vNV');
  return _glVertexAttribL2ui64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL3ui64vNV (GLuint index, const GLuint64EXT *v)
/// ```
void glVertexAttribL3ui64vNV(int index, Pointer<Uint64>? v) {
  final _glVertexAttribL3ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint64>? v),
      void Function(int index, Pointer<Uint64>? v)>('glVertexAttribL3ui64vNV');
  return _glVertexAttribL3ui64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribL4ui64vNV (GLuint index, const GLuint64EXT *v)
/// ```
void glVertexAttribL4ui64vNV(int index, Pointer<Uint64>? v) {
  final _glVertexAttribL4ui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Pointer<Uint64>? v),
      void Function(int index, Pointer<Uint64>? v)>('glVertexAttribL4ui64vNV');
  return _glVertexAttribL4ui64vNV(index, v);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribLi64vNV (GLuint index, GLenum pname, GLint64EXT *params)
/// ```
void glGetVertexAttribLi64vNV(int index, int pname, Pointer<Int64>? params) {
  final _glGetVertexAttribLi64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Int64>? params),
      void Function(int index, int pname, Pointer<Int64>? params)>('glGetVertexAttribLi64vNV');
  return _glGetVertexAttribLi64vNV(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glGetVertexAttribLui64vNV (GLuint index, GLenum pname, GLuint64EXT *params)
/// ```
void glGetVertexAttribLui64vNV(int index, int pname, Pointer<Uint64>? params) {
  final _glGetVertexAttribLui64vNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Uint32 pname, Pointer<Uint64>? params),
      void Function(int index, int pname, Pointer<Uint64>? params)>('glGetVertexAttribLui64vNV');
  return _glGetVertexAttribLui64vNV(index, pname, params);
}

/// ```c
/// GLAPI void APIENTRY glVertexAttribLFormatNV (GLuint index, GLint size, GLenum type, GLsizei stride)
/// ```
void glVertexAttribLFormatNV(int index, int size, int type, int stride) {
  final _glVertexAttribLFormatNV = _SDL2.lookupFunction<
      Void Function(Uint32 index, Int32 size, Uint32 type, Uint32 stride),
      void Function(int index, int size, int type, int stride)>('glVertexAttribLFormatNV');
  return _glVertexAttribLFormatNV(index, size, type, stride);
}

/// ```c
/// GLAPI void APIENTRY glGenNamesAMD (GLenum identifier, GLuint num, GLuint *names)
/// ```
void glGenNamesAMD(int identifier, int num, Pointer<Uint32>? names) {
  final _glGenNamesAMD = _SDL2.lookupFunction<
      Void Function(Uint32 identifier, Uint32 num, Pointer<Uint32>? names),
      void Function(int identifier, int num, Pointer<Uint32>? names)>('glGenNamesAMD');
  return _glGenNamesAMD(identifier, num, names);
}

/// ```c
/// GLAPI void APIENTRY glDeleteNamesAMD (GLenum identifier, GLuint num, const GLuint *names)
/// ```
void glDeleteNamesAMD(int identifier, int num, Pointer<Uint32>? names) {
  final _glDeleteNamesAMD = _SDL2.lookupFunction<
      Void Function(Uint32 identifier, Uint32 num, Pointer<Uint32>? names),
      void Function(int identifier, int num, Pointer<Uint32>? names)>('glDeleteNamesAMD');
  return _glDeleteNamesAMD(identifier, num, names);
}

/// ```c
/// GLAPI GLboolean APIENTRY glIsNameAMD (GLenum identifier, GLuint name)
/// ```
int glIsNameAMD(int identifier, int name) {
  final _glIsNameAMD = _SDL2.lookupFunction<
      Int32 Function(Uint32 identifier, Uint32 name),
      int Function(int identifier, int name)>('glIsNameAMD');
  return _glIsNameAMD(identifier, name);
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageEnableAMD (GLenum category, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled)
/// ```
void glDebugMessageEnableAMD(int category, int severity, int count, Pointer<Uint32>? ids, int enabled) {
  final _glDebugMessageEnableAMD = _SDL2.lookupFunction<
      Void Function(Uint32 category, Uint32 severity, Uint32 count, Pointer<Uint32>? ids, Int32 enabled),
      void Function(int category, int severity, int count, Pointer<Uint32>? ids, int enabled)>('glDebugMessageEnableAMD');
  return _glDebugMessageEnableAMD(category, severity, count, ids, enabled);
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageInsertAMD (GLenum category, GLenum severity, GLuint id, GLsizei length, const GLchar *buf)
/// ```
void glDebugMessageInsertAMD(int category, int severity, int id, int length, String buf) {
  final _glDebugMessageInsertAMD = _SDL2.lookupFunction<
      Void Function(Uint32 category, Uint32 severity, Uint32 id, Uint32 length, Pointer<Utf8>? buf),
      void Function(int category, int severity, int id, int length, Pointer<Utf8>? buf)>('glDebugMessageInsertAMD');
  final _bufPointer = buf.toNativeUtf8();
  final _result = _glDebugMessageInsertAMD(category, severity, id, length, _bufPointer);
  calloc.free(_bufPointer);
  return _result;
}

/// ```c
/// GLAPI void APIENTRY glDebugMessageCallbackAMD (GLDEBUGPROCAMD callback, GLvoid *userParam)
/// ```
void glDebugMessageCallbackAMD(Pointer<Void>? callback, Pointer<Void>? userParam) {
  final _glDebugMessageCallbackAMD = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? callback, Pointer<Void>? userParam),
      void Function(Pointer<Void>? callback, Pointer<Void>? userParam)>('glDebugMessageCallbackAMD');
  return _glDebugMessageCallbackAMD(callback, userParam);
}

/// ```c
/// GLAPI GLuint APIENTRY glGetDebugMessageLogAMD (GLuint count, GLsizei bufsize, GLenum *categories, GLuint *severities, GLuint *ids, GLsizei *lengths, GLchar *message)
/// ```
int glGetDebugMessageLogAMD(int count, int bufsize, Pointer<Uint32>? categories, Pointer<Uint32>? severities, Pointer<Uint32>? ids, Pointer<Uint32>? lengths, Pointer<Int8>? message) {
  final _glGetDebugMessageLogAMD = _SDL2.lookupFunction<
      Uint32 Function(Uint32 count, Uint32 bufsize, Pointer<Uint32>? categories, Pointer<Uint32>? severities, Pointer<Uint32>? ids, Pointer<Uint32>? lengths, Pointer<Int8>? message),
      int Function(int count, int bufsize, Pointer<Uint32>? categories, Pointer<Uint32>? severities, Pointer<Uint32>? ids, Pointer<Uint32>? lengths, Pointer<Int8>? message)>('glGetDebugMessageLogAMD');
  return _glGetDebugMessageLogAMD(count, bufsize, categories, severities, ids, lengths, message);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUInitNV (const GLvoid *vdpDevice, const GLvoid *getProcAddress)
/// ```
void glVDPAUInitNV(Pointer<Void>? vdpDevice, Pointer<Void>? getProcAddress) {
  final _glVDPAUInitNV = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? vdpDevice, Pointer<Void>? getProcAddress),
      void Function(Pointer<Void>? vdpDevice, Pointer<Void>? getProcAddress)>('glVDPAUInitNV');
  return _glVDPAUInitNV(vdpDevice, getProcAddress);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUFiniNV (void)
/// ```
void glVDPAUFiniNV() {
  final _glVDPAUFiniNV = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('glVDPAUFiniNV');
  return _glVDPAUFiniNV();
}

/// ```c
/// GLAPI GLvdpauSurfaceNV APIENTRY glVDPAURegisterVideoSurfaceNV (GLvoid *vdpSurface, GLenum target, GLsizei numTextureNames, const GLuint *textureNames)
/// ```
Pointer<Void>? glVDPAURegisterVideoSurfaceNV(Pointer<Void>? vdpSurface, int target, int numTextureNames, Pointer<Uint32>? textureNames) {
  final _glVDPAURegisterVideoSurfaceNV = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? vdpSurface, Uint32 target, Uint32 numTextureNames, Pointer<Uint32>? textureNames),
      Pointer<Void>? Function(Pointer<Void>? vdpSurface, int target, int numTextureNames, Pointer<Uint32>? textureNames)>('glVDPAURegisterVideoSurfaceNV');
  return _glVDPAURegisterVideoSurfaceNV(vdpSurface, target, numTextureNames, textureNames);
}

/// ```c
/// GLAPI GLvdpauSurfaceNV APIENTRY glVDPAURegisterOutputSurfaceNV (GLvoid *vdpSurface, GLenum target, GLsizei numTextureNames, const GLuint *textureNames)
/// ```
Pointer<Void>? glVDPAURegisterOutputSurfaceNV(Pointer<Void>? vdpSurface, int target, int numTextureNames, Pointer<Uint32>? textureNames) {
  final _glVDPAURegisterOutputSurfaceNV = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? vdpSurface, Uint32 target, Uint32 numTextureNames, Pointer<Uint32>? textureNames),
      Pointer<Void>? Function(Pointer<Void>? vdpSurface, int target, int numTextureNames, Pointer<Uint32>? textureNames)>('glVDPAURegisterOutputSurfaceNV');
  return _glVDPAURegisterOutputSurfaceNV(vdpSurface, target, numTextureNames, textureNames);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUIsSurfaceNV (GLvdpauSurfaceNV surface)
/// ```
void glVDPAUIsSurfaceNV(Pointer<Void>? surface) {
  final _glVDPAUIsSurfaceNV = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? surface),
      void Function(Pointer<Void>? surface)>('glVDPAUIsSurfaceNV');
  return _glVDPAUIsSurfaceNV(surface);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUUnregisterSurfaceNV (GLvdpauSurfaceNV surface)
/// ```
void glVDPAUUnregisterSurfaceNV(Pointer<Void>? surface) {
  final _glVDPAUUnregisterSurfaceNV = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? surface),
      void Function(Pointer<Void>? surface)>('glVDPAUUnregisterSurfaceNV');
  return _glVDPAUUnregisterSurfaceNV(surface);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUGetSurfaceivNV (GLvdpauSurfaceNV surface, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values)
/// ```
void glVDPAUGetSurfaceivNV(Pointer<Void>? surface, int pname, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? values) {
  final _glVDPAUGetSurfaceivNV = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? surface, Uint32 pname, Uint32 bufSize, Pointer<Uint32>? length, Pointer<Int32>? values),
      void Function(Pointer<Void>? surface, int pname, int bufSize, Pointer<Uint32>? length, Pointer<Int32>? values)>('glVDPAUGetSurfaceivNV');
  return _glVDPAUGetSurfaceivNV(surface, pname, bufSize, length, values);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUSurfaceAccessNV (GLvdpauSurfaceNV surface, GLenum access)
/// ```
void glVDPAUSurfaceAccessNV(Pointer<Void>? surface, int access) {
  final _glVDPAUSurfaceAccessNV = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? surface, Uint32 access),
      void Function(Pointer<Void>? surface, int access)>('glVDPAUSurfaceAccessNV');
  return _glVDPAUSurfaceAccessNV(surface, access);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUMapSurfacesNV (GLsizei numSurfaces, const GLvdpauSurfaceNV *surfaces)
/// ```
void glVDPAUMapSurfacesNV(int numSurfaces, Pointer<Pointer<Void>>? surfaces) {
  final _glVDPAUMapSurfacesNV = _SDL2.lookupFunction<
      Void Function(Uint32 numSurfaces, Pointer<Pointer<Void>>? surfaces),
      void Function(int numSurfaces, Pointer<Pointer<Void>>? surfaces)>('glVDPAUMapSurfacesNV');
  return _glVDPAUMapSurfacesNV(numSurfaces, surfaces);
}

/// ```c
/// GLAPI void APIENTRY glVDPAUUnmapSurfacesNV (GLsizei numSurface, const GLvdpauSurfaceNV *surfaces)
/// ```
void glVDPAUUnmapSurfacesNV(int numSurface, Pointer<Pointer<Void>>? surfaces) {
  final _glVDPAUUnmapSurfacesNV = _SDL2.lookupFunction<
      Void Function(Uint32 numSurface, Pointer<Pointer<Void>>? surfaces),
      void Function(int numSurface, Pointer<Pointer<Void>>? surfaces)>('glVDPAUUnmapSurfacesNV');
  return _glVDPAUUnmapSurfacesNV(numSurface, surfaces);
}

/// 
/// \brief Get the human readable name of a pixel format
/// 
/// ```c
/// extern DECLSPEC const char* SDLCALL SDL_GetPixelFormatName(Uint32 format)
/// ```
String SDL_GetPixelFormatName(int format) {
  final _SDL_GetPixelFormatName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Uint32 format),
      Pointer<Utf8>? Function(int format)>('SDL_GetPixelFormatName');
  return _SDL_GetPixelFormatName(format)!.toDartString();
}

/// 
/// \brief Convert one of the enumerated pixel formats to a bpp and RGBA masks.
/// 
/// \return SDL_TRUE, or SDL_FALSE if the conversion wasn't possible.
/// 
/// \sa SDL_MasksToPixelFormatEnum()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_PixelFormatEnumToMasks(Uint32 format, int *bpp, Uint32 * Rmask, Uint32 * Gmask, Uint32 * Bmask, Uint32 * Amask)
/// ```
int SDL_PixelFormatEnumToMasks(int format, Pointer<Int32>? bpp, Pointer<Uint32>? Rmask, Pointer<Uint32>? Gmask, Pointer<Uint32>? Bmask, Pointer<Uint32>? Amask) {
  final _SDL_PixelFormatEnumToMasks = _SDL2.lookupFunction<
      Int32 Function(Uint32 format, Pointer<Int32>? bpp, Pointer<Uint32>? Rmask, Pointer<Uint32>? Gmask, Pointer<Uint32>? Bmask, Pointer<Uint32>? Amask),
      int Function(int format, Pointer<Int32>? bpp, Pointer<Uint32>? Rmask, Pointer<Uint32>? Gmask, Pointer<Uint32>? Bmask, Pointer<Uint32>? Amask)>('SDL_PixelFormatEnumToMasks');
  return _SDL_PixelFormatEnumToMasks(format, bpp, Rmask, Gmask, Bmask, Amask);
}

/// 
/// \brief Convert a bpp and RGBA masks to an enumerated pixel format.
/// 
/// \return The pixel format, or ::SDL_PIXELFORMAT_UNKNOWN if the conversion
/// wasn't possible.
/// 
/// \sa SDL_PixelFormatEnumToMasks()
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_MasksToPixelFormatEnum(int bpp, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)
/// ```
int SDL_MasksToPixelFormatEnum(int bpp, int Rmask, int Gmask, int Bmask, int Amask) {
  final _SDL_MasksToPixelFormatEnum = _SDL2.lookupFunction<
      Uint32 Function(Int32 bpp, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask),
      int Function(int bpp, int Rmask, int Gmask, int Bmask, int Amask)>('SDL_MasksToPixelFormatEnum');
  return _SDL_MasksToPixelFormatEnum(bpp, Rmask, Gmask, Bmask, Amask);
}

/// 
/// \brief Create an SDL_PixelFormat structure from a pixel format enum.
/// 
/// ```c
/// extern DECLSPEC SDL_PixelFormat * SDLCALL SDL_AllocFormat(Uint32 pixel_format)
/// ```
Pointer<SDL_PixelFormat>? SDL_AllocFormat(int pixel_format) {
  final _SDL_AllocFormat = _SDL2.lookupFunction<
      Pointer<SDL_PixelFormat>? Function(Uint32 pixel_format),
      Pointer<SDL_PixelFormat>? Function(int pixel_format)>('SDL_AllocFormat');
  return _SDL_AllocFormat(pixel_format);
}

/// 
/// \brief Free an SDL_PixelFormat structure.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreeFormat(SDL_PixelFormat *format)
/// ```
void SDL_FreeFormat(Pointer<SDL_PixelFormat>? format) {
  final _SDL_FreeFormat = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_PixelFormat>? format),
      void Function(Pointer<SDL_PixelFormat>? format)>('SDL_FreeFormat');
  return _SDL_FreeFormat(format);
}

/// 
/// \brief Create a palette structure with the specified number of color
/// entries.
/// 
/// \return A new palette, or NULL if there wasn't enough memory.
/// 
/// \note The palette entries are initialized to white.
/// 
/// \sa SDL_FreePalette()
/// 
/// ```c
/// extern DECLSPEC SDL_Palette *SDLCALL SDL_AllocPalette(int ncolors)
/// ```
Pointer<SDL_Palette>? SDL_AllocPalette(int ncolors) {
  final _SDL_AllocPalette = _SDL2.lookupFunction<
      Pointer<SDL_Palette>? Function(Int32 ncolors),
      Pointer<SDL_Palette>? Function(int ncolors)>('SDL_AllocPalette');
  return _SDL_AllocPalette(ncolors);
}

/// 
/// \brief Set the palette for a pixel format structure.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetPixelFormatPalette(SDL_PixelFormat * format, SDL_Palette *palette)
/// ```
int SDL_SetPixelFormatPalette(Pointer<SDL_PixelFormat>? format, Pointer<SDL_Palette>? palette) {
  final _SDL_SetPixelFormatPalette = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_PixelFormat>? format, Pointer<SDL_Palette>? palette),
      int Function(Pointer<SDL_PixelFormat>? format, Pointer<SDL_Palette>? palette)>('SDL_SetPixelFormatPalette');
  return _SDL_SetPixelFormatPalette(format, palette);
}

/// 
/// \brief Set a range of colors in a palette.
/// 
/// \param palette    The palette to modify.
/// \param colors     An array of colors to copy into the palette.
/// \param firstcolor The index of the first palette entry to modify.
/// \param ncolors    The number of entries to modify.
/// 
/// \return 0 on success, or -1 if not all of the colors could be set.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetPaletteColors(SDL_Palette * palette, const SDL_Color * colors, int firstcolor, int ncolors)
/// ```
int SDL_SetPaletteColors(Pointer<SDL_Palette>? palette, Pointer<SDL_Color>? colors, int firstcolor, int ncolors) {
  final _SDL_SetPaletteColors = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Palette>? palette, Pointer<SDL_Color>? colors, Int32 firstcolor, Int32 ncolors),
      int Function(Pointer<SDL_Palette>? palette, Pointer<SDL_Color>? colors, int firstcolor, int ncolors)>('SDL_SetPaletteColors');
  return _SDL_SetPaletteColors(palette, colors, firstcolor, ncolors);
}

/// 
/// \brief Free a palette created with SDL_AllocPalette().
/// 
/// \sa SDL_AllocPalette()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreePalette(SDL_Palette * palette)
/// ```
void SDL_FreePalette(Pointer<SDL_Palette>? palette) {
  final _SDL_FreePalette = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Palette>? palette),
      void Function(Pointer<SDL_Palette>? palette)>('SDL_FreePalette');
  return _SDL_FreePalette(palette);
}

/// 
/// \brief Maps an RGB triple to an opaque pixel value for a given pixel format.
/// 
/// \sa SDL_MapRGBA
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_MapRGB(const SDL_PixelFormat * format, Uint8 r, Uint8 g, Uint8 b)
/// ```
int SDL_MapRGB(Pointer<SDL_PixelFormat>? format, int r, int g, int b) {
  final _SDL_MapRGB = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_PixelFormat>? format, Uint8 r, Uint8 g, Uint8 b),
      int Function(Pointer<SDL_PixelFormat>? format, int r, int g, int b)>('SDL_MapRGB');
  return _SDL_MapRGB(format, r, g, b);
}

/// 
/// \brief Maps an RGBA quadruple to a pixel value for a given pixel format.
/// 
/// \sa SDL_MapRGB
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_MapRGBA(const SDL_PixelFormat * format, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
/// ```
int SDL_MapRGBA(Pointer<SDL_PixelFormat>? format, int r, int g, int b, int a) {
  final _SDL_MapRGBA = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_PixelFormat>? format, Uint8 r, Uint8 g, Uint8 b, Uint8 a),
      int Function(Pointer<SDL_PixelFormat>? format, int r, int g, int b, int a)>('SDL_MapRGBA');
  return _SDL_MapRGBA(format, r, g, b, a);
}

/// 
/// \brief Get the RGB components from a pixel of the specified format.
/// 
/// \sa SDL_GetRGBA
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetRGB(Uint32 pixel, const SDL_PixelFormat * format, Uint8 * r, Uint8 * g, Uint8 * b)
/// ```
void SDL_GetRGB(int pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b) {
  final _SDL_GetRGB = _SDL2.lookupFunction<
      Void Function(Uint32 pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b),
      void Function(int pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b)>('SDL_GetRGB');
  return _SDL_GetRGB(pixel, format, r, g, b);
}

/// 
/// \brief Get the RGBA components from a pixel of the specified format.
/// 
/// \sa SDL_GetRGB
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetRGBA(Uint32 pixel, const SDL_PixelFormat * format, Uint8 * r, Uint8 * g, Uint8 * b, Uint8 * a)
/// ```
void SDL_GetRGBA(int pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a) {
  final _SDL_GetRGBA = _SDL2.lookupFunction<
      Void Function(Uint32 pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a),
      void Function(int pixel, Pointer<SDL_PixelFormat>? format, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a)>('SDL_GetRGBA');
  return _SDL_GetRGBA(pixel, format, r, g, b, a);
}

/// 
/// \brief Calculate a 256 entry gamma ramp for a gamma value.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_CalculateGammaRamp(float gamma, Uint16 * ramp)
/// ```
void SDL_CalculateGammaRamp(double gamma, Pointer<Uint16>? ramp) {
  final _SDL_CalculateGammaRamp = _SDL2.lookupFunction<
      Void Function(Float gamma, Pointer<Uint16>? ramp),
      void Function(double gamma, Pointer<Uint16>? ramp)>('SDL_CalculateGammaRamp');
  return _SDL_CalculateGammaRamp(gamma, ramp);
}

/// 
/// \brief Gets the name of the platform.
/// 
/// ```c
/// extern DECLSPEC const char * SDLCALL SDL_GetPlatform (void)
/// ```
String SDL_GetPlatform() {
  final _SDL_GetPlatform = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_GetPlatform');
  return _SDL_GetPlatform()!.toDartString();
}

/// 
/// \brief Get the current power supply details.
/// 
/// \param secs Seconds of battery life left. You can pass a NULL here if
/// you don't care. Will return -1 if we can't determine a
/// value, or we're not running on a battery.
/// 
/// \param pct Percentage of battery life left, between 0 and 100. You can
/// pass a NULL here if you don't care. Will return -1 if we
/// can't determine a value, or we're not running on a battery.
/// 
/// \return The state of the battery (if any).
/// 
/// ```c
/// extern DECLSPEC SDL_PowerState SDLCALL SDL_GetPowerInfo(int *secs, int *pct)
/// ```
int SDL_GetPowerInfo(Pointer<Int32>? secs, Pointer<Int32>? pct) {
  final _SDL_GetPowerInfo = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int32>? secs, Pointer<Int32>? pct),
      int Function(Pointer<Int32>? secs, Pointer<Int32>? pct)>('SDL_GetPowerInfo');
  return _SDL_GetPowerInfo(secs, pct);
}

/// 
/// \brief Determine whether two rectangles intersect.
/// 
/// \return SDL_TRUE if there is an intersection, SDL_FALSE otherwise.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_HasIntersection(const SDL_Rect * A, const SDL_Rect * B)
/// ```
int SDL_HasIntersection(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B) {
  final _SDL_HasIntersection = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B),
      int Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B)>('SDL_HasIntersection');
  return _SDL_HasIntersection(A, B);
}

/// 
/// \brief Calculate the intersection of two rectangles.
/// 
/// \return SDL_TRUE if there is an intersection, SDL_FALSE otherwise.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IntersectRect(const SDL_Rect * A, const SDL_Rect * B, SDL_Rect * result)
/// ```
int SDL_IntersectRect(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result) {
  final _SDL_IntersectRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result),
      int Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result)>('SDL_IntersectRect');
  return _SDL_IntersectRect(A, B, result);
}

/// 
/// \brief Calculate the union of two rectangles.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnionRect(const SDL_Rect * A, const SDL_Rect * B, SDL_Rect * result)
/// ```
void SDL_UnionRect(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result) {
  final _SDL_UnionRect = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result),
      void Function(Pointer<SDL_Rect>? A, Pointer<SDL_Rect>? B, Pointer<SDL_Rect>? result)>('SDL_UnionRect');
  return _SDL_UnionRect(A, B, result);
}

/// 
/// \brief Calculate a minimal rectangle enclosing a set of points
/// 
/// \return SDL_TRUE if any points were within the clipping rect
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_EnclosePoints(const SDL_Point * points, int count, const SDL_Rect * clip, SDL_Rect * result)
/// ```
int SDL_EnclosePoints(Pointer<SDL_Point>? points, int count, Pointer<SDL_Rect>? clip, Pointer<SDL_Rect>? result) {
  final _SDL_EnclosePoints = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Point>? points, Int32 count, Pointer<SDL_Rect>? clip, Pointer<SDL_Rect>? result),
      int Function(Pointer<SDL_Point>? points, int count, Pointer<SDL_Rect>? clip, Pointer<SDL_Rect>? result)>('SDL_EnclosePoints');
  return _SDL_EnclosePoints(points, count, clip, result);
}

/// 
/// \brief Calculate the intersection of a rectangle and line segment.
/// 
/// \return SDL_TRUE if there is an intersection, SDL_FALSE otherwise.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IntersectRectAndLine(const SDL_Rect * rect, int *X1, int *Y1, int *X2, int *Y2)
/// ```
int SDL_IntersectRectAndLine(Pointer<SDL_Rect>? rect, Pointer<Int32>? X1, Pointer<Int32>? Y1, Pointer<Int32>? X2, Pointer<Int32>? Y2) {
  final _SDL_IntersectRectAndLine = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Rect>? rect, Pointer<Int32>? X1, Pointer<Int32>? Y1, Pointer<Int32>? X2, Pointer<Int32>? Y2),
      int Function(Pointer<SDL_Rect>? rect, Pointer<Int32>? X1, Pointer<Int32>? Y1, Pointer<Int32>? X2, Pointer<Int32>? Y2)>('SDL_IntersectRectAndLine');
  return _SDL_IntersectRectAndLine(rect, X1, Y1, X2, Y2);
}

/// 
/// \brief Get the number of 2D rendering drivers available for the current
/// display.
/// 
/// A render driver is a set of code that handles rendering and texture
/// management on a particular display.  Normally there is only one, but
/// some drivers may have several available with different capabilities.
/// 
/// \sa SDL_GetRenderDriverInfo()
/// \sa SDL_CreateRenderer()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumRenderDrivers(void)
/// ```
int SDL_GetNumRenderDrivers() {
  final _SDL_GetNumRenderDrivers = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetNumRenderDrivers');
  return _SDL_GetNumRenderDrivers();
}

/// 
/// \brief Get information about a specific 2D rendering driver for the current
/// display.
/// 
/// \param index The index of the driver to query information about.
/// \param info  A pointer to an SDL_RendererInfo struct to be filled with
/// information on the rendering driver.
/// 
/// \return 0 on success, -1 if the index was out of range.
/// 
/// \sa SDL_CreateRenderer()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetRenderDriverInfo(int index, SDL_RendererInfo * info)
/// ```
int SDL_GetRenderDriverInfo(int index, Pointer<SDL_RendererInfo>? info) {
  final _SDL_GetRenderDriverInfo = _SDL2.lookupFunction<
      Int32 Function(Int32 index, Pointer<SDL_RendererInfo>? info),
      int Function(int index, Pointer<SDL_RendererInfo>? info)>('SDL_GetRenderDriverInfo');
  return _SDL_GetRenderDriverInfo(index, info);
}

/// 
/// \brief Create a window and default renderer
/// 
/// \param width    The width of the window
/// \param height   The height of the window
/// \param window_flags The flags used to create the window
/// \param window   A pointer filled with the window, or NULL on error
/// \param renderer A pointer filled with the renderer, or NULL on error
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_CreateWindowAndRenderer( int width, int height, Uint32 window_flags, SDL_Window **window, SDL_Renderer **renderer)
/// ```
int SDL_CreateWindowAndRenderer(int width, int height, int window_flags, Pointer<Pointer<SDL_Window>>? window, Pointer<Pointer<SDL_Renderer>>? renderer) {
  final _SDL_CreateWindowAndRenderer = _SDL2.lookupFunction<
      Int32 Function(Int32 width, Int32 height, Uint32 window_flags, Pointer<Pointer<SDL_Window>>? window, Pointer<Pointer<SDL_Renderer>>? renderer),
      int Function(int width, int height, int window_flags, Pointer<Pointer<SDL_Window>>? window, Pointer<Pointer<SDL_Renderer>>? renderer)>('SDL_CreateWindowAndRenderer');
  return _SDL_CreateWindowAndRenderer(width, height, window_flags, window, renderer);
}

/// 
/// \brief Create a 2D rendering context for a window.
/// 
/// \param window The window where rendering is displayed.
/// \param index    The index of the rendering driver to initialize, or -1 to
/// initialize the first one supporting the requested flags.
/// \param flags    ::SDL_RendererFlags.
/// 
/// \return A valid rendering context or NULL if there was an error.
/// 
/// \sa SDL_CreateSoftwareRenderer()
/// \sa SDL_GetRendererInfo()
/// \sa SDL_DestroyRenderer()
/// 
/// ```c
/// extern DECLSPEC SDL_Renderer * SDLCALL SDL_CreateRenderer(SDL_Window * window, int index, Uint32 flags)
/// ```
Pointer<SDL_Renderer>? SDL_CreateRenderer(Pointer<SDL_Window>? window, int index, int flags) {
  final _SDL_CreateRenderer = _SDL2.lookupFunction<
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Window>? window, Int32 index, Uint32 flags),
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Window>? window, int index, int flags)>('SDL_CreateRenderer');
  return _SDL_CreateRenderer(window, index, flags);
}

/// 
/// \brief Create a 2D software rendering context for a surface.
/// 
/// \param surface The surface where rendering is done.
/// 
/// \return A valid rendering context or NULL if there was an error.
/// 
/// \sa SDL_CreateRenderer()
/// \sa SDL_DestroyRenderer()
/// 
/// ```c
/// extern DECLSPEC SDL_Renderer * SDLCALL SDL_CreateSoftwareRenderer(SDL_Surface * surface)
/// ```
Pointer<SDL_Renderer>? SDL_CreateSoftwareRenderer(Pointer<SDL_Surface>? surface) {
  final _SDL_CreateSoftwareRenderer = _SDL2.lookupFunction<
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Surface>? surface),
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Surface>? surface)>('SDL_CreateSoftwareRenderer');
  return _SDL_CreateSoftwareRenderer(surface);
}

/// 
/// \brief Get the renderer associated with a window.
/// 
/// ```c
/// extern DECLSPEC SDL_Renderer * SDLCALL SDL_GetRenderer(SDL_Window * window)
/// ```
Pointer<SDL_Renderer>? SDL_GetRenderer(Pointer<SDL_Window>? window) {
  final _SDL_GetRenderer = _SDL2.lookupFunction<
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Window>? window),
      Pointer<SDL_Renderer>? Function(Pointer<SDL_Window>? window)>('SDL_GetRenderer');
  return _SDL_GetRenderer(window);
}

/// 
/// \brief Get information about a rendering context.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetRendererInfo(SDL_Renderer * renderer, SDL_RendererInfo * info)
/// ```
int SDL_GetRendererInfo(Pointer<SDL_Renderer>? renderer, Pointer<SDL_RendererInfo>? info) {
  final _SDL_GetRendererInfo = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_RendererInfo>? info),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_RendererInfo>? info)>('SDL_GetRendererInfo');
  return _SDL_GetRendererInfo(renderer, info);
}

/// 
/// \brief Get the output size of a rendering context.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetRendererOutputSize(SDL_Renderer * renderer, int *w, int *h)
/// ```
int SDL_GetRendererOutputSize(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_GetRendererOutputSize = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_GetRendererOutputSize');
  return _SDL_GetRendererOutputSize(renderer, w, h);
}

/// 
/// \brief Create a texture for a rendering context.
/// 
/// \param renderer The renderer.
/// \param format The format of the texture.
/// \param access One of the enumerated values in ::SDL_TextureAccess.
/// \param w      The width of the texture in pixels.
/// \param h      The height of the texture in pixels.
/// 
/// \return The created texture is returned, or 0 if no rendering context was
/// active,  the format was unsupported, or the width or height were out
/// of range.
/// 
/// \sa SDL_QueryTexture()
/// \sa SDL_UpdateTexture()
/// \sa SDL_DestroyTexture()
/// 
/// ```c
/// extern DECLSPEC SDL_Texture * SDLCALL SDL_CreateTexture(SDL_Renderer * renderer, Uint32 format, int access, int w, int h)
/// ```
Pointer<SDL_Texture>? SDL_CreateTexture(Pointer<SDL_Renderer>? renderer, int format, int access, int w, int h) {
  final _SDL_CreateTexture = _SDL2.lookupFunction<
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer, Uint32 format, Int32 access, Int32 w, Int32 h),
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer, int format, int access, int w, int h)>('SDL_CreateTexture');
  return _SDL_CreateTexture(renderer, format, access, w, h);
}

/// 
/// \brief Create a texture from an existing surface.
/// 
/// \param renderer The renderer.
/// \param surface The surface containing pixel data used to fill the texture.
/// 
/// \return The created texture is returned, or 0 on error.
/// 
/// \note The surface is not modified or freed by this function.
/// 
/// \sa SDL_QueryTexture()
/// \sa SDL_DestroyTexture()
/// 
/// ```c
/// extern DECLSPEC SDL_Texture * SDLCALL SDL_CreateTextureFromSurface(SDL_Renderer * renderer, SDL_Surface * surface)
/// ```
Pointer<SDL_Texture>? SDL_CreateTextureFromSurface(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Surface>? surface) {
  final _SDL_CreateTextureFromSurface = _SDL2.lookupFunction<
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Surface>? surface),
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Surface>? surface)>('SDL_CreateTextureFromSurface');
  return _SDL_CreateTextureFromSurface(renderer, surface);
}

/// 
/// \brief Query the attributes of a texture
/// 
/// \param texture A texture to be queried.
/// \param format  A pointer filled in with the raw format of the texture.  The
/// actual format may differ, but pixel transfers will use this
/// format.
/// \param access  A pointer filled in with the actual access to the texture.
/// \param w       A pointer filled in with the width of the texture in pixels.
/// \param h       A pointer filled in with the height of the texture in pixels.
/// 
/// \return 0 on success, or -1 if the texture is not valid.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_QueryTexture(SDL_Texture * texture, Uint32 * format, int *access, int *w, int *h)
/// ```
int SDL_QueryTexture(Pointer<SDL_Texture>? texture, Pointer<Uint32>? format, Pointer<Int32>? access, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_QueryTexture = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<Uint32>? format, Pointer<Int32>? access, Pointer<Int32>? w, Pointer<Int32>? h),
      int Function(Pointer<SDL_Texture>? texture, Pointer<Uint32>? format, Pointer<Int32>? access, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_QueryTexture');
  return _SDL_QueryTexture(texture, format, access, w, h);
}

/// 
/// \brief Set an additional color value used in render copy operations.
/// 
/// \param texture The texture to update.
/// \param r       The red color value multiplied into copy operations.
/// \param g       The green color value multiplied into copy operations.
/// \param b       The blue color value multiplied into copy operations.
/// 
/// \return 0 on success, or -1 if the texture is not valid or color modulation
/// is not supported.
/// 
/// \sa SDL_GetTextureColorMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetTextureColorMod(SDL_Texture * texture, Uint8 r, Uint8 g, Uint8 b)
/// ```
int SDL_SetTextureColorMod(Pointer<SDL_Texture>? texture, int r, int g, int b) {
  final _SDL_SetTextureColorMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Uint8 r, Uint8 g, Uint8 b),
      int Function(Pointer<SDL_Texture>? texture, int r, int g, int b)>('SDL_SetTextureColorMod');
  return _SDL_SetTextureColorMod(texture, r, g, b);
}

/// 
/// \brief Get the additional color value used in render copy operations.
/// 
/// \param texture The texture to query.
/// \param r         A pointer filled in with the current red color value.
/// \param g         A pointer filled in with the current green color value.
/// \param b         A pointer filled in with the current blue color value.
/// 
/// \return 0 on success, or -1 if the texture is not valid.
/// 
/// \sa SDL_SetTextureColorMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetTextureColorMod(SDL_Texture * texture, Uint8 * r, Uint8 * g, Uint8 * b)
/// ```
int SDL_GetTextureColorMod(Pointer<SDL_Texture>? texture, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b) {
  final _SDL_GetTextureColorMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b),
      int Function(Pointer<SDL_Texture>? texture, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b)>('SDL_GetTextureColorMod');
  return _SDL_GetTextureColorMod(texture, r, g, b);
}

/// 
/// \brief Set an additional alpha value used in render copy operations.
/// 
/// \param texture The texture to update.
/// \param alpha     The alpha value multiplied into copy operations.
/// 
/// \return 0 on success, or -1 if the texture is not valid or alpha modulation
/// is not supported.
/// 
/// \sa SDL_GetTextureAlphaMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetTextureAlphaMod(SDL_Texture * texture, Uint8 alpha)
/// ```
int SDL_SetTextureAlphaMod(Pointer<SDL_Texture>? texture, int alpha) {
  final _SDL_SetTextureAlphaMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Uint8 alpha),
      int Function(Pointer<SDL_Texture>? texture, int alpha)>('SDL_SetTextureAlphaMod');
  return _SDL_SetTextureAlphaMod(texture, alpha);
}

/// 
/// \brief Get the additional alpha value used in render copy operations.
/// 
/// \param texture The texture to query.
/// \param alpha     A pointer filled in with the current alpha value.
/// 
/// \return 0 on success, or -1 if the texture is not valid.
/// 
/// \sa SDL_SetTextureAlphaMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetTextureAlphaMod(SDL_Texture * texture, Uint8 * alpha)
/// ```
int SDL_GetTextureAlphaMod(Pointer<SDL_Texture>? texture, Pointer<Uint8>? alpha) {
  final _SDL_GetTextureAlphaMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<Uint8>? alpha),
      int Function(Pointer<SDL_Texture>? texture, Pointer<Uint8>? alpha)>('SDL_GetTextureAlphaMod');
  return _SDL_GetTextureAlphaMod(texture, alpha);
}

/// 
/// \brief Set the blend mode used for texture copy operations.
/// 
/// \param texture The texture to update.
/// \param blendMode ::SDL_BlendMode to use for texture blending.
/// 
/// \return 0 on success, or -1 if the texture is not valid or the blend mode is
/// not supported.
/// 
/// \note If the blend mode is not supported, the closest supported mode is
/// chosen.
/// 
/// \sa SDL_GetTextureBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetTextureBlendMode(SDL_Texture * texture, SDL_BlendMode blendMode)
/// ```
int SDL_SetTextureBlendMode(Pointer<SDL_Texture>? texture, int blendMode) {
  final _SDL_SetTextureBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Int32 blendMode),
      int Function(Pointer<SDL_Texture>? texture, int blendMode)>('SDL_SetTextureBlendMode');
  return _SDL_SetTextureBlendMode(texture, blendMode);
}

/// 
/// \brief Get the blend mode used for texture copy operations.
/// 
/// \param texture   The texture to query.
/// \param blendMode A pointer filled in with the current blend mode.
/// 
/// \return 0 on success, or -1 if the texture is not valid.
/// 
/// \sa SDL_SetTextureBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetTextureBlendMode(SDL_Texture * texture, SDL_BlendMode *blendMode)
/// ```
int SDL_GetTextureBlendMode(Pointer<SDL_Texture>? texture, Pointer<Int32>? blendMode) {
  final _SDL_GetTextureBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<Int32>? blendMode),
      int Function(Pointer<SDL_Texture>? texture, Pointer<Int32>? blendMode)>('SDL_GetTextureBlendMode');
  return _SDL_GetTextureBlendMode(texture, blendMode);
}

/// 
/// \brief Update the given texture rectangle with new pixel data.
/// 
/// \param texture   The texture to update
/// \param rect      A pointer to the rectangle of pixels to update, or NULL to
/// update the entire texture.
/// \param pixels    The raw pixel data.
/// \param pitch     The number of bytes between rows of pixel data.
/// 
/// \return 0 on success, or -1 if the texture is not valid.
/// 
/// \note This is a fairly slow function.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UpdateTexture(SDL_Texture * texture, const SDL_Rect * rect, const void *pixels, int pitch)
/// ```
int SDL_UpdateTexture(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Void>? pixels, int pitch) {
  final _SDL_UpdateTexture = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Void>? pixels, Int32 pitch),
      int Function(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Void>? pixels, int pitch)>('SDL_UpdateTexture');
  return _SDL_UpdateTexture(texture, rect, pixels, pitch);
}

/// 
/// \brief Lock a portion of the texture for write-only pixel access.
/// 
/// \param texture   The texture to lock for access, which was created with
/// ::SDL_TEXTUREACCESS_STREAMING.
/// \param rect      A pointer to the rectangle to lock for access. If the rect
/// is NULL, the entire texture will be locked.
/// \param pixels    This is filled in with a pointer to the locked pixels,
/// appropriately offset by the locked area.
/// \param pitch     This is filled in with the pitch of the locked pixels.
/// 
/// \return 0 on success, or -1 if the texture is not valid or was not created with ::SDL_TEXTUREACCESS_STREAMING.
/// 
/// \sa SDL_UnlockTexture()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LockTexture(SDL_Texture * texture, const SDL_Rect * rect, void **pixels, int *pitch)
/// ```
int SDL_LockTexture(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Pointer<Void>>? pixels, Pointer<Int32>? pitch) {
  final _SDL_LockTexture = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Pointer<Void>>? pixels, Pointer<Int32>? pitch),
      int Function(Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? rect, Pointer<Pointer<Void>>? pixels, Pointer<Int32>? pitch)>('SDL_LockTexture');
  return _SDL_LockTexture(texture, rect, pixels, pitch);
}

/// 
/// \brief Unlock a texture, uploading the changes to video memory, if needed.
/// 
/// \sa SDL_LockTexture()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnlockTexture(SDL_Texture * texture)
/// ```
void SDL_UnlockTexture(Pointer<SDL_Texture>? texture) {
  final _SDL_UnlockTexture = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Texture>? texture),
      void Function(Pointer<SDL_Texture>? texture)>('SDL_UnlockTexture');
  return _SDL_UnlockTexture(texture);
}

/// 
/// \brief Determines whether a window supports the use of render targets
/// 
/// \param renderer The renderer that will be checked
/// 
/// \return SDL_TRUE if supported, SDL_FALSE if not.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_RenderTargetSupported(SDL_Renderer *renderer)
/// ```
int SDL_RenderTargetSupported(Pointer<SDL_Renderer>? renderer) {
  final _SDL_RenderTargetSupported = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer),
      int Function(Pointer<SDL_Renderer>? renderer)>('SDL_RenderTargetSupported');
  return _SDL_RenderTargetSupported(renderer);
}

/// 
/// \brief Set a texture as the current rendering target.
/// 
/// \param renderer The renderer.
/// \param texture The targeted texture, which must be created with the SDL_TEXTUREACCESS_TARGET flag, or NULL for the default render target
/// 
/// \return 0 on success, or -1 on error
/// 
/// \sa SDL_GetRenderTarget()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetRenderTarget(SDL_Renderer *renderer, SDL_Texture *texture)
/// ```
int SDL_SetRenderTarget(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture) {
  final _SDL_SetRenderTarget = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture)>('SDL_SetRenderTarget');
  return _SDL_SetRenderTarget(renderer, texture);
}

/// 
/// \brief Get the current render target or NULL for the default render target.
/// 
/// \return The current render target
/// 
/// \sa SDL_SetRenderTarget()
/// 
/// ```c
/// extern DECLSPEC SDL_Texture * SDLCALL SDL_GetRenderTarget(SDL_Renderer *renderer)
/// ```
Pointer<SDL_Texture>? SDL_GetRenderTarget(Pointer<SDL_Renderer>? renderer) {
  final _SDL_GetRenderTarget = _SDL2.lookupFunction<
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer),
      Pointer<SDL_Texture>? Function(Pointer<SDL_Renderer>? renderer)>('SDL_GetRenderTarget');
  return _SDL_GetRenderTarget(renderer);
}

/// 
/// \brief Set device independent resolution for rendering
/// 
/// \param renderer The renderer for which resolution should be set.
/// \param w      The width of the logical resolution
/// \param h      The height of the logical resolution
/// 
/// This function uses the viewport and scaling functionality to allow a fixed logical
/// resolution for rendering, regardless of the actual output resolution.  If the actual
/// output resolution doesn't have the same aspect ratio the output rendering will be
/// centered within the output display.
/// 
/// If the output display is a window, mouse events in the window will be filtered
/// and scaled so they seem to arrive within the logical resolution.
/// 
/// \note If this function results in scaling or subpixel drawing by the
/// rendering backend, it will be handled using the appropriate
/// quality hints.
/// 
/// \sa SDL_RenderGetLogicalSize()
/// \sa SDL_RenderSetScale()
/// \sa SDL_RenderSetViewport()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderSetLogicalSize(SDL_Renderer * renderer, int w, int h)
/// ```
int SDL_RenderSetLogicalSize(Pointer<SDL_Renderer>? renderer, int w, int h) {
  final _SDL_RenderSetLogicalSize = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Int32 w, Int32 h),
      int Function(Pointer<SDL_Renderer>? renderer, int w, int h)>('SDL_RenderSetLogicalSize');
  return _SDL_RenderSetLogicalSize(renderer, w, h);
}

/// 
/// \brief Get device independent resolution for rendering
/// 
/// \param renderer The renderer from which resolution should be queried.
/// \param w      A pointer filled with the width of the logical resolution
/// \param h      A pointer filled with the height of the logical resolution
/// 
/// \sa SDL_RenderSetLogicalSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RenderGetLogicalSize(SDL_Renderer * renderer, int *w, int *h)
/// ```
void SDL_RenderGetLogicalSize(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_RenderGetLogicalSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h),
      void Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_RenderGetLogicalSize');
  return _SDL_RenderGetLogicalSize(renderer, w, h);
}

/// 
/// \brief Set the drawing area for rendering on the current target.
/// 
/// \param renderer The renderer for which the drawing area should be set.
/// \param rect The rectangle representing the drawing area, or NULL to set the viewport to the entire target.
/// 
/// The x,y of the viewport rect represents the origin for rendering.
/// 
/// \return 0 on success, or -1 on error
/// 
/// \note If the window associated with the renderer is resized, the viewport is automatically reset.
/// 
/// \sa SDL_RenderGetViewport()
/// \sa SDL_RenderSetLogicalSize()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderSetViewport(SDL_Renderer * renderer, const SDL_Rect * rect)
/// ```
int SDL_RenderSetViewport(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderSetViewport = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderSetViewport');
  return _SDL_RenderSetViewport(renderer, rect);
}

/// 
/// \brief Get the drawing area for the current target.
/// 
/// \sa SDL_RenderSetViewport()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RenderGetViewport(SDL_Renderer * renderer, SDL_Rect * rect)
/// ```
void SDL_RenderGetViewport(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderGetViewport = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      void Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderGetViewport');
  return _SDL_RenderGetViewport(renderer, rect);
}

/// 
/// \brief Set the clip rectangle for the current target.
/// 
/// \param renderer The renderer for which clip rectangle should be set.
/// \param rect   A pointer to the rectangle to set as the clip rectangle, or
/// NULL to disable clipping.
/// 
/// \return 0 on success, or -1 on error
/// 
/// \sa SDL_RenderGetClipRect()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderSetClipRect(SDL_Renderer * renderer, const SDL_Rect * rect)
/// ```
int SDL_RenderSetClipRect(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderSetClipRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderSetClipRect');
  return _SDL_RenderSetClipRect(renderer, rect);
}

/// 
/// \brief Get the clip rectangle for the current target.
/// 
/// \param renderer The renderer from which clip rectangle should be queried.
/// \param rect   A pointer filled in with the current clip rectangle, or
/// an empty rectangle if clipping is disabled.
/// 
/// \sa SDL_RenderSetClipRect()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RenderGetClipRect(SDL_Renderer * renderer, SDL_Rect * rect)
/// ```
void SDL_RenderGetClipRect(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderGetClipRect = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      void Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderGetClipRect');
  return _SDL_RenderGetClipRect(renderer, rect);
}

/// 
/// \brief Set the drawing scale for rendering on the current target.
/// 
/// \param renderer The renderer for which the drawing scale should be set.
/// \param scaleX The horizontal scaling factor
/// \param scaleY The vertical scaling factor
/// 
/// The drawing coordinates are scaled by the x/y scaling factors
/// before they are used by the renderer.  This allows resolution
/// independent drawing with a single coordinate system.
/// 
/// \note If this results in scaling or subpixel drawing by the
/// rendering backend, it will be handled using the appropriate
/// quality hints.  For best results use integer scaling factors.
/// 
/// \sa SDL_RenderGetScale()
/// \sa SDL_RenderSetLogicalSize()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderSetScale(SDL_Renderer * renderer, float scaleX, float scaleY)
/// ```
int SDL_RenderSetScale(Pointer<SDL_Renderer>? renderer, double scaleX, double scaleY) {
  final _SDL_RenderSetScale = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Float scaleX, Float scaleY),
      int Function(Pointer<SDL_Renderer>? renderer, double scaleX, double scaleY)>('SDL_RenderSetScale');
  return _SDL_RenderSetScale(renderer, scaleX, scaleY);
}

/// 
/// \brief Get the drawing scale for the current target.
/// 
/// \param renderer The renderer from which drawing scale should be queried.
/// \param scaleX A pointer filled in with the horizontal scaling factor
/// \param scaleY A pointer filled in with the vertical scaling factor
/// 
/// \sa SDL_RenderSetScale()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RenderGetScale(SDL_Renderer * renderer, float *scaleX, float *scaleY)
/// ```
void SDL_RenderGetScale(Pointer<SDL_Renderer>? renderer, Pointer<Float>? scaleX, Pointer<Float>? scaleY) {
  final _SDL_RenderGetScale = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer, Pointer<Float>? scaleX, Pointer<Float>? scaleY),
      void Function(Pointer<SDL_Renderer>? renderer, Pointer<Float>? scaleX, Pointer<Float>? scaleY)>('SDL_RenderGetScale');
  return _SDL_RenderGetScale(renderer, scaleX, scaleY);
}

/// 
/// \brief Set the color used for drawing operations (Rect, Line and Clear).
/// 
/// \param renderer The renderer for which drawing color should be set.
/// \param r The red value used to draw on the rendering target.
/// \param g The green value used to draw on the rendering target.
/// \param b The blue value used to draw on the rendering target.
/// \param a The alpha value used to draw on the rendering target, usually
/// ::SDL_ALPHA_OPAQUE (255).
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDL_SetRenderDrawColor(SDL_Renderer * renderer, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
/// ```
int SDL_SetRenderDrawColor(Pointer<SDL_Renderer>? renderer, int r, int g, int b, int a) {
  final _SDL_SetRenderDrawColor = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Uint8 r, Uint8 g, Uint8 b, Uint8 a),
      int Function(Pointer<SDL_Renderer>? renderer, int r, int g, int b, int a)>('SDL_SetRenderDrawColor');
  return _SDL_SetRenderDrawColor(renderer, r, g, b, a);
}

/// 
/// \brief Get the color used for drawing operations (Rect, Line and Clear).
/// 
/// \param renderer The renderer from which drawing color should be queried.
/// \param r A pointer to the red value used to draw on the rendering target.
/// \param g A pointer to the green value used to draw on the rendering target.
/// \param b A pointer to the blue value used to draw on the rendering target.
/// \param a A pointer to the alpha value used to draw on the rendering target,
/// usually ::SDL_ALPHA_OPAQUE (255).
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDL_GetRenderDrawColor(SDL_Renderer * renderer, Uint8 * r, Uint8 * g, Uint8 * b, Uint8 * a)
/// ```
int SDL_GetRenderDrawColor(Pointer<SDL_Renderer>? renderer, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a) {
  final _SDL_GetRenderDrawColor = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b, Pointer<Uint8>? a)>('SDL_GetRenderDrawColor');
  return _SDL_GetRenderDrawColor(renderer, r, g, b, a);
}

/// 
/// \brief Set the blend mode used for drawing operations (Fill and Line).
/// 
/// \param renderer The renderer for which blend mode should be set.
/// \param blendMode ::SDL_BlendMode to use for blending.
/// 
/// \return 0 on success, or -1 on error
/// 
/// \note If the blend mode is not supported, the closest supported mode is
/// chosen.
/// 
/// \sa SDL_GetRenderDrawBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetRenderDrawBlendMode(SDL_Renderer * renderer, SDL_BlendMode blendMode)
/// ```
int SDL_SetRenderDrawBlendMode(Pointer<SDL_Renderer>? renderer, int blendMode) {
  final _SDL_SetRenderDrawBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Int32 blendMode),
      int Function(Pointer<SDL_Renderer>? renderer, int blendMode)>('SDL_SetRenderDrawBlendMode');
  return _SDL_SetRenderDrawBlendMode(renderer, blendMode);
}

/// 
/// \brief Get the blend mode used for drawing operations.
/// 
/// \param renderer The renderer from which blend mode should be queried.
/// \param blendMode A pointer filled in with the current blend mode.
/// 
/// \return 0 on success, or -1 on error
/// 
/// \sa SDL_SetRenderDrawBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetRenderDrawBlendMode(SDL_Renderer * renderer, SDL_BlendMode *blendMode)
/// ```
int SDL_GetRenderDrawBlendMode(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? blendMode) {
  final _SDL_GetRenderDrawBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? blendMode),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<Int32>? blendMode)>('SDL_GetRenderDrawBlendMode');
  return _SDL_GetRenderDrawBlendMode(renderer, blendMode);
}

/// 
/// \brief Clear the current rendering target with the drawing color
/// 
/// This function clears the entire rendering target, ignoring the viewport.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderClear(SDL_Renderer * renderer)
/// ```
int SDL_RenderClear(Pointer<SDL_Renderer>? renderer) {
  final _SDL_RenderClear = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer),
      int Function(Pointer<SDL_Renderer>? renderer)>('SDL_RenderClear');
  return _SDL_RenderClear(renderer);
}

/// 
/// \brief Draw a point on the current rendering target.
/// 
/// \param renderer The renderer which should draw a point.
/// \param x The x coordinate of the point.
/// \param y The y coordinate of the point.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawPoint(SDL_Renderer * renderer, int x, int y)
/// ```
int SDL_RenderDrawPoint(Pointer<SDL_Renderer>? renderer, int x, int y) {
  final _SDL_RenderDrawPoint = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Int32 x, Int32 y),
      int Function(Pointer<SDL_Renderer>? renderer, int x, int y)>('SDL_RenderDrawPoint');
  return _SDL_RenderDrawPoint(renderer, x, y);
}

/// 
/// \brief Draw multiple points on the current rendering target.
/// 
/// \param renderer The renderer which should draw multiple points.
/// \param points The points to draw
/// \param count The number of points to draw
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawPoints(SDL_Renderer * renderer, const SDL_Point * points, int count)
/// ```
int SDL_RenderDrawPoints(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, int count) {
  final _SDL_RenderDrawPoints = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, Int32 count),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, int count)>('SDL_RenderDrawPoints');
  return _SDL_RenderDrawPoints(renderer, points, count);
}

/// 
/// \brief Draw a line on the current rendering target.
/// 
/// \param renderer The renderer which should draw a line.
/// \param x1 The x coordinate of the start point.
/// \param y1 The y coordinate of the start point.
/// \param x2 The x coordinate of the end point.
/// \param y2 The y coordinate of the end point.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawLine(SDL_Renderer * renderer, int x1, int y1, int x2, int y2)
/// ```
int SDL_RenderDrawLine(Pointer<SDL_Renderer>? renderer, int x1, int y1, int x2, int y2) {
  final _SDL_RenderDrawLine = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Int32 x1, Int32 y1, Int32 x2, Int32 y2),
      int Function(Pointer<SDL_Renderer>? renderer, int x1, int y1, int x2, int y2)>('SDL_RenderDrawLine');
  return _SDL_RenderDrawLine(renderer, x1, y1, x2, y2);
}

/// 
/// \brief Draw a series of connected lines on the current rendering target.
/// 
/// \param renderer The renderer which should draw multiple lines.
/// \param points The points along the lines
/// \param count The number of points, drawing count-1 lines
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawLines(SDL_Renderer * renderer, const SDL_Point * points, int count)
/// ```
int SDL_RenderDrawLines(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, int count) {
  final _SDL_RenderDrawLines = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, Int32 count),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Point>? points, int count)>('SDL_RenderDrawLines');
  return _SDL_RenderDrawLines(renderer, points, count);
}

/// 
/// \brief Draw a rectangle on the current rendering target.
/// 
/// \param renderer The renderer which should draw a rectangle.
/// \param rect A pointer to the destination rectangle, or NULL to outline the entire rendering target.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawRect(SDL_Renderer * renderer, const SDL_Rect * rect)
/// ```
int SDL_RenderDrawRect(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderDrawRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderDrawRect');
  return _SDL_RenderDrawRect(renderer, rect);
}

/// 
/// \brief Draw some number of rectangles on the current rendering target.
/// 
/// \param renderer The renderer which should draw multiple rectangles.
/// \param rects A pointer to an array of destination rectangles.
/// \param count The number of rectangles.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderDrawRects(SDL_Renderer * renderer, const SDL_Rect * rects, int count)
/// ```
int SDL_RenderDrawRects(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, int count) {
  final _SDL_RenderDrawRects = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, Int32 count),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, int count)>('SDL_RenderDrawRects');
  return _SDL_RenderDrawRects(renderer, rects, count);
}

/// 
/// \brief Fill a rectangle on the current rendering target with the drawing color.
/// 
/// \param renderer The renderer which should fill a rectangle.
/// \param rect A pointer to the destination rectangle, or NULL for the entire
/// rendering target.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderFillRect(SDL_Renderer * renderer, const SDL_Rect * rect)
/// ```
int SDL_RenderFillRect(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect) {
  final _SDL_RenderFillRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect)>('SDL_RenderFillRect');
  return _SDL_RenderFillRect(renderer, rect);
}

/// 
/// \brief Fill some number of rectangles on the current rendering target with the drawing color.
/// 
/// \param renderer The renderer which should fill multiple rectangles.
/// \param rects A pointer to an array of destination rectangles.
/// \param count The number of rectangles.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderFillRects(SDL_Renderer * renderer, const SDL_Rect * rects, int count)
/// ```
int SDL_RenderFillRects(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, int count) {
  final _SDL_RenderFillRects = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, Int32 count),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rects, int count)>('SDL_RenderFillRects');
  return _SDL_RenderFillRects(renderer, rects, count);
}

/// 
/// \brief Copy a portion of the texture to the current rendering target.
/// 
/// \param renderer The renderer which should copy parts of a texture.
/// \param texture The source texture.
/// \param srcrect   A pointer to the source rectangle, or NULL for the entire
/// texture.
/// \param dstrect   A pointer to the destination rectangle, or NULL for the
/// entire rendering target.
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderCopy(SDL_Renderer * renderer, SDL_Texture * texture, const SDL_Rect * srcrect, const SDL_Rect * dstrect)
/// ```
int SDL_RenderCopy(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect) {
  final _SDL_RenderCopy = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect)>('SDL_RenderCopy');
  return _SDL_RenderCopy(renderer, texture, srcrect, dstrect);
}

/// 
/// \brief Copy a portion of the source texture to the current rendering target, rotating it by angle around the given center
/// 
/// \param renderer The renderer which should copy parts of a texture.
/// \param texture The source texture.
/// \param srcrect   A pointer to the source rectangle, or NULL for the entire
/// texture.
/// \param dstrect   A pointer to the destination rectangle, or NULL for the
/// entire rendering target.
/// \param angle    An angle in degrees that indicates the rotation that will be applied to dstrect
/// \param center   A pointer to a point indicating the point around which dstrect will be rotated (if NULL, rotation will be done aroud dstrect.w/2, dstrect.h/2)
/// \param flip     An SDL_RendererFlip value stating which flipping actions should be performed on the texture
/// 
/// \return 0 on success, or -1 on error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderCopyEx(SDL_Renderer * renderer, SDL_Texture * texture, const SDL_Rect * srcrect, const SDL_Rect * dstrect, const double angle, const SDL_Point *center, const SDL_RendererFlip flip)
/// ```
int SDL_RenderCopyEx(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect, double angle, Pointer<SDL_Point>? center, int flip) {
  final _SDL_RenderCopyEx = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect, Double angle, Pointer<SDL_Point>? center, Int32 flip),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Texture>? texture, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Rect>? dstrect, double angle, Pointer<SDL_Point>? center, int flip)>('SDL_RenderCopyEx');
  return _SDL_RenderCopyEx(renderer, texture, srcrect, dstrect, angle, center, flip);
}

/// 
/// \brief Read pixels from the current rendering target.
/// 
/// \param renderer The renderer from which pixels should be read.
/// \param rect   A pointer to the rectangle to read, or NULL for the entire
/// render target.
/// \param format The desired format of the pixel data, or 0 to use the format
/// of the rendering target
/// \param pixels A pointer to be filled in with the pixel data
/// \param pitch  The pitch of the pixels parameter.
/// 
/// \return 0 on success, or -1 if pixel reading is not supported.
/// 
/// \warning This is a very slow operation, and should not be used frequently.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_RenderReadPixels(SDL_Renderer * renderer, const SDL_Rect * rect, Uint32 format, void *pixels, int pitch)
/// ```
int SDL_RenderReadPixels(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect, int format, Pointer<Void>? pixels, int pitch) {
  final _SDL_RenderReadPixels = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect, Uint32 format, Pointer<Void>? pixels, Int32 pitch),
      int Function(Pointer<SDL_Renderer>? renderer, Pointer<SDL_Rect>? rect, int format, Pointer<Void>? pixels, int pitch)>('SDL_RenderReadPixels');
  return _SDL_RenderReadPixels(renderer, rect, format, pixels, pitch);
}

/// 
/// \brief Update the screen with rendering performed.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RenderPresent(SDL_Renderer * renderer)
/// ```
void SDL_RenderPresent(Pointer<SDL_Renderer>? renderer) {
  final _SDL_RenderPresent = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer),
      void Function(Pointer<SDL_Renderer>? renderer)>('SDL_RenderPresent');
  return _SDL_RenderPresent(renderer);
}

/// 
/// \brief Destroy the specified texture.
/// 
/// \sa SDL_CreateTexture()
/// \sa SDL_CreateTextureFromSurface()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroyTexture(SDL_Texture * texture)
/// ```
void SDL_DestroyTexture(Pointer<SDL_Texture>? texture) {
  final _SDL_DestroyTexture = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Texture>? texture),
      void Function(Pointer<SDL_Texture>? texture)>('SDL_DestroyTexture');
  return _SDL_DestroyTexture(texture);
}

/// 
/// \brief Destroy the rendering context for a window and free associated
/// textures.
/// 
/// \sa SDL_CreateRenderer()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroyRenderer(SDL_Renderer * renderer)
/// ```
void SDL_DestroyRenderer(Pointer<SDL_Renderer>? renderer) {
  final _SDL_DestroyRenderer = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Renderer>? renderer),
      void Function(Pointer<SDL_Renderer>? renderer)>('SDL_DestroyRenderer');
  return _SDL_DestroyRenderer(renderer);
}

/// 
/// \brief Bind the texture to the current OpenGL/ES/ES2 context for use with
/// OpenGL instructions.
/// 
/// \param texture  The SDL texture to bind
/// \param texw     A pointer to a float that will be filled with the texture width
/// \param texh     A pointer to a float that will be filled with the texture height
/// 
/// \return 0 on success, or -1 if the operation is not supported
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_BindTexture(SDL_Texture *texture, float *texw, float *texh)
/// ```
int SDL_GL_BindTexture(Pointer<SDL_Texture>? texture, Pointer<Float>? texw, Pointer<Float>? texh) {
  final _SDL_GL_BindTexture = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture, Pointer<Float>? texw, Pointer<Float>? texh),
      int Function(Pointer<SDL_Texture>? texture, Pointer<Float>? texw, Pointer<Float>? texh)>('SDL_GL_BindTexture');
  return _SDL_GL_BindTexture(texture, texw, texh);
}

/// 
/// \brief Unbind a texture from the current OpenGL/ES/ES2 context.
/// 
/// \param texture  The SDL texture to unbind
/// 
/// \return 0 on success, or -1 if the operation is not supported
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_UnbindTexture(SDL_Texture *texture)
/// ```
int SDL_GL_UnbindTexture(Pointer<SDL_Texture>? texture) {
  final _SDL_GL_UnbindTexture = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Texture>? texture),
      int Function(Pointer<SDL_Texture>? texture)>('SDL_GL_UnbindTexture');
  return _SDL_GL_UnbindTexture(texture);
}

/// @{
/// ```c
/// extern DECLSPEC SDL_RWops *SDLCALL SDL_RWFromFile(const char *file, const char *mode)
/// ```
Pointer<SDL_RWops>? SDL_RWFromFile(String file, String mode) {
  final _SDL_RWFromFile = _SDL2.lookupFunction<
      Pointer<SDL_RWops>? Function(Pointer<Utf8>? file, Pointer<Utf8>? mode),
      Pointer<SDL_RWops>? Function(Pointer<Utf8>? file, Pointer<Utf8>? mode)>('SDL_RWFromFile');
  final _filePointer = file.toNativeUtf8();
  final _modePointer = mode.toNativeUtf8();
  final _result = _SDL_RWFromFile(_filePointer, _modePointer);
  calloc.free(_filePointer);
  calloc.free(_modePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC SDL_RWops *SDLCALL SDL_RWFromFP(FILE * fp, SDL_bool autoclose)
/// ```
Pointer<SDL_RWops>? SDL_RWFromFP(Pointer<IntPtr>? fp, int autoclose) {
  final _SDL_RWFromFP = _SDL2.lookupFunction<
      Pointer<SDL_RWops>? Function(Pointer<IntPtr>? fp, Int32 autoclose),
      Pointer<SDL_RWops>? Function(Pointer<IntPtr>? fp, int autoclose)>('SDL_RWFromFP');
  return _SDL_RWFromFP(fp, autoclose);
}

/// ```c
/// extern DECLSPEC SDL_RWops *SDLCALL SDL_RWFromMem(void *mem, int size)
/// ```
Pointer<SDL_RWops>? SDL_RWFromMem(Pointer<Void>? mem, int size) {
  final _SDL_RWFromMem = _SDL2.lookupFunction<
      Pointer<SDL_RWops>? Function(Pointer<Void>? mem, Int32 size),
      Pointer<SDL_RWops>? Function(Pointer<Void>? mem, int size)>('SDL_RWFromMem');
  return _SDL_RWFromMem(mem, size);
}

/// ```c
/// extern DECLSPEC SDL_RWops *SDLCALL SDL_RWFromConstMem(const void *mem, int size)
/// ```
Pointer<SDL_RWops>? SDL_RWFromConstMem(Pointer<Void>? mem, int size) {
  final _SDL_RWFromConstMem = _SDL2.lookupFunction<
      Pointer<SDL_RWops>? Function(Pointer<Void>? mem, Int32 size),
      Pointer<SDL_RWops>? Function(Pointer<Void>? mem, int size)>('SDL_RWFromConstMem');
  return _SDL_RWFromConstMem(mem, size);
}

/// RWFrom functions
/// ```c
/// extern DECLSPEC SDL_RWops *SDLCALL SDL_AllocRW(void)
/// ```
Pointer<SDL_RWops>? SDL_AllocRW() {
  final _SDL_AllocRW = _SDL2.lookupFunction<
      Pointer<SDL_RWops>? Function(),
      Pointer<SDL_RWops>? Function()>('SDL_AllocRW');
  return _SDL_AllocRW();
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreeRW(SDL_RWops * area)
/// ```
void SDL_FreeRW(Pointer<SDL_RWops>? area) {
  final _SDL_FreeRW = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_RWops>? area),
      void Function(Pointer<SDL_RWops>? area)>('SDL_FreeRW');
  return _SDL_FreeRW(area);
}

/// @{
/// ```c
/// extern DECLSPEC Uint8 SDLCALL SDL_ReadU8(SDL_RWops * src)
/// ```
int SDL_ReadU8(Pointer<SDL_RWops>? src) {
  final _SDL_ReadU8 = _SDL2.lookupFunction<
      Uint8 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadU8');
  return _SDL_ReadU8(src);
}

/// ```c
/// extern DECLSPEC Uint16 SDLCALL SDL_ReadLE16(SDL_RWops * src)
/// ```
int SDL_ReadLE16(Pointer<SDL_RWops>? src) {
  final _SDL_ReadLE16 = _SDL2.lookupFunction<
      Uint16 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadLE16');
  return _SDL_ReadLE16(src);
}

/// ```c
/// extern DECLSPEC Uint16 SDLCALL SDL_ReadBE16(SDL_RWops * src)
/// ```
int SDL_ReadBE16(Pointer<SDL_RWops>? src) {
  final _SDL_ReadBE16 = _SDL2.lookupFunction<
      Uint16 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadBE16');
  return _SDL_ReadBE16(src);
}

/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_ReadLE32(SDL_RWops * src)
/// ```
int SDL_ReadLE32(Pointer<SDL_RWops>? src) {
  final _SDL_ReadLE32 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadLE32');
  return _SDL_ReadLE32(src);
}

/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_ReadBE32(SDL_RWops * src)
/// ```
int SDL_ReadBE32(Pointer<SDL_RWops>? src) {
  final _SDL_ReadBE32 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadBE32');
  return _SDL_ReadBE32(src);
}

/// ```c
/// extern DECLSPEC Uint64 SDLCALL SDL_ReadLE64(SDL_RWops * src)
/// ```
int SDL_ReadLE64(Pointer<SDL_RWops>? src) {
  final _SDL_ReadLE64 = _SDL2.lookupFunction<
      Uint64 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadLE64');
  return _SDL_ReadLE64(src);
}

/// ```c
/// extern DECLSPEC Uint64 SDLCALL SDL_ReadBE64(SDL_RWops * src)
/// ```
int SDL_ReadBE64(Pointer<SDL_RWops>? src) {
  final _SDL_ReadBE64 = _SDL2.lookupFunction<
      Uint64 Function(Pointer<SDL_RWops>? src),
      int Function(Pointer<SDL_RWops>? src)>('SDL_ReadBE64');
  return _SDL_ReadBE64(src);
}

/// @{
/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteU8(SDL_RWops * dst, Uint8 value)
/// ```
int SDL_WriteU8(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteU8 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint8 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteU8');
  return _SDL_WriteU8(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteLE16(SDL_RWops * dst, Uint16 value)
/// ```
int SDL_WriteLE16(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteLE16 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint16 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteLE16');
  return _SDL_WriteLE16(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteBE16(SDL_RWops * dst, Uint16 value)
/// ```
int SDL_WriteBE16(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteBE16 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint16 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteBE16');
  return _SDL_WriteBE16(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteLE32(SDL_RWops * dst, Uint32 value)
/// ```
int SDL_WriteLE32(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteLE32 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint32 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteLE32');
  return _SDL_WriteLE32(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteBE32(SDL_RWops * dst, Uint32 value)
/// ```
int SDL_WriteBE32(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteBE32 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint32 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteBE32');
  return _SDL_WriteBE32(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteLE64(SDL_RWops * dst, Uint64 value)
/// ```
int SDL_WriteLE64(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteLE64 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint64 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteLE64');
  return _SDL_WriteLE64(dst, value);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_WriteBE64(SDL_RWops * dst, Uint64 value)
/// ```
int SDL_WriteBE64(Pointer<SDL_RWops>? dst, int value) {
  final _SDL_WriteBE64 = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_RWops>? dst, Uint64 value),
      int Function(Pointer<SDL_RWops>? dst, int value)>('SDL_WriteBE64');
  return _SDL_WriteBE64(dst, value);
}

/// 
/// \brief Create a window that can be shaped with the specified position, dimensions, and flags.
/// 
/// \param title The title of the window, in UTF-8 encoding.
/// \param x     The x position of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// \param y     The y position of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// \param w     The width of the window.
/// \param h     The height of the window.
/// \param flags The flags for the window, a mask of SDL_WINDOW_BORDERLESS with any of the following:
/// ::SDL_WINDOW_OPENGL,     ::SDL_WINDOW_INPUT_GRABBED,
/// ::SDL_WINDOW_HIDDEN,     ::SDL_WINDOW_RESIZABLE,
/// ::SDL_WINDOW_MAXIMIZED,  ::SDL_WINDOW_MINIMIZED,
/// ::SDL_WINDOW_BORDERLESS is always set, and ::SDL_WINDOW_FULLSCREEN is always unset.
/// 
/// \return The window created, or NULL if window creation failed.
/// 
/// \sa SDL_DestroyWindow()
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_CreateShapedWindow(const char *title,unsigned int x,unsigned int y,unsigned int w,unsigned int h,Uint32 flags)
/// ```
Pointer<SDL_Window>? SDL_CreateShapedWindow(String title, int x, int y, int w, int h, int flags) {
  final _SDL_CreateShapedWindow = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(Pointer<Utf8>? title, Uint32 x, Uint32 y, Uint32 w, Uint32 h, Uint32 flags),
      Pointer<SDL_Window>? Function(Pointer<Utf8>? title, int x, int y, int w, int h, int flags)>('SDL_CreateShapedWindow');
  final _titlePointer = title.toNativeUtf8();
  final _result = _SDL_CreateShapedWindow(_titlePointer, x, y, w, h, flags);
  calloc.free(_titlePointer);
  return _result;
}

/// 
/// \brief Return whether the given window is a shaped window.
/// 
/// \param window The window to query for being shaped.
/// 
/// \return SDL_TRUE if the window is a window that can be shaped, SDL_FALSE if the window is unshaped or NULL.
/// \sa SDL_CreateShapedWindow
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IsShapedWindow(const SDL_Window *window)
/// ```
int SDL_IsShapedWindow(Pointer<SDL_Window>? window) {
  final _SDL_IsShapedWindow = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_IsShapedWindow');
  return _SDL_IsShapedWindow(window);
}

/// 
/// \brief Set the shape and parameters of a shaped window.
/// 
/// \param window The shaped window whose parameters should be set.
/// \param shape A surface encoding the desired shape for the window.
/// \param shape_mode The parameters to set for the shaped window.
/// 
/// \return 0 on success, SDL_INVALID_SHAPE_ARGUMENT on invalid an invalid shape argument, or SDL_NONSHAPEABLE_WINDOW
/// if the SDL_Window* given does not reference a valid shaped window.
/// 
/// \sa SDL_WindowShapeMode
/// \sa SDL_GetShapedWindowMode.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetWindowShape(SDL_Window *window,SDL_Surface *shape,SDL_WindowShapeMode *shape_mode)
/// ```
int SDL_SetWindowShape(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? shape, Pointer<SDL_WindowShapeMode>? shape_mode) {
  final _SDL_SetWindowShape = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? shape, Pointer<SDL_WindowShapeMode>? shape_mode),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? shape, Pointer<SDL_WindowShapeMode>? shape_mode)>('SDL_SetWindowShape');
  return _SDL_SetWindowShape(window, shape, shape_mode);
}

/// 
/// \brief Get the shape parameters of a shaped window.
/// 
/// \param window The shaped window whose parameters should be retrieved.
/// \param shape_mode An empty shape-mode structure to fill, or NULL to check whether the window has a shape.
/// 
/// \return 0 if the window has a shape and, provided shape_mode was not NULL, shape_mode has been filled with the mode
/// data, SDL_NONSHAPEABLE_WINDOW if the SDL_Window given is not a shaped window, or SDL_WINDOW_LACKS_SHAPE if
/// the SDL_Window* given is a shapeable window currently lacking a shape.
/// 
/// \sa SDL_WindowShapeMode
/// \sa SDL_SetWindowShape
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetShapedWindowMode(SDL_Window *window,SDL_WindowShapeMode *shape_mode)
/// ```
int SDL_GetShapedWindowMode(Pointer<SDL_Window>? window, Pointer<SDL_WindowShapeMode>? shape_mode) {
  final _SDL_GetShapedWindowMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_WindowShapeMode>? shape_mode),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_WindowShapeMode>? shape_mode)>('SDL_GetShapedWindowMode');
  return _SDL_GetShapedWindowMode(window, shape_mode);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_malloc(size_t size)
/// ```
Pointer<Void>? SDL_malloc(int size) {
  final _SDL_malloc = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 size),
      Pointer<Void>? Function(int size)>('SDL_malloc');
  return _SDL_malloc(size);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_calloc(size_t nmemb, size_t size)
/// ```
Pointer<Void>? SDL_calloc(int nmemb, int size) {
  final _SDL_calloc = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 nmemb, Uint32 size),
      Pointer<Void>? Function(int nmemb, int size)>('SDL_calloc');
  return _SDL_calloc(nmemb, size);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_realloc(void *mem, size_t size)
/// ```
Pointer<Void>? SDL_realloc(Pointer<Void>? mem, int size) {
  final _SDL_realloc = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? mem, Uint32 size),
      Pointer<Void>? Function(Pointer<Void>? mem, int size)>('SDL_realloc');
  return _SDL_realloc(mem, size);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_free(void *mem)
/// ```
void SDL_free(Pointer<Void>? mem) {
  final _SDL_free = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? mem),
      void Function(Pointer<Void>? mem)>('SDL_free');
  return _SDL_free(mem);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_getenv(const char *name)
/// ```
Pointer<Int8>? SDL_getenv(String name) {
  final _SDL_getenv = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? name),
      Pointer<Int8>? Function(Pointer<Utf8>? name)>('SDL_getenv');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_getenv(_namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_setenv(const char *name, const char *value, int overwrite)
/// ```
int SDL_setenv(String name, String value, int overwrite) {
  final _SDL_setenv = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? name, Pointer<Utf8>? value, Int32 overwrite),
      int Function(Pointer<Utf8>? name, Pointer<Utf8>? value, int overwrite)>('SDL_setenv');
  final _namePointer = name.toNativeUtf8();
  final _valuePointer = value.toNativeUtf8();
  final _result = _SDL_setenv(_namePointer, _valuePointer, overwrite);
  calloc.free(_namePointer);
  calloc.free(_valuePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_qsort(void *base, size_t nmemb, size_t size, int (*compare) (const void *, const void *))
/// ```
void SDL_qsort(Pointer<Void>? base, int nmemb, int size, Pointer<Void>? compare) {
  final _SDL_qsort = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? base, Uint32 nmemb, Uint32 size, Pointer<Void>? compare),
      void Function(Pointer<Void>? base, int nmemb, int size, Pointer<Void>? compare)>('SDL_qsort');
  return _SDL_qsort(base, nmemb, size, compare);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_abs(int x)
/// ```
int SDL_abs(int x) {
  final _SDL_abs = _SDL2.lookupFunction<
      Int32 Function(Int32 x),
      int Function(int x)>('SDL_abs');
  return _SDL_abs(x);
}

/// !!! FIXME: Maybe we do forceinline functions of SDL_mini, SDL_minf, etc?
/// ```c
/// extern DECLSPEC int SDLCALL SDL_isdigit(int x)
/// ```
int SDL_isdigit(int x) {
  final _SDL_isdigit = _SDL2.lookupFunction<
      Int32 Function(Int32 x),
      int Function(int x)>('SDL_isdigit');
  return _SDL_isdigit(x);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_isspace(int x)
/// ```
int SDL_isspace(int x) {
  final _SDL_isspace = _SDL2.lookupFunction<
      Int32 Function(Int32 x),
      int Function(int x)>('SDL_isspace');
  return _SDL_isspace(x);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_toupper(int x)
/// ```
int SDL_toupper(int x) {
  final _SDL_toupper = _SDL2.lookupFunction<
      Int32 Function(Int32 x),
      int Function(int x)>('SDL_toupper');
  return _SDL_toupper(x);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_tolower(int x)
/// ```
int SDL_tolower(int x) {
  final _SDL_tolower = _SDL2.lookupFunction<
      Int32 Function(Int32 x),
      int Function(int x)>('SDL_tolower');
  return _SDL_tolower(x);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_memset(void *dst, int c, size_t len)
/// ```
Pointer<Void>? SDL_memset(Pointer<Void>? dst, int c, int len) {
  final _SDL_memset = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? dst, Int32 c, Uint32 len),
      Pointer<Void>? Function(Pointer<Void>? dst, int c, int len)>('SDL_memset');
  return _SDL_memset(dst, c, len);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_memcpy(void *dst, const void *src, size_t len)
/// ```
Pointer<Void>? SDL_memcpy(Pointer<Void>? dst, Pointer<Void>? src, int len) {
  final _SDL_memcpy = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? dst, Pointer<Void>? src, Uint32 len),
      Pointer<Void>? Function(Pointer<Void>? dst, Pointer<Void>? src, int len)>('SDL_memcpy');
  return _SDL_memcpy(dst, src, len);
}

/// ```c
/// extern DECLSPEC void *SDLCALL SDL_memmove(void *dst, const void *src, size_t len)
/// ```
Pointer<Void>? SDL_memmove(Pointer<Void>? dst, Pointer<Void>? src, int len) {
  final _SDL_memmove = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Void>? dst, Pointer<Void>? src, Uint32 len),
      Pointer<Void>? Function(Pointer<Void>? dst, Pointer<Void>? src, int len)>('SDL_memmove');
  return _SDL_memmove(dst, src, len);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_memcmp(const void *s1, const void *s2, size_t len)
/// ```
int SDL_memcmp(Pointer<Void>? s1, Pointer<Void>? s2, int len) {
  final _SDL_memcmp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Void>? s1, Pointer<Void>? s2, Uint32 len),
      int Function(Pointer<Void>? s1, Pointer<Void>? s2, int len)>('SDL_memcmp');
  return _SDL_memcmp(s1, s2, len);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_wcslen(const wchar_t *wstr)
/// ```
int SDL_wcslen(Pointer<Int16>? wstr) {
  final _SDL_wcslen = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int16>? wstr),
      int Function(Pointer<Int16>? wstr)>('SDL_wcslen');
  return _SDL_wcslen(wstr);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_wcslcpy(wchar_t *dst, const wchar_t *src, size_t maxlen)
/// ```
int SDL_wcslcpy(Pointer<Int16>? dst, Pointer<Int16>? src, int maxlen) {
  final _SDL_wcslcpy = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int16>? dst, Pointer<Int16>? src, Uint32 maxlen),
      int Function(Pointer<Int16>? dst, Pointer<Int16>? src, int maxlen)>('SDL_wcslcpy');
  return _SDL_wcslcpy(dst, src, maxlen);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_wcslcat(wchar_t *dst, const wchar_t *src, size_t maxlen)
/// ```
int SDL_wcslcat(Pointer<Int16>? dst, Pointer<Int16>? src, int maxlen) {
  final _SDL_wcslcat = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int16>? dst, Pointer<Int16>? src, Uint32 maxlen),
      int Function(Pointer<Int16>? dst, Pointer<Int16>? src, int maxlen)>('SDL_wcslcat');
  return _SDL_wcslcat(dst, src, maxlen);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_strlen(const char *str)
/// ```
int SDL_strlen(String str) {
  final _SDL_strlen = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Utf8>? str),
      int Function(Pointer<Utf8>? str)>('SDL_strlen');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strlen(_strPointer);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_strlcpy(char *dst, const char *src, size_t maxlen)
/// ```
int SDL_strlcpy(Pointer<Int8>? dst, String src, int maxlen) {
  final _SDL_strlcpy = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int8>? dst, Pointer<Utf8>? src, Uint32 maxlen),
      int Function(Pointer<Int8>? dst, Pointer<Utf8>? src, int maxlen)>('SDL_strlcpy');
  final _srcPointer = src.toNativeUtf8();
  final _result = _SDL_strlcpy(dst, _srcPointer, maxlen);
  calloc.free(_srcPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_utf8strlcpy(char *dst, const char *src, size_t dst_bytes)
/// ```
int SDL_utf8strlcpy(Pointer<Int8>? dst, String src, int dst_bytes) {
  final _SDL_utf8strlcpy = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int8>? dst, Pointer<Utf8>? src, Uint32 dst_bytes),
      int Function(Pointer<Int8>? dst, Pointer<Utf8>? src, int dst_bytes)>('SDL_utf8strlcpy');
  final _srcPointer = src.toNativeUtf8();
  final _result = _SDL_utf8strlcpy(dst, _srcPointer, dst_bytes);
  calloc.free(_srcPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_strlcat(char *dst, const char *src, size_t maxlen)
/// ```
int SDL_strlcat(Pointer<Int8>? dst, String src, int maxlen) {
  final _SDL_strlcat = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Int8>? dst, Pointer<Utf8>? src, Uint32 maxlen),
      int Function(Pointer<Int8>? dst, Pointer<Utf8>? src, int maxlen)>('SDL_strlcat');
  final _srcPointer = src.toNativeUtf8();
  final _result = _SDL_strlcat(dst, _srcPointer, maxlen);
  calloc.free(_srcPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strdup(const char *str)
/// ```
Pointer<Int8>? SDL_strdup(String str) {
  final _SDL_strdup = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? str),
      Pointer<Int8>? Function(Pointer<Utf8>? str)>('SDL_strdup');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strdup(_strPointer);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strrev(char *str)
/// ```
Pointer<Int8>? SDL_strrev(Pointer<Int8>? str) {
  final _SDL_strrev = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Int8>? str),
      Pointer<Int8>? Function(Pointer<Int8>? str)>('SDL_strrev');
  return _SDL_strrev(str);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strupr(char *str)
/// ```
Pointer<Int8>? SDL_strupr(Pointer<Int8>? str) {
  final _SDL_strupr = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Int8>? str),
      Pointer<Int8>? Function(Pointer<Int8>? str)>('SDL_strupr');
  return _SDL_strupr(str);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strlwr(char *str)
/// ```
Pointer<Int8>? SDL_strlwr(Pointer<Int8>? str) {
  final _SDL_strlwr = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Int8>? str),
      Pointer<Int8>? Function(Pointer<Int8>? str)>('SDL_strlwr');
  return _SDL_strlwr(str);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strchr(const char *str, int c)
/// ```
Pointer<Int8>? SDL_strchr(String str, int c) {
  final _SDL_strchr = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? str, Int32 c),
      Pointer<Int8>? Function(Pointer<Utf8>? str, int c)>('SDL_strchr');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strchr(_strPointer, c);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strrchr(const char *str, int c)
/// ```
Pointer<Int8>? SDL_strrchr(String str, int c) {
  final _SDL_strrchr = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? str, Int32 c),
      Pointer<Int8>? Function(Pointer<Utf8>? str, int c)>('SDL_strrchr');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strrchr(_strPointer, c);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_strstr(const char *haystack, const char *needle)
/// ```
Pointer<Int8>? SDL_strstr(String haystack, String needle) {
  final _SDL_strstr = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? haystack, Pointer<Utf8>? needle),
      Pointer<Int8>? Function(Pointer<Utf8>? haystack, Pointer<Utf8>? needle)>('SDL_strstr');
  final _haystackPointer = haystack.toNativeUtf8();
  final _needlePointer = needle.toNativeUtf8();
  final _result = _SDL_strstr(_haystackPointer, _needlePointer);
  calloc.free(_haystackPointer);
  calloc.free(_needlePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_itoa(int value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_itoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_itoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Int32 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_itoa');
  return _SDL_itoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_uitoa(unsigned int value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_uitoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_uitoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Uint32 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_uitoa');
  return _SDL_uitoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_ltoa(long value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_ltoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_ltoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Int32 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_ltoa');
  return _SDL_ltoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_ultoa(unsigned long value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_ultoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_ultoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Uint32 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_ultoa');
  return _SDL_ultoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_lltoa(Sint64 value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_lltoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_lltoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Int64 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_lltoa');
  return _SDL_lltoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC char *SDLCALL SDL_ulltoa(Uint64 value, char *str, int radix)
/// ```
Pointer<Int8>? SDL_ulltoa(int value, Pointer<Int8>? str, int radix) {
  final _SDL_ulltoa = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Uint64 value, Pointer<Int8>? str, Int32 radix),
      Pointer<Int8>? Function(int value, Pointer<Int8>? str, int radix)>('SDL_ulltoa');
  return _SDL_ulltoa(value, str, radix);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_atoi(const char *str)
/// ```
int SDL_atoi(String str) {
  final _SDL_atoi = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str),
      int Function(Pointer<Utf8>? str)>('SDL_atoi');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_atoi(_strPointer);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_atof(const char *str)
/// ```
double SDL_atof(String str) {
  final _SDL_atof = _SDL2.lookupFunction<
      Double Function(Pointer<Utf8>? str),
      double Function(Pointer<Utf8>? str)>('SDL_atof');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_atof(_strPointer);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC long SDLCALL SDL_strtol(const char *str, char **endp, int base)
/// ```
int SDL_strtol(String str, Pointer<Pointer<Int8>>? endp, int base) {
  final _SDL_strtol = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, Int32 base),
      int Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, int base)>('SDL_strtol');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strtol(_strPointer, endp, base);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC unsigned long SDLCALL SDL_strtoul(const char *str, char **endp, int base)
/// ```
int SDL_strtoul(String str, Pointer<Pointer<Int8>>? endp, int base) {
  final _SDL_strtoul = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, Int32 base),
      int Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, int base)>('SDL_strtoul');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strtoul(_strPointer, endp, base);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC Sint64 SDLCALL SDL_strtoll(const char *str, char **endp, int base)
/// ```
int SDL_strtoll(String str, Pointer<Pointer<Int8>>? endp, int base) {
  final _SDL_strtoll = _SDL2.lookupFunction<
      Int64 Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, Int32 base),
      int Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, int base)>('SDL_strtoll');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strtoll(_strPointer, endp, base);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC Uint64 SDLCALL SDL_strtoull(const char *str, char **endp, int base)
/// ```
int SDL_strtoull(String str, Pointer<Pointer<Int8>>? endp, int base) {
  final _SDL_strtoull = _SDL2.lookupFunction<
      Uint64 Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, Int32 base),
      int Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp, int base)>('SDL_strtoull');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strtoull(_strPointer, endp, base);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_strtod(const char *str, char **endp)
/// ```
double SDL_strtod(String str, Pointer<Pointer<Int8>>? endp) {
  final _SDL_strtod = _SDL2.lookupFunction<
      Double Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp),
      double Function(Pointer<Utf8>? str, Pointer<Pointer<Int8>>? endp)>('SDL_strtod');
  final _strPointer = str.toNativeUtf8();
  final _result = _SDL_strtod(_strPointer, endp);
  calloc.free(_strPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_strcmp(const char *str1, const char *str2)
/// ```
int SDL_strcmp(String str1, String str2) {
  final _SDL_strcmp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2),
      int Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2)>('SDL_strcmp');
  final _str1Pointer = str1.toNativeUtf8();
  final _str2Pointer = str2.toNativeUtf8();
  final _result = _SDL_strcmp(_str1Pointer, _str2Pointer);
  calloc.free(_str1Pointer);
  calloc.free(_str2Pointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_strncmp(const char *str1, const char *str2, size_t maxlen)
/// ```
int SDL_strncmp(String str1, String str2, int maxlen) {
  final _SDL_strncmp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2, Uint32 maxlen),
      int Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2, int maxlen)>('SDL_strncmp');
  final _str1Pointer = str1.toNativeUtf8();
  final _str2Pointer = str2.toNativeUtf8();
  final _result = _SDL_strncmp(_str1Pointer, _str2Pointer, maxlen);
  calloc.free(_str1Pointer);
  calloc.free(_str2Pointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_strcasecmp(const char *str1, const char *str2)
/// ```
int SDL_strcasecmp(String str1, String str2) {
  final _SDL_strcasecmp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2),
      int Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2)>('SDL_strcasecmp');
  final _str1Pointer = str1.toNativeUtf8();
  final _str2Pointer = str2.toNativeUtf8();
  final _result = _SDL_strcasecmp(_str1Pointer, _str2Pointer);
  calloc.free(_str1Pointer);
  calloc.free(_str2Pointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_strncasecmp(const char *str1, const char *str2, size_t len)
/// ```
int SDL_strncasecmp(String str1, String str2, int len) {
  final _SDL_strncasecmp = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2, Uint32 len),
      int Function(Pointer<Utf8>? str1, Pointer<Utf8>? str2, int len)>('SDL_strncasecmp');
  final _str1Pointer = str1.toNativeUtf8();
  final _str2Pointer = str2.toNativeUtf8();
  final _result = _SDL_strncasecmp(_str1Pointer, _str2Pointer, len);
  calloc.free(_str1Pointer);
  calloc.free(_str2Pointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_sscanf(const char *text, const char *fmt, ...)
/// ```
int SDL_sscanf(String text, String fmt, Pointer<Void>? arg2) {
  final _SDL_sscanf = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? text, Pointer<Utf8>? fmt, Pointer<Void>? arg2),
      int Function(Pointer<Utf8>? text, Pointer<Utf8>? fmt, Pointer<Void>? arg2)>('SDL_sscanf');
  final _textPointer = text.toNativeUtf8();
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_sscanf(_textPointer, _fmtPointer, arg2);
  calloc.free(_textPointer);
  calloc.free(_fmtPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_snprintf(char *text, size_t maxlen, const char *fmt, ...)
/// ```
int SDL_snprintf(Pointer<Int8>? text, int maxlen, String fmt, Pointer<Void>? arg3) {
  final _SDL_snprintf = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int8>? text, Uint32 maxlen, Pointer<Utf8>? fmt, Pointer<Void>? arg3),
      int Function(Pointer<Int8>? text, int maxlen, Pointer<Utf8>? fmt, Pointer<Void>? arg3)>('SDL_snprintf');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_snprintf(text, maxlen, _fmtPointer, arg3);
  calloc.free(_fmtPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_vsnprintf(char *text, size_t maxlen, const char *fmt, va_list ap)
/// ```
int SDL_vsnprintf(Pointer<Int8>? text, int maxlen, String fmt, Pointer<Void>? ap) {
  final _SDL_vsnprintf = _SDL2.lookupFunction<
      Int32 Function(Pointer<Int8>? text, Uint32 maxlen, Pointer<Utf8>? fmt, Pointer<Void>? ap),
      int Function(Pointer<Int8>? text, int maxlen, Pointer<Utf8>? fmt, Pointer<Void>? ap)>('SDL_vsnprintf');
  final _fmtPointer = fmt.toNativeUtf8();
  final _result = _SDL_vsnprintf(text, maxlen, _fmtPointer, ap);
  calloc.free(_fmtPointer);
  return _result;
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_atan(double x)
/// ```
double SDL_atan(double x) {
  final _SDL_atan = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_atan');
  return _SDL_atan(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_atan2(double x, double y)
/// ```
double SDL_atan2(double x, double y) {
  final _SDL_atan2 = _SDL2.lookupFunction<
      Double Function(Double x, Double y),
      double Function(double x, double y)>('SDL_atan2');
  return _SDL_atan2(x, y);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_ceil(double x)
/// ```
double SDL_ceil(double x) {
  final _SDL_ceil = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_ceil');
  return _SDL_ceil(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_copysign(double x, double y)
/// ```
double SDL_copysign(double x, double y) {
  final _SDL_copysign = _SDL2.lookupFunction<
      Double Function(Double x, Double y),
      double Function(double x, double y)>('SDL_copysign');
  return _SDL_copysign(x, y);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_cos(double x)
/// ```
double SDL_cos(double x) {
  final _SDL_cos = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_cos');
  return _SDL_cos(x);
}

/// ```c
/// extern DECLSPEC float SDLCALL SDL_cosf(float x)
/// ```
double SDL_cosf(double x) {
  final _SDL_cosf = _SDL2.lookupFunction<
      Float Function(Float x),
      double Function(double x)>('SDL_cosf');
  return _SDL_cosf(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_fabs(double x)
/// ```
double SDL_fabs(double x) {
  final _SDL_fabs = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_fabs');
  return _SDL_fabs(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_floor(double x)
/// ```
double SDL_floor(double x) {
  final _SDL_floor = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_floor');
  return _SDL_floor(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_log(double x)
/// ```
double SDL_log(double x) {
  final _SDL_log = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_log');
  return _SDL_log(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_pow(double x, double y)
/// ```
double SDL_pow(double x, double y) {
  final _SDL_pow = _SDL2.lookupFunction<
      Double Function(Double x, Double y),
      double Function(double x, double y)>('SDL_pow');
  return _SDL_pow(x, y);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_scalbn(double x, int n)
/// ```
double SDL_scalbn(double x, int n) {
  final _SDL_scalbn = _SDL2.lookupFunction<
      Double Function(Double x, Int32 n),
      double Function(double x, int n)>('SDL_scalbn');
  return _SDL_scalbn(x, n);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_sin(double x)
/// ```
double SDL_sin(double x) {
  final _SDL_sin = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_sin');
  return _SDL_sin(x);
}

/// ```c
/// extern DECLSPEC float SDLCALL SDL_sinf(float x)
/// ```
double SDL_sinf(double x) {
  final _SDL_sinf = _SDL2.lookupFunction<
      Float Function(Float x),
      double Function(double x)>('SDL_sinf');
  return _SDL_sinf(x);
}

/// ```c
/// extern DECLSPEC double SDLCALL SDL_sqrt(double x)
/// ```
double SDL_sqrt(double x) {
  final _SDL_sqrt = _SDL2.lookupFunction<
      Double Function(Double x),
      double Function(double x)>('SDL_sqrt');
  return _SDL_sqrt(x);
}

/// ```c
/// extern DECLSPEC SDL_iconv_t SDLCALL SDL_iconv_open(const char *tocode, const char *fromcode)
/// ```
Pointer<Void>? SDL_iconv_open(String tocode, String fromcode) {
  final _SDL_iconv_open = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Utf8>? tocode, Pointer<Utf8>? fromcode),
      Pointer<Void>? Function(Pointer<Utf8>? tocode, Pointer<Utf8>? fromcode)>('SDL_iconv_open');
  final _tocodePointer = tocode.toNativeUtf8();
  final _fromcodePointer = fromcode.toNativeUtf8();
  final _result = _SDL_iconv_open(_tocodePointer, _fromcodePointer);
  calloc.free(_tocodePointer);
  calloc.free(_fromcodePointer);
  return _result;
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_iconv_close(SDL_iconv_t cd)
/// ```
int SDL_iconv_close(Pointer<Void>? cd) {
  final _SDL_iconv_close = _SDL2.lookupFunction<
      Int32 Function(Pointer<Void>? cd),
      int Function(Pointer<Void>? cd)>('SDL_iconv_close');
  return _SDL_iconv_close(cd);
}

/// ```c
/// extern DECLSPEC size_t SDLCALL SDL_iconv(SDL_iconv_t cd, const char **inbuf, size_t * inbytesleft, char **outbuf, size_t * outbytesleft)
/// ```
int SDL_iconv(Pointer<Void>? cd, Pointer<Pointer<Int8>>? inbuf, Pointer<Uint32>? inbytesleft, Pointer<Pointer<Int8>>? outbuf, Pointer<Uint32>? outbytesleft) {
  final _SDL_iconv = _SDL2.lookupFunction<
      Uint32 Function(Pointer<Void>? cd, Pointer<Pointer<Int8>>? inbuf, Pointer<Uint32>? inbytesleft, Pointer<Pointer<Int8>>? outbuf, Pointer<Uint32>? outbytesleft),
      int Function(Pointer<Void>? cd, Pointer<Pointer<Int8>>? inbuf, Pointer<Uint32>? inbytesleft, Pointer<Pointer<Int8>>? outbuf, Pointer<Uint32>? outbytesleft)>('SDL_iconv');
  return _SDL_iconv(cd, inbuf, inbytesleft, outbuf, outbytesleft);
}

/// 
/// This function converts a string between encodings in one pass, returning a
/// string that must be freed with SDL_free() or NULL on error.
/// 
/// ```c
/// extern DECLSPEC char *SDLCALL SDL_iconv_string(const char *tocode, const char *fromcode, const char *inbuf, size_t inbytesleft)
/// ```
Pointer<Int8>? SDL_iconv_string(String tocode, String fromcode, String inbuf, int inbytesleft) {
  final _SDL_iconv_string = _SDL2.lookupFunction<
      Pointer<Int8>? Function(Pointer<Utf8>? tocode, Pointer<Utf8>? fromcode, Pointer<Utf8>? inbuf, Uint32 inbytesleft),
      Pointer<Int8>? Function(Pointer<Utf8>? tocode, Pointer<Utf8>? fromcode, Pointer<Utf8>? inbuf, int inbytesleft)>('SDL_iconv_string');
  final _tocodePointer = tocode.toNativeUtf8();
  final _fromcodePointer = fromcode.toNativeUtf8();
  final _inbufPointer = inbuf.toNativeUtf8();
  final _result = _SDL_iconv_string(_tocodePointer, _fromcodePointer, _inbufPointer, inbytesleft);
  calloc.free(_tocodePointer);
  calloc.free(_fromcodePointer);
  calloc.free(_inbufPointer);
  return _result;
}

/// 
/// Allocate and free an RGB surface.
/// 
/// If the depth is 4 or 8 bits, an empty palette is allocated for the surface.
/// If the depth is greater than 8 bits, the pixel format is set using the
/// flags '[RGB]mask'.
/// 
/// If the function runs out of memory, it will return NULL.
/// 
/// \param flags The \c flags are obsolete and should be set to 0.
/// \param width The width in pixels of the surface to create.
/// \param height The height in pixels of the surface to create.
/// \param depth The depth in bits of the surface to create.
/// \param Rmask The red mask of the surface to create.
/// \param Gmask The green mask of the surface to create.
/// \param Bmask The blue mask of the surface to create.
/// \param Amask The alpha mask of the surface to create.
/// 
/// ```c
/// extern DECLSPEC SDL_Surface *SDLCALL SDL_CreateRGBSurface (Uint32 flags, int width, int height, int depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)
/// ```
Pointer<SDL_Surface>? SDL_CreateRGBSurface(int flags, int width, int height, int depth, int Rmask, int Gmask, int Bmask, int Amask) {
  final _SDL_CreateRGBSurface = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Uint32 flags, Int32 width, Int32 height, Int32 depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask),
      Pointer<SDL_Surface>? Function(int flags, int width, int height, int depth, int Rmask, int Gmask, int Bmask, int Amask)>('SDL_CreateRGBSurface');
  return _SDL_CreateRGBSurface(flags, width, height, depth, Rmask, Gmask, Bmask, Amask);
}

/// ```c
/// extern DECLSPEC SDL_Surface *SDLCALL SDL_CreateRGBSurfaceFrom(void *pixels, int width, int height, int depth, int pitch, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)
/// ```
Pointer<SDL_Surface>? SDL_CreateRGBSurfaceFrom(Pointer<Void>? pixels, int width, int height, int depth, int pitch, int Rmask, int Gmask, int Bmask, int Amask) {
  final _SDL_CreateRGBSurfaceFrom = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Pointer<Void>? pixels, Int32 width, Int32 height, Int32 depth, Int32 pitch, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask),
      Pointer<SDL_Surface>? Function(Pointer<Void>? pixels, int width, int height, int depth, int pitch, int Rmask, int Gmask, int Bmask, int Amask)>('SDL_CreateRGBSurfaceFrom');
  return _SDL_CreateRGBSurfaceFrom(pixels, width, height, depth, pitch, Rmask, Gmask, Bmask, Amask);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_FreeSurface(SDL_Surface * surface)
/// ```
void SDL_FreeSurface(Pointer<SDL_Surface>? surface) {
  final _SDL_FreeSurface = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Surface>? surface),
      void Function(Pointer<SDL_Surface>? surface)>('SDL_FreeSurface');
  return _SDL_FreeSurface(surface);
}

/// 
/// \brief Set the palette used by a surface.
/// 
/// \return 0, or -1 if the surface format doesn't use a palette.
/// 
/// \note A single palette can be shared with many surfaces.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetSurfacePalette(SDL_Surface * surface, SDL_Palette * palette)
/// ```
int SDL_SetSurfacePalette(Pointer<SDL_Surface>? surface, Pointer<SDL_Palette>? palette) {
  final _SDL_SetSurfacePalette = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Palette>? palette),
      int Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Palette>? palette)>('SDL_SetSurfacePalette');
  return _SDL_SetSurfacePalette(surface, palette);
}

/// 
/// \brief Sets up a surface for directly accessing the pixels.
/// 
/// Between calls to SDL_LockSurface() / SDL_UnlockSurface(), you can write
/// to and read from \c surface->pixels, using the pixel format stored in
/// \c surface->format.  Once you are done accessing the surface, you should
/// use SDL_UnlockSurface() to release it.
/// 
/// Not all surfaces require locking.  If SDL_MUSTLOCK(surface) evaluates
/// to 0, then you can read and write to the surface at any time, and the
/// pixel format of the surface will not change.
/// 
/// No operating system or library calls should be made between lock/unlock
/// pairs, as critical system locks may be held during this time.
/// 
/// SDL_LockSurface() returns 0, or -1 if the surface couldn't be locked.
/// 
/// \sa SDL_UnlockSurface()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LockSurface(SDL_Surface * surface)
/// ```
int SDL_LockSurface(Pointer<SDL_Surface>? surface) {
  final _SDL_LockSurface = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface),
      int Function(Pointer<SDL_Surface>? surface)>('SDL_LockSurface');
  return _SDL_LockSurface(surface);
}

/// * \sa SDL_LockSurface()
/// ```c
/// extern DECLSPEC void SDLCALL SDL_UnlockSurface(SDL_Surface * surface)
/// ```
void SDL_UnlockSurface(Pointer<SDL_Surface>? surface) {
  final _SDL_UnlockSurface = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Surface>? surface),
      void Function(Pointer<SDL_Surface>? surface)>('SDL_UnlockSurface');
  return _SDL_UnlockSurface(surface);
}

/// 
/// Load a surface from a seekable SDL data stream (memory or file).
/// 
/// If \c freesrc is non-zero, the stream will be closed after being read.
/// 
/// The new surface should be freed with SDL_FreeSurface().
/// 
/// \return the new surface, or NULL if there was an error.
/// 
/// ```c
/// extern DECLSPEC SDL_Surface *SDLCALL SDL_LoadBMP_RW(SDL_RWops * src, int freesrc)
/// ```
Pointer<SDL_Surface>? SDL_LoadBMP_RW(Pointer<SDL_RWops>? src, int freesrc) {
  final _SDL_LoadBMP_RW = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Pointer<SDL_RWops>? src, Int32 freesrc),
      Pointer<SDL_Surface>? Function(Pointer<SDL_RWops>? src, int freesrc)>('SDL_LoadBMP_RW');
  return _SDL_LoadBMP_RW(src, freesrc);
}

/// 
/// Save a surface to a seekable SDL data stream (memory or file).
/// 
/// If \c freedst is non-zero, the stream will be closed after being written.
/// 
/// \return 0 if successful or -1 if there was an error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SaveBMP_RW (SDL_Surface * surface, SDL_RWops * dst, int freedst)
/// ```
int SDL_SaveBMP_RW(Pointer<SDL_Surface>? surface, Pointer<SDL_RWops>? dst, int freedst) {
  final _SDL_SaveBMP_RW = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<SDL_RWops>? dst, Int32 freedst),
      int Function(Pointer<SDL_Surface>? surface, Pointer<SDL_RWops>? dst, int freedst)>('SDL_SaveBMP_RW');
  return _SDL_SaveBMP_RW(surface, dst, freedst);
}

/// 
/// \brief Sets the RLE acceleration hint for a surface.
/// 
/// \return 0 on success, or -1 if the surface is not valid
/// 
/// \note If RLE is enabled, colorkey and alpha blending blits are much faster,
/// but the surface must be locked before directly accessing the pixels.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetSurfaceRLE(SDL_Surface * surface, int flag)
/// ```
int SDL_SetSurfaceRLE(Pointer<SDL_Surface>? surface, int flag) {
  final _SDL_SetSurfaceRLE = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Int32 flag),
      int Function(Pointer<SDL_Surface>? surface, int flag)>('SDL_SetSurfaceRLE');
  return _SDL_SetSurfaceRLE(surface, flag);
}

/// 
/// \brief Sets the color key (transparent pixel) in a blittable surface.
/// 
/// \param surface The surface to update
/// \param flag Non-zero to enable colorkey and 0 to disable colorkey
/// \param key The transparent pixel in the native surface format
/// 
/// \return 0 on success, or -1 if the surface is not valid
/// 
/// You can pass SDL_RLEACCEL to enable RLE accelerated blits.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetColorKey(SDL_Surface * surface, int flag, Uint32 key)
/// ```
int SDL_SetColorKey(Pointer<SDL_Surface>? surface, int flag, int key) {
  final _SDL_SetColorKey = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Int32 flag, Uint32 key),
      int Function(Pointer<SDL_Surface>? surface, int flag, int key)>('SDL_SetColorKey');
  return _SDL_SetColorKey(surface, flag, key);
}

/// 
/// \brief Gets the color key (transparent pixel) in a blittable surface.
/// 
/// \param surface The surface to update
/// \param key A pointer filled in with the transparent pixel in the native
/// surface format
/// 
/// \return 0 on success, or -1 if the surface is not valid or colorkey is not
/// enabled.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetColorKey(SDL_Surface * surface, Uint32 * key)
/// ```
int SDL_GetColorKey(Pointer<SDL_Surface>? surface, Pointer<Uint32>? key) {
  final _SDL_GetColorKey = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<Uint32>? key),
      int Function(Pointer<SDL_Surface>? surface, Pointer<Uint32>? key)>('SDL_GetColorKey');
  return _SDL_GetColorKey(surface, key);
}

/// 
/// \brief Set an additional color value used in blit operations.
/// 
/// \param surface The surface to update.
/// \param r The red color value multiplied into blit operations.
/// \param g The green color value multiplied into blit operations.
/// \param b The blue color value multiplied into blit operations.
/// 
/// \return 0 on success, or -1 if the surface is not valid.
/// 
/// \sa SDL_GetSurfaceColorMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetSurfaceColorMod(SDL_Surface * surface, Uint8 r, Uint8 g, Uint8 b)
/// ```
int SDL_SetSurfaceColorMod(Pointer<SDL_Surface>? surface, int r, int g, int b) {
  final _SDL_SetSurfaceColorMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Uint8 r, Uint8 g, Uint8 b),
      int Function(Pointer<SDL_Surface>? surface, int r, int g, int b)>('SDL_SetSurfaceColorMod');
  return _SDL_SetSurfaceColorMod(surface, r, g, b);
}

/// 
/// \brief Get the additional color value used in blit operations.
/// 
/// \param surface The surface to query.
/// \param r A pointer filled in with the current red color value.
/// \param g A pointer filled in with the current green color value.
/// \param b A pointer filled in with the current blue color value.
/// 
/// \return 0 on success, or -1 if the surface is not valid.
/// 
/// \sa SDL_SetSurfaceColorMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetSurfaceColorMod(SDL_Surface * surface, Uint8 * r, Uint8 * g, Uint8 * b)
/// ```
int SDL_GetSurfaceColorMod(Pointer<SDL_Surface>? surface, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b) {
  final _SDL_GetSurfaceColorMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b),
      int Function(Pointer<SDL_Surface>? surface, Pointer<Uint8>? r, Pointer<Uint8>? g, Pointer<Uint8>? b)>('SDL_GetSurfaceColorMod');
  return _SDL_GetSurfaceColorMod(surface, r, g, b);
}

/// 
/// \brief Set an additional alpha value used in blit operations.
/// 
/// \param surface The surface to update.
/// \param alpha The alpha value multiplied into blit operations.
/// 
/// \return 0 on success, or -1 if the surface is not valid.
/// 
/// \sa SDL_GetSurfaceAlphaMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetSurfaceAlphaMod(SDL_Surface * surface, Uint8 alpha)
/// ```
int SDL_SetSurfaceAlphaMod(Pointer<SDL_Surface>? surface, int alpha) {
  final _SDL_SetSurfaceAlphaMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Uint8 alpha),
      int Function(Pointer<SDL_Surface>? surface, int alpha)>('SDL_SetSurfaceAlphaMod');
  return _SDL_SetSurfaceAlphaMod(surface, alpha);
}

/// 
/// \brief Get the additional alpha value used in blit operations.
/// 
/// \param surface The surface to query.
/// \param alpha A pointer filled in with the current alpha value.
/// 
/// \return 0 on success, or -1 if the surface is not valid.
/// 
/// \sa SDL_SetSurfaceAlphaMod()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetSurfaceAlphaMod(SDL_Surface * surface, Uint8 * alpha)
/// ```
int SDL_GetSurfaceAlphaMod(Pointer<SDL_Surface>? surface, Pointer<Uint8>? alpha) {
  final _SDL_GetSurfaceAlphaMod = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<Uint8>? alpha),
      int Function(Pointer<SDL_Surface>? surface, Pointer<Uint8>? alpha)>('SDL_GetSurfaceAlphaMod');
  return _SDL_GetSurfaceAlphaMod(surface, alpha);
}

/// 
/// \brief Set the blend mode used for blit operations.
/// 
/// \param surface The surface to update.
/// \param blendMode ::SDL_BlendMode to use for blit blending.
/// 
/// \return 0 on success, or -1 if the parameters are not valid.
/// 
/// \sa SDL_GetSurfaceBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetSurfaceBlendMode(SDL_Surface * surface, SDL_BlendMode blendMode)
/// ```
int SDL_SetSurfaceBlendMode(Pointer<SDL_Surface>? surface, int blendMode) {
  final _SDL_SetSurfaceBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Int32 blendMode),
      int Function(Pointer<SDL_Surface>? surface, int blendMode)>('SDL_SetSurfaceBlendMode');
  return _SDL_SetSurfaceBlendMode(surface, blendMode);
}

/// 
/// \brief Get the blend mode used for blit operations.
/// 
/// \param surface   The surface to query.
/// \param blendMode A pointer filled in with the current blend mode.
/// 
/// \return 0 on success, or -1 if the surface is not valid.
/// 
/// \sa SDL_SetSurfaceBlendMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetSurfaceBlendMode(SDL_Surface * surface, SDL_BlendMode *blendMode)
/// ```
int SDL_GetSurfaceBlendMode(Pointer<SDL_Surface>? surface, Pointer<Int32>? blendMode) {
  final _SDL_GetSurfaceBlendMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<Int32>? blendMode),
      int Function(Pointer<SDL_Surface>? surface, Pointer<Int32>? blendMode)>('SDL_GetSurfaceBlendMode');
  return _SDL_GetSurfaceBlendMode(surface, blendMode);
}

/// 
/// Sets the clipping rectangle for the destination surface in a blit.
/// 
/// If the clip rectangle is NULL, clipping will be disabled.
/// 
/// If the clip rectangle doesn't intersect the surface, the function will
/// return SDL_FALSE and blits will be completely clipped.  Otherwise the
/// function returns SDL_TRUE and blits to the surface will be clipped to
/// the intersection of the surface area and the clipping rectangle.
/// 
/// Note that blits are automatically clipped to the edges of the source
/// and destination surfaces.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_SetClipRect(SDL_Surface * surface, const SDL_Rect * rect)
/// ```
int SDL_SetClipRect(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect) {
  final _SDL_SetClipRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect),
      int Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect)>('SDL_SetClipRect');
  return _SDL_SetClipRect(surface, rect);
}

/// 
/// Gets the clipping rectangle for the destination surface in a blit.
/// 
/// \c rect must be a pointer to a valid rectangle which will be filled
/// with the correct values.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetClipRect(SDL_Surface * surface, SDL_Rect * rect)
/// ```
void SDL_GetClipRect(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect) {
  final _SDL_GetClipRect = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect),
      void Function(Pointer<SDL_Surface>? surface, Pointer<SDL_Rect>? rect)>('SDL_GetClipRect');
  return _SDL_GetClipRect(surface, rect);
}

/// 
/// Creates a new surface of the specified format, and then copies and maps
/// the given surface to it so the blit of the converted surface will be as
/// fast as possible.  If this function fails, it returns NULL.
/// 
/// The \c flags parameter is passed to SDL_CreateRGBSurface() and has those
/// semantics.  You can also pass ::SDL_RLEACCEL in the flags parameter and
/// SDL will try to RLE accelerate colorkey and alpha blits in the resulting
/// surface.
/// 
/// ```c
/// extern DECLSPEC SDL_Surface *SDLCALL SDL_ConvertSurface (SDL_Surface * src, SDL_PixelFormat * fmt, Uint32 flags)
/// ```
Pointer<SDL_Surface>? SDL_ConvertSurface(Pointer<SDL_Surface>? src, Pointer<SDL_PixelFormat>? fmt, int flags) {
  final _SDL_ConvertSurface = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Pointer<SDL_Surface>? src, Pointer<SDL_PixelFormat>? fmt, Uint32 flags),
      Pointer<SDL_Surface>? Function(Pointer<SDL_Surface>? src, Pointer<SDL_PixelFormat>? fmt, int flags)>('SDL_ConvertSurface');
  return _SDL_ConvertSurface(src, fmt, flags);
}

/// ```c
/// extern DECLSPEC SDL_Surface *SDLCALL SDL_ConvertSurfaceFormat (SDL_Surface * src, Uint32 pixel_format, Uint32 flags)
/// ```
Pointer<SDL_Surface>? SDL_ConvertSurfaceFormat(Pointer<SDL_Surface>? src, int pixel_format, int flags) {
  final _SDL_ConvertSurfaceFormat = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Pointer<SDL_Surface>? src, Uint32 pixel_format, Uint32 flags),
      Pointer<SDL_Surface>? Function(Pointer<SDL_Surface>? src, int pixel_format, int flags)>('SDL_ConvertSurfaceFormat');
  return _SDL_ConvertSurfaceFormat(src, pixel_format, flags);
}

/// 
/// \brief Copy a block of pixels of one format to another format
/// 
/// \return 0 on success, or -1 if there was an error
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_ConvertPixels(int width, int height, Uint32 src_format, const void * src, int src_pitch, Uint32 dst_format, void * dst, int dst_pitch)
/// ```
int SDL_ConvertPixels(int width, int height, int src_format, Pointer<Void>? src, int src_pitch, int dst_format, Pointer<Void>? dst, int dst_pitch) {
  final _SDL_ConvertPixels = _SDL2.lookupFunction<
      Int32 Function(Int32 width, Int32 height, Uint32 src_format, Pointer<Void>? src, Int32 src_pitch, Uint32 dst_format, Pointer<Void>? dst, Int32 dst_pitch),
      int Function(int width, int height, int src_format, Pointer<Void>? src, int src_pitch, int dst_format, Pointer<Void>? dst, int dst_pitch)>('SDL_ConvertPixels');
  return _SDL_ConvertPixels(width, height, src_format, src, src_pitch, dst_format, dst, dst_pitch);
}

/// 
/// Performs a fast fill of the given rectangle with \c color.
/// 
/// If \c rect is NULL, the whole surface will be filled with \c color.
/// 
/// The color should be a pixel of the format used by the surface, and
/// can be generated by the SDL_MapRGB() function.
/// 
/// \return 0 on success, or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_FillRect (SDL_Surface * dst, const SDL_Rect * rect, Uint32 color)
/// ```
int SDL_FillRect(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rect, int color) {
  final _SDL_FillRect = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rect, Uint32 color),
      int Function(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rect, int color)>('SDL_FillRect');
  return _SDL_FillRect(dst, rect, color);
}

/// ```c
/// extern DECLSPEC int SDLCALL SDL_FillRects (SDL_Surface * dst, const SDL_Rect * rects, int count, Uint32 color)
/// ```
int SDL_FillRects(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rects, int count, int color) {
  final _SDL_FillRects = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rects, Int32 count, Uint32 color),
      int Function(Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? rects, int count, int color)>('SDL_FillRects');
  return _SDL_FillRects(dst, rects, count, color);
}

/// 
/// This is the public blit function, SDL_BlitSurface(), and it performs
/// rectangle validation and clipping before passing it to SDL_LowerBlit()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UpperBlit (SDL_Surface * src, const SDL_Rect * srcrect, SDL_Surface * dst, SDL_Rect * dstrect)
/// ```
int SDL_UpperBlit(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect) {
  final _SDL_UpperBlit = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect)>('SDL_UpperBlit');
  return _SDL_UpperBlit(src, srcrect, dst, dstrect);
}

/// 
/// This is a semi-private blit function and it performs low-level surface
/// blitting only.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LowerBlit (SDL_Surface * src, SDL_Rect * srcrect, SDL_Surface * dst, SDL_Rect * dstrect)
/// ```
int SDL_LowerBlit(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect) {
  final _SDL_LowerBlit = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect)>('SDL_LowerBlit');
  return _SDL_LowerBlit(src, srcrect, dst, dstrect);
}

/// 
/// \brief Perform a fast, low quality, stretch blit between two surfaces of the
/// same pixel format.
/// 
/// \note This function uses a static buffer, and is not thread-safe.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SoftStretch(SDL_Surface * src, const SDL_Rect * srcrect, SDL_Surface * dst, const SDL_Rect * dstrect)
/// ```
int SDL_SoftStretch(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect) {
  final _SDL_SoftStretch = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect)>('SDL_SoftStretch');
  return _SDL_SoftStretch(src, srcrect, dst, dstrect);
}

/// 
/// This is the public scaled blit function, SDL_BlitScaled(), and it performs
/// rectangle validation and clipping before passing it to SDL_LowerBlitScaled()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UpperBlitScaled (SDL_Surface * src, const SDL_Rect * srcrect, SDL_Surface * dst, SDL_Rect * dstrect)
/// ```
int SDL_UpperBlitScaled(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect) {
  final _SDL_UpperBlitScaled = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect)>('SDL_UpperBlitScaled');
  return _SDL_UpperBlitScaled(src, srcrect, dst, dstrect);
}

/// 
/// This is a semi-private blit function and it performs low-level surface
/// scaled blitting only.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_LowerBlitScaled (SDL_Surface * src, SDL_Rect * srcrect, SDL_Surface * dst, SDL_Rect * dstrect)
/// ```
int SDL_LowerBlitScaled(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect) {
  final _SDL_LowerBlitScaled = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect),
      int Function(Pointer<SDL_Surface>? src, Pointer<SDL_Rect>? srcrect, Pointer<SDL_Surface>? dst, Pointer<SDL_Rect>? dstrect)>('SDL_LowerBlitScaled');
  return _SDL_LowerBlitScaled(src, srcrect, dst, dstrect);
}

/// Platform specific functions for iOS
/// ```c
/// extern DECLSPEC int SDLCALL SDL_iPhoneSetAnimationCallback(SDL_Window * window, int interval, void (*callback)(void*), void *callbackParam)
/// ```
int SDL_iPhoneSetAnimationCallback(Pointer<SDL_Window>? window, int interval, Pointer<Void>? callback, Pointer<Void>? callbackParam) {
  final _SDL_iPhoneSetAnimationCallback = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Int32 interval, Pointer<Void>? callback, Pointer<Void>? callbackParam),
      int Function(Pointer<SDL_Window>? window, int interval, Pointer<Void>? callback, Pointer<Void>? callbackParam)>('SDL_iPhoneSetAnimationCallback');
  return _SDL_iPhoneSetAnimationCallback(window, interval, callback, callbackParam);
}

/// ```c
/// extern DECLSPEC void SDLCALL SDL_iPhoneSetEventPump(SDL_bool enabled)
/// ```
void SDL_iPhoneSetEventPump(int enabled) {
  final _SDL_iPhoneSetEventPump = _SDL2.lookupFunction<
      Void Function(Int32 enabled),
      void Function(int enabled)>('SDL_iPhoneSetEventPump');
  return _SDL_iPhoneSetEventPump(enabled);
}

/// Get the JNI environment for the current thread
/// This returns JNIEnv*, but the prototype is void* so we don't need jni.h
/// /
/// ```c
/// extern DECLSPEC void * SDLCALL SDL_AndroidGetJNIEnv()
/// ```
Pointer<Void>? SDL_AndroidGetJNIEnv() {
  final _SDL_AndroidGetJNIEnv = _SDL2.lookupFunction<
      Pointer<Void>? Function(),
      Pointer<Void>? Function()>('SDL_AndroidGetJNIEnv');
  return _SDL_AndroidGetJNIEnv();
}

/// Get the SDL Activity object for the application
/// This returns jobject, but the prototype is void* so we don't need jni.h
/// The jobject returned by SDL_AndroidGetActivity is a local reference.
/// It is the caller's responsibility to properly release it
/// (using env->Push/PopLocalFrame or manually with env->DeleteLocalRef)
/// /
/// ```c
/// extern DECLSPEC void * SDLCALL SDL_AndroidGetActivity()
/// ```
Pointer<Void>? SDL_AndroidGetActivity() {
  final _SDL_AndroidGetActivity = _SDL2.lookupFunction<
      Pointer<Void>? Function(),
      Pointer<Void>? Function()>('SDL_AndroidGetActivity');
  return _SDL_AndroidGetActivity();
}

/// Get the path used for internal storage for this application.
/// This path is unique to your application and cannot be written to
/// by other applications.
/// /
/// ```c
/// extern DECLSPEC const char * SDLCALL SDL_AndroidGetInternalStoragePath()
/// ```
String SDL_AndroidGetInternalStoragePath() {
  final _SDL_AndroidGetInternalStoragePath = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_AndroidGetInternalStoragePath');
  return _SDL_AndroidGetInternalStoragePath()!.toDartString();
}

/// Get the current state of external storage, a bitmask of these values:
/// SDL_ANDROID_EXTERNAL_STORAGE_READ
/// SDL_ANDROID_EXTERNAL_STORAGE_WRITE
/// If external storage is currently unavailable, this will return 0.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_AndroidGetExternalStorageState()
/// ```
int SDL_AndroidGetExternalStorageState() {
  final _SDL_AndroidGetExternalStorageState = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_AndroidGetExternalStorageState');
  return _SDL_AndroidGetExternalStorageState();
}

/// Get the path used for external storage for this application.
/// This path is unique to your application, but is public and can be
/// written to by other applications.
/// /
/// ```c
/// extern DECLSPEC const char * SDLCALL SDL_AndroidGetExternalStoragePath()
/// ```
String SDL_AndroidGetExternalStoragePath() {
  final _SDL_AndroidGetExternalStoragePath = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_AndroidGetExternalStoragePath');
  return _SDL_AndroidGetExternalStoragePath()!.toDartString();
}

/// 
/// \brief This function allows access to driver-dependent window information.
/// 
/// \param window The window about which information is being requested
/// \param info This structure must be initialized with the SDL version, and is
/// then filled in with information about the given window.
/// 
/// \return SDL_TRUE if the function is implemented and the version member of
/// the \c info struct is valid, SDL_FALSE otherwise.
/// 
/// You typically use this function like this:
/// \code
/// SDL_SysWMinfo info;
/// SDL_VERSION(&info.version);
/// if ( SDL_GetWindowWMInfo(window, &info) ) { ... }
/// \endcode
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GetWindowWMInfo(SDL_Window * window, SDL_SysWMinfo * info)
/// ```
int SDL_GetWindowWMInfo(Pointer<SDL_Window>? window, Pointer<SDL_SysWMinfo>? info) {
  final _SDL_GetWindowWMInfo = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_SysWMinfo>? info),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_SysWMinfo>? info)>('SDL_GetWindowWMInfo');
  return _SDL_GetWindowWMInfo(window, info);
}

/// 
/// Create a thread.
/// 
/// ```c
/// extern DECLSPEC SDL_Thread *SDLCALL SDL_CreateThread(SDL_ThreadFunction fn, const char *name, void *data, pfnSDL_CurrentBeginThread pfnBeginThread, pfnSDL_CurrentEndThread pfnEndThread)
/// ```
Pointer<SDL_Thread>? SDL_CreateThread(Pointer<Void>? fn, String name, Pointer<Void>? data, Pointer<Void>? pfnBeginThread, Pointer<Void>? pfnEndThread) {
  final _SDL_CreateThread = _SDL2.lookupFunction<
      Pointer<SDL_Thread>? Function(Pointer<Void>? fn, Pointer<Utf8>? name, Pointer<Void>? data, Pointer<Void>? pfnBeginThread, Pointer<Void>? pfnEndThread),
      Pointer<SDL_Thread>? Function(Pointer<Void>? fn, Pointer<Utf8>? name, Pointer<Void>? data, Pointer<Void>? pfnBeginThread, Pointer<Void>? pfnEndThread)>('SDL_CreateThread');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_CreateThread(fn, _namePointer, data, pfnBeginThread, pfnEndThread);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// Get the thread name, as it was specified in SDL_CreateThread().
/// This function returns a pointer to a UTF-8 string that names the
/// specified thread, or NULL if it doesn't have a name. This is internal
/// memory, not to be free()'d by the caller, and remains valid until the
/// specified thread is cleaned up by SDL_WaitThread().
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetThreadName(SDL_Thread *thread)
/// ```
String SDL_GetThreadName(Pointer<SDL_Thread>? thread) {
  final _SDL_GetThreadName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Pointer<SDL_Thread>? thread),
      Pointer<Utf8>? Function(Pointer<SDL_Thread>? thread)>('SDL_GetThreadName');
  return _SDL_GetThreadName(thread)!.toDartString();
}

/// 
/// Get the thread identifier for the current thread.
/// 
/// ```c
/// extern DECLSPEC SDL_threadID SDLCALL SDL_ThreadID(void)
/// ```
int SDL_ThreadID() {
  final _SDL_ThreadID = _SDL2.lookupFunction<
      Uint32 Function(),
      int Function()>('SDL_ThreadID');
  return _SDL_ThreadID();
}

/// 
/// Get the thread identifier for the specified thread.
/// 
/// Equivalent to SDL_ThreadID() if the specified thread is NULL.
/// 
/// ```c
/// extern DECLSPEC SDL_threadID SDLCALL SDL_GetThreadID(SDL_Thread * thread)
/// ```
int SDL_GetThreadID(Pointer<SDL_Thread>? thread) {
  final _SDL_GetThreadID = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_Thread>? thread),
      int Function(Pointer<SDL_Thread>? thread)>('SDL_GetThreadID');
  return _SDL_GetThreadID(thread);
}

/// 
/// Set the priority for the current thread
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetThreadPriority(SDL_ThreadPriority priority)
/// ```
int SDL_SetThreadPriority(int priority) {
  final _SDL_SetThreadPriority = _SDL2.lookupFunction<
      Int32 Function(Int32 priority),
      int Function(int priority)>('SDL_SetThreadPriority');
  return _SDL_SetThreadPriority(priority);
}

/// 
/// Wait for a thread to finish.
/// 
/// The return code for the thread function is placed in the area
/// pointed to by \c status, if \c status is not NULL.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_WaitThread(SDL_Thread * thread, int *status)
/// ```
void SDL_WaitThread(Pointer<SDL_Thread>? thread, Pointer<Int32>? status) {
  final _SDL_WaitThread = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Thread>? thread, Pointer<Int32>? status),
      void Function(Pointer<SDL_Thread>? thread, Pointer<Int32>? status)>('SDL_WaitThread');
  return _SDL_WaitThread(thread, status);
}

/// 
/// \brief Create an identifier that is globally visible to all threads but refers to data that is thread-specific.
/// 
/// \return The newly created thread local storage identifier, or 0 on error
/// 
/// \code
/// static SDL_SpinLock tls_lock;
/// static SDL_TLSID thread_local_storage;
/// 
/// void SetMyThreadData(void *value)
/// {
/// if (!thread_local_storage) {
/// SDL_AtomicLock(&tls_lock);
/// if (!thread_local_storage) {
/// thread_local_storage = SDL_TLSCreate();
/// }
/// SDL_AtomicUnLock(&tls_lock);
/// }
/// SDL_TLSSet(thread_local_storage, value);
/// }
/// 
/// void *GetMyThreadData(void)
/// {
/// return SDL_TLSGet(thread_local_storage);
/// }
/// \endcode
/// 
/// \sa SDL_TLSGet()
/// \sa SDL_TLSSet()
/// 
/// ```c
/// extern DECLSPEC SDL_TLSID SDLCALL SDL_TLSCreate(void)
/// ```
int SDL_TLSCreate() {
  final _SDL_TLSCreate = _SDL2.lookupFunction<
      Uint32 Function(),
      int Function()>('SDL_TLSCreate');
  return _SDL_TLSCreate();
}

/// 
/// \brief Get the value associated with a thread local storage ID for the current thread.
/// 
/// \param id The thread local storage ID
/// 
/// \return The value associated with the ID for the current thread, or NULL if no value has been set.
/// 
/// \sa SDL_TLSCreate()
/// \sa SDL_TLSSet()
/// 
/// ```c
/// extern DECLSPEC void * SDLCALL SDL_TLSGet(SDL_TLSID id)
/// ```
Pointer<Void>? SDL_TLSGet(int id) {
  final _SDL_TLSGet = _SDL2.lookupFunction<
      Pointer<Void>? Function(Uint32 id),
      Pointer<Void>? Function(int id)>('SDL_TLSGet');
  return _SDL_TLSGet(id);
}

/// 
/// \brief Set the value associated with a thread local storage ID for the current thread.
/// 
/// \param id The thread local storage ID
/// \param value The value to associate with the ID for the current thread
/// \param destructor A function called when the thread exits, to free the value.
/// 
/// \return 0 on success, -1 on error
/// 
/// \sa SDL_TLSCreate()
/// \sa SDL_TLSGet()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_TLSSet(SDL_TLSID id, const void *value, void (*destructor)(void*))
/// ```
int SDL_TLSSet(int id, Pointer<Void>? value, Pointer<Void>? deor) {
  final _SDL_TLSSet = _SDL2.lookupFunction<
      Int32 Function(Uint32 id, Pointer<Void>? value, Pointer<Void>? deor),
      int Function(int id, Pointer<Void>? value, Pointer<Void>? deor)>('SDL_TLSSet');
  return _SDL_TLSSet(id, value, deor);
}

/// 
/// \brief Get the number of milliseconds since the SDL library initialization.
/// 
/// \note This value wraps if the program runs for more than ~49 days.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetTicks(void)
/// ```
int SDL_GetTicks() {
  final _SDL_GetTicks = _SDL2.lookupFunction<
      Uint32 Function(),
      int Function()>('SDL_GetTicks');
  return _SDL_GetTicks();
}

/// 
/// \brief Get the current value of the high resolution counter
/// 
/// ```c
/// extern DECLSPEC Uint64 SDLCALL SDL_GetPerformanceCounter(void)
/// ```
int SDL_GetPerformanceCounter() {
  final _SDL_GetPerformanceCounter = _SDL2.lookupFunction<
      Uint64 Function(),
      int Function()>('SDL_GetPerformanceCounter');
  return _SDL_GetPerformanceCounter();
}

/// 
/// \brief Get the count per second of the high resolution counter
/// 
/// ```c
/// extern DECLSPEC Uint64 SDLCALL SDL_GetPerformanceFrequency(void)
/// ```
int SDL_GetPerformanceFrequency() {
  final _SDL_GetPerformanceFrequency = _SDL2.lookupFunction<
      Uint64 Function(),
      int Function()>('SDL_GetPerformanceFrequency');
  return _SDL_GetPerformanceFrequency();
}

/// 
/// \brief Wait a specified number of milliseconds before returning.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_Delay(Uint32 ms)
/// ```
void SDL_Delay(int ms) {
  final _SDL_Delay = _SDL2.lookupFunction<
      Void Function(Uint32 ms),
      void Function(int ms)>('SDL_Delay');
  return _SDL_Delay(ms);
}

/// 
/// \brief Add a new timer to the pool of timers already running.
/// 
/// \return A timer ID, or NULL when an error occurs.
/// 
/// ```c
/// extern DECLSPEC SDL_TimerID SDLCALL SDL_AddTimer(Uint32 interval, SDL_TimerCallback callback, void *param)
/// ```
int SDL_AddTimer(int interval, Pointer<Void>? callback, Pointer<Void>? param) {
  final _SDL_AddTimer = _SDL2.lookupFunction<
      Int32 Function(Uint32 interval, Pointer<Void>? callback, Pointer<Void>? param),
      int Function(int interval, Pointer<Void>? callback, Pointer<Void>? param)>('SDL_AddTimer');
  return _SDL_AddTimer(interval, callback, param);
}

/// 
/// \brief Remove a timer knowing its ID.
/// 
/// \return A boolean value indicating success or failure.
/// 
/// \warning It is not safe to remove a timer multiple times.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_RemoveTimer(SDL_TimerID id)
/// ```
int SDL_RemoveTimer(int id) {
  final _SDL_RemoveTimer = _SDL2.lookupFunction<
      Int32 Function(Int32 id),
      int Function(int id)>('SDL_RemoveTimer');
  return _SDL_RemoveTimer(id);
}

/// 
/// \brief Get the number of registered touch devices.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumTouchDevices(void)
/// ```
int SDL_GetNumTouchDevices() {
  final _SDL_GetNumTouchDevices = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetNumTouchDevices');
  return _SDL_GetNumTouchDevices();
}

/// 
/// \brief Get the touch ID with the given index, or 0 if the index is invalid.
/// 
/// ```c
/// extern DECLSPEC SDL_TouchID SDLCALL SDL_GetTouchDevice(int index)
/// ```
int SDL_GetTouchDevice(int index) {
  final _SDL_GetTouchDevice = _SDL2.lookupFunction<
      Int64 Function(Int32 index),
      int Function(int index)>('SDL_GetTouchDevice');
  return _SDL_GetTouchDevice(index);
}

/// 
/// \brief Get the number of active fingers for a given touch device.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumTouchFingers(SDL_TouchID touchID)
/// ```
int SDL_GetNumTouchFingers(int touchID) {
  final _SDL_GetNumTouchFingers = _SDL2.lookupFunction<
      Int32 Function(Int64 touchID),
      int Function(int touchID)>('SDL_GetNumTouchFingers');
  return _SDL_GetNumTouchFingers(touchID);
}

/// 
/// \brief Get the finger object of the given touch, with the given index.
/// 
/// ```c
/// extern DECLSPEC SDL_Finger * SDLCALL SDL_GetTouchFinger(SDL_TouchID touchID, int index)
/// ```
Pointer<SDL_Finger>? SDL_GetTouchFinger(int touchID, int index) {
  final _SDL_GetTouchFinger = _SDL2.lookupFunction<
      Pointer<SDL_Finger>? Function(Int64 touchID, Int32 index),
      Pointer<SDL_Finger>? Function(int touchID, int index)>('SDL_GetTouchFinger');
  return _SDL_GetTouchFinger(touchID, index);
}

/// 
/// \brief Get the version of SDL that is linked against your program.
/// 
/// If you are linking to SDL dynamically, then it is possible that the
/// current version will be different than the version you compiled against.
/// This function returns the current version, while SDL_VERSION() is a
/// macro that tells you what version you compiled with.
/// 
/// \code
/// SDL_version compiled;
/// SDL_version linked;
/// 
/// SDL_VERSION(&compiled);
/// SDL_GetVersion(&linked);
/// printf("We compiled against SDL version %d.%d.%d ...\n",
/// compiled.major, compiled.minor, compiled.patch);
/// printf("But we linked against SDL version %d.%d.%d.\n",
/// linked.major, linked.minor, linked.patch);
/// \endcode
/// 
/// This function may be called safely at any time, even before SDL_Init().
/// 
/// \sa SDL_VERSION
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetVersion(SDL_version * ver)
/// ```
void SDL_GetVersion(Pointer<SDL_version>? ver) {
  final _SDL_GetVersion = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_version>? ver),
      void Function(Pointer<SDL_version>? ver)>('SDL_GetVersion');
  return _SDL_GetVersion(ver);
}

/// 
/// \brief Get the code revision of SDL that is linked against your program.
/// 
/// Returns an arbitrary string (a hash value) uniquely identifying the
/// exact revision of the SDL library in use, and is only useful in comparing
/// against other revisions. It is NOT an incrementing number.
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetRevision(void)
/// ```
String SDL_GetRevision() {
  final _SDL_GetRevision = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_GetRevision');
  return _SDL_GetRevision()!.toDartString();
}

/// 
/// \brief Get the revision number of SDL that is linked against your program.
/// 
/// Returns a number uniquely identifying the exact revision of the SDL
/// library in use. It is an incrementing number based on commits to
/// hg.libsdl.org.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetRevisionNumber(void)
/// ```
int SDL_GetRevisionNumber() {
  final _SDL_GetRevisionNumber = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetRevisionNumber');
  return _SDL_GetRevisionNumber();
}

/// 
/// \brief Get the number of video drivers compiled into SDL
/// 
/// \sa SDL_GetVideoDriver()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumVideoDrivers(void)
/// ```
int SDL_GetNumVideoDrivers() {
  final _SDL_GetNumVideoDrivers = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetNumVideoDrivers');
  return _SDL_GetNumVideoDrivers();
}

/// 
/// \brief Get the name of a built in video driver.
/// 
/// \note The video drivers are presented in the order in which they are
/// normally checked during initialization.
/// 
/// \sa SDL_GetNumVideoDrivers()
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetVideoDriver(int index)
/// ```
String SDL_GetVideoDriver(int index) {
  final _SDL_GetVideoDriver = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 index),
      Pointer<Utf8>? Function(int index)>('SDL_GetVideoDriver');
  return _SDL_GetVideoDriver(index)!.toDartString();
}

/// 
/// \brief Initialize the video subsystem, optionally specifying a video driver.
/// 
/// \param driver_name Initialize a specific driver by name, or NULL for the
/// default video driver.
/// 
/// \return 0 on success, -1 on error
/// 
/// This function initializes the video subsystem; setting up a connection
/// to the window manager, etc, and determines the available display modes
/// and pixel formats, but does not initialize a window or graphics mode.
/// 
/// \sa SDL_VideoQuit()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_VideoInit(const char *driver_name)
/// ```
int SDL_VideoInit(String driver_name) {
  final _SDL_VideoInit = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? driver_name),
      int Function(Pointer<Utf8>? driver_name)>('SDL_VideoInit');
  final _driver_namePointer = driver_name.toNativeUtf8();
  final _result = _SDL_VideoInit(_driver_namePointer);
  calloc.free(_driver_namePointer);
  return _result;
}

/// 
/// \brief Shuts down the video subsystem.
/// 
/// This function closes all windows, and restores the original video mode.
/// 
/// \sa SDL_VideoInit()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_VideoQuit(void)
/// ```
void SDL_VideoQuit() {
  final _SDL_VideoQuit = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_VideoQuit');
  return _SDL_VideoQuit();
}

/// 
/// \brief Returns the name of the currently initialized video driver.
/// 
/// \return The name of the current video driver or NULL if no driver
/// has been initialized
/// 
/// \sa SDL_GetNumVideoDrivers()
/// \sa SDL_GetVideoDriver()
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetCurrentVideoDriver(void)
/// ```
String SDL_GetCurrentVideoDriver() {
  final _SDL_GetCurrentVideoDriver = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(),
      Pointer<Utf8>? Function()>('SDL_GetCurrentVideoDriver');
  return _SDL_GetCurrentVideoDriver()!.toDartString();
}

/// 
/// \brief Returns the number of available video displays.
/// 
/// \sa SDL_GetDisplayBounds()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumVideoDisplays(void)
/// ```
int SDL_GetNumVideoDisplays() {
  final _SDL_GetNumVideoDisplays = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GetNumVideoDisplays');
  return _SDL_GetNumVideoDisplays();
}

/// 
/// \brief Get the name of a display in UTF-8 encoding
/// 
/// \return The name of a display, or NULL for an invalid display index.
/// 
/// \sa SDL_GetNumVideoDisplays()
/// 
/// ```c
/// extern DECLSPEC const char * SDLCALL SDL_GetDisplayName(int displayIndex)
/// ```
String SDL_GetDisplayName(int displayIndex) {
  final _SDL_GetDisplayName = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Int32 displayIndex),
      Pointer<Utf8>? Function(int displayIndex)>('SDL_GetDisplayName');
  return _SDL_GetDisplayName(displayIndex)!.toDartString();
}

/// 
/// \brief Get the desktop area represented by a display, with the primary
/// display located at 0,0
/// 
/// \return 0 on success, or -1 if the index is out of range.
/// 
/// \sa SDL_GetNumVideoDisplays()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetDisplayBounds(int displayIndex, SDL_Rect * rect)
/// ```
int SDL_GetDisplayBounds(int displayIndex, Pointer<SDL_Rect>? rect) {
  final _SDL_GetDisplayBounds = _SDL2.lookupFunction<
      Int32 Function(Int32 displayIndex, Pointer<SDL_Rect>? rect),
      int Function(int displayIndex, Pointer<SDL_Rect>? rect)>('SDL_GetDisplayBounds');
  return _SDL_GetDisplayBounds(displayIndex, rect);
}

/// 
/// \brief Returns the number of available display modes.
/// 
/// \sa SDL_GetDisplayMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetNumDisplayModes(int displayIndex)
/// ```
int SDL_GetNumDisplayModes(int displayIndex) {
  final _SDL_GetNumDisplayModes = _SDL2.lookupFunction<
      Int32 Function(Int32 displayIndex),
      int Function(int displayIndex)>('SDL_GetNumDisplayModes');
  return _SDL_GetNumDisplayModes(displayIndex);
}

/// 
/// \brief Fill in information about a specific display mode.
/// 
/// \note The display modes are sorted in this priority:
/// \li bits per pixel -> more colors to fewer colors
/// \li width -> largest to smallest
/// \li height -> largest to smallest
/// \li refresh rate -> highest to lowest
/// 
/// \sa SDL_GetNumDisplayModes()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetDisplayMode(int displayIndex, int modeIndex, SDL_DisplayMode * mode)
/// ```
int SDL_GetDisplayMode(int displayIndex, int modeIndex, Pointer<SDL_DisplayMode>? mode) {
  final _SDL_GetDisplayMode = _SDL2.lookupFunction<
      Int32 Function(Int32 displayIndex, Int32 modeIndex, Pointer<SDL_DisplayMode>? mode),
      int Function(int displayIndex, int modeIndex, Pointer<SDL_DisplayMode>? mode)>('SDL_GetDisplayMode');
  return _SDL_GetDisplayMode(displayIndex, modeIndex, mode);
}

/// 
/// \brief Fill in information about the desktop display mode.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetDesktopDisplayMode(int displayIndex, SDL_DisplayMode * mode)
/// ```
int SDL_GetDesktopDisplayMode(int displayIndex, Pointer<SDL_DisplayMode>? mode) {
  final _SDL_GetDesktopDisplayMode = _SDL2.lookupFunction<
      Int32 Function(Int32 displayIndex, Pointer<SDL_DisplayMode>? mode),
      int Function(int displayIndex, Pointer<SDL_DisplayMode>? mode)>('SDL_GetDesktopDisplayMode');
  return _SDL_GetDesktopDisplayMode(displayIndex, mode);
}

/// 
/// \brief Fill in information about the current display mode.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetCurrentDisplayMode(int displayIndex, SDL_DisplayMode * mode)
/// ```
int SDL_GetCurrentDisplayMode(int displayIndex, Pointer<SDL_DisplayMode>? mode) {
  final _SDL_GetCurrentDisplayMode = _SDL2.lookupFunction<
      Int32 Function(Int32 displayIndex, Pointer<SDL_DisplayMode>? mode),
      int Function(int displayIndex, Pointer<SDL_DisplayMode>? mode)>('SDL_GetCurrentDisplayMode');
  return _SDL_GetCurrentDisplayMode(displayIndex, mode);
}

/// 
/// \brief Get the closest match to the requested display mode.
/// 
/// \param displayIndex The index of display from which mode should be queried.
/// \param mode The desired display mode
/// \param closest A pointer to a display mode to be filled in with the closest
/// match of the available display modes.
/// 
/// \return The passed in value \c closest, or NULL if no matching video mode
/// was available.
/// 
/// The available display modes are scanned, and \c closest is filled in with the
/// closest mode matching the requested mode and returned.  The mode format and
/// refresh_rate default to the desktop mode if they are 0.  The modes are
/// scanned with size being first priority, format being second priority, and
/// finally checking the refresh_rate.  If all the available modes are too
/// small, then NULL is returned.
/// 
/// \sa SDL_GetNumDisplayModes()
/// \sa SDL_GetDisplayMode()
/// 
/// ```c
/// extern DECLSPEC SDL_DisplayMode * SDLCALL SDL_GetClosestDisplayMode(int displayIndex, const SDL_DisplayMode * mode, SDL_DisplayMode * closest)
/// ```
Pointer<SDL_DisplayMode>? SDL_GetClosestDisplayMode(int displayIndex, Pointer<SDL_DisplayMode>? mode, Pointer<SDL_DisplayMode>? closest) {
  final _SDL_GetClosestDisplayMode = _SDL2.lookupFunction<
      Pointer<SDL_DisplayMode>? Function(Int32 displayIndex, Pointer<SDL_DisplayMode>? mode, Pointer<SDL_DisplayMode>? closest),
      Pointer<SDL_DisplayMode>? Function(int displayIndex, Pointer<SDL_DisplayMode>? mode, Pointer<SDL_DisplayMode>? closest)>('SDL_GetClosestDisplayMode');
  return _SDL_GetClosestDisplayMode(displayIndex, mode, closest);
}

/// 
/// \brief Get the display index associated with a window.
/// 
/// \return the display index of the display containing the center of the
/// window, or -1 on error.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetWindowDisplayIndex(SDL_Window * window)
/// ```
int SDL_GetWindowDisplayIndex(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowDisplayIndex = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_GetWindowDisplayIndex');
  return _SDL_GetWindowDisplayIndex(window);
}

/// 
/// \brief Set the display mode used when a fullscreen window is visible.
/// 
/// By default the window's dimensions and the desktop format and refresh rate
/// are used.
/// 
/// \param window The window for which the display mode should be set.
/// \param mode The mode to use, or NULL for the default mode.
/// 
/// \return 0 on success, or -1 if setting the display mode failed.
/// 
/// \sa SDL_GetWindowDisplayMode()
/// \sa SDL_SetWindowFullscreen()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetWindowDisplayMode(SDL_Window * window, const SDL_DisplayMode * mode)
/// ```
int SDL_SetWindowDisplayMode(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode) {
  final _SDL_SetWindowDisplayMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode)>('SDL_SetWindowDisplayMode');
  return _SDL_SetWindowDisplayMode(window, mode);
}

/// 
/// \brief Fill in information about the display mode used when a fullscreen
/// window is visible.
/// 
/// \sa SDL_SetWindowDisplayMode()
/// \sa SDL_SetWindowFullscreen()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetWindowDisplayMode(SDL_Window * window, SDL_DisplayMode * mode)
/// ```
int SDL_GetWindowDisplayMode(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode) {
  final _SDL_GetWindowDisplayMode = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_DisplayMode>? mode)>('SDL_GetWindowDisplayMode');
  return _SDL_GetWindowDisplayMode(window, mode);
}

/// 
/// \brief Get the pixel format associated with the window.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetWindowPixelFormat(SDL_Window * window)
/// ```
int SDL_GetWindowPixelFormat(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowPixelFormat = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_GetWindowPixelFormat');
  return _SDL_GetWindowPixelFormat(window);
}

/// 
/// \brief Create a window with the specified position, dimensions, and flags.
/// 
/// \param title The title of the window, in UTF-8 encoding.
/// \param x     The x position of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// \param y     The y position of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// \param w     The width of the window.
/// \param h     The height of the window.
/// \param flags The flags for the window, a mask of any of the following:
/// ::SDL_WINDOW_FULLSCREEN, ::SDL_WINDOW_OPENGL,
/// ::SDL_WINDOW_HIDDEN,     ::SDL_WINDOW_BORDERLESS,
/// ::SDL_WINDOW_RESIZABLE,  ::SDL_WINDOW_MAXIMIZED,
/// ::SDL_WINDOW_MINIMIZED,  ::SDL_WINDOW_INPUT_GRABBED.
/// 
/// \return The id of the window created, or zero if window creation failed.
/// 
/// \sa SDL_DestroyWindow()
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_CreateWindow(const char *title, int x, int y, int w, int h, Uint32 flags)
/// ```
Pointer<SDL_Window>? SDL_CreateWindow(String title, int x, int y, int w, int h, int flags) {
  final _SDL_CreateWindow = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(Pointer<Utf8>? title, Int32 x, Int32 y, Int32 w, Int32 h, Uint32 flags),
      Pointer<SDL_Window>? Function(Pointer<Utf8>? title, int x, int y, int w, int h, int flags)>('SDL_CreateWindow');
  final _titlePointer = title.toNativeUtf8();
  final _result = _SDL_CreateWindow(_titlePointer, x, y, w, h, flags);
  calloc.free(_titlePointer);
  return _result;
}

/// 
/// \brief Create an SDL window from an existing native window.
/// 
/// \param data A pointer to driver-dependent window creation data
/// 
/// \return The id of the window created, or zero if window creation failed.
/// 
/// \sa SDL_DestroyWindow()
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_CreateWindowFrom(const void *data)
/// ```
Pointer<SDL_Window>? SDL_CreateWindowFrom(Pointer<Void>? data) {
  final _SDL_CreateWindowFrom = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(Pointer<Void>? data),
      Pointer<SDL_Window>? Function(Pointer<Void>? data)>('SDL_CreateWindowFrom');
  return _SDL_CreateWindowFrom(data);
}

/// 
/// \brief Get the numeric ID of a window, for logging purposes.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetWindowID(SDL_Window * window)
/// ```
int SDL_GetWindowID(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowID = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_GetWindowID');
  return _SDL_GetWindowID(window);
}

/// 
/// \brief Get a window from a stored ID, or NULL if it doesn't exist.
/// 
/// ```c
/// extern DECLSPEC SDL_Window * SDLCALL SDL_GetWindowFromID(Uint32 id)
/// ```
Pointer<SDL_Window>? SDL_GetWindowFromID(int id) {
  final _SDL_GetWindowFromID = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(Uint32 id),
      Pointer<SDL_Window>? Function(int id)>('SDL_GetWindowFromID');
  return _SDL_GetWindowFromID(id);
}

/// 
/// \brief Get the window flags.
/// 
/// ```c
/// extern DECLSPEC Uint32 SDLCALL SDL_GetWindowFlags(SDL_Window * window)
/// ```
int SDL_GetWindowFlags(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowFlags = _SDL2.lookupFunction<
      Uint32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_GetWindowFlags');
  return _SDL_GetWindowFlags(window);
}

/// 
/// \brief Set the title of a window, in UTF-8 format.
/// 
/// \sa SDL_GetWindowTitle()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowTitle(SDL_Window * window, const char *title)
/// ```
void SDL_SetWindowTitle(Pointer<SDL_Window>? window, String title) {
  final _SDL_SetWindowTitle = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<Utf8>? title),
      void Function(Pointer<SDL_Window>? window, Pointer<Utf8>? title)>('SDL_SetWindowTitle');
  final _titlePointer = title.toNativeUtf8();
  final _result = _SDL_SetWindowTitle(window, _titlePointer);
  calloc.free(_titlePointer);
  return _result;
}

/// 
/// \brief Get the title of a window, in UTF-8 format.
/// 
/// \sa SDL_SetWindowTitle()
/// 
/// ```c
/// extern DECLSPEC const char *SDLCALL SDL_GetWindowTitle(SDL_Window * window)
/// ```
String SDL_GetWindowTitle(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowTitle = _SDL2.lookupFunction<
      Pointer<Utf8>? Function(Pointer<SDL_Window>? window),
      Pointer<Utf8>? Function(Pointer<SDL_Window>? window)>('SDL_GetWindowTitle');
  return _SDL_GetWindowTitle(window)!.toDartString();
}

/// 
/// \brief Set the icon for a window.
/// 
/// \param window The window for which the icon should be set.
/// \param icon The icon for the window.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowIcon(SDL_Window * window, SDL_Surface * icon)
/// ```
void SDL_SetWindowIcon(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? icon) {
  final _SDL_SetWindowIcon = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? icon),
      void Function(Pointer<SDL_Window>? window, Pointer<SDL_Surface>? icon)>('SDL_SetWindowIcon');
  return _SDL_SetWindowIcon(window, icon);
}

/// 
/// \brief Associate an arbitrary named pointer with a window.
/// 
/// \param window   The window to associate with the pointer.
/// \param name     The name of the pointer.
/// \param userdata The associated pointer.
/// 
/// \return The previous value associated with 'name'
/// 
/// \note The name is case-sensitive.
/// 
/// \sa SDL_GetWindowData()
/// 
/// ```c
/// extern DECLSPEC void* SDLCALL SDL_SetWindowData(SDL_Window * window, const char *name, void *userdata)
/// ```
Pointer<Void>? SDL_SetWindowData(Pointer<SDL_Window>? window, String name, Pointer<Void>? userdata) {
  final _SDL_SetWindowData = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_Window>? window, Pointer<Utf8>? name, Pointer<Void>? userdata),
      Pointer<Void>? Function(Pointer<SDL_Window>? window, Pointer<Utf8>? name, Pointer<Void>? userdata)>('SDL_SetWindowData');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_SetWindowData(window, _namePointer, userdata);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief Retrieve the data pointer associated with a window.
/// 
/// \param window   The window to query.
/// \param name     The name of the pointer.
/// 
/// \return The value associated with 'name'
/// 
/// \sa SDL_SetWindowData()
/// 
/// ```c
/// extern DECLSPEC void *SDLCALL SDL_GetWindowData(SDL_Window * window, const char *name)
/// ```
Pointer<Void>? SDL_GetWindowData(Pointer<SDL_Window>? window, String name) {
  final _SDL_GetWindowData = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_Window>? window, Pointer<Utf8>? name),
      Pointer<Void>? Function(Pointer<SDL_Window>? window, Pointer<Utf8>? name)>('SDL_GetWindowData');
  final _namePointer = name.toNativeUtf8();
  final _result = _SDL_GetWindowData(window, _namePointer);
  calloc.free(_namePointer);
  return _result;
}

/// 
/// \brief Set the position of a window.
/// 
/// \param window   The window to reposition.
/// \param x        The x coordinate of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// \param y        The y coordinate of the window, ::SDL_WINDOWPOS_CENTERED, or
/// ::SDL_WINDOWPOS_UNDEFINED.
/// 
/// \note The window coordinate origin is the upper left of the display.
/// 
/// \sa SDL_GetWindowPosition()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowPosition(SDL_Window * window, int x, int y)
/// ```
void SDL_SetWindowPosition(Pointer<SDL_Window>? window, int x, int y) {
  final _SDL_SetWindowPosition = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 x, Int32 y),
      void Function(Pointer<SDL_Window>? window, int x, int y)>('SDL_SetWindowPosition');
  return _SDL_SetWindowPosition(window, x, y);
}

/// 
/// \brief Get the position of a window.
/// 
/// \param window   The window to query.
/// \param x        Pointer to variable for storing the x position, may be NULL
/// \param y        Pointer to variable for storing the y position, may be NULL
/// 
/// \sa SDL_SetWindowPosition()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetWindowPosition(SDL_Window * window, int *x, int *y)
/// ```
void SDL_GetWindowPosition(Pointer<SDL_Window>? window, Pointer<Int32>? x, Pointer<Int32>? y) {
  final _SDL_GetWindowPosition = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<Int32>? x, Pointer<Int32>? y),
      void Function(Pointer<SDL_Window>? window, Pointer<Int32>? x, Pointer<Int32>? y)>('SDL_GetWindowPosition');
  return _SDL_GetWindowPosition(window, x, y);
}

/// 
/// \brief Set the size of a window's client area.
/// 
/// \param window   The window to resize.
/// \param w        The width of the window, must be >0
/// \param h        The height of the window, must be >0
/// 
/// \note You can't change the size of a fullscreen window, it automatically
/// matches the size of the display mode.
/// 
/// \sa SDL_GetWindowSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowSize(SDL_Window * window, int w, int h)
/// ```
void SDL_SetWindowSize(Pointer<SDL_Window>? window, int w, int h) {
  final _SDL_SetWindowSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 w, Int32 h),
      void Function(Pointer<SDL_Window>? window, int w, int h)>('SDL_SetWindowSize');
  return _SDL_SetWindowSize(window, w, h);
}

/// 
/// \brief Get the size of a window's client area.
/// 
/// \param window   The window to query.
/// \param w        Pointer to variable for storing the width, may be NULL
/// \param h        Pointer to variable for storing the height, may be NULL
/// 
/// \sa SDL_SetWindowSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetWindowSize(SDL_Window * window, int *w, int *h)
/// ```
void SDL_GetWindowSize(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_GetWindowSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h),
      void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_GetWindowSize');
  return _SDL_GetWindowSize(window, w, h);
}

/// 
/// \brief Set the minimum size of a window's client area.
/// 
/// \param window    The window to set a new minimum size.
/// \param min_w     The minimum width of the window, must be >0
/// \param min_h     The minimum height of the window, must be >0
/// 
/// \note You can't change the minimum size of a fullscreen window, it
/// automatically matches the size of the display mode.
/// 
/// \sa SDL_GetWindowMinimumSize()
/// \sa SDL_SetWindowMaximumSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowMinimumSize(SDL_Window * window, int min_w, int min_h)
/// ```
void SDL_SetWindowMinimumSize(Pointer<SDL_Window>? window, int min_w, int min_h) {
  final _SDL_SetWindowMinimumSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 min_w, Int32 min_h),
      void Function(Pointer<SDL_Window>? window, int min_w, int min_h)>('SDL_SetWindowMinimumSize');
  return _SDL_SetWindowMinimumSize(window, min_w, min_h);
}

/// 
/// \brief Get the minimum size of a window's client area.
/// 
/// \param window   The window to query.
/// \param w        Pointer to variable for storing the minimum width, may be NULL
/// \param h        Pointer to variable for storing the minimum height, may be NULL
/// 
/// \sa SDL_GetWindowMaximumSize()
/// \sa SDL_SetWindowMinimumSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetWindowMinimumSize(SDL_Window * window, int *w, int *h)
/// ```
void SDL_GetWindowMinimumSize(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_GetWindowMinimumSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h),
      void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_GetWindowMinimumSize');
  return _SDL_GetWindowMinimumSize(window, w, h);
}

/// 
/// \brief Set the maximum size of a window's client area.
/// 
/// \param window    The window to set a new maximum size.
/// \param max_w     The maximum width of the window, must be >0
/// \param max_h     The maximum height of the window, must be >0
/// 
/// \note You can't change the maximum size of a fullscreen window, it
/// automatically matches the size of the display mode.
/// 
/// \sa SDL_GetWindowMaximumSize()
/// \sa SDL_SetWindowMinimumSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowMaximumSize(SDL_Window * window, int max_w, int max_h)
/// ```
void SDL_SetWindowMaximumSize(Pointer<SDL_Window>? window, int max_w, int max_h) {
  final _SDL_SetWindowMaximumSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 max_w, Int32 max_h),
      void Function(Pointer<SDL_Window>? window, int max_w, int max_h)>('SDL_SetWindowMaximumSize');
  return _SDL_SetWindowMaximumSize(window, max_w, max_h);
}

/// 
/// \brief Get the maximum size of a window's client area.
/// 
/// \param window   The window to query.
/// \param w        Pointer to variable for storing the maximum width, may be NULL
/// \param h        Pointer to variable for storing the maximum height, may be NULL
/// 
/// \sa SDL_GetWindowMinimumSize()
/// \sa SDL_SetWindowMaximumSize()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GetWindowMaximumSize(SDL_Window * window, int *w, int *h)
/// ```
void SDL_GetWindowMaximumSize(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h) {
  final _SDL_GetWindowMaximumSize = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h),
      void Function(Pointer<SDL_Window>? window, Pointer<Int32>? w, Pointer<Int32>? h)>('SDL_GetWindowMaximumSize');
  return _SDL_GetWindowMaximumSize(window, w, h);
}

/// 
/// \brief Set the border state of a window.
/// 
/// This will add or remove the window's SDL_WINDOW_BORDERLESS flag and
/// add or remove the border from the actual window. This is a no-op if the
/// window's border already matches the requested state.
/// 
/// \param window The window of which to change the border state.
/// \param bordered SDL_FALSE to remove border, SDL_TRUE to add border.
/// 
/// \note You can't change the border state of a fullscreen window.
/// 
/// \sa SDL_GetWindowFlags()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowBordered(SDL_Window * window, SDL_bool bordered)
/// ```
void SDL_SetWindowBordered(Pointer<SDL_Window>? window, int bordered) {
  final _SDL_SetWindowBordered = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 bordered),
      void Function(Pointer<SDL_Window>? window, int bordered)>('SDL_SetWindowBordered');
  return _SDL_SetWindowBordered(window, bordered);
}

/// 
/// \brief Show a window.
/// 
/// \sa SDL_HideWindow()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_ShowWindow(SDL_Window * window)
/// ```
void SDL_ShowWindow(Pointer<SDL_Window>? window) {
  final _SDL_ShowWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_ShowWindow');
  return _SDL_ShowWindow(window);
}

/// 
/// \brief Hide a window.
/// 
/// \sa SDL_ShowWindow()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_HideWindow(SDL_Window * window)
/// ```
void SDL_HideWindow(Pointer<SDL_Window>? window) {
  final _SDL_HideWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_HideWindow');
  return _SDL_HideWindow(window);
}

/// 
/// \brief Raise a window above other windows and set the input focus.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RaiseWindow(SDL_Window * window)
/// ```
void SDL_RaiseWindow(Pointer<SDL_Window>? window) {
  final _SDL_RaiseWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_RaiseWindow');
  return _SDL_RaiseWindow(window);
}

/// 
/// \brief Make a window as large as possible.
/// 
/// \sa SDL_RestoreWindow()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_MaximizeWindow(SDL_Window * window)
/// ```
void SDL_MaximizeWindow(Pointer<SDL_Window>? window) {
  final _SDL_MaximizeWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_MaximizeWindow');
  return _SDL_MaximizeWindow(window);
}

/// 
/// \brief Minimize a window to an iconic representation.
/// 
/// \sa SDL_RestoreWindow()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_MinimizeWindow(SDL_Window * window)
/// ```
void SDL_MinimizeWindow(Pointer<SDL_Window>? window) {
  final _SDL_MinimizeWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_MinimizeWindow');
  return _SDL_MinimizeWindow(window);
}

/// 
/// \brief Restore the size and position of a minimized or maximized window.
/// 
/// \sa SDL_MaximizeWindow()
/// \sa SDL_MinimizeWindow()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_RestoreWindow(SDL_Window * window)
/// ```
void SDL_RestoreWindow(Pointer<SDL_Window>? window) {
  final _SDL_RestoreWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_RestoreWindow');
  return _SDL_RestoreWindow(window);
}

/// 
/// \brief Set a window's fullscreen state.
/// 
/// \return 0 on success, or -1 if setting the display mode failed.
/// 
/// \sa SDL_SetWindowDisplayMode()
/// \sa SDL_GetWindowDisplayMode()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetWindowFullscreen(SDL_Window * window, Uint32 flags)
/// ```
int SDL_SetWindowFullscreen(Pointer<SDL_Window>? window, int flags) {
  final _SDL_SetWindowFullscreen = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Uint32 flags),
      int Function(Pointer<SDL_Window>? window, int flags)>('SDL_SetWindowFullscreen');
  return _SDL_SetWindowFullscreen(window, flags);
}

/// 
/// \brief Get the SDL surface associated with the window.
/// 
/// \return The window's framebuffer surface, or NULL on error.
/// 
/// A new surface will be created with the optimal format for the window,
/// if necessary. This surface will be freed when the window is destroyed.
/// 
/// \note You may not combine this with 3D or the rendering API on this window.
/// 
/// \sa SDL_UpdateWindowSurface()
/// \sa SDL_UpdateWindowSurfaceRects()
/// 
/// ```c
/// extern DECLSPEC SDL_Surface * SDLCALL SDL_GetWindowSurface(SDL_Window * window)
/// ```
Pointer<SDL_Surface>? SDL_GetWindowSurface(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowSurface = _SDL2.lookupFunction<
      Pointer<SDL_Surface>? Function(Pointer<SDL_Window>? window),
      Pointer<SDL_Surface>? Function(Pointer<SDL_Window>? window)>('SDL_GetWindowSurface');
  return _SDL_GetWindowSurface(window);
}

/// 
/// \brief Copy the window surface to the screen.
/// 
/// \return 0 on success, or -1 on error.
/// 
/// \sa SDL_GetWindowSurface()
/// \sa SDL_UpdateWindowSurfaceRects()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UpdateWindowSurface(SDL_Window * window)
/// ```
int SDL_UpdateWindowSurface(Pointer<SDL_Window>? window) {
  final _SDL_UpdateWindowSurface = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_UpdateWindowSurface');
  return _SDL_UpdateWindowSurface(window);
}

/// 
/// \brief Copy a number of rectangles on the window surface to the screen.
/// 
/// \return 0 on success, or -1 on error.
/// 
/// \sa SDL_GetWindowSurface()
/// \sa SDL_UpdateWindowSurfaceRect()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_UpdateWindowSurfaceRects(SDL_Window * window, const SDL_Rect * rects, int numrects)
/// ```
int SDL_UpdateWindowSurfaceRects(Pointer<SDL_Window>? window, Pointer<SDL_Rect>? rects, int numrects) {
  final _SDL_UpdateWindowSurfaceRects = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<SDL_Rect>? rects, Int32 numrects),
      int Function(Pointer<SDL_Window>? window, Pointer<SDL_Rect>? rects, int numrects)>('SDL_UpdateWindowSurfaceRects');
  return _SDL_UpdateWindowSurfaceRects(window, rects, numrects);
}

/// 
/// \brief Set a window's input grab mode.
/// 
/// \param window The window for which the input grab mode should be set.
/// \param grabbed This is SDL_TRUE to grab input, and SDL_FALSE to release input.
/// 
/// \sa SDL_GetWindowGrab()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_SetWindowGrab(SDL_Window * window, SDL_bool grabbed)
/// ```
void SDL_SetWindowGrab(Pointer<SDL_Window>? window, int grabbed) {
  final _SDL_SetWindowGrab = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window, Int32 grabbed),
      void Function(Pointer<SDL_Window>? window, int grabbed)>('SDL_SetWindowGrab');
  return _SDL_SetWindowGrab(window, grabbed);
}

/// 
/// \brief Get a window's input grab mode.
/// 
/// \return This returns SDL_TRUE if input is grabbed, and SDL_FALSE otherwise.
/// 
/// \sa SDL_SetWindowGrab()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GetWindowGrab(SDL_Window * window)
/// ```
int SDL_GetWindowGrab(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowGrab = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window),
      int Function(Pointer<SDL_Window>? window)>('SDL_GetWindowGrab');
  return _SDL_GetWindowGrab(window);
}

/// 
/// \brief Set the brightness (gamma correction) for a window.
/// 
/// \return 0 on success, or -1 if setting the brightness isn't supported.
/// 
/// \sa SDL_GetWindowBrightness()
/// \sa SDL_SetWindowGammaRamp()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetWindowBrightness(SDL_Window * window, float brightness)
/// ```
int SDL_SetWindowBrightness(Pointer<SDL_Window>? window, double brightness) {
  final _SDL_SetWindowBrightness = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Float brightness),
      int Function(Pointer<SDL_Window>? window, double brightness)>('SDL_SetWindowBrightness');
  return _SDL_SetWindowBrightness(window, brightness);
}

/// 
/// \brief Get the brightness (gamma correction) for a window.
/// 
/// \return The last brightness value passed to SDL_SetWindowBrightness()
/// 
/// \sa SDL_SetWindowBrightness()
/// 
/// ```c
/// extern DECLSPEC float SDLCALL SDL_GetWindowBrightness(SDL_Window * window)
/// ```
double SDL_GetWindowBrightness(Pointer<SDL_Window>? window) {
  final _SDL_GetWindowBrightness = _SDL2.lookupFunction<
      Float Function(Pointer<SDL_Window>? window),
      double Function(Pointer<SDL_Window>? window)>('SDL_GetWindowBrightness');
  return _SDL_GetWindowBrightness(window);
}

/// 
/// \brief Set the gamma ramp for a window.
/// 
/// \param window The window for which the gamma ramp should be set.
/// \param red The translation table for the red channel, or NULL.
/// \param green The translation table for the green channel, or NULL.
/// \param blue The translation table for the blue channel, or NULL.
/// 
/// \return 0 on success, or -1 if gamma ramps are unsupported.
/// 
/// Set the gamma translation table for the red, green, and blue channels
/// of the video hardware.  Each table is an array of 256 16-bit quantities,
/// representing a mapping between the input and output for that channel.
/// The input is the index into the array, and the output is the 16-bit
/// gamma value at that index, scaled to the output color precision.
/// 
/// \sa SDL_GetWindowGammaRamp()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_SetWindowGammaRamp(SDL_Window * window, const Uint16 * red, const Uint16 * green, const Uint16 * blue)
/// ```
int SDL_SetWindowGammaRamp(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue) {
  final _SDL_SetWindowGammaRamp = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue),
      int Function(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue)>('SDL_SetWindowGammaRamp');
  return _SDL_SetWindowGammaRamp(window, red, green, blue);
}

/// 
/// \brief Get the gamma ramp for a window.
/// 
/// \param window The window from which the gamma ramp should be queried.
/// \param red   A pointer to a 256 element array of 16-bit quantities to hold
/// the translation table for the red channel, or NULL.
/// \param green A pointer to a 256 element array of 16-bit quantities to hold
/// the translation table for the green channel, or NULL.
/// \param blue  A pointer to a 256 element array of 16-bit quantities to hold
/// the translation table for the blue channel, or NULL.
/// 
/// \return 0 on success, or -1 if gamma ramps are unsupported.
/// 
/// \sa SDL_SetWindowGammaRamp()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GetWindowGammaRamp(SDL_Window * window, Uint16 * red, Uint16 * green, Uint16 * blue)
/// ```
int SDL_GetWindowGammaRamp(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue) {
  final _SDL_GetWindowGammaRamp = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue),
      int Function(Pointer<SDL_Window>? window, Pointer<Uint16>? red, Pointer<Uint16>? green, Pointer<Uint16>? blue)>('SDL_GetWindowGammaRamp');
  return _SDL_GetWindowGammaRamp(window, red, green, blue);
}

/// 
/// \brief Destroy a window.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DestroyWindow(SDL_Window * window)
/// ```
void SDL_DestroyWindow(Pointer<SDL_Window>? window) {
  final _SDL_DestroyWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_DestroyWindow');
  return _SDL_DestroyWindow(window);
}

/// 
/// \brief Returns whether the screensaver is currently enabled (default on).
/// 
/// \sa SDL_EnableScreenSaver()
/// \sa SDL_DisableScreenSaver()
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_IsScreenSaverEnabled(void)
/// ```
int SDL_IsScreenSaverEnabled() {
  final _SDL_IsScreenSaverEnabled = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_IsScreenSaverEnabled');
  return _SDL_IsScreenSaverEnabled();
}

/// 
/// \brief Allow the screen to be blanked by a screensaver
/// 
/// \sa SDL_IsScreenSaverEnabled()
/// \sa SDL_DisableScreenSaver()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_EnableScreenSaver(void)
/// ```
void SDL_EnableScreenSaver() {
  final _SDL_EnableScreenSaver = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_EnableScreenSaver');
  return _SDL_EnableScreenSaver();
}

/// 
/// \brief Prevent the screen from being blanked by a screensaver
/// 
/// \sa SDL_IsScreenSaverEnabled()
/// \sa SDL_EnableScreenSaver()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_DisableScreenSaver(void)
/// ```
void SDL_DisableScreenSaver() {
  final _SDL_DisableScreenSaver = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_DisableScreenSaver');
  return _SDL_DisableScreenSaver();
}

/// 
/// \brief Dynamically load an OpenGL library.
/// 
/// \param path The platform dependent OpenGL library name, or NULL to open the
/// default OpenGL library.
/// 
/// \return 0 on success, or -1 if the library couldn't be loaded.
/// 
/// This should be done after initializing the video driver, but before
/// creating any OpenGL windows.  If no OpenGL library is loaded, the default
/// library will be loaded upon creation of the first OpenGL window.
/// 
/// \note If you do this, you need to retrieve all of the GL functions used in
/// your program from the dynamic library using SDL_GL_GetProcAddress().
/// 
/// \sa SDL_GL_GetProcAddress()
/// \sa SDL_GL_UnloadLibrary()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_LoadLibrary(const char *path)
/// ```
int SDL_GL_LoadLibrary(String path) {
  final _SDL_GL_LoadLibrary = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? path),
      int Function(Pointer<Utf8>? path)>('SDL_GL_LoadLibrary');
  final _pathPointer = path.toNativeUtf8();
  final _result = _SDL_GL_LoadLibrary(_pathPointer);
  calloc.free(_pathPointer);
  return _result;
}

/// 
/// \brief Get the address of an OpenGL function.
/// 
/// ```c
/// extern DECLSPEC void *SDLCALL SDL_GL_GetProcAddress(const char *proc)
/// ```
Pointer<Void>? SDL_GL_GetProcAddress(String proc) {
  final _SDL_GL_GetProcAddress = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<Utf8>? proc),
      Pointer<Void>? Function(Pointer<Utf8>? proc)>('SDL_GL_GetProcAddress');
  final _procPointer = proc.toNativeUtf8();
  final _result = _SDL_GL_GetProcAddress(_procPointer);
  calloc.free(_procPointer);
  return _result;
}

/// 
/// \brief Unload the OpenGL library previously loaded by SDL_GL_LoadLibrary().
/// 
/// \sa SDL_GL_LoadLibrary()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GL_UnloadLibrary(void)
/// ```
void SDL_GL_UnloadLibrary() {
  final _SDL_GL_UnloadLibrary = _SDL2.lookupFunction<
      Void Function(),
      void Function()>('SDL_GL_UnloadLibrary');
  return _SDL_GL_UnloadLibrary();
}

/// 
/// \brief Return true if an OpenGL extension is supported for the current
/// context.
/// 
/// ```c
/// extern DECLSPEC SDL_bool SDLCALL SDL_GL_ExtensionSupported(const char *extension)
/// ```
int SDL_GL_ExtensionSupported(String extension) {
  final _SDL_GL_ExtensionSupported = _SDL2.lookupFunction<
      Int32 Function(Pointer<Utf8>? extension),
      int Function(Pointer<Utf8>? extension)>('SDL_GL_ExtensionSupported');
  final _extensionPointer = extension.toNativeUtf8();
  final _result = _SDL_GL_ExtensionSupported(_extensionPointer);
  calloc.free(_extensionPointer);
  return _result;
}

/// 
/// \brief Set an OpenGL window attribute before window creation.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_SetAttribute(SDL_GLattr attr, int value)
/// ```
int SDL_GL_SetAttribute(int attr, int value) {
  final _SDL_GL_SetAttribute = _SDL2.lookupFunction<
      Int32 Function(Int32 attr, Int32 value),
      int Function(int attr, int value)>('SDL_GL_SetAttribute');
  return _SDL_GL_SetAttribute(attr, value);
}

/// 
/// \brief Get the actual value for an attribute from the current context.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_GetAttribute(SDL_GLattr attr, int *value)
/// ```
int SDL_GL_GetAttribute(int attr, Pointer<Int32>? value) {
  final _SDL_GL_GetAttribute = _SDL2.lookupFunction<
      Int32 Function(Int32 attr, Pointer<Int32>? value),
      int Function(int attr, Pointer<Int32>? value)>('SDL_GL_GetAttribute');
  return _SDL_GL_GetAttribute(attr, value);
}

/// 
/// \brief Create an OpenGL context for use with an OpenGL window, and make it
/// current.
/// 
/// \sa SDL_GL_DeleteContext()
/// 
/// ```c
/// extern DECLSPEC SDL_GLContext SDLCALL SDL_GL_CreateContext(SDL_Window * window)
/// ```
Pointer<Void>? SDL_GL_CreateContext(Pointer<SDL_Window>? window) {
  final _SDL_GL_CreateContext = _SDL2.lookupFunction<
      Pointer<Void>? Function(Pointer<SDL_Window>? window),
      Pointer<Void>? Function(Pointer<SDL_Window>? window)>('SDL_GL_CreateContext');
  return _SDL_GL_CreateContext(window);
}

/// 
/// \brief Set up an OpenGL context for rendering into an OpenGL window.
/// 
/// \note The context must have been created with a compatible window.
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_MakeCurrent(SDL_Window * window, SDL_GLContext context)
/// ```
int SDL_GL_MakeCurrent(Pointer<SDL_Window>? window, Pointer<Void>? context) {
  final _SDL_GL_MakeCurrent = _SDL2.lookupFunction<
      Int32 Function(Pointer<SDL_Window>? window, Pointer<Void>? context),
      int Function(Pointer<SDL_Window>? window, Pointer<Void>? context)>('SDL_GL_MakeCurrent');
  return _SDL_GL_MakeCurrent(window, context);
}

/// 
/// \brief Get the currently active OpenGL window.
/// 
/// ```c
/// extern DECLSPEC SDL_Window* SDLCALL SDL_GL_GetCurrentWindow(void)
/// ```
Pointer<SDL_Window>? SDL_GL_GetCurrentWindow() {
  final _SDL_GL_GetCurrentWindow = _SDL2.lookupFunction<
      Pointer<SDL_Window>? Function(),
      Pointer<SDL_Window>? Function()>('SDL_GL_GetCurrentWindow');
  return _SDL_GL_GetCurrentWindow();
}

/// 
/// \brief Get the currently active OpenGL context.
/// 
/// ```c
/// extern DECLSPEC SDL_GLContext SDLCALL SDL_GL_GetCurrentContext(void)
/// ```
Pointer<Void>? SDL_GL_GetCurrentContext() {
  final _SDL_GL_GetCurrentContext = _SDL2.lookupFunction<
      Pointer<Void>? Function(),
      Pointer<Void>? Function()>('SDL_GL_GetCurrentContext');
  return _SDL_GL_GetCurrentContext();
}

/// 
/// \brief Set the swap interval for the current OpenGL context.
/// 
/// \param interval 0 for immediate updates, 1 for updates synchronized with the
/// vertical retrace. If the system supports it, you may
/// specify -1 to allow late swaps to happen immediately
/// instead of waiting for the next retrace.
/// 
/// \return 0 on success, or -1 if setting the swap interval is not supported.
/// 
/// \sa SDL_GL_GetSwapInterval()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_SetSwapInterval(int interval)
/// ```
int SDL_GL_SetSwapInterval(int interval) {
  final _SDL_GL_SetSwapInterval = _SDL2.lookupFunction<
      Int32 Function(Int32 interval),
      int Function(int interval)>('SDL_GL_SetSwapInterval');
  return _SDL_GL_SetSwapInterval(interval);
}

/// 
/// \brief Get the swap interval for the current OpenGL context.
/// 
/// \return 0 if there is no vertical retrace synchronization, 1 if the buffer
/// swap is synchronized with the vertical retrace, and -1 if late
/// swaps happen immediately instead of waiting for the next retrace.
/// If the system can't determine the swap interval, or there isn't a
/// valid current context, this will return 0 as a safe default.
/// 
/// \sa SDL_GL_SetSwapInterval()
/// 
/// ```c
/// extern DECLSPEC int SDLCALL SDL_GL_GetSwapInterval(void)
/// ```
int SDL_GL_GetSwapInterval() {
  final _SDL_GL_GetSwapInterval = _SDL2.lookupFunction<
      Int32 Function(),
      int Function()>('SDL_GL_GetSwapInterval');
  return _SDL_GL_GetSwapInterval();
}

/// 
/// \brief Swap the OpenGL buffers for a window, if double-buffering is
/// supported.
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GL_SwapWindow(SDL_Window * window)
/// ```
void SDL_GL_SwapWindow(Pointer<SDL_Window>? window) {
  final _SDL_GL_SwapWindow = _SDL2.lookupFunction<
      Void Function(Pointer<SDL_Window>? window),
      void Function(Pointer<SDL_Window>? window)>('SDL_GL_SwapWindow');
  return _SDL_GL_SwapWindow(window);
}

/// 
/// \brief Delete an OpenGL context.
/// 
/// \sa SDL_GL_CreateContext()
/// 
/// ```c
/// extern DECLSPEC void SDLCALL SDL_GL_DeleteContext(SDL_GLContext context)
/// ```
void SDL_GL_DeleteContext(Pointer<Void>? context) {
  final _SDL_GL_DeleteContext = _SDL2.lookupFunction<
      Void Function(Pointer<Void>? context),
      void Function(Pointer<Void>? context)>('SDL_GL_DeleteContext');
  return _SDL_GL_DeleteContext(context);
}

